voacapl
=======

A port of VOACAP for Linux

This seeks to maintain a port of the VOACAP code base that may be compiled using GFortran and run on Linux.  The code is based on the material made publicly available by Greg Hang at [http://www.greg-hand.com/hfwin32.html](http://www.greg-hand.com/hfwin32.html).

This material was previously made available on my website at QSL.net [http://www.qsl.net/hz1jw/](http://www.qsl.net/hz1jw/).

# Installation
The application requires the gfortran compiler which is present in the repositories most, if not all, modern Linux distributions. 

On Fedora, the compiler may be installed with the following command;

    $ sudo yum install gcc-gfortran

On Ubuntu, the following command may be used

    $ sudo apt-get install gfortran

Initialise the build with the following commands;

    $ automake --add-missing
    $ autoreconf

## Build
Building the application follows the normal configure / make / install cycle followed by the command 'makeitshfbc' to create the data files required by voacap;

    $ ./configure
    $ make
    $ sudo make install
    $ makeitshfbc

## Running voacapl
The following command will run voacapl from the command line using the contents of the default input file, saving results to itshfbc/run/voacapx.out;

    $ voacapl ~/itshfbc 

Please refer to the [wiki](https://github.com/jawatson/voacapl/wiki) for further guidance on running voacapl.

### Additional Software
VOACAP is capable of exporting a significant amount of distance information, triggered when using an input file named 'voacapd.dat'.  The information is exported in the form of a Fortran records and is not readily accessible to other applications.  A couple of small utilities have been added in version 0.7, dst2csv and dst2ascii, to read this file and produce a text based report, either as a CSV for importing into external applictaions for further analysis, or as a (large) ASCII table.

The two application will be compiled and installed as part of a normal installation.

73's

Jim (M0DNS / HZ1JW)

      subroutine areamap(area,filename,fileout,meth)
c**********************************************************
c          Execute with:
c                call areamap(area,filename,fileout,meth)
c          where:
c                area     = 'A' = normal  area coverage
c                         = 'I' = INVERSE area coverage
c                filename = input data file name to process
c                fileout  = output data file name to create
c                           If method={c,p} make fileout.da? files
c                meth     = 'm' = map only
c                         = 'c' = map with contours
c                         = 'p' = calculations & plots
c**********************************************************
      use voacapl_defs
      use crun_directory
      INCLUDE 'ficearea.hdr'
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      character fileout*64,filename*64,ich,meth*1,model*6
      character grid_file*70,area*1
      dimension layers(6),areafreqs(11)
      integer bandw
c jw      integer*2 error_code
      integer error_code
c jw      character tns*1,tew*1,pns*1,pew*1,alf*80,sufix*4,path*5,coeffs*4
      character tns*1,tew*1,pns*1,pew*1,alf*80,path*5,coeffs*4
      character(len=5) :: sufix
      character recfile*21,xmtrfile*21,cirafz*30
c      character system_type*4,beam_alf*5,card*90,data_dir*9
      character system_type*4,beam_alf*5
      character(len=VOA_PATH_LEN) :: data_dir
      character(len=max(12+MAX_AREA_MONTHS*7, 90)) :: card
      character(len=20) :: fmt_str

c jw      data system_type/'DOS '/
      data system_type/'UNIX'/
      data iyear/1993/
c jw      call DOScolr                      !  read color table
c jw      call WINcolr                      !  read Windows color table

      data_dir=trim(area_directory)//PATH_SEPARATOR
      if(area.eq.'I') data_dir=trim(area_inv_directory)//PATH_SEPARATOR

      open(29,file=trim(data_dir)//filename,status='old',iostat=ios,err=900)
      rewind(29)
      cirafz='      '
800   read(29,'(a)',end=890) card
      if(card(1:10).eq.'Model    :') then
         model=card(11:16)
      else if(card(1:10).eq.'Colors   :') then
         alf=card(11:90)
c          read COLOR & CITYNAME whether OLD or NEW format
         call col_FMT(29,alf,color,cityname)
      else if(card(1:10).eq.'Nparms   :') then
         read (card(11:15),'(i5)') nparms
         do 803 i=1,5
         parms(i)='      '
         nlevels(i)=0
         do 803 j=1,10
         conlevels(j,i)=-1
803      ishades(j,i)=-1
         do 805 i=1,nparms
805      read (29,806) parms(i),nlevels(i),
     +             (ishades(j,i),conlevels(j,i),j=1,nlevels(i))
806      format(10x,a,i4,10(i3,1x,f7.2))
      else if(card(1:10).eq.'Transmit :' .or.
     +        card(1:10).eq.'Receive  :') then
         tlatdeg=card(11:20)
         tlondeg=card(21:30)
         tname=card(31:50)
         path=card(52:56)
         if(path(1:1).eq.'L') then
            path='Long '
            npsl=1
         else
            path='Short'
            npsl=0
         end if
      else if(card(1:10).eq.'Pcenter  :') then
         platdeg=card(11:20)
         plondeg=card(21:30)
         pname=card(31:50)
      else if(card(1:10).eq.'Area     :') then
         read(card(11:50),'(4f10.1)') xmin,xmax,ymin,ymax
      else if(card(1:10).eq.'Gridsize :') then
         read(card(11:20),'(2i5)') ngrid,gridtype
      else if(card(1:10).eq.'Method   :') then
         read(card(11:15),'(i5)') method
      else if(card(1:10).eq.'Coeffs   :') then
         coeffs=card(11:14)
      ! The following inputs have been modified to work with a larger
      ! number of area plots
      else if(card(1:10).eq.'Months   :') then
         write (fmt_str, "(A,I0,A)") "(10x,", MAX_AREA_MONTHS,"f7.2)"
         read(card, fmt_str) montha
         do 305 i=1,MAX_AREA_MONTHS     !  fix old integer months (before MONTH.DAY)
           if(montha(i).gt.0. .and. montha(i).lt.1.) montha(i)=montha(i)*100.
305      continue
      else if(card(1:10).eq.'Ssns     :') then
         write (fmt_str, "(A,I0,A)") "(10x,", MAX_AREA_MONTHS,"I7)"
         read(card, fmt_str) ssna
      else if(card(1:10).eq.'Qindexs  :') then
         write (fmt_str, "(A,I0,A)") "(10x,", MAX_AREA_MONTHS,"I7)"
         read(card,fmt_str) qindexa
      else if(card(1:10).eq.'Hours    :') then
         write (fmt_str, "(A,I0,A)") "(10x,", MAX_AREA_MONTHS,"I7)"
         read(card, fmt_str) ihour
      else if(card(1:10).eq.'Freqs    :') then
         write (fmt_str, "(A,I0,A)") "(10x,", MAX_AREA_MONTHS,"f7.3)"
         read(card, fmt_str) Freq
      else if(card(1:10).eq.'System   :') then
         if(model.eq.'ICEPAC' .or. model.eq.'VOACAP') then
            read (card,810) noise,amind,xlufp,rsn,pmp,dmpx
810         format(10x,i5,f10.3,2i5,2f10.3)
         else if(model.eq.'REC533') then
            read (card,811) noise,amind,xlufp,rsn,bandw
811         format(10x,i5,f10.3,2i5,i10)
         end if
      else if(card(1:10).eq.'Fprob    :') then
            read(card,'(10x,4f5.2)') fprob
      else if(card(1:10).eq.'Rec Ants :') then
         read(card,812)  recfile,rec_gain,rec_bear
812      format(10x,1x,a21,1x,7x,2f6.1)
      else if(card(1:10).eq.'Tx Ants  :') then
         read(card,813) xmtrfile,design_freq,beam_main,TxPower
813      format(10x,1x,a21,1x,f7.3,f6.1,1x,f10.4)
      else if(card(1:10).eq.'Zones    :') then
         cirafz=card(11:40)       !  CIRAF zones to calculate
         platdeg=tlatdeg
         plondeg=tlondeg
         pname=tname
      end if
      go to 800
890   close(29)
c********************************************
      do 10 i=1,6
      layers(i)=-1
      ich=color(i)(1:1)
      if(ich.ge.'0' .and. ich.le.'9') layers(i)=ichar(ich)-ichar('0')
10    continue
      call gettra(tlat,tlon,plat,plon)   !  convert to decimal degrees
      do 20 nmonths=1,MAX_AREA_MONTHS    !  find out how many months
      if(montha(nmonths).eq.0) go to 25
20    continue
25    nmonths=nmonths-1
      if(meth.eq.'m') then
         nmonths=1                       !  only 1 plot for map only
         model='      '                  !  map only, no calculation model
      end if
c      nch=lcount(filename,30)
      grid_file=trim(root_directory)//data_dir//filename(1:nch-2)//'g?'
      nchg=lcount(grid_file,70)
      do 500 ii=1,MAX_AREA_MONTHS        !  create a file for each plot
c jw      call yieldit                   !  yield for windows control
      if (ii <= 9) then
        write(sufix,'(3h.da,i1)') ii
        call suffix(fileout,12,sufix,4)    !  append suffix
      else
        write(sufix,'(3h.da,i2)') ii
        call suffix(fileout,13,sufix,5)    !  append suffix
      endif
c jw      call erase@(fileout,error_code)!  delete file first
      call unlink(trim(run_directory)//PATH_SEPARATOR//fileout,error_code)    !  delete file first
      grid_file(nchg:nchg)=sufix(4:4)
c jw      call erase@(grid_file,error_code)!  delete *.vg? files
      call unlink(grid_file,error_code)    !  delete *.vg? files
      if(ii.gt.nmonths) go to 500
c      open(29,file=run_directory(1:nch_run)//PATH_SEPARATOR//fileout)
      open(29,file=trim(run_directory)//PATH_SEPARATOR//fileout)
      rewind(29)
      write(29,1) model,filename
1     format('COMMENT   ',a6,4x,a)
      if(cirafz(1:10).eq.'          ') then     !  normal area
         write(29,2)   layers,cityname,
     +                 tlat,tlon,tname,beam_main,path,
     +                 plat,plon,
     +                 xmin,xmax,ymin,ymax,ngrid,ngrid,gridtype
2        format('COMMENT   ',6i5,1x,a,/,
     +          'COMMENT   ',2f10.4,1x,a20,1x,f6.1,1x,a,/
     +          'AREA      ',2f10.4,4f10.2,3i5)
         if(meth.eq.'m') go to 500        !  don't output model info
         write(29,3) nparms
3        format('COMMENT   Parameters:',i5)
         do 5 i=1,nparms
5        write(29,6) parms(i),nlevels(i),
     +              (ishades(j,i),conlevels(j,i),j=1,nlevels(i))
6        format('COMMENT   ',a,i4,10(i2,1h=,f7.2))
      else
         write(29,7)   tlat,tlon,tname,beam_main,path,
     +                 cirafz
7        format('COMMENT   ',2f10.4,1x,a20,1x,f6.1,1x,a,/
     +          'ZONES     ',a)
      end if
c******************************************************************
      if(model.eq.'VOACAP' .or. model.eq.'ICEPAC') then
c             Copy defaults from VOACAP.DEF
         open(32,file=trim(root_directory)//PATH_SEPARATOR//'database'//PATH_SEPARATOR//'voacap.def',
     +        status='old',err=100)
90       read(32,'(a)',end=99) alf
         nch=lcount(alf,80)
         write(29,'(a)') alf(1:nch)
         go to 90
99       close(32)
      end if
c***************************************************************
100   write(29,'(10hCOEFFS    ,a)') coeffs
      write(29,101) ihour(ii),ihour(ii),1,1    !  always UT
101   format('TIME      ',4i5)
      if(model.eq.'ICEPAC' .or. model.eq.'VOACAP') then
         write(29,102) iyear,montha(ii)
102      format('MONTH     ',i5,f5.2)
      else
         write(29,103) iyear,ifix(montha(ii))
103      format('MONTH     ',2i5)
      end if

      if(model.eq.'VOACAP' .or. model.eq.'REC533') then
         write(29,104) float(ssna(ii))
104      format('SUNSPOT   ',f5.0,f5.2)
      else if(model.eq.'ICEPAC') then
         write(29,104) float(ssna(ii)),qindexa(ii)
      end if

      if(model.eq.'VOACAP') then
	 call getfreqs(Freq(ii),areafreqs,nfreqs)
         write(29,'(11hFREQUENCY $,11f6.3)') (areafreqs(i),i=1,nfreqs)
      else if(model.eq.'ICEPAC') then
	 call getfreqs(Freq(ii),areafreqs,nfreqs)
         write(29,'(10hFREQUENCY ,11f5.2)') (areafreqs(i),i=1,nfreqs)
      else
	 call getfreqs(Freq(ii),areafreqs,nfreqs)
         write(29,'(10hFREQ      ,10f7.3)') (areafreqs(i),i=1,nfreqs)
      end if

      tlatd=tlat
      tns='N'
      if(tlatd.lt.0.) tns='S'
      tlond=tlon
      if(tlond.gt.180.) tlond=tlond-360.
      tew='E'
      if(tlond.lt.0.) tew='W'
      platd=plat
      pns='N'
      if(platd.lt.0.) pns='S'
      plond=plon
      if(plond.gt.180.) plond=plond-360.
      pew='E'
      if(plond.lt.0.) pew='W'

      if(model.eq.'VOACAP' .or. model.eq.'ICEPAC') then
         write(29,105) tname,pname
105      format('LABEL     ',2a20)
         write(29,106) abs(tlatd),tns,abs(tlond),tew,
     +                 abs(platd),pns,abs(plond),pew,path(1:1),npsl
106      format('CIRCUIT   ',f5.2,a1,3(f9.2,a1),2x,a1,1x,i5)
      else if(model.eq.'REC533') then
         write(29,107) 'TRANS     ',tname,abs(tlatd),tns,abs(tlond),tew,
     +                              path(1:1)
         write(29,107) 'RECVR     ',pname,abs(platd),pns,abs(plond),pew,
     +                              path(1:1)
107      format(a10,a20,f7.2,a1,f10.2,a1,2x,a1,5x,1hD)
      end if

      xnoise=noise
      if(noise.eq.1) xnoise=-1.      !  =-140.4
      if(noise.eq.2) xnoise=-2.      !  =-144.7
      if(noise.eq.3) xnoise=-3.      !  =-150.0
      if(noise.eq.4) xnoise=-4.      !  =-164.1
      if(noise.eq.5) xnoise=-5.      !  =-138.7
      if(noise.eq.6) xnoise=-6.      !  =-152.7
      if(model.eq.'REC533') then
         write(29,216)1.,amind,0,0.
216      format('SYSTEM    ',f10.4,f5.2,i5,f5.1)
      else
         write(29,215)1.,xnoise,amind,float(xlufp),float(rsn),pmp,dmpx
215      format('SYSTEM    ',2f5.0,f5.2,f5.0,f5.1,2f5.2)
      end if

      if(model.eq.'REC533') then
         nnoise=noise
         if(nnoise.ge.1 .and. nnoise.le.6) nnoise=-nnoise  !  noise category
         write(29,217) -nnoise,bandw,rsn,xlufp
217      format('NOIS      ',4i5)
      end if

      if(model.eq.'VOACAP' .or. model.eq.'ICEPAC') then
      write(29,116) fprob
116   format('FPROB     ',4f5.2)
      end if

      call antfile_name(xmtrfile,system_type)
c          negative beam_main is for NON-terminated horizontal rhombics
      write(beam_alf,'(f5.1)') beam_main
      if(beam_alf(1:5).eq.'*****') write(beam_alf,'(f5.0)') beam_main
      write(29,117) 1,1,2,30,design_freq,xmtrfile,beam_alf,TxPower
117   format('ANTENNA   ',4i5,f10.3,1h[,a21,1h],a5,f10.4)
      call antfile_name(recfile,system_type)
      write(29,119) 2,2,2,30,0.,recfile,rec_bear,rec_gain
119   format('ANTENNA   ',4i5,f10.3,1h[,a21,1h],f5.1,f10.4)

      npage0=0
      write(29,118) 100+method,npage0
118   format('METHOD    ',2i5)

      write(29,'(7HEXECUTE)')

      write(29,'(4HQUIT)')
500   close(29)
      return
c***************************************************
900   write(*,901) ios,data_dir//filename
901   format('In areamap, err=',i5,' Could not OPEN file:',a)
      END
* -------------------------------------------------------------------- *
      subroutine getfreqs(Freq,areafreqs,nfreqs)
      use voacapl_defs
      use crun_directory
      dimension areafreqs(11)
      character filename*24
      areafreqs(1)=Freq
      nfreqs=1
      if(Freq.gt..5) return
c           get frequencies from areafreq.dat
c      nch_run=lcount(run_directory,50)
      open(41,file=trim(run_directory)//PATH_SEPARATOR//'areafreq.dat',
     +     status='old',err=100)
      filename=trim(run_directory)//PATH_SEPARATOR//'areafreq.dat'
      go to 110
100   open(41,file=trim(root_directory)//'database'//PATH_SEPARATOR//'areafreq.dat',
     +     status='old',err=200)
      filename=trim(root_directory)//'database'//PATH_SEPARATOR//'areafreq.dat'
110   rewind(41)
      read(41,*) areafreqs
      close(41)
      do 120 i=1,11
      if(areafreqs(i).gt.0.) nfreqs=i
120   continue
      write(*,121) filename,(areafreqs(i),i=1,nfreqs)
121   format(' Choosing MAXIMUM values from frequency file:',a,/
     +       ' Freqs=',11f6.2)
      write(*,122)
122   format(' TRANSMIT antenna MUST BE non-directional for this',
     +       ' purpose!')
200   return
      end
* -------------------------------------------------------------------- *
      subroutine antfile_name(file,system_type)
      character file*21,system_type*4,dir_bad*1,dir_good*1
      save dir_bad,dir_good
      if(system_type.eq.'DOS ') then
         dir_bad='/'
         dir_good='\'
      else
         dir_bad='\'
         dir_good='/'
      end if
      nch=21
      call rblankc(file,nch)     !  remove blanks
c jw      call lcase(file,nch)       !  convert to lower case
      idx=index(file,dir_bad)    !  change / or \ to for proper op sys
      if(idx.gt.0) file(idx:idx)=dir_good
      return
      end
* -------------------------------------------------------------------- *
      subroutine gettra(tlat,tlon,plat,plon)
      INCLUDE 'ficearea.hdr'
      character cdeg*10

      cdeg=tlatdeg
      nch=10
      call rblankc(cdeg,nch)
      call chardeg(cdeg,0,tlat,ierr)
      cdeg=tlondeg
      nch=10
      call rblankc(cdeg,nch)
      call chardeg(cdeg,1,tlon,ierr)
      cdeg=platdeg
      nch=10
      call rblankc(cdeg,nch)
      call chardeg(cdeg,0,plat,ierr)
      cdeg=plondeg
      nch=10
      call rblankc(cdeg,nch)
      call chardeg(cdeg,1,plon,ierr)
      return
      end
* -------------------------------------------------------------------- *
      SUBROUTINE col_FMT(lu,card,color,cityname)
c          read the COLORS & CITYNAME
c          handle both OLD & NEW formats
c          NEW format is compatible with HP UNIX format
      CHARACTER color(6)*6,cityname*12
      character card*80,ich*1,color_new(5)*6,shading*20
      character cities(6)*6,shads(7)*20
      character col_DOS*6
      data cities/'BLACK ','black ','RED   ','red   ','BLUE  ','blue  '/
      data shads/'Black with shading  ',
     +           'Red   with shading  ',
     +           'Black  NO  shading  ',
     +           'Red    NO  shading  ',
     +           'Shading, no contours',
     +           'Bin color shading   ',
     +           'Bin  B/W  shading   '/

      if(card(10:10).eq.':') then              !  new format
         read(card,2) color_new,shading
2        format(5(a6,4x),a20)
         color(1)=col_DOS(icolDOS(color_new(1)),1)    !  GRID
         color(2)=col_DOS(icolDOS(color_new(2)),1)    !  COUNTRIES
         color(3)=col_DOS(icolDOS(color_new(3)),1)    !  ZONES
         color(5)=col_DOS(icolDOS(color_new(5)),1)    !  MAINBEAM
c***********************************
c          CITIES (4) is different
      color(4)='Ignore'
      do 10 i=1,6
      if(color_new(4).eq.cities(i)) write(color(4),'(i1)') i-1
10    continue
      call colortab(4,color(4))
c***********************************
c          SHADING (6) is different
      color(6)='Ignore'
      do 20 i=1,7
      if(shading.eq.shads(i)) write(color(6),'(i1)') i-1
20    continue
      call colortab(6,color(6))
c***********************************
         read(lu,'(a)') card                   !  read cities file name
         nchc=lcount(card,80)
         do 30 i=nchc,1,-1
         ich=card(i:i)
         if(ich.eq.'/' .or. ich.eq.'\' .or. ich.eq.':') then
            cityname=card(i+1:nchc)
            go to 800
         end if
30       continue
      else                                     !  old format
         read (card,1) color,cityname
1        format(6(a6,3x),a)
      end if
800   if(cityname(1:1).eq.' ') cityname='receive.cty'
      return
      end
c-----------------------------------------------------------------
      subroutine colortab(idx,color)    !  set color from color table
      character color*6,colors(16)*6,ich*1,contours(7)*6,cities(6)*6
      data colors/'0=Blck','1=Red ','2=Grn ','3=Yell','4=Blue','5=Magn',
     +            '6=Cyan','7=Grey','8=DGry','9=Orng','A=Lgrn','B=Brwn',
     +            'C=Lblu','D=Pink','E=LLbl','F=Whit'/
      data contours/'0=BLCK','1=RED ','2=blck','3=red ','4=Shad',
     +              '5=Bin ','6=bin '/
      data cities/'0=BLCK','1=blck','2=RED ','3=red ','4=BLUE','5=blue'/
      ich=color(1:1)
      if(idx.eq.4) go to 50       !  Cities   are different
      if(idx.eq.6) go to 100      !  Contours are different
      do 10 i=1,16
      if(ich.ne.colors(i)(1:1)) go to 10
         color=colors(i)
         return
10    continue
      color='Ignore'
      return
50    do 60 i=1,6
      if(ich.ne.cities(i)(1:1)) go to 60
         color=cities(i)
         return
60    continue
      color='Ignore'
      return
100   do 110 i=1,7
      if(ich.ne.contours(i)(1:1)) go to 110
         color=contours(i)
         return
110   continue
      color='Ignore'
      return
      end
c-----------------------------------------------------------------

module Cant99
    implicit none
    integer :: luaa, nfreq, itype
    integer :: ifreq1, ifreq2
    real, dimension(20) :: parms
    real, dimension(100) :: frequency,dbi,eff
    real, dimension(91, 360) :: gain1, gain2
    character(len=80) :: filenam,title
end module

c# outbod.f
      SUBROUTINE OUTBOD
C--------------------------------
C
C     THIS ROUTINE OUTPUTS THE VARIABLES SET IN SUBROUTINE SETOUT
C     DEPENDENT ON METHOD BUT THE USER MAY SPECIFY HIS OWN CHOICE OF
C     VARIABLES TO OUTPUT BY INCLUDING A "BOTLINES" CONTROL CARD AND
C     RUNNING METHOD 23.  THE ROUTINE USES A VECTORED FORMAT SCHEME AND
C     CALLS SUBROUTINES FIXLIN AND FLOLIN TO OUTPUT THE LINE
C
      common /cdistance/ idistance,ndistance,ihr       !  plot vs distance
      common /ctime/ ntime                             !  plot vs time
      common /c_S_to_I/ i_S_to_I    !  = 1 = S/I calculation
      common /Charris/ iharris    !  =1=harris99.exe exists
      common /sncom/ snxx(13)
      common /cgains/ gaint(13),gainr(13)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON /OUTPRT/ LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1, slmdl*9
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      character jfmt*40
      DATA ND/11/
C.....THIS PROGRAM WILL WRITE 2 PLUS LINBOT(26) LINES. IT IS
C     ASSUMED THAT THE LINE COUNT WAS CHECKED BY THE CALLING PROGRAM.
      IFREQ=1
      if(ndistance.ne.1) then
         call outbod3           !  output for Plots vs DISTANCE
         return
      end if
      if(ntime.ne.0) then
         call outbod4           !  output for Plots vs TIME
         return
      end if
 
ccc      IF(LINES.gt.LINTOP(15)) go to 200
ccc      if(MSPEC.eq.121)then
ccc        WRITE(LUO,1501)
ccc 1501 FORMAT(/,' ',3X,'UT  MUF ',5x,'***MODEL  S=Short path  L=LONG Pa',
ccc     +'th  M=Smoothed(VOA)')
ccc      else
ccc        WRITE(LUO,1500)
ccc 1500 FORMAT(/,' ',3X,'UT  MUF ')
ccc      ENDIF
ccc      LINES=LINES+2
200   if(MSPEC.ne.121) then
         slmdl='         '
      else
         if(MDL(13).eq.'S')then
            slmdl='/SP-Model'
         else if(MDL(13).eq.'L')then
            slmdl='/LP-Model'
         else
            slmdl='/Model***'
         endif
      end if
ccc      WRITE(LUO,1502)GMT,ALLMUF(IT),MDL(12),(FREL(IQ),MDL(IQ),IQ=1,ND),
ccc     +slmdl
ccc 1502 FORMAT(/,' ',1X,F4.1,1X,12(F4.1,A1),'FREQ',a9)
ccc       changes made at VOA request 9/8/95
cc      WRITE(LUO,1502)GMT,ALLMUF(IT),(FREL(IQ),IQ=1,ND)
cc 1502 FORMAT(/,' ',1X,F4.1,12F5.1,' FREQ')
C*****Begin HARRIS RF Mod by CJK 8/1/96************************************
      if(iharris.eq.0) then
         WRITE(LUO,1502)GMT,ALLMUF(IT),(FREL(IQ),IQ=1,ND)
c1502  FORMAT(/,' ',1X,F4.1,12F5.1,' FREQ')
      else
         WRITE(LUO,1502) GMT,ALLMUF(IT),(FREL(IQ),IQ=1,ND),XLMT(IT),
     1                FOT(IT),XLUF(IT)
      end if
 1502 FORMAT(/,' ',1X,F4.1,12F5.1,' FREQ',4X,3(F4.1,1X))
C*****End HARRIS RF Mod****************************************************


      if(ALLMUF(IT).gt.30.) then        !  no antenna support
         nhp(12)=0
         mode(12)='NA'
         moder(12)='NA'
         angle(12)=99.9
         delay(12)=99.9
         vhigh(12)=1000
         dblos(12)=1000
         dbu(12)=-999
         dbw(12)=-999
         sndb(12)=-999
         snpr(12)=-999
         reliab(12)=0.
         probmp(12)=0.
         sprob(12)=0.
         snxx(12)=-999
      end if
      DO 210 IFQ = 2,ND
      IF(FREL(IFQ).gt.0) IFREQ=IFQ
  210 CONTINUE
      JFREQ = -1
      DO 225 IFQ = 1,IFREQ
      IF(NHP(IFQ).gt.0) JFREQ=IFQ
  225 CONTINUE
      JFREQ = MIN0(ND+1, JFREQ)
      IF(JFREQ.le.0) then         !  write all dashes
         LINES=LINES+3
         RETURN
      end if
      IF(JFREQ.ge.ND) then      !  write no dashes
         jfmt='(6x,12(1x,i2,a2),1x,a6)'
         JDASH = -1
      else                      !  write some dashes
         JDASH = ND - JFREQ
         write(jfmt,226) jfreq+1,jdash
226      format(4h(6x,,i2,11h(1x,i2,a2),,i2,14h(1x,a4),1x,a6))
      end if

      if(method.eq.23 .or. linbyp.ne.0) then   !  output controlled by BOTLINES
         linbot(26)=0
         do 510 i=1,14
         lin=LINBD(i)
         if(lin.gt.0) then
            call outbod2(lin,jfmt)
            linbot(26)=linbot(26)+1
         end if
510      continue
      else
         do 500 lin=1,22                !  output in order on OUTLINES card
         if(LINBOT(lin).gt.0) call outbod2(lin,jfmt)   !  output this parameter
500      continue
      end if
      LINES = LINES + LINBOT(26) + 2
      if(i_S_to_I.ne.0) call out_si        !  = 1 = S/I calculation
      RETURN
      END
C--------------------------------
c# outbod2.f
      SUBROUTINE OUTBOD2(lin,jfmt)
C--------------------------------
C
C     THIS ROUTINE OUTPUTS THE VARIABLES SET IN SUBROUTINE SETOUT
C     DEPENDENT ON METHOD BUT THE USER MAY SPECIFY HIS OWN CHOICE OF
C     VARIABLES TO OUTPUT BY INCLUDING A "BOTLINES" CONTROL CARD AND
C     RUNNING METHOD 23.  THE ROUTINE USES A VECTORED FORMAT SCHEME AND
C     CALLS SUBROUTINES FIXLIN AND FLOLIN TO OUTPUT THE LINE
C
      COMMON /DUDL_NOIS/ DU_NOIS(13),DL_NOIS(13)
      common /c_S_to_I/ i_S_to_I    !  = 1 = S/I calculation
      common /sncom/ snxx(13)
      common /cgains/ gaint(13),gainr(13)
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / OUTFMT / KLINE(26)
      COMMON /OUTPRT/ LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      CHARACTER NDASH*4
      CHARACTER KLINE*6
      INTEGER ITMP(13)
      character jfmt*(*)
      DATA NDASH/'  - '/
      DATA IMUF/12/
C.....THIS PROGRAM WILL WRITE 2 PLUS LINBOT(26) LINES. IT IS
C     ASSUMED THAT THE LINE COUNT WAS CHECKED BY THE CALLING PROGRAM.

      go to (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
     +      21,22),lin
1     continue                       !  MODE
      IF(JLONG.lt.0) then            !  short path
         jfmt(8:15)='1x,i2,a2'
         WRITE(LUO,jfmt) NHP(IMUF),MODE(IMUF),(NHP(IFQ),MODE(IFQ),
     +                   IFQ =1,JFREQ),(NDASH,ID=1,JDASH),KLINE(1)
      else                            !  long path
         jfmt(8:15)='1x,a2,a2'
         WRITE(LUO,jfmt) MODE(IMUF),MODER(IMUF),(MODE(IFQ),MODER(IFQ),
     +                   IFQ=1,JFREQ),(NDASH,ID=1,JDASH),KLINE(1)
      end if
      go to 500
2     CALL FLOLIN(jfmt,1,ANGLE,2)     !  ANGLE
      IF(JLONG.gt.0) CALL FLOLIN(jfmt,1,ANGLER,23)   !  long path ANGLE
      go to 500
3     CALL FLOLIN(jfmt,1,DELAY,3)     !  DELAY
      go to 500
4     DO 104 II=1,13                  !  V HITE
  104 ITMP(II)=anint(vhigh(II))
      CALL FIXLIN(jfmt,ITMP,4)
      go to 500
5     CALL FLOLIN(jfmt,2,CPROB,5)     !  F DAYS
ccc      write(luo,'(''cprob='',13f8.5)') (cprob(ii),ii=1,jfreq)
      go to 500
6     DO 106 II=1,13                  !  LOSS
  106 ITMP(II)=anint(dblos(II))
      CALL FIXLIN(jfmt,ITMP,6)
      go to 500
7     DO 107 II=1,13                  !  dBu
  107 ITMP(II)=anint(dbu(II))
      CALL FIXLIN(jfmt,ITMP,7)
      go to 500
8     DO 108 II=1,13                  !  S dBw
  108 ITMP(II)=anint(DBW(II))
      CALL FIXLIN(jfmt,ITMP,8)
      go to 500
9     DO 109 II=1,13                  !  N dBw
  109 ITMP(II)=anint(XNYNOIS(II)+RNEFF(II))
      CALL FIXLIN(jfmt,ITMP,9)
      go to 500
10    DO 110 II=1,13                  !  SNR median
  110 ITMP(II)=anint(sndb(II))
      CALL FIXLIN(jfmt,ITMP,10)
      go to 500
11    DO 111 II=1,13                  !  RPWRG
  111 ITMP(II)=anint(snpr(II))
      CALL FIXLIN(jfmt,ITMP,11)
      go to 500
12    CALL FLOLIN(jfmt,2,RELIAB,12)   !  REL
      go to 500
13    CALL FLOLIN(jfmt,2,PROBMP,13)   !  MPROB
      go to 500
14    CALL FLOLIN(jfmt,2,SPROB,14)    !  SPRB
      go to 500
15    CALL FLOLIN(jfmt,1,DBLOSL,15)   !  SIGLW
      go to 500
16    CALL FLOLIN(jfmt,1,DBLOSU,16)   !  SIGUP
      go to 500
17    if(i_S_to_I.eq.0) then          !  not S/I output
         CALL FLOLIN(jfmt,1,SNRLW,17)    !  SNRLW
      else
         CALL FLOLIN(jfmt,1,DL_NOIS,24)  !  Noise dl
      end if
      go to 500
18    if(i_S_to_I.eq.0) then          !  not S/I output
         CALL FLOLIN(jfmt,1,SNRUP,18)    !  SNRUP
      else
         CALL FLOLIN(jfmt,1,DU_NOIS,25)  !  Noise du
      end if
      go to 500
19    CALL FLOLIN(jfmt,1,gaint,19)    !  T gain
      go to 500
20    CALL FLOLIN(jfmt,1,gainr,20)    !  R gain
      go to 500
21    DO 121 II=1,13                  !  SNR xx
  121 ITMP(II)=anint(snxx(II))
      CALL FIXLIN(jfmt,ITMP,21)
      go to 500
22    DO 122 II=1,13                  !  dBm = S DBW + 30
  122 ITMP(II)=anint(DBW(II)+30.)
      CALL FIXLIN(jfmt,ITMP,22)
500   continue
      RETURN
      END
C--------------------------------
c# outbod3.f
      SUBROUTINE OUTBOD3
C--------------------------------
C
C     THIS ROUTINE OUTPUTS THE VARIABLES SET IN SUBROUTINE SETOUT
C     DEPENDENT ON METHOD BUT THE USER MAY SPECIFY HIS OWN CHOICE OF
C     VARIABLES TO OUTPUT BY INCLUDING A "BOTLINES" CONTROL CARD AND
C     RUNNING METHOD 23.  THE ROUTINE USES A VECTORED FORMAT SCHEME AND
C     CALLS SUBROUTINES FIXLIN AND FLOLIN TO OUTPUT THE LINE
C
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      common /cdistance/ idistance,ndistance,ihr       !  plot vs distance
      common /cnfreqs/ nfreqs
      COMMON /DUDL_NOIS/ DU_NOIS(13),DL_NOIS(13)
      common /c_S_to_I/ i_S_to_I    !  = 1 = S/I calculation
      common /sncom/ snxx(13)
      common /cgains/ gaint(13),gainr(13)
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / OUTFMT / KLINE(26)
      COMMON /OUTPRT/ LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX

      character xmode*4
      dimension vals(21)
      data nvals/21/

      if(idistance*ihr.eq.1) write(LUO,'(''**********'')')
      do 100 ifreq=1,nfreqs
      irec=((ihr-1)*ndistance + idistance-1)*nfreqs + ifreq
ccc      irec=((ihr-1)*nfreqs + ifreq-1)*ndistance + idistance
      if(JLONG.lt.0) then       !  short path algorithm
         write(xmode,'(i2,a2)') iabs(nhp(ifreq)),mode(ifreq)
      else                      !  long path algorithm
         write(xmode,'(a2,a2)') mode(ifreq),moder(ifreq)
      end if
      xmuf=ALLMUF(IT)
      xfot=FOT(IT)
      vals( 1)=ANGLE(ifreq)     !  ANGLE
      vals( 2)=DELAY(ifreq)     !  DELAY
      vals( 3)=VHIGH(ifreq)     !  V HITE
      vals( 4)=CPROB(ifreq)     !  MUFday
      vals( 5)=DBLOS(ifreq)     !  LOSS
      vals( 6)=DBU(ifreq)       !  DBU
      vals( 7)=DBW(ifreq)       !  S DBW
      vals( 8)=XNYNOIS(ifreq)+RNEFF(ifreq)   !  N DBW
      vals( 9)=SNDB(ifreq)      !  SNR median
      vals(10)=SNPR(ifreq)      !  RPWRG
      vals(11)=RELIAB(ifreq)    !  REL
      vals(12)=PROBMP(ifreq)    !  MPROB
      vals(13)=SPROB(ifreq)     !  S PRB
      vals(14)=DBLOSL(ifreq)    !  SIG LW
      vals(15)=DBLOSU(ifreq)    !  SIG UP
      vals(16)=SNRLW(ifreq)     !  SNR LW
      vals(17)=SNRUP(ifreq)     !  SNR UP
      vals(18)=GAINT(ifreq)     !  T gain
      vals(19)=GAINR(ifreq)     !  R gain
      vals(20)=SNxx(ifreq)      !  SNRxx
      vals(21)=DBW(ifreq)+30.   !  DBM
      xlat=rlat*r2d
      xlon=rlong*r2d
      write(49,rec=irec) gcdkm,xlat,xlon,xmode,xmuf,xfot,
     +                   (vals(i),i=1,nvals)
ccc      write(LUO,99) ifreq,ihr,idistance,irec,xlat,xlon,
ccc     +            xmode,xmuf,(vals(i),i=1,6)
ccc 99   format(3i3,i5,1h=,f6.2,f7.3,1h=,a4,f8.3,2f5.1,f5.0,f5.3,2f6.1)
 100  continue
      RETURN
      END
C--------------------------------
c# outbod4.f
      SUBROUTINE OUTBOD4
C--------------------------------
C
C     THIS ROUTINE OUTPUTS THE VARIABLES SET IN SUBROUTINE SETOUT
C     DEPENDENT ON METHOD BUT THE USER MAY SPECIFY HIS OWN CHOICE OF
C     VARIABLES TO OUTPUT BY INCLUDING A "BOTLINES" CONTROL CARD AND
C     RUNNING METHOD 23.  THE ROUTINE USES A VECTORED FORMAT SCHEME AND
C     CALLS SUBROUTINES FIXLIN AND FLOLIN TO OUTPUT THE LINE
C
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      common /cdistance/ idistance,ndistance,ihr       !  plot vs distance
      common /cnfreqs/ nfreqs
      COMMON /DUDL_NOIS/ DU_NOIS(13),DL_NOIS(13)
      common /c_S_to_I/ i_S_to_I    !  = 1 = S/I calculation
      common /sncom/ snxx(13)
      common /cgains/ gaint(13),gainr(13)
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / OUTFMT / KLINE(26)
      COMMON /OUTPRT/ LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX

      character xmode*4
      dimension vals(21)
      data nvals/21/

      if(ihr.eq.1) write(LUO,'(''**********'')')
      do 100 ifreq=1,nfreqs
      irec=(ihr-1)*nfreqs + ifreq
      if(JLONG.lt.0) then       !  short path algorithm
         write(xmode,'(i2,a2)') nhp(ifreq),mode(ifreq)
      else                      !  long path algorithm
         write(xmode,'(a2,a2)') mode(ifreq),moder(ifreq)
      end if
      xmuf=ALLMUF(IT)
      xfot=FOT(IT)
      vals( 1)=ANGLE(ifreq)     !  ANGLE
      vals( 2)=DELAY(ifreq)     !  DELAY
      vals( 3)=VHIGH(ifreq)     !  V HITE
      vals( 4)=CPROB(ifreq)     !  MUFday
      vals( 5)=DBLOS(ifreq)     !  LOSS
      vals( 6)=DBU(ifreq)       !  DBU
      vals( 7)=DBW(ifreq)       !  S DBW
      vals( 8)=XNYNOIS(ifreq)+RNEFF(ifreq)   !  N DBW
      vals( 9)=SNDB(ifreq)      !  SNR median
      vals(10)=SNPR(ifreq)      !  RPWRG
      vals(11)=RELIAB(ifreq)    !  REL
      vals(12)=PROBMP(ifreq)    !  MPROB
      vals(13)=SPROB(ifreq)     !  S PRB
      vals(14)=DBLOSL(ifreq)    !  SIG LW
      vals(15)=DBLOSU(ifreq)    !  SIG UP
      vals(16)=SNRLW(ifreq)     !  SNR LW
      vals(17)=SNRUP(ifreq)     !  SNR UP
      vals(18)=GAINT(ifreq)     !  T gain
      vals(19)=GAINR(ifreq)     !  R gain
      vals(20)=SNxx(ifreq)      !  SNRxx
      vals(21)=DBW(ifreq)+30.   !  DBM
      xlat=rlat*r2d
      xlon=rlong*r2d
      write(49,rec=irec) xmode,xmuf,xfot,(vals(i),i=1,nvals)
ccc      write(LUO,99) ifreq,ihr,irec,
ccc     +            xmode,xmuf,(vals(i),i=1,6)
ccc 99   format(3i3,1h=,a4,f8.3,2f5.1,f5.0,f5.3,2f6.1)
 100  continue
      RETURN
      END
C--------------------------------

c# outarea.f
      SUBROUTINE OUTciraf(ix,iy)
C--------------------------------
C
C     THIS ROUTINE OUTPUTS all variables for area coverage contour plotting
C
      use cversn
      common /chours/ nhours,ihours(24)       !  which hours are active
      common /cdaily/ idaily(12)       !  day of the month modification
      common /cantenna/ numants,iats(20),anttype(20),antname(20),
     +                  xfqs(20),xfqe(20),designfreq(20),antfile(20),
     +                  beammain(20),offazim(20),cond(20),diel(20),
     +                  array(30,91,20),aeff(30,20)
      character anttype*10,antname*70,antfile*24
      common /pantenna/ pwrkw(20),pwrdba(20)
      common /sncom/ snxx(13)
      common /cgains/ gaint(13),gainr(13)
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
      COMMON /DUDL_NOIS/ DU_NOIS(13),DL_NOIS(13)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / OUTFMT / KLINE(26)
      COMMON /OUTPRT/ LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      CHARACTER KLINE*6
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
c jw      common /CVERSN/ VERSN
c jw         character VERSN*8

      character antbear*12,slew*4
      character alfs(23)*6,alfPwr*10,label*90,path*5,daily*3
      equivalence (alfs,label)
      data SNR88,SNR91/88.,91./

      if(ix.lt.0) go to 100                  !  output header

      write(alfs(1),'(f6.2)') frel(12)            !  MUF
      if(JLONG.lt.0) then
        write(alfs(2),'(2x,i2,a2)') NHP(1),MODE(1)  !  MODE
      else
        write(alfs(2),'(2x,a2,a2)') MODE(1),MODER(1)  !  T_MODE,R_MODE
      end if
      do 50 i=2,nf
      if(dbu(i).gt.dbu(1)) dbu(1)=dbu(i)
      if(dbw(i).gt.dbw(1)) dbw(1)=dbw(i)
      if(sndb(i).gt.sndb(1)) sndb(1)=sndb(i)
      if(reliab(i).gt.reliab(1)) reliab(1)=reliab(i)
      if(sprob(i).gt.sprob(1)) sprob(1)=sprob(i)
      if(snxx(i).gt.snxx(1)) snxx(1)=snxx(i)
50    continue
c          calculate the George Lane % Power Cut
      SNR_LW=SNRLW(1)
      SNR_UP=SNRUP(1)
      SNR50=sndb(1)
      call pwrcut(SNR50,SNR_LW,SNR_UP,SNR88,SNR91,power_cut)
      write(alfs(3),'(f6.2)') xlimit6(angle(1),2)            !  ANGLE
      write(alfs(4),'(f6.2)') xlimit6(delay(1),2)            !  DELAY
      write(alfs(5),'(f6.1)') xlimit6(vhigh(1),1)            !  V HITE
      write(alfs(6),'(f6.3)') xlimit6(cprob(1),3)            !  MUF days
      write(alfs(7),'(f6.1)') xlimit6(dblos(1),1)            !  LOSS
      write(alfs(8),'(f6.1)') xlimit6(dbu(1)  ,1)            !  DBU
      write(alfs(9),'(f6.1)') xlimit6(dbw(1),1)              !  S DBW
      write(alfs(10),'(f6.1)') xlimit6(XNYNOIS(1)+RNEFF(1),1)      !  N DBW
      write(alfs(11),'(f6.1)') xlimit6(sndb(1),1)            !  SNR median
      write(alfs(12),'(f6.1)') xlimit6(snpr(1),1)            !  RPWRG
      write(alfs(13),'(f6.3)') xlimit6(reliab(1),3)          !  REL
      write(alfs(14),'(f6.3)') xlimit6(probmp(1),3)          !  MPROB
      write(alfs(15),'(f6.3)') xlimit6(sprob(1),3)           !  S PRB
      write(alfs(16),'(f6.2)') xlimit6(gaint(1),2)           !  TGAIN
      write(alfs(17),'(f6.2)') xlimit6(gainr(1),2)           !  RGAIN
      write(alfs(18),'(f6.1)') xlimit6(snxx(1),1)            !  SNRxx
ccc      write(alfs(19),'(f6.1)') xlimit6(dbw(1)+30.,1)         !  DBM
      write(alfs(19),'(f6.2)') xlimit6(DU_NOIS(1),2)         !  DU NOISE
      write(alfs(20),'(f6.2)') xlimit6(DL_NOIS(1),2)         !  DL NOISE
      write(alfs(21),'(f6.2)') xlimit6(DBLOSL(1),2)          !  SIG LW
      write(alfs(22),'(f6.2)') xlimit6(DBLOSU(1),2)          !  SIG UP
      write(alfs(23),'(f6.3)') xlimit6(power_cut,3)          !  PWRCT
      if(nf.eq.1) then
      write(LUO,'(2i3,2f10.4,23a6)') ix,iy,rlatd,rlongd,alfs
      else
      write(LUO,'(2i3,2f10.4,23a6)') ix,iy,rlatd,rlongd,alfs(1),alfs(8),
     +            alfs(9),alfs(11),alfs(13),alfs(15),alfs(18)
      end if
      return

100   write(LUO,101) VERSN
c jw 101   format('VOACAP Version',1x,a8)
101   format('VOACAPL Version',1x,a8)
      path='     '
      if(NPSL.ne.0) path='/Long'     !  using long path
      itr=1
      call TxPwr(pwrkw(itr),alfPwr,nchp)
      daily='   '
      if(idaily(1).ne.0) write(daily,'(1h.,i2.2)') idaily(1)
c**********************************************************
c         get slew angle for HFCC antennas
      islew=0
      ncha=lcount(antfile(itr),24)
      slew=antfile(itr)(ncha-3:ncha)
      if(slew(1:2).eq.'.m') then    !  -slew angle
         read(slew,'(2x,i2)',err=110) islew
         islew=-islew
      else if(slew(1:2).eq.'.p') then    !  +slew angle
         read(slew,'(2x,i2)',err=110) islew
      end if
110   if(islew.eq.0) then
         write(antbear,'(i3,3hdeg)') iabs(nint(beammain(itr)))
      else
         mainbeam=nint(beammain(itr))+islew       !  add slew back in
         if(mainbeam.lt.0.) mainbeam=mainbeam+360
         write(antbear,'(1h(,i3,1h,,i3,4h)deg)') mainbeam,islew 
      end if
c**********************************************************
      if(nf.eq.1) then
      write(label,102) ITRAN,antname(itr)(1:10),alfPwr(1:nchp),
     +                 antbear,ihours(1),Frel(1),
     +                 IMON(months(1)),daily,nint(sunsp(1)),path
102   format(2a10,1h[,a10,2h] ,a,1x,a,i3.2,'ut',f7.3,'MHz ',2a3,
     +       i4,'ssn',a)
      else
      write(label,202) ITRAN,antname(itr)(1:10),alfPwr(1:nchp),
     +                 antbear,ihours(1),nf,
     +                 IMON(months(1)),daily,nint(sunsp(1)),path
202   format(2a10,1h[,a10,2h] ,a,1x,a,i3.2,'ut',i3,'Freqs ',2a3,
     +       i4,'ssn',a)
      end if
      call squeez(label,90)      !  squeeze blanks out
      nch=lcount(label,90)
ccc      write(*,'(1x,a)') label(1:nch)
      call progress_label(label)
      write(LUO,'(a)') label(1:nch)
      if(nf.eq.1) then
      write(LUO,103) -ix,-iy
103   format(2i3,'  Latitude Longitude',
     +               '   MUF  MODE ANGLE DELAY VHITE MUFda  LOSS',
     +               '   DBU  SDBW  NDBW   SNR RPWRG   REL MPROB',
     +         ' SPROB TGAIN RGAIN SNRxx    DU    DL SIGLW SIGUP PWRCT')
      else
      write(LUO,104) -ix,-iy
104   format(2i3,'  Latitude Longitude',
     +               '   MUF   DBU  SDBW   SNR   REL SPROB SNRxx')
      end if
      RETURN
      END
C---------------------------------

c# decred.f
      SUBROUTINE DECRED
C---------------------------------
C
C     THIS ROUTINE CALLS FUNCTION MONITR TO READ THE CONTROL CARDS.
C     THE CARD IMAGES ARE THEN DECODED , PROCESSED AND THE DATA STORED
C
      use voacapl_defs
      use crun_directory
      character cirafz*30,zones(100)*4
      common /cCIRAF_TP/ nTP,idx_TP(911)
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      common /ccoeff/ coeff
      character coeff*4
      common /cdaily/ idaily(12)       !  day of the month modification
      common /carea/ iarea
      common /c_S_to_I/ i_S_to_I    !  = 1 = S/I calculation
      common /cmodel/ model
      character model*8
      common /cantenna/ numants,iats(20),anttype(20),antname(20),
     +                  xfqs(20),xfqe(20),designfreq(20),antfile(20),
     +                  beammain(20),offazim(20),cond(20),diel(20),
     +                  array(30,91,20),aeff(30,20)
      character anttype*10,antname*70,antfile*24,gainfile*10
      dimension array91(91)
      common /pantenna/ pwrkw(20),pwrdba(20)    !  antenna powers
      common /chours/ nhours,ihours(24)       !  which hours are active
      COMMON /RGRID/ IPROJ,PLAT,PLON,XMIN,XMAX,YYMIN,YMAX,NX,NY
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON /CON/ D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON /ES /FS (3, 5), HS (5)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON /GEOG /GYZ (5), RAT (5), GMDIP (5), CLCK (5), ABIY (5), ART
     1IC (5), SIGPAT (5), EPSPAT (5)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
      COMMON / MFAC / F2M3(5),HPF2(5),ZENANG(5),ZENMAX(5),IEDP,FSECV(3)
      COMMON / MODES / GHOP, DELMOD(6,3), HPMOD(6,3), HTMOD(6,3),
     1 FVMOD(6,3), ITMOD(6,3), AFMOD(6,3)
      COMMON / NAMEX / NAMES(100), INPUT
      CHARACTER INPUT*85
      COMMON / OUTLAB / LABEL(11), LAYTYP(5), IEAST, INORTH, ISOUTH,
     A IWEST, LABLI, LABLJ, LABLK
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / RAYS / ANG(40), IFOB(40,30,5), NANG
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON /SSP /SUN (2, 12), MONTH
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON /TON /ADJ, ADS, GNOS, GOT, REL, SL, SLS
     1, SPR, SU, SUS, XNOISE, ZNOISE, NF
      COMMON / ZON / ABPS(7), CREL(7), EFF(7), FLDST(7), GRLOS(7),
     1 HN(7), HP(7), PROB(7), RELY(7), RGAIN(7), SIGPOW(7), SN(7),
     2 SPRO(7), TGAIN(7), TIMED(7), TLOSS(7), B(7), FSLOS(7), ADV(7),
     3 OBF(7),NMODE(7),TLLOW(7),TLHGH(7)
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/INFORM/INFO,IHSHR,IHLNG
      COMMON / PSCA / PSC(4), PSCB(4), IPSC
      DIMENSION IWCRD(100),xmonth(12)
      CHARACTER INAME1*8, INAME2*8, JNAME1*8, JNAME2*8, IOFF*3,
     A IBLANK*1, ITEMP*10, ISLAT*1, ISLONG*1, ISGLAT*1
      CHARACTER INORTH*1,IEAST*1,ISOUTH*1,IWEST*1
      CHARACTER NAMES*10, LABEL*5,
     A LAYTYP*2, LABLI*5, LABLJ*5, LABLK*5
      DATA INAME1/'BOULDER,'/, INAME2/' COLO.  '/, JNAME1/'ST. LOUI'/,
     A JNAME2/'S, MO.  '/
      DATA IWCRD/100*1/,
     A IOFF/'OFF'/, IBLANK/' '/
C***********************************************************************
C
C     SUBROUTINE REDMAP MAY READ THE IONOSPHERIC LONG TERM DATA BASE
C     FILE (LU2) DEPENDENT ON TASK OPTION AND USER DEFINED INPUT
C     THE PROGRAM WILL TERMINATE IF AN ERROR OCCURS (SET ITRUN = 0)
C
C     ON THE FIRST CALL TO THIS SUBROUTINE CONTROL PASSES TO STATEMENT
C     LABEL  90 TO READ THE FIRST CONTROL CARD FROM LUI WHICH INITIALLY
C     IS SET TO LU5.  CONTROL THEN PASSES TO STATEMENT LABEL 105 TO
C     BRANCH AND PROCESS THE CONTROL CARD.
C
C***********************************************************************

c jw      nch_run=lcount(run_directory,50)
C.....EXECUTE PROGRAM IF TWO CONSECUTIVE CARDS WITH SAME NAME
      IF(IRED.le.0) go to 105
   90 CONTINUE
C.....IF ISPROC = 0, CARDS ARE INPUT FROM THE USER DEFINED FILE (LUI)
C.....IF ISPROC = 1, CARDS ARE INPUT FROM THE PROCEDURE FILE (LU35)
      IF(ISPROC.gt.0) then
         ICARD = MONITR(LU35,MAXNAM)     !  read from procedure file
      else
         ICARD = MONITR(LUI,MAXNAM)      !  read from LUI
      end if
ccc      write(*,'(''  after monitr='',i3,''  maxnum,numnam='',2i5)')
ccc     +                icard,maxnum,numnam
      IF(LUI.ne.LU15) KCARD=KCARD+1
C.....ICARD IS AN INDEX OF THE CARD NAME
  105 IF(ICARD.GT.MAXNAM) GO TO 910
      IF(ICARD.GT.NUMNAM) GO TO 880
C.....ICARD = 1   2   3   4   5   6   7   8   9  10  11  12  13  14  15
C            16  17  18  19  20  21  22  23  24  25  26  27  28  29  30
C            31  32  33  34  35  36  37  38  39  40  41  42  43  44  45
C
C           MET MON MON SUN CIR SYS TIM CCI FRE LAB INT EXE SAM EFV ESV
C           EDP AUX AUX ANT OUT COM FRE PRO END NEX QUI FPR TOP BOT INF
C           ARE LIN COE ZON
C
ccc      write(*,'('' before GO TO (..) icard='',i5)') icard
      GO TO(110,145,165,205,230,270,285,330,340,380,390,410,425,465,480,
     A      490,505,515,525,535,545,550,560,625,635,670,700,750,770,780,
     B      800,805,806,810,820), ICARD
C***********************************************************************
C     METHOD CARD                                             ICARD = 1
C***********************************************************************
C.....THE METHOD CARD IS USED FOR PROGRAM CONTROL
  110 IF(IWCRD(1).le.0) go to 900
      READ(INPUT,1500) METHOD, NPAGO, MSPEC
c          PCVOACAP cannot use MSPEC=125
      if(METHOD.gt.200) then
         i_S_to_I=1             !  S/I calculations
         METHOD=METHOD-200
      else if(METHOD.gt.100) then
         iarea=1                !  area coverage
         METHOD=METHOD-100
      end if
      if(MSPEC.eq.125 .and. model.eq.'PCVOACAP') MSPEC=0
      if(METHOD.eq.30) then            !  Short/Long Path smoothing
         MSPEC=121
         METHOD=20
      end if
C.....TERMINATE EXECUTION IF METHOD .LE. 0 OR .GT. MAXIMUM METHOD
C.....HOWEVER, A "QUIT" CARD IS REQUIRED AS THE LAST CONTROL CARD
      IF(METHOD.le.MAXMET) go to 125
      ITRUN = 0
      ITOUT = 0
      GO TO 920
C.....SET RUN AND OUTPUT INDICATORS DEPENDING ON METHOD
  125 ITRUN = JTRUN(METHOD)
      ITOUT = JTOUT(METHOD)
C.....SET STARTING PAGE NUMBER FOR OUTPUT FILE
      IF(NPAGO.gt.0) LPAGES = NPAGO-1
      IWCRD(1) = -1
      GO TO 90
C***********************************************************************
C     MONTH CARD                                              ICARD = 2
C***********************************************************************
  145 IF(IWCRD(2).le.0) go to 900
ccc      READ(INPUT,1502) NYEAR, (MONTHS(I),I=1,12)
      READ(INPUT,'(10x,a5,13f5.2)') NYEAR, (XMONTH(I),I=1,12)
      do 146 i=1,12
      if(xmonth(i).lt..005) then          !  no  month
         months(i)=0
         idaily(i)=0
      else if(xmonth(i).lt.1.) then       !  old month
         months(i)=nint(xmonth(i)*100.)
         idaily(i)=0
      else                                !  month.day
         monthx=xmonth(i)
         ida=nint((xmonth(i)-float(monthx))*100.)
         idaily(i)=ida                    !  if <>0, use daily foF2 coeff
         months(i)=monthx
         if(ida.gt.0) then
            if (coeff.eq.'CCIR') then
              write(*,'('' *******************************************************'')')
              write(*,'('' * Warning: Daily predictions specified in input file. *'')')
              write(*,'('' * forcing use of URSI coefficients.                   *'')')
              write(*,'('' *******************************************************'')')
            end if
            coeff='URSI'                  !  daily MUST use URSI            
         end if
      end if
146   continue

      IWCRD(2) = -1
      GO TO 90
C***********************************************************************
C     MONTHLOOP CARD                                          ICARD = 3
C***********************************************************************
  165 continue
      pause 'MONTHLOOP card no longer valid in VOACAP'
      stop  'MONTHLOOP card no longer valid in VOACAP'
C***********************************************************************
C     SUNSPOT CARD                                            ICARD = 4
C***********************************************************************
  205 IF(IWCRD(4).le.0) go to 900
      READ(INPUT,1508) (SUNSP(I),I=1,12)
      IWCRD(4) = -1
      go to 90
C***********************************************************************
C     CIRCUIT CARD                                            ICARD = 5
C***********************************************************************
  230 IF(IWCRD(5).le.0) go to 900
      READ(INPUT,1506) TLATD,ITLAT, TLONGD, ITLONG, RLATD, IRLAT,
     A RLONGD, IRLONG, NPSL
 1506 FORMAT(10X,F5.2,A1,3(F9.2,A1),4X,I5)
      IWCRD(5) = -1
      IF(ITLAT .EQ. IBLANK) GO TO 255
      IF(ITLONG .EQ. IBLANK) GO TO 255
      IF(IRLAT .EQ. IBLANK) GO TO 255
      IF(IRLONG .NE. IBLANK) GO TO 260
C.....CIRCUIT TRANSMITTER AND RECEIVER COORDINATES ARE BLANK
C.....SET COORDINATES TO THE FOLLOWING DEFAULT CIRCUIT
C.....BOULDER, COLORADO TO ST. LOUIS, MO.
  255 TLATD = 40.03
      ITLAT = INORTH
      TLONGD = 105.3
      ITLONG = IWEST
      RLATD = 38.67
      IRLAT = INORTH
      RLONGD = 90.25
      IRLONG= IWEST
      ITRAN(1) = INAME1
      ITRAN(2) = INAME2
      IRCVR(1) = JNAME1
      IRCVR(2) = JNAME2
C.....OUTPUT IN GEOM
  260 CONTINUE
      if(ITLAT.eq.ISOUTH) TLATD=-TLATD
      if(ITLONG.eq.IWEST) TLONGD=-TLONGD
      if(IRLAT.eq.ISOUTH) RLATD=-RLATD
      if(IRLONG.eq.IWEST) RLONGD=-RLONGD
      GO TO 90
C***********************************************************************
C     SYSTEM CARD                                             ICARD = 6
C***********************************************************************
  270 IF(IWCRD(6).le.0) go to 900
      READ(INPUT,1507) PWX, XNOISE, AMIND, XLUFP, RSNX, PMPX, DMPX
 1507 FORMAT(10X,F5.2,F5.0,F5.2,F5.0,3F5.2)
C.....SET VARIABLES TO DEFAULT VALUES IF NOT SET ON SYSTEM CARD
      IWCRD(6) = -1
      IF(XNOISE.NE.0.) NOISE = XNOISE
      LUFP = XLUFP
      IF(AMIND.LE.0.0) AMIND = 3.0
      AMIN = AMIND * D2R
      IF(LUFP.LE.0) LUFP = 90.
ccc      IF(RSNX.GT.0.) RSN = RSNX
ccc      IF(PMPX.NE.0.) PMP = PMPX
ccc      IF(DMPX.NE.0.) DMP = DMPX
      RSN = RSNX
      PMP = PMPX
      DMP = DMPX
      GO TO 90
C***********************************************************************
C     TIME CARD                                               ICARD = 7
C***********************************************************************
  285 IF(IWCRD(7).le.0) go to 900
      READ(INPUT,1500) IHRO, IHRE, IHRS, ITIM
      IWCRD(7) = -1
C.....SET HOUR INCREMENT TO THE DEFAULT VALUE OF ONE (IF .LE. 0)
      IF(IHRS.LE.0) IHRS = 1
c          New TIME concept by Greg Hand 5/17/93
c          Time may now run around midnight (e.g. 22 to 04)
      istart=IHRO
      if(istart.eq.0) istart=24
      iend=IHRE
      if(IHRE.lt.istart) iend=iend+24
      nhours=0
      do 287 ihr=istart,iend,IHRS
      jhr=ihr
      if(jhr.gt.24) jhr=jhr-24
      nhours=nhours+1
287   ihours(nhours)=jhr
      GO TO 90
C***********************************************************************
C     ANTENNA CARD                                            ICARD = 8
C***********************************************************************
  330 CONTINUE
      READ(INPUT,1510) IAT,iantr,minfreq,maxfreq,designfreq(iantr),
     +                 antfile(iantr),beammain(iantr),pwrkw(iantr)
 1510 FORMAT(10X,4I5,f10.3,1x,a21,1x,f5.1,f10.4)
      iats(iantr)=iat
      if(iat.eq.1) then             !  transmitter, save power
         if(pwrkw(iantr).le.0.) pwrkw(iantr)=1.
         pwrdba(iantr)=30. + 10.*alog10(pwrkw(iantr))    !  convert to dB
      end if
      if(iantr.gt.numants) numants=iantr
      write(gainfile,'(4hgain,i2.2,4h.dat)') iantr
ccc      write(*,'('' opening file='',a)') run_directory(1:nch_run)//
ccc     +                                         '\'//gainfile
      open(lu26,file=trim(run_directory)//PATH_SEPARATOR//gainfile,status='old',form='formatted')
      rewind(lu26)
      read(lu26,331) anttype(iantr),antname(iantr)
331   format(a10,a70)
      read(lu26,332) xfqs(iantr),xfqe(iantr),
     +           beammain(iantr),offazim(iantr),cond(iantr),diel(iantr)
332   format(2f5.0,2f7.2,2f10.5)
      if(offazim(iantr).eq.-999.) then      !  area coverage
c          change made 8/31/95 for Windows version because gains are
c          stored in the correct arrays in antcalc
ccc         read(lu26,'(25x,f10.3)') aeff(1,iantr)
ccc         do 334 iazim=1,360
ccc         read(lu26,333) (array91(ielev),ielev=1,91)
ccc333      format(9x,10f7.3)
ccc         do 334 ielev=1,91              !  store in INTEGER*2 to save space
ccc         gain=array91(ielev)
ccc         if(gain.gt. 300.) gain= 300.
ccc         if(gain.lt.-300.) gain=-300.
ccc334      iarray360(iazim,ielev,iantr)=gain*100.
      else
         do 335 ifreq=1,30
335      read(lu26,336) AEFF(ifreq,iantr),(array(ifreq,j,iantr),j=1,91)
336      format(2x,f6.2,(t10,10f7.3))
      end if
      close(lu26)
      GO TO 90
C***********************************************************************
C     FREQUENCY CARD                                          ICARD = 9
C***********************************************************************
  340 IF(IWCRD(9).le.0) go to 900
      if(INPUT(11:11).eq.'$') then           !  get 3 sig digits in frequency
         READ(INPUT,341) (FREL(IFK),IFK=1,11)
341      format(11x,11f6.3)
      else
         READ(INPUT,1508) (FREL(IFK),IFK=1,11)
      end if
      IWCRD(9) = -1
C.....SET REST OF FREQUENCY ARRAY
      DO 350 IFK = 12,29
  350 FREL(IFK) = 0.
C.....SET FREL(14) AS A FLAG
      IF(FREL(1).eq.0.) then
         IF(FREL(2).le.0.) then
C.....SET FLAG TO CALCULATE FREQUENCY COMPLEMENT IN FRQCOM EACH HOUR
            FREL(14) = -1.
         else
C.....SET FLAG TO USE FOT AS FIRST FREQUENCY FOR EACH HOUR
            FREL(14) = -10.
         end if
      else
C.....SET FLAG TO USE INPUT DATA
         FREL(14) = 1.
      end if
      GO TO 90
C***********************************************************************
C     LABEL CARD                                              ICARD = 10
C***********************************************************************
  380 IF(IWCRD(10)) 900, 900, 385
  385 READ(INPUT,1504) ITRAN(1), ITRAN(2), IRCVR(1), IRCVR(2)
      IWCRD(10) = -1
      GO TO 90
C***********************************************************************
C     INTEGRATE CARD                                          ICARD = 11
C***********************************************************************
C.....THE "INTEGRATE" CARD INDICATES WHAT KIND OF INTEGRATION IS USED
C.....INTEG = -1 FOR ALWAYS GAUSSIAN,
C.....INTEG .GE. 0 FOR MODEL SEGMENT WHEN NO F1 LAYER
  390 CONTINUE
      READ(INPUT,1504) ITEMP
      INTEG = 1
      IEDP = 1
      IF(ITEMP .EQ. IOFF) GO TO 90
      READ(INPUT,1500) INTEG
      IEDP = INTEG
      GO TO 90
C***********************************************************************
C     EXECUTE CARD                                            ICARD = 12
C***********************************************************************
C.....THE "EXECUTE" CARD CAUSES PROGRAM EXECUTION
  410 READ(INPUT,1500) KRUN
      IRED = 1
  415 DO 420 IC = 1,MAXNAM
  420 IWCRD(IC) = 1
      GO TO 920
C***********************************************************************
C     SAMPLE CARD                                             ICARD = 13
C***********************************************************************
C.....SAMPLE FOR GEOGRAPHICAL VARIABLES
  425 CONTINUE
C.....THE USER MAY RUN METHOD= 1 TO OBTAIN THESE VALUES FROM THE
C.....IONOSPHERIC LONG TERM DATA BASE FILE (LU2) . HE MAY THEN PUNCH THE
C.....VALUES ON DATA CARDS INSTEAD OF READING THE DATA BASE FILE.
  430 READ(INPUT,1514) I, SLAT, ISLAT, SLONG, ISLONG, SGLAT,
     A ISGLAT, RD(I), GYZ(I), CLCK(I), GMDIP(I), ARTIC(I), SIGPAT(I),
     B EPSPAT(I)
      IF(ISLAT .EQ. ISOUTH) SLAT = -SLAT
      CLAT(I) = SLAT * D2R
      IF(ISLONG .EQ. IWEST) SLONG = -SLONG
      CLONG(I) = SLONG * D2R
      IF(ISGLAT .EQ. ISOUTH) SGLAT = -SGLAT
      GLAT(I) = SGLAT * D2R
      GO TO 90
C***********************************************************************
C     EFVAR CARD                                              ICARD = 14
C***********************************************************************
C.....SAMPLE FOR E, F1, F2 LAYERS, FREQ, SEMI-THICKNESS, HEIGHT OF MAX
  465 CONTINUE
C.....THE USER MAY RUN METHOD= 1 TO OBTAIN THESE VALUES FROM THE
C.....IONOSPHERIC LONG TERM DATA BASE FILE (LU2) . HE MAY THEN PUNCH THE
C.....VALUES ON DATA CARDS INSTEAD OF READING THE DATA BASE FILE.
  470 READ(INPUT,1516) I,(FI(J,I), YI(J,I), HI(J,I),J=1,3)
      F2M3(I) = 1490. / (HI(3,I) + 176.)
      HPF2(I) = HI(3,I)
      GO TO 90
C***********************************************************************
C     ESVAR CARD                                              ICARD = 15
C***********************************************************************
C.....SAMPLE FOR ES LAYER, LOW, MIDDLE, HIGH, VIRTUAL HEIGHT
  480 CONTINUE
C.....THE USER MAY RUN METHOD= 1 TO OBTAIN THESE VALUES FROM THE
C.....IONOSPHERIC LONG TERM DATA BASE FILE (LU2) . HE MAY THEN PUNCH THE
C.....VALUES ON DATA CARDS INSTEAD OF READING THE DATA BASE FILE.
  485 READ(INPUT,1518) I, FS(1,I), FS(2,I), FS(3,I), HS(I)
      GO TO 90
C***********************************************************************
C     EDP CARD                                                ICARD = 16
C***********************************************************************
C.....THE "EDP" CARD ALLOWS THE USER TO READ IN AND USE AN EXTERNAL
C.....ELECTRON DENSITY PROFILE FOR A SPECIFIED SAMPLE AREA
C.....(FOR ONE HOP PATH ONLY)
  490 CONTINUE
      READ(INPUT,1530) JSAMP, ITEMP
C.....ASSUME THE DEFAULT SAMPLE AREA = 1
C.....IF THE SPECIFIED SAMPLE AREA ISN"T 1, 2 OR 3
      IF(JSAMP) 494, 494, 492
  492 IF(JSAMP - 3) 496, 496, 494
  494 JSAMP = 1
  496 IF(ITEMP .NE. IOFF) GO TO 500
C.....USE THE INTERNAL ELECTRON DENSITY PROFILE INSTEAD OF THE ONE READ
      IELECT(JSAMP) = 0
      GO TO 90
C.....READ THE EXTERNAL ELECTRON DENSITY PROFILE
  500 IELECT(JSAMP) = 1
C.....N O T E    CHANGED TO HTR(50,3) AND FNSQ(50,3)
      READ(LUI,1528) (HTR(I,1),I=1,50)
      READ(LUI,1528) (FNSQ(I,1),I=1,50)
      GO TO 90
C***********************************************************************
C     AUXIN CARD                                              ICARD = 17
C***********************************************************************
C.....THE "AUXIN" CARD CAUSES INPUT CARD IMAGES TO BE READ FROM THE
C.....AUXILLARY INPUT FILE
  505 CONTINUE
      READ(INPUT,1504) ITEMP
      LUI = LU15
      IF(ITEMP .NE. IOFF) GO TO 90
      LUI = LU5
      GO TO 90
C***********************************************************************
C     AUXOUT CARD                                             ICARD = 18
C***********************************************************************
C.....THE "AUXOUT" CARD CAUSES THE OUTPUT FILE TO BE CHANGED FROM THE
C.....STANDARD OUTPUT FILE TO THE ALTERNATE OUTPUT FILE
  515 CONTINUE
      READ(INPUT,1504) ITEMP
      LUO = LU16
      IF(ITEMP .NE. IOFF) GO TO 90
      LUO = LU6
      GO TO 90
C***********************************************************************
C     ANTOUT CARD                                             ICARD = 19
C***********************************************************************
C.....THE "ANTOUT" CARD INDICATES THE ANTENNA PATTERNS CREATED
C.....ARE TO BE WRITTEN ON A FILE FOR LATER USE
  525 CONTINUE
      READ(INPUT,1504) ITEMP
      IANTOU = 1
      IF(ITEMP .NE. IOFF) GO TO 90
      IANTOU = 0
      GO TO 90
C***********************************************************************
C     OUTGRAPH CARD                                           ICARD = 20
C***********************************************************************
C.....THE "OUTGRAPH" CARD ALLOWS THE USER TO REQUEST OUTPUT OF SEVERAL
C.....DIFFERENT METHODS THAT HAVE OUTPUT OPTIONS 3 OR 4
  535 CONTINUE
      READ(INPUT,1504) ITEMP
      ISOUT = 0
      IF(ITEMP .EQ. IOFF) GO TO 90
      ISOUT = 1
      READ(INPUT,1500) KTOUT
      GO TO 90
C***********************************************************************
C     COMMENT CARD                                            ICARD = 21
C***********************************************************************
C.....THE "COMMENT" CARD ALLOWS THE USER TO PUT COMMENTS IN THE INPUT
C.....FILE. IT HAS NO EFFECT ON PROGRAM EXECUTION
  545 CONTINUE
      if(input(11:14).eq.'GROU') write(LUO,'(11h COMMENT   ,a)')
     +        input(11:)
      GO TO 90
C***********************************************************************
C     FREEFORM                                                ICARD = 22
C***********************************************************************
C.....THE "FREEFORM" CARD INDICATES THAT THE INPUT CONSISTES OF
C.....FREEFORM CARD IMAGES
C     XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
C     N O T E - THE FREEFORM INPUT ANALYSER IS NOT YET DEVELOPED
C     XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  550 CONTINUE
      READ(INPUT,1504) ITEMP
      ITYPE = 1
      IF(ITEMP .NE. IOFF) GO TO 90
      ITYPE = 0
      GO TO 90
C***********************************************************************
C     PROCEDURE CARD                                          ICARD = 23
C***********************************************************************
C.....THE "PROCEDURE" CARD ALLOWS THE USER TO DEFINE A PROCEDURE
C.....THE PROCEDURE IS STORED ON LU35 AND WHEN A CALL TO THE PROCEDURE
C.....OCCURS (IE THE USER SPECIFIES THE NAME OF THE PROCEDURE ON AN
C.....INPUT CARD) THE PROGRAM READS THE PROCEDURE FILE AND REPLACES
C.....THE PROCEDURE CALL WITH THE PROCEDURE DEFINITION
  560 CONTINUE
C.....PROCEDURE FILE HAS ALREADY BEEN CREATED IN SUBROUTINE LISTIN
C.....IGNORE THE PROCEDURE DEFINITION ON THE INPUT FILE
  590 JCARD = MONITR(LUI,MAXNAM)
      KCARD = KCARD + 1
C.....SKIP PAST THE "END" CARD
      IF(JCARD - 24) 590, 90, 590
C***********************************************************************
C     END CARD                                                ICARD = 24
C***********************************************************************
C.....THE "END" CARD IS USED TO END A PROCEDURE DEFINITION
  625 CONTINUE
      ISPROC = 0
      GO TO 90
C***********************************************************************
C     NEXT CARD                                               ICARD = 25
C***********************************************************************
C.....THE "NEXT" CARD TERMINATES A MONTH SUNSPOT LOOP
  635 CONTINUE
      pause 'NEXT card no longer valid in VOACAP'
      stop  'NEXT card no longer valid in VOACAP'
ccc      GO TO 90
C***********************************************************************
C     QUIT CARD                                               ICARD = 26
C***********************************************************************
C.....THE "QUIT" CARD IS USED TO TERMINATE PROGRAM EXECUTION
  670 CONTINUE
      ITRUN = 0
      GO TO 920
C***********************************************************************
C     FPROB CARD                                              ICARD = 27
C***********************************************************************
C.....THE "FPROB" CARD ALLOWS THE USER TO ALTER THE PREDICTED CRITICAL
C.....FREQUENCIES. EACH CRITICAL FREQUENCY IS MULTIPLIED BY PSC(N),
C.....WHERE N = 1 IS E, N=2 IS F1, N=3 IS F2 AND N=4 IS ES.
C.....(N O T E -  E AND F2 ARE NECESSARY)
  700 CONTINUE
      READ(INPUT,1504) ITEMP
      IF(ITEMP .EQ. IOFF) GO TO 720
      IPSC = 1
      READ(INPUT,1508) PSC
      IF(PSC(1).LE.0.) PSC(1) = PSCB(1)
      IF(PSC(2).LT.0.) PSC(2) = PSCB(2)
      IF(PSC(3).LE.0.) PSC(3) = PSCB(3)
      IF(PSC(4).LT.0.) PSC(4) = PSCB(4)
      GO TO 90
  720 IPSC = 0
      DO 730 I = 1,4
  730 PSC(I) = PSCB(I)
      GO TO 90
C***********************************************************************
C     TOPLINES CARD                                           ICARD = 28
C***********************************************************************
C.....THE "TOPLINES" CARD ALLOWS THE USER TO SPECIFY THE LINES PRINTED
C     IN SUBROUTINE OUTTOP (WHENEVER METHOD = 23)
  750 CONTINUE
      READ(INPUT,1504) ITEMP
      LINTYP = 0
      IF(ITEMP .EQ. IOFF) GO TO 90
      LINTYP = 1
      READ(INPUT,1500) LINTP
      GO TO 90
C***********************************************************************
C     BOTLINES CARD                                           ICARD = 29
C***********************************************************************
C.....THE "BOTLINES" CARD ALLOWS THE USER TO SPECIFY THE LINES PRINTED
C     IN SUBROUTINE OUTBOD (WHENEVER METHOD = 23)
  770 CONTINUE
      READ(INPUT,1504) ITEMP
      LINBYP = 0
      IF(ITEMP .EQ. IOFF) GO TO 90
      LINBYP = 1
      READ(INPUT,1500) LINBD
      GO TO 90
C***********************************************************************
C     INFORMATION CARD                                        ICARD = 30
C***********************************************************************
C     N O T E - THIS OPTION IS NOT AVAILABLE TO ALL USERS AND IF NOT
C     AVAILABLE ACTS AS A "DO-NOTHING" CARD AND IS IGNORED
C
C     1.  MODE GENERATION SUBROUTINE.                     SHORT
C     2.  OVER-THE-MUF ABSORPTION RATES.                  BOTH
C     4.  SELTXR (0.05 to 0.5) CHANGE RESULTS.            LONG
C         or LUCAS' LETTER FOR HIGH ORDER MUFS ONLY       SHORT
C     8.  LUCAS' LETTER CHANGE RESULTS.                   BOTH
C    16.  LONG PATH/SHORT PATH SMOOTHING VALUES.          BOTH (MSPEC=121)
C    32.  RAYSET (PAGE 23)                                BOTH
C    64.  V. IONOGRAM AND REFLECTRIX (PAGE 21)            BOTH
C   128.  EXTRA LONG PATH PARAMETERS                      LONG
C
  780 READ(INPUT,1500)INFO
      IHSHR=IAND(INFO,1)+IAND(INFO,2)+IAND(INFO,32)+IAND(INFO,128)
      IHLNG=IAND(INFO,2)+IAND(INFO,8)+IAND(INFO,32)+IAND(INFO,128)
            GO TO 90
C***********************************************************************
C     AREA    CARD                                            ICARD = 31
C***********************************************************************
C.....AREA    card reads area coverage center and limits
800   nx=0
      ny=0
      READ(INPUT,801) plat,plon,xmin,xmax,yymin,ymax,nx,ny,itype
801   format(10x,6F10.0,3i5)
      if(nx.eq.0) nx=5
      if(ny.eq.0) ny=5
      iproj=7               !  great circle projection
      if(itype.ne.0) iproj=8         !  lat/lon for GRIB format
      iarea=1
      GO TO 90
C***********************************************************************
C     LINEMAX CARD                                            ICARD = 32
C***********************************************************************
C.....LINEMAX card reads maximum lines per page
805   READ(INPUT,'(10x,i5)') LINMAX
      if(LINMAX.lt.30) LINMAX=55
      GO TO 90
C***********************************************************************
C     COEFFS  CARD                                            ICARD = 33
C***********************************************************************
C.....COEFFS card allows either CCIR or URSI88 foF2 coefficients
806   coeff=INPUT(11:14)
      if(coeff.ne.'URSI') coeff='CCIR'
      GO TO 90
C***********************************************************************
C     (ZONES) CARD                                            ICARD = 34
C***********************************************************************
C.....CIRAF zone list to calculate values at CIRAF test points
  810 CONTINUE
      call rdCIRAF           !  read the 911 CIRAF test points
      cirafz=input(11:40)
      call parse_zones(cirafz,zones,nzones)
      call zones_to_TP(zones,nzones,idx_TP,nTP)  !  convert zones to Test Points
      GO TO 90
C***********************************************************************
C     (BLANK) CARD                                            ICARD = 35
C***********************************************************************
C.....A "(BLANK)" CARD ACTS AS A "DO-NOTHING" CARD AND IS IGNORED
  820 CONTINUE
      GO TO 90
C***********************************************************************
C     (USER DEFINED PROCEDURE NAME) CARD
C***********************************************************************
C.....THE "(USER DEFINED PROCEDURE NAME)" CARD PLACES THE CARD IMAGES
C     DEFINED BY THE USER PROCEDURE INTO THE INPUT STREAM
  880 CONTINUE
      REWIND LU35
      ISPROC = 1
C.....LOCATE THE DESIRED PROCEDURE ON THE PROCEDURE FILE
  890 JCARD = MONITR(LU35,MAXNAM)
      IF(JCARD - ICARD) 890, 90, 890
C.....END OF NAMES
C.....EXECUTE PROGRAM IF TWO CONSECUTIVE CARDS WITH THE SAME NAME
  900 CONTINUE
      IRED = -1
      GO TO 415
C.....E R R O R IN THE INPUT - CARD NAME NOT FOUND IN THE CARD NAME LIST
  910 WRITE(LUO,1520)
      ITRUN = 0
  920 continue
      do 930 i=1,12   !  if any daily predictions, must use URSI
         if(idaily(i).ne.0) then
            coeff='URSI'
         end if
930   continue
      RETURN
C.....FORMAT SPECIFICATIONS
 1401 FORMAT(A80)
 1402 FORMAT(' ','MONTH =',I5,5X,'MONTH INDEX =',I5)
 1403 FORMAT(' ',8A10,5X,'ICARD = ',I5)
 1406 FORMAT(' ','SSN = ',F7.2)
 1500 FORMAT(10X,14I5)
 1502 FORMAT(10X,A5,13I5)
 1504 FORMAT(10X,4A10)
 1508 FORMAT(10X,13F5.2)
 1514 FORMAT(10X,I5,3(F5.2,A1,4X),F5.0,6F5.2)
 1516 FORMAT(10X,I5,3(F5.2,2F5.1))
 1518 FORMAT(10X,I5,3F5.2,F5.1)
 1520 FORMAT(///,' NAME IDENTIFIER ERRORS DETECTED ON INPUT FILE')
 1528 FORMAT(16F5.2)
 1530 FORMAT(10X,I5,A10)
      END
C--------------------------------

C FUNCTION CANG               (NEXT)
      FUNCTION CANG (Z) 
C 
C 
C      FOR USE WITH HFMUFES3 IN SYSTEMS WHERE FUNCTION CANG IS MISSING. 
C 
C 
C 
C     CANG - COMPUTES CANG=ARG(Z), Z=X + I*Y=COMPLEX NUMBER, SUCH THAT
C        -PI .LT. CANG .LE. +PI.  SEE CONTROL DATA CORP. 3600/3800
C        COMPUTER SYSTEMS LIBRARY FUNCTIONS MANUAL, PUBLICATION NO. 
C        60056400, JULY 1, 1966.
C 
      COMPLEX Z 
C 
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RO, VOFL 
C 
C 
C.....INITIALIZE CANG FOR QUADRANT CORRECTION, GET RE(Z) AND IM(Z), TEST
C.....X FOR + OR - TO FIND CORRECT HALF-PLANE...........................
      CANG = 0.0
      X = REAL (Z)
      Y = AIMAG (Z) 
      IF (X)100, 120, 140 
C.....X .LT. 0.0........................................................
 100  IF (Y)105, 110, 115 
 105  CANG = - PI 
      GO TO 140 
 110  CANG = + PI 
      RETURN
 115  CANG = + PI 
      GO TO 140 
C.....X .EQ. 0.0........................................................
 120  IF (Y)125, 130, 135 
 125  CANG = - PIO2 
      RETURN
C. . .X=0 AND Y=0 IS REALLY UNDEFINED, BUT IN AGREEMENT WITH CDC WE. . .
C. . .RETURN A VALUE OF CANG=0.0 . . . . . . . . . . . . . . . . . . . .
 130  CANG = 0.0
      RETURN
 135  CANG = + PIO2 
      RETURN
C.....X .GT. 0.0 AND X .6T. 0.0 ADJUSTED FOR CORRECT QUADRANT...........
 140  CANG = ATAN (Y / X) + CANG
      RETURN
      END 

      subroutine ioninit(index,parm,asig,aeps,and,anl,anh,aex)
c            initialize IONCAP antennas
      dimension parm(20),aex(4)

      asig=parm(4)                         !  conductivity
      aeps=parm(3)                         !  dielectric
      do 111 i=1,4
111   aex(i)=0.
      go to (1,2,3,3,5,6,7,8,9,10),index
c                                          !  Terminated Horizontal Rhombic
1     and=parm(6)              !  tilt angle
      anl=parm(7)              !  leg length
      anh=parm(8)              !  height
      return
c                                          !  Vertical Monopole
2     anl=parm(6)              !  height
      anh=parm(7)              !  gain above dipole
      and=0.
      return
c                                          !  Horizontal Dipole & Yagi
3     anl=parm(6)              !  antenna length
      anh=parm(7)              !  antenna height
      and=0.
      aex(1)=parm(8)           !  gain above 1/2 wavelength horizontal dipole
      return
c                                          !  Vertical Lop-Periodic
5     anl=-.25                 !  antenna height (MUST be 1/4 wavelength)
      and=0.
      anh=0.
      aex(1)=parm(6)           !  gain above 1/4 wavelength vertical
      return
c                                          !  Curtain
6     and=parm(6)              !  # of bays
      anl=parm(7)              !  antenna element length
      anh=parm(8)              !  antenna height to 1st element
      aex(1)=parm(9)           !  # of elements per bay
      aex(2)=parm(10)          !  distance between element centers
      aex(3)=parm(11)          !  vertical spacing of elements
      aex(4)=parm(12)          !  distance from screen
      return
c                                          !  Sloping Vee
7     and=parm(6)              !  1/2 apex angle in plane of wires
      anl=parm(7)              !  antenna leg length
      anh=parm(8)              !  antenna height
      aex(1)=parm(9)           !  terminated height
      return
c                                          !  Inverted L
8     anl=parm(6)              !  antenna length
      anh=parm(7)              !  antenna height
      and=0.
      return
c                                          !  Sloping Rhombic
9     and=parm(6)              !  1/2 large interior angle in plane of wires
      anl=parm(7)              !  antenna leg length
      anh=parm(8)              !  antenna height
      aex(1)=parm(9)           !  terminated height
      return
c                                          !  Interlaced Rhombic
10    and=parm(6)              !  1/2 large interior angle in plane of wires
      anl=parm(7)              !  antenna leg length
      anh=parm(8)              !  lower antenna height
      aex(1)=parm(9)           !  vertical displacement
      aex(2)=parm(10)          !  horizontal feed point displacement
      return
      end
c------------------------------------------------------------------

c###allmodes.for
      SUBROUTINE ALLMODES(iflg,fval)
C--------------------------------
C
C     THIS ROUTINE outputs THE binary values for the allmodes method
c
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SYGU,SYGL,KJ,JK
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / ZON / ABPS(7), CREL(7), EFF(7), FLDST(7), GRLOS(7),
     1 HN(7), HP(7), PROB(7), RELY(7), RGAIN(7), SIGPOW(7), SN(7),
     2 SPRO(7), TGAIN(7), TIMED(7), TLOSS(7), B(7), FSLOS(7), ADV(7),
     3 OBF(7),NMODE(7),TLLOW(7),TLHGH(7)
      COMMON / allMODE /zABPS(20),zCREL(20),zFLDST(20),zHN(20),zHP(20),
     1zPROB(20),zRELY(20),zRGAIN(20),zSIGPOW(20),zSN(20),
     2zSPRO(20),zTGAIN(20),zTIMED(20),zTLOSS(20),zB(20),zFSLOS(20),
     3zgrlos(20),zadv(20),zobf(20),
     CizNMODE(20),zTLLOW(20),zTLHGH(20),zEFF(20),NREL,NMMOD
C125PC      COMMON/SPALMOUT/RNZ(11,24,4,2),DUZ(11,24,4,2),DLZ(11,24,4,2),
C125PC     -ZTL(20,11,24,4,2),BBZ(20,11,24,4,2), ZLO(20,11,24,4,2),
C125PC     -ZHG(20,11,24,4,2)
C125PC      COMMON/INDICEZ/ISP,ISZ,IFQN,IUR,NMS(11,24,4,2)
C125PC      COMMON/LPALMOT2/zACAV(24,4,2),zASM(24,4,2),zDSL(24,4,2),
C125PC     +zDSU(24,4,2),zYMUF(4,24,4,2),zYFOT(4,24,4,2),zYHPF(4,24,4,2),
C125PC     +zFVMUF(4,24,4,2),zSIGL(4,24,4,2),zSIGU(4,24,4,2)
C125PC      common/lpalmcmp/imddl(45,2,11,24,4,2),igdfx(45,2,11,24,4,2),
C125PC     +itlos(45,2,11,24,4,2),ihpfx(45,2,11,24,4,2),lNANG(2,11,24,4,2)
C125PC      integer*2 imddl,igdfx,itlos,ihpfx,lNANG
c--------------------------------------------------------------
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / GEOG / GYZ(5), RAT(5), GMDIP(5), CLCK(5), ABIY(5),
     1 ARTIC(5), SIGPAT(5), EPSPAT(5)
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
C125PC   character*13 FILNAM
C125PC   data FILNAM/'xmtrddddd.alm'/
C------------------------------------------------------------------------
C125PC      if(iflg.eq.200.AND.MSPEC.GT.120)GO TO 100
      if(iflg.eq.0)then
        NMMOD=0
        do 2 i=1,20
        zTLOSS(i)=99999.
        ztllow(i)=999.
        ztlhgh(i)=999.
        ZHP(I)=-1.
C125PC        IF(MSPEC.EQ.125)THEN
C125PC          BBZ(I,IFQN,IUR,ISZ,ISP)=99.
C125PC          ZTL(I,IFQN,IUR,ISZ,ISP)=99999.
C125PC          ZLO(I,IFQN,IUR,ISZ,ISP)=999.
C125PC          ZHG(I,IFQN,IUR,ISZ,ISP)=999.
C125PC        ENDIF
    2   continue
        freq=fval
        RETURN
C125PC      else if(iflg.eq.1.AND.MSPEC.NE.125)then
      else if(iflg.eq.1)then
        ist=1
        hp(2)=hp(1)
        zTLOSS(2)=32000.
        lst=1
        iznmode(NMMOD+2)=nmode(2)
        zb(NMMOD+2)=b(2)
      else if(iflg.eq.2)then
        ist=4
        lst=5
      else
        ist=1
        lst=6
      ENDIF
C125PC      IF(NMMOD.EQ.0.AND.MSPEC.EQ.125)THEN
C125PC        RNZ(IFQN,IUR,ISZ,ISP)=RCNSE
C125PC        DUZ(IFQN,IUR,ISZ,ISP)=DU
C125PC        DLZ(IFQN,IUR,ISZ,ISP)=DL
C125PC      ENDIF
      do 10 i=ist,lst
      if(hp(i).gt.0.)then
        NMMOD=NMMOD+1
C125PC        if(MSPEC.eq.125)then
C125PC          ihn=1000.*hn(i)
C125PC          ilay=100.*nmode(i)
C125PC          BBZ(NMMOD,IFQN,IUR,ISZ,ISP)=b(i)+ihn+ilay
C125PC          ZTL(NMMOD,IFQN,IUR,ISZ,ISP)=TLOSS(i)
C125PC          ZLO(NMMOD,IFQN,IUR,ISZ,ISP)=TLLOW(i)
C125PC          ZHG(NMMOD,IFQN,IUR,ISZ,ISP)=TLHGH(i)
C125PC        else
          zTLOSS(NMMOD)=TLOSS(i)
          ztllow(NMMOD)=tllow(i)
          ztlhgh(NMMOD)=tlhgh(i)
          zhp(NMMOD)=hp(i)
          zcrel(NMMOD)=crel(i)
          zrely(NMMOD)=rely(i)
          zhn(NMMOD)=hn(i)
          iznmode(NMMOD)=nmode(i)
          zsn(NMMOD)=sn(i)
          zfldst(NMMOD)=fldst(i)
          zsigpow(NMMOD)=sigpow(i)
          zb(NMMOD)=b(i)
          ztimed(NMMOD)=timed(i)
          zabps(NMMOD)=abps(i)
          zprob(NMMOD)=prob(i)
          zrgain(NMMOD)=rgain(i)
          ztgain(NMMOD)=tgain(i)
          zfslos(NMMOD)=fslos(i)
          zspro(NMMOD)=spro(i)
          zEFF(NMMOD)=EFF(i)
          zgrlos(NMMOD)=grlos(i)
          zadv(NMMOD)=adv(i)
          zobf(NMMOD)=obf(i)
C125PC        ENDIF
      ENDIF
   10 continue
C125PC      IF(MSPEC.EQ.125)THEN
C125PC        NMS(IFQN,IUR,ISZ,ISP)=NMMOD
C125PC        if(NMMOD.eq.0)NMS(IFQN,IUR,ISZ,ISP)=NMMOD+1
C125PC      ENDIF
C125PC  100 if(fval.EQ.999..AND.MSPEC.EQ.125)then
C125PC        IF(IFQN.EQ.11.AND.IUR.EQ.24.AND.ISZ.EQ.4.AND.ISP.EQ.2)THEN
C125SPLP          IF(GCDKM.GE.7000.)THEN
C125SPLP            NYEAR(1:1)='L'
C125SPLP          ELSE
C125PC            NYEAR(1:1)='A'
C125SPLP          ENDIF
C125PC          FILNAM(1:9)=itran(1)(1:9)
C125PC          open(M100,file=FILNAM,status='new',form='unformatted')
C125PC          WRITE(M100)tlatd,itlat,tLONGd,itLONG,RLATD,IRLAT,
C125PC     +    RLONGD,irLONG,btrd,gcdkm,rsn,lufp,nyear
C125PC          WRITE(M100)(FREL(if),if=1,11)
C125PC          WRITE(M100)((((NMS(if,it,IM,IS),(ztl(ih,if,it,IM,IS),
C125PC     -    BBZ(ih,if,it,IM,IS),zlo(ih,if,it,IM,IS),zhg(ih,if,it,IM,IS),
C125PC     -    ih=1,NMS(if,it,IM,IS)),RNZ(if,it,IM,IS),DUZ(if,it,IM,IS),
C125PC     -    DLZ(if,it,IM,IS),if=1,11),it=1,24),IM=1,4),IS=1,2)
C125SPLP          IF(GCDKM.GE.7000.)THEN
C125SPLP            WRITE(M100)(HI(1,ILY),FI(1,ILY),ILY=1,3),GYZ(3),AMIND,
C125SPLP     +      km,(SIGPAT(icp),EPSPAT(icp),icp=1,km)
C125SPLP            WRITE(m100)(((((LNANG(JJ,IF,IT,IM,IS),
C125SPLP     +      (imddl(ia,JJ,if,it,im,is),igdfx(ia,JJ,if,it,im,is),
C125SPLP     +      itlos(ia,JJ,if,it,im,is),ihpfx(ia,JJ,if,it,im,is),
C125SPLP     +      IA=1,LNANG(JJ,IF,IT,IM,IS)),JJ=1,2),if=1,11),it=1,24),
C125SPLP     +      IM=1,4),IS=1,2)
C125SPLP            WRITE(m100)(((zACAV(it,im,is),zASM(IT,IM,IS),
C125SPLP     +      zDSL(IT,IM,IS),zDSU(IT,IM,IS),(zYMUF(ILY,IT,IM,IS),
C125SPLP     +      zYFOT(ILY,IT,IM,IS),zYHPF(ILY,IT,IM,IS),
C125SPLP     +      zFVMUF(ILY,IT,IM,IS),zSIGL(ILY,IT,IM,IS),
C125SPLP     +      zSIGU(ILY,IT,IM,IS),ILY=1,4),it=1,24),IM=1,4),IS=1,2)
C125SPLP          ENDIF
C125PC          close(M100)
C125PC        ENDIF
C125PC      ENDIF
      RETURN
      END
C--------------------------------

c###lecden.for
      SUBROUTINE LECDEN(K)
C--------------------------------
C
C     THIS ROUTINE GENERATES ELECTRON DENSITY PROFILE
C
C     ADD TOP BY EXTENDING HTR(50,3) AND FNSQ(50,3)
C
      COMMON / MFAC / F2M3(5),HPF2(5),ZENANG(5),ZENMAX(5),IEDP,FSECV(3)
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
C.....RETURN IF EXTERNAL ELECTRON DENSITY PROFILE IS USED
      DO 90 I = 1,3
      IF(IELECT(I)) 90, 90, 85
   85 RETURN
   90 CONTINUE
C.....MUST CHECK ON F1 LAYER PARAMETERS FIRST
      XLOW = .8516
      HZ = HI (1, K) - YI (1, K)
      XUP = 0.98 * FI (1, K) / FI (3, K)
      HLOW = HZ + YI (1, K) * (1. + SQRT (1. - XLOW * XLOW))
      HTE = HI (1, K) + YI (1, K)
      HB2 = HI (3, K) - YI (3, K)
      FCE = FI (1, K) * FI (1, K)
      FC2 = FI (3, K) * FI (3, K)
C.....VALLEY FILLED FROM (FLOW,HLOW) TO (FUP,HUP)
      HUP = HB2 + YI (3, K) * (1. - SQRT (1. - XUP * XUP))
      FUP = XUP * XUP * FC2
      FLOW = XLOW * XLOW * FCE
      ASP = 0.
      IF (HUP - HLOW)175, 175, 165
  165 ASP = (FUP - FLOW) / (HUP - HLOW)
  175 CONTINUE
      IF (FI (2, K))215, 215, 185
  185 CONTINUE
      FC1 = FI (2, K) * FI (2, K)
      HB1 = HI (2, K) - YI (2, K)
      HT1 = HI (2, K) + YI (2, K)
C.....HEIGHT OF F2 AT F1 CRITICAL FREQUENCY
      HTW = HB2 + YI (3, K) * (1. - SQRT (1. - FC1 / FC2))
c-----
ccc      WRITE(6,'(1h+)')
c-----
ccc      IF (HTW - HI (2, K))190, 190, 205
      IF(HTW.gt.HI(2, K)+.001) go to 205
C.....FORCE F1 AT CRITICAL FREQUENCY
  190 YS = HTW - HB1
      YS = AMAX1 (1., YS)
C.....SLOPE OF LINEAR F1
      S1 = FC1 / YS
      hiold=hi(2,k)
      HI(2,K) = HTW
      YI(2,K) = YS
C.....AVOID A SPURIOUS LAYER
      IF(HB2 - HB1) 194, 195, 195
  194 YI(2,K) = HI(2,K) - HB2
      GO TO 205
C.....SET FLAG TO INDICATE LINEAR LAYER FOR F1
  195 LIN = 1
      FSECV(K) =  SQRT(FLOW)
      DENOM = 1. - (FI(1,K) / FI(2,K)) ** 2
C.....F1 LINE NOT TO OBSCURE E LAYER
      DENOM = AMAX1(.17,DENOM)
      YB = (HI(2,K) - HI(1,K)) / DENOM
      IF(YS-YB) 402,401,401
C  THIS  IS CCIR(1976) IF FI(2,K) = 1.7*FI(1,K)
C.....F1 PASSES THROUGH E NOSE
  401 YS = YB
      YI(2,K) = YS
      S1  = FC1/YS
      HB1 = HI(1,K)
      GO TO 415
  402 CONTINUE
C.....TO FORCE CCIR (BRADLEY) SET
C     FI(2,K) = 1.7 * FI(1,K)
C     HI(2,K) = HTW
C     YI(2,K) = YB
C     HB1 = HI(1,K)
C     HT1 = HTW
C     S1  = FC1/YS
  415 CONTINUE
      HT1 = HTW
      GO TO 215
  205 LIN = 0
C.....FORCE F1 ABOVE E LAYER
      YI(2,K) = AMIN1(YI(2,K),(HI(2,K) - HI(1,K) + 1.))
      FSECV(K) = -1.
  215 CONTINUE
C.....D-REGION PROFILE - XTAIL MAY HAVE DIURNAL VARIATION.
      HD = 70.
      XTAIL = .85
      HEX = HI(1,K) - XTAIL * YI(1,K)
      FNX = 1. - XTAIL * XTAIL
C.....SLOPE OF E IS SAME AS SLOPE OF V AT HEX
      ALP = 2. * (HI(1,K) - HEX) / (FNX * YI(1,K) * YI(1,K))
      FSQ = FNX * EXP(-ALP * (HEX - HD))
      HTR(1,1) = HD
      HTR(5,1) = HEX
      HDIF = (HTR(5,1) - HTR(1,1)) * .25
      HDIF = AMAX1 (0., HDIF)
      HTR(4,1) = HTR(5,1) - AMIN1(1.0,HDIF)
      HTR(2,1) = HTR(1,1) + HDIF
      HTR(3,1) = (HTR(2,1) + HTR(4,1)) * 0.5
C  E  BELOW NOSE
      HTR(11,1) = HI (1, K)
      HDIF = (HTR(11,1) - HTR(5,1)) / 6.
      DO 100 IH = 6, 10
  100 HTR(IH,1) = HTR(IH - 1,1) + HDIF
C  E ABOVE  NOSE
      HTR(17,1) = HI (1, K) + YI (1, K)
      HDIF = (HTR(17,1) - HTR(11,1)) / 6.
      DO 105 IH = 12, 16
  105 HTR(IH,1) = HTR(IH - 1,1) + HDIF
      HTR(11,1) = 0.5 * (HTR(10,1) + HTR(12,1))
      HTR(50,1) = HI (3, K)
      IF (FI (2, K))110, 110, 125
C  F2  LAYER, NO F1 LAYER.
  110 HTR(18,1) = HI (3, K) - YI (3, K)
      HDIF = (HTR(50,1) - HTR(18,1)) / 32.
      DO 115 IH = 19, 49
  115 HTR(IH,1) = HTR(IH - 1,1) + HDIF
      GO TO 155
C  F1 LAYER AND F2 LAYER
  125 HB2 = HI(3,K) - YI(3,K)
      HB1 = HI(2,K) - YI(2,K)+.00001
      IF(HB2 - HB1) 110, 110, 126
  126 HTR(18,1) = HI(2,K) - YI(2,K)
      HTR(18,1) = AMAX1 (HTR(18,1), HTR(17,1) + 1.)
      HTR(28,1) = HI (2, K)
      HDIF = (HTR(28,1) - HTR(18,1)) / 10.
      DO 135 IH = 19, 27
  135 HTR(IH,1) = HTR(IH - 1,1) + HDIF
      HDIF = (HTR(50,1) - HTR(28,1)) / 22.
      DO 145 IH = 29, 49
  145 HTR(IH,1) = HTR(IH - 1,1) + HDIF
  155 CONTINUE
C.....FORCE F1 ABOVE E LAYER
      HB1 = AMAX1(HI(1,K), (HI(2,K)-YI(2,K) )  )
      DO 375 IH = 1, 50
      FND = 0.
      FNE = 0.
      FN1 = 0.
      FN2 = 0.
      FNVAL = 0.
      H = HTR(IH,1)
      IF (H - HLOW)245, 245, 225
  225 IF (H - HUP)235, 245, 245
C.....LINEAR VALLEY
  235 FNVAL = FUP + ASP * (H - HUP)
  245 IF(H - HEX) 275, 255, 255
  255 IF (H - HTE)260, 260, 285
C.....PARABOLIC E
  260 Z = (H - HI (1, K)) / YI (1, K)
      FNE = FCE * (1. - Z * Z)
      IF(H - HEX) 275, 285, 285
C.....EXPONENTIAL D-E
  275 FND = FCE * FSQ * EXP (ALP * (H - HD))
  285 IF (FI (2, K))345, 345, 290
  290 IF (HB1 - H)295, 295, 345
  295 IF (H - HT1)300, 300, 345
  300 IF (LIN)305, 305, 335
  305 Z = (H - HI (2, K)) / YI (2, K)
C.....PARABOLIC F1
      FN1 = FC1 * (1.0 - Z * Z)
      GO TO 345
C.....LINEAR F1
  335 FN1 = S1*(H - (HI(2,K)-YI(2,K) ) )
  345 IF (HB2 - H)355, 355, 365
  355 Z = (H - HI (3, K)) / YI (3, K)
C.....PARABOLIC F2
      FN2 = FC2 * (1.0 - Z*Z)
  365 FNSQ (IH,1) = AMAX1 (FND, FNE, FNVAL, FN1, FN2)
C.....USE THE MAXIMUM
  375 CONTINUE
      RETURN
      END
C--------------------------------

c###setlng.for
      SUBROUTINE SETLNG
C--------------------------------
C
C     IF SHORT PATH, THIS SUBROUTINE FILLS IN ALL OF THE ARRAYS
C
      COMMON /RAYS/ ANG(40), IFOB(40,30,5), NANG
      COMMON/ES/FS(3,5),HS(5)
      COMMON/GEOG/GYZ(5),RAT(5),GMDIP(5),CLCK(5),ABIY(5),ARTIC(5),SIGPAT
     A (5),EPSPAT(5)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      IF(KFX -3) 105,100,100
  100 CONTINUE
      RETURN
  105 IF(KFX-1) 110,110,135
C.....ONE SAMPLE AREA
  110 CONTINUE
      DO 120 IS =2,5
      CLAT(IS)  = CLAT(1)
      CLONG(IS) = CLONG(1)
      GLAT(IS)  = GLAT(1)
C
C  IF DISTANCE INTERPOLATION IS USED THIS MAY CAUSE FAILURE.
C     (AS THE RD"S ARE EQUAL)
C
      RD(IS)    = RD(1)
      GYZ(IS)   = GYZ(1)
      RAT(IS)   = RAT(1)
      GMDIP(IS) = GMDIP(1)
      CLCK(IS)  = CLCK(1)
      ABIY(IS)  = ABIY(1)
      ARTIC(IS) = ARTIC(1)
      SIGPAT(IS)= SIGPAT(1)
      EPSPAT(IS)= EPSPAT(1)
      HS(IS)    = HS(1)
      DO 115 IL =1,3
      FS(IL,IS) = FS(IL,1)
      FI(IL,IS) = FI(IL,1)
      YI(IL,IS) = YI(IL,1)
      HI(IL,IS) = HI(IL,1)
  115 CONTINUE
  120 CONTINUE
      DO 130 IS = 2,3
      DO 125 IL= 1,30
      HPRIM(IL,IS) = HPRIM(IL,1)
      HTRUE(IL,IS) = HTRUE(IL,1)
      FVERT(IL,IS) = FVERT(IL,1)
      AFAC(IL,IS) = AFAC(IL,1)
      DO 124 IA = 1,40
  124 IFOB(IA,IL,IS) = IFOB(IA,IL,1)
  125 CONTINUE
  130 CONTINUE
      RETURN
C.....THE CASE OF 3 SAMPLE AREAS
  135 CONTINUE
      DO 145  IS =4,5
      CLAT(IS)=   CLAT(3)
      CLONG(IS) = CLONG(3)
      GLAT(IS)  = GLAT(3)
C  IF DISTANCE INTERPOLATION IS USED THIS MAY CAUSE FAILURE.
      RD(IS)    = RD(3)
      GYZ(IS)   = GYZ(3)
      RAT(IS)   = RAT(3)
      GMDIP(IS) = GMDIP(3)
      CLCK(IS)  = CLCK(3)
      ABIY(IS)  = ABIY(3)
      ARTIC(IS) = ARTIC(3)
      SIGPAT(IS) = SIGPAT(3)
      EPSPAT(IS)= EPSPAT(3)
      HS(IS)    = HS(3)
      DO 140 IL =1,3
      FS(IL,IS) = FS(IL,3)
      FI(IL,IS) = FI(IL,3)
      YI(IL,IS) = YI(IL,3)
      HI(IL,IS) = HI(IL,3)
  140 CONTINUE
  145 CONTINUE
      DO 150 IL = 1,30
      HPRIM(IL,3)= HPRIM(IL,2)
      HTRUE(IL,3)= HTRUE(IL,2)
      FVERT(IL,3) = FVERT(IL,2)
      AFAC(IL,3) = AFAC(IL,2)
      DO 149 IA = 1,40
  149 IFOB(IA,IL,3) = IFOB(IA,IL,2)
  150 CONTINUE
      RETURN
      END
C--------------------------------

c###relbil.for
      SUBROUTINE RELBIL (IF,freq)
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
C--------------------------------
C
C     THIS ROUTINE COMPUTES THE RELIABILITY FOR EACH MODE AT A
C     PARTICULAR FREQUENCY, SELECTS THE MOST RELIABLE, CALCULATES THE
C     COMBINED DISTRIBUTION FOR ALL MODES AND THE RELIABILITY OF THE
C     COMBINATION, AND THE REQUIRED POWER PLUS GAIN TO ACHIEVE THE
C     REQUIRED RELIABILITY
C
C     SN(IM) = MEAN SIGNAL TO NOISE FOR MODE IM
C
C.....SIGNAL STATISTICS
C DSU =UPPER DECILE SIGNAL LEVEL ADJUSTMENT FROM MEDIAN
C ASM = AURORAL ADJUSTMENT TO MEDIAN SIGNAL LEVEL
C DSL = LOWER DECILE SIGNAL LEVEL ADJUSTMENT FROM MEDIAN
C     ADS = MEAN PREDICTION ERROR
C     SUS = UPPER DECILE PREDICTION ERROR
C     SLS = LOWER DECILE PREDICTION ERROR
C
C.....NOISE STATISTICS
C     RCNSE = MEAN NOISE LEVEL
C     DU = UPPER DECILE NOISE LEVEL
C     DL = LOWER DECILE NOISE LEVEL
C
C     RSN = REQUIRED SIGNAL TO NOISE RATIO
C     DRSN = 2. = RSN PREDICTION ERROR
C     LUFP = GIVEN REQUIRED RELIABILITY
C     IF = FREQUENCY INDEX, FREQ = FREL(IF)
C
C
C     RELIAB(IF) = RELIABILITY
C     SPROB(IF) = SERVICE PROBABILITY
C
c
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SXGU,SXGL,KJ,JK
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / OUTLAB / LABEL(11), LAYTYP(5), IEAST, INORTH, ISOUTH,
     A IWEST, LABLI, LABLJ, LABLK
      CHARACTER IEAST*1, ISOUTH*1, INORTH*1, IWEST*1, LABEL*5, LAYTYP*2,
     A LABLI*5, LABLJ*5, LABLK*5
      COMMON/SIGD/DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE,HNU
     A ,HTLOSS,XNUZ,XVE
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON /DUDL_NOIS/ DU_NOIS(13),DL_NOIS(13)
      COMMON / allMODE /ABPS(20),CREL(20),FLDST(20),HN(20),HP(20),
     1PROB(20),RELY(20),RGAIN(20),SIGPOW(20),SN(20),
     2SPRO(20),TGAIN(20),TIMED(20),TLOSS(20),B(20),FSLOS(20),
     3grlos(20),adv(20),obf(20),
     CNMODE(20),TLLOW(20),TLHGH(20),EFF(20),NREL,NMMOD
      COMMON/INFORM/INFO,IHSHR,IHLNG
      common /sncom/ snxx(13)
      common /cgains/ gaint(13),gainr(13)    !  transmitter & receiver gains
      DIMENSION TME(10)
C.....NORMAL DISTRIBUTION
      DATA TME/ 0.0,0.1257,0.2533, 0.3853,0.5244,0.6745,0.8416,1.0364,
     A 1.2815,1.6449/
      DATA XEPS/0.05/
      INUM=NMMOD
C.....IF NO MODES RETURN...............................................
      IF(INUM.LE.0)RETURN
C.....BEGINNING OF RELIABILITY CALCULATION FOR EACH MODE
C.....USED TO SELECT 1 OF UP TO 20 MODES FOR EACH FREQ
      DU2=DU*DU
      DL2=DL*DL
      DO 310 IM = 1,INUM
      IF( HP(IM).le. 70. ) then
         CREL(IM) = 0.001
         RELY(IM) = 0.001
      else
         IS = NMODE(IM)
         DSLF = TLLOW(IM)
         DSUF = TLHGH(IM)
C.....REQUIRED SIGNAL TO NOISE DISTRIBUTION
c%lc:gsp 28-DEC-1994:1st change, subroutine RELBIL *********************
c%lc    D10R is the lower distribution variable for the snr; values of snr
c%lc    at this end of the snr distribution reflect high noise & low signal.
c%lc    As such, D10R = f(DU2, DSLF).  Similarly, D90R = f(DL2, DSUF)
         D10R = SQRT(DU2 + DSLF*DSLF)
         D50R = SN(IM)
         D90R = SQRT( DL2 + DSUF*DSUF )
c%lc        D10R = SQRT(DL2 + DSLF*DSLF)
c%lc        D50R =  SN(IM)
c%lc        D90R = SQRT( DU2 + DSUF*DSUF )
c%lc:gsp 28-DEC-1994:end change ***************************************
         Z =  RSN - D50R
         IF(Z.le.0.) then
            Z = Z/(D10R/1.28)
         else
            Z = Z/(D90R/1.28)
         end if
         RELY(IM) = 1. - FNORML(Z)
C.....CREL IS NOT USED NOW
         CREL(IM) =  1000.
      end if
  310 CONTINUE
C
C.....END OF RELIABILITY CALCULATION FOR EACH MODE
C  MOST RELIABLE  MODE
C
      IRmethod=1       !  original - if RELs are within .05 of each other
ccc      IRmethod=2       !  if RELs are within 5% of each other
ccc      IRmethod=3       !  original, but if MRM REL is < .01, use mode with max REL
      IRmax=1
c          the original way of looking for the MRM in the 140 loop could
c          produce an improper mode.
c          Thus, first find the max REL mode
      do 10 im=2,inum
      if(RELY(IM).gt.RELY(IRmax)) IRmax=IM     !  IRmax will be the mode with max REL
10    continue

      IR=IRmax
      XREL = RELY(IR)
      XHN  = HN(IR)
      XSN  = SN(IR)
C.....IF ONLY ONE MODE USE IT........................................
ccc      write(luo,311) ir,rely(ir),hn(ir),sn(ir)
      DO 140 IM= 1,INUM
      if(im.eq.IRmax) go to 140       !  don't compare this mode
ccc      write(luo,311) im,rely(im),hn(im),sn(im)
ccc311   format('mode=',i5,3f10.5)
C.....MAKE SELECTION BASED ON RELIABILITY FIRST BUT IF CLOSE SELECT ON
C.....LOWER NUMBER OF HOPS (IF THE NUMBER OF HOPS ARE EQUAL SELECT BY
C.....MEDIAN SNR)
      if(xrel.lt..00000001) xrel=.00000001
      RELtest=ABS(RELY(IM)-XREL)
      if(IRmethod.eq.2) RELtest=RELtest/XREL        !  use percentage
      IF(RELtest .GE. XEPS ) go to 140              !  REL not close to max REL
C.......CLOSE SO TEST IF NUMBER OF HOPS ARE EQUAL.....................
        IF(ABS(XHN - HN(IM)).LE.XEPS)THEN
C.........NUMBER OF HOPS ARE EQUAL SO TEST MEDIAN SNR.................
          IF( XSN.LT.SN(IM) )THEN
            GO TO 139
          ENDIF
        ELSE IF(XHN.GT.HN(IM))THEN
C.........THIS ONE HAS FEWER HOPS.....................................
          GO TO 139
        ENDIF
      GO TO 140
C.....THIS MODE IS BETTER SO TRY IT...................................
  139 IR = IM
      XHN=HN(IM)
      XSN=SN(IM)
      XREL = RELY(IM)
  140 CONTINUE
c          if REL is small (<.01) use mode with highest REL
      if(IRmethod.eq.3 .and. RELY(IR).lt..01) IR=IRmax
      NREL = IR
      IS = NMODE(IR)
      MR=HN(IR)
ccc      write(luo,141) nrel
ccc141   format('nrel=',i5)
      IF(INUM.eq.1)THEN
C.......ONLY ONE MODE SO SET MOST RELIABLE VALUES....................
        RELIAB(IF) = RELY(IR)
        DBLOSL(IF) = TLLOW(IR)
        DBLOSU(IF) = TLHGH(IR)
        DBU(IF) = FLDST(IR)
        SNDB(IF) = SN(IR)
ccc        write(12,'('' in relbil, sndb('',i2,'')=sn('',i2,'')='',f9.3)')
ccc     +       if,ir,sndb(if)
        DBW(IF) = SIGPOW(IR)
      ELSE
C.......ADD THE SIGNALS RANDOM PHASE i.e. ADD THE POWERS IN WATTS....
        XDSLW = 0.0
        XSIGS = 0.0
        XDSUP = 0.0
        XFLD = 0.
        DXSIGS=-1000.
        DXFLD=-1000.
        DXDSLW=-1000.
        DXDSUP=-1000.
        DO 369 IV=1,INUM
        DXSIGS=AMAX1(DXSIGS,SIGPOW(IV))
        DXFLD=AMAX1(DXFLD,FLDST(IV))
        DXDSLW=AMAX1(DXDSLW,SIGPOW(IV)-TLLOW(IV))
        DXDSUP=AMAX1(DXDSUP,SIGPOW(IV)+TLHGH(IV))
  369   CONTINUE
        DO 370 IM = 1,INUM
        ZEXP = .1*(SIGPOW(IM) - TLLOW(IM)-DXDSLW)
        if(ZEXP.gt.-10.) XDSLW = XDSLW + 10. ** ZEXP
        ZEXP = .1*(SIGPOW(IM)-DXSIGS)
        if(ZEXP.gt.-10.) XSIGS = XSIGS +10. ** ZEXP
        ZEXP = .1 * (SIGPOW(IM) + TLHGH(IM)-DXDSUP)
        if(ZEXP.gt.-10.) XDSUP = XDSUP + 10. ** ZEXP
C  MUST DO FIELD STRENGTH SEPARATE  BECAUSE OF RECEIVE ANTENNA
        ZEXP = .1*(FLDST(IM)-DXFLD)
        if(ZEXP.gt.-10.) XFLD = XFLD + 10.**ZEXP
  370   CONTINUE
	SIGMED=-500.
        if(XSIGS.gt.0.) SIGMED = DXSIGS+ 10.*ALOG10(XSIGS)
	if(XDSLW.gt.0.) then
           DBLOSL(IF) = ABS( SIGMED - 10.*ALOG10(XDSLW)-DXDSLW )
        else
	   DBLOSL(IF)=0.
        end if
        if(DBLOSL(IF).lt. .2) DBLOSL(IF)=.2    !  set min GRH 8/21/02
        if(DBLOSL(IF).gt.30.) DBLOSL(IF)=30.   !  set max GRH 8/21/02
	if(XDSUP.gt.0.) then
           DBLOSU(IF) = ABS( DXDSUP+10.*ALOG10(XDSUP) - SIGMED )
        else
	   DBLOSU(IF)=0.
        end if
        if(DBLOSU(IF).lt. .2) DBLOSU(IF)=.2    !  set min GRH 8/21/02
        if(DBLOSU(IF).gt.30.) DBLOSU(IF)=30.   !  set max GRH 8/21/02
        DBW(IF) = SIGMED
        DELSIG = SIGMED - SIGPOW(IR)
	if(XFLD.gt.0.) then
           DBU(IF) = DXFLD + 10.*ALOG10(XFLD)
        else
	   DBU(IF)=-500.
	end if
        SNDB(IF) = SN(IR) + DELSIG
      if(prob(ir).lt..0001) then      !  MUFday says freq cannot work
ccc         dbu(if)=-500.
ccc         sndb(if)=-500.
ccc         sn(if)=-500.
      end if
ccc        write(12,'('' in relbil, sndb('',i2,'')=sn('',i2,'')='',2f9.3)')
ccc     +       if,ir,sndb(if),delsig
C.......REDO RELIABILITY FOR SUM OF MODES............................
c%lc:gsp 22-FEB-1995:change missed earlier, subroutine RELBIL ***************
        D10R = SQRT( DU2 + DBLOSL(IF)*DBLOSL(IF) )
        D50R = SNDB(IF)
        D90R = SQRT( DL2 + DBLOSU(IF)*DBLOSU(IF) )
c%lc:        D10R = SQRT( DL2 + DBLOSL(IF)*DBLOSL(IF) )
c%lc:        D50R = SNDB(IF)
c%lc:        D90R = SQRT( DU2 + DBLOSU(IF)*DBLOSU(IF) )
c%lc:gsp 28-DEC-1994:end change ***************************************
        if(D10R.lt. .2) D10R=.2
        if(D90R.gt.30.) D90R=30.
        Z = RSN - D50R
        IF(Z.le.0.) then
           Z = Z/(D10R/1.28)
        else
           Z = Z/(D90R/1.28)
        end if
        RELIAB(IF) = 1. - FNORML(Z)
      ENDIF
ccc      write(luo,777) if,reliab(if)
ccc777   format('if=',i5,'     REL=',f10.6)
      gaint(if)=TGAIN(IR)              !  save transmitter gain
      gainr(if)=RGAIN(IR)              !  save receiver    gain
      SNRLW(IF) = D10R
      SNRUP(IF) = D90R
      ANGLE(IF) =  B(IR)
      VHIGH(IF)=HP(IR)
      DELAY(IF)=TIMED(IR)
      DBLOS (IF)= TLOSS(IR)
c         new LOSS calculation 11/13/2014
c         since we have summed the signal powers, need to adjust transmission loss
      dblos(if)=pwrdb(freq)-dbw(if)     !  recalculate transmission loss
      CPROB(IF)=PROB(IR)
      MODE  (IF)= LAYTYP(IS)
      NHP   (IF)= HN(IR)
      XNYNOIS(IF)= RCNSE
      DU_NOIS(IF)=DU
      DL_NOIS(IF)=DL
C------------    ADDED 9/24/91  (LONG PATH RCVR EFF CORRECTION)
      RNEFF(IF)=EFF(IR)
ccc      write(luo,'(''eff='',2f10.3,2i5)') eff(ir),rgain(ir),ir,if
C  REQUIRED POWER GAIN  FOR SPECIFIED RELIABILITY.
      ITM = IABS( (LUFP - 50))/5 +1
      ITM = MIN0(ITM,10)
      TMX = TME(ITM)/TME(9)
      IF( LUFP.LT.50) THEN
         SNPR(IF) = - (D50R + TMX * D90R) + RSN
      ELSE
         SNPR(IF) = - (D50R - TMX * D10R) + RSN
      ENDIF
ccc      sn90(if)=d50r - d10r             !  lower decile (90%)
c          any % decile created 14.NOV.94
      snxx(if)=RSN     - SNPR(IF)     !  xx decile (xx%)
      IF(IAND(INFO,1).GT.0)THEN
        WRITE(99,'(29X,A,I4,A2)')'MOST RELIABLE MODE',NHP(IF),MODE(IF)
      ENDIF
      RETURN
      END
C--------------------------------

c# voacap.f
c      winapp 80000,260000
ccc      winapp 240000,500000
      PROGRAM VOACAPW
*    +                (filein,fileout,areach)
C***********************************************************************
      use voacapl_defs
      use cversn
      use crun_directory
C***********************************************************************
      character(len=3), parameter :: COMPILER='w32'       !  32-bit compiler

c jw     include <windows.ins>
C***********************************************************************
c Execute with:
c    VOACAPW.EXE [S] directory VOACAPX.DAT VOACAPX.OUT a  (P-P circuit)
c    VOACAPW.EXE [S] directory VOACAPG.DAT VOACAPG.OUT    (P-P graph)
c    VOACAPW.EXE [S] directory VOACAPD.DAT VOACAPD.OUT    (P-P distance)
c    VOACAPW.EXE [S] directory VOACAPT.DAT VOACAPT.OUT    (P-P time)
c    VOACAPW.EXE [S] directory BATCH                      (P-P batch)
c    VOACAPW.EXE [S] directory BATCH deckname.dat         (P-P NEW batch)
c    VOACAPW.EXE [S] directory BATCH deckname.dat nam.out (P-P NEW batch)
c    VOACAPW.EXE [S] directory AREA CALC VOAAREAW.CIR     (AREA batch)
c    VOACAPW.EXE [S] directory AREA method pathname       (AREA single)
c    VOACAPW.EXE [S] directory INV  CALC VOAAREAW.CIR     (AREA INVERSE batch)
c    VOACAPW.EXE [S] directory INV  method pathname       (AREA INVERSE single)
c    VOACAPW.EXE [S] directory CIRAF pathname             (CIRAF single)
c where:
c    [S]       = SILENT, then no messages are written to output window
c    directory = full pathname to the install directory (e.g. c:\ITSHFBC)
c    method    = (CALC/SCREEN/PRINT)
c    pathname  = pathname below directory\AREADATA\ of input data file
c                (e.g. DEFAULT\DEFAULT.VOA)
c    deckname  = where raw input deck is found.
c                cannot be named VOACAPX.DAT.
c    a         = append results to output file
c
C***********************************************************************
C************************************************************************
c          Execute with:
c                  voacapw filein fileout list
c                       where:
c                             filein  = input card image data file
c                                     = 'batch' is special batch processing
c                             fileout = output file to create
c                             list    = n = do not list input deck
c                                     =   = list input deck
c                                     = a = area coverage mode
c                                           fileout is directory name
c                                           filein 1st record contains name
C***********************************************************************
c  Modification by Greg Hand NTIA/ITS.S3  (303)-497-3375.
c  VOACAP modified for NTIA/ITS HP730 computer system beginning 7/28/92.
c  The D in column 1 are lines which will NOT be compiled for PCVOACAP.
c  PCVOACAP is compiled with MicroSoft FORTRAN. This should simplify
c  by not needing to maintain 2 different sources. Some other minor
c  differences need to be addressed ( e.g. getting filein,fileout).
C--------------------------------
c%lc:gsp 28-DEC-1994:1st change, program voacapw   *********************
c%lc    .Changes made affecting "MUF DAYS" calculation in REGMOD
c%lc    .Changes made in reliability calculation in RELBIL
c%lc
c%lc    comments regarding changes may be collected by stripping lines
c%lc    with this 'c%lc' prefix. Should be insensitive to case to be safe.
c%lc            George Scott Pinson
c%lc            Lucas Consulting
c%lc            2900 Valmont Rd, Suite H
c%lc            Boulder, Co 80301
c%lc:. end change                  ***************************************
C***********************************************************************
C
C  THIS is the July 1988 Version of the IONOSPHERIC COMMUNICATIONS ANALYSIS
C  AND PREDICTION Program (IONCAP) developed by Frank RHOADS, NRL Code 4184,
C  from the 85.04 version obtained from I.T.S. by, AND for, VOA.  It is an
C  INTEGRATED SYSTEM of SUBROUTINEs that is designed to analyse IONOSPHERIC
C  PARAMETERs AND PREDICT the PERFORMANCE of RADIO SYSTEMs that utilize
C  HIGH-FREQUENCY (HF) SKY-WAVE PROPAGATION.
C
C---------------------------------
C
C  D     INCLUDE 'NEWCAP.DOC/LIST'      ! 3 additional PAGEs of INFO
C
C WEIGHTS AND ABSCISSCAE FOR 40 POINT GUASSIAN SET BELOW:
      COMMON / DATR /  WT(20), XT(20), NT, NPL, XNPL, TWDIV
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16,
     1                 LU20, LU25, LU26, LU35
C NUMERICAL MAP COEFICENTS (SEE REDMAP):
      COMMON / ONE /   IA(6), IB(6), IKIM(10,6), ESLCOF(5,55),
     1                 ESMCOF(7,61), ESUCOF(5,55), F2COF(13,76),
     2                 FM3COF(9,49), ERCOF(9,22)
C MORE COEFICENTS AND TABLES (SEE REDMAP):
      COMMON / TWO /   F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     1                 FAM(14,12), SYS(9,16,6), PERR(9,4,6)
      COMMON /TWO_AB/ AB(318)
      common /Cround/ iround
      common /Careach/ areach
         character areach*1
c jw      character filein*64,fileout*64,areafile*30
      character(len=VOA_PATH_LEN+13) :: filein, fileout, areafile, file_batch
c      character file_batch*64
c jw      integer*2 istat
      integer istat
      common /cmodel/ model
      character model*8
      common /clisting/ listing,formfeed
      character listing*1,formfeed*1
      common /c_S_to_I/ i_S_to_I         !  =1= S/I calculations
      logical           :: iharris
      common /Charris/ iharris    !  =1=harris99.exe exists
      common /cdistance/ idistance,ndistance,ihr    !  plot vs distance
      common /ctime/ ntime                          !  plot vs time
      common /cCIRAF_TP/ nTP,idx_TP(911)
      character cmnam*64,title*80,ich*1,area_meth*1,dum*1
      character message*80, PROGRAM*300
      character(len=VOA_PATH_LEN+15) :: c_arg
      logical*1 doesit
      logical*1 fexists
C  PROGRAM VERSION NUMBER, PROGRAM CONTROL VARIABLES
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
c      common /CVERSN/ VERSN
c      character VERSN*8
      character(len=1) :: ABSORPTION_MODE=" "
c jw      real*8 start_time,end_time

c      common /crun_directory/ run_directory
c         character run_directory*50
      common /cQUIET/ iquiet
      character alf_narea_batch*4,alf_iarea_batch*4
      character alf_elapsed_time*8,alf_fileout*50
      common /Cprogress/ iarea_batch,alf_label
         character alf_label*80
      common /Ccancel_batch/ icancel_batch
      external cancel_batch
      character alf*80,append*1
c jw      integer (kind=3) count_underflow
c jw      logical (kind=2) permission

c *******************************************************************
c Integer added by JW to emulate the function of the cmnam() function
c using the get_command_argument() function
c *******************************************************************
      integer argCtr !jw added by JW to emulate the function of cmnam()
      integer fileNumCtr !jw File Number Counter used for nameing area files
      character(len=5)  :: ci
      character(len=256) :: cmd

C
C SET PREDEFINED CONSTANTS:
C
      DIMENSION IIA (6), IIB (6)
C
      DATA IIA / 1,276,703,978,1966,2407 /
      DATA IIB / 5, 7, 5, 13, 9, 9 /
C
      F2D(1,1,1) = -1.
      DO 100 I = 1, 6
      IA (I) = IIA (I)
 100  IB (I) = IIB (I)
C  DEFINE NT - POINT GAUSSIAN INTEGRATION
      NT = 20
C  USE LINEAR INTERVAL TRANSFORMATION TO (-1,1)
      NPL = 1
      XNPL = NPL
      TWDIV = 1. / (2. ** NPL)
c******************************************************
      i_S_to_I=0               !  =1= S/I calculations
      iarea_batch=0
      icancel_batch=0
      model='  VOACAP'
      nTP=0                    !  # of CIRAF test points to calculate
      ntime=0
      ihr=1
c******************************************************
c set the argument and file number counters to 1
c******************************************************
      argCtr = 1
      fileNumCtr = 1
      call get_command_argument(argCtr, c_arg) !jw
      argCtr = argCtr + 1
      nch=lenchar(c_arg)
C******************************************************************
C Process posix type commands that appear before then run directory
C******************************************************************
c If a run direcory is specified then we'll use this for all
c volatile data.
c******************************************************************
      run_directory = ""
      area_directory = ""
      area_inv_directory = ""
      do command=1, COMMAND_ARGUMENT_COUNT()
        if (c_arg(1:1).ne.'-') exit

        if((c_arg(1:9).eq.'--version').or.(c_arg(1:2).eq.'-v')) then
           write(*,'(''voacapl - release '',a)') VOACAPL_VERSION
           call exit(0)
        else if (c_arg(1:2).eq.'-h') then
           call print_help()
           call exit(0)
        else if((c_arg(1:2).eq.'--silent').or.(c_arg(1:2).eq.'-s')) then
           iquiet=1
        else if(c_arg(1:18).eq.'--absorption-mode=') then
           if (scan("WIAa", c_arg(19:19))>0) then
               ABSORPTION_MODE=c_arg(19:19)
           else
               write(*, '(AA)') "Invalid absorption mode: ", c_arg(19:19)
           end if
        else if (c_arg(1:10).eq.'--run-dir=') then
            run_directory = c_arg(11:len(trim(c_arg)))
            area_directory = c_arg(11:len(trim(c_arg)))
            area_inv_directory = c_arg(11:len(trim(c_arg)))
c        else if (c_arg(1:11).eq.'--area-dir=') then
c            area_directory = c_arg(12:len(trim(c_arg)))
        else
           write(*, '(AA)') "Option not recognised: ", c_arg
        end if

        call get_command_argument(argCtr, c_arg)
        argCtr = argCtr + 1

      end do

c******************************************************
c     check that the itshfbc directory exists, quit with
c     a message about creating one if not.
c******************************************************
c      nch=len(trim(c_arg))
      inquire(file=trim(c_arg)//'/.', exist=doesit)
      if (.not. doesit) goto 941

      root_directory=trim(c_arg)
      if (len(trim(run_directory)).eq.0) then
          run_directory=trim(root_directory)//PATH_SEPARATOR//'run'
          area_directory=trim(root_directory)//PATH_SEPARATOR//'areadata'
          area_inv_directory=trim(root_directory)//PATH_SEPARATOR//'area_inv'
      end if
      inquire(file=trim(run_directory)//'/.', exist=doesit)
      if (.not. doesit) goto 947
!     set_run is no longer required now that we're using absolute file paths
!     TODO Look at replaceing set_run with something that performs a few sanity checks.
!      call set_run            !  make sure we are in ..\RUN directory
      nch_run=lcount(run_directory,50)
ccc      open(72,file='voacap_dmp.txt')
ccc      rewind(72)
c******************************************************
      ierase=0    !  do not erase
      alf='ERASE debug window'
c jw      open(21,file=run_directory(1:nch_run-3)//'database\debug.txt',status='old',err=101)
      open(21,file=trim(root_directory)//PATH_SEPARATOR//'database'//PATH_SEPARATOR//'debug.txt',status='old',err=101)
      rewind(21)
      read(21,'(a)') alf
      close(21)
101   if(alf(1:18).eq.'ERASE debug window') ierase=1  !  do erase
ccc      ierase=0    !  do not erase
c******************************************************
      iround=0    !  do not round
ccc      open(21,file=run_directory(1:nch_run-3)//
ccc     +        'database\round.txt',status='old',err=102)
ccc      close(21)
ccc      iround=1  !  do round
ccc102   continue
c****************************************************************
      if(iquiet.eq.0) write(*,'('' Root Directory: '',a)') trim(root_directory)
      if(iquiet.eq.0) write(*,'('' Run Directory:  '',a)') trim(run_directory)

c****************************************************************
c jw      iharris=it_exist(run_directory(1:nch_run-3)//bin_win\anttyp99.exe')
      inquire(file=trim(root_directory)//PATH_SEPARATOR//'bin_win'//PATH_SEPARATOR//'anttyp99.exe', exist=iharris)
c****************************************************************
c jw      call del_abt     !  delete the voaarea.abt & voacap.abt files
      listing='Y'
      areach=' '
c jw      filein=cmnam()
      call get_command_argument(argCtr, filein)
      argCtr = argCtr + 1 !jw
ccc      write(*,'('' filein='',a)') filein
      if(filein(1:1).eq.' ') filein='voacapx.dat'
c jw      call lcase(filein,20)
      if(filein(1:5).eq.'area ' .or. filein(1:4).eq.'inv ') then ! area coverage
         areach='A'
         if(filein(1:1).eq.'i') areach='I'    !  inverse area coverage

c jw This test seems redundant as we check for the file just a few
c    lines below
c jw        inquire(file=trim(area_directory)//'/.', exist=doesit)
c jw        if (.not. doesit) goto 947

c jw         area_meth=cmnam()
c jw         if(area_meth.eq.' ') area_meth='c'
         call get_command_argument(argCtr, area_meth) ! jw
         argCtr = argCtr + 1 !jw
         if(LEN_TRIM(area_meth) == 0) area_meth='c' ! calc
c jw         filein=cmnam()
         call get_command_argument(argCtr, filein) ! jw
         argCtr = argCtr + 1 !jw
c        Check the area input file exists and is readable
         if (areach == "I") then
            if(iquiet.eq.0) write(*,'('' Area Inv Directory: '',a)') trim(area_inv_directory)
            inquire(file=trim(area_inv_directory)//PATH_SEPARATOR//filein, exist=doesit)
         else
            if(iquiet.eq.0) write(*,'('' Area Directory: '',a)') trim(area_directory)
            inquire(file=trim(area_directory)//PATH_SEPARATOR//filein, exist=doesit)
         end if
         if(.NOT.doesit) goto 944
c jw         call lcase(filein,20)
ccc         write(*,'('' filein='',a)') filein
         if(filein(1:12).eq.'voaareaw.cir') then    !  batch area coverage
c jw            call seconds_since_1980@(start_time)    !  use to calc time
            iarea_batch=iarea_batch+1
c jw            open(61,file=run_directory(1:nch_run)//'\'//filein, status='old',err=920)
            open(61,file=trim(run_directory)//PATH_SEPARATOR//filein, status='old',err=920)
            rewind(61)
            call count_batch(61,narea_batch)  !  count # files to process
            read(61,'(a)',end=999) filein
            if(iquiet.eq.0) write(*,39) iarea_batch,narea_batch,filein
39          format(' BATCH area file(',i4,' of ',i4,'):',a)
            write(alf_narea_batch,'(i4)') narea_batch
            write(alf_iarea_batch,'(i4)') iarea_batch
         end if
         fileout='voaareax'
ccc         write(*,'(''before areamap, filein='',a)') filein
         call areamap(areach,filein,fileout,area_meth)
         filein='voaareax.da1'

         fileout=trim(area_directory)//PATH_SEPARATOR
         if(areach.eq.'I') fileout=trim(area_inv_directory)//PATH_SEPARATOR
c.....End of area processing
      else if(filein(1:6).eq.'batch ') then     !  Batch point-to-point
         areach='B'
c jw         file_batch=cmnam()       !  is this "new" Special batch?
         call get_command_argument(argCtr, file_batch) !  is this "new" Special batch?
         argCtr = argCtr + 1 !jw
         if(file_batch(1:1).ne.' ') areach='S'    !  YES!!!
         filein='voacapx.dat'
c jw         fileout=cmnam()
         call get_command_argument(argCtr, fileout) !jw
         argCtr = argCtr + 1 !jw
         if(fileout(1:1).eq.' ') fileout='voacapb.out'
         nch_out=lcount(fileout,64)
c jw         call erase@(run_directory(1:nch_run)//'\'//fileout(1:nch_out),istat)   !  delete any previous file
         call unlink(trim(run_directory)//PATH_SEPARATOR//trim(fileout), istat)
ccc         write(*,'('' after erase, istat='',i5)') istat
c jw         if(istat.ne.0 .and. iquiet.eq.0) then
c jw            call dos_error_message@(istat,message)
c TODO insert an error message here.
ccc            write(*,'('' istat='',i5,1h=,a)') istat,message
ccc            write(*,'('' file='',a)') run_directory(1:nch_run)//
ccc     +                                '\'//fileout(1:nch_out)
c jw         end if
c.....end of batch processing
      else
c jw         fileout=cmnam()
         call get_command_argument(argCtr, fileout) !jw
         argCtr = argCtr + 1
         if(fileout(1:1).eq.' ') fileout='voacapx.out'
c jw         call lcase(fileout,20)
      end if
c jw      append=cmnam()       !  should we append to output file
      call get_command_argument(argCtr, append) !jw
      argCtr = argCtr + 1 !jw
      if(append.eq.'A') append='a'
      listing=areach
      if(listing.eq.'n') listing='N'
      if(listing.eq.'a') listing='A'
      if(filein (1:1).eq.' ' .or. fileout(1:1).eq.' ')
     +      stop 'Execute with: voacapw filein fileout'
      iabort=0
c jw      call del_abt      !  delete the voacap.abt & voaarea.abt files
c******************************************************
C
C.....REWIND INPUT LOGICAL UNITS BEFORE EXECUTION:
C
C                THIS IS THE USER-GENERATED INPUT FILE
40    continue
ccc      write(*,'(''after 40, area='',a)') areach
      if(areach.eq.'A' .or. areach.eq.'I') then  !  get real file name of output
         open(LU5,file=trim(run_directory)//PATH_SEPARATOR//filein,STATUS='OLD',iostat=ios,err=942)
         rewind(lu5)
         read(lu5,'(20x,a)') areafile
         close(lu5)
         nch=len(trim(fileout))
         nch2=len(trim(areafile))
         nch3=len(trim(filein))
         areafile(nch2-2:nch2)='vg'//filein(nch3:nch3)
         fileout(nch+1:nch+nch2)=areafile(1:nch2)
      else if(listing.eq.'B') then           !  Initialize batch processing
         call read_asc('VOACAP',*999)  !read pt-to-pt common from VOACAPW.ASC
         open(38,file=trim(run_directory)//PATH_SEPARATOR//'voacap.cir',
     +        status='old',err=999)
         rewind(38)
         read(38,'(a)',err=999) dum     !  skip 1st record
         if(iquiet.eq.0) then
             write(*,'('' Output is being written to: '',a,/)') trim(fileout)
         end if
         icircuit=0
         call batch(38,'VOACAP',filein,icircuit,*999)
      else if(listing.eq.'S') then           !  New SPECIAL batch
!         nch_batch=lcount(file_batch,64)
         open(38,file=trim(run_directory)//PATH_SEPARATOR//trim(file_batch),status='old',err=999)
         if(iquiet.eq.0)
     +   write(*,'('' Output is being written to: '',a,/)')
     +                 fileout(1:nch_out)
         icircuit=0
         call batch_S(38,'VOACAP',filein,icircuit,*999)
      end if
c***********************************************************
ccc50    inquire(file=filein,exist=doesit)   !  if file does not exist, quit
50    nch_in=lcount(filein,64)
c jw      doesit=fexists@(
c jw     +     run_directory(1:nch_run)//'\'//filein(1:nch_in),
c jw     +     error_code)   !  if file does not exist, quit
ccc      write(*,'(''opening file='',a)') filein
      inquire(file=trim(run_directory)//PATH_SEPARATOR//trim(filein),exist=doesit)
      if(.NOT.doesit) go to 950
      if(iquiet.eq.0) then
         if(filein(1:7).eq.'voacapw') write(*,51) 'WANTED  '
         if(filein(1:7).eq.'voacapu') write(*,51) 'UNWANTED'
51       format(' Calculating ',a,' signal')
      end if
      call antcalc(filein,listing)
c***********************************************************
      if(iquiet.eq.0) then
         if(listing.eq.'A') then
            write(*,'('' Area Input File: '',a)') trim(filein)
            write(*,'('' Area Output File: '',a)') trim(fileout)
            if(iarea_batch.ne.0) then
               alf_fileout=fileout
            end if
         else if(listing.eq.'I') then
            write(*,'('' Inverse Area Input File: '',a)') trim(filein)
            write(*,'('' Inverse Area Output File: '',a)') trim(fileout)
         end if
      end if
c***********************************************************
ccc      write(*,'(''listing, areach='',a,1h:,a)') listing,areach
ccc      write(*,'(''opening file='',a)') filein
      open(LU5,file=trim(run_directory)//PATH_SEPARATOR//filein,STATUS='OLD', iostat=ios,err=944)
      rewind(lu5)
      ndistance=1
      if(fileout(1:11).eq.'VOACAPD.OUT' .or.
     +   fileout(1:11).eq.'voacapd.out') ndistance=51  !  plot vs distance
      ntime=0
      if(fileout(1:11).eq.'VOACAPT.OUT' .or.
     +   fileout(1:11).eq.'voacapt.out') ntime=1       !  plot vs time
      if(areach.eq.'B' .or. areach.eq.'S') then        !  batch, use APPEND
         open(LU6,file=trim(run_directory)//PATH_SEPARATOR//fileout, access='APPEND')
         formfeed='\n\f'
! TODO I think we no longer need the first '..' as paths are now fully defined
! The following branch used to include (fileout(1:2).eq.'..').or.
      else if((listing.eq.'A').or.(listing.eq.'I'))then ! area inv_area
!         write(*, '(A)') " *On branch 1"
         open(LU6,file=fileout, iostat=ios, position='rewind', err=946)
         formfeed=' '
      else if(append.eq.'a') then
!         write(*, '(A)') " *On branch 2"
         open(LU6,file=trim(run_directory)//PATH_SEPARATOR//fileout, access='APPEND')
         formfeed='\n\f'
      else !p2p, distance
!         write(*, '(A)') " *On branch 3"
         if(iquiet.eq.0) write(*, '('' Opening output file: '',a)') trim(trim(run_directory)//PATH_SEPARATOR//fileout)
         open(LU6,file=trim(run_directory)//PATH_SEPARATOR//fileout, iostat=ios, position='rewind', err=948)
         formfeed=' '
      end if
ccc      write(*,'('' opening LU15/scratch'')')
cccc      open(LU15,status='scratch')
      open(LU15,file=trim(run_directory)//PATH_SEPARATOR//'lu15_voa.tmp', iostat=ios,err=960)
ccc      write(*,'('' opening LU35/scratch'')')
cccc      open(LU35,status='scratch')
      open(LU35,file=trim(run_directory)//PATH_SEPARATOR//'lu35_voa.tmp', iostat=ios,err=962)
      REWIND LU15
      REWIND LU35
c***********************************************************
      if(ndistance.gt.1) then ! Do the distance calcs.
         OPEN(48,file=trim(run_directory)//PATH_SEPARATOR//'voacapd.idx')
         rewind(48)
c jw         call erase@(run_directory(1:nch_run)//'\VOACAPD.DST',istat)
         call unlink(trim(run_directory)//PATH_SEPARATOR//'voacapd.dst',istat)
         OPEN(49,file=trim(run_directory)//PATH_SEPARATOR//'voacapd.dst',
     +        access='direct',form='unformatted',recl=108)
      end if
      if(ntime.ne.0) then
         OPEN(48,file=trim(run_directory)//PATH_SEPARATOR//'voacapt.idx')
         rewind(48)
c jw         call erase@(run_directory(1:nch_run)//'\VOACAPT.DST',istat)
         call unlink(trim(run_directory)//PATH_SEPARATOR//'voacapt.dst',istat)
         OPEN(49,file=trim(run_directory)//PATH_SEPARATOR//'voacapt.dst',
     +        access='direct',form='unformatted',recl=96)
      end if
c***********************************************************
c VERSN
c***********************************************************
      open(21,file=trim(root_directory)//PATH_SEPARATOR//'database'//PATH_SEPARATOR//'version.'//COMPILER,status='old',iostat=ios,err=964)
      rewind(21)
      read(21,'(8x,a)') VERSN
c.....Modify the VERSN string if we have a user defined mode.
      if (len(trim(ABSORPTION_MODE))>0) then
          VERSN(8:8) = ABSORPTION_MODE
      end if

      close(21)
ccc      write(*,'('' version='',a)') VERSN
c****************************************************************
      call set_magnetic_pole    !  get the location of the geomagnetic north pole
c****************************************************************
      iabort=1
      if(ndistance.gt.1 .or. ntime.ne.0) then
         CALL HFMUFS2(fileout,*950)           !  distance or time calculations
      else
         CALL HFMUFS(fileout,*950)            !  normal
      end if
      iabort=0          !  was not aborted
      if(i_S_to_I.ne.0) close(18)     !  close special S/I output file
      CLOSE(LU15)
      CLOSE(LU35)
      CLOSE(LU5)
      close(lu6)
c*********************************************************************
c          do we need to PLOT the results?
c*********************************************************************
c jw      if((listing.eq.'A' .or. listing.eq.'I') .and.
c jw     +    (area_meth.eq.'p'.or.area_meth.eq.'s'))then
c jw         if(iquiet.eq.0) write(*,'('' Plotting:'',a)') fileout
c jw         nchf=lcount(fileout,64)
c jw         PROGRAM=run_directory(1:nch_run-3)//
c jw     +             'bin_win\worldwin.exe '//
c jw     +       run_directory(1:nch_run)//' '//fileout(4:11)//' '//
c jw     +       fileout(13:nchf)//' '//
c jw     +              area_meth
c jw         nch=lcount(PROGRAM,300)
c jw         call gh_exec(PROGRAM,nch,1)   !  execute and wait for WORLDWIN.EXE
c jw      end if

c**************************************************************
c The following section has been modified from the original to
c permit longer file extensions to be used (e.g. 'da12')
c**************************************************************
      if(listing.eq.'A' .or. listing.eq.'I') then   !area coverage, are there more files to process
         ich=filein(nch3:nch3)
         fileNumCtr = fileNumCtr+1
         if (fileNumCtr.eq.(MAX_AREA_MONTHS+1)) then
            go to 950
         else                    !  process next file in order
            if (fileNumCtr <= 9) then
                write (filein,'(A11I1)') "voaareax.da", fileNumCtr
                write (fileout, '(AI1)') fileout(1:index(fileout, '.vg')+2),fileNumCtr
            else
                write (filein,'(A11I2)') "voaareax.da", fileNumCtr
                write (fileout, '(AI2)') fileout(1:index(fileout, '.vg')+2),fileNumCtr
            endif
            filein = trim(filein)
            fileout = trim(fileout)
            go to 50                 !  calculate another area file
         end if
      else if(listing.eq.'B') then   !Batch point-to-point, next circuit
         call batch(38,'VOACAP',filein,icircuit,*999)
         go to 50                !  process next batch circuit
      else if(listing.eq.'S') then   !New Batch point-to-point, next circuit
         call batch_S(38,'VOACAP',filein,icircuit,*999)
         go to 50                !  process next batch circuit
      else
      end if
c***********************************************************************
      if(filein(1:12).eq.'voacapwx.dat' .or.
     +   filein(1:12).eq.'voacapwg.dat') then   !  need to process UNWANTED
         filein(7:7)='u'
         fileout(7:7)='u'
         go to 50
      end if
c***********************************************************************
      go to 950
c***********************************************************************
c*****voaarea.cir batch area coverage file not found
920   write(*,'('' Error: Could not open file voaarea.cir for BATCH AREA: '',a)') trim(run_directory)//PATH_SEPARATOR//filein
      write(*,'('' Refer to the man page ("man voacapl") for help.'')')
      write(*, '('' VOACAPW:920'')')
      call exit(1) ! Exit if we can't find the right file.

c*****This error is no longer called
940   write(*,'('' Error: voacapl not executed properly.'')')
      write(*,'('' Refer to the man page ("man voacapl") for help.'')')941
      call exit(1)

c*****itshfbc directory not found
941   write(*,'('' Error: Unable to open itshfbc directory at: '',a)') trim(root_directory)
      write(*,'('' Run the command "makeitshbc" to create a copy of the'')')
      write(*,'('' itshfbc directory in your home directory.'')')
      write(*, '('' VOACAPW:941'')')
      call exit(1) ! Exit if we can't find the right file.

c*****P2P prediction input file not found
942   write(*,'('' Error: The specified input file was not found: '',a)') trim(run_directory)//PATH_SEPARATOR//filein
      write(*,'('' Refer to the man page ("man voacapl") for help.'')')
      write(*, '('' VOACAPW:942'')')
c      call exit(1) ! Exit if we can't find the right file.
      goto 950

c*****Area prediction input file not found
943   write(*,'('' Error: The specified input file was not found: '',a)') trim(run_directory)//PATH_SEPARATOR//filein
      write(*,'('' Refer to the man page ("man voacapl") for help.'')')
      write(*, '('' VOACAPW:943'')')
      call exit(1) ! Exit if we can't find the right file.

c*****Missing or unreadable area data input file
944   write(*,'('' Error: The specified input file was not found: '',a)') filein
      write(*,'('' Refer to the man page ("man voacapl") for help.'')')
      write(*, '('' VOACAPW:'')')
      call exit(1) ! Exit if we can't find the right file.

c*****Missing or unreadable area data input file
945   write(*,'('' Error: The specified input file was not found: '',a)') trim(run_directory)//PATH_SEPARATOR//filein
      write(*,'('' Refer to the man page ("man voacapl") for help.'')')
      write(*, '('' VOACAPW:945'')')
      call exit(1) ! Exit if we can't find the right file.

c*****Error opening output file
946   write(*,'('' Error opening output file : '',a)') fileout
      write(*,'('' Refer to the man page ("man voacapl") for help.'')')
      write(*, '('' VOACAPW:946'')')
      write(ci,'(I3)') ios
      ci = adjustl(ci)
      write(*,'('' Error code ('',a,'')'')') trim(ci)
      call exit(1) ! Exit if we can't find the right file.

c*****itshfbc directory not found
947   write(*,'('' Error: Unable to open run directory at: '',a)') trim(run_directory)
      write(*, '('' VOACAPW:947'')')
      call exit(1) ! Exit if we can't find the run directory.


c*****Error opening output file
948   write(*,'('' Error opening output file : '',a)') fileout
      write(*,'('' Refer to the man page ("man voacapl") for help.'')')
      write(*, '('' VOACAPW:948'')')
      write(ci,'(I3)') ios
      ci = adjustl(ci)
      write(*,'('' Error code ('',a,'')'')') trim(ci)
      call exit(1) ! Exit if we can't find the right file.

c****Error opening the scratch file
960   write(*,'('' Error opening temporary scratch file : '',a)') trim(run_directory)//PATH_SEPARATOR//'lu15_voa.tmp'
      write(*,'('' Refer to the man page ("man voacapl") for help.'')')
      write(*, '('' VOACAPW:960'')')
      write(ci,'(I3)') ios
      ci = adjustl(ci)
      write(*,'('' Error code ('',a,'')'')') trim(ci)
      call exit(1) ! Exit if we can't find the right file.

c****Error opening the scratch file
962   write(*,'('' Error opening file : '',a)') trim(run_directory)//PATH_SEPARATOR//'lu35_voa.tmp'
      write(*,'('' Refer to the man page ("man voacapl") for help.'')')
      write(*, '('' VOACAPW:962'')')
      write(ci,'(I3)') ios
      ci = adjustl(ci)
      write(*,'('' Error code ('',a,'')'')') trim(ci)
      call exit(1) ! Exit if we can't find the right file.

c****Error opening the vesion file
964   write(*,'('' Error opening file : '',a)') trim(root_directory)//PATH_SEPARATOR//'database'//PATH_SEPARATOR//'version.'//COMPILER
      write(*,'('' Refer to the man page ("man voacapl") for help.'')')
      write(*, '('' VOACAPW:964'')')
      write(ci,'(I3)') ios
      ci = adjustl(ci)
      write(*,'('' Error code ('',a,'')'')') trim(ci)
      call exit(1) ! Exit if we can't find the right file.

c******************************************************************
950   CLOSE(LU15)
      CLOSE(LU35)
      if(icancel_batch.ne.0) go to 999
      if(iabort.ne.0) go to 999
      if(iarea_batch.eq.0) go to 999      !  not area coverage batch run
         read(61,'(a)',end=999) filein
         iarea_batch=iarea_batch+1
         if(iquiet.eq.0) write(*,39) iarea_batch,narea_batch,filein
         write(alf_iarea_batch,'(i4)') iarea_batch
         write(alf_iarea_batch,'(i4)') iarea_batch
         fileout='voaareax'
ccc         write(*,'(''BEFORE areamap, filein='',a)') filein
ccc         write(*,'(''areach='',a)') areach
         call areamap(areach,filein,fileout,area_meth)
ccc         areach=area
         filein='voaareax.da1'
         fileout=trim(area_directory)//PATH_SEPARATOR
         if(areach.eq.'I') fileout=trim(area_inv_directory)//PATH_SEPARATOR
         go to 40      !  begin next area calculation
999   continue
      if(iarea_batch.ne.0) then      !  batch area finish
         idone=iarea_batch           !  number of files done
         if(iabort.ne.0 .or. icancel_batch.ne.0) then
            if(iquiet.eq.0) write(*,'(1x)')
            idone=idone-1            !  current one was not done
         end if
         iprocess_ctrl=0
! jw         call window_update@(iprocess_ctrl)    !  remove process message
! jw         call seconds_since_1980@(end_time)    !  use to calc time
! jw         elapsed=end_time-start_time
! jw         if(iquiet.eq.0) write(*,997) idone,elapsed/60.
997      format(50(1h*),/,
     +          i5,' BATCH Area calculations done.',f10.1,' minutes',/,
     +          50(1h*))
      end if
      if(listing.ne.'B' .and. iarea_batch.eq.0)then!don't destroy BATCH output
c jw         if(ierase.ne.0) call destroy_window(window_handle)
      else
         if(iabort.ne.0) write(*,998)
998                      format(/,' Batch processing has been aborted.')
      end if
c******************************************************************
c         close and delete temporary files
      close(LU15)
      close(LU35)
c jw      call erase@(run_directory(1:nch_run)//'\'//'LU15_VOA.TMP',istat)
      call unlink(trim(run_directory)//PATH_SEPARATOR//'lu15_voa.tmp', istat) ! jw
c jw      call erase@(run_directory(1:nch_run)//'\'//'LU35_VOA.TMP',istat)
      call unlink(trim(run_directory)//PATH_SEPARATOR//'lu35_voa.tmp', istat) ! jw
c jw      call underflow_count@(count_underflow)  !  see if any underflows occured
ccc      write(*,'(''underflow='',i8)') count_underflow
      END
c
c--------------------------------------------------------------
c###set_magnetic_pole.for
      SUBROUTINE set_magnetic_pole
c         This sets the location of the geomagnetic north pole
c         The default is (78.5N, 69.0W) = (78.5, -69.0)
      use voacapl_defs
      use crun_directory
      common /Cnorth_pole/ g_magnetic_lat,g_magnetic_lon  !  magnetic north pole
c      common /crun_directory/ run_directory
c         character run_directory*50
      data lu/21/

      nch_run=lcount(run_directory,50)
c***********************************************************
c          read the user values from ..\run\north_pole.txt
      open(lu,file=trim(run_directory)//PATH_SEPARATOR//'north_pole.txt',status='old',err=200)
      rewind(lu)
      read(lu,*,err=150) glat,glon
      close(lu)
      if(glat.lt.60. .or. glat.gt.90.) go to 200       !  bad values of latitude
      if(glon.lt.-180. .or. glon.gt.180.) go to 200    !  bad values of longitude
      go to 500     !  use these values
c***********************************************************
150   close(lu)
c          if user values do not exist,
c          read the default values from ..\database\north_pole.txt
200   open(lu,file=trim(root_directory)//'database'//PATH_SEPARATOR//'north_pole.txt',status='old',err=300)
      rewind(lu)
      read(lu,*,err=250) glat,glon
      close(lu)
      if(glat.lt.60. .or. glat.gt.90.) go to 300       !  bad values of latitude
      if(glon.lt.-180. .or. glon.gt.180.) go to 300    !  bad values of longitude
      go to 500     !  use these values
c***********************************************************
250   close(lu)
300   glat=78.5           !  set default values if data files do not exist
      glon=-69.0
500   g_magnetic_lat=glat
      g_magnetic_lon=glon
ccc      open(lu,file=run_directory(1:nch_run)//'\pole.txt')
ccc      write(lu,1) g_magnetic_lat,g_magnetic_lon
ccc1     format('Magnetic North =',2f10.3)
ccc      close(lu)
      return
      end
c----------------------------------------------------------------------

c----------------------------------------------------------------------

      subroutine print_help()
      print *, ' Usage:'
      print *, ' voacapl [-s] voacap_directory [inputfile]'
      print *, ' voacapl [-s] voacap_directory [inputfile outputfile]'
      print *, ' voacapl [-s] voacap_directory area calc [areafile]'
      print *, ' voacapl [-s] voacap_directory batch'
      print *, ' voacapl -v (prints the version number)'
      print *, ' voacapl -h (prints this help message)'
      end

c###ionplt.for
      SUBROUTINE IONPLT(K)
C--------------------------------
C
C     THIS ROUTINE OUTPUTS IONOGRAMS
C
C     K IS SAMPLE AREA INDEX
C
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON / MFAC /F2M3(5),HPF2(5),ZENANG(5),ZENMAX(5),IEDP,FSECV(3)
      COMMON/GEOG/GYZ(5),RAT(5),GMDIP(5),CLCK(5),ABIY(5),ARTIC(5),SIGPAT
     A (5),EPSPAT(5)
      COMMON /ES /FS (3, 5), HS (5)
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      DIMENSION JFSCAL(10)
      CHARACTER ILY(4)*3, IMINUS*1, IPLUS*1, IBLANK*3, IDOT*3,
     A IXXX*3, IBB(6)*3, IS(3)*3, INTG(2)*10, IFONE(3)*10,
     B IX(100)*3, IC*1, IB*3,ITF*1
      DATA ILY/' E=','F1=','F2=','ES='/
      DATA IMINUS/'-'/, IPLUS/'+'/, IBLANK/'   '/, IDOT/'.  '/,
     A     IXXX/'X  '/
      DATA IBB/'600', '500', '400', '300', '200', '100'/
      DATA IS /'U', 'M', 'L'/
      DATA INTG/'GAUSSIAN  ','MODEL SEG '/
      DATA IFONE/'GONE      ','PARABOLIC','LINEAR   '/
      ITF=CHAR(12)
      IF(METHOD - 2) 100, 105, 100
  100 JOUT = 61
      WRITE(JOUT,'(A1)')ITF
      GO TO 107
  105 JOUT = LUO
C.....CALL SUBROUTINE OUTTOP TO OUTPUT HEADER LINES
      CALL OUTTOP
  107 IF(FI(3,K) - 10.) 110, 110, 130
  110 FINC = .1
      DO 115 IJ = 1, 10
  115 JFSCAL (IJ) = IJ
      GO TO 140
  130 FINC = .2
      DO 135 IJ = 1, 10
  135 JFSCAL (IJ) = IJ + IJ
  140 CONTINUE
      CLA = CLAT (K) * R2D
      CLON = CLONG (K) * R2D
      IDX = 2 * K - 1
      IF(KFX - 3) 141, 142, 142
  141 IDY = KFX
      GO TO 143
  142 IDY = K + 1
  143 RDX = RD(IDX) * RZ
      RDY = RD(IDY) * RZ
      CKC=CLCK(K)
      INDEX = 1
      IF( FI(2,K) ) 305,305,310
  305 INE = 1
      IF(IEDP) 325, 306, 306
  306 INDEX = 2
      GO TO 325
  310 IF(FSECV(K)) 315, 315, 320
  315 INE = 2
      GO TO 325
  320 INE = 3
  325 CONTINUE
      WRITE(JOUT,524) GMT,CKC,CLA,CLON,RDX,RDY,INTG(INDEX),IFONE(INE)
      WRITE(JOUT,522)
      WRITE(JOUT,501) JFSCAL
      WRITE(JOUT, 502)
      IBI = 1
      ZOB2 = 605.
      IHLS = (ZOB2 - HS(K)) * .1 + 1.0
      IPX = 1
      DO 255 IDN = 1, 51
      DO 145 ICR = 1, 100
  145 IX (ICR) = IBLANK
      ZOB1 = ZOB2
      ZOB2 = ZOB1 - 10.
      IF (IDN - IPX)150, 155, 155
  150 IC = IMINUS
      IB = IBLANK
      GO TO 160
  155 IC = IPLUS
      IB = IBB (IBI)
      IBI = IBI + 1
      IPX = IPX + 10
  160 CONTINUE
C
C     TEST FOR ES LEVEL
C
      IF(IDN - IHLS) 180, 165, 180
  165 ISX = 0
      DO 175 IZ = 1, 3
      ISB = ISX + 1
      ISX = FS (IZ, K) / FINC + 0.5
      ISX = MIN0 (100, ISX)
      IF (ISX .LT. ISB) GO TO 265
      DO 170 JJ = ISB, ISX
  170 IX (JJ) = IS (IZ)
  265 CONTINUE
  175 CONTINUE
      GO TO 225
  180 CONTINUE
      DO 215 IH = 1, 30
      ICR = FVERT(IH,K) / FINC + 1.0
      ICR=MIN0 (100,ICR)
      ICR=MAX0(1,ICR)
      IF (HPRIM (IH, K) - ZOB1)185, 185, 195
  185 IF (HPRIM (IH, K) - ZOB2)195, 195, 190
  190 IX(ICR) = IXXX
  195 IF (HTRUE (IH, K) - ZOB1)200, 200, 215
  200 IF (HTRUE (IH, K) - ZOB2)215, 215, 205
  205 IX(ICR) = IDOT
  215 CONTINUE
  225 CONTINUE
      IF (IDN - 3)235, 235, 245
  235 WRITE(JOUT, 506) IB, IC, ILY(IDN), FI(IDN,K), YI(IDN,K),
     1 HI(IDN,K), (IX(IPRT),IPRT=23,100), IC, IDN, FVERT(IDN,K),
     2 HTRUE(IDN,K), HPRIM(IDN,K)
      GO TO 255
  245 IF(IDN - 4) 247, 246, 247
  246 WRITE(JOUT,528) IB,IC,ILY(IDN),FS(1,K),FS(2,K),FS(3,K),HS(K),
     A (IX(IPRT),IPRT=29,100),IC,IDN,FVERT(IDN,K),HTRUE(IDN,K),
     B HPRIM(IDN,K)
      GO TO 255
  247 IF(IDN - 30) 250, 250, 252
  250 WRITE(JOUT, 505) IB, IC, IX, IC, IDN, FVERT(IDN,K), HTRUE(IDN,K),
     1 HPRIM(IDN,K)
      GO TO 255
  252 WRITE(JOUT, 504) IB, IC, IX, IC
  255 CONTINUE
      WRITE(JOUT, 502)
      WRITE(JOUT, 500) JFSCAL
      RETURN
  500 FORMAT(' ',13X,10(I2,8X))
  501 FORMAT(' ',13X,9(I2,8X),I2,6X,'FVERT',2X,'HTRUE',2X,'HPRIM')
  502 FORMAT(' ',4X,20('+----'))
  504 FORMAT(' ',1X,A3,A1,100A1,A1)
  505 FORMAT(' ',1X,A3,A1,100A1,A1,I3,3F7.2)
  506 FORMAT(' ',1X,A3,A1,1X,A3,F5.2,2(1X,F5.1),1X,78A1,A1,I3,3F7.2)
  522 FORMAT(' ',20X,'VIRTUAL HEIGHT - REFLECTION HEIGHT VS. SOUNDING',
     A ' FREQUENCY -MHZ-')
  524 FORMAT(' ',2X,'GMT = ',F5.1,3X,'LMT = ',F5.1,3X,'LAT = ',F6.2,
     A ' N',2X,F7.2,' W  DIST = ',2(F5.0,1X),' KM',2X,A10,
     B ' HP   F1 IS ',A10,/)
  528 FORMAT(' ',1X,A3,A1,1X,A3,3(F5.2,1X),F5.1,1X,72A1,
     A A1,I3,3F7.2)
      END
C--------------------------------

      subroutine pwrcut(snr50,snr_lw,snr_up,SNR88,SNR91,power_cut)
c          calculte Percent Power Cut possible based on George Lane Algorithm
c          An estimate of the number of days on which a power reduction can be
c          used during a given hour and month can be made by computing the
c          area under the assumed normal distribution of Signal-to-Noise
c          ratios over the days of the month.
c
c          SNR50 = SNR from IONCAP, the median S/N ratio
c          SNR_LW = lower decile deviation of SNR
c          SNR_UP = upper decile deviation of SNR
c          SNR88  = 3 dB (half power) SNR limit (nominally 88 dB)
c          SNR91  = 6 dB (quarter power) SNR limit (nominally 91 dB)
c          power_cut = [0 to .75], the calculated fraction power cut available
      dimension snr(11),fact(4)
      data fact/1.28,.84,.525,.255/
      std_lw=snr_lw/1.28              !  convert to standard deviation
      snr(11)=snr50 - fact(1)*std_lw*2.
      snr(10)=snr50 - fact(1)*std_lw
      snr(9)=snr50 - fact(2)*std_lw
      snr(8)=snr50 - fact(3)*std_lw
      snr(7)=snr50 - fact(4)*std_lw
      snr(6)=snr50
      std_up=snr_up/1.28              !  convert to standard deviation
      snr(5)=snr50 + fact(4)*std_up
      snr(4)=snr50 + fact(3)*std_up
      snr(3)=snr50 + fact(2)*std_up
      snr(2)=snr50 + fact(1)*std_up
      snr(1)=snr50 + fact(1)*std_up*2.
ccc      write(72,'('' snr='',11f8.3)') snr
      day3dB=dayinterp(snr,snr88)     !  fract days that exceed SNR88
      day6dB=dayinterp(snr,snr91)     !  fract days that exceed SNR91
      power_cut=1. - (1.-day3dB) - (day3dB-day6dB)/2. - day6dB/4.
ccc      write(72,1) power_cut,day3dB,day6dB
ccc1     format(' power_cut=',f8.3,5x,'day3dB=',f8.3,5x,'day6dB=',f8.3)
      return
      end
c---------------------------------------------------------------
      function dayinterp(snr,snrx)     !  fract days that exceed SNR88
      dimension snr(11)
      dayinterp=0.
      if(snrx.gt.snr(1)) return
      do 10 i=1,10
      if(snrx.le.snr(i) .and. snrx.ge.snr(i+1)) then
	 dayinterp=(float(i-1) + (snr(i)-snrx)/(snr(i)-snr(i+1)))/10.
         return
      end if
10    continue
      dayinterp=1.
      return
      end
c---------------------------------------------------------------

c# redmap.f
      SUBROUTINE REDMAP(SSN,MONTH)
C--------------------------------
C
C     THIS ROUTINE READS THE IONOSPHERIC LONG TERM DATA BASE FILE
c*****************************************************************
c     An error in the coefficient data file was corrected on 3.Nov.94
c     The values for SYS(9,2,6) & SYS(9,10,6) for SPRING & FALL were wrong.
c     They were 115.2 and should have been 11.52.
c     This required no programming change, but the comment was placed here
c     to record the error for posterity.  The change was corrected in the
c     ASCII data file and then it was converted to binary.
c*****************************************************************
C
      use voacapl_defs
      use crun_directory
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      common /ccoeff/ coeff
      character coeff*4
C.....F1 LAYER MONTHLY COEFFICIENTS
      COMMON /FONE/ ANEW(3),BNEW(3),ACHI(2),BCHI(2)
C.....COEFFICIENTS FOR CRITICAL FREQUENCIES AND F2 LAYER HEIGHT OF
C.....MAXIMUM / SEMITHICKNESS RATIO
      COMMON /ONE/ IA(6),IB(6),IKIM(10,6),ESLCOF(5,55),ESMCOF(7,61),
     +             ESUCOF(5,55),F2COF(13,76),FM3COF(9,49),ERCOF(9,22)
ccc   COMMON / RAYS / ANG(40), IFOB(40,30,5), NANG
C  PROGRAM VERSION NUMBER, PROGRAM CONTROL VARIABLES
C.....NOISE COEFFICIENTS AND DISTRIBUTION TABLES
      COMMON /TWO/ F2D(16,6,6),
     +             FAKP(29,16,6),FAKMAP(29,16),HMYM(29,16),
     +             FAKABP(2,6),ABMAP(2,3),
     +             DUD(5,12,5),FAM(14,12),SYS(9,16,6),PERR(9,4,6)
C.....VARIABLES FROM THE DATA BASE FILE BEFORE SUNSPOT INTERPOLATION
      DIMENSION XESLCF(5,55,2), XESMCF(7,61,2), XESUCF(5,55,2),
     A XFM3CF(9,49,2),XERCOF(9,22,2),XF2COF(13,76,2),XPMAP(29,16,2)
ccc   DIMENSION STOCOF(3600),
ccc  A START(1000), END(2000)
C.....EQUIVALENCE ALL DATA FILE VARIABLES TO IFOB(40,30,5)
ccc   EQUIVALENCE(STOCOF(1), IFOB(1,1,1))
ccc   EQUIVALENCE(START(1), STOCOF(1))
ccc   EQUIVALENCE(END(1), STOCOF(1001))
ccc   EQUIVALENCE(XESMCF(1,1,1), START(1))
ccc   EQUIVALENCE(XESLCF(1,1,1), START(1))
ccc   EQUIVALENCE(XESUCF(1,1,1), END(1))
ccc   EQUIVALENCE(XFM3CF(1,1,1), START(1))
ccc   EQUIVALENCE(XERCOF(1,1,1), END(1))
ccc   EQUIVALENCE(XF2COF(1,1,1), END(1))
C--------------------------------
      CHARACTER foF2_name*12,coeff_name*12
c*****************************************************************
c      nch_run=lcount(run_directory,50)
      if(coeff.ne.'URSI') coeff='CCIR'    !  default is CCIR
c          read the foF2 coefficients (CCIR or URSI88)
      write(foF2_name,'(4hfof2,a4,4h.daw)') coeff
      OPEN(27,FILE=trim(root_directory)//PATH_SEPARATOR//'coeffs'//PATH_SEPARATOR//foF2_name,
     +       status='old',form='unformatted',access='direct',recl=7904)
      read(27,rec=month) XF2COF
      close(27)
c*****************************************************************
c          read the rest of the coefficients
      write(coeff_name,'(5hcoeff,i2.2,5hw.bin)') MONTH
      OPEN(27,FILE=trim(root_directory)//PATH_SEPARATOR//'coeffs'//PATH_SEPARATOR//coeff_name,
     +       status='old',form='unformatted')
      rewind(27)
      READ(27,END=300,ERR=400) IKIM
      READ(27,END=300,ERR=400) FAKP,FAKABP
      READ(27,END=300,ERR=400) DUD,FAM,SYS
      READ(27,END=300,ERR=400) XFM3CF

      READ(27,END=300,ERR=400) F2D,PERR
      READ(27,END=300,ERR=400) ANEW,BNEW,ACHI,BCHI,FAKMAP,ABMAP
      READ(27,END=300,ERR=400) XESMCF,XPMAP
      READ(27,END=300,ERR=400) XESLCF,XESUCF
      READ(27,END=300,ERR=400) XERCOF
c*****************************************************************
      SSN100=100.-SSN
      DO 200 I=1,13
      DO 200 J=1,76
200   F2COF(I,J)=(XF2COF(I,J,1)*SSN100 + XF2COF(I,J,2)*SSN)/100.
      SSN150=150.-SSN
      SSN10=SSN-10.
      DO 210 I = 1,7
      DO 210 J = 1,61
210   ESMCOF(I,J)=(XESMCF(I,J,1)*SSN150 + XESMCF(I,J,2)*SSN10)/140.
      SSN125=125.-SSN
      SSN25=SSN-25.
      DO 220 I=1,29
      DO 220 J=1,16
220   HMYM(I,J)=(XPMAP(I,J,1)*SSN125 + XPMAP(I,J,2)*SSN25)/100.
      DO 230 I = 1,5
      DO 230 J = 1,55
      ESLCOF(I,J)=(XESLCF(I,J,1)*SSN150 + XESLCF(I,J,2)*SSN10)/140.
230   ESUCOF(I,J)=(XESUCF(I,J,1)*SSN150 + XESUCF(I,J,2)*SSN10)/140.
      DO 240 I = 1,9
      DO 240 J = 1,49
240   FM3COF(I,J)=(XFM3CF(I,J,1)*SSN100 + XFM3CF(I,J,2)*SSN)/100.
      DO 250 I = 1,9
      DO 250 J = 1,22
250   ERCOF(I,J)=(XERCOF(I,J,1)*SSN150 + XERCOF(I,J,2)*SSN10)/140.
      GO TO 500
c*****************************************************************
300   PAUSE 'END OF FILE ON DATA BASE in REDMAP'
      GO TO 500
400   PAUSE 'ERROR ON DATA BASE READ in REDMAP'
500   CLOSE(27)
      RETURN
      END
C--------------------------------

c###flolin.for
      SUBROUTINE FLOLIN(jfmt,idecimal,VAR,LIN)
C--------------------------------
C.....THIS SUBROUTINE WRITES A VECTOR FORMATTED LINE
C     FOR A FLOATING POINT VARIABLE
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON / OUTFMT / KLINE(26)
      DIMENSION VAR(13)
      character jfmt*(*),decimal(3)*8
      CHARACTER KLINE*6
      CHARACTER NDASH*4
      data decimal/'f5.0    ','f5.1    ','f5.2    '/
      DATA IMUF/12/, NDASH/'  - '/
      IF(LIN.le.0 .or. LIN.gt.30) return
      jfmt(8:15)=decimal(idecimal+1)
      WRITE(LUO,jfmt,IOSTAT=IERRSTAT) VAR(IMUF),(VAR(I),I=1,JFREQ)
     A    ,(NDASH,J=1,JDASH),KLINE(LIN)
      RETURN
      END
C--------------------------------

C FUNCTION AGAUSS             (NEXT)
      FUNCTION AGAUSS (XFUNCT, H2)
C 
C     AGAUSS - GAUSSIAN INTEGRATION IN WHICH 48 ABSCISSAS AND WEIGHT
C        FACTORS ARE USED.  XFUNCT IS THE FUNCTION TO BE INTEGRATED AND 
C        H2 IS THE ELEMENT LENGTH WHICH DETERMINES THE INTEGRATION
C        LIMITS.
C     SEE ABRAMOWITZ AND STEGUN, HANDBOOK OF MATHEMATICAL FUNCTIONS,
C     P 887 (EQU 25.4.30), P917 (WEIGHT AND ABSCISSA VALUES). 
C     THE WEIGHTS AND ABSCISSAS ARE IN COMMON /WEIGHT/ AND ARE SET
C     IN SUBROUTINE GAIN IN A DATA STATEMENT. 
C 
      COMMON /WAITS /HH (48), XI (48) 
C 
      EXTERNAL XFUNCT 
C 
C 
C.....INITIALIZE, INTEGRATE, AND TEST...................................
      DATA TESTD / 5.0E-08/ 
      M = 1 
      ANS = 0.0 
      CHECK = 1000.0
      IF (H2 .EQ. 0.0) GO TO 125
 100  AGAUSS = 0.0
      IF (M .LT. 1) GO TO 130 
      DO 110 L = 1, M 
      FL = L
      FM = M
      BOLIM = - H2 + 2.0 * H2 * (FL - 1.0) / FM 
      UPLIM = - H2 + 2.0 * H2 * FL / FM 
      SUM = 0.0 
      DO 105 I = 1, 48
      S = 0.5 * ((UPLIM - BOLIM) * XI (I) + UPLIM + BOLIM)
 105  SUM = SUM + HH (I) * XFUNCT (S) 
      SUM = 0.5 * (UPLIM - BOLIM) * SUM 
 110  AGAUSS = AGAUSS + SUM 
 130  CONTINUE
      TEST = ABS ((AGAUSS - ANS) / AGAUSS)
      IF (TEST .GT. 0.0005) GO TO 115 
      IF (TEST .LE. TESTD) GO TO 125
 115  IF (M .GE. 10) GO TO 120
      CHECK = TEST - TESTD
      M = M + 1 
      ANS = AGAUSS
      GO TO 100 
 120  IF (CHECK .GE. TEST) GO TO 125
      AGAUSS = ANS
 125  RETURN
      END 

      subroutine gh_exec(PROGRAM,nch,iwait)
c          PROGRAM = command line to execute (with parameters)
c          nch     = # characters in PROGRAM
c          iwait   = 0 = execute without wait
c                  = 1 = execute with wait until done
c*******************************************************************
      INCLUDE <WINDOWS.INS>
c********************************************************
      STDCALL MYCREATEPROCESS 'CreateProcessA' (VAL,STRING,VAL,VAL,
     +    VAL,VAL,VAL,VAL,REF,REF):LOGICAL*4

c          *** startup info structure ***
      character startup*68
      integer*4 cb,wShowWindow
      equivalence (cb,startup(1:4)),(wShowWindow,startup(49:50))

c          *** process info structure ***
      character process*16
      integer*4 hProcess
      equivalence (hProcess,process(1:4))
c********************************************************
      character PROGRAM*(*)
      integer*4 exit_code
c          *** initialize startup info structure ***
      call char_fill@(startup,char(0))
      cb=68
      wShowWindow=SW_SHOW
c**************************************************************
      if(.not.MyCreateProcess(0,PROGRAM(1:nch),0,0,0,0,0,0,
     +      startup,process)) then
         write(*,1) PROGRAM(1:nch)
1        format(' MyCreateProcess error in gh_exec during:',/,a)
         pause
      else                !  wait for WORLDWIN.EXE to finish
         if(iwait.eq.0) go to 999      !  do not wait
         exit_code=STILL_ACTIVE
         do while(exit_code.eq.STILL_ACTIVE) ! wait until [model]W.EXE finished
            call yieldit
            call GetExitCodeProcess(hProcess,exit_code)
         enddo
      end if
c**************************************************************
999   return
      END
c-----------------------------------------------------------------

      subroutine file_nam(subdir,filenam,filesufx,filename)
c          concatenate to create the antenna type filename
      use voacapl_defs
      character filename*(*),subdir*(*),filenam*8,filesufx*3,t_subdir*12
c**********************************************************************
      t_subdir=subdir
      nch1=lcount(t_subdir ,12)
      nch2=lcount(filenam,8)
      nch3=lcount(filesufx,3)
      if(nch1.eq.0) nch1=1
      if(nch2.eq.0) nch2=1
      if(nch3.eq.0) nch3=1
      filename='..'//PATH_SEPARATOR//'antennas'//PATH_SEPARATOR//
     +         t_subdir(1:nch1)//PATH_SEPARATOR//filenam(1:nch2)//
     +         '.'//filesufx(1:nch3)
      return
      end

      subroutine antcalc
     +               (filename,method)
c****************************************************************
c          Execute with:
c             antcalc filename method
c          where:
c                filename = propagation input data file to process
c                           (e.g. voacapx.dat)
c                method   = a = area coverage method
c                         = i = inverse area
c                         =   = point-to-point method
c****************************************************************
      use voacapl_defs
      use crun_directory
      common /cQUIET/ iquiet
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      common /designfreq/ freqdesign
      common /ccirparm/ parm(20),z6,umax,vmax,giso,
     +                  modegain,gainmax(3,2),gainmaxb(30),antnam
      character antnam*20,antname*20
      common /antnamec/ antname
c****************************************************************
      CHARACTER xmtrecv(2)*8,antfile*21,description*70
      character antfile40*40
c****************************************************************
      character tlatns*1,tlonew*1,rlatns*1,rlonew*1,path*1
      character filename*20,fileant*10,alf*80,anttype*10,method*1
      character methodX*1
c****************************************************************
      dimension antgains(30,91),efficiency(30),ztaz(2),aex(4)
      dimension areagain(91),gains1(91),gains2(91),freqarea(11)
ccc      data antgains/2730*0./
ccc      data efficiency/30*0./
      data xmtrecv/'TRANSMIT','RECEIVE'/
      data tlat,tlon,rlat,rlon/0.,0.,0.,0./
c****************************************************************
      iexecute=0         !  make sure antennas are not changed after an EXECUTE card
c                        !  as this WILL NOT work.
      do 400 i=1,30
      efficiency(i)=0.
      do 400 j=1,91
400   antgains(i,j)=0.
c****************************************************************
ccc      if(method.eq.'A') method='a'
      methodX=method
      if(methodX.eq.'I') methodX='A'
c****************************************************************
      if(iquiet.eq.0) write(*,'('' Opening input file:  '',a)') trim(run_directory)//PATH_SEPARATOR//filename
ccc      write(*,'('' OPENing file='',a)') filename
c      nch_run=lcount(run_directory,50)
      open(21,file=trim(run_directory)//PATH_SEPARATOR//filename,
     +     status='old',err=900)
      rewind(21)
c          read once to fill freqarea array
      do 505 i=1,11
505   freqarea(i)=0.
510   read(21,'(a)',end=520) alf
ccc      write(*,'('' alf='',a)') alf
      if(alf(1:10).eq.'AREA      ') methodX='A'    !  AREA mode
      if(alf(1:11).eq.'FREQUENCY $') then  !read frequency for area coverage
         read(alf,'(11x,11f6.3)') freqarea   !  VOACAP
      else if(alf(1:9).eq.'FREQUENCY') then  !read frequency for area coverage
         read(alf,'(10x,11f5.2)') freqarea   !  ICEPAC
ccc         write(*,'(''freq='',11f6.2)') freqarea
      else if(alf(1:9).eq.'FREQ     ') then  !read frequency for area coverage
         read(alf,'(10x,10f7.3)') (freqarea(i),i=1,10)   !  REC533
      end if
      go to 510
520   rewind(21)

10    read(21,'(a)',end=100) alf
ccc      write(*,'('' alf='',a)') alf
      if(alf(1:10).eq.'CIRCUIT   ') then
         read(alf,1) tlat,tlatns,tlon,tlonew,
     +               rlat,rlatns,rlon,rlonew,path
1        format(10x,f5.2,a1,3(f9.2,a1),2x,a)
         if(tlatns.eq.'S') tlat=-tlat
         if(tlonew.eq.'W') tlon=-tlon
         if(rlatns.eq.'S') rlat=-rlat
         if(rlonew.eq.'W') rlon=-rlon
         if(path.ne.'L') path='S'       !  default short path

      else if(alf(1:11).eq.'FREQUENCY $') then !read frequency for area coverage
         read(alf,'(11x,11f6.3)') freqarea   !  VOACAP
      else if(alf(1:9).eq.'FREQUENCY') then  !read frequency for area coverage
         read(alf,'(10x,11f5.2)') freqarea   !  ICEPAC
      else if(alf(1:9).eq.'FREQ     ') then  !read frequency for area coverage
         read(alf,'(10x,10f7.3)') (freqarea(i),i=1,10)   !  REC533

      else if(alf(1:10).eq.'TRANS     ') then
         read(alf,2) tlat,tlatns,tlon,tlonew
2        format(30x,f7.2,a1,f10.2,a1,2x,a)
         if(tlatns.eq.'S') tlat=-tlat
         if(tlonew.eq.'W') tlon=-tlon

      else if(alf(1:10).eq.'EXECUTE   ') then
         iexecute=1          !  flag to make sure no ANTENNA cards after EXECUTE

      else if(alf(1:10).eq.'RECVR     ') then
         read(alf,2) rlat,rlatns,rlon,rlonew,path
         if(rlatns.eq.'S') rlat=-rlat
         if(rlonew.eq.'W') rlon=-rlon
         if(path.ne.'L') path='S'       !  default short path

      else if(alf(1:10).eq.'ANTENNA   ') then
         if(iexecute.ne.0) go to 910        !  cannot have ANTENNA card after EXECUTE
         call dazel0(tlat,tlon,rlat,rlon,ztaz(1),zdgc)    !  calc azimuth T-R
         call dazel0(rlat,rlon,tlat,tlon,ztaz(2),zdgc)    !  calc azimuth R-T
         if(path.eq.'L') then        !  other way around earth
            ztaz(1)=ztaz(1)+180.
            if(ztaz(1).ge.360.) ztaz(1)=ztaz(1)-360.
            ztaz(2)=ztaz(2)+180.
            if(ztaz(2).ge.360.) ztaz(2)=ztaz(2)-360.
         end if
         read(alf,3) itr,idx,minfreq,maxfreq,design_freq,
     +               antfile,beam_main,rgain
3        format(10x,4i5,f10.3,1x,a21,1x,f5.1,f10.4)
         if(itr.eq.2 .and. rgain.ne.0.) design_freq=rgain   ! fix isotrope gain
         write(fileant,'(4hgain,i2.2,4h.dat)') idx
         open(22,file=trim(run_directory)//PATH_SEPARATOR//fileant,
     +        form='formatted')
         rewind(22)
         fs=minfreq
         fe=maxfreq
         if(freqarea(2).ne.0.) go to 200      !  point-to-point
         if(methodX.ne.'A') go to 200          !  point-to-point
c*****************************************************************
c          Area coverage  antenna calculations
c          1 Freq, 360 azimuths, 91 elevation angles
c*****************************************************************
         antfile40=antfile//'                   '
         call readant(37,antfile40,description)
         jant=nint(parm(2))                !  antenna type
         freqdesign=design_freq
         if(jant.eq.0) parm(1)=freqdesign   !  set isotrope gain
         call antmodel(jant,freqdesign,anttype)
         if(iquiet.eq.0)
     +   write(*,118) xmtrecv(itr),anttype,antfile,description(1:15),
     +                beam_main
118      format(4x,'    ',a8,'=',a10,1h[,a21,1h],'=',a,'  beam=',f6.1)
         write(22,'(a)') anttype//description
         write(22,119) fs,fe,beam_main,-999.,parm(4),parm(3)
119      format(2f5.0,2f7.2,2f10.5)
         parm(5)=freqarea(1)
         if(jant.le.12) then                            !  CCIR antenna
            call antinit2
            eff=0.
            if(jant.eq.11) eff=parm(3) !  efficiency
            if(jant.eq.7 .and. beam_main.lt.-1.) then   ! NON-terminated Rhombic
               do 125 iazim=0,359
c jw               call yieldit       !  yield for windows operations
               azimuth=iazim
               if(iazim.ge.91 .and. iazim.le.180) then
                  azimuth=180-iazim
               else if(iazim.ge.181 .and. iazim.le.269) then
                  azimuth=180-iazim+360
               end if
               do 120 ielev=0,90
               delev=ielev
120            call antcal(0.,azimuth,delev,areagain(ielev+1))
               call antsave(idx,iazim,freqarea(1),eff,areagain)
125            continue
            else
               do 135 iazim=0,359
c jw               call yieldit       !  yield for windows operations
               azimuth=iazim
               do 130 ielev=0,90
               delev=ielev
130            call antcal(0.,azimuth,delev,areagain(ielev+1))
               call antsave(idx,iazim,freqarea(1),eff,areagain)
135            continue
            end if
         else if(jant.eq.13) then      !  360 gain table
            eff=parm(3)         !  efficiency
            do 150 iazim=0,359
c jw            call yieldit       !  yield for windows operations
            read(13,rec=iazim+1) areagain
            do 140 ielev=1,91
140         areagain(ielev)=areagain(ielev)+parm(1)     !  additional gain
150         call antsave(idx,iazim,freqarea(1),eff,areagain)
         else if(jant.eq.14) then      !  Point-to-Point gain table
            ifreq=freqarea(1)
            read(14,rec=ifreq) eff1,gains1
            ifreq2=ifreq+1
            if(ifreq2.gt.30) ifreq2=30
            read(14,rec=ifreq2) eff2,gains2
            fract=freqarea(1)-ifreq
            eff=eff1 + (eff2-eff1)*fract
            do 160 iazim=0,359
c jw            call yieldit       !  yield for windows operations
            do 155 ielev=1,91
155         areagain(ielev)=parm(1) + gains1(ielev) +
     +                      (gains2(ielev)-gains1(ielev))*fract
160         call antsave(idx,iazim,freqarea(1),eff,areagain)
         else if(jant.ge.21 .and. jant.le.30) then      !  IONCAP antenna
            indx=jant-20
            call ioninit(indx,parm,asig,aeps,and,anl,anh,aex)
            azimuth=0.
            delev=6.*.0174533     !  get eff at 6 degrees
            call iongain(indx,azimuth,asig,aeps,and,anl,anh,aex,
     +            delev,freqarea(1),areagain,eff)
            do 190 iazim=0,359
c jw            call yieldit       !  yield for windows operations
            azimuth=iazim
            do 180 ielev=0,90
            delev=float(ielev)*.0174533
180         call iongain(indx,azimuth,asig,aeps,and,anl,anh,aex,
     +            delev,freqarea(1),areagain(ielev+1),eff)
190         call antsave(idx,iazim,freqarea(1),eff,areagain)
         else if(jant.ge.31 .and. jant.le.47) then      !  HFMUFES antenna
            indx=jant-30
            call mufesint(indx,parm,asig,aeps,and,anl,anh,aex)
            azimuth=0.
            delev=6.*.0174533     !  get eff at 6 degrees
            call mufesgan(indx,1,azimuth,asig,aeps,and,anl,anh,aex,
     +            delev,freqarea(1),areagain,eff)
            do 199 iazim=0,359
c jw            call yieldit       !  yield for windows operations
            azimuth=iazim
            do 195 ielev=0,90
            delev=float(ielev)*.0174533
195         call mufesgan(indx,2,azimuth,asig,aeps,and,anl,anh,aex,
     +            delev,freqarea(1),areagain(ielev+1),eff)
199         call antsave(idx,iazim,freqarea(1),eff,areagain)
         else if(jant.eq.48) then      !  NOSC antenna models
            eff=0.
            do 210 iazim=0,359
c jw            call yieldit       !  yield for windows operations
            azimuth=iazim
            do 205 ielev=0,90
            delev=float(ielev)
205         call invcon(30,freqarea(1),delev,areagain(ielev+1))
210         call antsave(idx,iazim,freqarea(1),eff,areagain)
         else if(jant.ge.90) then      !  Harris modifications (Area coverage)
            close(22)
            call harris(jant,fileant,'a',idx,antfile,freqarea(1),30.,
     +                  beam_main,-999.)
            go to 301
         end if
         go to 300
c*****************************************************************
c          Point-to-point antenna calculations
c          Freqs 2-30, 1 azimuth, 91 elevation angles
c*****************************************************************
200      do 15 if=1,30
         efficiency(if)=0.
         do 15 ielev=0,90
15       antgains(if,ielev+1)=0.
         antfile40=antfile//'                   '
         call readant(37,antfile40,description)
         jant=nint(parm(2))                !  antenna type
         freqdesign=design_freq
         if(jant.eq.0) parm(1)=freqdesign   !  set isotrope gain
         call antmodel(jant,freqdesign,anttype)
         if(jant.le.12) then                            !  CCIR antenna
            do 20 ifreq=minfreq,maxfreq
c jw            call yieldit       !  yield for windows operations
            freq=ifreq
            parm(5)=freq
            call antinit2
ccc            call setmaxgain(freq)
            if(jant.eq.11) efficiency(ifreq)=parm(3) !  efficiency
            do 20 ielev=0,90
            delev=ielev
20          call antcal(beam_main,ztaz(itr),delev,
     +                  antgains(ifreq,ielev+1))
         else if(jant.eq.13) then                       !  Area gain table
            do 21 ifreq=minfreq,maxfreq
21          efficiency(ifreq)=parm(3)      !  efficiency
            offazim=ztaz(itr)-beam_main    !  off azimuth
            if(offazim.lt.0.) offazim=offazim+360.
            iazim=offazim
            iazim2=iazim+1
            if(iazim2.eq.360) iazim2=0
            read(13,rec=iazim+1) gains1
            read(13,rec=iazim2+1) gains2
            fract=offazim-float(iazim)
            do 22 ielev=0,90
            g1=gains1(ielev+1)
            g2=gains2(ielev+1)
            g=g1 + (g2-g1)*fract + parm(1)
            do 22 ifreq=minfreq,maxfreq
22          antgains(ifreq,ielev+1)=g
         else if(jant.eq.14) then                   !  Point-to-Point gain table
            do 25 ifreq=minfreq,maxfreq
c jw            call yieldit       !  yield for windows operations
            read(14,rec=ifreq) efficiency(ifreq),
     +                         (antgains(ifreq,ielev+1),ielev=0,90)
            do 25 ielev=0,90
25          antgains(ifreq,ielev+1)=antgains(ifreq,ielev+1)+parm(1)
         else if(jant.ge.21 .and. jant.le.30) then      !  IONCAP antenna
            indx=jant-20
            call ioninit(indx,parm,asig,aeps,and,anl,anh,aex)
            offazim=ztaz(itr)-beam_main    !  off azimuth
            if(offazim.lt.0.) offazim=offazim+360.
            do 30 ifreq=minfreq,maxfreq
c jw            call yieldit       !  yield for windows operations
            freq=ifreq
            parm(5)=freq
            do 30 ielev=0,90
            delev=float(ielev)*.01745329          !  elevation angle in radians
30          call iongain(indx,offazim,asig,aeps,and,anl,anh,aex,
     +            delev,freq,antgains(ifreq,ielev+1),efficiency(ifreq))
         else if(jant.ge.31 .and. jant.le.47) then      !  HFMUFES antenna
            indx=jant-30
            call mufesint(indx,parm,asig,aeps,and,anl,anh,aex)
            offazim=ztaz(itr)-beam_main    !  off azimuth
            if(offazim.lt.0.) offazim=offazim+360.
            do 40 ifreq=minfreq,maxfreq
c jw            call yieldit       !  yield for windows operations
            freq=ifreq
            parm(5)=freq
            kas=0
            do 40 ielev=0,90
            delev=float(ielev)*.01745329          !  elevation angle in radians
40         call mufesgan(indx,kas+ielev,offazim,asig,aeps,and,anl,anh,
     +       aex,delev,freq,antgains(ifreq,ielev+1),efficiency(ifreq))
         else if(jant.eq.48) then      !  NOSC antenna models
            offazim=ztaz(itr)-beam_main    !  off azimuth
            if(offazim.lt.0.) offazim=offazim+360.
            do 45 ifreq=minfreq,maxfreq
c jw            call yieldit       !  yield for windows operations
            freq=ifreq
            do 45 ielev=0,90
            elev=float(ielev)          !  elevation angle in degrees
45         call invcon(30,freq,elev,antgains(ifreq,ielev+1))
         else if(jant.ge.90) then      !  Harris modifications (point-to-point)
            offazim=ztaz(itr)-beam_main    !  off azimuth
            if(offazim.lt.0.) offazim=offazim+360.
            close(22)
            call harris(jant,fileant,' ',idx,antfile,fs,fe,
     +                  beam_main,offazim)
            go to 301
         end if
         offazim=ztaz(itr)-beam_main    !  off azimuth
         if(offazim.lt.0.) offazim=offazim+360.
         write(22,'(a)') anttype//description
         write(22,94) fs,fe,beam_main,offazim,parm(4),parm(3)
94       format(2f5.0,2f7.2,2f10.5)
         do 95 ifreq=1,30
         do j=1,91     !  make sure format does not make **********
            if(antgains(ifreq,j).lt.-99.99) antgains(ifreq,j)=-99.99
         end do
95       write(22,96) ifreq,efficiency(ifreq),
     +                (antgains(ifreq,j),j=1,91)
96       format(i2,f6.2,(t10,10f7.3))
         if(iquiet.eq.0)
     +   write(*,101) xmtrecv(itr),anttype,antfile,description(1:10),
     +                beam_main,ztaz(itr)
101      format(1x,a8,'=',a10,1h[,a21,1h],'=',a10,'  beam=',f6.1,
     +          '  az=',f6.1)
ccc         write(*,102) (antgains(10,j),j=1,91)
ccc102      format(10x,10f6.1)
c***************************************************************
300      close(22)
301      continue

      end if
      go to 10
100   close(21)
      go to 999
c****************************************************************
900   write(*,901) filename
901   format(' In ANTCALC, could not OPEN file=',a)
      go to 999
910   write(*,911)
911   format(' You cannot have an ANTENNA card after EXECUTE.',
     +       ' The software does not allow that.')
      stop 'Input deck error -- ANTENNA card after EXECUTE.'
999   continue
ccc      call antprint
      return
      END
c--------------------------------------------------------------------- *
      subroutine antsave(iantr,iazim,freq,eff,areagain)
c        save into /cantenna/ array to save DECRED the effort
c        for area coverage, we can remove the write & read since antcalc
c        is back inside the propagation program.
      dimension areagain(91)
      common /cantenna/ numants,iats(20),anttype(20),antname(20),
     +                  xfqs(20),xfqe(20),designfreq(20),antfile(20),
     +                  beammain(20),offazim(20),cond(20),diel(20),
     +                  array(30,91,20),aeff(30,20)
      character anttype*10,antname*70,antfile*24
      common /Careaant/ iarray360(360,91,2)
         integer*2 iarray360
ccc      equivalence (array,iarray360)        !  for area coverage
      aeff(1,iantr)=eff
      do 10 ielev=1,91
      gain=areagain(ielev)
      if(gain.gt. 300.) gain= 300.
      if(gain.lt.-300.) gain=-300.
10    iarray360(iazim+1,ielev,iantr)=nint(gain*100.)
ccc            if(iazim.eq.0) write(22,14) freq,eff
ccc14          format(10x,f7.3,'MHz eff=',f10.3)
ccc            write(22,121) iazim,areagain
ccc121         format(i5,(t10,10f7.3))
      return
      end
c--------------------------------------------------------------------- *
      subroutine antprint
c        save into /cantenna/ array to save DECRED the effort
c        for area coverage, we can remove the write & read since antcalc
c        is back inside the propagation program.
      common /cantenna/ numants,iats(20),anttype(20),antname(20),
     +                  xfqs(20),xfqe(20),designfreq(20),antfile(20),
     +                  beammain(20),offazim(20),cond(20),diel(20),
     +                  array(30,91,20),aeff(30,20)
      character anttype*10,antname*70,antfile*24
      common /Careaant/ iarray360(360,91,2)
         integer*2 iarray360
cccccc      equivalence (array,iarray360)        !  for area coverage
ccc      write(72,1) (iarray360(1,i,1),i=1,10)
ccc1     format('iarray360=',10i7)
      return
      end
c---------------------------------------------------------------------

c###mpath.for
      SUBROUTINE MPATH(IF)
C-------------------------------
C
C     THIS ROUTINE PERFORMS THE MULTIPATH PROBABILITY AND DETERMINES
C     IF ANY OTHER MODE WILL INTERFERE WITH THE MOST RELIABLE MODE
c**********************************************************************
c          As changed 26 March 2009
c          This return the reliability of the next most probable mode
c          that is within the Maximum tolerable time delay (DMP)
c          and whose signal power is greater than PMP below the
c          signal power of the MRM.
c**********************************************************************
C
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON / allMODE /ABPS(20),CREL(20),FLDST(20),HN(20),HP(20),
     1PROB(20),RELY(20),RGAIN(20),SIGPOW(20),SN(20),
     2SPRO(20),TGAIN(20),TIMED(20),TLOSS(20),B(20),FSLOS(20),
     3grlos(20),adv(20),obf(20),
     CNMODE(20),TLLOW(20),TLHGH(20),EFF(20),NREL,NMMOD
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16,
     1                 LU20, LU25, LU26, LU35
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100

      PROBMP(IF) = 0.001
      IF(DMP.le.0. .or. PMP.le.0.) return        !  no multipath requested
c          Is this METHOD=30? If so, not valid>7000km
      if(method.eq.20 .and. mspec.eq.121 .and. gcdkm.gt.7000.) return
      sig_power=sigpow(nrel)         !  signal power of Most-Reliable-Mode
      sig_power_limit=sig_power-PMP  !  ignore signals below this level
      TTIM = timed(nrel)             !  time delay of MRM
ccc      write(luo,4) method,mspec,gcdkm
ccc4     format('method, mspec=',2i5,f10.2)
ccc      write(luo,1) nrel,sig_power,sig_power_limit,ttim,pmp,dmp
ccc1     format('mpath=',i3,5f10.3)

      DO 135 IM = 1,NMMOD   ! DO LOOP up to max. number of modes.
      IF(IM.EQ.NREL) GO TO 135  ! Don't check mode for MRM -- found already by RELBIL.FOR.
      IF(HP(IM).LE.0.) GO TO 135  ! This mode does not exist.
ccc      write(luo,2) im,timed(im),sigpow(im)
ccc2     format(i4,2f10.3)
      IF(ABS(TIMED(IM)-TTIM).LE.DMP) GO TO 135   !  inside acceptable time delay

C        Check on Multipath Power criterion set by operator.
C        The logic of this next part is revised from original code.
c        Ignore signal powers below this limit
      if(sigpow(im).lt.sig_power_limit) go to 135

      PROBMP(IF)=AMAX1(PROBMP(IF),RELY(IM))
ccc      write(luo,3) probmp(if),rely(im)
ccc3     format(20x,2f10.3)
135   CONTINUE
      RETURN
      END
C--------------------------------

module crun_directory
    implicit none
    integer, parameter :: VOA_PATH_LEN = 128
    character(len=VOA_PATH_LEN) :: root_directory
    character(len=VOA_PATH_LEN) :: run_directory
    character(len=VOA_PATH_LEN) :: area_directory
    character(len=VOA_PATH_LEN) :: area_inv_directory
end module crun_directory

      function gainterp(gainaa,freqoper,freqdesign,iant)
c          interpolate directivity gain given:
c              gainaa(1-3,1) = gain @  2MHz Fr=.70,1.0,1.4  iant=1
c              gainaa(1-3,2) = gain @ 30MHz Fr=.70,1.0,1.4  iant=1
c              gainaa(1-3,1) = gain @  2MHz Fr=.85,1.0,1.2  iant=2,3,4,8,9
c              gainaa(1-3,2) = gain @ 30MHz Fr=.85,1.0,1.2  iant=2,3,4,8,9
c              freqoper      = operating frequency
c              freqdesign    = design    frequency
      dimension gainaa(3,2)
      Fr=freqoper/freqdesign      !  Frequency ratio
ccc      if(Fr.lt. .7) Fr= .7        !  lower limit
ccc      if(Fr.gt.1.4) Fr=1.4        !  upper limit
      if(iant.eq.1 .and. (Fr.lt. .7 .or. Fr.gt.1.4)) then
         gainterp=-30.            !  outside limits
      else if(iant.ne.1 .and. (Fr.lt. .85 .or. Fr.gt.1.2)) then
         gainterp=-30.            !  outside limits
      else
         g1=gainterp1(gainaa(1,1),Fr,iant)!   2 MHz Operating
         g2=gainterp1(gainaa(1,2),Fr,iant)!  30 MHz Operating
         gainterp=g1 + (g2-g1)*(freqoper-2.)/28.
      end if
      return
      end
c----------------------------------------------------
      function gainterp1(gainaa,Fr,iant)
      dimension gainaa(3),Frs(3,2)
      data frs/.7,1.0,1.4,.85,1.0,1.2/
      jant=iant
      if(jant.ne.1) jant=2
      idx=2                   !  between 1.0 & 1.4 (or 1.2)
      if(Fr.lt.1.) idx=1      !  between  .7 (or .85) & 1.0
      gainterp1=gainaa(idx) + (gainaa(idx+1)-gainaa(idx))*
     +             (Fr-Frs(idx,jant))/(Frs(idx+1,jant)-Frs(idx,jant))
      return
      end
c----------------------------------------------------

c###tabs.for
      SUBROUTINE TABS(DEL,HP,DM,AM)
C--------------------------------
C
C     THIS SUBROUTINE CALCULATES THE LOSS PER KILOMETER FOR THE
C     PART OF THE PATH THAT MISSES THE ABSORBING REGINON
C
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
      COMMON/GEOG/GYZ(5),RAT(5),GMDIP(5),CLCK(5),ABIY(5),ARTIC(5),SIGPAT
     A(5), EPSPAT(5)
      IF(DM) 110,110,105
  105 IF(HP-70.) 110,110,115
  110 AM = 1000.
      RETURN
C.....ABSORPTION INDEX
  115 XI = 0.1
C.....THIS IS THE F2 MODE LOSS FOR A FRACTIONAL NUMBER OF HOPS
      AB  = 10.2 + (FREQ +GYZ(3))  **1.98
      AM  = 677.2 * XI/AB
      RCOSD = RZ*COS(DEL)
      SPHE  = RCOSD/(RZ+HP)
      PHE   = ATAN(SPHE/SQRT(1.-SPHE*SPHE))
      PSI   = PIO2 -PHE - DEL
      XMHOP = .5* DM/PSI
      SPHE  = RCOSD/(RZ+100.)
      SCPHE = 1./SQRT(1.-SPHE*SPHE)
      PORT  = XMHOP* SCPHE/(DM*RZ)
      AM  = AM*PORT
      RETURN
      END
C--------------------------------

      subroutine getdirs(basedir,list,nmax,num)
c*******************************************************************
c         get list of antenna file directories
c         under the directory "basedir"
c*******************************************************************
      character basedir*(*),based*20,dirname*12,list(*)*14
      based=basedir
      nch=lcount(based,20)
      ier=isystem('dir '//based(1:nch)//' /one /A:D /b /-p>dirs.lst',
     +      30+nch)
      open(31,file='dirs.lst',status='old',err=900)
      rewind(31)
      num=0
10    read(31,'(a)',end=100) dirname
      num=num+1
      list(num)=' '//dirname//' '
      if(num.lt.nmax) go to 10
100   close(31)
      ier=isystem('del dirs.lst',12)
      return
900   stop 'In GETDIRS Could not OPEN file=dirs.lst'
      end
c---------------------------------------------------------------

! dst2cvs. Convert a .DST binary record file into a text based CSV.
!
! Copyright (C) 2018 J.Watson
!
! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

! This program uses Hani Andreas Ibrahim's getopt module
! https://github.com/haniibrahim/f90getopt

program dst2csv
    use f90getopt
    implicit none
    logical*1 file_exists
    logical*1 :: dump_file = .false.
    real :: gcdkm, xlat, xlon, MUF, FOT, ANGLE, DELAY, VHITE, MUFday, LOSS
    real :: DBU, SDBW, NDBW, SNR, RPWRG, REL, MPROB, SPRB, SIGLW, SIGUP, SNRLW, SNRUP
    real :: TGAIN, RGAIN, SNRxx, DBM
    character(len=128) :: data_dir_path = "."
    integer :: ios
    integer :: NUMDIST, NUMFREQ, NUMHOUR
    real, dimension(1 : 25) :: FREQS
    integer, dimension(1 : 25) :: hours
    integer, parameter :: DMP_FILE = 60
    integer, parameter :: IDX_FILE = 70
    integer, parameter :: DST_FILE = 80
    integer, parameter :: CSV_FILE = 90
    integer :: HOURBLK
    integer :: ptr, utcPtr, freqPtr, offset, id = 0
    character(200) :: index_buffer
    character(4) :: xmode
    character(120) :: RUN_DIR
    character(len=1), parameter :: PATH_SEPARATOR ='/'
    character(len=128) :: idx_path, dst_path, csv_path, dmp_path

    ! Define options
    type(option_s):: opts(2)
    opts(1) = option_s( "input", .true., 'i' )
    opts(2) = option_s( "dump", .false., 'd' )
    ! option definitions

    do
        select case( getopt( "di:", opts ) )
            case( char(0) )
                exit
            case( 'i' )
                data_dir_path = optarg
            case( 'd' )
                dump_file = .true.
        end select
    end do

    idx_path = trim(data_dir_path)//PATH_SEPARATOR//'voacapd.idx'
    dst_path = trim(data_dir_path)//PATH_SEPARATOR//'voacapd.dst'
    csv_path = trim(data_dir_path)//PATH_SEPARATOR//'voacapd.csv'
    dmp_path = trim(data_dir_path)//PATH_SEPARATOR//'voacapd.dmp'

    inquire(file=idx_path, exist=file_exists)
    if (.not.file_exists) then
        write(*,'(''IDX file does not exist : '',a)') idx_path
        stop
    end if

    inquire(file=dst_path, exist=file_exists)
    if (.not.file_exists) then
        write(*,'(''DST file  does not exist: '',a)') dst_path
        stop
    end if

    open(IDX_FILE, file=idx_path, status='old')
    ! Read the number of distances
    read(IDX_FILE, '(I5A)') NUMDIST, index_buffer

    ! Read the frequencies
    read(IDX_FILE, '(I2A)') NUMFREQ, index_buffer
    do freqPtr = 1, NUMFREQ
        offset = 1 + (7*(freqPtr-1))
        read(index_buffer((offset): (offset+7)), '(F7.3)') FREQS(freqPtr)
    end do

    ! Read the hours
    read(IDX_FILE, '(I3A)') NUMHOUR, index_buffer
    do ptr = 1, NUMHOUR
        offset = 1 + (3*(ptr-1))
        read(index_buffer((offset): (offset+3)), '(I3)') hours(ptr)
    end do

    close(IDX_FILE)

    HOURBLK = NUMDIST * NUMFREQ

    open(DST_FILE,file=dst_path,status='old', form='unformatted',access='direct',recl=108)


    if (dump_file) then
        open(DMP_FILE,file=dmp_path)
        write(DMP_FILE, '(A)') "id,gcdkm,Latitude,Longitude,Mode,MUF,FOT,ANGLE,DELAY,VHITE,MUFday,LOSS,&
            DBU,SDBW,NDBW,SNR,RPWRG,REL,MPROB,SPRB,SIGLW,SIGUP,SNRLW,SNRUP,TGAIN,RGAIN,SNRxx,DBM"
        do ptr=1, HOURBLK*NUMHOUR
          read(DST_FILE, rec=ptr) gcdkm,xlat,xlon,xmode, MUF, &
              FOT, ANGLE, DELAY, VHITE, MUFday, LOSS, DBU, SDBW, &
              NDBW, SNR, RPWRG, REL, MPROB, SPRB, SIGLW, SIGUP, &
              SNRLW, SNRUP, TGAIN, RGAIN, SNRxx, DBM
          write(DMP_FILE, '(I0, A, F0.1, A, 2(F0.4,","), A4, 23(",",F0.3))') &
              ptr, ",", gcdkm, ",", xlat, xlon, xmode, MUF, FOT, ANGLE, &
              DELAY, VHITE, MUFday, LOSS, DBU, SDBW, NDBW, SNR, RPWRG, REL, MPROB, SPRB, SIGLW, SIGUP, &
              SNRLW, SNRUP, TGAIN, RGAIN, SNRxx, DBM
        end do
        close(DMP_FILE)
    end if

    open(CSV_FILE,file=csv_path)
    rewind(CSV_FILE)
    write(CSV_FILE, '(A)') "id,utc,chan,freq,gcdkm,Latitude,Longitude,Mode,MUF,FOT,ANGLE,DELAY,VHITE,MUFday,LOSS,&
        DBU,SDBW,NDBW,SNR,RPWRG,REL,MPROB,SPRB,SIGLW,SIGUP,SNRLW,SNRUP,TGAIN,RGAIN,SNRxx,DBM"

    do utcPtr = 1, NUMHOUR
        do freqPtr = 1, NUMFREQ
            do ptr = NUMDIST-1, 0, -1
                id = id + 1
                read(DST_FILE, rec=((utcPtr-1)*HOURBLK)+(ptr*NUMFREQ)+freqPtr ) gcdkm,xlat,xlon,xmode, MUF, &
                    FOT, ANGLE, DELAY, VHITE, MUFday, LOSS, DBU, SDBW, &
                    NDBW, SNR, RPWRG, REL, MPROB, SPRB, SIGLW, SIGUP, &
                    SNRLW, SNRUP, TGAIN, RGAIN, SNRxx, DBM
                write(CSV_FILE, '(3(I0,","), F0.3, A, F0.1, A, 2(F0.4,","), A4, 23(",",F0.3))') &
                    id, hours(utcPtr), freqPtr, FREQS(freqPtr), ",", gcdkm, ",", xlat, xlon, xmode, MUF, FOT, ANGLE, &
                    DELAY, VHITE, MUFday, LOSS, DBU, SDBW, NDBW, SNR, RPWRG, REL, MPROB, SPRB, SIGLW, SIGUP, &
                    SNRLW, SNRUP, TGAIN, RGAIN, SNRxx, DBM
            end do
        end do
    end do
    close(DST_FILE)
    close(CSV_FILE)
end program dst2csv

c###outlin.for
      SUBROUTINE OUTLIN
C--------------------------------
C
C     THIS ROUTINE CALLS SUBROUTINES OUTTOP AND OUTBOD TO OUTPUT LINES
C
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      LINADD = LINBOT(26)
      ISAV=LUO
      IONCE=0
      IF(LINADD+LINES.lt.LINMAX) go to 105
      IF(METHOD.EQ.23.AND.LINBYP.LT.0)THEN
        DO 103 ILU=1,18
        IF(LINBOT(ILU).EQ.1)THEN
          LUO=70+ILU
          CALL OUTTOP
          IF(IONCE.EQ.0)IONCE=LINES
        ENDIF
  103   CONTINUE
        LUO=ISAV
        LINES=IONCE
      ELSE
        CALL OUTTOP
      ENDIF
  105 CALL OUTBOD
      RETURN
      END
C--------------------------------

      subroutine runfreqs(ifr,frel)
      dimension frel(11)
      dimension if1(3),if2(3)
      data if1/ 2,11,21/
      data if2/10,20,30/
      data mode/1/
      do 5 i=1,11
5     frel(i)=0.
      i=0
      if(mode.eq.2) go to 100
      do 10 if=if1(ifr),if2(ifr)
      i=i+1
10    frel(i)=if
      return
100   if(ifr.eq.1) then
         jf1=2
         jf2=20
      else
         jf1=22
         jf2=30
      end if
      do 110 if=jf1,jf2,2
      i=i+1
110   frel(i)=if
      end

c###inmuf.for
      SUBROUTINE INMUF(IHOP,NUMMOD)
C--------------------------------
C
C     THIS ROUTINE INSERTS OVER-THE-MUF OR ZERO DISTANCE MODES
C     IHOP WILL MATCH THE CORRECT NUMBER OF HOP ON SOME CALL
C     THE ROUTINE ASSURES SMOOTH TRANSITIONS
C
C  IF NO MODE IN REFLECTRIX ADD A OVER-THE-MUF MODE FOR EACH LAYER.
C
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/MODES/GHOP,DELMOD(6,3),HPMOD(6,3),HTMOD(6,3),FVMOD(6,3)
     A ,ITMOD(6,3),AFMOD(6,3)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24),FOT
     A(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMUF(4)
     B ,HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     A ,YMUF(4)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON/INFORM/INFO,IHSHR,IHLNG
C*****************************************************
      REAL*4 OSIGL(3),OSIGU(3),OYFOT(3),OYHPF(3),OYMUF(3)
      INTEGER*4 INM(3)
      character MODZ(3)*4, mlay(3,2)*4, HIMUFS(3)*7
      data mlay/'  E ',' F1 ',' F2 ','  Ex',' F1x',' F2x'/
      DATA EPS /.4001/
      K = JMODE
      IRESET=0
C.....WHAT LAYERS ARE IN.
      do 1 i=1,3
      INM(I)=-1
    1 MODZ(i)='    '
C.....BEINNING OF CHECK ON LAYER PRESENT
      INUM=0
      DO 125 IM = 1,6
C.....IF NO MODE BRANCH TO STATEMENT LABEL 125
      IF(HPMOD(IM,K) - 70.)  125,100,100
  100 INUM = INUM +1
      ITP=ITMOD(IM,K)
      INM(ITP)=1
      DELMOD(INUM,K) = DELMOD(IM,K)
      HPMOD (INUM,K) = HPMOD (IM,K)
      HTMOD (INUM,K) = HTMOD (IM,K)
      FVMOD (INUM,K) = FVMOD (IM,K)
      AFMOD (INUM,K) = AFMOD (IM,K)
      ITMOD (INUM,K) = ITMOD (IM,K)
  125 CONTINUE
      ISAV=INUM
C.....END OF CHECK ON LAYER PRESENT
C.....CHECK ON VERY SHORT DISTANCE (TAKE-OFF ANGLE .GE. 89.9)
      IF(DELMUF(MODMUF) .GE. 89.9)GO TO 250
      DO 150 ILY=1,3
C.....CHECK TO SEE IF F1 EXISTS
      IF(ILY.EQ.2.AND.FI(2,K).LE.0.)GO TO 150
C.....ALL THE LAYERS ARE IN IF 5 OR 6
      IF(INUM .GE. 5) GO TO 151
C.....CHECK IF LAYER(ILY) IS IN
      IF(INM(ILY).LT.0)THEN
C.......IF FREQ .GT. MUF AND THE NUMBER OF HOPS IS THE SAME INSERT MUF(ILY)
        IF( (FREQ+EPS).GE.YMUF(ILY).AND.IHOP.EQ.NHOPMF(ILY))THEN
C.........OVER-THE-MUF
C.........INSERT MUF(ILY) MODE
          INUM = INUM +1
          INEW=INUM-ISAV
          DELMOD(INUM,K) = DELMUF(ILY)
          HPMOD (INUM,K) = HPMUF (ILY)
          HTMOD (INUM,K) = HTMUF (ILY)
          FVMOD (INUM,K) = FVMUF (ILY)
          AFMOD (INUM,K) = AFMUF (ILY)
          ITMOD (INUM,K) = ILY
          INM(ILY)=1
          MODZ(INEW)=MLAY(ILY,1)
        ENDIF
      ENDIF
  150 CONTINUE
  151 IF(INUM.GT.ISAV)THEN
        IF(IAND(INFO,1).GT.0)THEN
          ghopkm=ghop*rz
         WRITE(99,'(16h "INMUF1"  Nhop=,I1,3x,6hHopkm=,f6.0,7h  Mods=,
     1    I1,3X,3A3)')IHOP,GHOPKM,INUM,(MODZ(II)(1:3),II=1,INEW)
        ENDIF
        do 152 i=1,3
  152   MODZ(i)='    '
        ISAV=INUM
      ENDIF
C.....CHECK ON ABOVE ABOVE THE MUF FOR THIS ORDER HOP
C.....FIND NEW MUF FOR MODE WITH THIS NUMBER OF HOPS
      IF(IHOP.EQ.NHOPMF(MODMUF))THEN
        IF(INUM.GT.0)THEN
          GO TO 275
        ELSE
          GO TO 250
        ENDIF
      ENDIF
C.....SAVE CIRCUIT MUF PARAMETERS
      IRESET=1
      DO 200 IL=1,3
      OSIGL(IL)=SIGL(IL)
      OSIGU(IL)=SIGU(IL)
      OYFOT(IL)=YFOT(IL)
      OYHPF(IL)=YHPF(IL)
  200 OYMUF(IL)=YMUF(IL)
C.....SET HIMUFS(JH) TO PRODUCE ***** IF NOT CALCULATED
      DO 201 JH=1,3
  201 HIMUFS(JH)='  *****'
      DO 240 JH=1,3
C.....ALL THE LAYERS ARE IN IF 5 OR 6
      IF(INUM .GE. 5) GO TO 241
C.....CHECK IF MODE FOR LAYER ALREADY EXISTS
      IF(INM(JH).GT.0)GO TO 240
C.....CHECK IF LAYER (F1) EXISTS
      IF(JH.EQ.2.AND.FI(2,K).LE.0.)GO TO 240
C.....CHECK IF HOP NUMBER LESS THAN OR EQUAL TO LAYER MUF HOPS
      IF(IHOP.LE.NHOPMF(JH))GO TO 240
      FV = FVMUF (JH)
      K = JMODE
      HT = HTMUF (JH)
      HPVER = XLIN(FV,FVERT,HPRIM,30,K)
      XHP = (HPVER - HT)/RZ
      HPNOW = HPVER
      NNOW = IHOP
      HOP = NNOW
      PSI = .5 *GCD/HOP
      TDEL = (COS(PSI) - RZ/(RZ + HPNOW     ))/ SIN(PSI)
      CDEL = 1. / SQRT (1. + TDEL * TDEL)
      SPHE = RZ * CDEL / (RZ + HT)
      SECP = 1. / SQRT(1. - SPHE * SPHE)
      ESD = FV * SECP
C.....CORRECTION TO MARTYN S THEOREM,SEE CURMUF
      FOB1 = ESD
      XMUT = SPHE*SPHE
      XFSQ = FOB1*FOB1/(FI(JH,K)*FI(JH,K) )
      SPH  =  XFSQ*XMUT*XHP*(HT+2.*(RZ+HT)*XHP)
C.....sph=amin1(sph,60.)
      IF(IAND(INFO,8).GT.0)THEN
        WRITE(99,'(A,I2,3(A,F8.2))')' "INMUF"  LAYER= ',JH,
     1  '  HP= ',HPVER,'  MARTYN CORR= ',SPH,'  FOB= ',FOB1
      ENDIF
      HPNOW   = HPVER + SPH
      TDEL = (COS(PSI) - RZ/(RZ + HPNOW     ))/ SIN(PSI)
      CDEL = 1. / SQRT (1. + TDEL * TDEL)
      SPHE = RZ * CDEL / (RZ + HT)
      SECP = 1. / SQRT(1. - SPHE * SPHE)
      ESD = FV * SECP
      WRITE(HIMUFS(JH),'(F7.2)')ESD
C.....CHECK IF FREQ IS ABOVE NEW MUF (ESD)
      IF (FREQ - ESD + EPS) 240,160,160
C.....NEW MUF HAS BEEN FOUND AND CAN BE USED
  160 CONTINUE
      YMUF(JH) = ESD
      SIGL(JH) = ESD * OSIGL(JH)/OYMUF(JH)
      YFOT(JH) = YMUF(JH) - 1.28 * SIGL(JH)
      SIGU(JH) = ESD * OSIGU(JH)/OYMUF(JH)
      YHPF(JH)= YMUF(JH) + 1.28*SIGU(JH)
      INUM=INUM+1
      INEW=INUM-ISAV
      DELMOD(INUM,K) = ATAN(TDEL) * R2D
      HPMOD(INUM,K) = HPNOW
      HTMOD(INUM,K) = HTMUF(JH)
      FVMOD(INUM,K) = FVMUF(JH)
      AFMOD(INUM,K) = AFMUF(JH)
      ITMOD(INUM,K) = JH
      MODZ(INEW)=MLAY(JH,1)
      GHOP = 2. * PSI
  240 CONTINUE
  241 IF(INUM.GT.ISAV)THEN
        IF(IAND(INFO,1).GT.0)THEN
          WRITE(99,'(A,3(I1,A2,1H=,A7,2X))')'  MUFS THIS HOP  ',
     1    (IHOP,MLAY(IL,1)(2:3),HIMUFS(IL),IL=1,3)
          ghopkm=ghop*rz
        WRITE(99,'(16h "INMUF2"  Nhop=,I1,3x,6hHopkm=,f6.0,7h  Mods=,
     1   I1,3X,3A3)')IHOP,GHOPKM,INUM,(MODZ(II)(1:3),II=1,INEW)
        ENDIF
      ENDIF
      GO TO 275
C  VERY SHORT DISTANCE, MAY NOT BE OVER MUF FOR F2 LAYER.
C  SO PROGRAM WILL DO ZERO DISTANCE WHICH MAY NOT BE IN THE REFLECTRIX
C  TABLE
  250 INUM = INUM +1
      INEW=INUM-ISAV
C.....BEGINNING OF SECTION TO ALWAYS FIND A MODE.
C.....THIS WILL REPRODUCE THE IONOGRAM
      FV = FREQ - 0.001
C.....INTERPOLATE IN IONOGRAM
C.....FIND FREQ IN TABLE
      FMAX=FVERT(1,K)
      DO 255 IH = 2,30
      IHX = IH
      IF(FVERT(IH,K).GT.FMAX)FMAX=FVERT(IH,K)
      IF( FV - FVERT(IH,K) ) 260,265,255
  255 CONTINUE
C.....FREQ ABOVE TABLE VALUES GO TO EXIT
      IF(IAND(INFO,1).GT.0)THEN
        WRITE(99,'(A,I4,2F7.2)')
     1'  FREQ ABOVE TABLE VALUES  K,FMAX,FREQ= ',K,FMAX,FREQ
      ENDIF
      GO TO 275
C.....INTERPOLATE BETWEEN TABLE VALUES
  260 SLOPE  = FVERT(IHX,K) - FVERT(IHX-1,K)
      IF(SLOPE .GT. 0.01 )THEN
        SLP = (FV -FVERT(IHX-1,K) ) / SLOPE
        DELMOD(INUM,K) = 90.0
        HPMOD(INUM,K)=HPRIM(IHX-1,K) +(HPRIM(IHX,K)-HPRIM(IHX-1,K))*SLP
        HTMOD(INUM,K)=HTRUE(IHX-1,K) + (HTRUE(IHX,K) - HTRUE(IHX-1,K) )
     1  * SLP
        FVMOD(INUM,K) = FV
        AFMOD(INUM,K)=AFAC (IHX-1,K) +(AFAC (IHX,K)- AFAC(IHX-1,K))*SLP
      ENDIF
      GO TO 270
C.....FOUND EXACT FREQ IN FVERT TABLE SO USE ENTRIES
  265 DELMOD(INUM,K) = 90.
      HPMOD (INUM,K) = HPRIM(IHX,K)
      HTMOD (INUM,K) = HTRUE(IHX,K)
      FVMOD (INUM,K) = FVERT(IHX,K)
      AFMOD (INUM,K) = AFAC (IHX,K)
  270 CONTINUE
      DO 272 ILY=1,3
      IF(ILY.EQ.2.AND.FI(2,K).LE.0.)GO TO 272
      IF(HTMOD(INUM,K).LE.HI(ILY,K))THEN
        ITMOD(INUM,K) = ILY
        MODZ(INEW)=MLAY(ILY,2)
        INM(ILY)=1
        GO TO 273
      ENDIF
  272 CONTINUE
      GO TO 275
C.....END OF SECTION TO FIND ZERO DISTANCE MODE.
  273 IF(IAND(INFO,1).GT.0)THEN
        HOPKM=GCDKM/NNOW
        WRITE(99,'(16h "INMUF3"  Nhop=,I1,3x,6hHopkm=,f6.0,7h  Mods=,
     1  I1,3X,A3)')NNOW,Hopkm,MODZ(1)(1:3),INUM
      ENDIF
  275 NUMMOD=0
      do 276 ilm=1,6
      if(HPMOD(ilm,k).lt.0.)go to 276
      NUMMOD=NUMMOD+1
  276 continue
      CALL REGMOD
      IF(IRESET.EQ.1)THEN
C.......RESTORE CIRCUIT MUF PARAMETERS
        DO 245 IL=1,3
        SIGL(IL)=OSIGL(IL)
        SIGU(IL)=OSIGU(IL)
        YFOT(IL)=OYFOT(IL)
        YHPF(IL)=OYHPF(IL)
  245   YMUF(IL)=OYMUF(IL)
      ENDIF
      RETURN
      END
C--------------------------------

c###regmod.for
      SUBROUTINE REGMOD
C---------------------------------
C
C     THIS ROUTINE FINDS ALL MODES FOR THE CURRENT FREQUENCY AND THE
C     DISTANCE FROM THE IONOGRAM (NO SPORADIC E MODES - SEE SUBROUTINE
C     ESMOD) THIS IS FOR A GIVEN HOP DISTANCE SET IN SUBROUTINE LUFFY
c
      common /gh_ipfg/ ipfg
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SXGU,SXGL,KJ,JK
      COMMON/SIGD/DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE,HNU
     A ,HTLOSS,XNUZ,XVE
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24),FOT
     A(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMUF(4)
     B ,HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     C ,YMUF(4)
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / ZON / ABPS(7), CREL(7), EFF(7), FLDST(7), GRLOS(7),
     1 HN(7), HP(7), PROB(7), RELY(7), RGAIN(7), SIGPOW(7), SN(7),
     2 SPRO(7), TGAIN(7), TIMED(7), TLOSS(7), B(7), FSLOS(7), ADV(7),
     3 OBF(7),NMODE(7),TLLOW(7),TLHGH(7)
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS
     A ,SPR,SU,SUS,XNOISE,ZNOISE,NF
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON /ES /FS (3, 5), HS (5)
      COMMON /MODES /GHOP, DELMOD (6, 3), HPMOD (6, 3), HTMOD (6, 3), FV
     1MOD (6, 3), ITMOD (6, 3), AFMOD (6, 3)
      COMMON /GEOG /GYZ (5), RAT (5), GMDIP (5), CLCK (5), ABIY (5), ART
     1IC (5), SIGPAT (5), EPSPAT (5)
      COMMON / RAYS / ANG(40), IFOB(40,30,5), NANG
      COMMON/INFORM/INFO,IHSHR,IHLNG
      DIMENSION LX(3)
      DATA LX/1,3,5/
C
C  TEMPORARILY FILL  A SELECTED MODES INTO COMMON/ZON
C  SHOULD DO THIS BY A EQUAL TAKEOFF ANGLE SEARCH IN COMMON/REFLX/
C  WILL USE  COMMON/MODES/ NOW. THIS IS A ONE SAMPLE AREA FOR CORRECT
C  DISTANCE  AT ALL SAMPLE AREAS. FOR A SHORT PATH THESE RESULTS ARE
C  CORRECT. MODES THAT GO ALL SAMPLE AREAS ARE GOOD. BUT SOME GOOD MODES
C  MAY BE MISSED THIS WAY.
C  SELECT SAMPLE AREA TO BE USED BY CRITICAL FREQUENCIES.
C  SET BY CALL TO SUBROUTINE SANG FROM SUBROUTINE LUFFY
C  RELATE 3 IONOSPHERES TO 5 SAMPLE AREAS

ccc      if(gcdkm.gt.10000. .and. mspec.eq.121) return
      K = JMODE
      L = LX(K)
C.....USE AVERAGE ABSORBTION INDEX FROM SUBROUTINE SIGDIS
      AC = 677.2 * ACAV
      BC = (FREQ + GYZ(L) ) ** 1.98
C.....IHOP IS THE NUMBER OF HOPS (GHOP IS FROM SUBROUTINE LUFFY)
      IHOP = GCD/GHOP  +.01
      HOP=IHOP
C  NOW ADD LOSSES
      DO 240 IM = 1,7
      ITRY =1
C.....PRESET IN COMMON/ZON/
      HN(IM) = -1.
      HP   (IM) = -1.
      IF(IM.ge.7) go to 240
      IF(ITRY.lt.1) go to 240
      IF(HPMOD(IM,K).le.0.) go to 240
C   FREE SPACE LOSS LOSS RELATIVE TO AN ISOTROPIC RADIATOR
      DEL = D2R * DELMOD (IM, K)
      DEL = AMIN1(DEL, 89.99*D2R)
      CDEL = COS (DEL)
      PSI = GHOP * 0.5
      PHE = PIO2 - PSI - DEL
      PATH = 2. * (HPMOD(IM,K) + RZ * (1. - COS(PSI))) / COS(PHE)
      PATH=ABS(PATH*HOP)
C.....TIME DELAY
      TIMED(IM)=PATH/VOFL
C.....FREE SPACE LOSSES
ccc      write(luo,1) im,timed(im),hop,path,gcdkm
ccc1     format('timed=',i5,4f15.5)
      FSLOS (IM) = 32.45 + 20.*ALOG10(PATH*FREQ)
      IF(FI(1,K) - FVMOD(IM,K))  125,106,106
C  D-E MODE
  106 CONTINUE
      IF(HTLOSS - HTMOD(IM,K) )  110,110,115
C.....XNSQ IS THE COLLISION FREQUENCY TERM
  110 XNSQ = 10.2
      GO TO 120
  115 HNUX= 61. + 3.*(HTMOD(IM,K) - 70.)/18.
      XNSQ=  XNUZ * EXP(- 2.*(HNUX-60.)/HNU)
  120 CONTINUE
C.....SECANT PHE FOR REFLECTION AREA - THE CLASSICAL HEIGHT OF 100 KM
C.....IS ASSUMED FOR HTMOD .GT. 100 KM
      HEFF = AMIN1( 100.,HTMOD(IM,K))
      SINP = RZ*CDEL/(RZ+ HEFF)
      SECP = 1./SQRT(1. -SINP*SINP)
      ABPS(IM) = SECP* AC/(BC + XNSQ)
C.....ABSORPTION LOSS BUT REMOVE E LAYER BENDING EFFECT
      XV = AMAX1( FVMOD(IM,K)/FI(1,K) , XVE)
      ADX =  AFE + BFE * ALOG(XV)
      SECP= 1./SIN(DEL +PSI)
       BCX = BC
C.....DEVIATION TERM FOR HIGH ANGLE RAYS, PLUS E LAYER BENDING EFFECT
      ADV(IM) = SECP*AFMOD(IM,K)*((FVMOD(IM,K)+GYZ(L))**1.98 + XNSQ)
     A          / (BCX + XNSQ ) + ADX
C.....SET ES OBSCURATION TO 0.0 FOR D - E MODES
      OBF(IM) = 0.0
      OBFU = 0.0
      OBFL = 0.0
      GO TO 160
C   F LAYER MODES
  125 CONTINUE
C.....COLLISION FREQUENCY TERM
C.....HTMOD .GT. 100KM FOR F LAYER
      XNSQ = 10.2
      SINP = RZ*CDEL/(RZ + 100.)
      SECP = 1./SQRT(1.-SINP*SINP)
C.....ABSORPTION LOSS
      ABPS(IM)= SECP*AC/(BC+ XNSQ)
      SECP = 1./SIN(DEL + PSI)
C.....DEVIATIVE LOSS TERM FOR HIGH ANGLE MODES
      ADV(IM) = SECP* AFMOD(IM,K)*((FVMOD(IM,K) +GYZ(L))**1.98 + XNSQ)
     A          /(BC + XNSQ)
C  ES OBSCURATION LOSS
      OBF(IM) = 0.0
      OBFU = 0.0
      OBFL = 0.0
      IF(FS(2,K).le.0.) go to 160
C.....FOR LOW FREQUENCIES, INCLUSION OF REGULAR E INTO SPORADIC E CAUSES
C.....PROBLEM, SEE ALSO SUBROUTINE SIGDIS
      FSDEAD = IFOB(1,3,K)
      FSDEAD = FSDEAD/1000.
      FSDEAD = AMIN1(FSDEAD,3.)
      FMHZ = AMAX1(FREQ,FSDEAD)
      SINS = RZ*CDEL/(RZ+ HS(K))
      SECS = 1./SQRT(1.- SINS*SINS)
C.....MEDIAN MUF FOR THIS HOP, NOT FOR THE PATH.
C.....PRBMUF IS THE PROBABILITY FUNCTION
C.....NOTE LIMIT ON LOSS
      ESD  = FS(2,K)*SECS
      DUMMY = YMUF(4)
      PROS = PRBMUF(FMHZ,ESD,DUMMY,4)
      PROS = AMIN1(PROS,.90)
      OBF(IM) = -10.*ALOG10(1.-PROS)
      ESD = FS(1,K)* SECS
C.....UPPER DECILE OBSCURATION AT ES FOT
      DUMMY = YFOT(4)
      PROS = PRBMUF(FMHZ,ESD,DUMMY,4)
      PROS = AMIN1( PROS, 0.90)
      OBFU= -10.*ALOG10(1.- PROS)
C.....LOWER DECILE OBSCURATION AT ES HPF
      DUMMY = YHPF(4)
      PROS = PRBMUF(FMHZ,ESD,DUMMY,4)
      PROS = AMIN1(PROS, 0.9)
      OBFL =  -10.*ALOG10(1.- PROS)
  160 CONTINUE
      Y = 0.0
      DO 185 IG = 1,KM
      IGX = - IG
      CALL GAIN(IGX,DEL,FREQ,YG,GEFF)
  185 Y = Y + YG
      XKM = KM
C.....AVERAGE GROUND LOSS
      GRLOS(IM) = Y / XKM
C  ANTENNA GAINS
C125PC      if(MSPEC.ne.125)then
C.......GAIN AT TRANSMITTER
        CALL GAIN(1,DEL,FREQ,DUMMY,TEFF)
        TGAIN(IM) = DUMMY
C.......GAIN AT RECEIVER
        CALL GAIN(2,DEL,FREQ,DUMMY1,DUMMY2)
        RGAIN(IM) = DUMMY1
        EFF(IM) = DUMMY2
C125PC      else
c.......set gains and EFF to 0. dB or unity
C125PC        tgain(im)=0.
C125PC        rgain(im)=0.
C125PC        EFF(im)=0.
C125PC      ENDIF
C.....NOTE ONLY 2 HOPS FOR THE OBSCURATION
      HOPS = AMIN1( HOP, 2.)
      XTLOS = FSLOS(IM) + HOP*(ABPS(IM)+ADV(IM)) + GRLOS(IM)*(HOP-1.)
     A  + HOPS*OBF(IM) + ASM - RGAIN(IM) - TGAIN(IM)
ccc      write(luo,123) xtlos,im,fslos(im),hop,abps(im),adv(im),grlos(im),
ccc     +               obf(im),asm
ccc123   format('xtlos=',f9.2,i4,7f9.2)
C.....BEGINNING OF TRANSMISSION LOSS DISTRIBUTION
      ISMOD = ITMOD(IM,K)
      SPHET = RZ * CDEL / (RZ + HTMOD(IM,K))
      CPHET = 1. - SPHET * SPHET
      CPHET = AMAX1(0.000001,CPHET)
      CPHET = SQRT(CPHET)
C.....MUF FOR THIS HOP DISTANCE
c%lc:gsp, change 1a     12 Jan 1995,                        subroutine  regmod
c%lc    "prob()" is the array to be printed as fdays in methods 16-23, and 
c%lc    "MODE PROB" in method 25.  This change is to base fdays on the specific
c%lc    hop muf, not path muf.  This change supercedes fdays code below.  See 
c%lc    change 1b.  Note: the code above for CPHET is problematic and does not
c%lc    give a correct "hop muf." It may be correct for its other uses, though.
c%lc    A better "hop muf" is calculated in this added code.  The original is 
c%lc    preserved for its original uses.
c%lc begin change 
      PSI = GCD/2.
      PSI=PSI/HOP
      CPSI = COS(PSI)
      SPSI = SIN(PSI)
      TANP = SPSI / (1. - CPSI + HPmuf(ismod) / RZ)
      PHE = ATAN(TANP)
      DEL = PIO2 - PHE - PSI
      CDEL = COS(DEL)
      SPHE = RZ*CDEL/(RZ+ HTmuf(ismod))
      xmuf=fvmuf(ismod)/sqrt(1.-sphe*sphe)
      DUMMY = YMUF(ISMOD)
      Prob(im) = PRBMUF(FREQ,XMUF,DUMMY,ISMOD)   !  this is MUFday
c          add more loss when MUFday gets very low but put a limit on it.
c          Extra loss goes from 0 to 24dB for MUFday .0001 to .0000001
c          this was added 11/11/2006 for problems posed by Jim Tabor
ccc      if(prob(im).le..000001) prob(im)=.000001       !  put a limit on low probability (GRH 5/12/2005)
      if(prob(im).lt..0001) then
      if(prob(im).le.0.) then
         write(*,1116) prob(im)
1116     format('prob(im)=',f10.3)
         write(*,1111) tlatd,tlongd,rlatd,rlongd,gcdkm
1111     format('lat,lon=',4f10.4,f10.2)
         write(*,1112) ipfg,mspec
1112     format('ipfg=',2i5)
         stop
      end if
         xfac=alog10(prob(im))
         if(xfac.gt.-4.) xfac=-4.
         if(xfac.lt.-7.) xfac=-7.
         ghlos=(xfac+4.)*8.
         xtlos=xtlos-ghlos
      end if
c%lc. end change 1a
      XMUF = FVMUF(ISMOD)/CPHET
      DUMMY = YMUF(ISMOD)
ccc      write(luo,'(''before prbmuf='',3f12.6,i5)') freq,xmuf,dummy,ismod
      P = PRBMUF(FREQ,XMUF,DUMMY,ISMOD)
      if(p.le..000001) p=.000001         !  put a limit on low probability (GRH 5/12/2005)
      XLS =  -10.*ALOG10(P)/CPHET
ccc      write(luo,'(''xls='',3f12.6)') xls,p,cphet
      IF(IAND(INFO,2).GT.0)THEN
        XRAT=XMUF/DUMMY
        XLSWO=XLS*CPHET
        WRITE(99,'(13h "REGMOD" LY=,I1,19h FRQ,XMUF,YMUF,RAT=,3F6.2,
     1  F5.2,11h  OTMs,OTM=,2F6.2)')ISMOD,FREQ,XMUF,DUMMY,XRAT,XLS,XLSWO
      ENDIF
C.....MEDIAN
      XTLOS = XTLOS + XLS*HOP
ccc      write(luo,'(''xtlos='',3f10.3)') xtlos,xls,hop
      CPR = FVMUF(ISMOD)/YMUF(ISMOD)
      FVFOT = YFOT(ISMOD)* CPR
      XMUF  = FVFOT/ CPHET
      DUMMY = YFOT(ISMOD)
      PF = PRBMUF(FREQ,XMUF,DUMMY,ISMOD)
      if(pf.le..000001) pf=.000001       !  put a limit on low probability (GRH 5/12/2005)
      XLSL = -10.*ALOG10(PF)/CPHET
      FVHPF = YHPF(ISMOD)*CPR
      XMUF  =  FVHPF/CPHET
      DUMMY = YHPF(ISMOD)
      PF = PRBMUF(FREQ,XMUF,DUMMY,ISMOD)
      if(pf.le..000001) pf=.000001       !  put a limit on low probability (GRH 5/12/2005)
      XLSU = -10.*ALOG10(PF)/CPHET
      IF(IAND(INFO,2).GT.0)THEN
        XLSLWO=XLSL*CPHET
        XLSUWO=XLSU*CPHET
        WRITE(99,'(2(5X,A,2F7.2))')'L-DECILE} OTMs,OTM=',XLSL,XLSLWO,
     1 'U-DECILE} OTMs,OTM=',XLSU,XLSUWO
      ENDIF
C
C DECILES OF SIGNAL LEVEL
C
c%lc:gsp, comment change 12 Jan 1995,                      subroutine  regmod
c%lc Despite the name, tllow is the signal level - lower decile; tlhgh is the
c%lc signal level - upper decile.
      TLLOW(IM) =  DSL + HOPS *(OBFL-OBF(IM)) + HOP*(XLSL - XLS)
      TLHGH(IM) =  DSU + HOPS *(OBF(IM)-OBFU) + HOP*(XLS  - XLSU)
      TLLOW(IM) = AMIN1(TLLOW(IM) , 25.)
      TLHGH(IM) = AMIN1(TLHGH(IM) , 25.)
C.....ENDING OF TRANSMISSION LOSS DISTRIBUTION
C
C.....THIS IS F.DAYS (NOT USED ELSEWHERE)
c%lc:gsp, change 1b     12 Jan 1995,                       subroutine  regmod
c%lc      the next two lines have been superceded by change 1a above.
c%lc            DUMMY = YMUF(ISMOD)
c%lc            PROB(IM) = PRBMUF(FREQ,DUMMY,DUMMY,ISMOD)
c%lc. end change 1b
      ITRY = -1
      TLOSS (IM) = XTLOS
C.....FLDST(IM) IS FIELD STRENGTH
C.....SIGPOW(IM) IS SIGNAL
C.....SN(IM) IS SIGNAL TO NOISE
C.....B(IM) IS RADIATION ANGLE
C.....NMODE(IM) IS MODE
C.....HP(IM) IS VIRTUAL HEIGHT
C.....HN(IM) IS NUMBER OF HOPS
      if(freq.le.0.) then
         write(*,1117) freq
1117     format('freq=',f10.3)
         stop
      end if
      FLDST(IM) = 107.2 + PWRDB(FREQ) + 20.*ALOG10(FREQ)-XTLOS-RGAIN(IM)
      SIGPOW (IM) = PWRDB(FREQ) - XTLOS
C------------    CHANGED 9/24/91  (LONG PATH RCVR EFF CORRECTION)  FJR
C------------          SN(IM) = SIGPOW(IM) - RCNSE
      SN(IM) = SIGPOW(IM) - RCNSE - EFF(IM)
      B (IM) = DELMOD(IM,K)
      NMODE(IM) = ISMOD
      HP(IM) = HPMOD(IM,K)
      HN(IM)   = IHOP
  240 CONTINUE
      RETURN
      END
C--------------------------------

      subroutine distxy(idistance,ndistance,
     +    tlat,tlon,rlat_dist,rlon_dist,npsl,rlatd,rlongd)
      COMMON /AZEL/ ZTLAT,ZTLON,ZTHT,ZRLAT,ZRLON,ZRHT,ZTAZ,ZRAZ,
     +              ZTELV,ZRELV,ZD,ZDGC,ZTAKOF,ZRAKOF
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
c**********************************************************************
      ZTLAT=tlat*R2D
      ZTLON=tlon*R2D
      ZRLAT=rlat_dist*R2D
      ZRLON=rlon_dist*R2D
      if(idistance.eq.1) then       !  Set Rx to Tx
         rlatd=ZRLAT
         rlongd=ZRLON
      else if(idistance.eq.ndistance) then    !  Set Rx to original Rx
         rlatd=ZTLAT
         rlongd=ZTLON
      else                               !  interpolate in between
         call dazel(0)             !  distance Tx to Rx
         zdgc=zdgc*float(ndistance-idistance)/float(ndistance-1)
         call dazel(1)             !  calc new Rx
         rlatd=ZRLAT
         rlongd=ZRLON
      end if
c          fix up RLONG so it is between 0 & 360.
      if(rlongd.lt.0.) rlongd=rlongd+360.
      if(rlongd.gt.360.) rlongd=rlongd-360.
      RETURN
      END
C------------------------------------------------------------------

c###settxr.for
      SUBROUTINE SETTXR
c***********************************************
c          Alex Shovkoplyas made some changes to:
c             curmuf
c             seltxr
c             settxr
c             sigdis
c          Normally if the version (..\database\version.w32)
c             is yy.mmddW then the original version is used.
c                yy.mmddA then Alex's version is used.
c***********************************************
      use cversn
c      common /CVERSN/ VERSN
c      character VERSN*8
      if(versn(8:8).eq.'A' .or. versn(8:8).eq.'a') then
         call settxr_alex       !  use Alex's modified version
      else
         call settxr_orig       !  use original version
      end if
      return
      end
C--------------------------------
      SUBROUTINE SETTXR_orig
C--------------------------------
C------------ SUBROUTINES SETRCR AND SETTMT COMBINED  1/10/91 FJR
C
C     THIS SUBROUTINE CALCULATES THE LOSSES, ETC. FOR ALL
C     MODES AT THE TRANSMITTER/RECEIVER END
C
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
      COMMON/ES/FS(3,5),HS(5)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/GEOG/GYZ(5),RAT(5),GMDIP(5),CLCK(5),ABIY(5),ARTIC(5),SIGPAT
     A (5),EPSPAT(5)
      COMMON/LOSX/ANDVX(45,3),ADVX(45,3),AOFX(45,3),ARFX(45,3),GRLOSX(45
     A ,3),TGAINX(45,3),TLSKM(45,3),EFFlp(45),IAFTXR(3)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24)
     A ,ALLMUF(24),FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4)
     B ,SIGU(4),DELMUF(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4)
     C ,YFOT(4),YHPF(4),YMUF(4)
      COMMON/SIGD/DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE,HNU
     A ,HTLOSS,XNUZ,XVE
      COMMON/RAYS/ANG(40),IFOB(40,30,5),NANG
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / allMODE /ABPS(20),CREL(20),FLDST(20),HN(20),HP(20),
     1PROB(20),RELY(20),RGAIN(20),SIGPOW(20),SN(20),
     2SPRO(20),TGAIN(20),TIMED(20),TLOSS(20),B(20),FSLOS(20),
     3grlos(20),adv(20),obf(20),
     CNMODE(20),TLLOW(20),TLHGH(20),EFF(20),NREL,NMMOD
C125PC      common/lpalmcmp/imddl(45,2,11,24,4,2),igdfx(45,2,11,24,4,2),
C125PC     +itlos(45,2,11,24,4,2),ihpfx(45,2,11,24,4,2),lNANG(2,11,24,4,2)
C125PC      integer*2 imddl,igdfx,itlos,ihpfx,lNANG
      COMMON/INFORM/INFO,IHSHR,IHLNG
C125PC      COMMON/INDICEZ/ISP,ISZ,IFQN,IUR,NMS(11,24,4,2)
c----------------------------------------------------------------
C.....FOR MAX. NUMBER OF HOPS
      DEND = AMIN1(4000.,GCDKM)
ccc      write(12,'(''amind='',f10.5)') amind
      DO 1000 JJ=1,2
      ILN=0
      K = ITXRCP(JJ)
      DO 10 IA=1,45
      GML(IA,K)=-999.
   10 FHP(IA,K)=999.
      DO 80 IA = 1,45
C.....DOES THE MODE EXIST (QUESTION MARK)
      IF(HPFLX(IA,K) - 70. ) 90,75,75
C.....NUMBER OF HOPS
   75 XHPM = DEND/GDFLX(IA,K)
C.....MUST HAVE AT LEAST ONE FOR SHORT PATHS
      IF( XHPM - 0.9) 80, 76, 76
   76 IF(DELFX(IA,K) - AMIND) 80, 95, 95
   80 CONTINUE
   90 CONTINUE
C  PENETRATED LAYER, TRY OVER THE MUF MODE.
C.....SO IF NONE FAILS, INCLUDE OVER-THE-MUF
      IM = MODMUF
      DELFX(1,K) = DELMUF(IM)
      HPFLX(1,K) = HPMUF (IM)
      HTFLX(1,K) = HTMUF (IM)
      FVFLX(1,K) = FVMUF (IM)
      AFFLX(1,K) = AFMUF (IM)
      XHOP = NHOPMF(IM)
      GDFLX(1,K) = GCDKM/XHOP
      IMODE(1,K) = MODMUF
   95 CONTINUE
      BC = (FREQ+ GYZ(K))**1.98
      AC = 677.2*ABIY(K)
      DO 250 IA = 1,45
C.....PRESET ARRAYS
      TGAINX(IA,K) = -10.
      ANDVX(IA,K) = 1000.
      ADVX (IA,K) = 1000.
      GRLOSX(IA,K) = 0.0
C.....MODE GOOD (QUESTION MARK)  ONE IS.
ccc      write(12,14) ia,k,hpflx(ia,k),delfx(ia,k)
ccc14    format('ia,k,hpflx,delfx=',2i5,2f10.4)
      IF(HPFLX(IA,K).lt.70.) go to 250
C.....CHECK FOR MINIMUM
      IF(DELFX(IA,K).lt.AMIND) go to 250
      DEL = DELFX(IA,K) * D2R      !  radiation angle
      CDEL = COS(DEL)
C.....E MODE (QUESTION MARK)
      IF(FI(1,K).lt.FVFLX(IA,K) ) go to 125
C  D-E  LAYER MODES.
C.....VERY LOW REFLECTIONS (QUESTION MARK)
      IF(HTLOSS.le.HTFLX(IA,K)) then
         XNSQ = 10.2
      else
         HNUX = 61.+ 3.*(HTFLX(IA,K)- 70.)/18.
C.....COLLISION FREQUENCY
         XNSQ = XNUZ * EXP(-2.*(HNUX -60.)/HNU)
      end if
      HEFF = AMIN1(100.,HTFLX(IA,K))
      SINP = RZ* CDEL/(RZ+ HEFF)
      SECP = 1./SQRT(1.- SINP*SINP)
C.....ABSORPTION LOSS
      ANDVX(IA,K)= SECP *AC /(BC +XNSQ)
      XV = AMAX1(FVFLX(IA,K)/FI(1,K) , XVE)
C.....CORRECTION FOR E LAYER
      ADX= AFE + BFE* ALOG(XV)
      SINP = RZ*CDEL/(RZ +HPFLX(IA,K))
      SECP = 1./SQRT(1.-SINP*SINP)
C.....DEVIATIVE LOSS + CORRECTION
      ADVX(IA,K) = SECP*AFFLX(IA,K)*( ( FVFLX(IA,K)+GYZ(K))**1.98 +XNSQ)
     A            /(BC+ XNSQ)   +ADX
C.....ES OBSCURATION, NONE
      AOFX(IA,K) = 0.0
      GO TO 160
C  F LAYER MODES
  125 CONTINUE
      XNSQ = 10.2
      SINP = RZ*CDEL/(RZ +100.)
      SECP = 1./SQRT(1. -SINP*SINP)
C.....ABSORPTION LOSS
      ANDVX(IA,K) = SECP*AC/(BC+ XNSQ)
      SINP = RZ* CDEL/(RZ +HPFLX(IA,K))
      SECP = 1./SQRT(1. -SINP*SINP)
C.....DEVIATIVE LOSS
      ADVX(IA,K) = SECP*AFFLX(IA,K)*((FVFLX(IA,K)+GYZ(K))**1.98 +XNSQ)
     A            /(BC+ XNSQ)
C  ES OBSCURTION LOSS
      AOFX(IA,K) =0.0
C.....SPORADIC E EXISTS (QUESTION MARK)
      IF(FS(2,K).le.0.) go to 160
      FSDEAD =IFOB(1,3,K)
      FSDEAD =FSDEAD/1000.
      FMHZ = AMAX1(FREQ,FSDEAD)
      SINS = RZ*CDEL/(RZ + HS(K) )
      SECS = 1./SQRT(1.-SINS*SINS)
C.....MUF THIS DISTANCE
      ESD  = FS(2,K)*SECS
      DUMMY = YMUF(4)
      P = PRBMUF(FMHZ,ESD,DUMMY,4)
      P = AMAX1(.1,P)
      P = AMIN1(.9,P)
C.....OBSCURATION
      AOFX(IA,K) = -10.*ALOG10(1.-P)
  160 CONTINUE
C GROUND LOSS
      Y = 0.0
      DO 170 IG = 1,KM
      IGX = -IG
      CALL GAIN(IGX,DEL,FREQ,YG,GEFF)
  170 Y = Y + YG
      XKM = KM
C.....AVERAGE GROUND LOSS
      GRLOSX(IA,K) = Y / XKM
C ANTENNA GAINS
C125PC      IF(MSPEC.EQ.125)THEN
C125PC        TGAINX(IA,K) =0.
C125PC      ELSE
        CALL GAIN(JJ,DEL,FREQ,Y,TEFF)
        TGAINX(IA,K) =Y
        if(JJ.eq.2)EFFlp(ia)=TEFF
C125PC      ENDIF
      SPHET = RZ * CDEL / (RZ + HTFLX(IA,K))
      CPHET = 1.-SPHET*SPHET
      CPHET = AMAX1(0.00000001,CPHET)
      CPHET = SQRT(CPHET)
C-----?????????????????
      IS = IMODE(IA,K)
      IS = MODMUF
C-----?????????????????
      DUMMY = YMUF(IS)
      PROS = PRBMUF(FREQ,DUMMY,DUMMY,IS)
C.....OVER-THE-MUF, MEDIAN
      XLS = -10.*ALOG10(PROS)/CPHET
      IF(IAND(INFO,2).GT.0)THEN
        XLSWO=XLS*CPHET
        WRITE(99,'(2(A,I2),A,2F7.2,A,2F7.2)')' "SETTXR" LAY=',IS,
     1'  IA=',IA,'  FRQ,YMUF=',FREQ,DUMMY,'   MD OTMs,OTM=',XLS,
     2  XLSWO
      ENDIF
C ADD ADJUSTMENT TO ABSORPTION LOSS
      ANDVX(IA,K) = ANDVX(IA,K) + XLS
      PROB(JJ) = PROS
      ILN=ILN+1
C125PC      IF(MSPEC.EQ.125)THEN
C125PC      itlos(ILN,JJ,IFQN,IUR,ISZ,ISP)=(andvx(ia,k)+advx(ia,k)+.05)*10.
C125PC      imod=IMODE(ia,k)
C125PC      imddl(ILN,JJ,IFQN,IUR,ISZ,ISP)=imod*10000+(delfx(ia,k)+.05)*10.
C125PC      ihpfx(ILN,JJ,IFQN,IUR,ISZ,ISP)=(hpflx(ia,k)+.05)*10.
C125PC      igdfx(ILN,JJ,IFQN,IUR,ISZ,ISP)=(GDFLX(IA,K)+.5)
C125PC      ENDIF
  250 CONTINUE
C125PC      IF(MSPEC.EQ.125)LNANG(JJ,IFQN,IUR,ISZ,ISP)=ILN
 1000 CONTINUE
      RETURN
      END
C--------------------------------
c###settxr.for
      SUBROUTINE SETTXR_alex
C--------------------------------
C------------ SUBROUTINES SETRCR AND SETTMT COMBINED  1/10/91 FJR
C
C     THIS SUBROUTINE CALCULATES THE LOSSES, ETC. FOR ALL
C     MODES AT THE TRANSMITTER/RECEIVER END
C
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
      COMMON/ES/FS(3,5),HS(5)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/GEOG/GYZ(5),RAT(5),GMDIP(5),CLCK(5),ABIY(5),ARTIC(5),SIGPAT
     A (5),EPSPAT(5)
      COMMON/LOSX/ANDVX(45,3),ADVX(45,3),AOFX(45,3),ARFX(45,3),GRLOSX(45
     A ,3),TGAINX(45,3),TLSKM(45,3),EFFlp(45),IAFTXR(3)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24)
     A ,ALLMUF(24),FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4)
     B ,SIGU(4),DELMUF(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4)
     C ,YFOT(4),YHPF(4),YMUF(4)
      COMMON/SIGD/DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE,HNU
     A ,HTLOSS,XNUZ,XVE
      COMMON/RAYS/ANG(40),IFOB(40,30,5),NANG
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / allMODE /ABPS(20),CREL(20),FLDST(20),HN(20),HP(20),
     1PROB(20),RELY(20),RGAIN(20),SIGPOW(20),SN(20),
     2SPRO(20),TGAIN(20),TIMED(20),TLOSS(20),B(20),FSLOS(20),
     3grlos(20),adv(20),obf(20),
     CNMODE(20),TLLOW(20),TLHGH(20),EFF(20),NREL,NMMOD
C125PC      common/lpalmcmp/imddl(45,2,11,24,4,2),igdfx(45,2,11,24,4,2),
C125PC     +itlos(45,2,11,24,4,2),ihpfx(45,2,11,24,4,2),lNANG(2,11,24,4,2)
C125PC      integer*2 imddl,igdfx,itlos,ihpfx,lNANG
      COMMON/INFORM/INFO,IHSHR,IHLNG
C125PC      COMMON/INDICEZ/ISP,ISZ,IFQN,IUR,NMS(11,24,4,2)
c----------------------------------------------------------------
c>>>>>A.S.
      DIMENSION LX(3)
      DATA LX/1,3,5/
      LOGICAL FOUND
c<<<<<       
C.....FOR MAX. NUMBER OF HOPS
      DEND = AMIN1(4000.,GCDKM)
ccc      write(12,'(''amind='',f10.5)') amind
      DO 1000 JJ=1,2
      ILN=0
      K = ITXRCP(JJ)
      DO 10 IA=1,45
      GML(IA,K)=-999.
   10 FHP(IA,K)=999.
   
c>>>>>A.S.
c     check if any good modes exist
c     mark bad modes with HPFLX = 0
      FOUND = .FALSE.
      DO 80 IA = 1,45
      IF(IA .GT. IAFTXR(K)) GOTO 75                  !end of HPFLX reached
      IF(HPFLX(IA,K) .LT. 70) GOTO 75                !end of HPFLX reached
      IF(DELFX(IA,K) .LT. AMIND) GOTO 75             !below the minimum angle 
      IF((DEND/GDFLX(IA,K) - 0.9) .LT. 0) GOTO 75    !less than one hop
c     good mode
      FOUND = .TRUE.
      GOTO 80 
c     bad mode      
   75 HPFLX(IA,K) = 0 
   80 CONTINUE
      if (FOUND) GOTO 95
c<<<<<       
C  PENETRATED LAYER, TRY OVER THE MUF MODE.
C.....SO IF NONE FAILS, INCLUDE OVER-THE-MUF
      IM = MODMUF
      DELFX(1,K) = DELMUF(IM)
      HPFLX(1,K) = HPMUF (IM)
      HTFLX(1,K) = HTMUF (IM)
      FVFLX(1,K) = FVMUF (IM)
      AFFLX(1,K) = AFMUF (IM)
      XHOP = NHOPMF(IM)
      GDFLX(1,K) = GCDKM/XHOP
      IMODE(1,K) = MODMUF
   95 CONTINUE
c>>>>>A.S. 
      BC = (FREQ+ GYZ(LX(K)))**1.98
c<<<<< 
      AC = 677.2*ABIY(K)
      DO 250 IA = 1,45
C.....PRESET ARRAYS
      TGAINX(IA,K) = -10.
      ANDVX(IA,K) = 1000.
      ADVX (IA,K) = 1000.
      GRLOSX(IA,K) = 0.0
C.....MODE GOOD (QUESTION MARK)  ONE IS.
ccc      write(12,14) ia,k,hpflx(ia,k),delfx(ia,k)
ccc14    format('ia,k,hpflx,delfx=',2i5,2f10.4)
      IF(HPFLX(IA,K).lt.70.) go to 250
C.....CHECK FOR MINIMUM
c>>>>>A.S. 
c      this line was causing problems and has been removed
c      no need to check DELFX 
c      since all bad modes now have HPFLX = 0
c      IF(DELFX(IA,K).lt.AMIND) go to 250
c<<<<<       
      DEL = DELFX(IA,K) * D2R      !  radiation angle
      CDEL = COS(DEL)
C.....E MODE (QUESTION MARK)
      IF(FI(1,K).lt.FVFLX(IA,K) ) go to 125
C  D-E  LAYER MODES.
C.....VERY LOW REFLECTIONS (QUESTION MARK)
      IF(HTLOSS.le.HTFLX(IA,K)) then
         XNSQ = 10.2
      else
         HNUX = 61.+ 3.*(HTFLX(IA,K)- 70.)/18.
C.....COLLISION FREQUENCY
         XNSQ = XNUZ * EXP(-2.*(HNUX -60.)/HNU)
      end if
      HEFF = AMIN1(100.,HTFLX(IA,K))
      SINP = RZ* CDEL/(RZ+ HEFF)
      SECP = 1./SQRT(1.- SINP*SINP)
C.....ABSORPTION LOSS
      ANDVX(IA,K)= SECP *AC /(BC +XNSQ)
      XV = AMAX1(FVFLX(IA,K)/FI(1,K) , XVE)
C.....CORRECTION FOR E LAYER
      ADX= AFE + BFE* ALOG(XV)
      SINP = RZ*CDEL/(RZ +HPFLX(IA,K))
      SECP = 1./SQRT(1.-SINP*SINP)
C.....DEVIATIVE LOSS + CORRECTION
c>>>>>A.S. 
      ADVX(IA,K) = SECP*AFFLX(IA,K)*( ( FVFLX(IA,K)+GYZ(LX(K)))**1.98
     A +XNSQ) /(BC+ XNSQ)   +ADX
c<<<<< 
C.....ES OBSCURATION, NONE
      AOFX(IA,K) = 0.0
      GO TO 160
C  F LAYER MODES
  125 CONTINUE
      XNSQ = 10.2
      SINP = RZ*CDEL/(RZ +100.)
      SECP = 1./SQRT(1. -SINP*SINP)
C.....ABSORPTION LOSS
      ANDVX(IA,K) = SECP*AC/(BC+ XNSQ)
      SINP = RZ* CDEL/(RZ +HPFLX(IA,K))
      SECP = 1./SQRT(1. -SINP*SINP)
C.....DEVIATIVE LOSS
c>>>>>A.S. 
      ADVX(IA,K) = SECP*AFFLX(IA,K)*((FVFLX(IA,K)+GYZ(LX(K)))**1.98 
     A +XNSQ)/(BC+ XNSQ)
c<<<<< 
C  ES OBSCURTION LOSS
      AOFX(IA,K) =0.0
C.....SPORADIC E EXISTS (QUESTION MARK)
      IF(FS(2,K).le.0.) go to 160
      FSDEAD =IFOB(1,3,K)
      FSDEAD =FSDEAD/1000.
      FMHZ = AMAX1(FREQ,FSDEAD)
      SINS = RZ*CDEL/(RZ + HS(K) )
      SECS = 1./SQRT(1.-SINS*SINS)
C.....MUF THIS DISTANCE
      ESD  = FS(2,K)*SECS
      DUMMY = YMUF(4)
      P = PRBMUF(FMHZ,ESD,DUMMY,4)
      P = AMAX1(.1,P)
      P = AMIN1(.9,P)
C.....OBSCURATION
      AOFX(IA,K) = -10.*ALOG10(1.-P)
  160 CONTINUE
C GROUND LOSS
      Y = 0.0
      DO 170 IG = 1,KM
      IGX = -IG
      CALL GAIN(IGX,DEL,FREQ,YG,GEFF)
  170 Y = Y + YG
      XKM = KM
C.....AVERAGE GROUND LOSS
      GRLOSX(IA,K) = Y / XKM
C ANTENNA GAINS
C125PC      IF(MSPEC.EQ.125)THEN
C125PC        TGAINX(IA,K) =0.
C125PC      ELSE
        CALL GAIN(JJ,DEL,FREQ,Y,TEFF)
        TGAINX(IA,K) =Y
        if(JJ.eq.2)EFFlp(ia)=TEFF
C125PC      ENDIF
      SPHET = RZ * CDEL / (RZ + HTFLX(IA,K))
      CPHET = 1.-SPHET*SPHET
      CPHET = AMAX1(0.00000001,CPHET)
      CPHET = SQRT(CPHET)
C-----?????????????????
      IS = IMODE(IA,K)
      IS = MODMUF
C-----?????????????????
      DUMMY = YMUF(IS)
      PROS = PRBMUF(FREQ,DUMMY,DUMMY,IS)
C.....OVER-THE-MUF, MEDIAN
      XLS = -10.*ALOG10(PROS)/CPHET
      IF(IAND(INFO,2).GT.0)THEN
        XLSWO=XLS*CPHET
        WRITE(99,'(2(A,I2),A,2F7.2,A,2F7.2)')' "SETTXR" LAY=',IS,
     1'  IA=',IA,'  FRQ,YMUF=',FREQ,DUMMY,'   MD OTMs,OTM=',XLS,
     2  XLSWO
      ENDIF
C ADD ADJUSTMENT TO ABSORPTION LOSS
      ANDVX(IA,K) = ANDVX(IA,K) + XLS
      PROB(JJ) = PROS
      ILN=ILN+1
C125PC      IF(MSPEC.EQ.125)THEN
C125PC      itlos(ILN,JJ,IFQN,IUR,ISZ,ISP)=(andvx(ia,k)+advx(ia,k)+.05)*10.
C125PC      imod=IMODE(ia,k)
C125PC      imddl(ILN,JJ,IFQN,IUR,ISZ,ISP)=imod*10000+(delfx(ia,k)+.05)*10.
C125PC      ihpfx(ILN,JJ,IFQN,IUR,ISZ,ISP)=(hpflx(ia,k)+.05)*10.
C125PC      igdfx(ILN,JJ,IFQN,IUR,ISZ,ISP)=(GDFLX(IA,K)+.5)
C125PC      ENDIF
  250 CONTINUE
C125PC      IF(MSPEC.EQ.125)LNANG(JJ,IFQN,IUR,ISZ,ISP)=ILN
 1000 CONTINUE
      RETURN
      END
C--------------------------------

C SUBROUTINE SIM              (NEXT)
      SUBROUTINE SIM
C 
C     SIM - CALCULATES THE MUTUAL IMPEDANCE BETWEEN LINEAR PARALLEL 
C        DIPOLE ELEMENTS OF UNEQUAL LENGTHS.
C     SEE THE REFERENCES IN SUBROUTINE GAIN.
C 
      COMMON /HFMUFES_ONE /D1D (20), ELL (20), NMX, NO, ZS (20) 
C 
      COMPLEX CSZ1, ZS
C 
C.......................................................................
      IF (NO .LT. 1) GO TO 105
      DO 100 J = 1, NO
      DJJ = D1D (J) 
      DJS = DJJ * * 2 
      HS = ELL (NMX) + ELL (J)
      HD = ELL (NMX) - ELL (J)
      CW1 = COS (HS)
      CW2 = COS (HD)
      SW1 = SIN (HS)
      SW2 = SIN (HD)
      TT = SQRT (DJS + HS * * 2)
      UZ = TT - HS
      VZ = TT + HS
      TT = SQRT (DJS + HD * * 2)
      UZP = TT - HD 
      VZP = TT + HD 
      TT = SQRT (DJS + ELL (NMX) * * 2) 
      U1 = TT - ELL (NMX) 
      V1 = TT + ELL (NMX) 
      TT = SQRT (DJS + ELL (J) * * 2) 
      U2 = TT - ELL (J) 
      V2 = TT + ELL (J) 
      ZS (J) = (CSZ1 (UZ) - CSZ1 (U1) - CSZ1 (U2)) * CMPLX (CW1, - SW1) 
     1+ (CSZ1 (VZ) - CSZ1 (V1) - CSZ1 (V2)) * CMPLX (CW1, SW1) + (CSZ1 (
     2UZP) - CSZ1 (U1) - CSZ1 (V2)) * CMPLX (CW2, - SW2) + (CSZ1 (VZP) -
     3 CSZ1 (V1) - CSZ1 (U2)) * CMPLX (CW2, SW2) + 2.0 * CSZ1 (DJJ) * (C
     4W1 + CW2) 
 100  ZS (J) = ZS (J) * 60.0 / (CW2 - CW1)
 105  CONTINUE
      RETURN
      END

c###gphbod.for
      SUBROUTINE GPHBOD
C--------------------------------
C
C     THIS ROUTINE CREATES LINE PRINTER GRAPHS OF THE VARIABLES SET IN
C     SUBROUTINE SETGPH -THE GRAPHS OUTPUT DEPEND ON METHOD BUT THE
C     USER MAY SPECIFY ADDITIONAL GRAPHS VIA THE "OUTGRAPH" CONTROL CARD
C
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON / OUTGH / PLOTI(24), PLOTJ(24), PLOTK(24), XOUT(13), NPLOTS
      COMMON / OUTLAB / LABEL(11), LAYTYP(5), IEAST, INORTH, ISOUTH,
     A IWEST, LABLI, LABLJ, LABLK
      CHARACTER IEAST*1, ISOUTH*1, INORTH*1, IWEST*1, LABEL*5, LAYTYP*2,
     A LABLI*5, LABLJ*5, LABLK*5
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      CHARACTER IHR(40)*2, IBLANK*6, ISYMBL*6, JSYMBL*6, KSYMBL*6,
     A ICHARS*6, JCHARS*6, KCHARS*6, NDASH*1, LTIME*4, ICHAR*6, JCHAR*6,
     B KCHAR*6, LIN(25)*6
      DATA IHR/'40','  ','38','  ','36','  ','34','  ','32','  ','30',
     A    '  ','28','  ','26','  ','24','  ','22','  ','20','  ','18',
     2    '  ','16','  ','14','  ','12','  ','10','  ','08','  ','06',
     3    '  ','04','  ','02','  '/
      DATA IBLANK/'      '/, ISYMBL/'.     '/, JSYMBL/'X     '/,
     A KSYMBL/'+     '/, NHR/24/
      DATA ICHARS/'(....)'/, JCHARS/'(XXXX)'/, KCHARS/'(++++)'/,
     A NDASH/'-'/, LTIME/' GMT'/, ONE/-.99/, NHRP1/25/
      JOUT = LUO
      ICHAR = ICHARS
      JCHAR = JCHARS
      KCHAR = KCHARS
C.....CHECK THE NUMBER OF VARIABLES TO PLOT
      IF(NPLOTS) 110, 110, 120
  110 LABLI = IBLANK
      LABLJ = IBLANK
      LABLK = IBLANK
      GO TO 710
C.....PRINT TOP SCALES
  120 IF(NPLOTS - 2) 122, 124, 126
  122 JCHAR = IBLANK
      KCHAR = IBLANK
      GO TO 126
  124 KCHAR = IBLANK
  126 WRITE(JOUT,1500) LABLI, ICHAR, LABLJ, JCHAR, LABLK, KCHAR
      WRITE(JOUT,1508)
      WRITE(JOUT,1510)
      ZOB2 = 40.5
      IT = 1
      DO 700 IDN = 1, 40
C.....BLANK OUT THE CURRENT LINE
      DO 130 ICR = 1,NHRP1
  130 LIN(ICR) = IBLANK
      ZOB1 = ZOB2
      ZOB2 = ZOB1 - 1.
C.....SET PLOTTING SYMBOL FOR THE FIRST VARIABLE
      DO 170 ICR = 1,NHR
      IF(PLOTI(ICR) - ONE) 170, 170, 140
  140 IF(PLOTI(ICR) - ZOB1) 150, 150, 170
  150 IF(PLOTI(ICR) - ZOB2) 170, 170, 160
  160 ICRP1 = ICR + 1
      LIN(ICRP1) = ISYMBL
      IF(ICR - NHR) 170, 165, 170
  165 LIN(1) = ISYMBL
  170 CONTINUE
C.....SET PLOTTING SYMBOL FOR THE SECOND VARIABLE
      IF(NPLOTS - 2) 280, 180, 180
  180 DO 220 ICR = 1,NHR
      IF(PLOTJ(ICR) - ONE) 220, 220, 190
  190 IF(PLOTJ(ICR) - ZOB1) 200, 200, 220
  200 IF(PLOTJ(ICR) - ZOB2) 220, 220, 210
  210 ICRP1 = ICR + 1
      LIN(ICRP1) = JSYMBL
      IF(ICR - NHR) 220, 215, 220
  215 LIN(1) = JSYMBL
  220 CONTINUE
C.....SET PLOTTING SYMBOL FOR THE THIRD VARIABLE
      IF(NPLOTS - 3) 280, 230, 230
  230 DO 270 ICR = 1,NHR
      IF(PLOTK(ICR) - ONE) 270, 270, 240
  240 IF(PLOTK(ICR) - ZOB1) 250, 250, 270
  250 IF(PLOTK(ICR) - ZOB2) 270, 270, 260
  260 ICRP1 = ICR + 1
      LIN(ICRP1) = KSYMBL
      IF(ICR - NHR) 270, 265, 270
  265 LIN(1) = KSYMBL
  270 CONTINUE
C.....CONTROL OUTPUT ACCORDING TO LINE NUMBER
  280 IF(IDN - 5) 310, 320, 290
  290 IF(IDN - 7) 310, 330, 300
  300 IF(IDN - 30) 330, 330, 310
C.....PRINT GRAPH ONLY
  310 WRITE(JOUT,1512) IHR(IDN), LIN, IHR(IDN)
      GO TO 700
C.....PRINT THE GRAPHS AND THE HEADINGS
  320 WRITE(JOUT,1514) IHR(IDN),LIN,IHR(IDN),LTIME,LABLI,LABLJ,LABLK
      GO TO 700
C.....PRINT THE GRAPH AND THE VARIABLES
  330 IF(NHR - IT) 310, 332, 332
  332 IF(UTIME(IT)) 334, 336, 336
  334 IT = IT + 1
      GO TO 330
  336 IF(NPLOTS - 2) 340, 370, 440
C.....PLOT AND PRINT ONE VARIABLE
  340 IF(PLOTI(IT) - ONE) 350, 350, 360
  350 WRITE(JOUT,1515) IHR(IDN),LIN,IHR(IDN),UTIME(IT),NDASH
      GO TO 600
  360 WRITE(JOUT,1516) IHR(IDN),LIN,IHR(IDN),UTIME(IT),PLOTI(IT)
      GO TO 600
C.....PLOT AND PRINT TWO VARIABLES
  370 IF(PLOTI(IT) - ONE) 380, 380, 410
  380 IF(PLOTJ(IT) - ONE) 390, 390, 400
  390 WRITE(JOUT,1515) IHR(IDN), LIN,IHR(IDN),UTIME(IT),NDASH,NDASH
      GO TO 600
  400 WRITE(JOUT,1517) IHR(IDN),LIN,IHR(IDN),UTIME(IT),NDASH,PLOTJ(IT)
      GO TO 600
  410 IF(PLOTJ(IT) - ONE) 420, 420, 430
  420 WRITE(JOUT,1518) IHR(IDN),LIN,IHR(IDN),UTIME(IT),PLOTI(IT),NDASH
      GO TO 600
  430 WRITE(JOUT,1516) IHR(IDN),LIN,IHR(IDN),UTIME(IT),PLOTI(IT),
     1 PLOTJ(IT)
      GO TO 600
C.....PLOT AND PRINT THREE VARIABLES
  440 IF(PLOTI(IT) - ONE) 450, 450, 520
  450 IF(PLOTJ(IT) - ONE) 460, 460, 490
  460 IF(PLOTK(IT) - ONE) 470, 470, 480
  470 WRITE(JOUT,1515) IHR(IDN),LIN,IHR(IDN),UTIME(IT),NDASH,NDASH,NDASH
      GO TO 600
  480 WRITE(JOUT,1519) IHR(IDN),LIN,IHR(IDN),UTIME(IT),NDASH,NDASH,
     1 PLOTK(IT)
      GO TO 600
  490 IF(PLOTK(IT) - ONE) 500, 500, 510
  500 WRITE(JOUT,1520) IHR(IDN),LIN,IHR(IDN),UTIME(IT),NDASH,PLOTJ(IT),
     1 NDASH
      GO TO 600
  510 WRITE(JOUT,1521) IHR(IDN),LIN,IHR(IDN),UTIME(IT),NDASH,PLOTJ(IT),
     1 PLOTK(IT)
      GO TO 600
  520 IF(PLOTJ(IT) - ONE) 530, 530, 560
  530 IF(PLOTK(IT) - ONE) 540, 540, 550
  540 WRITE(JOUT,1522) IHR(IDN),LIN,IHR(IDN),UTIME(IT),PLOTI(IT),NDASH,
     1 NDASH
      GO TO 600
  550 WRITE(JOUT,1523) IHR(IDN),LIN,IHR(IDN),UTIME(IT),PLOTI(IT),NDASH,
     1 PLOTK(IT)
      GO TO 600
  560 IF(PLOTK(IT) - ONE) 570, 570, 580
  570 WRITE(JOUT,1524) IHR(IDN),LIN,IHR(IDN),UTIME(IT),PLOTI(IT),
     1 PLOTJ(IT),NDASH
      GO TO 600
  580 WRITE(JOUT,1516) IHR(IDN),LIN,IHR(IDN),UTIME(IT),PLOTI(IT),
     1 PLOTJ(IT), PLOTK(IT)
  600 IT = IT + 1
  700 CONTINUE
      WRITE(JOUT,1510)
      WRITE(JOUT,1508)
      WRITE(JOUT,1525)
  710 CONTINUE
      RETURN
C.....FORMAT STATEMENTS
 1500 FORMAT(' ',//,10X,3(A5,A6,5X)/)
 1508 FORMAT (' ',6X,'00  02  04  06  08  10  12  14  16  18  20  22',
     A '  00')
 1510 FORMAT(' ',4X,'MHZ+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+',
     A'-+-+MHZ')
 1512 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2)
 1514 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2,3X,A4,3(1X,A5))
 1515 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2,3X,F4.1,3(3X,A1,2X))
 1516 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2,3X,F4.1,3F6.1)
 1517 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2,3X,F4.1,3X,A1,2X,2F6.1)
 1518 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2,3X,F4.1,F6.1,2(3X,A1,2X))
 1519 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2,3X,F4.1,2(3X,A1,2X),F6.1)
 1520 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2,3X,F4.1,3X,A1,2X,F6.1,3X,
     1 A1)
 1521 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2,3X,F4.1,3X,A1,2X,2F6.1)
 1522 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2,3X,F4.1,F6.1,2(3X,A1,2X))
 1523 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2,3X,F4.1,F6.1,3X,A1,2X,
     1 F6.1)
 1524 FORMAT(' ',3X,A2,'-',25(1X,A1),1X,'-',A2,3X,F4.1,2F6.1,3X,A1)
 1525 FORMAT(' ',20X,'UNIVERSAL TIME')
      END
C--------------------------------
C--------------------------------

c###genion.for
      SUBROUTINE GENION(K)
C--------------------------------
C  THIS SECTION WILL GENERATE AN ELECTRON DENSITY PROFILE, AN IONOGRAM,
C  A REFLECTRIX,TABLE OF OBLIQUE FREQUENCIES AND DISTANCES AT SPECIFIED
C  ANGLES,ORDINARY MODE ONLY
C
C     HTR(50,3)  TRUE HEIGHT PROFILE FOR ELECTRON DENSITY PROFILE -- KM
C     FNSQ(50,3) ELECTRON DENSITY AS PLASMA FREQUENCY -- (MHZ)**2
C     FVERT(30,5) VERTICAL SOUNDING FREQUENCY--MHZ
C     HTRUE(30,5) TRUE HEIGHT OF REFLECTION--KM
C     HPRIM(30,5) VIRTUAL HEIGHT OF REFLECTION--KM
C
C     IFOB(40,30,5) OBLIQUE OPERATING FREQUENCY -- HZ
C     IDIST(40,30,5) PATH DISTANCE -- KM
C     ANG(40)  ELEVATION ANGLE -- DEGREES
C
      COMMON / MFAC / F2M3(5),HPF2(5),ZENANG(5),ZENMAX(5),IEDP,FSECV(3)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      DIMENSION HTE(10),HPE(10)
C.....TRUE AND VIRTUAL HEIGHTS FOR E LAYER WITH 110 AND 20 AS PARAMETERS
      DATA HTE/70.00,84.51,88.52,93.00,94.26,95.71,97.68,100.27,104.22,
     A 107.19 /
      DATA HPE/70.00,87.40,94.00,98.68,100.20,102.65,107.15,113.74,
     A 125.25,140.03/
C  SAMPLE VERTICAL SOUNDING  FREQUENCIES
C D-E  REGION TAIL
C   XTAIL MUST AGREE WITH LECDEN
      XTAIL = .85
      FEX = FI(1,K) * SQRT(1. - XTAIL * XTAIL)
      FVERT (1, K) = .01
      FVERT (4, K) = FEX
      FDIF = (FVERT (4, K) - FVERT (1, K)) / 3.
      FVERT (2, K) = FVERT (1, K) + FDIF
      FVERT (3, K) = FVERT (2, K) + FDIF
C  E REGION NOSE
C.....GUESS FOR E MUF
      FVERT(9,K) = .957 * FI(1,K)
      FVERT(10,K) = 0.99 * FI(1,K)
      FDIF = (FVERT(9,K) - FVERT(4,K)) / 5.
      FVERT (5, K) = FVERT (4, K) + FDIF
      FVERT (6, K) = FVERT (5, K) + FDIF
      FVERT (7, K) = FVERT (6, K) + FDIF
      FVERT (8, K) = FVERT (7, K) + FDIF
C.....E - F CUSP
      FVERT(11,K) =  1.05 * FI(1,K)
C.....F REGION NOSE
      FVERT(30,K) = 0.99 * FI(3,K)
      FVERT (29, K) = 0.98 * FI (3, K)
      FVERT (28, K) = 0.96 * FI (3, K)
      FVERT (27, K) = 0.92 * FI (3, K)
      IF (FI (2, K))385, 385, 400
C   F2 LAYER, NO F1 LAYER
  385 CONTINUE
      FDIF = (FVERT (27, K) - FVERT (11, K)) / 16.
      DO 395 IF = 12, 26
  395 FVERT (IF, K) = FVERT (IF - 1, K) + FDIF
      GO TO 425
C  F1 LAYER  AND F2 LAYER
  400 CONTINUE
      FVERT(20,K) = 0.99 * FI(2,K)
      FDIF = (FVERT (20, K) - FVERT (11, K)) / 9.
      DO 405 IF = 12, 19
  405 FVERT (IF, K) = FVERT (IF - 1, K) + FDIF
C.....F1 - F2 CUSP
      FVERT(21,K) = 1.01 * FI(2,K)
      FDIF = (FVERT (27, K) - FVERT (21, K)) / 6.
      DO 415 IF = 22, 26
  415 FVERT (IF, K) = FVERT (IF - 1, K) + FDIF
  425 CONTINUE
C.....DO FAST VERSION INTEGRATION BY DEFAULT
      IF( IEDP ) 600,705,705
  600 CONTINUE
C
C
C   INTEGRATE TO GET IONOGRAM,  NT-POINT GUASSIAN
C
      DO 640 IF = 1, 30
C.....VERTICAL SOUNDING FREQUENCY
      FXX = FVERT(IF,K)
      CALL GETHP(FXX, HPX, HTX)
C.....HPRIM(IF,K) IS THE VIRTUAL HEIGHT
C.....HTRUE(IF,K) IS THE TRUE HEIGHT
      HPRIM(IF,K) = HPX
      HTRUE(IF,K) = HTX
  640 CONTINUE
      GO TO 750
  705 CONTINUE
C
C FASTER VERSION, PARABOLIC E LAYER ( HI(1,K)=110.,YI(1,K)=20.) WITH
C  EXPONENTIAL TAIL.
C
C.....SAME AS CALL TO SUBROUTINE GETHP FOR DEFAULT E LAYER
      DO 710 IF = 1,10
      HTRUE(IF,K) = HTE(IF)
      HPRIM(IF,K) = HPE(IF)
710   continue
      DO 715 IF = 11,30
      FN = FVERT(IF,K)*FVERT(IF,K)
C.....TRUE HEIGHT BY TABLE LOOKUP
      HTRUE(IF,K) = XLIN(FN,FNSQ(1,1),HTR(1,1),50,1 )
  715 CONTINUE
      IF( FI(2,K) ) 720,720,730
  720 CONTINUE
      DO 725 IF = 11,30
C.....BOTTOM OF F LAYER PLUS BENDING PLUS RETARDATION
      FN = FVERT(IF,K)
      HPRIM(IF,K) = HI(3,K) - YI(3,K) + BENDY(3,K,FN)
     A            + (PEN(1,K,FN) - 2.*YI(1,K) )
  725 CONTINUE
      GO TO 750
  730 CONTINUE
C.....THERE ARE TO MANY POSSIBILITIES WITH F1 PRESENT
      DO 740 IF = 11,30
      FXX = FVERT(IF,K)
      CALL GETHP(FXX,HPX,HTX)
      HPRIM(IF,K) = HPX
  740 CONTINUE
  750 CONTINUE
      RETURN
      END
C--------------------------------

c###gmloss.for
      SUBROUTINE GMLOSS
C--------------------------------
C
C     THIS SUBROUTINE CALCULATES THE GAIN MINUS LOSS FUNCTION
C
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON/LOSX/ANDVX(45,3),ADVX(45,3),AOFX(45,3),ARFX(45,3),GRLOSX(45
     A ,3),TGAINX(45,3),TLSKM(45,3),EFFlp(45),IAFTXR(3)
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON / ZON / ABPS(7), CREL(7), EFF(7), FLDST(7), GRLOS(7),
     1 HN(7), HP(7), PROB(7), RELY(7), RGAIN(7), SIGPOW(7), SN(7),
     2 SPRO(7), TGAIN(7), TIMED(7), TLOSS(7), B(7), FSLOS(7), ADV(7),
     3 OBF(7),NMODE(7),TLLOW(7),TLHGH(7)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
C.....PRESET ALL ARRAYS
      DO 240 IM = 1,7
      OBF(IM)    = 1000.
      ADV(IM)    = 1000.
      FSLOS(IM)  = 1000.
      TLOSS(IM)  = 1000.
      ABPS(IM)   = 1000.
      EFF (IM)   = 0.0
      GRLOS(IM) = 1000.0
      RGAIN(IM)  = 0.0
      TGAIN(IM)  = 0.0
      HN(IM)     =-1.
      PROB(IM)   = 0.001
      CREL(IM)   = 0.001
      RELY(IM)   = 0.001
      SPRO(IM)   = 0.001
      FLDST(IM) = -1000.0
      SIGPOW(IM) =-1000.
      SN(IM)     =-1000.
      TIMED(IM)  =-1.
      HP(IM)     =-1.
      B(IM)      =-1.
      NMODE(IM) = 5
  240 CONTINUE
C.....TRANSMITTER/RECEIVER ENDS
      CALL SETTXR
      DO 120 JJ=1,2
      K=ITXRCP(JJ)
      DO 110 IA=1,IAFTXR(K)
C.....AT LEAST AN OVER THE MUF
      IF(HPFLX(IA,K)- 70.) 110,105,105
  105 IF( DELFX(IA,K) - AMIND) 110,106,106
C.....GAIN-LOSS, TRANSMITTER /RECEIVER ENDS
  106 TXRGML(IA,JJ) = TGAINX(IA,K) - (ANDVX(IA,K) + ADVX(IA,K) )
  110 CONTINUE
  120 CONTINUE
      RETURN
      END
C--------------------------------

c###genois.for
      SUBROUTINE GENOIS!  (rcnse_x,du_x,dl_x,sigm_x,sygu_x,sygl_x,rnse)
c          GENOIS for Power sum #1 = Spaulding's original with Caruana modification
c          This is the change per ITU submission to ITU-R P.372-8 April 2007 GRH
      common /c_noise/ mode_n1,mode_n2,mode_n3
      common /c_noises/ xn_atnos,xn_galactic,xn_mmn
      common /c_method_used/ method_used
C--------------------------------
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
C--------------------------------
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
C
C     THIS ROUTINE COMPUTES THE COMBINED NOISE DISTRIBUTION - as prescribed
C       in ITS Report 87-212 "Updated NOISE Model for use in IONCAP"
C
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SYGU,SYGL,KJ,JK
      COMMON /TON /ADJ, ADS, GNOS, GOT, REL, SL, SLS
     1, SPR, SU, SUS, XNOISE, ZNOISE, NF
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / TWO / F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     A FAM(14,12), SYS(9,16,6), PERR(9,4,6)
      COMMON / ZON / ABPS(7), CREL(7), EFF(7), FLDST(7), GRLOS(7),
     1 HN(7), HP(7), PROB(7), RELY(7), RGAIN(7), SIGPOW(7), SN(7),
     2 SPRO(7), TGAIN(7), TIMED(7), TLOSS(7), B(7), FSLOS(7), ADV(7),
     3 OBF(7),NMODE(7),TLLOW(7),TLHGH(7)
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
      real*8 vu,vl,au,al,vu1,vu2,vu3,vl1,vl2,vl3
      real*8 au1,au2,au3,al1,al2,al3,sigtsqu,sigtsql
      real*8 dxx,dxx2,dxx3
      DIMENSION XNINT(6),conn(6)
C.....MAN-MADE NOISE LEVELS
c                   #1         #2        #3     #4     #5     #6
c               industrial residential  rural remote  noisy  quiet
      data conn/   27.7   ,   27.7    , 27.7 , 28.6 , 37.5 , 29.1 /
      DATA XNINT / 76.8   ,   72.5    , 67.2 , 53.6 , 83.2 , 65.2 /
c         -27.7 for #4 (remote) changed 4/13/07 from -28.6 per GRH to match ITU report
c         changed back 8/14/07 to match ITU Rec372 - Radio Noise
C
      DATA DFAC,BFAC,CFAC /7.87384, 30.99872, 5.56765/
C
C        7.87384=SQRT(2 * 1.282**2 * 4.34294**2)
C
C       30.99872=(1.282**2)*(4.34294**2)
C
C        5.56765=4.34294 * 1.282
C
C.....DATA ARE FA VALUES AT 1 MHZ
C
C.....ATNU, ATNY ARE DB .GT. KTB FOR 1 MHZ
C.....ATNZ, ATNX ARE DB .GT. KTB FOR FREQ
C.....ATNOS, GNOS, XNOIS ARE DB .GT. KTB FOR ALL CALCULATIONS
C.....AND ARE CONVERTED TO DBW(1 HZ BWDTH) AT END OF ROUTINE
C.....UPPER LIMIT IS 55 MHZ FOR NOISE
      if(nyear.eq.' 2089') then    !  use old genois
         call genois_old
         return
      end if

      DUME=AMIN1(FREQ,55.)
      MAN=NOISE
C
C     FREQUENCY DEPENDENT ATMOSPHERIC NOISE
C
      IF (F2D(1,1,1)) 85,90,90
C.....NO IONOSPHERIC LONG TERM DATA BASE FILE
C.....FORCE MAN-MADE NOISE OR GALACTIC NOISE
   85 ATNOS=204.
      atnos=0.
      DUA=9.
      DLA=7.
      SMA=3.
      SUA=1.5
      SLA=1.5
      GO TO 95
   90 CONTINUE
C.....FREQUENCY DEPENDENCE
      CALL GENFAM(RLAT,KJ,DUME,ATNU,ATNZ,DU,DL,SIGM,SYGU,SYGL)
ccc      write(luo,'(''genfam='',i5,5f10.4)') kj,freq,atnu,atnz,du,dl
      CALL GENFAM(RLAT,JK,DUME,ATNY,ATNX,DX,DQ,SIGZ,SIGX,SIGSQ)
ccc      write(luo,'(''genfam='',i5,5f10.4)') jk,freq,atny,atnx,dx,dq
C.....BEGIN INTERPOLATION ON LOCAL TIME
      SLOP=ABS(CC-TM)/4.
      ATNOS=ATNZ+(ATNX-ATNZ)*SLOP
ccc      atnos=atnz
ccc      dua=du
ccc      dla=dl
ccc      sma=sigm
ccc      sua=sygu
ccc      sla=sygl
ccc      write(luo,'(''atnos='',5f10.4)') atnos,atnz,atnx,atnz,slop
      DUA=DU+(DX-DU)*SLOP
      DLA=DL+(DQ-DL)*SLOP
      SMA=SIGM+(SIGZ-SIGM)*SLOP
      SUA=SYGU+(SIGX-SYGU)*SLOP
      SLA=SYGL+(SIGSQ-SYGL)*SLOP
ccc      write(luo,'(''atnos='',3f10.4)') atnos,dua,dla
C.....END OF INTERPOLATION ON LOCAL TIME
C
C     (DUA/DFAC)**2=(DUA/1.282)**2/(2*4.34294**2)
C                  =(DUA/SQRT(2*1.282**2*4.34294**2))**2
C                  =(DUA/7.87384)**2
C
95    continue
      atnos_sav=atnos
cxxx      if(mode_n1.eq.0) atnos=204.
ccc      if(mode_n1.eq.0) atnos=0.
      AU1=EXP((DUA/DFAC)**2+(ATNOS/4.34294))
ccc      write(*,'(''au='',4f15.4)') au,dua,dfac,atnos
      VU1=AU1*AU1*(EXP(DUA*DUA/BFAC)-1.)
      AL1=EXP((DLA/DFAC)**2+(ATNOS/4.34294))
C
C     DLA*DLA/BFAC=(DLA/1.282)**2/(4.34294)**2
C                 =DLA**2/30.99872
C
      VL1=AL1*AL1*(EXP(DLA*DLA/BFAC)-1.)
cxxx      if(mode_n1.eq.0) then         !  ignore Atmospheric noise
cxxx         au1=0.
cxxx         vu1=0.
cxxx         al1=0.
cxxx         vl1=0.
cxxx      end if
      atnos=atnos_sav
c****************************************************************
C
C     GALACTIC NOISE
C
      GNOS=52.-23.*ALOG10(FREQ)
      DUG=2.
      DLG=2.
      SMG=.5
      SUG=.2
      SLG=.2
      mode_n2=1
cxxx      if(mode_n2.eq.0) gnos=0.    !  ignore galactic noise
ccc      write(*,'(''gnos='',f10.4)') gnos
      AU2=EXP((DUG/DFAC)**2+(GNOS/4.34294))
      VU2=AU2*AU2*(EXP(DUG*DUG/BFAC)-1.)
      AL2=EXP((DLG/DFAC)**2+(GNOS/4.34294))
      VL2=AL2*AL2*(EXP(DLG*DLG/BFAC)-1.)
ccc      write(*,'(''gnos ='',3f10.4)') gnos,dug,dlg
      IF(FREQ.le.FI(3,KFX)) then    !  Galactic noise does not penetrate -- ignore
ccc      if(mode_n2.eq.0) then         !  ignore Galactic noise
         mode_n2=0    !  ignore Galactic noise
         gnos=0.
         au2=0.
         vu2=0.
         al2=0.
         vl2=0.
      end if
c****************************************************************
C
C     MAN MADE NOISE
C
      MAN=NOISE
      XNOIS=MAN
      MA=IABS(MAN)
      ZNOISE=XNOIS
      IF (MAN) 120,114,115
C.....INDICATES -164 ON USER INPUT
  114 MA=4
      GO TO 120
C.....CONVERT 3 MHZ DB .LT. 1 WATT INPUT VALUE TO FA AT 1 MHZ
  115 XNOIS=204.0-XNOIS+13.22
C.....OBTAIN FA AT DESIRED FREQUENCY
      XNOIS=XNOIS-27.7*ALOG10(FREQ)
      GO TO 125
C.....NEGATIVE ON USER INPUT INDICATES INDEX
  120 MA=MIN0(4,MA)
      XNOIS=XNINT(MA)-CONN(MA)*ALOG10(FREQ)
      ZNOISE=204.0 - XNINT(MA) + conn(ma)*alog10(3.)   !  3 MHz noise
  125 DUM=9.7
ccc      write(luo,'(''znoise='',2f12.5,i5)') znoise,xnois,man
      DLM=6.
      SUM=1.5
      SMM=5.4
      SLM=1.5
cxxx      if(mode_n3.eq.0) xnois=0.
      AU3=EXP((DUM/DFAC)**2+(XNOIS/4.34294))
      VU3=AU3*AU3*(EXP(DUM*DUM/BFAC)-1.)
      AL3=EXP((DLM/DFAC)**2+(XNOIS/4.34294))
      VL3=AL3*AL3*(EXP(DLM*DLM/BFAC)-1.)
ccc      write(*,'(''mnos ='',3f10.4)') xnois,dum,dlm
cxxx      if(mode_n3.eq.0) then         !  ignore Man-Made noise
cxxx         au3=0.
cxxx         vu3=0.
cxxx         al3=0.
cxxx         vl3=0.
cxxx      end if
c****************************************************************
      VU=VU1+VU2+VU3
      VL=VL1+VL2+VL3
      AU=AU1+AU2+AU3
      AL=AL1+AL2+AL3
ccc      write(*,'(''vu='',4e15.7)') vu,vu1,vu2,vu3
ccc      write(*,'(''vl='',4e15.7)') vl,vl1,vl2,vl3
ccc      write(*,'(''au='',4e15.7)') au,au1,au2,au3
ccc      write(*,'(''al='',4e15.7)') al,al1,al2,al3
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
C.....RECEIVER ANTENNA EFFICIENCY
C125PC      if(MSPEC.eq.125)then
c.......set rec EFF to 0. dB or unity
C125PC        reff=0.
C125PC      else
      reff=0
        CALL GAIN(2,0.0,FREQ,GDUM,reff)
C125PC      ENDIF
C.....SET ARRAY FOR ALL POSSIBLE MODES
      DO 196 IM=1,6
  196 EFF(IM) = reff
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
C.....NOW DETERMINATION OF NOISE LEVEL IS ITS-78 (HFMUFES4)
C.....SWITCH TO DB .GT. WATT
ccc      write(luo,'(''atnos,gnos,xnois='',3f10.4)') atnos,gnos,xnois
      ATNOS=ATNOS-204.
      GNOS=GNOS-204.
      XNOIS=XNOIS-204.

      xn_atnos=atnos
      xn_galactic=gnos
      xn_mmn=xnois
      rnse=4.34294*alog((10.**(atnos*.1))+(10.**(gnos*.1))
     +     + 10.**((xnois*.1)))

c************************************************************
c          This is where Spaulding's original replaces simple power sum
c************************************************************

      SIGTSQu=dLOG(1.d0+VU/(AU*AU))
      SIGTSQl=dLOG(1.d0+VL/(AL*AL))
      method_used=2
      if(dua.le.12. .and. dla.le.12.) go to 200  ! use Spaulding original
c************************************************************
c          This is where Caruana's modification begins
c************************************************************
c          see if the Spaulding method is going to breakdown
      dxx=rnse         !  this is the simple power sum
      dxx=dxx+204.
      dxx2=2.d0*(dlog(au)-dxx/4.34294d0)
      dxx3=2.d0*(dlog(al)-dxx/4.34294d0)
ccc      dxx3=2.d0*(dlog(al)-rnse/4.34294d0)
ccc      write(*,'(''dxx='',8f15.5)') atnos,gnos,xnois,dxx,dxx2,
ccc     +       dxx3,sigtsqu,au
      if(sigtsqu.gt.dxx2 .and. dxx2.gt.0.) then
         method_used=1
         sigtsqu=dxx2   !  problem with Spaulding, limit SIGTSQu
ccc         sigtsql=dxx3   !  problem with Spaulding, limit SIGTSQl
      end if
      if(sigtsql.gt.dxx3 .and. dxx3.gt.0.) then
         method_used=1
         sigtsql=dxx3   !  problem with Spaulding, limit SIGTSQl
      end if
c************************************************************
c          End Caruana's modification
c************************************************************
200   XRNSE=4.34294*(dLOG(AU)-SIGTSQu/2.)-204.
ccc      write(luo,'(''xrnse='',5f15.4)') xrnse,au,sigtsq,xnois,rnse
C.....UPPER DECILE
C
C     CFAC=4.34294*1.282
C         =5.56765
C
      DU=CFAC*dSQRT(SIGTSQu)


C.....LOWER DECILE
      DL=CFAC*dSQRT(SIGTSQl)

      QPA=10.**((ATNOS-XRNSE)*0.1)
cxxx      if(mode_n1.eq.0) QPA=0.      !  no atmospheric noise requested
      QPG=10.**((GNOS-XRNSE)*0.1)
      if(mode_n2.eq.0) QPG=0.      !  no galactic    noise requested
C.....PREDICTION ERRORS
C.....SIGM IS MEDIAN, SYGU IS UPPER AND SYGL IS LOWER
      QPM=10.**((XNOIS-XRNSE)*0.1)
cxxx      if(mode_n3.eq.0) QPM=0.      !  no man-made    noise requested
      SIGM=SQRT((QPA*SMA)**2+(QPG*SMG)**2+(QPM*SMM)**2)  !  /QP
C
C     0.23026=1.0/4.34294
C
      PV=QPA*EXP((DUA-DU)*0.23026)
      SYGU1=(PV*SUA)**2+((PV-QPA)*SMA)**2
      PV=QPG*EXP((DUG-DU)*0.23026)
      SYGU2=(PV*SUG)**2+((PV-QPG)*SMG)**2
      PV=QPM*EXP((DUM-DU)*0.23026)
      SYGU3=(PV*SUM)**2+((PV-QPM)*SMM)**2
      SYGU=SQRT(SYGU1 + SYGU2 + SYGU3)

      PV=QPA*EXP((DLA-DL)*0.23026)
      SYGL1=(PV*SLA)**2+((PV-QPA)*SMA)**2
      PV=QPG*EXP((DLG-DL)*0.23026)
      SYGL2=(PV*SLG)**2+((PV-QPG)*SMG)**2    !  original code used SMA
CCCC  SYGL=SYGL+(PV*SLG)**2+((PV-QPG)*SMA)**2    !  as in this commented line
      PV=QPM*EXP((DLM-DL)*0.23026)
      SYGL3=(PV*SLM)**2 +((PV-QPM)*SMM)**2
      SYGL=SQRT(SYGL1 + SYGL2 + SYGL3)
c**************************************************************
c          End Spaulding's original
c**************************************************************
ccc      write(*,'(''sigm ='',4f12.4)') sigm,sma,smg,smm
ccc      write(*,'(''sigu ='',4f12.4)') sygu,sua,sug,sum
ccc      write(*,'(''sigl ='',4f12.4)') sygl,sla,slg,slm
ccc      write(*,'(''xrnse='',5f12.4)') 
ccc     +   xrnse+204.,atnos+204.,gnos+204.,xnois+204.,rnse+204.
ccc      write(*,'(''QP   ='',3f12.4)') qpa,qpg,qpm
C
C     RCVR SITE NOISE = TOTAL NOISE + ANTENNA EFFICENCY (ADDED TO
C                       SIGNAL WITH GAIN)
C
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
C------------    CHANGED 9/24/91  (LONG PATH RCVR EFF CORRECTION)  FJR
C------------          210 RCNSE = XRNSE + reff
      RCNSE = XRNSE
      XNOISE=XNOIS
cxxx      rcnse_x=rcnse
ccc      write(luo,'(''xnois='',5f10.4)') rcnse,rcnse+204.,atnos+204.,
ccc     +          gnos+204.,xnois+204.
cxxx      du_x=du
cxxx      dl_x=dl
cxxx      sigm_x=sigm
cxxx      sygu_x=sygu
cxxx      sygl_x=sygl
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
      RETURN
      END
C--------------------------------
c###genois.for
      SUBROUTINE GENOIS_old
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
C--------------------------------
C
C     THIS ROUTINE COMPUTES THE COMBINED NOISE DISTRIBUTION - as prescribed
C       in ITS Report 87-212 "Updated NOISE Model for use in IONCAP"
C
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SYGU,SYGL,KJ,JK
      COMMON /TON /ADJ, ADS, GNOS, GOT, REL, SL, SLS
     1, SPR, SU, SUS, XNOISE, ZNOISE, NF
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / TWO / F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     A FAM(14,12), SYS(9,16,6), PERR(9,4,6)
      COMMON / ZON / ABPS(7), CREL(7), EFF(7), FLDST(7), GRLOS(7),
     1 HN(7), HP(7), PROB(7), RELY(7), RGAIN(7), SIGPOW(7), SN(7),
     2 SPRO(7), TGAIN(7), TIMED(7), TLOSS(7), B(7), FSLOS(7), ADV(7),
     3 OBF(7),NMODE(7),TLLOW(7),TLHGH(7)
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
      DIMENSION XNINT(4)
C.....MAN-MADE NOISE LEVELS
      DATA XNINT /76.8, 72.5, 67.2, 53.6/
C
      DATA DFAC,BFAC,CFAC /7.87384, 30.99872, 5.56765/
C
C        7.87384=SQRT(2 * 1.282**2 * 4.34294**2)
C
C       30.99872=(1.282**2)*(4.34294**2)
C
C        5.56765=4.34294 * 1.282
C
C.....DATA ARE FA VALUES AT 1 MHZ
C
C.....ATNU, ATNY ARE DB .GT. KTB FOR 1 MHZ
C.....ATNZ, ATNX ARE DB .GT. KTB FOR FREQ
C.....ATNOS, GNOS, XNOIS ARE DB .GT. KTB FOR ALL CALCULATIONS
C.....AND ARE CONVERTED TO DBW(1 HZ BWDTH) AT END OF ROUTINE
C.....UPPER LIMIT IS 55 MHZ FOR NOISE
      DUME=AMIN1(FREQ,55.)
      MAN=NOISE
C
C     FREQUENCY DEPENDENT ATMOSPHERIC NOISE
C
      IF (F2D(1,1,1)) 85,90,90
C.....NO IONOSPHERIC LONG TERM DATA BASE FILE
C.....FORCE MAN-MADE NOISE OR GALACTIC NOISE
   85 ATNOS=204.
      DUA=9.
      DLA=7.
      SMA=3.
      SUA=1.5
      SLA=1.5
      GO TO 95
   90 CONTINUE
C.....FREQUENCY DEPENDENCE
      CALL GENFAM(RLAT,KJ,DUME,ATNU,ATNZ,DU,DL,SIGM,SYGU,SYGL)
ccc      write(luo,'(''Genfam='',i5,3f10.4)') kj,freq,atnu,atnz
      CALL GENFAM(RLAT,JK,DUME,ATNY,ATNX,DX,DQ,SIGZ,SIGX,SIGSQ)
ccc      write(luo,'(''Genfam='',i5,3f10.4)') jk,freq,atny,atnx
C.....BEGIN INTERPOLATION ON LOCAL TIME
      SLOP=ABS(CC-TM)/4.
      ATNOS=ATNZ+(ATNX-ATNZ)*SLOP
ccc      write(luo,'(''atnos='',5f10.4)') atnos,atnz,atnx,atnz,slop
      DUA=DU+(DX-DU)*SLOP
      DLA=DL+(DQ-DL)*SLOP
      SMA=SIGM+(SIGZ-SIGM)*SLOP
      SUA=SYGU+(SIGX-SYGU)*SLOP
      SLA=SYGL+(SIGSQ-SYGL)*SLOP
C.....END OF INTERPOLATION ON LOCAL TIME
C
C     (DUA/DFAC)**2=(DUA/1.282)**2/(2*4.34294**2)
C                  =(DUA/SQRT(2*1.282**2*4.34294**2))**2
C                  =(DUA/7.87384)**2
C
   95 AU=EXP((DUA/DFAC)**2+(ATNOS/4.34294))
ccc      write(luo,'(''au='',4f15.4)') au,dua,dfac,atnos
      VU=AU*AU*(EXP(DUA*DUA/BFAC)-1.)
      AL=EXP((DLA/DFAC)**2+(ATNOS/4.34294))
C
C     DLA*DLA/BFAC=(DLA/1.282)**2/(4.34294)**2
C                 =DLA**2/30.99872
C
      VL=AL*AL*(EXP(DLA*DLA/BFAC)-1.)
C
C     GALACTIC NOISE
C
      IF(FREQ.le.FI(3,KFX)) then   !  FI(3,..) is F2 critical frequency
         GNOS=0.        !  GALACTIC NOISE DOES NOT PENETRATE
      else
         GNOS=52.-23.*ALOG10(FREQ)
      end if
      DUG=2.
ccc      write(luo,'(''gnos='',f10.4)') gnos
      AT=EXP((DUG/DFAC)**2+(GNOS/4.34294))
      AU=AU+AT
      VU=VU+AT*AT*(EXP(DUG*DUG/BFAC)-1.)
      DLG=2.
      AT=EXP((DLG/DFAC)**2+(GNOS/4.34294))
      AL=AL+AT
      VL=VL+AT*AT*(EXP(DLG*DLG/BFAC)-1.)
      SMG=.5
      SUG=.2
      SLG=.2
C
C     MAN MADE NOISE
C
      MAN=NOISE
      XNOIS=MAN
      MA=IABS(MAN)
      ZNOISE=XNOIS
      IF (MAN) 120,114,115
C.....INDICATES -164 ON USER INPUT
  114 MA=4
      GO TO 120
C.....CONVERT 3 MHZ DB .LT. 1 WATT INPUT VALUE TO FA AT 1 MHZ
  115 XNOIS=204.0-XNOIS+13.22
C.....OBTAIN FA AT DESIRED FREQUENCY
      XNOIS=XNOIS-27.7*ALOG10(FREQ)
      GO TO 125
C.....NEGATIVE ON USER INPUT INDICATES INDEX
  120 MA=MIN0(4,MA)
      CONN=27.7
ccc      IF (MA.EQ.4) CONN=28.6    !  removed 4/13/2007 GRH
      XNOIS=XNINT(MA)-CONN*ALOG10(FREQ)
      ZNOISE=204.0-XNINT(MA)+13.22
  125 DUM=9.7
      AT=EXP((DUM/DFAC)**2+(XNOIS/4.34294))
      AU=AU+AT
      VU=VU+AT*AT*(EXP(DUM*DUM/BFAC)-1.)
      DLM=6.
      AT=EXP((DLM/DFAC)**2+(XNOIS/4.34294))
      AL=AL+AT
      VL=VL+AT*AT*(EXP(DLM*DLM/BFAC)-1.)
      SUM=1.5
      SMM=5.4
      SLM=1.5
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
C.....RECEIVER ANTENNA EFFICIENCY
C125PC      if(MSPEC.eq.125)then
c.......set rec EFF to 0. dB or unity
C125PC        reff=0.
C125PC      else
        CALL GAIN(2,0.0,FREQ,GDUM,reff)
C125PC      ENDIF
C.....SET ARRAY FOR ALL POSSIBLE MODES
      DO 196 IM=1,6
  196 EFF(IM) = reff
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
C.....NOW DETERMINATION OF NOISE LEVEL IS ITS-78 (HFMUFES4)
C.....SWITCH TO DB .GT. WATT
ccc      write(luo,'(''atnos,gnos,xnois='',3f10.4)') atnos,gnos,xnois
      ATNOS=ATNOS-204.
      GNOS=GNOS-204.
      XNOIS=XNOIS-204.
      SIGTSQ=ALOG(1.+VU/(AU*AU))
      XRNSE=4.34294*(ALOG(AU)-SIGTSQ/2.)-204.
ccc      write(luo,'(''xrnse='',3f15.4)') xrnse,au,sigtsq
C.....UPPER DECILE
C
C     CFAC=4.34294*1.282
C         =5.56765
C
      DU=CFAC*SQRT(SIGTSQ)
      SIGTSQ=ALOG(1.+VL/(AL*AL))
C.....LOWER DECILE
      DL=CFAC*SQRT(SIGTSQ)
      IF (ITRUN-8) 205,210,205
  205 QPA=10.**((ATNOS-XRNSE)*0.1)
      QPG=10.**((GNOS-XRNSE)*0.1)
C.....PREDICTION ERRORS
C.....SIGM IS MEDIAN, SYGU IS UPPER AND SYGL IS LOWER
      QPM=10.**((XNOIS-XRNSE)*0.1)
      SIGM=SQRT((QPA*SMA)**2+(QPG*SMG)**2+(QPM*SMM)**2)
ccc      write(*,'(''sigm ='',4f10.4)') sigm,sma,smg,smm
ccc      write(*,'(''xrnse='',4f10.4)') 
ccc     +           xrnse+204.,atnos+204.,gnos+204.,xnois+204.
ccc      write(*,'(''QP?  ='',10x,3f10.4)') qpa,qpg,qpm
C
C     0.23026=1.0/4.34294
C
      PV=QPA*EXP((DUA-DU)*0.23026)
      SYGU=(PV*SUA)**2+((PV-QPA)*SMA)**2
      PV=QPG*EXP((DUG-DU)*0.23026)
      SYGU=SYGU+(PV*SUG)**2+((PV-QPG)*SMG)**2
      PV=QPM*EXP((DUM-DU)*0.23026)
      SYGU=SQRT(SYGU+(PV*SUM)**2+((PV-QPM)*SMM)**2)
      PV=QPA*EXP((DLA-DL)*0.23026)
      SYGL=(PV*SLA)**2+((PV-QPA)*SMA)**2
      PV=QPG*EXP((DLG-DL)*0.23026)
      SYGL=SYGL+(PV*SLG)**2+((PV-QPG)*SMG)**2    !  original code used SMA
CCCC  SYGL=SYGL+(PV*SLG)**2+((PV-QPG)*SMA)**2    !  as in this commented line
      PV=QPM*EXP((DLM-DL)*0.23026)
      SYGL=SQRT(SYGL+(PV*SLM)**2 +((PV-QPM)*SMM)**2)
C
C     RCVR SITE NOISE = TOTAL NOISE + ANTENNA EFFICENCY (ADDED TO
C                       SIGNAL WITH GAIN)
C
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
C------------    CHANGED 9/24/91  (LONG PATH RCVR EFF CORRECTION)  FJR
C------------          210 RCNSE = XRNSE + reff
  210 RCNSE = XRNSE
      XNOISE=XNOIS
ccc      write(luo,'(''xnois='',5f10.4)') rcnse,rcnse+204.,atnos+204.,
ccc     +          gnos+204.,xnois+204.
CQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
      RETURN
      END
C--------------------------------

      subroutine harris(jant,fileant,mode,idx,antfile,fs,fe,
     +                  beam_main,offazim)
c*******************************************************************
c     11/98 Greg Hand modifications for Harris
c
c     Given an external antenna type xx (90-99),
c     1. create a data file ANTTYPxx.DAT
c     2. execute the program ..\BIN_WIN\ANTTYPxx.EXE rundirectory mode
c        where:
c              rundirectory = C:\ITSHFBC\RUN (default installation)
c              mode = (blank) = point-to-point
c                   = a = area coverage
c*******************************************************************
      use voacapl_defs
      use crun_directory
      CHARACTER fileant*10,antfile*21,mode*1
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      dimension areagain(91)
      character program*300,alf*1,exe*12,dat*12
      logical*1 iexe_exist
      nch_run=lcount(run_directory,50)

#ifdef _WIN
      write(exe,'(6hANTTYP,i2.2,4h.EXE)') jant
      write(dat,'(6hANTTYP,i2.2,4h.DAT)') jant
#else
      write(exe,'(6hanttyp,i2.2)') jant
      write(dat,'(6hanttyp,i2.2,4h.dat)') jant
#endif

C
C**********Harris modification M Packer for Area Coverage 11 May 1998 *******
C
c        This handles the Harris Type 99 antenna files.  Call the external
c        routines (written in C) to prepare the
c        GAINxx.DAT for area coverage.  Then read in the file.
c        We're gonna use numbers 250-299 if necessary.

c           Follow the same routine necessary for AREA type 13 antenna files.

c           The difficulty here is that antcalc is writing the GAINxx.DAT
c           file on lu 22 and we want to call a routine to generate the
c           GAINxx.DAT file.

c           Prepare ANTTYPxx.DAT to communicate with ANTTYPxx.EXE:
      open( 99, file=run_directory(1:nch_run)//PATH_SEPARATOR//dat,err=900)
      write( 99, 289 ) idx, antfile, fs,fe,beam_main,offazim
289   format( i2, 28x,   '=antenna number (idx)' /
     2       a21,  9x,  '=antenna file filename' /
     3      f7.3, 23x, '=antenna starting frequency (MHz)' /
     4      f7.3, 23x, '=antenna ending frequency (MHz)' /
     5      f7.2, 23x, '=antenna main beam (deg)' /
     6      f7.2, 23x, '=antenna off azimuth angle (deg)' )
      close( 99 )

c**********************************************************************
c          Make sure ANTTYPxx.EXE exists before executing it.
c**********************************************************************
c jw      iexe_exist=it_exist(run_directory(1:nch_run-3)//'bin_win\'//exe)
#ifdef _WIN
      inquire(file=run_directory(1:nch_run-3)//'bin_win'//PATH_SEPARATOR//exe,exist=iexe_exist)
c jw      if(iexe_exist.ne.1) then    !  antenna program does not exist
      if(.NOT.iexe_exist) then    !  antenna program does not exist
         write(*,1) jant,run_directory(1:nch_run-3)//'bin_win\'//exe
1        format('You are attempting to use an antenna of type=',i4,'.',/
     +   'That requires an external antenna calculation program.',/
     +   'The required program=',a,'  does not exist.'/
     +   'Please correct the problem and try again.'//)
         stop 'Required external antenna program does not exist.'
      end if
c**********************************************************************
C        Call ANTTYPxx.EXE to create GAINxx.DAT file:
C
      PROGRAM=run_directory(1:nch_run-3)//'bin_win'//PATH_SEPARATOR//exe//' '//
     +             run_directory(1:nch_run)//' '//mode
#else
      PROGRAM=exe//' '//trim(run_directory)//' '//trim(root_directory)//' '//mode
#endif
      nch=lcount(PROGRAM,300)
c jw      call gh_exec(PROGRAM,nch,1)   !  execute and wait for ANTTYPxx.EXE
      call system(PROGRAM)
      if(mode.eq.' ') return     !  point-to-point is done

C           Open GAINxx.DAT file
      open(22,file=run_directory(1:nch_run)//PATH_SEPARATOR//fileant,
     1            status='old', err=910)
      rewind(22)
      read(22,'(a)') alf
      read(22,'(a)') alf
      read(22, 292 ) freq, eff
292   format( 10x, f7.3, 10x, f10.3 )


c           Read the rest of the file which contains antenna gain info
      do iazim=0,359
c jw         call yieldit
         read( 22, 293 ) ( areagain(ielev), ielev=1,91 )
293      format( 9x, 10f7.3 )
         call antsave( idx, iazim, freq, eff, areagain )
      end do

c           We are done.  Close up, take your ball, and go home.
      close( 22 )
      return
c*****End Harris mod      *************************************************
900   write(*,901) run_directory(1:nch_run)//dat
901   format('Could not create file:',a)
      go to 920
910   write(*,911) run_directory(1:nch_run)//PATH_SEPARATOR//fileant
911   format('Could not OPEN file:',a)
920   write(*,921)
921   format('Failure in subroutine harris')
      stop 'Fatal error in subroutine harris'
      end
c-------------------------------------------------------

c# setout.f
      SUBROUTINE SETOUT
C--------------------------------
C
C     THIS ROUTINE SETS THE LINES TO BE OUTPUT IN SUBROUTINE OUTTOP AND
C     SUBROUTINE OUTBOD DEPENDENT ON METHOD. THE USER MAY SPECIFY THE
C     LINES TO BE OUTPUT BY RUNNING METHOD 23 AND SPECIFYING THE LINES
C     ON "TOPLINES" AND "BOTLINES" CONTROL CARDS
C     THE ROUTINE ALSO SETS OR ZEROS ARRAYS BEFORE EXECUTING
C
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
C.....SET MUFS TO -1
      DO 100 ICR=1,24
      UTIME(ICR) = -1.
      EMUF(ICR) = -1.
      F1MUF(ICR) = -1.
      F2MUF(ICR) = -1.
      ESMUF(ICR) = -1.
      ALLMUF(ICR) = -1.
      FOT(ICR) = -1.
      XLUF(ICR) = -1.
      HPF(ICR) = -1.
  100 ANGMUF(ICR) = -1.
C.....SET CONTROL PARAMETERS
      GRPTYP = 1.
      LINES = LINMAX
      NLINE = LINMAX
      DO 105 LIN = 1,15
  105 LINTOP(LIN) = -1
      DO 110 LIN = 1,26
  110 LINBOT(LIN) = -1
C.....BRANCH TO SET USER SELECTED LINES IF METHOD = 23
      IF(METHOD.eq.23) go to 515
C.....SET LINES POSITIVE TO PRINT IN OUTTOP AND OUTBOD
      NTOP = 3
      NBOD = 1
      IF(ITRUN.eq.3 .or. ITRUN.eq.4) then
         NTOP = 3
      else IF(ITRUN.eq.8) then
         NTOP = 6
      else IF(METHOD.eq.16) then
         NTOP = 7
         NBOD = 13
      else IF(METHOD.eq.17) then
         NTOP = 7
      else IF(METHOD.eq.18) then
         NTOP = 6
      else IF(METHOD.eq.19) then
         NTOP = 3
         NBOD = 5
      else IF(METHOD.eq.20) then
         NTOP = 7
         NBOD = 21
      else IF(METHOD.eq.21) then
         NTOP = 7
         NBOD = 21
      else IF(METHOD.eq.22) then
         NTOP = 7
         NBOD = 21
      else IF(METHOD.eq.23) then
      else IF(METHOD.eq.24) then
         NTOP = 6
      else IF(METHOD.eq.25) then
         NTOP = 6
         NBOD = 22
      end if
      DO 405 LIN=1,NTOP
  405 LINTOP(LIN) = 1
C.....FIX METHODS THAT DON'T PRINT CONSECUTIVE LINES IN OUTBOD
      IF(METHOD.eq.17) then
         NBOD = 6
         LINBOT(1) = 1
         LINBOT(2) = 1
         LINBOT(5) = 1
         LINBOT(7) = 1
         LINBOT(10) = 1
         LINBOT(12) = 1
         GO TO 510
      end if
      IF(METHOD.eq.18) then
         NBOD = 6
         LINBOT(1) = 1
         LINBOT(2) = 1
         LINBOT(5) = 1
         LINBOT(7) = 1
         LINBOT(10) = 1
         LINBOT(14) = 1
         GO TO 510
      end if
      IF(METHOD.eq.24) then
         NBOD = 1
         LINBOT(12) = 1
         GO TO 510
      end if
      DO 505 LIN =1,NBOD
  505 LINBOT(LIN) = 1
C.....SET LAST ELEMENT OF LINTOP AND LINBOT TO NUMBER OF LINES
  510 LINTOP(15) = NTOP
      LINBOT(26) = NBOD
ccc      GO TO 580
C.....SET USER DEFINED LINES TO OVERRIDE METHOD IF SET BY "TOPLINES"
C.....IF METHOD = 23
  515 IF(LINTYP) 550, 550, 520
  520 DO 525 LIN = 1,15
  525 LINTOP(LIN) = -1
      NTOP = 0
      DO 540 LIN = 1,14
      ITEMP = LINTP(LIN)
      IF(ITEMP) 540, 540, 530
  530 IF(ITEMP - 14) 535, 535, 540
  535 LINTOP(ITEMP) = 1
      NTOP = NTOP + 1
  540 CONTINUE
      LINTOP(15) = NTOP
C.....SET USER DEFINED LINES TO OVERRIDE METHOD IF SET BY "BOTLINES"
C.....IF METHOD = 23
  550 IF(LINBYP) 580, 580, 555
  555 DO 560 LIN = 1,26
  560 LINBOT(LIN) = -1
      NBOD = 0
      DO 575 LIN = 1,14
      ITEMP = LINBD(LIN)
      IF(ITEMP) 575, 575, 565
  565 IF(ITEMP - 25) 570, 570, 575
  570 LINBOT(ITEMP) = 1
      NBOD = NBOD + 1
  575 CONTINUE
      LINBOT(26) = NBOD
  580 CONTINUE
      RETURN
      END
C--------------------------------

c# hfarea.f
      SUBROUTINE hfarea(*)
      use crun_directory
c jw      include <windows.ins>
      common /Ccancel_batch/ icancel_batch
      common /cQUIET/ iquiet
      common /Careach/ areach      !  =I=inverse area
         character areach*1
      common /cantenna/ numants,iats(20),anttype(20),antname(20),
     +                  xfqs(20),xfqe(20),designfreq(20),antfile(20),
     +                  beammain(20),offazim(20),cond(20),diel(20),
     +                  array(30,91,22),aeff(30,20)
      character anttype*10,antname*70,antfile*24
C--------------------------------
      common /Cround/ iround
C
C     THIS IS THE PROGRAM CONTROL SUBROUTINE
C     ITRUN CONTROLS PROGRAM TASK, ITOUT CONTROLS PROGRAM OUTPUT.
C
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON /RTANT /XETA, XSIG, XEPS, XND, XNL, XNH, TEX (4), ITANT,
     1 IRANT, RETA, RSIG, REPS, RND, RNL, RNH, REX(4), TEFF, REFF,
     2 KASANT(2), ITSANT, JTSANT
      COMMON / SSP / SUN(2,12), MONTH
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
*D     COMMON/INDICEZ/ISP,ISZ,IFQN,IUR,NMS(11,24,4,2)
*D     common/lpalmcmp/imddl(45,2,11,24,4,2),igdfx(45,2,11,24,4,2),
*D    +itlos(45,2,11,24,4,2),ihpfx(45,2,11,24,4,2),lNANG(2,11,24,4,2)
*D     integer*2 imddl,igdfx,itlos,ihpfx,lNANG
      COMMON /RGRID/ IPROJ,PLAT,PLON,XMIN,XMAX,YYMIN,YMAX,NX,NY
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      common /cdaily/ idaily(12)
      common /Cday/ iday
      character alf*20
c jw      logical doesit*1
      logical*1 doesit
c jw      logical*4 fexists@
      logical*4 fexists
      integer*4 error_code4
      integer*2 error_code
      data D2R/.01745329/
c------------------------------------------------------------------------
C.....START OF PROGRAM
C.....SET THE LOGICAL UNITS FOR SYSTEM INPUT AND OUTPUT FILES.
C     THE USER MUST INCLUDE AN "AUXIN" AND/OR AN "AUXOUT" CARD IF THE
C.....AUXILIARY INPUT AND/OR OUTPUT FILES ARE TO BE USED.
      LUI = LU5
      LUO = LU6
c***********************************************************************
c jw      nch_run=lcount(run_directory,50)
      MONTH=MONTHS(1)
      SSN=SUNSP(1)
      call REDMAP(SSN,MONTH)
      iday=idaily(1)            !  day of the month (if used)
      if(iday.ne.0) call redaily(ssn,month,iday)
      nf=1
      do 5 nf=1,11
      if(frel(nf).eq.0.) go to 6
5     continue
6     nf=nf-1
      call outarea(-nx,-ny)                !  output headers
      meth=METHOD
      if(MSPEC.eq.121) meth=30             !  smoothing method
      if(nf.eq.1) then
         if(iquiet.eq.0) 
     +   write(*,21) meth,IMON(MONTH),IHRO,nint(SSN),frel(1)
21       format(20x,' Method',i3,1x,a3,i3.2,'ut',i4,'ssn  Freqs=',f6.2)
      else
         if(iquiet.eq.0) 
     +   write(*,22) meth,IMON(MONTH),IHRO,nint(SSN),nf
22       format(20x,' Method',i3,1x,a3,i3.2,'ut',i4,'ssn  max of',
     +          i3,' Freqs')
      end if
      tlat=tlatd*d2r
      tlong=tlongd*d2r
      rlat=rlatd*d2r
      rlong=rlongd*d2r
      if(areach.eq.'I') then            !  inverse area coverage
         rlat=tlat
         rlong=tlong
         rlatd=tlatd
         rlongd=tlongd
         if(iquiet.eq.0) write(*,'(''Area Inverse'')')
      end if
ccc      write(72,'(''Tx, Rx='',4f12.4)') tlatd,tlongd,rlatd,rlongd
c*****************************************************************
      DO 900 IY=1,NY
c jw      if(iquiet.eq.0) then
c jw         if(iy.eq.1) then
c jw            write(alf,'(i3,'' rows['',i2)') ny,iy
c jw         else
c jw            write(alf,'(i3)') iy
c jw         end if
c jw         call soua@(alf)
c jw         if(mod(iy,20).eq.0) then
c jw            call sou@(' ')            !  cause a <new line>
c jw            call coua@('        ')    !  space over to line things up
c jw         end if
c jw       end if
      if(iquiet.eq.0) then
         if(iy.eq.1) then
             write(unit=*,fmt='(i3, '' rows '')') ny !jw
             write(unit=*,fmt='(''['', i4)', advance='no') iy !jw
         else
             write(unit=*,fmt='(i4)', advance='no') iy !jw
         end if

         if(mod(iy,15).eq.0) then !jw
            write(*,*) ' '            !  cause a <new line>
            write(unit=*,fmt='(A)', advance='no') ' '
         end if
      end if
c          check to see if we should abort processing
c jw      doesit=fexists@(run_directory(1:nch_run)//'\voaarea.abt',error_code4)
c jw      if(doesit) then      !  file exists, abort area calculations
c jw         call erase@(run_directory(1:nch_run)//'\voaarea.abt', error_code)   !  delete file first
c jw         call unlink(run_directory(1:nch_run)//'\voaarea.abt', error_code)   !  delete file first
c jw         return 1
c jw      end if
      if(icancel_batch.ne.0) return     !  other cancel button picked
      DO 900 IX=1,NX
c jw      call yieldit    !  yield for Windows
      if(areach.ne.'I') then            !  normal area coverage
         CALL GRIDXY(IX,IY,RLONGD,RLATD)      !  GET LON/LAT of RECEIVER
ccc         if(iround.ne.0) then
ccc            rlongd=roundit(rlongd)   !  round to nearest .01 deg
ccc            rlatd=roundit(rlatd)    !  round to nearest .01 deg
ccc         end if
         if(abs(RLATD-TLATD).lt..05 .and. 
     +      abs(RLONGD-TLONGD).le..05) then
            RLONGD=TLONGD+.05
            if(RLONGD.ge.360.) RLONGD=RLONGD-360.
         end if
         if(abs(RLATD).gt.89.9) RLONGD=0.   !  at poles, force longitude=0
         RLONG=RLONGD*D2R
         RLAT=RLATD*D2R
      else                              !  Inverse Area Coverage
         CALL GRIDXY(IX,IY,TLONGD,TLATD)      !  GET LON/LAT of RECEIVER
         if(abs(TLATD-RLAT/D2R).lt..05 .and. 
     +      abs(TLONGD-RLONG/D2R).le..05) then
            TLONGD=RLONG/D2R+.05
            if(TLONGD.ge.360.) TLONGD=TLONGD-360.
         end if
         if(abs(TLATD).gt.89.9) TLONGD=0.   !  at poles, force longitude=0
         TLONG=TLONGD*D2R
         TLAT=TLATD*D2R
         call dazel0(tlatd,tlongd,rlatd,rlongd,ztaz,dist)
         beammain(1)=ztaz       !  set main beam antenna direction
      end if
      do 10 i=1,24
10    allmuf(i)=-1.
ccc      NPSL=0            !  shortest path  (get NPSL from CIRCUIT card)
ccc      NPSL=1            !  thru antipode
ccc      write( *,711) ix,iy,tlong/d2r,tlat/d2r,rlong/d2r,rlat/d2r
ccc      write(72,711) ix,iy,tlong/d2r,tlat/d2r,rlong/d2r,rlat/d2r
ccc711   format(2i5,4f12.4)
C==================================================================
      CALL GEOM
      CALL SANG         !  reduce angle scan for this distance
C.....SET OUTPUT ARRAYS
      CALL SETOUT
C.....SET CONTROL PARAMETER FOR FREQUENCY COMPLEMENTS
      IFREQ = 1
C.....BEGIN HOUR LOOP
      JT = IHRO
      IUR=jt
      JTX = JT
      CALL GEOTIM(JT)   !  convert UT to LMT, etc
C.....WANT TO USE LONG TERM COEFFICIENTS
C.....TIME VARIATION OF MAPS
      CALL VIRTIM       !  UT variation of critical frequencies, F2M(3000)
      CALL TIMVAR       !  LMT dependency and E and F1 parameters
      CALL F2VAR        !  F2 parameters (F1 may be changed)
      CALL ESIND        !  Sporatic E parameters
      CALL IONSET
      CALL CURMUF       !  MUF by full ionosphere, and FOT calculation
      FREL(12) = ALLMUF(IT)
      IF(METHOD.EQ.22.OR.METHOD.EQ.25.OR.MSPEC.EQ.125)THEN
C.......FORCE SHORT PATH MODEL
        IPFG=100
      ELSE IF(METHOD.EQ.21)THEN
        IF(MSPEC.EQ.121)THEN
C.........SET FOR SHORT PATH AND USE LONGPATH/SHORTPATH SMOOTHING
          IPFG=100
        ELSE
C.........FORCE LONG PATH MODEL
          IPFG=200
        ENDIF
      ELSE
C.......FORCE LONG PATH MODEL IF PATH LENGTH .GT. SPECIFIED LIMIT
        IPFG=100
        IF(MSPEC.ne.121 .and. GCDKM.GT.GCDLNG)IPFG=200
        IF(GCDKM.GT.GCDLNG)IPFG=200
      ENDIF
ccc      write(luo,111) ix,iy,method,npsl,ipfg,gcdkm,frel(12)
ccc111   format(5i5,f10.1,f10.3)
      CALL LUFFY(IPFG)
      CALL SETLUF
      call outarea(ix,iy)
C==================================================================
900   CONTINUE
c jw      if(iquiet.eq.0) call sou@(']')
      if(iquiet.eq.0) print *, ']' !jw
C******************************************************************
C.....END OF RUN
      RETURN
      END
C--------------------------------
      function roundit(x)    !  round to nearest .01 deg
      ix=abs(x)*100. +.5
      roundit=float(ix)/100.
      if(x.lt.0.) roundit=-roundit
      return
      end
C--------------------------------

      module voacapl_defs
#ifdef _WIN32
        character(len=1), parameter :: PATH_SEPARATOR ='\'
        integer, parameter :: MAX_AREA_MONTHS = 9
#else
        character(len=1), parameter :: PATH_SEPARATOR ='/'
        integer, parameter :: MAX_AREA_MONTHS = 25
#endif

#if defined(VERSION)
        character(len=*), parameter :: VOACAPL_VERSION = VERSION
#else
        character(len=*), parameter :: VOACAPL_VERSION = "Test"
#endif
      end module voacapl_defs

C SUBROUTINE ECH               (NEXT)
      SUBROUTINE ECH(ZSUM) 
C 
C     ECH - CALCULATES THE MUTUAL IMPEDANCE BETWEEN LINEAR DIPOLE 
C        ELEMENTS IN ECHELON OF EQUAL LENGTHS.
C     SEE THE REFERENCES IN SUBROUTINES GAIN AND COLL.
C 
      COMPLEX CSU1, CSU2, CSUZP, CSV1, CSV2, CSVZP, CSZ1, ZE, ZSUM
C 
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RO, VOFL 
C 
      COMMON /CUR /DIJ, EIL, HIJ, KODE
C 
C.......................................................................
      D2 = DIJ * * 2
      HML = HIJ - EIL 
      HPL = HIJ + EIL 
      T = SQRT (D2 + HML * * 2) 
      UZ = PI2 * (T + HML)
      VZ = PI2 * (T - HML)
      T = SQRT (D2 + HPL * * 2) 
      UZP = PI2 * (T - HPL) 
      VZP = PI2 * (T + HPL) 
      TS = HIJ
      T = SQRT (D2 + TS * * 2)
      U1 = PI2 * (T + TS) 
      V1 = PI2 * (T - TS) 
      TS = HIJ + 2.0 * EIL
      T = SQRT (D2 + TS * * 2)
      U2 = PI2 * (T - TS) 
      V2 = PI2 * (T + TS) 
      TS = HIJ + 3.0 * EIL
      T = SQRT (D2 + TS * * 2)
      U4 = PI2 * (T - TS) 
      V4 = PI2 * (T + TS) 
      CSU1 = CSZ1 (U1)
      CSV1 = CSZ1 (V1)
      CSU2 = CSZ1 (U2)
      CSV2 = CSZ1 (V2)
      CSUZP = CSZ1 (UZP)
      CSVZP = CSZ1 (VZP)
      ZSUM = CMPLX (0.0, 0.0) 
      T = PI2 * (EIL - HIJ) 
      ZE = CMPLX (COS (T), SIN (T)) 
      ZSUM=ZSUM + CONJG(ZE)*(CSZ1(UZ) - CSU1) + ZE*(CSZ1(VZ) - CSV1)
      T = PI2 * (EIL + HIJ) 
      ZE = CMPLX (COS (T), SIN (T)) 
      ZSUM = ZSUM + CONJG (ZE) * (CSUZP - CSU2) + ZE * (CSVZP - CSV2) 
      T = PI2 * ( - EIL - HIJ)
      ZE = CMPLX (COS (T), SIN (T)) 
      ZSUM=ZSUM + CONJG(ZE)*( -CSU1 + CSVZP) + ZE*( -CSV1 + CSUZP)
      T = PI2 * (3.0 * EIL + HIJ) 
      ZE = CMPLX (COS (T), SIN (T)) 
      ZSUM=ZSUM + CONJG(ZE)*( -CSU2+CSZ1(U4)) + ZE*( -CSV2+CSZ1(V4))
      TS = 2.0 * COS (PI2 * EIL)
      T = PI2 * HIJ 
      ZE = CMPLX (COS (T), SIN (T)) 
      ZSUM=ZSUM+TS*CONJG(ZE)*(-CSV1+CSUZP)+TS*ZE*(-CSU1+CSVZP)
      T = PI2 * (2.0 * EIL + HIJ) 
      ZE = CMPLX (COS (T), SIN (T)) 
      ZSUM=ZSUM + TS*CONJG(ZE)*(CSUZP - CSU2) + TS*ZE*(CSVZP-CSV2)
      IF (KODE .GT. 0) GO TO 100
      ZSUM = ZSUM * 15.0
      GO TO 105 
 100  ZSUM = ZSUM * 30.0 / (1.0 - COS (2.0 * PI2 * EIL))
 105  RETURN
      END

c###outmuf.for
      SUBROUTINE OUTMUF
C--------------------------------
C.....THIS ROUTINE TABULATES THE "MUFS" USING A VECTORED FORMAT SCHEME
C.....WHICH PRINTS A "DASH" IF "MUFS" .LE. ONE AND THE VALUE OTHERWISE
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / OUTLAB / LABEL(11), LAYTYP(5), IEAST, INORTH, ISOUTH,
     A IWEST, LABLI, LABLJ, LABLK
      CHARACTER IEAST*1, ISOUTH*1, INORTH*1, IWEST*1, LABEL*5, LAYTYP*2,
     A LABLI*5, LABLJ*5, LABLK*5
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      DIMENSION XFMT(5)
      CHARACTER NFMT(4)*6, IFMT(14)*6, IGMT*6, ILMT*6
      DATA NFMT/',5X,  ', '2H-   ', ',F7.2 ', '      '/
      DATA IFMT(1)/'(1H , '/, IFMT(2)/'2X,   '/, IFMT(3)/'2F6.1 '/,
     A IFMT(14)/'     )'/, IGMT/'   GMT'/, ILMT/'   LMT'/
      LINES = 0
C.....CALL SUBROUTINE OUTTOP TO OUTPUT THE HEADER LINES
      CALL OUTTOP
C.....PRINT THE TABULATION HEADING
      IF(METHOD - 26) 130, 120, 130
  120 WRITE(LUO,901) IGMT, ILMT, LABEL(4), LABEL(7), LABEL(3),
     1 LABEL(10), LABEL(8)
       GO TO 135
  130 WRITE(LUO,902) IGMT, ILMT, LABEL(4), LABEL(7), LABEL(3), LABEL(10)
  135 CONTINUE
C.....BEGIN HOUR LOOP
      DO 400 JT = 1,24
C.....INCREMENT HOUR IF GMT . LT. 0
      IF(UTIME(JT)) 400, 140, 140
C.....INITIALIZE LINE TO PRINT DASHES (CHANGE LATER WHERE NEEDED)
  140 KOUNT = 0
      DO 150 J = 4, 12, 2
  150 IFMT(J) = NFMT(1)
      DO 160 J = 5, 13, 2
  160 IFMT(J) = NFMT(2)
C.....SET TO TABULATE FOT
      KOUNT = KOUNT + 1
      IFMT(4) = NFMT(3)
      IFMT(5) = NFMT(4)
      XFMT(KOUNT) = FOT(JT)
C.....SET TO TABULATE HPF
      KOUNT = KOUNT + 1
      IFMT(6) = NFMT(3)
      IFMT(7) = NFMT(4)
      XFMT(KOUNT) = HPF(JT)
C.....SET TO TABULATE ESMUF
      KOUNT = KOUNT + 1
      IFMT(8) = NFMT(3)
      IFMT(9) = NFMT(4)
      XFMT(KOUNT) = ESMUF(JT)
C.....SET TO TABULATE ALLMUF
      KOUNT = KOUNT + 1
      IFMT(10) = NFMT(3)
      IFMT(11) = NFMT(4)
      XFMT(KOUNT) = ALLMUF(JT)
C.....SET TO TABULATE LUFS (IF METHOD = 26)
      IF(METHOD - 26) 250, 260, 250
  250 IFMT(12) = NFMT(4)
      IFMT(13) = NFMT(4)
      GO TO 280
  260 CONTINUE
      KOUNT = KOUNT + 1
      IFMT(12) = NFMT(3)
      IFMT(13) = NFMT(4)
      XFMT(KOUNT) = XLUF(JT)
  280 CONTINUE
      WRITE(LUO,IFMT) UTIME(JT), XLMT(JT), (XFMT(K),K=1,KOUNT)
  400 CONTINUE
C.....END OF HOUR LOOP
      RETURN
  901 FORMAT(//,' ',2X,2A6,5(2X,A5),/)
  902 FORMAT(//,' ',2X,2A6,4(2X,A5),/)
      END
C--------------------------------

      subroutine batch(lu,model,filein,icircuit,*)  ! Point-to-Point BATCH
c**************************************************************************
c          lu = file unit open of model.CIR
c          model = VOACAP, ICEPAC, or REC533
c          filein = file to create the input data on
c          icircuit = circuit number to be processed
c          * = alternate return when done or if error occurs
c**************************************************************************
         character model*6,filein*(*)

      INCLUDE 'ficepac.hdr'
      character path*5,antenna(5)*63
      character tlatns*1,tlonew*1,rlatns*1,rlonew*1
c**********************************************************************
      icircuit=icircuit+1
      read(lu,1,end=998) tname,itlatdeg,tlatns,itlatmin,
     +                         itlondeg,tlonew,itlonmin,
     +                   rname,irlatdeg,rlatns,irlatmin,
     +                         irlondeg,rlonew,irlonmin,path(1:1)
1     format(1x,a20,1x,i2,a1,i2,1x,i3,a1,i2,2x,
     +          a20,1x,i2,a1,i2,1x,i3,a1,i2,a)
      if(path(1:1).ne.'L') path='SHORT'
      if(path(1:1).eq.'L') path='LONG '
      tlat=float(itlatdeg) + float(itlatmin)/60.
      tlon=float(itlondeg) + float(itlonmin)/60.
      if(tlatns.eq.'S') tlat=-tlat
      if(tlonew.eq.'W') tlon=-tlon
      rlat=float(irlatdeg) + float(irlatmin)/60.
      rlon=float(irlondeg) + float(irlonmin)/60.
      if(rlatns.eq.'S') rlat=-rlat
      if(rlonew.eq.'W') rlon=-rlon
      call benchfix(rname,rlat,rlon)
      call deg2chr(tlat,2,tlatdeg)
      call deg2chr(tlon,3,tlondeg)
      call deg2chr(rlat,2,rlatdeg)
      call deg2chr(rlon,3,rlondeg)
      call circant(lu,nant,antenna)
      numants=nant
      do 30 i=1,nant
      read(antenna(i),2) minfreq(i),maxfreq(i),xmtr_dir(i),xmtr_file(i),
     +                   design_freq(i),beam_main(i),TxPower(i)
2     format(2i5,2x,a8,1x,a12,3f10.3)
      if(beam_main(i).lt.0.) beam_main(i)=0.
30    continue
c************************
      igraph=0
      ipath=1
      if(path(1:1).eq.'L') ipath=2       !  long path
      write(*,51) icircuit,tname,rname,path
51    format(' circuit #',i3,5x,a,' <to> ',a,2x,a,' Path')
ccc      if(model.eq.'ICEPAC') call icepac(igraph)
      call voacap(igraph)
ccc      if(model.eq.'REC533') call rec533(igraph)
      return
c********************************************************
998   write(*,'(i5,'' Batch circuits processed'')') icircuit-1
      write(*,997) model
997   format(' Batch processing for ',a,' is complete.',/
     +       ' You may close this output window now.')
      close(lu)
c          file does not exist or end of file encountered
      return 1
      end
c----------------------------------------------------------------
      subroutine benchfix(rname,rlat,rlon)    !  fix coordinates for benchmark
      character rname*20
      dimension rlatb(27),rlonb(27)
      data rlatb/  50.50,  55.15,  59.83,  66.01,  63.10,  55.16,
     +             44.78,   4.99,  42.83,  44.30,  45.17,  43.44,
     +             38.82,  32.11,  24.01,  -7.11,  33.67,  32.09,
     +             29.81,  22.26,  15.37,   7.85,    .04, -24.30,
     +            -35.59,  37.72,  41.94/
      data rlonb/   8.13,  15.18,  25.38,  63.27,  94.28, 115.79,
     +            129.31, 153.26,  15.47,  23.92,  33.98,  59.11,
     +             75.98,  90.38, 102.63, 135.91,  15.86,  23.12,
     +             31.08,  49.29,  61.55,  73.00,  84.03, 123.09,
     +            173.09,  -1.04,  11.90/
      if(rname(1:1).ne.'#') return            !  not benchmark
      if(rname(2:2).lt.'0' .or. rname(2:2).gt.'9') return
      if(rname(3:3).lt.'0' .or. rname(3:3).gt.'9') return
      read(rname,'(1x,i2)') idx
      if(idx.lt.1 .or.idx.gt.27) return
      if(abs(rlat-rlatb(idx)).gt..02 .or.
     +   abs(rlon-rlonb(idx)).gt..02) return
      rlat=rlatb(idx)
      rlon=rlonb(idx)
      return
      end
c------------------------------------------------------------

c# WINcolr.for
      subroutine WINcolr    !  read DOS color table
      use voacapl_defs
      use crun_directory
      common /WIN_col/ ncolors,DOS_colors(20),colors(20),
     +            ncities_colors,DOS_cities(7),cities_colors(7),
     +            ncontours_colors,DOS_contours(8),contours_colors(8)
         character DOS_colors*6,colors*10
         character DOS_cities*6,cities_colors*20
         character DOS_contours*6,contours_colors*20
      character skip*1
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
c jw      nch_run=lcount(run_directory,50)

      open(17,file=trim(root_directory)//PATH_SEPARATOR//'database'//PATH_SEPARATOR//'colors.win',
     +      status='old',err=900)
      rewind(17)
      read(17,'(a)') skip    !  skip header card
      read(17,*) ncolors,ncities_colors,ncontours_colors
      do 10 i=1,ncolors
10    read(17,11) DOS_colors(i),colors(i)
11    format(a6,1x,a)
      do 20 i=1,ncities_colors
20    read(17,11) DOS_cities(i),cities_colors(i)
      do 30 i=1,ncontours_colors
30    read(17,11) DOS_contours(i),contours_colors(i)
      close(17)
      return
900   write(*,'('' Could not OPEN file='',a,1h;)') 
     +     trim(root_directory)//PATH_SEPARATOR//'database'//PATH_SEPARATOR//'colors.win'
      stop 'Missing file: colors.win'
      end

c###outtab.for
      SUBROUTINE OUTTAB
C--------------------------------
C.....THIS ROUTINE TABULATES THE VARIABLE TO BE TABULATED WITH ALLMUF
C.....VS. FREQUENCY IN SUBROUTINE TABBOD
      COMMON / OUTGH / PLOTI(24), PLOTJ(24), PLOTK(24), XOUT(13), NPLOTS
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
C.....SET THE VARIABLE TO BE TABULATED DEPENDENT OF METHOD
      DO 120 I = 1,13
  120 XOUT(I) = RELIAB(I)
C.....PRINT TOP OF PAGE INFORMATION IF FIRST TIME IN HOUR LOOP
      IF(LINES.ge.LINMAX) then
         CALL OUTTOP
         LINES=9            !  fake for TABBOD
      end if
      CALL TABBOD
      RETURN
      END
C--------------------------------

      function gainterb(gainab,freqoper)
c          interpolate directivity gain given:
c              gainab(2-30) = gain @  2 - 30 MHz
c              freqoper      = operating frequency
      dimension gainab(*)
      idx=freqoper
      if(idx.eq.30) idx=29     !  can't exceed 30
      fact=freqoper-float(idx)
      gainterb=gainab(idx) + (gainab(idx+1)-gainab(idx))*fact
      return
      end
c----------------------------------------------------

c###gettop.for
      SUBROUTINE  GETTOP(DIKM, GMKM)
C--------------------------------
C
C     THIS SUBROUTINE FINDS THE DISTANCE SUPPORTING M MODES,
C     E.G., NIGHT-DAY-NIGHT PATH
C
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      DIMENSION FPE(3)
C  FIND DISTANCE THAT SUPPORT  E (M)  MODE.
      DEL = DELOPT*D2R
      RCOSD = RZ*COS(DEL)
      DO 105  JF = 1,3
      HT = HI(1,JF)
      FV = FI(1,JF)
      SPHE = RCOSD/(RZ +HT)
      SPHE = SPHE*SPHE
      SPHE = AMIN1(SPHE, 0.9999)
C.....E PENETRATION FREQUENCIES
  105 FPE(JF) = FV/SQRT(1.-SPHE)
C.....END
      FP1 = AMAX1(FPE(1),FPE(3))
C.....MIDDLE
      FP2 = FPE(2)
C.....END
      FP3 = AMIN1(FPE(1),FPE(3))
C.....THE MIDDLE IS --
      IF(FP1-FP2) 170,235,235
  170 IF(FREQ -FP2 -.001) 175,235,235
  175 IF(FREQ -FP1 +.001) 235,235,185
  185 GMKM =  0.5 * DIKM * (FP2-FREQ) * (1./(FP2-FP1) + 1./(FP2-FP3))
      IF(GMKM - 1000.) 235,235,225
C.....MUST BE ABLE TO GET UP THERE FOR M MODE
  225 IF(DIKM -GMKM -1000.) 235,235,240
  235 GMKM=0.
  240 CONTINUE
      RETURN
      END
C--------------------------------

      subroutine squeez(alf,maxch)     !  squeeze multiple blanks out
      character alf*(*),tmp*120
      nch=lcount(alf,maxch)

10    idx=index(alf(1:nch),'  ')
      if(idx.eq.0) return
      nn=nch-idx-1
      tmp(1:nn)=alf(idx+2:nch)//' '
      alf(idx+1:nch)=tmp(1:nn)
      nch=nch-1
      go to 10
      end

c###fixlin.for
      SUBROUTINE FIXLIN(jfmt,IVAR,LIN)
C--------------------------------
C.....THIS SUBROUTINE WRITES A VECTOR FORMATTED LINE
C     FOR A FIXED POINT (INTEGER) VARIABLE
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON / OUTFMT / KLINE(26)
      DIMENSION IVAR(13)
      character jfmt*(*)
      CHARACTER NDASH*4
      CHARACTER KLINE*6
      DATA IMUF/12/, NDASH/'  - '/
      IF(LIN.le.0 .or.LIN.gt.30) return
      jfmt(8:15)='i5      '
      WRITE(LUO,jfmt) IVAR(IMUF), (IVAR(I),I=1,JFREQ),
     A (NDASH,J=1,JDASH), KLINE(LIN)
      RETURN
      END
C--------------------------------

      function it_exist(file)
c***************************************************************
c          if FILE does     exist, it_exist=1
c          if FILE does not exist, it_exist=0
c***************************************************************
      character file*(*)
ccc      integer*2 idate,itime
      logical doesit*4,fexists@*4
      integer*4 error_code
      it_exist=1
ccc      call get_file_date_time_stamp@(file,idate,itime)
ccc      if(idate.eq.-1) it_exist=0      !  file does not exist
      doesit=fexists@(file,error_code)
      if(.NOT.doesit) it_exist=0      !  file does not exist
      return
      end
c-----------------------------------------------------------

        subroutine azmax (iant,u, vmin1, vmax1, vm, rmax, vmax)
c          given:
c               u = elevation angle
c               azimuth from vmin1 to vmax1, step vm
c          find:
c               rmax = maximum relative gain
c               vmax = azimuth angle at vmax
c
        dimension w(0:362)
c
        i = 0
        j = 0
        w(0) = rmax
        do 1675 v = vmin1, vmax1, vm
        call gainrel(iant,u, v, z9)
        i = i + 1
        w(i) = z9
ccc        if (w(i).lt.w(i - 1)) then
        if (w(i).lt.rmax) then
          j=0
ccc        elseif (w(i).gt.w(i - 1)) then
        elseif (w(i).gt.rmax) then
          rmax=w(i)
          vmax=v
        else       
          j = j + 1
          rmax = w(i)
          if(v.ne.vmax) vmax = v - j / 2.0 + 1.0
        endif
 1675   continue
        return
        end
c----------------------------------------------------------------

c###versy.for
      SUBROUTINE VERSY(KIK, LIK, II)
C--------------------------------
C
C     THIS ROUTINE EVALUATES THE GEOGRAPHIC VARIATION OF THE LONG TERM
C     PREDICTION MAPS. (THE MAPS WERE READ IN SUBROUTINE REDMAP)
C     THE TIME VARIATION IS PERFORMED IN SUBROUTINE VIRTIM
C     NOTE THAT "AB" IS A TWO DIMENSIONAL ARRAY TREATED AS A
C     SINGLE DIMENSIONED ARRAY
C
C KIK IS START,1,2,3 ARE ES, 4,5,F2 AND 6 IS REGULAR E.
C LIK IS STOP
C
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON /GEOG /GYZ (5), RAT (5), GMDIP (5), CLCK (5), ABIY (5), ART
     1IC (5), SIGPAT (5), EPSPAT (5)
      COMMON /A11 /GAMMA (6)
      COMMON / ONE /   IA(6), IB(6), IKIM(10,6), ESLCOF(5,55),
     1                 ESMCOF(7,61), ESUCOF(5,55), F2COF(13,76),
     2                 FM3COF(9,49), ERCOF(9,22)
      COMMON / TWO / F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     A FAM(14,12), SYS(9,16,6), PERR(9,4,6)
      COMMON /TWO_AB/ AB(318)
      DIMENSION IC (6), G (76)
      real*8 sx,x,g,cx,t    !  to solve floating point underflows
C.....IC ARE THE ARRAY LIMITS FOR EACH VARIABLE
      DATA IC/1,56,117,172,248,297/
      C360 = 360. * D2R
C.....SAMPLE AREA LONGITUDE AND LATITUDE
      CENLG = CLONG (II)
      CENLAT = CLAT (II)
      IF (CENLG)100, 105, 105
C.....CHANGE TO EAST LONGITUDE
  100 CLG = C360 + CENLG
      GO TO 110
  105 CLG = CENLG
  110 GOB = COS (CENLAT)
      DO 200 IZ = KIK, LIK
      IF (IZ - 6)115, 120, 115
C.....RAWER MAGNETIC DIP ANGLE
  115 X = GMDIP (II)
      GO TO 125
C.....USE LATITUDE FOR REGULAR E
  120 X = CENLAT
  125 Y = CLG
C.....LIMITS FOR FOURIER SERIES
      I = IKIM (9, IZ) + 1
      K = IKIM (1, IZ)
      SX = SIN (X)
      G (1) = 1.
C.....CALCULATE THE GEOGRAPHIC COORDINATE FUNCTIONS  G
      G (2) = SX
      IF (K - 1)130, 140, 130
  130 IF (K .LT. 2) GO TO 210
      DO 135 KA = 2, K
  135 G (KA + 1) = SX * G (KA)
  210 CONTINUE
  140 KDIF = IKIM (2, IZ) - K
      IF (KDIF)145, 190, 145
  145 JG = 1
      CX = GOB
      T = Y
  150 KK = IKIM (JG, IZ) + 4
      G (KK - 2) = CX * COS (T)
      G (KK - 1) = CX * SIN (T)
      LO = IKIM (JG + 1, IZ)
      IF (KDIF - 2)155, 175, 155
  155 IF (LO - KK)175, 160, 160
  160 IF (LO .LT. KK) GO TO 215
      DO 170 KA = KK, LO, 2
      IF (KA - LO)165, 165, 170
  165 G (KA) = SX * G (KA - 2)
  170 G (KA + 1) = SX * G (KA - 1)
  215 CONTINUE
  175 IF (JG - 8)180, 190, 180
  180 KDIF=IKIM(JG+2,IZ)-LO
      IF (KDIF)185, 190, 185
  185 CX = CX * GOB
      JG = JG + 1
      FJ = JG
      T = FJ * Y
      GO TO 150
  190 ISUBA = IC (IZ)
C     AB(1,IZ)
C.....FINAL SUMMATION OF THE FOURIER EXPANSION
      GAMMA (IZ) = G (1) * AB (ISUBA)
      IF (I .LT. 2) GO TO 220
      DO 195 JB = 2, I
C     AB(JB,IZ)
      ISUBA = IC (IZ) + JB - 1
      GAMMA (IZ) = GAMMA (IZ) + AB (ISUBA) * G (JB)
  195 CONTINUE
  220 CONTINUE
  200 CONTINUE
      RETURN
      END
C--------------------------------

C COMPLEX FUNCTION CSZ1       (NEXT)
      COMPLEX FUNCTION CSZ1 (X) 
C 
C     CSZ1 - EVALUATES THE COSINE-INTEGRAL AND SINE-INTEGRAL FUNCTIONS. 
C     SEE THE REFERENCES IN SUBROUTINE GAIN AND THOSE GIVEN BELOW.
C 
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RO, VOFL 
C 
      COMPLEX A,AM1, AM2, B,BM1, BM2, SA
      real*8 testq,t,tm1
C 
C 
C.....TEST ARGUMENT RANGE...............................................
ccc      DATA TESTQ / 4.0E-10/ 
      DATA TESTQ / 4.0E-9/     !  the above values cause floating point errors
      IF (X .GT. 6.0) GO TO 120 
C.....FOR X .LE. 6 USE THE SERIES EXPANSION.............................
C. . .SEE THE HANDBOOK OF MATHEMATICAL FUNCTIONS, ABRAMOWITZ AND STEGUN,
C. . .P 232, EQU 5.2.14 AND 5.2.16 . . . . . . . . . . . . . . . . . . .
      EN = 0.0
      X2 = X * * 2
      TN = X
      SI = X
 100  EN = EN + 1.0 
      TN = - TN * X2 * (2.0 * EN - 1.0) / ((2.0 * EN) * (2.0 * EN + 1.0)
     1 * * 2) 
      IF (ABS (TN / SI) .LE. TESTQ) GO TO 105 
      SI = SI + TN
      GO TO 100 
 105  EN = 1.0
      TN = - X2 / 4.0 
      CI = TN + GAMA + ALOG (X) 
 110  EN = EN + 1.0 
      TN = - TN * X2 * (2.0 * EN - 2.0) / ((2.0 * EN - 1.0) * (2.0 * EN)
     1 * * 2) 
      IF (ABS (TN / CI) .LE. TESTQ) GO TO 115 
      CI = CI + TN
      GO TO 110 
 115  CSZ1 = CMPLX (CI, - SI) 
      GO TO 145 
C.....FOR X .GT. 6 USE THE CONTINUED FRACTION EXPANSION.................
C. . .SEE  ANALYSIS AND DESIGN OF THE LOG PERIODIC DIPOLE ANTENNA. . . .
C. . .BY ROBERT L. CARREL, UNIV. OF ILL. ANTENNA LAB. TECH. REPORT . . .
C. . .NUMBER 52 (NTIS NO. AD264558), PAGE 177 (APPENDIX A) . . . . . . .
 120  AM1 = (1.0, 0.0)
      AM2 = (1.0, 0.0)
      BM1 = (1.0, 0.0)
      BM2 = (0.0, 0.0)
      P = 0.0 
      K = 0 
      TM1 = 0.0 
 125  P = P + 1.0 
      K = K + 1 
      IF (MOD (K, 2) .EQ. 0) GO TO 130
      SA = CMPLX (0.0, (P + 1.0) / (2.0 * X)) 
      GO TO 135 
 130  SA = CMPLX (0.0, P / (2.0 * X)) 
 135  A = AM1 + SA * AM2
      B = BM1 + SA * BM2
      CSZ1 = A / B
      T = CABS (CSZ1) 
      IF (DABS ((T - TM1) / T) .LE. TESTQ) GO TO 140 
      AM2 = AM1 
      AM1 = A 
      BM2 = BM1 
      BM1 = B 
      TM1 = T 
      GO TO 125 
140   CSZ1=CMPLX(0.0,PIO2)+CMPLX(COS(X),SIN(X))/(CMPLX(0.0,X)*CSZ1)
      CSZ1 = CONJG (CSZ1) 
 145  RETURN
      END 

      subroutine lcase(ialf,nch)
c          Convert all UPPER case letters in IALF to lower case
      character ialf*(*)
      do 10 i=1,nch
      ich=ichar(ialf(i:i))
      if(ich.ge.65 .and. ich.le. 90) ialf(i:i)=char(ich+32)
 10   continue
      return
      end

      function lenchar(LABEL)
      CHARACTER*(*) LABEL
      max=len(label)
      DO 10 I=MAX,1,-1
      IF(LABEL(I:I).eq.char(0)) GO TO 10
      IF(LABEL(I:I).NE.' ') GO TO 20
10    CONTINUE
20    lenchar=I
      RETURN
      END
C------------------------------------------------------------------

c# monitr.f
      FUNCTION MONITR(LU,NX)
C--------------------------------
C
C / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
C
C     THIS FUNCTION READS A CARD IMAGE FROM LOGICAL UNIT LU.
C     THE FIRST TEN COLUMNS CONTAIN A STRING OF 10 HOLLERITH
C     CHARACTERS CALLED THE "NAME IDENTIFIER". THE "NAME IDENTIFIER"
C     IS COMPARED WITH THE LIST OF 10-CHARACTER STRINGS STORED IN THE
C     ARRAY CALLED "NAMES". IF A MATCH IS FOUND, THE VALUE OF MONITR
C     IS SET EQUAL TO THE SUBSCRIPT OF THE MATCHING NAME IN THE LIST.
C     A MAXIMUM OF NX NAMES WILL BE SEARCHED. IF NO MATCHING NAME
C     IS FOUND, THE VALUE OF MONITR WILL BE SET TO NX + 1.
C
C / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
C
      COMMON / NAMEX / NAMES(100), INPUT
      CHARACTER NAMES*10, INPUT*85
      CHARACTER NAME*10
C
C
C-----------------------------------------------------------------------
C
C.....READ ONE CARD WITH THE "NAME IDENTIFIER" IN COLUMNS 1 - 10.
      READ(LU,'(a)',end=900) INPUT
      NAME = INPUT (1:10)
      IF (NX .LT. 1) GO TO 145
      DO 100 I = 1, NX
      IF(NAME .EQ. NAMES(I)) GO TO 105
 100  CONTINUE
 145  CONTINUE
C - - - - - - THERE WAS NO MATCHING NAME IN THE LIST OF NAMES.
      MONITR = NX + 1
      RETURN
C - - - - - - A MATCHING NAME WAS FOUND.
 105  MONITR = I
ccc      write(*,'('' nx='',i5)') nx
ccc      write(*,2) i,lu,input
ccc2     format(' monitr=',i3,'  lu=',i3,' input=',8a10)
      RETURN
900   stop 'EOF read in monitr'
      END
C--------------------------------

C--------------------------------
      SUBROUTINE Curtain(parm,AZIMD,ELEVD,XMGN,GNORM)
c          AZIMD= Degrees from Boresight
c          ELEVD= Elevation angle Degrees
c***************************************************************
c          parm( 1)= gain above isotrope (not used)
c              ( 2)= antenna type [should be 12]
c              ( 3)= Dielectric
c              ( 4)= Conductivity
c              ( 5)= Operating freq
c              ( 6)= # of bays
c              ( 7)= # elements per bay (# of stacks)
c              ( 8)= Design Frequency
c              ( 9)= Antenna element length (>0=meters  <0=wavelengths)
c              (10)= Height above ground (>0  <0)
c              (11)= Horiz Dist between dipole centers (>0  <0)
c              (12)= Vertical displacement (>0  <0)
c              (13)= Distance from Screen (>0  <0)
c              (14)= Vertical Excitation (mode number)
c              (15)= Horizontal Slew Angle
c***************************************************************
      dimension parm(15)
      COMMON/ANTDAT/nostak,STKSPM,NUMBAY,BAYSPM,DIPLNM,RRSPM,STKHTM,
     +STKRAT(8),bayphs(14),DFMHZ,OFMHZ
C*******************************************************
      CHARACTER ICHR*1,IVMA(15)*4
      INTEGER*4 IPHASE(14,8)
      DATA IPHASE/0,  0,  0,  0, 0,  0,  0,  0,  0, 0,  0,  0,  0,  0,
     2            0,  0, 31, 31, 0, 77, 77,109,109, 0,155,155,186,186,
     3            0, 47, 56,103, 0,139,185,195,242, 0,278,324,334,381,
     4            0, 47, 81,128, 0,200,246,281,327, 0,399,446,480,527,
     5            0, 47,105,152, 0,260,306,365,411, 0,519,566,624,671,
     6            0, 47,129,176, 0,318,365,447,494, 0,636,683,765,812,
     7            0, 90,152,242, 0,375,465,527,617, 0,750,840,903,993,
     8            0, 90,180,270, 0,444,534,624,714, 0,888,978,1068,1158/
      data IVMA/'+000','0+00','00+0','++00','+0+0','0++0','+-00',
     +          '+0-0','0+-0','+++0','++-0','+-+0','+--0','++++','++--'/
c......
      data VofL/299.79246/     !  speed of light
      DATA PI/3.1415926/
      DATA PIO2/1.570796326/
      DATA D2R/.01745329251/

      DFMHZ=parm(8)            !  design frequency
      wave=VofL/DFMHZ          !  wavelength in meters
      nostak=nint(parm(7))
      STKSPM=parm(12)
      if(STKSPM.lt.0.) STKSPM=-STKSPM*wave    !  convert to meters
      NUMBAY=nint(parm(6))
      BAYSPM=parm(11)
      if(BAYSPM.lt.0.) BAYSPM=-BAYSPM*wave    !  convert to meters
      DIPLNM=parm(9)
      if(DIPLNM.lt.0.) diplnm=-diplnm*wave    !  convert to meters
      RRSPM=parm(13)
      if(RRSPM.lt.0.) RRSPM=-RRSPM*wave       !  convert to meters
      STKHTM=parm(10)
      if(STKHTM.lt.0.) STKHTM=-STKHTM*wave    !  convert to meters
      mode=nint(parm(14))      !  vertical excitation mode
      DO 100 I=1,4
      ICHR=IVMA(mode)(I:I)
      K=2*I-1
      IF(ICHR.EQ.'+')THEN
        STKRAT(K)=1.
        STKRAT(K+1)=1.
      ELSE IF(ICHR.EQ.'-')THEN
        STKRAT(K)=-1.
        STKRAT(K+1)=-1.
      ELSE
        STKRAT(K)=0.
        STKRAT(K+1)=0.
      ENDIF
  100 CONTINUE
      IF(nostak.LT.8)THEN
        DO 101 I=nostak+1,8
  101   STKRAT(I)=0.
      ENDIF
      ISLEW=nint(parm(15))      !  Horizontal Slew angle
      KSLEW = (ABS(ISLEW)/4)+1
      DO 200 I=1,14
      IF(ISLEW.LT.0)THEN
        bayphs(I) = IPHASE(I,KSLEW)
      ELSE
        bayphs(I) = -IPHASE(I,KSLEW)
      ENDIF
  200 CONTINUE
      OFMHZ=parm(5)        !  operating freq
      IAZ=0
      AZIM=AZIMD*D2R
      IF(ABS(AZIM).GT.PIO2 .and. ABS(AZIM).lt.3.*PIO2) THEN
        AZIM=AZIM-SIGN(PI,AZIM)
        IAZ=1
      ENDIF

      CALL PATTRN0(AZIM,ELEVD*D2R,XMGN,GNORM)
      IF(IAZ.EQ.1) XMGN=XMGN-20.     !  backward radiation
      RETURN
      END
C------------------------

      subroutine readant(lu,filename,description)
      use voacapl_defs
      use crun_directory
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      common /designfreq/ freqdesign
      common /ctype11g/ gain_type11(91)
      common /gain_10/ gain10(90,29)
      common /ccirparm/ parm(20),z6,umax,vmax,giso,
     +                  modegain,gainmax(3,2),gainmaxb(30)
      character filename*(*),description*70,alf*80

      dimension gains(91)
      equivalence (gains,gain_type11)
      nc1=len_trim(filename)
      alf=filename
      nch=80
      call rblankc(alf,nch)
ccc      nch=len_trim(alf)
      if(nch.le.2 .or. alf(nch:nch).eq.PATH_SEPARATOR) then  ! no file name = 0 dB gain
         description='0 dB gain'
         n=2
         parm(1)=0
         parm(2)=0
         modegain=0               !  use giso as max gain
         freqdesign=0.      !  default design freq=operating freq
         return
      end if
      nch_run=lcount(run_directory,50)
      open(lu,file=trim(root_directory)//PATH_SEPARATOR//'antennas'//PATH_SEPARATOR//alf(1:nch),status='old',iostat=ios,err=900)
      rewind(lu)
      read(lu,'(a)',err=910) description
      read(lu,*,err=910) n
      do 10 i=1,n
      read(lu,*,err=910) parm(i)
10    continue
      do 110 i=n+1,20
110   parm(i)=0.
      jant=nint(parm(2))       !  CCIR antenna type
      modegain=0               !  use giso as max gain
      if((jant.ge.1 .and.jant.le.4) .or. jant.eq.8 .or. jant.eq.9)
     +then
          modegain=1     !  interpolate on operating & design freq
          read(lu,*,err=910) (gainmax(i,1),i=1,3)
          read(lu,*,err=910) (gainmax(i,2),i=1,3)
      else if(jant.ge.5 .and.jant.le.7) then
          modegain=2     !  interpolate on operating freq
          read(lu,11,err=910) (gainmaxb(i),i=1,30)
11        format(10x,10f6.2)
      else if(jant.eq.10) then        !  vertical monopole
          modegain=2     !  interpolate on operating freq
          do 15 ifreq=2,30
15        read(lu,16,err=910) gainmaxb(ifreq),
     +                        (gain10(ielev,ifreq-1),ielev=1,90)
16        format(10x,f6.2,(t19,10f6.2))
      else if(jant.eq.11) then    !  type 11 = gain table at 91 elevation angles
         read(lu,*) gain_type11
      else if(jant.eq.12) then    !  read gain normalizing for Non-standards
          modegain=3     !  gain normalizing factor
          read(lu,17,err=920,end=920) (gainmaxb(i),i=1,30)
17        format(10x,5f10.3)
      else if(jant.eq.13) then    !  type 13 = gain table at 360x91 values
ccc         open(13,status='scratch',access='direct',form='unformatted',
ccc     +                recl=91*4)
c          Windows-95 cannot open SCRATCH files
         open(13,file=trim(run_directory)//PATH_SEPARATOR//'type13.tmp',
     +        access='direct',form='unformatted',recl=91*4)
         do 170 iang=0,359
         read(lu,'(9x,10f7.3)') gains
170      write(13,rec=iang+1) gains
      else if(jant.eq.14) then    !  type 14 = gain table at 30x91 values
ccc         open(14,status='scratch',
ccc     +        access='direct',form='unformatted',recl=92*4)
c          Windows-95 cannot open SCRATCH files
         open(14,file=trim(run_directory)//PATH_SEPARATOR//'type14.tmp',
     +        access='direct',form='unformatted',recl=92*4)
         do 180 ifreq=1,30
         read(lu,'(2x,f6.1,(t10,10f7.3))') eff,gains
180      write(14,rec=ifreq) eff,gains
      end if
20    freqdesign=0.      !  default design freq=operating freq
      close(lu)
ccc      call antinit2      !  initialize CCIR antenna routines
      return
900   write(*,901) ios,trim(root_directory)//PATH_SEPARATOR//'antennas'//PATH_SEPARATOR//alf(1:nch)
901   format(' Error=',i5,' OPENing antenna file=',a,1h.)
      write(*,'('' nch='',i5)') nch
      write(*,'('' nc1='',i5,''  filename='',a)') nc1,filename(1:nc1)
      pause 'error in readant'
      stop 'error in readant'
910   write(*,911) filename
911   format(' Error reading antenna file=',a)
      pause 'error in readant'
      stop 'error in readant'
920   do 925 i=1,30           !  initailize gain normalizing values
925   gainmaxb(i)=-99999.
      go to 20
      end
c------------------------------------------------------------------

c# out_si.f
      SUBROUTINE OUT_si
C--------------------------------
C
C     THIS ROUTINE OUTPUTS THE VARIABLES needed for S/I calculations
C
      COMMON /DUDL_NOIS/ DU_NOIS(13),DL_NOIS(13)
      common /sncom/ snxx(13)
      common /cgains/ gaint(13),gainr(13)
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON /OUTPRT/ LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      data lu18/18/

      write(lu18,'(''Time ='',i5)') it
      write(lu18,1) 'S DBW ',(DBW(i),i=1,12)
      write(lu18,1) 'N DBW ',(XNYNOIS(I)+RNEFF(I),i=1,12)
      write(lu18,1) 'SNRxx ',(snxx(i),i=1,12)
      write(lu18,1) 'N dl  ',(DL_NOIS(i),i=1,12)
      write(lu18,1) 'N du  ',(DU_NOIS(i),i=1,12)
      write(lu18,1) 'SIGLW ',(DBLOSL(i),i=1,12)
      write(lu18,1) 'SIGUP ',(DBLOSU(i),i=1,12)
 1    format(a6,12f10.4)
      RETURN
      END
C--------------------------------

      subroutine mufesint(index,parm,asig,aeps,and,anl,anh,aex)
c            initialize HFMUFES antennas
      dimension parm(20),aex(4)

      asig=parm(4)                         !  conductivity
      aeps=parm(3)                         !  dielectric
      do 111 i=1,4
111   aex(i)=0.
      go to (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17),index
c                                          !  Terminated Horizontal Rhombic
1     and=parm(6)              !  tilt angle
      anl=parm(7)              !  leg length
      anh=parm(8)              !  height
      return
c                                          !  Vertical Monopole
2     anl=parm(6)              !  height
      anh=parm(7)              !  gain above dipole
      and=0.
      return
c                                          !  Horizontal Half-Wave Dipole
3     anl=-.5                  !  antenna length(Must be -.5)
      anh=parm(7)              !  antenna height
      and=parm(8)              !  gain above 1/2 wavelength horizontal dipole
      return
c                                          !  Horizontal Yagi
4     anh=parm(6)              !  antenna height
      anl=parm(7)              !  length of driven element
      and=parm(8)              !  length of reflector element
      aex(1)=parm(9)           !  director length
      aex(2)=parm(12)          !  number of elements
      aex(3)=parm(10)          !  director spacing
      aex(4)=parm(11)          !  reflector spacing
      return
c                                          !  Vertical Dipole
5     anl=parm(6)              !  antenna length
      anh=parm(7)              !  feed    height
      and=parm(8)              !  additional gain
      return
c                                          !  Curtain
6     and=parm(6)              !  # of bays
      anl=parm(7)              !  antenna element length
      anh=parm(8)              !  antenna height to 1st element
      aex(1)=parm(9)           !  # of elements per bay
      aex(2)=parm(10)          !  distance between element centers
      aex(3)=parm(11)          !  vertical spacing of elements
      aex(4)=parm(12)          !  distance from screen
      return
c                                          !  Terminated Sloping Vee
7     and=parm(6)              !  1/2 apex angle in plane of wires
      anl=parm(7)              !  antenna leg length
      anh=parm(8)              !  antenna height
      aex(1)=parm(9)           !  terminated height
      return
c                                          !  Inverted L
8     anl=parm(6)              !  antenna length
      anh=parm(7)              !  antenna height
      and=0.
      return
c                                          !  Terminated Sloping Rhombic
9     and=parm(6)              !  1/2 large interior angle in plane of wires
      anl=parm(7)              !  antenna leg length
      anh=parm(8)              !  antenna height
      aex(1)=parm(9)           !  terminated height
      return
c                                          !  Not used
10    return
c                                          !  Sloping Long Wire
11    and=parm(6)              !  Slope from Horizontal
      anl=parm(7)              !  Wire length
      anh=parm(8)              !  Feed height
      return
c                                          !  Not used (constant gain)
12    return
c                                          !  Horizontal Log Periodic
13    anh=parm(6)              !  Feed height
      anl=parm(7)              !  rear element length
      and=parm(8)              !  array slope mesaured from vertical
      aex(1)=parm(9)           !  unloaded transmission line impedance (Ohm)
      aex(2)=parm(10)          !  angle between array axis & element tips
      aex(3)=parm(11)          !  geometric ratio of element length
      aex(4)=parm(12)          !  number of elements
      return
c                                          !  Arbitrary Tilted Dipole
14    and=parm(6)              !  Tilt of element from horizontal
      anl=parm(7)              !  length
      anh=parm(8)              !  Feed height
      return
c                                          !  Side-Loaded Vertical Half Rhombic
15    and=parm(6)              !  angle between leg and ground
      anl=parm(7)              !  leg length
      anh=0.
      return
c                                          !  Sloping Double Rhomboid
16    anh=parm(6)              !  Feed height
      anl=parm(7)              !  Short leg length
      and=parm(8)              !  Angle bet antenna axis & major rhomboid axis
      aex(1)=parm(9)           !  Angle bet major rhomboid axis & short leg
      aex(2)=parm(10)          !  Angle bet major rhomboid axis & long  leg
      aex(3)=parm(11)          !  Long leg length
      aex(4)=parm(12)          !  Termination height
      return
c                                          !  Vertical w/ Radial Conductor
17    anl=parm(6)              !  antenna length
      and=parm(7)              !  length of radials
      anh=0.
      aex(1)=parm(8)           !  radius of radials
      aex(2)=parm(9)           !  number of radials
      return
      end
c------------------------------------------------------------------

c###esmod.for
      SUBROUTINE ESMOD
C--------------------------------
C
C     THIS ROUTINE FINDS SPORADIC E MODE AND LOSS INFORMATION
C     (SAME AS SUBROUTINE REGMOD FOR THE OTHER LAYERS)
C
C AC(3) IS ABSORPTION LOSS FACTOR, SEE LUFFY.
C BC(3) IS DENOMINATOR OF LOSS FACTOR.
c
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SXGU,SXGL,KJ,JK
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON/SIGD/ DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE
     A ,HNU,HTLOSS,XNUZ,XVE
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24),FOT
     A(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMUF(4)
     B ,HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     C ,YMUF(4)
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / ZON / ABPS(7), CREL(7), EFF(7), FLDST(7), GRLOS(7),
     1 HN(7), HP(7), PROB(7), RELY(7), RGAIN(7), SIGPOW(7), SN(7),
     2 SPRO(7), TGAIN(7), TIMED(7), TLOSS(7), B(7), FSLOS(7), ADV(7),
     3 OBF(7),NMODE(7),TLLOW(7),TLHGH(7)
      COMMON /TON /ADJ, ADS, GNOS, GOT, REL, SL, SLS
     1, SPR, SU, SUS, XNOISE, ZNOISE, NF
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON /ES /FS (3, 5), HS (5)
      COMMON /GEOG /GYZ (5), RAT (5), GMDIP (5), CLCK (5), ABIY (5), ART
     1IC (5), SIGPAT (5), EPSPAT (5)
      COMMON / RAYS / ANG(40), IFOB(40,30,5), NANG
C ES MODES
C     ONE SAMPLE MODEL
      K=1
C.....SELECT SAMPLE AREA - ALL MODES WILL BE AT LEAST THIS GOOD
      DO 95 IS = 1,KM
      IF( FS(2,K) - FS(2,IS) ) 95,95,90
   90 K= IS
   95 CONTINUE
C.....MAPS ARE ES OR E - DO NOT USE AT LOW END
      FSDEAD = IFOB(1,3,JMODE)
      FSDEAD = FSDEAD /1000.
      FSDEAD = AMIN1(FSDEAD,3.)
C.....ONLY 2 ES MODES - PRESET ARRAYS
      DO 97 IHT = 4,5
      OBF(IHT)  = 1000.
      ADV(IHT)  = 1000.
      FSLOS(IHT)  = 1000.
      TLOSS(IHT)  = 1000.
      ABPS (IHT)  = 1000.
      EFF  (IHT)  = 0.0
      GRLOS(IHT)  = 1000.
      RGAIN(IHT)  = 0.0
      TGAIN(IHT)  = 0.0
      HN   (IHT)  = -1.
      PROB (IHT)  = 0.001
      CREL (IHT)  = -1000.
      RELY (IHT)  = .001
      SPRO (IHT)  = 0.001
      FLDST(IHT)  = -1000.
      SIGPOW(IHT)  = -1000.
      SN(IHT)     = -1000.
      HP(IHT)     =  -1.
      B (IHT)     =  -1.
      NMODE(IHT)  =   5
      TLLOW(IHT)  =  10.
      TIMED(IHT) = -1.
      TLHGH(IHT)  = 10.
   97 CONTINUE
      IF(FREQ.le.FSDEAD) return
      IF(FS(2,K).le.0.) return
C.....VIRTUAL HEIGHTS SAME AS TRUE HEIGHTS
      SDMAX = 2.*RZ*(PIO2 - ASIN(1./(1.+ HS(K)/RZ) ) )
      IHSRT = GCDKM/SDMAX + 1.
      IHSTP = 2
C.....DO ONLY 2 Es HOPS
      IF(IHSRT .gt.2) return
      IH =3
C.....ABSORPTION LOSS - F2 MODE
      AC = 677.2 * ACAV/ ( (FREQ + GYZ(K)) ** 1.98  + 10.2 )
      DO 150 IHOP = IHSRT, IHSTP
      IH = IH + 1
      GP = IHOP
      GHOP = GCD / GP
      THET = 0.5 * GHOP
      TANS=SIN(THET)/(1.-COS(THET)+HS(K)/RZ)
      PSI=ATAN(TANS)
      SECS=1./COS(PSI)
      SFVMOD = FREQ/SECS
C.....MUF AT THIS HOP DISTANCE
      ESD=FS(2,K)*SECS
      DEL=PIO2-THET-PSI
      CDEL = COS (DEL)
      ADEL = DEL * R2D
      IF(ADEL.lt.AMIND)  go to 150
C.....GROUP PATH
      PATH = 2. * SIN (.5 * GHOP) * (RZ + HS (K)) / CDEL
      HOP = IHOP
      PATH = HOP * PATH
C.....FREE SPACE LOSS
      SFLOS = 32.45 + 20.*ALOG10(PATH * FREQ)
      SINP = RZ * CDEL / (RZ + 100.)
      COSP = SQRT(1. - SINP * SINP)
      SABPS = AC/COSP
      ADX =0.0
C.....CHECK IF Es LAYER < E LAYER (IF YES REMOVE E LAYER BENDING ABOVE HS)
      if(FI(1,K).gt.SFVMOD) ADX=AFE + BFE*ALOG(SFVMOD/FI(1,K) )
      SABPS = SABPS + ADX
C.....PROBABILITY OF REFLECTION
      DUMMY = YMUF(4)
      PROS = PRBMUF(FREQ,ESD,DUMMY,4)
C.....LIMIT LOSS
      PROS = AMIN1(PROS,.90)
      REF = 8.9136 * PROS ** (-0.7)
C.....LOWER DECILE FOR LOSS USE FOT
      ESD  = FS(1,K) * SECS
      DUMMY = YFOT(4)
      PS = PRBMUF(FREQ,ESD,DUMMY,4)
      PS = AMIN1(PS,.9)
      REFL = 8.9136 * PS ** (-0.7)
C.....UPPER DECILE -   HPF
      ESD =  FS(3,K)* SECS
      DUMMY = YHPF(4)
      PS = PRBMUF(FREQ,ESD,DUMMY,4)
      PS  = AMIN1(PS,.9)
      REFU = 8.9136 * PS ** (-0.7)
C.....LOWER DECILE WITH AURORAL
      TLLOW(IH) = DSL + HOP * (REFL - REF)
C.....UPPER DECILE WITH AURORAL
      TLHGH(IH) = DSU + HOP * (REF - REFU)
C.....MAXIMUM OBSERVED IS 25.
      TLLOW(IH) = AMIN1(TLLOW(IH),25.)
      TLHGH(IH) = AMIN1(TLHGH(IH),25.)
      Y = 0.0
C.....GROUND LOSS
      DO 130 IG = 1,KM
      IGX = -IG
      CALL GAIN(IGX,DEL,FREQ,YG,GEFF)
  130 Y = Y + YG
      XKM = KM
      SGRLOS = Y / XKM
C.....ANTENNAS
C125PC      if(MSPEC.ne.125)then
        CALL GAIN(1,DEL,FREQ,STGAIN,STEFF)
        CALL GAIN(2,DEL,FREQ,SRGAIN,DUMMY)
        EFF(IH) = DUMMY
C125PC      else
c.......set gains and EFF to 0 dB or unity
C125PC        stgain=0.
C125PC        srgain=0.
C125PC        EFF(ih)=0.
C125PC      ENDIF
      xtlos = SFLOS + HOP*(SABPS + REF + ADX ) + (HOP -1.) * SGRLOS
     A    - SRGAIN  - STGAIN  + ASM
C.....FIELD STRENGTH
      FLDST(IH) = 107.2 + PWRDB(FREQ) + 20.*ALOG10(FREQ)-XTLOS-SRGAIN
C.....MEDIAN SIGNAL POWER
      SIGPOW(IH) = PWRDB(FREQ) - XTLOS
      DUMMY = YMUF(4)
      PROS = PRBMUF(FREQ,DUMMY,DUMMY,4)
      IHT = IH
C.....OBSCURATION FOR F LAYER NOT USED
      OBF(IHT)    =  + 8.9136*PROS ** (-0.7)
C.....DEVIATION LOSS
      ADV(IHT)    = 0.0
C.....FREE SPACE
      FSLOS(IHT)  =  SFLOS
C.....MEDIAN TRANSMISSION LOSS
      TLOSS(IHT)  =  XTLOS
C.....ABSORPTION LOSS
      ABPS (IHT)  =  AC/COSP + ADX
C.....GROUND LOSS
      GRLOS(IHT)  =  SGRLOS
C.....ANTENNA GAINS
      RGAIN(IHT)  = SRGAIN
      TGAIN(IHT)  = STGAIN
      HN(  IHT)  = HOP
C.....SIGNAL POWER
      SIGPOW(IHT) = PWRDB(FREQ) - XTLOS
C.....SIGNAL-TO-NOISE RATIO
C------------    CHANGED 9/24/91  (LONG PATH RCVR EFF CORRECTION)  FJR
C------------            SN    (IHT) = SIGPOW(IHT) - RCNSE
      SN    (IHT) = SIGPOW(IHT) - RCNSE - EFF(IHT)
C.....HEIGHT
      HP    (IHT) = HS(K)
C.....RADIATION ANGLE
      B     (IHT) =  ADEL
C.....MODE
      NMODE (IHT) =  4
C.....F. DAYS
      PROB  (IHT) =  PROS ** IHOP
C.....TIME DELAY
      TIMED (IHT) =  PATH/VOFL
  150 CONTINUE
      RETURN
      END
C--------------------------------

c###outtop.for
      SUBROUTINE OUTTOP
C---------------------------------
C
C     THIS ROUTINE OUTPUTS THE HEADER INFORMATION WHICH INCLUDES THE
C     METHOD, VERSION NUMBER OF THE PROGRAM AND PAGE NUMBER. OTHER
C     OUTPUT CONSISTS OF THE USER DEFINED INPUT INFORMATION AND DEPENDS
C     ON THE METHOD. SUBROUTINE SETOUT SETS THE LINES TO BE OUTPUT IN AN
C     ARRAY CALLED LINTOP(I) WHERE THE INDEX REFERS TO THE FOLLOWING
C     =1 OUTPUT MONTH, YEAR AND SUNSPOT NUMBER & MINIMUM TAKE-OFF ANGLE
C     =2 OUTPUT INFORMATION ON "LABEL" CONTROL CARD
C     =3 OUTPUT TRANSMITTER AND RECEIVER INFORMATION CONSISTING OF
C        COORDINATES, AZIMUTH AND GREAT CIRCLE DISTANCE
C     =4 OUTPUT TRANSMITTER ANTENNA INFORMATION & OUTPUT POWER
C     =5 OUTPUT RECEIVER ANTENNA INFORMATION
C     =6 3 MHZ MAN-MADE NOISE, REQUIRED RELIABILITY AND REQUIRED SNR
C     =7 OUTPUT THE MULTIPATH POWER TOLERANCE AND DELAY TIME TOLERANCE
C
      use cversn
      common /cdistance/ idistance,ndistance,ihr       !  plot vs distance
      common /ctime/ ntime                             !  plot vs time
      common /cmodel/ model
      character model*8
      common /ccoeff/ coeff
      character coeff*4
      common /cdaily/ idaily(12)
      common /cantenna/ numants,iats(20),anttype(20),antname(20),
     +                  xfqs(20),xfqe(20),designfreq(20),antfile(20),
     +                  beammain(20),offazim(20),cond(20),diel(20),
     +                  array(30,91,20),aeff(30,20)
      character anttype*10,antname*70,antfile*24
      common /pantenna/ pwrkw(20),pwrdba(20)
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
c jw      common /CVERSN/ VERSN
c jw         character VERSN*8
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / SSP / SUN(2,12), MONTH
      common /Cday/ iday
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      CHARACTER ITOP*1
      CHARACTER path*6
      CHARACTER MFORM*1
      DATA MFORM /''/

      if(ndistance.ne.1) then         !  only test if distance plot
         if(idistance.ne.1 .or. ihr.ne.1) return
      end if
      if(ntime.ne.0 .and. ihr.ne.1) return
      JOUT = LUO
      KNT = 0
C.....INCREMENT PAGE NUMBER
      LPAGES= LPAGES + 1
      ITOP='~'
      IF(JTX.NE.1)ITOP=' '
      meth=METHOD
      if(mspec.eq.121) meth=30
      if(iday.eq.0) then
        WRITE(JOUT,1500) MFORM,coeff,ITOP, meth, model,VERSN, LPAGES
 1500   FORMAT(a1,5x,a4,' Coefficients',8x,
     +       A1,'METHOD',I3,1X,a8,' L ',a8,'  PAGE',I4,/)
      else
        WRITE(JOUT,1501) MFORM,'URSI',ITOP, meth, model,VERSN, LPAGES
 1501   FORMAT(a1,5x,a4,' Coeff(Daily)',8x,
     +       A1,'METHOD',I3,1X,a8,' L ',a8,'  PAGE',I4,/)
      end if

      if(LINTOP(1).gt.0 .and. MONTH.gt.0) then
         if(iday.le.0) then
             WRITE(JOUT,1502) IMON(MONTH), NYEAR, SSN,AMIND
 1502        FORMAT(2X,A3,3X,A5,10X,'SSN = ',F4.0,16x,
     +             'Minimum Angle=',f6.3,' degrees')
         else
             WRITE(JOUT,1503) IMON(MONTH), iday,NYEAR, SSN,AMIND
 1503        FORMAT(2X,A3,1h,,i2.2,A5,10X,'SSN = ',F4.0,16x,
     +             'Minimum Angle=',f6.3,' degrees')
         end if
      end if
      path='    '
      if(NPSL.ne.0) path='<Long>'
      if(LINTOP(2).gt.0) WRITE(JOUT,1504)  ITRAN,IRCVR,path
 1504 FORMAT(2X,4A10,2X,'AZIMUTHS',2X,a6,2x,'N. MI.',6X,'KM')
      if(LINTOP(3).gt.0) then
        GCDNMI = GCDKM*0.54
        ITLAT='N'
        ITLONG='E'
        IRLAT='N'
        IRLONG='E'
        if(TLATD.lt.0.) ITLAT='S'
        if(TLONGD.lt.0.) ITLONG='W'
        if(RLATD.lt.0.) IRLAT='S'
        if(RLONGD.lt.0.) IRLONG='W'
        WRITE(JOUT,1506) abs(TLATD),ITLAT,abs(TLONGD),ITLONG,
     +                   abs(RLATD),IRLAT,abs(RLONGD),IRLONG,
     +                   BTRD,BRTD,GCDNMI,GCDKM
      end if
c*****************************************************************
      if(LINTOP(4).gt.0) then
         do 50 i=1,numants               !  TRANSMITTER (with power)
         if(iats(i).ne.1) go to 50
         write(LUO,1520) 'XMTR',nint(xfqs(i)),nint(xfqe(i)),
     +         anttype(i),antfile(i)(1:21),
     +         beammain(i),offazim(i),pwrkw(i)
1520     format(2x,a4,i3,'-',i2,1x,a10,1h[,a21,'] Az=',f5.1,
     +       ' OFFaz=',f5.1,f8.3,'kW')
         KNT=KNT+1
50       continue
      end if
      if(LINTOP(5).gt.0) then
         do 55 i=1,numants                !  RECEIVER (no power)
         if(iats(i).ne.2) go to 55
         write(LUO,1520) 'RCVR',nint(xfqs(i)),nint(xfqe(i)),
     +         anttype(i),antfile(i)(1:21),beammain(i),offazim(i)
         KNT=KNT+1
55       continue
      end if
c*****************************************************************
  161 if(LINTOP(6).gt.0) WRITE(JOUT,1514) -ZNOISE, LUFP, RSN
      if(LINTOP(7).gt.0) WRITE(JOUT,1516) PMP,DMP
      LINES = LINTOP(15) + KNT
      RETURN
 1506 FORMAT(F7.2,1X,A1,F8.2,1X,A1,' - ',F5.2,1X,A1,F8.2,
     A 1X,A1,F10.2,F8.2,F10.1,F9.1)
 1514 FORMAT(2X,'3 MHz NOISE = ',F6.1,
     A ' dBW     REQ. REL = ',I2,'%    REQ. SNR =',F5.1,' dB')
 1516 FORMAT(2X,'MULTIPATH POWER TOLERANCE = ',F4.1,' dB   ',
     A 'MULTIPATH DELAY TOLERANCE = ',F6.3,' ms')
      END
C--------------------------------

c# gridxy.f
      SUBROUTINE GRIDXY(IX,IY,RLONG,RLAT)
      COMMON /AZEL/ ZTLAT,ZTLON,ZTHT,ZRLAT,ZRLON,ZRHT,ZTAZ,ZRAZ,
     +              ZTELV,ZRELV,ZD,ZDGC,ZTAKOF,ZRAKOF
      COMMON /RGRID/ IPROJ,PLAT,PLON,XMIN,XMAX,YMIN,YMAX,NX,NY
      X=XMIN + FLOAT(IX-1)*(XMAX-XMIN)/FLOAT(NX-1)
      Y=YMIN + FLOAT(IY-1)*(YMAX-YMIN)/FLOAT(NY-1)
      IF(IPROJ.EQ.7) GO TO 70              !  GREAT CIRCLE PROJECTION
      RLONG=X                   !  LAT LONG PROJECTION
      RLAT=Y
      go to 100
70    ZTLAT=PLAT                !  CENTER OF GREAT CIRCLE PROJECTION
      ZTLON=PLON
      if(x.ne.0. .or. y.ne.0.) then
         ZTAZ=90.-ATAN2(Y,X)/.0174533         !  AZIMUTH
         IF(ZTAZ.LT.0.) ZTAZ=ZTAZ+360.
         ZDGC=SQRT(X*X+Y*Y)                   !  GREAT CIRCLE DISTANCE
ccc      write(*,1) ztlat,ztlon,ztaz,zdgc,x,y,ix,iy
ccc1     format(' ztlat,ztlon,ztaz,zdgc=',6f10.2,2i5)
         ZTHT=0.
         ZRHT=0.
         CALL DAZEL1
         RLONG=ZRLON
         RLAT=ZRLAT
      else
ccc      write(*,'("Center of projection  ix,iy=",2i5)') ix,iy
	 rlat=plat                         !  point is center of projection
	 rlong=plon
      end if
c          fix up RLONG so it is between 0 & 360.
100   if(rlong.lt.0.) rlong=rlong+360.
ccc      if(ix.eq.1) WRITE(6,2) Iy,nY,RLONG,RLAT,X,Y,ZTAZ,ZDGC
ccc 2    FORMAT(' GRIDXY=',I5,1h/,I5,2F10.4,2F10.1,F8.1,F8.0)
ccc      if(ix.eq.1) call lineup
      RETURN
      END
C------------------------------------------------------------------

c###gethp.for
      SUBROUTINE GETHP(FXX,HPX,HTX)
C--------------------------------
C
C     THIS ROUTINE PERFORMS GAUSSIAN INTEGRATION FOR THE VIRTUAL HEIGHTS
C     (SEE SUBROUTINE IONMUF FOR SETTING OF DATA)
C
      COMMON / DATR / WT(20), XT(20), NT, NPL, XNPL, TWDIV
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      FR = FXX * FXX
C.....FIRST FIND THE TRUE HEIGHT BY INTERPOLATION
      IF (FR - FNSQ (1,1))435, 435, 445
  435 HTX = HTR(1,1)
      HPX = HTX
      RETURN
  445 CONTINUE
      DO 490 IH = 1, 49
      IF (FNSQ (IH,1) - FNSQ (IH + 1,1))465, 455, 480
  455 IF (FR - FNSQ (IH,1))490, 460, 490
  460 HT = HTR (IH,1)
      GO TO 495
  465 IF (FNSQ (IH,1) - FR)470, 470, 475
  470 IF (FR - FNSQ (IH + 1,1))475, 490, 490
  475 HT = HTR (IH,1) + (FR - FNSQ (IH,1)) * (HTR(IH + 1,1) - HTR(IH,1))
     1 / (FNSQ (IH + 1,1) - FNSQ (IH,1))
      GO TO 495
  480 IF (FNSQ (IH,1) - FR)490, 485, 485
  485 IF (FR - FNSQ (IH + 1,1))490, 490, 475
  490 CONTINUE
      HT = HTR (50,1)
  495 CONTINUE
C.....END OF TRUE HEIGHT CALCULATION
      HP = 0
      HT = HT - HTR (1,1)
      HRMZ = HT * TWDIV * XNPL
      IF (NT .LT. 1) GO TO 665
C.....BEGINNING OF GAUSSIAN INTEGRATION
      DO 635 IG = 1, NT
      ZG = 1.0 - XT(IG)
C.....TRANSLATION TO (-1,1) FROM (0,HT) NEED NOT BE LINEAR
      ZI = HT * (1. - TWDIV * (ZG * * NPL)) + HTR (1,1)
      IB = - 1
      GO TO 535
  500 YSQ = YSQ / FR
      YSQ = AMIN1 (YSQ, 0.9999)
      YMUP = 1. / SQRT (1. - YSQ)
      YMUP = YMUP * (ZG * * (NPL - 1))
      ZG = 1. + XT (IG)
      ZI = HT * (1. - TWDIV * (ZG * * NPL)) + HTR (1,1)
      IB = 1
      GO TO 535
  505 YSQ = YSQ / FR
      YSQ = AMIN1 (YSQ, 0.9999)
      ZMUP = 1. / SQRT (1. - YSQ)
      ZMUP = ZMUP * (ZG * * (NPL - 1))
      GO TO 635
C.....BEGIN INTERPOLATION FOR PLASMA FREQUENCY SQUARED
  535 CONTINUE
      IF (ZI - HTR (1,1))545, 545, 555
  545 YSQ = FNSQ (1,1)
      GO TO 625
  555 CONTINUE
      DO 615 IH = 1, 49
      IF (HTR (IH,1) - HTR (IH + 1,1))585, 565, 605
  565 IF (ZI - HTR (IH,1))615, 575, 615
  575 YSQ = FNSQ (IH,1)
      GO TO 625
  585 IF (HTR (IH,1) - ZI)595, 595, 600
  595 IF (ZI - HTR (IH + 1,1))600, 615, 615
  600 YSQ = FNSQ (IH,1) + (ZI - HTR (IH,1)) * (FNSQ(IH+1,1)-FNSQ(IH,1))
     1 /(HTR (IH + 1,1) - HTR (IH,1))
      GO TO 625
  605 IF (HTR (IH,1) - ZI)615, 610, 610
  610 IF (ZI - HTR (IH + 1,1))615, 615, 600
  615 CONTINUE
      YSQ = FNSQ (50,1)
C.....END OF INTERPOLATION FOR PLASMA FREQUENCY SQUARED
  625 IF (IB)500, 500, 505
  635 HP = HP + WT (IG) * (YMUP + ZMUP)
C.....END OF GAUSSIAN INTEGRATION FOR VIRTUAL HEIGHTS
  665 CONTINUE
C.....HPX IS THE VIRTUAL HEIGHT
C.....HTX IS THE TRUE HEIGHT
      HPX = HTR(1,1) + HRMZ * HP
      HTX = HTR(1,1) + HT
      RETURN
      END
C--------------------------------

* --------------------------------------------------------------------- *
      FUNCTION iant_idx(dir,file)     !  open file and get antenna index
* --------------------------------------------------------------------- *
      use voacapl_defs
      use crun_directory
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      CHARACTER tempstring*1,dir*8,file*12,antfil*21
      iant_idx=-1
      call antfile(dir,file,antfil)
      nch_run=lcount(run_directory,50)
      open(31,file=run_directory(1:nch_run-3)//'antennas'//PATH_SEPARATOR//antfil,
     +     status='old',err=100)
      rewind(31)
      read(31,'(a)') tempstring
      read(31,'(a)') tempstring
      read(31,'(a)') tempstring
      read(31,*) iant_idx          !  antenna index
      close(31)
100   return
      end

      SUBROUTINE CHARDEG(CARD,LATLON,DEG,IERR)
C******************************************************************
C#  SUB CHARDEG(CARD,LATLON,DEG,IERR)  CHAR string to LAT LON degrees
C          Convert a CHARACTER string to degrees of LAT or LONG.
C          Input may be of the form:
C               dddXmm'ss"   dddXmm    dddX   ddd.dddX
C               ddd.ddd     -ddd.ddd
C          where  X=N or S for latitude
C                  =E or W for longitude
C                 W longitude is negative
C                 E latitude  is negative
C******************************************************************
C          LATLON = 0 = LATITUDE
C                 = 1 = LONGITUDE
C          *      = ERROR RETURN
C******************************************************************
      DIMENSION DMAX(2) 
      CHARACTER*(*) CARD,ICH*1
      DATA DMAX/90.,360./       !  MAX VALUES ALLOWED FOR LAT/LON
      IERR=0
      DEG=0
      MIN=0
      ISEC=0
      ISIGN=1
      IDEC=0
      IDEL=0                    !  COUNTS # OF DELIMITERS
      ionce=0
      ii=0
      DO 100 I=1,20
      ICH=CARD(I:I)
      if(ionce.eq.0 .and. ich.eq.' ') go to 100  !  skip leading blanks
      ionce=1
      IF(ICH.EQ.' ' .OR. ICH.EQ.',') GO TO 150   !  END OF STRING
      IF(IDEL.EQ.3) GO TO 80    !  SOMETHING AFTER SECONDS
      IF(ICH.EQ.'-') GO TO 10   !  - SIGN
      IF(ICH.EQ.'.') GO TO 20   !  . decimal point
      IF(ICH.GE.'0' .AND. ICH.LE.'9') GO TO 30    !  0-9 number
      IDEL=IDEL+1
      IF(IDEL.EQ.1) GO TO 70    !  1st DELIMITER--CHECK DIRECTION
      GO TO 99
10    IF(ii.NE.0) IERR=-3        !  - MUST be 1st character
      ISIGN=-1
      GO TO 99
20    IF(IDEC.NE.0) IERR=-4     !  Only 1 decimal point allowed
      IF(IDEL.NE.0) IERR=-5     !  Must be before any delimiters
      IDEC=1
      GO TO 99
30    N=ICHAR(ICH)-ICHAR('0')   !  Convert to a number
      IF(IDEL-1) 40,50,60
40    IF(IDEC.NE.0) GO TO 45    !  Fractions
      DEG=DEG*10. + FLOAT(N)
      GO TO 99
45    DEG=DEG + FLOAT(N)/10.**IDEC
      IDEC=IDEC+1
      GO TO 99
50    MIN=MIN*10 + N
      IF(MIN.GE.60) IERR=-6     !  BAD minutes
      GO TO 99
60    ISEC=ISEC*10 + N
      IF(ISEC.GE.60) IERR=-7    !  BAD seconds
      GO TO 99
70    IF(LATLON.NE.0) GO TO 75  !  LONGITUDE
      IF(ICH.EQ.'n') ICH='N'
      IF(ICH.EQ.'s') ICH='S'
      IF(ICH.NE.'N' .AND. ICH.NE.'S') IERR=-10   !  BAD DIRECTION
      IF(ICH.EQ.'S') ISIGN=-ISIGN
      GO TO 99
75    IF(ICH.EQ.'e') ICH='E'
      IF(ICH.EQ.'w') ICH='W'
      IF(ICH.NE.'E' .AND. ICH.NE.'W') IERR=-11   !  BAD DIRECTION
      IF(ICH.EQ.'W') ISIGN=-ISIGN
      GO TO 99
80    IERR=-2                   !  SOMETHING AFTER SECONDS DELIMITER
99    IF(IERR.LT.0) RETURN
      ii=ii+1
100   CONTINUE
      IERR=-8          !  Can't be this long of a character string
      RETURN
150   DEG=DEG + FLOAT(MIN)/60. + FLOAT(ISEC)/3600.
      IF(DEG.GT.DMAX(LATLON+1)) IERR=-9    !  BAD VALUE
      if(LATLON.eq.1 .and. DEG.gt.180.) DEG=DEG-360.
      DEG=DEG*ISIGN
      RETURN
      END

        subroutine dirgain(iant,z6,giso,*)
c**********************************************************************
c       DIRECTIVITY GAIN CALCULATION (SIMPSON RULE INTEGRATION)
c          calculates gain relative to isotrope
c       INPUT  PARAMETERS:
c          iant = antenna index number [0-10]
c          z6   = gain normalizing factor (from ccirantinit)
c       OUTPUT PARAMETERS:
c          giso = directivity gain relative to isotrope
c**********************************************************************
      common/general/d1,e1,f1,p1,q1,s1,beta,rlambda
      common/cros/cpfr,cp11,fr1,h1,pfr,p11,p11s,q2,r2,r3,sl
      common/trig/a(0:361),b(0:361)
      common /c_bar/ pct_done,s_pct_done,pct_fact,iabort_dir
         real*8 pct_done
         character s_pct_done*4
c
c                                 iant=0=isotrope
      if(iant.eq.0) return
        iperf = 1
        call parmprec(iant,iperf)
        sup1 = 0.0
        sup2 = 0.0
        i = 0
        j = 0
        ust = 1.0
        vst = 1.0
        svd = 0.0
        svp = 0.0
        do 7840 iv=0,360
        v=iv
        if(iv.ne.0 .and. mod(iv,60).eq.0) then
           if(iabort_dir.ne.0) return 1
           pct_done=pct_done + pct_fact/6.
ccc           call window_update@(pct_done)
           write(s_pct_done,'(i3,1h%)') nint(pct_done*100.)
           call window_update@(s_pct_done)
        end if
        j = 0
        sud = 0
        sup = 0
        do 7710 u=0,90
        b0 = b(ifix(u))
        call gainrel(iant,u, v, z9)
        dsu = z9 **2 * b0
      if(abs(u).le.0.001) then
          sau = dsu
      else
        if(abs(u-90.0).le.0.001) then
          sbu = dsu
        else
          j = j + 1
          if (j.ne. (j / 2) * 2) then 
            sud = sud + dsu
          else
            sup = sup + dsu
          endif
        endif
      endif
 7710   continue
        dsv = (sau + sbu + 4 * sud + 2 * sup) * ust / 3.0 * q1 * q1
        if(abs(v).le.0.001) then
          sav = dsv
        else
          if (abs(v-360.0).le.0.001) then
            sbv = dsv
          else
            i = i + 1
            if (i.ne.(i / 2) * 2) then
              svd = svd + dsv
            else
              svp = svp + dsv
            endif
          endif
        endif
 7840   continue
        superf = (sav + sbv + 4 * svd + 2 * svp) * vst / 3.0
        requiv = sqrt(superf / (4 * p1))
      if(z6.gt.0.0) then
        giso = 20.* alog10(z6 / requiv)
      else
        giso=0.0
      endif
        iperf = 0
        call parmprec(iant, iperf)
        return
        end
c---------------------------------------------------------------

c------------------------------------------------------------
      subroutine rdCIRAF    !  read the ..\database\cirafp.911 file

      use voacapl_defs
      use crun_directory
      common /Cciraf/ nciraf_tp,ciraf(911),ciraf_lat(911),ciraf_lon(911)
         character ciraf*4
c          this contains rectangle containing CIRAF zones
      common /Cciraf_max/ ciraf_lat_max(4,85),ciraf_lon_max(4,85)
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      character ns*1,ew*1

      nch_run=lenchar(run_directory)

      nciraf_tp=911
      open(31,file=run_directory(1:nch_run-3)//
     +        'database'//PATH_SEPARATOR//'cirafp.911',status='old',err=900)
      rewind(31)
      do 10 itp=1,nciraf_tp
      read(31,1) ciraf(itp),latd,ns,lond,ew
1     format(a4,i2,a1,i3,a1)
      if(ns.eq.'S') latd=-latd
      if(ew.eq.'W') lond=-lond
      ciraf_lat(itp)=latd
10    ciraf_lon(itp)=lond
      close(31)

      open(31,file=run_directory(1:nch_run-3)//
     +        'database'//PATH_SEPARATOR//'cirafp.max',status='old',err=910)
      rewind(31)
      do 30 izn=1,85
      do 20 j=1,2
      read(31,11) latd,ns,lond,ew
11    format(4x,i2,a1,i3,a1)
      if(ns.eq.'S') latd=-latd
      if(ew.eq.'W') lond=-lond
      ciraf_lat_max(j,izn)=latd
20    ciraf_lon_max(j,izn)=lond
      ciraf_lat_max(3,izn)=ciraf_lat_max(1,izn)
      ciraf_lon_max(3,izn)=ciraf_lon_max(2,izn)
      ciraf_lat_max(4,izn)=ciraf_lat_max(2,izn)
      ciraf_lon_max(4,izn)=ciraf_lon_max(1,izn)
30    continue
      close(31)
      return
c***********************************************************
900   write(*,901) '..'//PATH_SEPARATOR//'DATABASE'//PATH_SEPARATOR//'CIRAFP.911'
901   format(' In rdciraf, could not OPEN file=',a)
      pause 'Could not OPEN file ..'//PATH_SEPARATOR//'DATABASE'//PATH_SEPARATOR//'CIRAFP.911'
      go to 999
910   write(*,901) '..'//PATH_SEPARATOR//'DATABASE'//PATH_SEPARATOR//'CIRAFP.MAX'
      pause 'Could not OPEN file ..'//PATH_SEPARATOR//'DATABASE'//PATH_SEPARATOR//'CIRAFP.MAX'
999   return
      end
c------------------------------------------------------------

c###esind.for
      SUBROUTINE ESIND
C--------------------------------
C
C     THIS ROUTINE EVALUATES THE SPORADIC E (ES) PARAMETERS
C     NOTE THE CRITICAL FREQUENCIES ARE THE MAXIMUM OF REGULAR E AND THE
C     SPORADIC E.  PSC IS USUALLY 0.70 TO OBTAIN MEDIAN LOSSES.
C
C  GMT IS UNIVERSAL TIME
C
      COMMON / PSCA / PSC(4), PSCB(4), IPSC
      COMMON /A11 /GAMMA (6)
      COMMON /ES /FS (3, 5), HS (5)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      IF (KM .LT. 1) GO TO 105
      DO 100 II = 1, KM
C.....HS(II) IS THE HEIGHT OF REFLECTION
      HS (II) = 110.
C.....CALL SUBROUTINE VERSY FOR THE EVALUATION OF THE FOURIER EXPANSION
      CALL VERSY(1, 3, II)
C.....FS(1,II) IS THE CRITICAL FREQUENCY LOWER DECILE
C.....FS(2,II) IS THE CRITICAL FREQUENCY MEDIAN
C.....FS(3,II) IS THE CRITICAL FREQUENCY UPPER DECILE
      FS (1, II) = GAMMA (3) * PSC (4)
      FS (2, II) = GAMMA (2) * PSC (4)
      FS (3, II) = GAMMA (1) * PSC (4)
  100 CONTINUE
  105 RETURN
      END
C--------------------------------
C--------------------------------

c-----------------------------------------------------------
      subroutine zones_to_TP(zones,nzones,idx_TP,nTP)
c        convert CIRAF zones to Test Points
      character zones(*)*4,zone*4
      dimension idx_TP(*)
      common /Cciraf/ nciraf_tp,ciraf(911),ciraf_lat(911),ciraf_lon(911)
         character ciraf*4
      nTP=0
      do 100 iz=1,nzones
      zone=zones(iz)
      if(zone(3:4).eq.'  ') then      !  full zone
	 do i=1,nciraf_tp
	 if(zone(1:2).eq.ciraf(i)(1:2)) then        !  add test point
	    nTP=nTP+1
	    idx_TP(nTP)=i
         end if
         end do
      else if(zone(4:4).ne.' ') then      !  XX quadrant
	 do i=1,nciraf_tp
	 if(zone(1:4).eq.ciraf(i)(1:4)) then        !  add test point
	    nTP=nTP+1
	    idx_TP(nTP)=i
         end if
         end do
      else if(zone(3:3).eq.'N' .or. zone(3:3).eq.'S') then  !  N or S  quadrants
	 do i=1,nciraf_tp
	 if(zone(1:3).eq.ciraf(i)(1:3)) then        !  add test point
	    nTP=nTP+1
	    idx_TP(nTP)=i
         end if
         end do
      else if(zone(3:3).eq.'E') then  !  NE or SE  quadrants
	 do i=1,nciraf_tp
	 if(zone(1:2).eq.ciraf(i)(1:2) .and. 
     +      ciraf(i)(4:4).eq.'E') then        !  add test point
	    nTP=nTP+1
	    idx_TP(nTP)=i
         end if
         end do
      else if(zone(3:3).eq.'W') then  !  NW or SW  quadrants
	 do i=1,nciraf_tp
	 if(zone(1:2).eq.ciraf(i)(1:2) .and. 
     +      ciraf(i)(4:4).eq.'W') then        !  add test point
	    nTP=nTP+1
	    idx_TP(nTP)=i
         end if
         end do
      else
	 stop 'Should not get here in zone_to_TP.'
      end if
100   continue
      return
      end
c------------------------------------------------------------
      subroutine parse_zones(cirafz,zones,nzones)
c          parse the CIRAF zone field into its parts
      character cirafz*30,zones(*)*4
      character tempz*31
      nzones=0
      tempz=cirafz
      nchz=lenchar(tempz)
      tempz(nchz+1:nchz+1)=','         !  add terminator
      nchz=nchz+1
      last=1
      do 100 i=2,nchz                 !  find next ','
      if(tempz(i:i).ne.',') go to 100
      call pzones(tempz(last:i-1),i-last,zones,nzones)
      last=i+1
100   continue
      return
      end
c------------------------------------------------------------
      subroutine pzones(alf,nch,zones,nzones)
      character alf*(*),zones(*)*4,ich*1,numb*2,quad*2,nums(2)*2
      dimension n(2)
      if(index(alf(1:nch),'-').gt.0) then            !  process '-'
	 nums(1)='  '
	 nums(2)='  '
	 n(1)=0
	 n(2)=0
	 inum=1
	 do 10 i=1,nch
	 ich=alf(i:i)
	 if(ich.ge.'0' .and. ich.le.'9') then
	    n(inum)=n(inum)+1
	    nn=n(inum)
	    if(nn.gt.2) stop 'CIRAF zone (in -) > 2 digits'
	    nums(inum)(nn:nn)=ich
	 else if(ich.eq.'-') then
	    inum=inum+1
	    if(inum.gt.2) stop 'CIRAF zone had more than 1 -.'
	 else
	    stop 'CIRAF zone (with -) had bad character.'
	 end if
10       continue
	 do 15 i=1,2
	 nn=n(inum)
	 if(nn.eq.1) then
	    ich=nums(i)(1:1)
	    nums(i)=' '//ich
	 else if(nn.eq.0) then
	    stop 'CIRAF zone (with -) had no number'
         end if
15       continue
	 read(nums(1),'(i2)') iz1
	 read(nums(2),'(i2)') iz2
	 if(iz2.le.iz1) then
	    stop 'CIRAF zone (with N-M) has N>M.'
	 end if
	 do 20 iz=iz1,iz2
	 nzones=nzones+1
	 write(zones(nzones),'(i2,2x)') iz
20       continue
      else
	 numb='  '
	 nnumb=0
	 quad='  '
	 nquad=0
	 do 50 i=1,nch
	 ich=alf(i:i)
	 if(ich.ge.'0' .and. ich.le.'9') then
	    nnumb=nnumb+1
	    if(nnumb.gt.2) stop 'CIRAF zone > 2 digits'
	    numb(nnumb:nnumb)=ich
         else
	    nquad=nquad+1
	    if(nquad.gt.2) stop 'CIRAF quadrant > 2 characters'
	    quad(nquad:nquad)=ich
	 end if
50       continue
	 if(nnumb.eq.1) then
	    ich=numb(1:1)
	    numb=' '//ich
	 else if(nnumb.eq.0) then
	    stop 'CIRAF zone had no number'
	 end if
	 nzones=nzones+1
	 zones(nzones)=numb//quad
      end if
      return
      end
c------------------------------------------------------------

      subroutine setmaxgain(freqoper)
c*******************************************************************
c       PURPOSE:
c          set maximum gain parameter (giso) for use by ANTCAL
c       INPUT  PARAMETERS:
c          freqoper  = Operating Frequency
c          freqdesign= Design Frequency (=0=use Operating Frequency)
c                    = in range .7 to 1.4  use as FreqRatio
c                        thus   fdesign=foper/FreqRatio
c       OUTPUT PARAMETERS:
c*******************************************************************
      common /designfreq/ freqdesign
      common /ccirparm/ parm(20),z6,umax,vmax,giso,
     +                  modegain,gainmax(3,2),gainmaxb(30)
      iant=nint(parm(2))                  !  type [1,2,...12]
      if(modegain.eq.0) then
         giso=parm(1)                     !  maximum gain
      else if(modegain.eq.1) then
c          interpolate on Frequency ratio and Operating frequency
         foper=freqoper                   !  set operating frequency
         if(foper.lt.2. .or. foper.gt.30.) foper=10.
         fdesign=freqdesign               !  set design frequency
c          was this Frequency Ratio (.7 to 1.4)
         if(fdesign.ge..7 .and. fdesign.le.1.4)fdesign=foper/freqdesign
         if(fdesign.lt.2. .or. fdesign.gt.30.) fdesign=foper
         parm(5)=foper
         parm(8)=fdesign
         if(iant.eq.8) parm(6)=fdesign     !  quadrant antenna
         giso=gainterp(gainmax,foper,fdesign,iant)
      else if(modegain.eq.2) then
         parm(5)=freqoper
         giso=gainterb(gainmaxb,freqoper)  !  types 5,6,7,10
      end if
      return
      end
c----------------------------------------------------------------------

       subroutine DAZEL1
C#  SUB DAZEL1                 Same as CALL DAZEL(1)
       IMPLICIT DOUBLE PRECISION(A-L,N-Y)
C
C     TWO MODES--   0   INPUT LAT AND LON OF END POINT
C                       RETURN DISTANCE AND AZIMUTH TO END PT WITH ELEVATIONS
C                   1   INPUT BEARING (AZIMUTH) OF END POINT
C                       RETURN LAT AND LON OF END POINT WITH ELEVATIONS
C
C   MODE 0
C   INPUT PARAMETERS (THESE DEFINE LOCATION OF POINTS T (TRANSMITTER)
C     AND R (RECEIVER) RELATIVE TO A SPHERICAL EARTH.
C     ZTLAT - LATITUDE (DECIMAL DEGREES NORTH OF EQUATOR) OF POINT T
C     ZTLON - LONGITUDE (DECIMAL DEGREES EAST OF PRIME (GREENWICH)
C            MERIDIAN) OF POINT T
C     ZTHT  - HEIGHT (METERS ABOVE MEAN SEA LEVEL) OF POINT T
C     ZRLAT - LATITUDE (DECIMAL DEGREES NORTH OF EQUATOR) OF POINT R
C     ZRLON - LONGITUDE (DECIMAL DEGREES EAST OF PRIME MERIDIAN OF POINT R
C     ZRHT  - HEIGHT (METERS ABOVE MEAN SEA LEVEL) OF POINT R
C
C   OUTPUT PARAMETERS
C     ZTAZ  - AZUMUTH (DECIMAL DEGREES CLOCKWISE FROM NORTH) AT T OF R
C     ZRAZ  - AZIMUTH (DECIMAL DEGREES CLOCKWISE FROM NORTH) AT R OF T
C     ZTELV - ELEVATION ANGLE (DECIMAL DEGREES ABOVE HORIZONTAL AT T
C            OF STRAIGHT LINE BETWEEN T AND R
C     ZRELV - ELEVATION ANGLE (DECIMAL DEGREES ABOVE HORIZONTAL AT R)
C            OF STRAIGHT LINE BETWEEN T AND R
C     ZTAKOF - TAKE-OFF ANGLE (DECIMAL DEGREES ABOVE HORIZONTAL AT T)
C            OF REFRACTED RAY BETWEEN T AND R (ASSUMED 4/3 EARTH RADIUS)
C     ZRAKOF - TAKE-OFF ANGLE (DECIMAL DEGREES ABOVE HORIZONTAL AT R)
C            OF REFRACTED RAY BETWEEN T AND R (ASSUMED 4/3 EARTH RADIUS)
C     ZD    - STRAIGHT LINE DISTANCE (KILOMETERS) BETWEEN T AND R
C     ZDGC  - GREAT CIRCLE DISTANCE (KILOMETERS) BETWEEN T AND R
C
C   MODE 1
C   INPUT PARAMETERS                    OUTPUT PARAMETERS
C     ZTLAT                                ZRLAT
C     ZTLON                                ZRLON
C     ZTAZ                                 RELEV,ZRAKOF
C     ZDGC                                 TELEV,ZTAKOF
C
C
C     ALL OF THE ABOVE PARAMETERS START WITH THE LETTER Z AND ARE SINGLE
C     PRECISION.  ALL PROGRAM VARIABLES ARE DOUBLE PRECISION.
C     PROGRAM IS UNPREDICTABLE FOR SEPARATIONS LESS THAN 0.00005 DEGREES,
C     ABOUT 5 METERS.
C
C   WRITTEN BY KEN SPIES 5/79
C   REFRACTION AND ST. LINE ELEVATIONS BY EJH
C
      COMMON/AZEL/ ZTLAT,ZTLON,ZTHT,ZRLAT,ZRLON,ZRHT,ZTAZ,ZRAZ,
     * ZTELV,ZRELV,ZD,ZDGC,ZTAKOF,ZRAKOF
      DATA PI/3.141592653589793238462643D0/,RERTH/6370.0D0/
      DATA DTOR/0.01745329252D0/,RTOD/57.29577951D0/
C
C     COMPUTE END POINT GIVEN DISTANCE AND BEARING
C
200   TLATR=ZTLAT*DTOR
      TLONR=ZTLON*DTOR
      TAZR=ZTAZ*DTOR
      GC=ZDGC/RERTH
      COLAT=PI/2.0 - TLATR
      COSCO=DCOS(COLAT)
      SINCO=DSIN(COLAT)
      COSGC=DCOS(GC)
      SINGC=DSIN(GC)
      COSB=COSCO*COSGC + SINCO*SINGC*DCOS(TAZR)
      ARG=DMAX1(0.0D0,(1.0D0-COSB*COSB))
      B=DATAN2(DSQRT(ARG),COSB)
      ARC=(COSGC-COSCO*COSB)/(SINCO*DSIN(B))
      ARG=DMAX1(0.0D0,(1.0D0-ARC*ARC))
      RDLON=DATAN2(DSQRT(ARG),ARC)
      ZRLAT=(PI/2.0 - DABS(B))*RTOD
      DRLAT=ZRLAT
      ZRLAT=DSIGN(DRLAT,COSB)
      ZRLON=ZTLON+(DABS(RDLON)*RTOD)
      IF(ZTAZ .GT. 180) ZRLON=ZTLON-(DABS(RDLON)*RTOD)
      THTS=ZTHT*1.0E-3
      RHTS=ZRHT*1.0E-3
      DELHT=RHTS-THTS
      SGC=DSIN(0.5*GC)
      D=DSQRT(DELHT*DELHT+4.0*(RERTH+THTS)*(RERTH+RHTS)*SGC*SGC)
C
C   COMPUTE GREAT CIRCLE DISTANCE AND ELEVATION ANGLES
C
       IF(DELHT .GE. 0) GOTO 145
       AHT=THTS
       BHT=RHTS
       GO TO 150
145    AHT=RHTS
       BHT=THTS
150    SAELV=0.5*(D*D+DABS(DELHT)*(RERTH+AHT+RERTH+BHT))/(D*(RERTH+AHT))
      ARG=DMAX1(0.0001D0,(1.0D0-SAELV*SAELV))
       AELV=DATAN2(SAELV,DSQRT(ARG))
       BELV=(AELV-GC)*RTOD
       AELV=-AELV*RTOD
C   COMPUTE TAKE-OFF ANGLES ASSUMING 4/3 EARTH RADIUS
       R4THD=RERTH*4.0/3.0
       GC=0.75*GC
       SGC=DSIN(0.5*GC)
       P=2.0*SGC*SGC
       AALT=R4THD+AHT
       BALT=R4THD+BHT
       DA=DSQRT(DELHT*DELHT+2.0*AALT*BALT*P)
       SAELV=0.5*(DA*DA+DABS(DELHT)*(AALT+BALT))/(DA*AALT)
      ARG=DMAX1(0.0001D0,(1.0D0-SAELV*SAELV))
       ATAKOF=DATAN(SAELV/DSQRT(ARG))
       BTAKOF=(ATAKOF-GC)*RTOD
       ATAKOF=-ATAKOF*RTOD
       IF(DELHT-0.0)151,155,155
151    ZTELV=AELV
       ZRELV=BELV
       ZTAKOF=ATAKOF
       ZRAKOF=BTAKOF
       RETURN
155    ZTELV=BELV
       ZRELV=AELV
       ZTAKOF=BTAKOF
       ZRAKOF=ATAKOF
       RETURN
      END
C------------------------------------------------------------------

c###sigdis.for
      SUBROUTINE SIGDIS
c***********************************************
c          Alex Shovkoplyas made some changes to:
c             curmuf
c             seltxr
c             settxr
c             sigdis
c          Normally if the version (..\database\version.w32)
c             is yy.mmddW then the original version is used.
c                yy.mmddA then Alex's version is used.
c***********************************************
      use cversn
c jw      common /CVERSN/ VERSN
c jw      character VERSN*8
      if(versn(8:8).eq.'A' .or. versn(8:8).eq.'a') then
         call sigdis_alex       !  use Alex's modified version
      else
         call sigdis_orig       !  use original version
      end if
      return
      end
C--------------------------------
      SUBROUTINE SIGDIS_orig
C--------------------------------
C
C  ADJUST SIGNAL DISTRIBUTION TABLES FOR THIS PATH AND SET ABSORPTION
C  LOSS PARAMETERS
C
      use cversn
c jw      common /cversn/ versn
c jw         character versn*8      !  look for "H" to ignore absorption fix
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/GEOG/GYZ(5),RAT(5),GMDIP(5),CLCK(5),ABIY(5),ARTIC(5),SIGPAT
     A(5), EPSPAT(5)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24),FOT
     A (24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMUF(4)
     B ,HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     C ,YMUF(4)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON/SIGD/DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE,HNU
     A ,HTLOSS,XNUZ,XVE
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
      COMMON/INFORM/INFO,IHSHR,IHLNG
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      GLAV = 0.0
C.....SET NUMBER OF IONOSPHERES
      KFXX=KFX
ccc      KFXX=KM         !  temp change by Greg for receprocity try

      XKF  = KFXX
      XADJ = 0.0
      XSU  = 0.0
      XSL  = 0.0
      XFMP = 0.0
      XSUP = 0.0
      XSLP = 0.0
      AC = 0.0
      FEAV=0.0
ccc      write(luo,'(''in sigdis, kfx='',2i5)') kfx,km
      DO 115 K = 1,KFXX
C.....ABSORPTION INDEX
      ABIY(K) =  - 0.04 + EXP(-2.937 + 0.8445*FI(1,K) )
c****** Change made 6/2/99 by Greg Hand to fix absorption error
c       that was never fixed in VOACAP.
c******  per change to ICEPAC 3/18/93 by Frank Stewart to fix losses problem
c          this limits ABIY to a lower limit of .1 because that is the
c          lower limit of the curve.
c          IONCAP was wrong when it did not have the lower limit.
c          It was too optimistic with its prediction.
ccc      write(12,'(''abiy('',i1,'')='',f8.4)') k,abiy(k)
c          the "HAM" version does not do the absorption fix
c          to create the "HAM" version, edit the file:
c                  ..\database\version.w32
c             change the "W" to "H".
c          this was changed 2/8/2006 for Dean Straw
c          this was changed 4/18/2006 to "I" from "H". "I"=IONCAP
c          "I" or "a" is IONCAP. "a" is Alex's changes
      if(versn(8:8).eq.'I' .or. versn(8:8).eq.'a') then
      else
         ABIY(K)=MAX(0.1,ABIY(K))
      end if
C.....SYSTEM LOSS TABLE
      DUMMY1 = GLAT(K)
      DUMMY2 = CLCK(K)
      IDP=2
      IF(GCDKM.GT.2500.)IDP=5
      CALL SYSSY(DUMMY1,DUMMY2,IDP,ADJ,SU,SL,FMP,SUP,SLP)
ccc      write(luo,122) k,dummy1,dummy2,idp,adj,su,sl,fmp,sup,slp
ccc     +                ,abiy(k),fi(1,k)
ccc122   format('syssy=',i5,2e15.7,i5,8f10.4)
C.....MEDIAN
      XADJ = XADJ + ADJ
C.....UPPER DECILE
      XSU  = XSU  + SU
C.....LOWER DECILE
      XSL  = XSL  + SL
C.....PREDICTION ERROR, MEDIAN
      XFMP = XFMP + FMP
C.....UPPER DECILE
      XSUP = XSUP + SUP
C.....LOWER DECILE
      XSLP = XSLP + SLP
C.....E CRITICAL
      FEAV = FEAV + FI(1,K)
C.....ABSORBTION INDEX
      AC   = AC   + ABIY(K)
      ARTIC(K) = ADJ
C.....GEOMAGNETIC LATITUDE
      GLAV = GLAV + ABS(GLAT(K))
  115 CONTINUE
C.....BEGIN SECTION TO SAVE THE AVERAGE VALUES
      GLAV= GLAV/XKF
      AGLAT = GLAV
      ACAV= AC/XKF
      FEAV= FEAV/XKF
      ADJ = XADJ/XKF
ccc      write(luo,'(''adj='',4f11.4)') adj,xadj,xkf,acav
      SU  = XSU/XKF
      SL  = XSL/XKF
      ADS = XFMP/XKF
      SUS = XSUP/XKF
      SLS = XSLP/XKF
C.....END SECTION TO SAVE THE AVERAGE VALUES
      K = JMODE
C
C  PARAMETER FOR D-E ABSORTION LOSS.
C  ABIY( )  IS ABSORPTION INDEX. ACAV IS THE AVERAGE FOR THE PATH
C
C.....D - E REGION LOSS ADJUSTMENT FACTOR
      HTLOSS = 88.
      XVE    = XLIN( 90., HTRUE,FVERT,30, K )
      XVE    = XVE/FI(1,K)
      XNUZ = 63.07
      HNU  = 4.39
      IF(FEAV - 2.0) 125,125,120
C.....ADJUSTMENT TO CCIR 252 (HAYDON,LUCAS) LOSS EQUATION FOR E MODES
  120 AFE  = 1.359
      BFE  = 8.617
      GO TO 140
  125 IF(FEAV - 0. 5) 130,130,135
  130 AFE  = 0.0
      BFE  = 0.0
      GO TO 140
  135 AFE  = 1.359 *(FEAV - 0.5)/1.5
      BFE  = 8.617 *(FEAV - 0.5)/1.5
  140 CONTINUE
C
C  SET SIGNAL DISTRIBUTION TABLES. TABLE IS FOR FREQ = FTAB
C
C.....USE FOT, F2 LAYER
      GLAV = GLAV*R2D
      IF( GLAV - 40.)  145,145,150
  145 FTAB = YFOT(3)
      GO TO 165
  150 IF(GLAV  - 50.)  155,155,160
  155 FTAB = YFOT(3)
C.....INTERPOLATE IN BETWEEN
      FTAB = FTAB  - (GLAV - 40.)*(FTAB - 10.)/ 10.
      GO TO 165
C.....SET TO 10 MHZ (NEAR POLES)
  160 FTAB = 10.
  165 CONTINUE
      ESLSM = 0.0
      IF(YMUF(4).gt.0.) then
C   ES CONTRIBUTION TO TABLE( OBSCURTION LOSS).
C
C.....NOW REMOVE ES OBSCURATION AND F2 OVER-THE-MUF AT FTAB FROM TABLES
C.....AND WILL REPLACE FOR EACH MODE AND FREQUENCY AS NECESSARY
         DUMMY = YMUF(4)
         PES = PRBMUF(FTAB,DUMMY,DUMMY,4)
         PES =AMAX1(0.1,PES)
         PES =AMIN1(0.9,PES)
         ESLSM = -10.*ALOG10(1.-PES)
      end if
C  F2 OVER-THE-MUF CONTRIBUTION TO TABLE
C.....PROBABILITY CALCULATION
      DUMMY = YMUF(3)
      PF2 = PRBMUF(FTAB,DUMMY,DUMMY,3)
      PF2 = AMAX1(0.1, PF2)
ccc      PF2 = AMIN1(0.9, PF2)       !  this added 5/12/2005 GRH
      F2LSM = -10.*ALOG10(PF2)
      IF(IAND(INFO,2).GT.0)THEN
        WRITE(99,'(A,A,3F6.2)')' "SIGDIS" OTM(F2 NO SEC) LOSS E',
     1 'XCL FROM TAB 6 FTAB,YMUF,LOS=',FTAB,YMUF(3),F2LSM
      ENDIF
C RESIDUAL (AURORAL) LOSS ADJUSTMENT TO MEDIAN SIGNAL LEVEL.
      ASM = ADJ  - ESLSM - F2LSM
ccc      write(luo,123) asm,adj,eslsm,f2lsm,pf2
ccc123   format('ASM=',5f11.4)
      ASM = AMAX1(ASM, 0.0 )
C  UPPER DECILE
      PES = 0.0
      IF(YFOT(4).gt.0.) then
         DUMMY = YFOT(4)
         PES = PRBMUF(FTAB,DUMMY,DUMMY,4)
         PES = AMAX1( 0.1,PES)
         PES = AMIN1( 0.9,PES)
      end if
      DUMMY = YHPF(3)
      PF2 = PRBMUF(FTAB,DUMMY,DUMMY,3)
      PF2 = AMAX1(0.1, PF2)
ccc      PF2 = AMIN1(0.9, PF2)       !  this added 5/12/2005 GRH
C  UPPER DECILE SIGNAL LEVEL ADJUSTMENT TO MEDIAN
      DSU = 1.28* SL  -( +10.*ALOG10(1.- PES) + ESLSM)
     A                -( +10.*ALOG10(PF2) + F2LSM)
      DSU = AMAX1 ( DSU, 0.5)
C  LOWER DECILE.
      PES = 0.0
      IF(YHPF(4).gt.0.) then
         DUMMY = YHPF(4)
         PES = PRBMUF(FTAB,DUMMY,DUMMY,4)
         PES= AMAX1(0.1,PES)
         PES= AMIN1(0.9, PES)
      end if
      DUMMY = YFOT(3)
      PF2 = PRBMUF(FTAB,DUMMY,DUMMY,3)
      PF2 = AMAX1( 0.1,PF2)
ccc      PF2 = AMIN1(0.9, PF2)       !  this added 5/12/2005 GRH
C LOWER DECILE SIGNAL LEVEL ADJUSTMENT TO MEDIAN
      DSL = 1.28* SU - (-10.* ALOG10(1.-PES) - ESLSM)
     A               - (-10.* ALOG10(PF2) - F2LSM)
      DSL = AMAX1(1.,DSL)
      RETURN
      END
C--------------------------------
c###sigdis.for
      SUBROUTINE SIGDIS_alex
C--------------------------------
C
C  ADJUST SIGNAL DISTRIBUTION TABLES FOR THIS PATH AND SET ABSORPTION
C  LOSS PARAMETERS
C
      use cversn
c jw      common /cversn/ versn
c jw         character versn*8      !  look for "H" to ignore absorption fix
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/GEOG/GYZ(5),RAT(5),GMDIP(5),CLCK(5),ABIY(5),ARTIC(5),SIGPAT
     A(5), EPSPAT(5)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24),FOT
     A (24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMUF(4)
     B ,HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     C ,YMUF(4)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON/SIGD/DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE,HNU
     A ,HTLOSS,XNUZ,XVE
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
      COMMON/INFORM/INFO,IHSHR,IHLNG
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
c>>>>>A.S.
      DIMENSION LX(3)
      DATA LX/1,3,5/
c<<<<<       
      GLAV = 0.0
C.....SET NUMBER OF IONOSPHERES
      KFXX=KFX
ccc      KFXX=KM         !  temp change by Greg for receprocity try

      XKF  = KFXX
      XADJ = 0.0
      XSU  = 0.0
      XSL  = 0.0
      XFMP = 0.0
      XSUP = 0.0
      XSLP = 0.0
      AC = 0.0
      FEAV=0.0
ccc      write(luo,'(''in sigdis, kfx='',2i5)') kfx,km
      DO 115 K = 1,KFXX
C.....ABSORPTION INDEX
      ABIY(K) =  - 0.04 + EXP(-2.937 + 0.8445*FI(1,K) )
c****** Change made 6/2/99 by Greg Hand to fix absorption error
c       that was never fixed in VOACAP.
c******  per change to ICEPAC 3/18/93 by Frank Stewart to fix losses problem
c          this limits ABIY to a lower limit of .1 because that is the
c          lower limit of the curve.
c          IONCAP was wrong when it did not have the lower limit.
c          It was too optimistic with its prediction.
ccc      write(12,'(''abiy('',i1,'')='',f8.4)') k,abiy(k)
c          the "HAM" version does not do the absorption fix
c          to create the "HAM" version, edit the file:
c                  ..\database\version.w32
c             change the "W" to "H".
c          this was changed 2/8/2006 for Dean Straw
c          this was changed 4/18/2006 to "I" from "H". "I"=IONCAP
c          "I" or "a" is IONCAP. "a" is Alex's changes
      if(versn(8:8).eq.'I' .or. versn(8:8).eq.'a') then
      else
         ABIY(K)=MAX(0.1,ABIY(K))
      end if
C.....SYSTEM LOSS TABLE
      DUMMY1 = GLAT(LX(K))
      DUMMY2 = CLCK(LX(K))
      IDP=2
      IF(GCDKM.GT.2500.)IDP=5
      CALL SYSSY(DUMMY1,DUMMY2,IDP,ADJ,SU,SL,FMP,SUP,SLP)
ccc      write(luo,122) k,dummy1,dummy2,idp,adj,su,sl,fmp,sup,slp
ccc     +                ,abiy(k),fi(1,k)
ccc122   format('syssy=',i5,2e15.7,i5,8f10.4)
C.....MEDIAN
      XADJ = XADJ + ADJ
C.....UPPER DECILE
      XSU  = XSU  + SU
C.....LOWER DECILE
      XSL  = XSL  + SL
C.....PREDICTION ERROR, MEDIAN
      XFMP = XFMP + FMP
C.....UPPER DECILE
      XSUP = XSUP + SUP
C.....LOWER DECILE
      XSLP = XSLP + SLP
C.....E CRITICAL
      FEAV = FEAV + FI(1,K)
C.....ABSORBTION INDEX
      AC   = AC   + ABIY(K)
      ARTIC(K) = ADJ
C.....GEOMAGNETIC LATITUDE
      GLAV = GLAV + ABS(GLAT(LX(K)))
  115 CONTINUE
C.....BEGIN SECTION TO SAVE THE AVERAGE VALUES
      GLAV= GLAV/XKF
      AGLAT = GLAV
      ACAV= AC/XKF
      FEAV= FEAV/XKF
      ADJ = XADJ/XKF
ccc      write(luo,'(''adj='',4f11.4)') adj,xadj,xkf,acav
      SU  = XSU/XKF
      SL  = XSL/XKF
      ADS = XFMP/XKF
      SUS = XSUP/XKF
      SLS = XSLP/XKF
C.....END SECTION TO SAVE THE AVERAGE VALUES
      K = JMODE
C
C  PARAMETER FOR D-E ABSORTION LOSS.
C  ABIY( )  IS ABSORPTION INDEX. ACAV IS THE AVERAGE FOR THE PATH
C
C.....D - E REGION LOSS ADJUSTMENT FACTOR
      HTLOSS = 88.
      XVE    = XLIN( 90., HTRUE,FVERT,30, K )
      XVE    = XVE/FI(1,K)
      XNUZ = 63.07
      HNU  = 4.39
      IF(FEAV - 2.0) 125,125,120
C.....ADJUSTMENT TO CCIR 252 (HAYDON,LUCAS) LOSS EQUATION FOR E MODES
  120 AFE  = 1.359
      BFE  = 8.617
      GO TO 140
  125 IF(FEAV - 0. 5) 130,130,135
  130 AFE  = 0.0
      BFE  = 0.0
      GO TO 140
  135 AFE  = 1.359 *(FEAV - 0.5)/1.5
      BFE  = 8.617 *(FEAV - 0.5)/1.5
  140 CONTINUE
C
C  SET SIGNAL DISTRIBUTION TABLES. TABLE IS FOR FREQ = FTAB
C
C.....USE FOT, F2 LAYER
      GLAV = GLAV*R2D
      IF( GLAV - 40.)  145,145,150
  145 FTAB = YFOT(3)
      GO TO 165
  150 IF(GLAV  - 50.)  155,155,160
  155 FTAB = YFOT(3)
C.....INTERPOLATE IN BETWEEN
      FTAB = FTAB  - (GLAV - 40.)*(FTAB - 10.)/ 10.
      GO TO 165
C.....SET TO 10 MHZ (NEAR POLES)
  160 FTAB = 10.
  165 CONTINUE
      ESLSM = 0.0
      IF(YMUF(4).gt.0.) then
C   ES CONTRIBUTION TO TABLE( OBSCURTION LOSS).
C
C.....NOW REMOVE ES OBSCURATION AND F2 OVER-THE-MUF AT FTAB FROM TABLES
C.....AND WILL REPLACE FOR EACH MODE AND FREQUENCY AS NECESSARY
         DUMMY = YMUF(4)
         PES = PRBMUF(FTAB,DUMMY,DUMMY,4)
         PES =AMAX1(0.1,PES)
         PES =AMIN1(0.9,PES)
         ESLSM = -10.*ALOG10(1.-PES)
      end if
C  F2 OVER-THE-MUF CONTRIBUTION TO TABLE
C.....PROBABILITY CALCULATION
      DUMMY = YMUF(3)
      PF2 = PRBMUF(FTAB,DUMMY,DUMMY,3)
      PF2 = AMAX1(0.1, PF2)
ccc      PF2 = AMIN1(0.9, PF2)       !  this added 5/12/2005 GRH
      F2LSM = -10.*ALOG10(PF2)
      IF(IAND(INFO,2).GT.0)THEN
        WRITE(99,'(A,A,3F6.2)')' "SIGDIS" OTM(F2 NO SEC) LOSS E',
     1 'XCL FROM TAB 6 FTAB,YMUF,LOS=',FTAB,YMUF(3),F2LSM
      ENDIF
C RESIDUAL (AURORAL) LOSS ADJUSTMENT TO MEDIAN SIGNAL LEVEL.
      ASM = ADJ  - ESLSM - F2LSM
ccc      write(luo,123) asm,adj,eslsm,f2lsm,pf2
ccc123   format('ASM=',5f11.4)
      ASM = AMAX1(ASM, 0.0 )
C  UPPER DECILE
      PES = 0.0
      IF(YFOT(4).gt.0.) then
         DUMMY = YFOT(4)
         PES = PRBMUF(FTAB,DUMMY,DUMMY,4)
         PES = AMAX1( 0.1,PES)
         PES = AMIN1( 0.9,PES)
      end if
      DUMMY = YHPF(3)
      PF2 = PRBMUF(FTAB,DUMMY,DUMMY,3)
      PF2 = AMAX1(0.1, PF2)
ccc      PF2 = AMIN1(0.9, PF2)       !  this added 5/12/2005 GRH
C  UPPER DECILE SIGNAL LEVEL ADJUSTMENT TO MEDIAN
      DSU = 1.28* SL  -( +10.*ALOG10(1.- PES) + ESLSM)
     A                -( +10.*ALOG10(PF2) + F2LSM)
      DSU = AMAX1 ( DSU, 0.5)
C  LOWER DECILE.
      PES = 0.0
      IF(YHPF(4).gt.0.) then
         DUMMY = YHPF(4)
         PES = PRBMUF(FTAB,DUMMY,DUMMY,4)
         PES= AMAX1(0.1,PES)
         PES= AMIN1(0.9, PES)
      end if
      DUMMY = YFOT(3)
      PF2 = PRBMUF(FTAB,DUMMY,DUMMY,3)
      PF2 = AMAX1( 0.1,PF2)
ccc      PF2 = AMIN1(0.9, PF2)       !  this added 5/12/2005 GRH
C LOWER DECILE SIGNAL LEVEL ADJUSTMENT TO MEDIAN
      DSL = 1.28* SU - (-10.* ALOG10(1.-PES) - ESLSM)
     A               - (-10.* ALOG10(PF2) - F2LSM)
      DSL = AMAX1(1.,DSL)
      RETURN
      END
C--------------------------------

      SUBROUTINE PATTRN0(AZIM,ELEV,XGN,FACTOR)
C--------------------------------------------------------------------
C                        SUBPROGRAM USAGE
C
C  SGAIN - computes power gain dBi
C*********************************************************************
C  COMMON BLOCKS:
C ANTDAT
C       nostak - NUMBER OF VERTICAL STACKS
C       STKSPM - SPACING BETWEEN STACKS
C       NUMBAY - NUMBER OF BAYS
C       BAYSPM - SPACING BETWEEN BAYS
C       DIPLNM - LENGTH OF DIPOLE RADIATOR
C       RRSPM - SPACING BETWEEN RADIATORS AND REFLECTING SCREEN
C       STKHTM - HEIGHT OF LOWEST STACK ABOVE GROUND
C       STKRAT - CURRENT RATIO FOR STACKS
C       BAYPHS - RELATIVE PHASE FOR THE BAYS
C       BAYRAT - CURRENT RATIO FOR THE BAYS (ALWAYS = 1)
C       OFMHZ - ANTENNA OPERATING FREQUENCY
C       DFMHZ - ANTENNA DESIGN FREQUENCY
C
C CONST
C       PI      -  MATHEMATICAL SYMBOL PI = 3.14159
C       VOFL    -  VELOCITY OF LIGHT  FOR FREQUENCY IN MEGAHERTZ = 3.0E-
C       PI2     -  2 * PI
C       PIO2    -  PI / 2
C       D2R     -  CONVERSION FACTOR FOR DEGREES TO RADIANS CONVERSION
C                   = PI / 180.
C       R2D     -  CONVERSION FACTOR FOR RADIANS TO DEGREES CONVERSION
C                   = 180 / PI
C FWAVE
C       EIL     -  0.5 * LENGTH OF DIPOLE IN radianS
C       XB      -  SPACING BETWEEN BAYS IN radiansS
C       XS      -  SPACING BETWEEN STACKS IN radianS
C       XH      -  HEIGHT OF LOWEST STACK ABOVE GROUND IN radianS
C       XR      -  REFLECTOR TO DIPOLE SPACING IN radianS
C       C(8)    -  ARRAY OF RELATIVE STACK CURRENT MAGNITUDE RATIOS
C       R(14)   -  ARRAY OF RELATIVE BAY CURRENT MAGNITUDE RATIOS
C       PS(14)  -  ARRAY OF BAY CURRENT PHASE RATIOS IN RADIANS INCLUDIN
C                     FREQUENCY ADJUSTMENT FOR OPERATING FREQUENCY NOT
C                     EQUAL TO DESIGN FREQUENCY
C       A(8)    -  ARRAY OF STACK CURRENT PHASE RATIOS IN RADIANS,
C                    CURRENTLY DEFAULTED TO ZERO
C       Y(14)   -  ARRAY CONTAINING THE SPACINGS BETWEEN THE BAY DIPOLES
C                     IN radianS (RELATIVE TO BAY 1)
C       Z(8)    -  ARRAY CONTAINING THE SPACINGS BETWEEN THE STACK DIPOL
C                     IN radianS (RELATIVE TO STACK 1)
C       WAVE    -  OPERATING FREQUENCY WAVELENGTH
C       BETA    -  OPERATING FREQUENCY WAVE NUMBER (K=2*PI/WAVE)
C
C
C  DUMMY ARGUMENTS:
C       AZIM  - an azimuth counter-clockwise from Boresight RADIANS 
C       ELEV  - an elevation angle above the horizon  RADIANS
C       XGN  - antenna gain (dB) for AZIM, ELEV
C       FACTOR  - integral result for antenna gain normalization
C
C*********************************************************************
      COMMON/ANTDAT/nostak,STKSPM,NUMBAY,BAYSPM,DIPLNM,RRSPM,STKHTM,
     +STKRAT(8),bayphs(14),DFMHZ,OFMHZ
      COMMON/FWAVE/EIL,CEIL,XB,XS,XH,XR,C,R,PS,A,Y,Z,WAVE,BETA
      DIMENSION C(8),R(14),PS(14),A(8),Y(14),Z(8)
      DATA PI/3.1415926/,VOFL/299.79246/
      DATA PI2/6.283185307/
      DATA D2R/.01745329251/
C  SET DEFAULT VALUES FOR GAIN
        WAVE = VOFL /OFMHZ
        BETA = PI2 / WAVE
        XH = STKHTM * BETA
        XB = BETA * BAYSPM
        EL = DIPLNM * BETA
        EIL = EL / 2.0
        CEIL = COS(EIL)
        XR = RRSPM * BETA
        XS = STKSPM * BETA
C
C  CONSTANTS FUNCTIONS OF FREQUENCY ONLY
       DO 30 Is = 1,nostak
         Z(Is) = XS * FLOAT(Is-1) + XH
         C(Is) = STKRAT(Is)
   30  CONTINUE
       ODRAT = D2R * OFMHZ / DFMHZ
       NBS=IABS(NUMBAY)
       DO 40 Ib = 1,NBS
          PS(Ib) = ODRAT * bayphs(Ib)
          R(Ib) = 1.
          Y(Ib) = FLOAT(Ib-1) * XB
   40 CONTINUE
        Y(1)=0.
        IF(FACTOR.EQ.-99999.)THEN
          CALL DBLTRAP(DINTGL)
          FACTOR = 4.0 * PI / DINTGL
        ENDIF
        XGN=-1000.
        XGAIN = F2 (ELEV,AZIM)
        IF(XGAIN.NE.0.) XGN = 10.* ALOG10(ABS(XGAIN*FACTOR))
        RETURN
      END
C------------------------------------------------------------------

c# pwrdb.for
      function pwrdb(freq)
c          return the power in dBw for the transmitter at frequency
      common /cantenna/ numants,iats(20),anttype(20),antname(20),
     +                  xfqs(20),xfqe(20),designfreq(20),antfile(20),
     +                  beammain(20),offazim(20),cond(20),diel(20),
     +                  array(30,91,20),aeff(30,20)
      character anttype*10,antname*70,antfile*24
      common /pantenna/ pwrkw(20),pwrdba(20)

      pwrdb=30.
      f=freq
      if(f.lt.2.) f=2.
      if(f.gt.30.) f=30.
      do 50 i=1,numants
      if(iats(i).ne.1) go to 50     !  not transmitter
      if(xfqs(i).le.f .and. f.le.xfqe(i)) then
         pwrdb=pwrdba(i)
         return
      end if
50    continue
      return
      end

c# outbod2.f
      SUBROUTINE OUTBOD2(lin,jfmt)
C--------------------------------
C
C     THIS ROUTINE OUTPUTS THE VARIABLES SET IN SUBROUTINE SETOUT
C     DEPENDENT ON METHOD BUT THE USER MAY SPECIFY HIS OWN CHOICE OF
C     VARIABLES TO OUTPUT BY INCLUDING A "BOTLINES" CONTROL CARD AND
C     RUNNING METHOD 23.  THE ROUTINE USES A VECTORED FORMAT SCHEME AND
C     CALLS SUBROUTINES FIXLIN AND FLOLIN TO OUTPUT THE LINE
C
      COMMON /DUDL_NOIS/ DU_NOIS(13),DL_NOIS(13)
      common /c_S_to_I/ i_S_to_I    !  = 1 = S/I calculation
      common /sncom/ snxx(13)
      common /cgains/ gaint(13),gainr(13)
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / OUTFMT / KLINE(26)
      COMMON /OUTPRT/ LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      CHARACTER NDASH*4
      CHARACTER KLINE*6
      INTEGER ITMP(13)
      character jfmt*(*)
      DATA NDASH/'  - '/
      DATA IMUF/12/
C.....THIS PROGRAM WILL WRITE 2 PLUS LINBOT(26) LINES. IT IS
C     ASSUMED THAT THE LINE COUNT WAS CHECKED BY THE CALLING PROGRAM.

      go to (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
     +      21,22),lin
1     continue                       !  MODE
      IF(JLONG.lt.0) then            !  short path
         jfmt(8:15)='1x,i2,a2'
         WRITE(LUO,jfmt) NHP(IMUF),MODE(IMUF),(NHP(IFQ),MODE(IFQ),
     +                   IFQ =1,JFREQ),(NDASH,ID=1,JDASH),KLINE(1)
      else                            !  long path
         jfmt(8:15)='1x,a2,a2'
         WRITE(LUO,jfmt) MODE(IMUF),MODER(IMUF),(MODE(IFQ),MODER(IFQ),
     +                   IFQ=1,JFREQ),(NDASH,ID=1,JDASH),KLINE(1)
      end if
      go to 500
2     CALL FLOLIN(jfmt,1,ANGLE,2)     !  ANGLE
      IF(JLONG.gt.0) CALL FLOLIN(jfmt,1,ANGLER,23)   !  long path ANGLE
      go to 500
3     CALL FLOLIN(jfmt,1,DELAY,3)     !  DELAY
      go to 500
4     DO 104 II=1,13                  !  V HITE
  104 ITMP(II)=anint(vhigh(II))
      CALL FIXLIN(jfmt,ITMP,4)
      go to 500
5     CALL FLOLIN(jfmt,2,CPROB,5)     !  F DAYS
      go to 500
6     DO 106 II=1,13                  !  LOSS
  106 ITMP(II)=anint(dblos(II))
      CALL FIXLIN(jfmt,ITMP,6)
      go to 500
7     DO 107 II=1,13                  !  dBu
  107 ITMP(II)=anint(dbu(II))
      CALL FIXLIN(jfmt,ITMP,7)
      go to 500
8     DO 108 II=1,13                  !  S dBw
  108 ITMP(II)=anint(DBW(II))
      CALL FIXLIN(jfmt,ITMP,8)
      go to 500
9     DO 109 II=1,13                  !  N dBw
  109 ITMP(II)=anint(XNYNOIS(II)+RNEFF(II))
      CALL FIXLIN(jfmt,ITMP,9)
      go to 500
10    DO 110 II=1,13                  !  SNR median
  110 ITMP(II)=anint(sndb(II))
      CALL FIXLIN(jfmt,ITMP,10)
      go to 500
11    DO 111 II=1,13                  !  RPWRG
  111 ITMP(II)=anint(snpr(II))
      CALL FIXLIN(jfmt,ITMP,11)
      go to 500
12    CALL FLOLIN(jfmt,2,RELIAB,12)   !  REL
      go to 500
13    CALL FLOLIN(jfmt,2,PROBMP,13)   !  MPROB
      go to 500
14    CALL FLOLIN(jfmt,2,SPROB,14)    !  SPRB
      go to 500
15    CALL FLOLIN(jfmt,1,DBLOSL,15)   !  SIGLW
      go to 500
16    CALL FLOLIN(jfmt,1,DBLOSU,16)   !  SIGUP
      go to 500
17    if(i_S_to_I.eq.0) then          !  not S/I output
         CALL FLOLIN(jfmt,1,SNRLW,17)    !  SNRLW
      else
         CALL FLOLIN(jfmt,1,DL_NOIS,24)  !  Noise dl
      end if
      go to 500
18    if(i_S_to_I.eq.0) then          !  not S/I output
         CALL FLOLIN(jfmt,1,SNRUP,18)    !  SNRUP
      else
         CALL FLOLIN(jfmt,1,DU_NOIS,25)  !  Noise du
      end if
      go to 500
19    CALL FLOLIN(jfmt,1,gaint,19)    !  T gain
      go to 500
20    CALL FLOLIN(jfmt,1,gainr,20)    !  R gain
      go to 500
21    DO 121 II=1,13                  !  SNR xx
  121 ITMP(II)=anint(snxx(II))
      CALL FIXLIN(jfmt,ITMP,21)
      go to 500
22    DO 122 II=1,13                  !  dBm = S DBW + 30
  122 ITMP(II)=anint(DBW(II)+30.)
      CALL FIXLIN(jfmt,ITMP,22)
500   continue
      RETURN
      END
C--------------------------------

c###tabbod.for
      SUBROUTINE TABBOD
C--------------------------------
C.....THIS ROUTINE TABULATES A VARIABLE SET IN OUTTAB USING A VECTORED
C.....FORMAT SCHEME WHICH PRINTS A DASH IF THE VARIABLE .LE. 0 AND THE
C.....VALUE OTHERWISE
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / OUTGH / PLOTI(24), PLOTJ(24), PLOTK(24), XOUT(13), NPLOTS
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      DIMENSION XFMT(13)
      save ifmt
      CHARACTER IGMT*5, ILMT*5, IMUF*5, IFMT(26)*6, NFMT(11)*6
      DATA IGMT/'  GMT '/, ILMT/'  LMT'/, IMUF/'  MUF'/
      DATA NFMT/'(     ', '  ,2X ', '3F5.1 ', ',3X,  ', '2H-   ',
     A',F5.2 ', '3A5   ', ',F5.1 ', '      ', ',F6.2)', ',A5,/)'/
      JOUT = LUO
      IF(UTIME(IT).le.0) go to 500      !  return if TIME set negative
      IF(ALLMUF(IT).le.1.) go to 500    !  return if MUF = 1.0
C.....SET THE ENTIRE LINE TO PRINT DASHES (CHANGE LATER WHERE NECESSARY)
      IFMT(1) = NFMT(1)
      DO 120 J = 4, 24, 2
  120 IFMT(J) = NFMT(4)
      DO 130 J = 5, 25, 2
  130 IFMT(J) = NFMT(5)
C.....PRINT HEADING IF OUTTOP JUST PRINTED
      IF(LINES.gt.9) go to 220
      WRITE(JOUT,141)
  141 FORMAT(/,27X,'FREQUENCY / RELIABILITY',/)
C.....PRINT FREQUENCIES ( OR DASHES IF THEY AREN"T SET)
      IFREQ = 0
      IFMT(2) = NFMT(7)
      IFMT(3) = NFMT(2)
      IFMT(26) = NFMT(11)
      IF(FREL(14).le.-2.) go to 192
      DO 170 IFQ = 1, 11
      IF(FREL(IFQ).le.0.) go to 170
         IFREQ = IFREQ + 1
         XFMT(IFREQ) = FREL(IFQ)
  170 CONTINUE
      KNT = 4
      DO 180 IFQ = 1, IFREQ
      IFMT(KNT) = NFMT(8)
      IFMT(KNT+1) = NFMT(9)
      KNT = KNT + 2
  180 CONTINUE
      IF(IFREQ.le.0) go to 195
C  TEMP FIX WHEN FOT IS INSERTED
  192 IF(FREL(14).gt.0.) go to 200
      XFMT(1) = 0.0
      GO TO 200
  195 WRITE(JOUT,IFMT) IGMT, ILMT, IMUF, IMUF
      GO TO 205
  200 WRITE(JOUT,IFMT) IGMT, ILMT, IMUF, (XFMT(IFQ),IFQ=1,IFREQ), IMUF
  205 LINES = LINES + 1
C.....RE-INITIALIZE LINE TO PRINT ALL DASHES (CHANGE WHERE NECESSARY)
      DO 210 J = 4, 24, 2
  210 IFMT(J) = NFMT(4)
      DO 215 J = 5, 25, 2
  215 IFMT(J) = NFMT(5)
C.....CHANGE FORMAT VECTORS TO XOUT INSTEAD OF FREQUENCY
  220 IFMT(2) = NFMT(3)
      IFMT(26) = NFMT(10)
C.....TABULATE THE VARIABLE (OR DASHES IF VARIABLE .LE.0)
      IFREQ = 0
      KNT = 4
      DO 250 IFQ = 1, 11
      IF(XOUT(IFQ).gt.0.) then
         IFREQ = IFREQ + 1
         XFMT(IFREQ) = XOUT(IFQ)
         IFMT(KNT) = NFMT(6)
         IFMT(KNT+1) = NFMT(9)
      end if
  250 KNT = KNT + 2
      IF(IFREQ.le.0) then
         WRITE(JOUT,IFMT) UTIME(IT), XLMT(IT), ALLMUF(IT), XOUT(12)
      else
         WRITE(JOUT,IFMT) UTIME(IT), XLMT(IT), ALLMUF(IT),
     +                    (XFMT(IFQ), IFQ = 1, IFREQ), XOUT(12)
      end if
      LINES = LINES + 1
  500 RETURN
      END
C--------------------------------

      subroutine getantyp(iant,antyp)   !  get antenna type generic description
      character antyp*48,antyps(0:48)*48
c============================================================================
      data (antyps(I),i=0,10)/
     +            'ITS addition   ISOTROPE',
     1            'ITU-R Rec705   MULTIBAND APER.REF. ARRAY',
     2            'ITU-R Rec705   DUAL-BAND CNT.FED TUN.REF. AR.',
     3            'ITU-R Rec705   DUAL-BAND END.FED TUN.REF. AR.',
     4            'ITU-R Rec705   DUAL-BAND CNT.FED TROPIC ARR.',
     5            'ITU-R Rec705   HORIZONTAL LOG-PERIODIC ARRAY',
     6            'ITU-R Rec705   VERTICAL LOG-PERIODIC ARRAY',
     7            'ITU-R Rec705   HORIZONTAL RHOMBIC',
     8            'ITU-R Rec705   QUADRANT ANTENNA',
     9            'ITU-R Rec705   CROSSED-DIPOLE ANTENNA',
     +            'ITU-R Rec705   VERTICAL MONOPOLE'/
      data (antyps(I),i=11,20)/
     1            'ITS addition   GAIN TABLE vs ELEVATION ANGLE',
     2            'ITS addition   CURTAIN ARRAY NTIA Rep 87-215',
     3            'ITS addition   GAIN TABLE vs AZIMUTH & ELEVATION',
     4            'ITS addition   Point-to-Point GAIN TABLE',
     +          6*'Unknown antenna type'/
      data (antyps(I),i=21,30)/
     1            'IONCAP ITSA-1  Terminated Horizontal Rhombic',
     2            'IONCAP ITSA-1  Vertical Monopole',
     3            'IONCAP ITSA-1  Horizontal Dipole',
     4            'IONCAP ITSA-1  Horizontal Yagi',
     5            'IONCAP ITSA-1  Vertical Log Periodic',
     6            'IONCAP ITSA-1  Curtain',
     7            'IONCAP ITSA-1  Sloping Vee',
     8            'IONCAP ITSA-1  Inverted L',
     9            'IONCAP ITSA-1  Sloping Rhombic',
     +            'IONCAP ITSA-1  Interlaced Rhombic'/
      data (antyps(I),i=31,40)/
     1            'HFMUFES ITS-78 Terminated Horizontal Rhombic',
     2            'HFMUFES ITS-78 Vertical Monopole',
     3            'HFMUFES ITS-78 Horizontal Half-Wave Dipole',
     4            'HFMUFES ITS-78 Horizontal Yagi',
     5            'HFMUFES ITS-78 Vertical Dipole',
     6            'HFMUFES ITS-78 Curtain',
     7            'HFMUFES ITS-78 Terminated Sloping Vee',
     8            'HFMUFES ITS-78 Inverted L',
     9            'HFMUFES ITS-78 Terminated Sloping Rhombic',
     +            'HFMUFES ITS-78 #10 - Not Used'/
      data (antyps(I),i=41,48)/
     1            'HFMUFES ITS-78 Sloping Long Wire',
     2            'HFMUFES ITS-78 #12 - Not Used',
     3            'HFMUFES ITS-78 Horiz Xed-Dipole Log-Periodic',
     4            'HFMUFES ITS-78 Arbitrary Tilted Dipole',
     5            'HFMUFES ITS-78 Side-Loaded Vert Half-Rhombic',
     6            'HFMUFES ITS-78 Sloping Double Rhomboid',
     7            'HFMUFES ITS-78 Vertical Monopole w/Ground Scrn',
     8            'NOSC-95        Inverted Cone Antenna'/
c=========================================================================
      if(iant.le.48) then
         antyp=antyps(iant)
      else if(iant.ge.90 .and. iant.le.99) then
         write(antyp,1) iant
1        format('External Antenna Type #',i2.2)
      else
         antyp='Unknown antenna type'
      end if
      return
      end

c###findf.for
      SUBROUTINE FINDF(K)
C--------------------------------
C
C     THIS ROUTINE DOES AREA COVERAGE FOR A SPECIFIED FREQUENCY
C     (FIND ALL MODES FOR AN OPERATING FREQUENCY)
C     INSERTS PENETRATION ANGLES INTO THE ANGLE TABLE AND COMPUTES ALL
C     RAY PATH PARAMETERS FOR EACH ANGLE AT THE FREQUENCY "FREQ"
C
C     FREQ  GIVEN OPERATING FREQUENCY  - MHZ-
C     GHOP  GIVEN GROUND DISTANCE -RADIANS-
C     DELPEN(3,5) PENETRATION ANGLE FOR FREQUENCY FMHZ -DEGREES-
C
C
C     DELMOD(6,5)  TAKE OFF ANGLE AT FMHZ,GHOP -DEGREES-
C     HPMOD (6,5)  VIRTUAL HEIGHT AT FMHZ,GHOP -KM-
C     HTMOD (6,5)  TRUE    HEIGHT AT FMHZ,GHOP -KM-
C     DSKPKM       SKIP DISTANCE AT FMHZ,GHOP -KM-
C     DELSKP       TAKE OFF ANGLE FOR SKIP DISTANCE -DEGREES-
C     HPSKP        VIRTUAL HEIGHT FOR SKIP DISTANCE -KM-
C     HTSKP        TRUE    HEIGHT FOR SKIP DISTANCE -KM-
C     NANG IS THE HIGHEST ANGLE NUMBER (PRESET IN SUBROUTINE SANG)
C
 
C     K IS THE SAMPLE AREA
C     ICUSP IS THE INSERT CUSP INDEX
C     (=-1 FOR NOT IN, =0 FOR ONE SIDE IN, =1 FOR FINISHED)
C     IH IS THE HEIGHT INDEX FOR COMMON/RAYS/ (FROM 1 TO 30)
C     ILOW IS THE LOWER LIMIT (IH) FOR LAYER
C     IHIGH IS THE UPPER LIMIT (IH) FOR LAYER
C     IA IS THE ANGLE INDEX FOR COMMON/RAYS/ (1 TO NANG .LE. 40)
C     IAF IS THE ANGLE INDEX FOR COMMON/REFLX/ (1 TO 45)
C     IFOB IS IN KHZ
C
C  LONG PATH PARAMETERS,SEE SUBR LNGPAT.
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON/LOSX/ANDVX(45,3),ADVX(45,3),AOFX(45,3),ARFX(45,3),GRLOSX(45
     A ,3),TGAINX(45,3),TLSKM(45,3),EFFlp(45),IAFTXR(3)
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON/INFORM/INFO,IHSHR,IHLNG
      COMMON/RAYS/ANG(40),IFOB(40,30,5),NANG
      DIMENSION ITYPE(3)
      CHARACTER ITF*1
      DATA ITYPE/1,2,3/
      JFHZ = 1000. * FREQ
      DMAXKM (K) = 0.
      DSKPKM (K) = 10000.
      DO 100 IA = 1, 45
      HPFLX (IA, K) = 0.
      DELFX (IA,K) = 0.
  100 GDFLX (IA, K) = 0.
      FC2 = FI (3, K) * FI (3, K)
C
C     FIND PENETRATION ANGLES
C
      CALL PENANG(K)
      ITF=CHAR(12)
      IF(IAND(INFO,32).GT.0.OR.IAND(INFO,8).GT.0)THEN
      WRITE(99,'(A1,/,/,18X,8H  FREQ  ,F7.3,8H   NANG ,I4,8H  AMIND ,
     1 F6.2,/,31X,12HCONTROL AREA,I4,/,16X,20HPENETRATION ANGLES  ,
     2 3F8.3)')ITF,FREQ,NANG,AMIND,K,(delpen(ia,k),ia=1,3)
      WRITE(99,'(/,A,A,/)')'  IDX  CUSP  DISTANCE  ANGLE V',
     1'IRTUAL M.CORR   TRUE  MODE  FVERT COLL-ADJ'
      ENDIF
      IA = 0
      IAF = 1
C
C     SET  LAYER
C
C.....SET FOR E LAYER
      ICUSP = - 1
      IL = 1
      IH = 1
      ILOW = 1
      IHIGH = 10
      GO TO 275
C.....SET FOR F LAYER
  225 IH = 11
      ILOW = 11
      IF (FI (2, K))235, 235, 245
C.....SET FOR F2 LAYER ONLY
  235 IL = 3
      ICUSP = - 1
      IHIGH = 30
  236 CONTINUE
      GO TO 275
C.....SET FOR F1 LAYER
  245 IL = 2
      ICUSP = - 1
      IHIGH = 20
      GO TO 236
C.....SET FOR F2 LAYER
  255 IL = 3
      ICUSP = - 1
      ILOW = IHIGH + 1
      IHIGH = 30
      IH = 21
      GO TO 236
  265 GO TO (225, 255, 400), IL
C.....START OF SEARCH
  275 CONTINUE
C.....CHECK TO SEE IF ANY MODES FROM THIS LAYER
      IF (DELPEN (IL, K))265, 265, 285
C.....CHECK IF PENETRATED ALL LAYERS
  285 IF (DELPEN (IL, K) - 89.99)295, 295, 400
C.....INCREMENT ANGLE
  295 IA = IA + 1
C.....STOP IF THERE ARE MORE HOPS THAN REASONABLE
      IF(IA-NANG) 300,300,400
  300 CONTINUE
C.....CHECK TO SEE IF LAYER WAS PENETRATED
      IF (DELPEN (IL, K) - ANG (IA))345, 345, 305
C.....SEARCH FOR FREQUENCY
  305 CONTINUE
      IF(IFOB(IA,ILOW,K) - JFHZ) 306, 325, 325
  306 IF(IH - IHIGH) 315, 275, 275
  315 IF (IFOB (IA, IH, K) - JFHZ)335, 325, 330
C.....EXACT FREQUENCY TO THREE PLACES (IN MHZ)
  325 DELFX (IAF, K) = ANG (IA)
      HTFLX (IAF, K) = HTRUE (IH, K)
      AFFLX(IAF,K)=AFAC(IH,K)
      FV = FVERT (IH, K)
      HP = HPRIM (IH, K)
      IMODE (IAF, K) = ITYPE (IL)
      GO TO 375
C.....INCREMENT HEIGHT INDEX
  330 IH = IH + 1
      GO TO 305
  335 IF (IFOB (IA, IH + 1, K) - JFHZ)330, 340, 340
C.....BEGIN INTERPOLATION
  340 SLOPD = IFOB (IA, IH + 1, K) - IFOB (IA, IH, K)
      SLOPD = AMAX1 (1., SLOPD)
      SLOPE = JFHZ - IFOB (IA, IH, K)
      SLOPE = SLOPE / SLOPD
      HTFLX (IAF, K) = HTRUE (IH, K) + SLOPE * (HTRUE (IH + 1, K) - HTRU
     1E (IH, K))
      FV = FVERT (IH, K) + SLOPE * (FVERT (IH + 1, K) - FVERT (IH, K))
      DELFX (IAF, K) = ANG (IA)
      HP = HPRIM (IH, K) + SLOPE * (HPRIM (IH + 1, K) - HPRIM (IH, K))
      AFFLX (IAF, K) = AFAC (IH, K) + SLOPE * (AFAC (IH + 1, K) - AFAC (
     1IH, K))
      IMODE (IAF, K) = ITYPE (IL)
C.....END INTERPOLATION
      GO TO 375
C.....BEGIN INSERT OF CUSP
  345 DELFX (IAF, K) = DELPEN (IL, K)
      HTFLX (IAF, K) = HTRUE (IHIGH, K)
      AFFLX( IAF,K ) = AFAC( IHIGH, K)
      FV = FVERT (IHIGH, K)
      HP = HPRIM (IHIGH, K)
C.....KEEP ANGLE COUNT CORRECT
      IA = IA - 1
      ICUSP = 0
      IMODE (IAF, K) = ITYPE (IL)
C.....END OF INSERT CUSP
      GO TO 375
C.....F2 IS THE LAST LAYER
  350 IF (IL - 3)355, 400, 400
C.....IS NEXT LAYER POSSIBLE
C
C.....BEGIN INSERT CUSP FOR NEXT LAYER
  355 IF (DELPEN (IL, K) - 89.9)360, 400, 400
  360 DELFX (IAF, K) = DELFX (IAF - 1, K) + .001
      HTFLX (IAF, K) = HTRUE (IHIGH + 1, K)
      AFFLX(IAF,K) = AFAC(IHIGH+1,K)
      FV = FVERT (IHIGH + 1, K)
      HP = HPRIM (IHIGH + 1, K)
      ICUSP = 1
      IF (FI (2, K))365, 365, 370
  365 IMODE (IAF, K) = ITYPE (3)
      GO TO 375
  370 IMODE (IAF, K) = ITYPE (IL + 1)
C.....END OF INSERT CUSP FOR NEXT LAYER
  375 CONTINUE
C  CORRECT MARTYN S THEOREM
C.....MARTYN"S THEOREM ASSUMES FLAT IONOSPHERE
C.....THIS IS A CORRECTION FOR A SPHERICAL IONOSPHERE
      DEL = DELFX (IAF, K) * D2R
      RCOSD = RZ * COS (DEL)
      XFSQ = FREQ * FREQ / FC2
      HT = HTFLX (IAF, K)
      XMUT = 1. - FV * FV / (FREQ * FREQ)
      XHP = (HP - HT) / RZ
      SPH = XFSQ * XMUT * XHP * (HT + 2. * (RZ + HT) * XHP)
c.....SPH=amin1(SPH,60.)
CANCEL      IF(IAND(INFO,8).GT.0)THEN
CANCEL        WRITE(99,'(2(A,I2),3(A,F7.2))')' "FINDF" LAYER=',IL,
CANCEL     1'  IAF=',IAF,'  FREQ=',FREQ,'  HP=',HP,'  MARTYN CORR=',SPH
CANCEL      ENDIF
      HP = HP + SPH
      PHE = RCOSD / (RZ + HP)
      PHE = ASIN (PHE)
      GDR = 2. * RZ * (PIO2 - DEL - PHE)
C.....GROUND DISTANCE (KM)
      GDFLX (IAF, K) = GDR
      HPFLX (IAF, K) = HP
      FVFLX (IAF, K) = FV
C.....BEGIN TO FIND SKIP DISTANCE (MINIMUM)
      IF (DSKPKM (K) - GDR)385, 385, 380
  380 DSKPKM (K) = GDR
      DELSKP (K) = DELFX (IAF, K)
      HTSKP (K) = HT
      HPSKP (K) = HP
      FVSKP (K) = FV
      ISKP (K) = ITYPE (IL)
      SKPSPH=SPH
      ICUSPSKP=ICUSP
C.....END OF FINDING SKIP DISTANCE
  385 IF (DMAXKM (K) -  GDR)390, 390, 395
  390 IF(DELFX(IAF,K)  - AMIND ) 395,391,391
C.....FIND MAXIMUM DISTANCE
  391 DMAXKM(K) = GDR
      ICUSPMAX=ICUSP
  395 CONTINUE
C.....INCREMENT INDEX FOR COMMON/REFLX/ (MAXIMUM IS 45)
      IF(IAND(INFO,32).GT.0.OR.IAND(INFO,8).GT.0)THEN
      WRITE(99,'(2I5,F11.1,F7.2,F8.2,F6.2,F9.2,I4,F8.3,F7.2))')IAF,
     1 ICUSP,GDFLX(IAF,K),DELFX(IAF,K),HPFLX(IAF,K),SPH,HTFLX(IAF,K),
     2 IMODE(IAF,K),FVFLX(IAF,K),AFFLX(IAF,K)
      ENDIF
      IAFTXR(K)=IAF
      IAF = IAF + 1
      IF(IAF - 45) 396, 396, 400
  396 IF(ICUSP) 275, 350, 265
  400 CONTINUE
C.....END OF INSERT CUSP  (IE CUSP FINISHED)
      IF(IAND(INFO,32).GT.0.OR.IAND(INFO,8).GT.0)THEN
      WRITE(99,'(/,5H SKIP,I5,F11.1,F7.2,F8.2,F6.2,F9.2,I4,F8.3,/,A,
     1 I5,F11.1)')ICUSPSKP,DSKPKM(K),DELSKP(K),HPSKP(K),SKPSPH,HTSKP(K),
     2 ISKP(K),FVSKP(K),' MAX ',ICUSPMAX,DMAXKM(K)
      ENDIF
      RETURN
      END
C--------------------------------

c###lngpat.for
      SUBROUTINE LNGPAT
C--------------------------------
C
C     THIS SUBROUTINE PUTS THE LONG PATH MODE TOGETHER
C
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SxGU,SxGL,KJ,JK
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24),FOT
     A (24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMUF(4)
     B ,HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     C ,YMUF(4)
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/LOSX/ANDVX(45,3),ADVX(45,3),AOFX(45,3),ARFX(45,3),GRLOSX(45
     A ,3),TGAINX(45,3),TLSKM(45,3),EFFlp(45),IAFTXR(3)
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON/SIGD/DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE,HNU
     A ,HTLOSS,XNUZ,XVE
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
      COMMON / allMODE /ABPS(20),CREL(20),FLDST(20),HN(20),HP(20),
     1PROB(20),RELY(20),RGAIN(20),SIGPOW(20),SN(20),
     2SPRO(20),TGAIN(20),TIMED(20),TLOSS(20),B(20),FSLOS(20),
     3grlos(20),adv(20),obf(20),
     CNMODE(20),TLLOW(20),TLHGH(20),EFF(20),NREL,NMMOD
      COMMON/INFORM/INFO,IHSHR,IHLNG
      CHARACTER OUTDAT*25, MR*1,ITF*1
C==========================================================
C.....LTXRGM(1) .GE. 1 AND LTXRGM(2) .GE. 1 SINCE OVER-THE-MUF ADDED
      IF(LTXRGM(1).le.0.) return
      IF(LTXRGM(2).le.0.) return
C.....AVERAGE TAKE-OFF ANGLE
      DEL = .5*D2R*(DELFX(LTXRGM(1),1) + DELFX(LTXRGM(2),ITXRCP(2)))
C.....AVERAGE VIRTUAL HEIGHT
      HPX = .5*(HPFLX(LTXRGM(1),1) + HPFLX(LTXRGM(2),ITXRCP(2)))
      RCOSD = RZ*COS(DEL)
      SPHE = RCOSD/(RZ+HPX)
      PHE  = ATAN(SPHE/SQRT(1.- SPHE*SPHE) )
      DT = .5* GDFLX(LTXRGM(1),1)/RZ
      DR = .5* GDFLX(LTXRGM(2),ITXRCP(2))/RZ
      RAY  = RZ* COS(PHE+DEL)/SPHE
C.....FREE-SPACE CONVERGENCE FACTOR
      CALL CONVH(GCD,PHE,DEL,HPX,RAY,CH,PTOT)
C.....FREE-SPACE LOSS
      FREE = 36.58 + 20.*ALOG10(.6214 *PTOT* FREQ) -CH
C.....IONOSPHERIC DISTANCE
      DI  = GCD - DT -DR
      DIKM = DI*RZ
      IF(DIKM.le.-1.) then
         DM = 0.
         AM = 0.
         AF = 0.
         DF = 0.
         GMKM=0.
      else
C.....OVER-THE-TOP DISTANCE
         CALL GETTOP(DIKM, GMKM)
         DM = GMKM/RZ
         DF = DI - DM
         DF = AMAX1(DF,0.0)
C.....LOSS PER KILOMETER
         CALL  TABS(DEL,HPX,DM,AM)
         CALL BABS(DEL,HPX,DF,AF)
      end if
C.....LOSSES
      XLM = AM*DM*RZ
      XLF = AF*DF*RZ
C  LOSS AT TRANSMITTER END.
      XLT = (ANDVX(LTXRGM(1),1) + ADVX(LTXRGM(1),1)) / 2.
C  LOSS AT RECEIVER END
      XLR = (ANDVX(LTXRGM(2),ITXRCP(2))+ADVX(LTXRGM(2),ITXRCP(2)))/2.
C.....AVERAGE GROUND LOSS
      GLOSS=.5*(GRLOSX(LTXRGM(1),1) + GRLOSX(LTXRGM(2),ITXRCP(2)) )
      FHOP = DF/(DR + DT)
      FHOP = AMAX1(FHOP,1.)
      NMMOD=1
C.....TRANSMISSION LOSS
ccc      write(luo,108) df,di,dm,gcd,dt,dr,dikm
ccc108   format('df=',6f10.6,f10.3)
ccc      write(luo,109) xlf,af,df,rz
ccc109   format('xlf=',f10.3,f10.6,f10.6,f10.3)
ccc      write(luo,111) FREE,XLT,XLM,XLF,XLR,FHOP,GLOSS,ASM
ccc111   format('free=',8f10.3)
      TLOSL = FREE + XLT + XLM + XLF + XLR + (FHOP - 1.) * GLOSS + ASM
     A        - TGAINX(LTXRGM(2),ITXRCP(2)) - TGAINX(LTXRGM(1),1)
ccc      write(luo,'(''tlosl='',f10.3)') tlosl
      GRLOS (1) = GLOSS
      HN(1) = 0.5 * GCD / (DR + DT)
C.....NUMBER OF HOPS
      HN(1) = AMAX1(1.0,HN(1) )
C.....VIRTUAL HEIGHT
      HP(1)   = HPX
C.....ANTENNA GAIN
      RGAIN(1)= TGAINX(LTXRGM(2),ITXRCP(2))
      TGAIN(1)= TGAINX(LTXRGM(1),1)
      EFF(1) = EFFlp(ltxrgm(2))
C.....TIME DELAY
      TIMED(1) = PTOT/VOFL
      TLOSS(1) =  TLOSL
C.....TRANSMISSION ANGLE
      B(1)     =  DELFX(LTXRGM(1),1)
C.....RECEPTION ANGLE
      B(2)     =  DELFX(LTXRGM(2),ITXRCP(2))
C.....MODE TYPE
      NMODE(1) = IMODE(LTXRGM(1),1)
      NMODE(2) = IMODE(LTXRGM(2),ITXRCP(2))
      FSLOS(1) =  FREE
      ADV(1)   = (ADVX(LTXRGM(1),1) + ADVX(LTXRGM(2),ITXRCP(2)))*.5
      ABPS(1)  =(ANDVX(LTXRGM(1),1) +ANDVX(LTXRGM(2),ITXRCP(2)))*.5
      OBF(1)   =(AOFX(LTXRGM(1),1) + AOFX(LTXRGM(2),ITXRCP(2)))*.5
      SIGPOW(1)= PWRDB(FREQ) - TLOSL
C.....FIELD STRENGTH
      FLDST(1) = 107.2 + PWRDB(FREQ) + 20.*ALOG10(FREQ)-TLOSL-RGAIN(1)
C.....SNR
C------------    CHANGED 9/24/91  (LONG PATH RCVR EFF CORRECTION)  FJR
C------------            SN(1) = SIGPOW(1) - RCNSE
      SN(1) = SIGPOW(1) - RCNSE - EFF(1)
      ITRY = 1
      IS = NMODE(1)
  200 DUMMY = YMUF(IS)
      P = PRBMUF(FREQ,DUMMY,DUMMY,IS)
      ZLMUF = -10.*ALOG10(P)
      DUMMY = YFOT(IS)
      P = PRBMUF(FREQ,DUMMY,DUMMY,IS)
      ZLFOT = -10.*ALOG10(P)
      DUMMY = YHPF(IS)
      P = PRBMUF(FREQ,DUMMY,DUMMY,IS)
       ZLHPF = -10.*ALOG10(P)
      CPR = FVMUF(IS)/YMUF(IS)
      DSLF = ( ZLFOT - ZLMUF ) / CPR
      DSUF = ( ZLMUF - ZLHPF ) / CPR
      IF( ITRY -1 ) 250,250,260
  250 IF(IS - NMODE(2) ) 255,265,255
  255 ITRY = 2
      IS = NMODE(2)
      DSLFF = DSLF
      DSUFF = DSUF
      GO TO 200
  260 DSUF = .5 * (DSUF + DSUFF)
      DSLF = .5 * (DSLF + DSLFF)
  265 TLLOW(1) =DSL + HN(1) * DSLF
      TLHGH(1) =DSU + HN(1) * DSUF
C.....LOWER DECILE
      TLLOW(1) = AMIN1( TLLOW(1), 25.)
C.....UPPER DECILE
      TLHGH(1) = AMIN1( TLHGH(1), 25.)
C--------------------------------
      IF(IAND(INFO,128).GT.0)THEN
        ITF=CHAR(12)
        DO 280 JJ=1,2
        WRITE(99,'(A1,20X,20hCONTROL AREA NUMBER ,I2,3X,11HMOST RELIAB,
     1  3HLE ,I3,/,44H IDX    ABSORP   DEV LOS    OBSCUR    GR LOS,4X,
     2  31HA.GAIN   GN-LOS   F HOP  TO ANG,/)')ITF,ITXRCP(JJ),LTXRGM(JJ)
        K=ITXRCP(JJ)
        DO 275 IA=1,IAFTXR(K)
        IF((GML(IA,K).EQ.-999..AND.FHP(IA,K).EQ.999.).OR.
     1  (ANDVX(IA,K).EQ.1000..AND.ADVX(IA,K).EQ.1000.))THEN
          OUTDAT=' '
        ELSE
         WRITE(OUTDAT,'(F9.2,F8.4,F8.3)')GML(IA,K),FHP(IA,K),DELFX(IA,K)
        ENDIF
        MR=' '
        IF(IA.EQ.LTXRGM(JJ))THEN
          WRITE(OUTDAT(10:10),'(1H*)')
          WRITE(OUTDAT(18:18),'(1H*)')
          MR='*'
        ENDIF
        WRITE(99,'(I4,A1,5F10.2,A25)')IA,MR,ANDVX(IA,K),ADVX(IA,K),
     1  AOFX(IA,K),GRLOSX(IA,K),TGAINX(IA,K),OUTDAT
  275   CONTINUE
  280   CONTINUE
        NHOPS=HN(1)+.01
        WRITE(99,'(/,/,  14H  NUMBER HOPS ,I3,22H  MOST RELIABLE MODES:,
     1  8H   XMTR ,I3,8H   RCVR ,I3,/,11H  F.S.LOSS ,F8.2,3X,8H F-DAYS ,
     2  6H XMTR ,F5.2,6H RCVR ,F5.2)')NHOPS,LTXRGM(1),LTXRGM(2),FREE,
     3  PROB(1), PROB(2)
      ENDIF
C.....F.DAYS
      PROB(1) = AMIN1( PROB(1), PROB(2))
      RETURN
      END
C--------------------------------

      subroutine ucase(ialf,nch)
c          Convert all lower case letters in IALF to UPPER case
      character ialf*(*)
      do 10 i=1,nch
      ich=ichar(ialf(i:i))
      if(ich.ge.97 .and. ich.le.122) ialf(i:i)=char(ich-32)
 10   continue
      return
      end

c# col_DOS.for
      character*6 function col_DOS(index,icode)  ! convert color index to color
      common /DOS_col/ ncolors,colors(20),index_DOS(20),DOScol(20)
      character colors*6,DOScol*6
      do 10 i=1,ncolors
      if(index.eq.index_DOS(i)) then
         if(icode.eq.0) col_DOS=colors(i)
         if(icode.ne.0) col_DOS=DOScol(i)
         return
      end if
10    continue
      col_DOS='Ignore'       !  Ignore if not found
      return
      end
C------------------------------------------------------------------

c###outpar.for
      SUBROUTINE OUTPAR
C--------------------------------
C
C     THIS ROUTINE OUTPUTS IONOSPHERIC PARAMETERS
C
      COMMON / CON / D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON / ES / FS(3,5), HS(5)
      COMMON / GEOG / GYZ(5), RAT(5), GMDIP(5), CLCK(5), ABIY(5),
     1 ARTIC(5), SIGPAT(5), EPSPAT(5)
      COMMON / MFAC / F2M3(5),HPF2(5),ZENANG(5),ZENMAX(5),IEDP,FSECV(3)
      COMMON / OUTLAB / LABEL(11), LAYTYP(5), IEAST, INORTH, ISOUTH,
     A IWEST, LABLI, LABLJ, LABLK
      CHARACTER IEAST*1, ISOUTH*1, INORTH*1, IWEST*1, LABEL*5, LAYTYP*2,
     A LABLI*5, LABLJ*5, LABLK*5
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      CHARACTER IGLAT*1, ISLAT*1, ISLONG*1
      DO 160 K=1,KM
      LINES = LINES + 1
      IF(LINES - LINMAX) 110, 110, 100
C.....CALL SUBROUTINE OUTTOP TO OUTPUT HEADER INFORMATION
  100 CALL OUTTOP
      WRITE(LUO,503)
      WRITE(LUO,500) YI(1,1), HI(1,1), HS(1)
      WRITE(LUO,501)
      LINES = LINTOP(15)
  110 GL = ABS(GLAT(K) * R2D)
      XLAT = ABS(CLAT(K) * R2D)
      XLONG = ABS(CLONG(K) * R2D)
      GYZH = GYZ(K) / 2.
      IGLAT = INORTH
      ISLAT = INORTH
      ISLONG = IEAST
      IF(GLAT(K)) 115, 120, 120
  115 IGLAT = ISOUTH
  120 IF(CLAT(K)) 125, 130, 130
  125 ISLAT = ISOUTH
  130 IF(CLONG(K)) 140, 150, 150
  140 ISLONG = IWEST
  150 WRITE(LUO,502) XLAT, ISLAT, XLONG, ISLONG, CLCK(K), GMT, FI(1,K),
     1 FI(2,K), YI(2,K), HI(2,K), GYZH, FI(3,K), YI(3,K), HI(3,K),
     2 FS(1,K), FS(2,K), FS(3,K), F2M3(K), HPF2(K), RAT(K), ZENANG(K),
     3 ZENMAX(K), GL, IGLAT
  160 CONTINUE
      RETURN
  500 FORMAT(' ',32X,'YE = ',F5.1,5X,'HE = ',F5.1,5X,'HS = ',F5.1,/)
  501 FORMAT(' ',2X,'LAT',3X,'LONG',4X,'LMT',4X,'UT',4X,'E',5X,'F1',4X,
     A 'Y1',5X,'H1',2X,'FH/2',3X,'F2Z',4X,'Y2',5X,'H2',3X,'ES',2X,'MED',
     B 3X,'HI',1X,'M3000',3X,'HPF2',3X,'RAT',4X,'ZEN',2X,'ZMAX',2X,
     C 'MAGL')
  502 FORMAT(2(1X,F5.1,A1),2F6.1,F6.2,2F6.1,F7.1,3F6.1,F7.1,
     1 3F5.1,F6.2,2(F7.1,F6.1),F6.1,A1)
  503 FORMAT(' ')
      END
C--------------------------------

c# DOScolr.for
      subroutine DOScolr    !  read DOS color table
      use voacapl_defs
      use crun_directory
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      common /DOS_col/ ncolors,colors(20),index_DOS(20),DOScol(20)
      character colors*6,DOScol*6
      character skip*1
C------------------------------------------------------------------
      nc=0
c jw      nch_run=lcount(run_directory,50)
      open(17,file=trim(root_directory)//PATH_SEPARATOR//'database'//PATH_SEPARATOR//'colors.dat',
     +     status='old',err=900)
      rewind(17)
      read(17,'(a)') skip    !  skip header card
10    read(17,11,end=100) colors(nc+1),index_DOS(nc+1),DOScol(nc+1)
11    format(a6,i5,2x,a6)
      nc=nc+1
      if(nc.lt.20) go to 10
100   close(17)
900   ncolors=nc
      return
      end

c###magvar.for
      SUBROUTINE MAGVAR (CENLAT, CENLG, II, CLG)
C--------------------------------
C
C     ROUTINE TO EVALUATE RAWER MAGNETIC DIP ANGLE AND GYROFREQUENCY
C
C CYCEN IS SUN ZENITH ANGLE, RADIANS.
C II IS SAMPLE AREA
C
C
C CENLAT IS GEOGRAPHIC LATITUDE, RADIANS, OF SAMPLE AREA.
C CENLG IS GEOGRAPHIC LONGITUDE. - IS WEST, + IS EAST
C II IS SAMPLE AREA.,1 TO 5.
C CLG IS GEOGRAPHIC  EAST LONGITUDE.
C
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /GEOG /GYZ (5), RAT (5), GMDIP (5), CLCK (5), ABIY (5), ART
     1IC (5), SIGPAT (5), EPSPAT (5)
      DIMENSION POS (3), UNE (3)
      C360 = 360. * D2R
      IF (CENLG)100, 105, 105
C.....CHANGE TO EAST LONGITUDE
  100 CLG = C360 + CENLG
      GO TO 110
  105 CLG = CENLG
C.....POS(1) IS LATITUDE, POS(2) IS LONGITUDE AND POS(3) IS HEIGHT 300KM
  110 POS (1) = CENLAT
      POS (2) = CLG
      POS (3) = 300000.
C.....EVALUATE THE MAGNETIC FIELD VECTORS
      CALL MAGFIN (POS, UNE)
      HHM = SQRT (UNE (1) * UNE (1) + UNE (2) * UNE (2) + UNE (3) * UNE
     1(3))
C.....GYZ(II) IS THE GYROFREQUENCY
      GYZ (II) = 2.8 * HHM
      TMP = UNE (2) * UNE (2) + UNE (3) * UNE (3)
      GOB = COS (CENLAT)
      IF (GOB .LE. .000001) GOB = .000001
      X = ATAN (ATAN ( - UNE (1) / SQRT (TMP)) / SQRT (GOB))
      GMDIP (II) = X
C.....GMDIP(II) IS THE RAWER MAGNETIC DIP ANGLE
      RETURN
      END
C--------------------------------
C--------------------------------

c###babs.for
      SUBROUTINE BABS(DEL,HP,DF,AF)
C--------------------------------
C
C     THIS SUBROUTINE CALCULATES THE LOSS PER KILOMETER FOR A PATH
C     PASSING THROUGH THE ABSORBING REGION
C
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON / GEOG / GYZ(5), RAT(5), GMDIP(5), CLCK(5), ABIY(5),
     1 ARTIC(5), SIGPAT(5), EPSPAT(5)
      COMMON/SIGD/ DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE
     A ,HNU,HTLOSS,XNUZ,XVE
      IF(DF) 105,105,110
  105 AF = 1000.
      RETURN
  110 IF( HP-70.) 105,115,115
C.....ABSORPTION INDEX
  115 AF = ACAV
C.....THIS IS THE F2 MODE LOSS FOR A FRACTIONAL NUMBER OF HOPS
      AB = 10.2 + (FREQ + GYZ(3))**1.98
       AF = 677.2*AF/AB
      RCOSD = RZ*COS(DEL)
      SPHE  = RCOSD/(RZ+HP)
      PHE  = ATAN(SPHE/SQRT(1.- SPHE*SPHE) )
      PSI  = PIO2 -PHE -DEL
      XMHOP= .5*DF/PSI
      SPHE = RCOSD/(RZ+100.)
      SCPHE= 1./SQRT(1.-SPHE*SPHE)
      PORT = XMHOP*SCPHE/(DF*RZ)
      AF   = AF*PORT
      RETURN
      END
C--------------------------------

C FUNCTION REACT              (NEXT)
      FUNCTION REACT (S)
C 
C     REACT - PARAMETERS FOR THE MUTUAL REACTANCE EVALUATION BY 
C        GAUSSIAN INTEGRATION.
C     CALLED BY AGAUSS (BY DIRECTION OF MUTUAL) TO EVALUATE INTEGRAND 
C     SEE REFERENCES IN SUBROUTINE GAIN 
C 
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RO, VOFL 
C 
      COMMON /MUT /CFAC, CT, H2, PROD1, RHI2, R21, X21, Y0, Z0
C 
C.......................................................................
      SZ = S * CT 
      SY = S * PROD1
      TERM = Y0 + SY
      RHO2 = TERM * * 2 
      CA = Z0 + SZ
      CA1 = CA + H2 
      CA2 = CA - H2 
      R = SQRT (RHO2 + CA * * 2)
      R1 = SQRT (RHO2 + CA1 * * 2)
      R2 = SQRT (RHO2 + CA2 * * 2)
      CR = COS (PI2 * R) / R
      FACX = 2.0 * CFAC * CR
      CR1 = COS (PI2 * R1) / R1 
      CR2 = COS (PI2 * R2) / R2 
      REACT = (((CR1 * CA1 + CR2 * CA2 - FACX * CA) * SY) / TERM + (FACX
     1 - CR1 - CR2) * SZ) * SIN (PI2 * (H2 - ABS (S))) / S
      RETURN 
      END

c# ioncap.f
      subroutine voacap(igraph)
c******************************************************************
c            this routine executes VOACAP 
c******************************************************************
      use voacapl_defs
      use crun_directory
      INCLUDE 'ficepac.hdr'
      common /cbotlines/ nbotlines,linesbot(14)
      common /ctoplines/ ntoplines,linestop( 7)
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
c******************************************************************
      character tns*1,tew*1,rns*1,rew*1,alf*80,antfile_name*21
      character path(2)*1,coefflist(2)*4
      data path/'S','L'/
      data coefflist/'CCIR','URSI'/

      nch_run=lcount(run_directory,50)
      if(igraph.eq.0) then
         open(31,file=run_directory(1:nch_run)//PATH_SEPARATOR//'voacapx.dat')
      else
         open(31,file=run_directory(1:nch_run)//PATH_SEPARATOR//'voacapg.dat')
      end if
      rewind(31)
c***************************************************************
c          Copy defaults from VOACAP.DEF
      open(32,file=run_directory(1:nch_run-3)//'database'//PATH_SEPARATOR//'voacap.def',
     +     status='old',err=100)
90    read(32,'(a)',end=99) alf
      nch=lcount(alf,80)
      write(31,'(a)') alf(1:nch)
      go to 90
99    close(32)
c***************************************************************
100   write(31,101) coefflist(icoeffs)(1:4)
101   format('COEFFS    ',a4)
c***************************************************************
      if(igraph.eq.0) then               !  circuit
         if(method.eq.11 .or. method.eq.28) then
            write(31,3) 1,24,1,1         !  MUF-LUF plots
         else
            iflag=-1                     !  LMT
            if(itimecode.eq.1) iflag=1   !  UT
            write(31,3) ihr1,ihr2,ihrinc,iflag
3           format('TIME      ',4i5)
         end if
      else                               !  graph, force 24 hours UT
         write(31,3) 1,24,1,1
      end if

      do 120 n=1,10
      if(montha(n).eq.0.) go to 125
120   continue
      n=11
125   n=n-1
ccc      write(31,4) year,(int(montha(i)),i=1,n)
ccc4     format('MONTH     ',11i5)
      write(31,4) year,(montha(i),i=1,n)
4     format('MONTH     ',i5,10f5.2)
      write(31,2) (float(ssna(i)),i=1,n)
2     format('SUNSPOT   ',12f5.0)

      call getTR(tlat,tlon,rlat,rlon)
      call benchfix(rname,rlat,rlon)      !  fix coordinates for benchmark
      write(31,5) tname,rname
5     format('LABEL     ',2a20)
      tlatd=tlat
      tns='N'
      if(tlatd.lt.0.) tns='S'
      tlond=tlon
      if(tlond.gt.180.) tlond=tlond-360.
      tew='E'
      if(tlond.lt.0.) tew='W'
      rlatd=rlat
      rns='N'
      if(rlatd.lt.0.) rns='S'
      rlond=rlon
      if(rlond.gt.180.) rlond=rlond-360.
      rew='E'
      if(rlond.lt.0.) rew='W'
      write(31,6) abs(tlatd),tns,abs(tlond),tew,
     +            abs(rlatd),rns,abs(rlond),rew,path(ipath),ipath-1
6     format('CIRCUIT   ',f5.2,a1,3(f9.2,a1),2x,a1,1x,i5)
      xnoise=noise
      if(noise.eq.1) xnoise=-1.       !  -140.4
      if(noise.eq.2) xnoise=-2.       !  -144.7
      if(noise.eq.3) xnoise=-3.       !  -150.0
      if(noise.eq.4) xnoise=-4.       !  -164.1
      write(31,111) 1.0,xnoise,amind,float(xlufp),float(rsn),pmp,dmpx
111   format('SYSTEM    ',f5.0,f5.0,f5.2,f5.0,3f5.2)
      write(31,13) fprob
13    format('FPROB     ',4f5.2)
      do 10 i=1,numants
      call antfile(xmtr_dir(i),xmtr_file(i),antfile_name)
10    write(31,11) 1,i,minfreq(i),maxfreq(i),design_freq(i),
     +             antfile_name,beam_main(i),TxPower(i)
11    format('ANTENNA   ',4i5,f10.3,1h[,a21,1h],f5.1,f10.4)
      call antfile(rec_dir,rec_file,antfile_name)
      write(31,11) 2,numants+1,2,30,0.,antfile_name,rec_bear,rec_gain

      if(igraph.eq.0) then
         write(31,7) (float(freq(i))/1000.,i=1,11)
7        format('FREQUENCY ',11f5.2)
      else
            write(31,17) (freq(i),i=1,11)
17          format('COMMENT   FREQ ',11i5)
ccc         write(31,8) 26,0                 !  method 26 is LUF-MUF table
ccc         write(31,'(7HEXECUTE)')
         write(31,7) -1.                  !  do all frequencies for graph
      end if

      npage0=0
      if(igraph.eq.0) then
         write(31,8) method,npage0
8        format('METHOD    ',2i5)
      else
         met=method
         if(met.lt.16 .or. met.gt.23) met=16
         if(method.eq.30) met=30      !  method 30 is allowed for graphs
         write(31,8) met,npage0
      end if
      if(method.eq.23) then
         if(nbotlines.eq.0) then
            nbotlines=7
            linesbot(1)=1         !  MODE
            linesbot(2)=2         !  ANGLE
            linesbot(3)=19        !  Tgain
            linesbot(4)=7         !  DBU
            linesbot(5)=10        !  SNR
            linesbot(6)=21        !  SNR90
            linesbot(7)=12        !  REL
         end if
         write(31,23) (linesbot(i),i=1,nbotlines)
23       format('BOTLINES  ',14i5)
         if(ntoplines.eq.0) then
            ntoplines=7
            do 123 i=1,7
123         linestop(i)=i        !  turn on all
         end if
         write(31,24) (linestop(i),i=1,ntoplines)
24       format('TOPLINES  ',7i5)

      end if

      write(31,'(7HEXECUTE)')

      write(31,'(4HQUIT)')
      close(31)
ccc      if(igraph.eq.0) then
ccc         if(method.eq.11 .or.method.eq.28) stop 25   !  graphics plots
ccc         stop 5
ccc      else
ccc         stop 15
ccc      end if
      end
c------------------------------------------------------------------

c------------------------------------------------------
      subroutine ant90_calc(freq,azimuth,elev,gain,efficiency,*)
c          external antenna calculations:
c          If outside frequency range, gain=-99.9 returned.
c          If ELEVATION angle or AZIMUTH angle in error, return 1
      common /Cant90/ luaa,filenam,title,itype,parms(20),
     +                 nfreq,frequency(100),dbi(100),eff(100),
     +                 ifreq1,gain1(91,360),ifreq2,gain2(91,360)
         character filenam*80,title*80

      gain=-99.9
      efficiency=0.
      if(freq.lt.frequency(1) .or. freq.gt.frequency(nfreq)) go to 900 ! out of freq range
      if(elev.lt.0. .or. elev.gt.90.) go to 910 ! out of elevation angle range
      azim=azimuth
      if(azim.lt.0.) azim=azim+360.
      if(azim.ge.360.) azim=azim-360.
      if(azim.lt.0. .or. azim.ge.360.) go to 920   !  out of azimuth angle range
      do 10 i=1,nfreq
      if(abs(freq-frequency(i)).lt..001) then   !  frequency match
	 gain=ant90_gain(i,azim,elev,luaa,ifreq1,gain1)
	 efficiency=eff(i)
         return
      end if
10    continue
c          interpolate on frequency
      do 20 i=2,nfreq
      if(freq.le.frequency(i)) then       !  interpolate between (i-1) and (i)
	 g1=ant90_gain(i-1,azim,elev,luaa,ifreq1,gain1)
	 eff1=eff(i-1)
	 g2=ant90_gain(i  ,azim,elev,luaa,ifreq2,gain2)
	 eff2=eff(i)
	 xf=(freq-frequency(i-1))/(frequency(i)-frequency(i-1))
	 efficiency=eff1 + (eff2-eff1)*xf
	 gain=g1 + (g2-g1)*xf
         return
      end if
20    continue

      gain=-99.9
      return
c*************************************************************************
900   continue
ccc      write(*,901) freq
ccc901   format(' Frequency=',f10.3,' is outside the frequencies',
ccc     +        ' specified by the external antenna file.')
ccc      write(*,902) (frequency(i),i=1,nfreq)
ccc902   format(' Frequencies in external data file are:',/,(10f8.3))
ccc      go to 999
      return
910   write(*,911) elev
911   format(' Elevation angle=',f10.3,' is not allowed.',/
     +       ' MUST be in the range [0 to 90 degrees].')
      go to 999
920   write(*,921) azimuth
921   format(' Azimuth angle=',f10.3,' is not allowed.',/
     +       ' MUST be in the range [-360 to 360 degrees].')
999   return 1
      end
c------------------------------------------------------
      function ant90_gain(ifreq,azimuth,elev,luaa,ifreq1,gain1)
      dimension gain1(91,360)
      data bad/-99998./
      ant90_gain=-99.9
      if(ifreq.ne.ifreq1) read(luaa,rec=ifreq) gain1
      ifreq1=ifreq
      iaz=azimuth
      do 10 ia=iaz,0,-1        !  find lower azimuth
      if(gain1(1,ia+1).lt.bad) go to 10
      low_az=ia
      go to 20
10    continue
      write(*,'('' Cannot get here in ant90_gain.'')')
20    do 30 ia=iaz+1,359       !  find upper azimuth
      if(gain1(1,ia+1).lt.bad) go to 30
      iup_az=ia
      go to 40
30    continue
      iup_az=360
40    continue
      iel=elev
      do 50 ie=iel,0,-1        !  find lower elevation
      if(gain1(ie+1,1).lt.bad) go to 50
      low_el=ie
      go to 60
50    continue
      write(*,'('' Cannot get here in ant90_gain.'')')
60    do 70 ie=iel+1,90        !  find upper elevation
      if(gain1(ie+1,1).lt.bad) go to 70
      iup_el=ie
      go to 80
70    continue
      iup_el=90
80    continue

c      if(low_el.eq.iup_el) low_el=low_el-1
      g=ant90_interp(gain1,low_az,azimuth,iup_az,low_el,elev,iup_el)
      ant90_gain=g
      return
      end
c------------------------------------------------------
      function ant90_interp(z,iy1,y,iy2,ix1,x,ix2)
c          interpolation
      dimension z(91,*)
      jy2=iy2
      if(jy2.eq.360) jy2=0
      z1=z(ix1+1,iy1+1)
      z2=z(ix2+1,iy1+1)
      z3=z(ix1+1,jy2+1)
      z4=z(ix2+1,jy2+1)
      if (ix1.eq.ix2) then ! 90deg elevation
            z12 = z2
            z34 = z4
      else
            xf = (x-float(ix1))/float(ix2-ix1)
            z12 = z1 + (z2-z1)*xf
            z34 = z3 + (z4-z3)*xf
      end if
      zz=z12 + (z34-z12)*(y-float(iy1))/float(iy2-iy1)
      ant90_interp=zz
      return
      end
c-------------------------------------------------------
      subroutine ant90_read(filename,lu,lua,*)
      common /Cant90/ luaa,filenam,title,itype,parms(20),
     +                 nfreq,frequency(100),dbi(100),eff(100),
     +                 ifreq1,gain1(91,360),ifreq2,gain2(91,360)
         character filenam*80,title*80
      character filename*(*)
      character alf*80
      dimension iazimuth(360)
      data bad/-99999./
      filenam=filename
      nch=len(trim(filename))
ccc      write(*,'('' OPENing file='',a)') filename(1:nch)
      open(lu,file=filename(1:nch),status='old',err=910)
      rewind(lu)
      read(lu,'(a)',end=100) title
      read(lu,*) nparms
      do 10 i=1,nparms
10    read(lu,*) parms(i)
      itype=nint(parms(2))

      ifreq1=0
      ifreq2=0
      nfreq=0
      luaa=lua               !  save scratch file lu
      open(lua,status='scratch',access='direct',recl=360*91*4)
20    read(lu,'(a)',end=100) alf
      if(alf(1:1).eq.'#') then                   !  comment record
      else if(alf(1:9).eq.'frequency') then
	 nfreq=nfreq+1
	 read(alf(10:),*) frequency(nfreq)
c         write(*,21) nfreq,frequency(nfreq)
21       format(' Reading frequency #',i3,'=',f8.3,' MHz')
	 dbi(nfreq)=0.
	 eff(nfreq)=0.
	 do 30 iaz=1,360
	 iazimuth(iaz)=0
	 do 30 iel=1,91
30       gain1(iel,iaz)=bad         !  dummy value
      else if(alf(1:9).eq.'normalize') then
	 read(alf(10:),*) dbi(nfreq)
      else if(alf(1:18).eq.'antenna_efficiency') then
	 read(alf(19:),*) eff(nfreq)
c          make sure the gain record is valid
	 do 40 iaz=1,360
	 if(iazimuth(iaz).eq.0 .or. iazimuth(iaz).eq.7) go to 40
	 write(*,51) filename(1:nch)
	 write(*,31) 
31       format(' For any AZIMUTH ANGLE defined, the ELEVATION',
     +          ' ANGLES 0 and 90 MUST be defined.')
	 write(*,'('' AZIMUTH ANGLE='',i5,'' in error.'')') iaz
	 go to 900
40       continue
ccc         write(*,'('' writing rec#'',i3,f8.3)') nfreq,frequency(nfreq)
	 write(lua,rec=nfreq,iostat=ios,err=920) gain1
ccc         write(*,'('' wrote   record='',i5)') nfreq
      else if(alf(1:8).eq.'matching') then       !  ignore this record
      else if(alf(1:10).eq.'          ') then    !  comment record
      else                                       !  must be a data record
	 read(alf,*) iaz,iel,g
	 if(iaz.lt.0 .or. iaz.ge.360) then       !  azimuth angle error
	    write(*,51) filename(1:nch)
51          format(' Error READing antenna file=',a)
	    write(*,'('' Data file contains AZIMUTH ANGLE error.'')')
	    write(*,'('' AZIMUTH ANGLE must be [0 to 359].'')')
	    write(*,'('' Value read was='',i8)') iaz
	    go to 900
	 end if
	 if(iel.lt.0 .or. iel.gt.90) then        !  elevation angle error
	    write(*,51) filename(1:nch)
	    write(*,'('' Data file contains ELEVATION ANGLE error.'')')
	    write(*,'('' ELEVATION ANGLE must be [0 to 90].'')')
	    write(*,'('' Value read was='',i8)') iel
	    go to 900
	 end if
	 gain1(iel+1,iaz+1)=g
	 if(iel.eq.0) then
	    iazimuth(iaz+1)=ior(iazimuth(iaz+1),1)
	 else if(iel.eq.90) then
	    iazimuth(iaz+1)=ior(iazimuth(iaz+1),2)
	 else
	    iazimuth(iaz+1)=ior(iazimuth(iaz+1),4)
         end if
      end if
      go to 20
100   close(lu)
ccc      write(*,'(i5,'' frequencies'')') nfreq
ccc      write(*,'(''freq='',7f10.3)') (frequency(i),i=1,nfreq)
ccc      write(*,'(''dbi ='',7f10.3)') (dbi(i),i=1,nfreq)
ccc      write(*,'(''eff ='',7f10.3)') (eff(i),i=1,nfreq)
      return
c*************************************************************************
900   close(lu)
      return 1
910   write(*,911) filename(1:nch)
911   format('Could not OPEN antenna file=',a)
      return 1
920   write(*,921) ios
921   format('Error READing antenna file=',i5)
      stop
      end
c------------------------------------------------------
      subroutine ant90_close       !  close the scratch unit
      common /Cant90/ luaa,filenam,title,itype,parms(20),
     +                 nfreq,frequency(100),dbi(100),eff(100),
     +                 ifreq1,gain1(91,360),ifreq2,gain2(91,360)
         character filenam*80,title*80

      close(luaa)
      return
      end
c------------------------------------------------------

!------------------------------------------------------
subroutine ant99_calc(freq,azimuth,elev,gain,efficiency,*)
!   external antenna calculations:
!   If outside frequency range, gain=-99.9 returned.
!   If ELEVATION angle or AZIMUTH angle in error, return 1
    use Cant99
    implicit none
    real, intent(in)    :: freq, azimuth, elev
    real                :: gain, efficiency
    real                :: azim, g1, g2, eff1, eff2, xf
    real                :: ant99_gain
    integer             :: i
    gain=-99.9
    efficiency=0.0
    if(freq.lt.frequency(1) .or. freq.gt.frequency(nfreq)) go to 900 ! out of freq range
    if(elev.lt.0. .or. elev.gt.90.) go to 910 ! out of elevation angle range
    azim=azimuth
    if(azim.lt.0.) azim=azim+360.
    if(azim.ge.360.) azim=azim-360.
    if(azim.lt.0. .or. azim.ge.360.) go to 920   !  out of azimuth angle range
    do i=1,nfreq
        if(abs(freq-frequency(i)).lt..001) then  !  frequency match
	        gain=ant99_gain(i,azim,elev,luaa,ifreq1,gain1)
	        efficiency=eff(i)
            return
        end if
    end do
!   interpolate on frequency
    do i=2,nfreq
        if(freq.le.frequency(i)) then       !  interpolate between (i-1) and (i)
	        g1=ant99_gain(i-1, azim, elev, luaa, ifreq1, gain1)
	        eff1=eff(i-1)
	        g2=ant99_gain(i, azim, elev, luaa, ifreq2, gain2)
	        eff2=eff(i)
	        xf=(freq-frequency(i-1))/(frequency(i)-frequency(i-1))
	        efficiency=eff1 + (eff2-eff1)*xf
	        gain=g1 + (g2-g1)*xf
            return
        end if
    end do

    gain=-99.9
    return
!*************************************************************************
900 continue
    return
910 write(*,911) elev
911 format(' Elevation angle=',f10.3,' is not allowed.',&
        ' MUST be in the range [0 to 90 degrees].')
    go to 999
920 write(*,921) azimuth
921 format(' Azimuth angle=',f10.3,' is not allowed.',&
        ' MUST be in the range [-360 to 360 degrees].')
999 return 1
end
!------------------------------------------------------

function ant99_gain(ifreq,azimuth,elev,luaa,ifreq1,gain1) result(g)
    implicit none
    real, intent(in)    :: azimuth
    real, intent(in)    :: elev
    integer             :: ifreq1, ifreq, luaa
    integer             :: iaz, iel, iup_az, iup_el, ia, ie
    integer             :: low_az, low_el
    real                :: g, gain1
    real                :: ant99_interp
    dimension gain1(91,360)
    real bad
    data bad/-99998./
    g=-99.9
    if(ifreq.ne.ifreq1) read(luaa,rec=ifreq) gain1
    ifreq1=ifreq
    iaz=azimuth
    do ia=iaz,0,-1        !  find lower azimuth
        if(gain1(1,ia+1).lt.bad) go to 10
        low_az=ia
        go to 20
10      continue
    end do
    write(*,'('' Cannot get here in ant99_gain.'')')
20  do ia=iaz+1,359       !  find upper azimuth
        if(gain1(1,ia+1).lt.bad) go to 30
        iup_az=ia
        go to 40
30      continue
    end do
    iup_az=360
40  continue
    iel=elev
    do ie=iel,0,-1        !  find lower elevation
        if(gain1(ie+1,1).lt.bad) go to 50
        low_el=ie
        go to 60
50      continue
    end do
    write(*,'('' Cannot get here in ant99_gain.'')')
60  do ie=iel+1,90        !  find upper elevation
        if(gain1(ie+1,1).lt.bad) go to 70
        iup_el=ie
        go to 80
70      continue
    end do
    iup_el=90
80  continue
    g=ant99_interp(gain1,low_az,azimuth,iup_az,low_el,elev,iup_el)
    !ant99_gain=g
    return
end

!------------------------------------------------------
function ant99_interp(z,iy1,y,iy2,ix1,x,ix2) result(zz)
!...interpolation
    implicit none
    real, intent(in)    :: x, y, z
    integer, intent(in) :: iy1,iy2,ix1,ix2
    integer             :: jy2
    real                :: z1, z2, z3, z4, z12, z34, xf, zz
    dimension z(91,*)
    jy2=iy2
    if(jy2.eq.360) jy2=0
    z1=z(ix1+1,iy1+1)
    z2=z(ix2+1,iy1+1)
    z3=z(ix1+1,jy2+1)
    z4=z(ix2+1,jy2+1)

    if (ix1.eq.ix2) then ! 90deg elevation
        z12 = z2
        z34 = z4
    else
        xf = (x-real(ix1))/real(ix2-ix1)
        z12 = z1 + (z2-z1)*xf
        z34 = z3 + (z4-z3)*xf
    end if
    zz=z12 + (z34-z12)*(y-real(iy1))/real(iy2-iy1)
    return
end
!-------------------------------------------------------
subroutine ant99_read(filename, lu, lua,*)
    use Cant99
    implicit none
    integer :: lu, lua
    integer :: i, iaz, iel, ios, nch, nparms
    integer, dimension(360) :: iazimuth
    real :: g, bad
    character filename*(*)
    character(len=80) :: alf


    data bad/-99999./
    filenam=filename
    nch=len(trim(filename))
    open(lu,file=filename(1:nch),position='rewind', status='old',err=910)
    read(lu,'(a)',end=100) title
    read(lu,*) nparms
    do i=1,nparms
        read(lu,*) parms(i)
    end do
    itype=nint(parms(2))

    ifreq1=0
    ifreq2=0
    nfreq=0
    luaa=lua               !  save scratch file lu
    open(lua,status='scratch',access='direct',recl=360*91*4)
20  read(lu,'(a)',end=100) alf
    if(alf(1:1).eq.'#') then
        !  comment record
    else if(alf(1:9).eq.'frequency') then
	    nfreq=nfreq+1
	    read(alf(10:),*) frequency(nfreq)

21      format(' Reading frequency #',i3,'=',f8.3,' MHz')
	    dbi(nfreq)=0.
	    eff(nfreq)=0.
	    do iaz=1,360
	        iazimuth(iaz)=0
	        do iel=1,91
              gain1(iel,iaz)=bad         !  dummy value
          end do
      end do
    else if(alf(1:9).eq.'normalize') then
	    read(alf(10:),*) dbi(nfreq)
    else if(alf(1:18).eq.'antenna_efficiency') then
	    read(alf(19:),*) eff(nfreq)
!          make sure the gain record is valid
	    do 40 iaz=1,360
	        if(iazimuth(iaz).eq.0 .or. iazimuth(iaz).eq.7) go to 40
	        write(*,51) filename(1:nch)
	        write(*,31)
31          format(' For any AZIMUTH ANGLE defined, the ELEVATION'&
            ' ANGLES 0 and 90 MUST be defined.')
	        write(*,'('' AZIMUTH ANGLE='',i5,'' in error.'')') iaz
	        go to 900
40      continue
	    write(lua,rec=nfreq,iostat=ios,err=920) gain1
    else if(alf(1:8).eq.'matching') then
        ! ignore this record
    else if(alf(1:10).eq.'          ') then
        !  comment record
    else                                       !  must be a data record
	    read(alf,*) iaz,iel,g
	    if(iaz.lt.0 .or. iaz.ge.360) then       !  azimuth angle error
	        write(*,51) filename(1:nch)
51          format(' Error READing antenna file=',a)
	        write(*,'('' Data file contains AZIMUTH ANGLE error.'')')
	        write(*,'('' AZIMUTH ANGLE must be [0 to 359].'')')
	        write(*,'('' Value read was='',i8)') iaz
	        go to 900
	    end if
	    if(iel.lt.0 .or. iel.gt.90) then        !  elevation angle error
	        write(*,51) filename(1:nch)
	        write(*,'('' Data file contains ELEVATION ANGLE error.'')')
	        write(*,'('' ELEVATION ANGLE must be [0 to 90].'')')
	        write(*,'('' Value read was='',i8)') iel
	        go to 900
	    end if
	    gain1(iel+1,iaz+1)=g
	    if(iel.eq.0) then
	        iazimuth(iaz+1)=ior(iazimuth(iaz+1),1)
	    else if(iel.eq.90) then
	        iazimuth(iaz+1)=ior(iazimuth(iaz+1),2)
	    else
	        iazimuth(iaz+1)=ior(iazimuth(iaz+1),4)
        end if
    end if
    go to 20
100 close(lu)
    return

!*************************************************************************
900 close(lu)
    return 1
910 write(*,911) filename(1:nch)
911 format('Could not OPEN antenna file: ',a)
    return 1
920 write(*,921) ios
921 format('Error READing antenna file: ',i5)
    stop
end

!------------------------------------------------------
subroutine ant99_close       !  close the scratch unit
    use Cant99
    implicit none
    close(luaa)
    return
end
!------------------------------------------------------

C SUBROUTINE ZMUT             (NEXT)
      SUBROUTINE ZMUT (ZSUM)
C 
C     ZMUT - CALCULATES THE SELF-IMPEDANCE AND MUTUAL-IMPEDANCE 
C        BETWEEN LINEAR PARALLEL DIPOLE ELEMENTS OF EQUAL LENGTHS.
C     SEE THE REFERENCES IN SUBROUTINE GAIN.
C 
      COMPLEX CSU1, CSUZP, CSV1, CSZ1, ZSUM 
C 
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RO, VOFL 
C 
      COMMON /CUR /DIJ, EIL, HIJ, KODE
C 
C.......................................................................
      D2 = DIJ * * 2
      EL2 = EIL * * 2 
      T = SQRT (D2 + 4.0 * EL2) 
      UZ = PI2 * (T - 2.0 * EIL)
      VZ = PI2 * (T + 2.0 * EIL)
      UZP = PI2 * DIJ 
      T = SQRT (D2 + EL2) 
      U1 = PI2 * (T - EIL)
      V1 = PI2 * (T + EIL)
      W1 = 2.0 * PI2 * EIL
      CW1 = COS (W1)
      SW1 = SIN (W1)
      CSU1 = CSZ1 (U1)
      CSV1 = CSZ1 (V1)
      CSUZP = CSZ1 (UZP)
      ZSUM = (CSZ1 (UZ) - 2.0 * CSU1) * CMPLX (CW1, - SW1) + (CSZ1 (VZ) 
     1- 2.0 * CSV1) * CMPLX (CW1, SW1) + 2.0 * (CSUZP - CSU1 - CSV1) + 2
     2.0 * CSUZP * (CW1 + 1.0)
      IF (KODE .GT. 0) GO TO 100
      ZSUM = ZSUM * 30.0
      GO TO 105 
 100  ZSUM = ZSUM * 60.0 / (1.0 - CW1)
 105  RETURN
      END

      SUBROUTINE MATINV (A, N)
C 
C     MATINV - INVERTS A REAL SQUARE (N BY N) MATRIX A AND STORES 
C        THE RESULTANT INVERSE BACK IN A.  THE METHOD USED IS GAUSS-
C        JORDAN ELIMINATION WITH COMPLETE PIVOTING (SEE, FOR EXAMPLE, 
C        A.RALSTON AND H.S.WILF (1967), MATHEMATICAL METHODS FOR
C        DIGITAL COMPUTERS, VOL. 2,  ARTICLE BY J.H.WILKINSON.) 
C     THIS ROUTINE IS SHARE NO. ANL F402 BY B.S.GARBOW OF ARGONNE 
C     NATIONAL LABORATORY, ARGONNE, ILLINOIS
C 
      DIMENSION A (20, 20)
C 
      COMMON /PON /INDEX (20, 2), IPIVOT (20), PIVOT (20) 
C 
C.....INITIALIZE........................................................
      DETERM = 1.0
      IF (N .LT. 1) GO TO 160 
      DO 100 J = 1, N 
 100  IPIVOT (J) = 0
 160  CONTINUE
      IF (N .LT. 1) GO TO 165 
      DO 140 I = 1, N 
C.....SEARCH FOR PIVOTAL ELEMENT........................................
      TEMP = 0.0
      IF (N .LT. 1) GO TO 170 
      DO 115 J1 = 1, N
      IF (IPIVOT (J1) .EQ. 1) GO TO 115 
      IF (N .LT. 1) GO TO 175 
      DO 110 K = 1, N 
      IF (IPIVOT (K) - 1)105, 110, 155
 105  IF (ABS (TEMP) .GT. ABS (A (J1, K))) GO TO 110
      IROW = J1 
      ICOLUM = K
      TEMP = A (J1, K)
 110  CONTINUE
 175  CONTINUE
 115  CONTINUE
 170  CONTINUE
      IPIVOT (ICOLUM) = IPIVOT (ICOLUM) + 1 
C.....INTERCHANGE ROWS TO PUT PIVOTAL ELEMENT ON DIAGONAL...............
      IF (IROW .EQ. ICOLUM) GO TO 125 
      DETERM = - DETERM 
      IF (N .LT. 1) GO TO 180 
      DO 120 L = 1, N 
      TEMP = A (IROW, L)
      A (IROW, L) = A (ICOLUM, L) 
 120  A (ICOLUM, L) = TEMP
 180  CONTINUE
 125  INDEX (I, 1) = IROW 
      INDEX (I, 2) = ICOLUM 
      PIVOT (I) = A (ICOLUM, ICOLUM)
      DETERM = DETERM * PIVOT (I) 
      IF (DETERM .EQ. 0.0) GO TO 155
C.....DIVIDE PIVOTAL ROW BY PIVOTAL ELEMENT.............................
      A (ICOLUM, ICOLUM) = 1.0
      IF (N .LT. 1) GO TO 185 
      DO 130 L1 = 1, N
 130  A (ICOLUM, L1) = A (ICOLUM, L1) / PIVOT (I) 
 185  CONTINUE
C.....REDUCE NON-PIVOTAL ROWS...........................................
      IF (N .LT. 1) GO TO 190 
      DO 140 I1 = 1, N
      IF (I1 .EQ. ICOLUM) GO TO 140 
      TEMP = A (I1, ICOLUM) 
      A (I1, ICOLUM) = 0.0
      IF (N .LT. 1) GO TO 195 
      DO 135 L2 = 1, N
 135  A (I1, L2) = A (I1, L2) - A (ICOLUM, L2) * TEMP 
 195  CONTINUE
 140  CONTINUE
 190  CONTINUE
 165  CONTINUE
C.....INTERCHANGE COLUMNS (TO UNDO THE SWAP TO GET MAX PIVOT ON DIAG)...
      IF (N .LT. 1) GO TO 200 
      DO 150 I2 = 1, N
      LL = N + 1 - I2 
      IF (INDEX (LL, 1) .EQ. INDEX (LL, 2)) GO TO 150 
      IROW = INDEX (LL, 1)
      ICOLUM = INDEX (LL, 2)
      IF (N .LT. 1) GO TO 205 
      DO 145 K1 = 1, N
      TEMP = A (K1, IROW) 
      A (K1, IROW) = A (K1, ICOLUM) 
 145  A (K1, ICOLUM) = TEMP 
 205  CONTINUE
 150  CONTINUE
 200  CONTINUE
 155  RETURN
      END

c--------------------------------------------------------------
c# anttyp90.for
C***********************************************************************
      PROGRAM anttyp90
*    +               (run_directory,mode)
C***********************************************************************
c Calculate an exteranl antenna file.
c Assumes data is in the format of:
c       ..\antennas\samples\sample.90
c Execute with:
c    anttyp90 directory mode
c where:
c    directory = full pathname to the RUN directory (e.g. c:\ITSHFBC\RUN)
c    mode      = (blank) = Point-to-Point
c              = a = Area Coverage
C***********************************************************************
      common /Cant90/ luaa,filenam,title,itype,parms(20),
     +                 nfreq,frequency(100),dbi(100),eff(100),
     +                 ifreq1,gain1(91,360),ifreq2,gain2(91,360)
      character filenam*80,title*80
      common /cantenna/ anttype,antname,
     +                  xfqs,xfqe,designfreq,antfile,
     +                  beammain,offazim,cond,diel,
     +                  gain(91)
      character(len=120)  :: run_directory, root_directory, arg
      character anttype*10,antname*70,antfile*24

      character (len=80) :: filename, gainfile

      character (len=1) :: mode
      
C.....START OF PROGRAM
      mode = " "
c We need to consider two forms of command args;
c anttype99 rundir [mode]
c anttype99 rundir rootdir [mode]
      call GET_COMMAND_ARGUMENT(1, run_directory)
      if (COMMAND_ARGUMENT_COUNT().eq.1) then
          root_directory = run_directory(1:len(trim(run_directory))-3)
      else if (COMMAND_ARGUMENT_COUNT().eq.2) then
          call GET_COMMAND_ARGUMENT(2, arg)
          if (len(trim(arg)).eq.1) then
             call GET_COMMAND_ARGUMENT(2, mode)
          else
              call GET_COMMAND_ARGUMENT(2, root_directory)
          end if
      else if (COMMAND_ARGUMENT_COUNT().eq.3) then
          call GET_COMMAND_ARGUMENT(2, root_directory)
          call GET_COMMAND_ARGUMENT(3, mode)
      end if

      open(21,file=run_directory(1:nch_run)//'/anttyp90.dat', status='old',err=900)
      rewind(21)
      read(21,*,err=920) idx          !  antenna index #, GAINxx.dat
      read(21,'(a)',err=920) antfile  !  antenna file name
      read(21,*,err=920) xfqs         !  starting frequency
      read(21,*,err=920) xfqe         !  ending frequency
      read(21,*,err=920) beammain     !  main beam (deg from North)
      read(21,*,err=920) offazim      !  off azimuth (deg from North)
      close(21)

      filename=trim(root_directory)//'/antennas/'//trim(antfile)
      lua=42
      call ant90_read(filename,21,lua,*910)
      diel=parms(3)         !  dielectric constant
      cond=parms(4)         !  conductivity
      write(gainfile,1) trim(run_directory),idx
1     format(a,5h/gain,i2.2,4h.dat)
      open(22,file=gainfile)
      rewind(22)
      write(22,'(a)') 'Extern#90/'//title
c****************************************************************
      if(mode.ne.' ') go to 200     !  area coverage
c*****Point-to-Point mode
      write(22,2) xfqs,xfqe,beammain,offazim,cond,diel
2     format(2f5.0,2f7.2,2f10.5)
      azimuth=offazim
      do 50 ifreq=1,30
      freq=ifreq
      if(freq.ge.xfqs .and. freq.le.xfqe) then    !  in frequency range
         do 20 iel=0,90
         elev=iel
20       call ant90_calc(freq,azimuth,elev,gain(iel+1),aeff,*940)
      else                                        !  outside freq range
         aeff=0.
         do 30 iel=0,90
30       gain(iel+1)=0.
      end if
      write(22,3) ifreq,aeff,gain
3     format(i2,f6.2,(T10,10F7.3))
50    continue
      go to 500
c****************************************************************
c*****Area Coverage mode
200   write(22,2) 2.0,xfqe,beammain,-999.,cond,diel
      freq=xfqs
      call ant90_calc(freq,0.,8.,g,aeff,*940)
      write(22,201) freq,aeff
201   format(10x,f7.3,'MHz eff=',f10.3)
      do 250 iazim=0,359
      azimuth=iazim
      do 220 iel=0,90
      elev=iel
220   call ant90_calc(freq,azimuth,elev,gain(iel+1),aeff,*940)
250   write(22,251) iazim,gain
251   format(i5,(T10,10F7.3))
c****************************************************************
500   call ant90_close
      close(22)
c****************************************************************
      go to 999
c****************************************************************
900   write(*,901) trim(run_directory)//'/anttyp90.dat' !jw
901   format(' In anttyp90, could not OPEN file=',a)
      stop 'OPEN error in anttyp90 at 900'
910   write(*,911) filename
911   format(' In anttyp90, error READing file=',a)
      stop 'READ error in anttyp90 at 910'
920   write(*,921) trim(run_directory)//'/anttyp90.dat' !jw
921   format(' In anttyp90, error READing file=',a)
      stop 'READ error in anttyp90 at 920'
c***********************************************************************
930   write(*,931)
931   format('anttyp90 must be executed:',/
     +  '1. Point-to-Point:',/
     +  '   anttyp90.exe run_directory',/,
     +  '4. Area Coverage:',/
     +  '   icepacw.exe run_directory a')
      write(*,932)
932   format(/
     +  'Where:',/
     +  '      run_directory = full pathname to RUN directory',/
     +  '                      (e.g. /home/usr_name/itshfbc/run)')
      stop 'anttyp90 not executed properly.'
940   write(*,941) filename
941   format(' In anttyp90, error Calculating from file=',a)
      stop 'READ error in ANTTYP90 at 940'
c***********************************************************************
999   continue
      end

c# gain.f
      SUBROUTINE GAIN(ITR,DELTA,FMC,RAIN,EFF)
c**************************************************************
c          re-written 10/22/92 by Greg Hand to access all
c          antennas as external tables so they can come from any
c          source and simplify addition of new antennas.
c**************************************************************
C--------------------------------
C.....ITR .LT. 0 INDICATES TO CALCULATE GROUND REFLECTION LOSS
C     ITR = 1 INDICATES TRANSMITTER ANTENNA
C     ITR = 2 INDICATES RECEIVER ANTENNA
C
C     POWER GAIN OF ANTENNA AND GROUND REFLECTION LOSS
C     FOR LOSS, KOP IS ZERO OR MINUS
C DELTA IS ELEVATION ANGLE,RADIANS
C FMC  IS FREQUENCY,MHZ.
C SIGMA IS GROUND CONDUCTIVITY, MHOS/METER.
C ER IS GROUND RELATIVE DIELECTRIC CONSTANT.
C RAIN IS LOSS OR GAIN.
C
C
C     THE REFLECTION COEFFICIENTS ARE
C     KSUBV = -CV * EXP(I * PSIV),  KSUBV = CV * EXP(I * GAMMAV)
C     KSUBH = -CH * EXP(I * PSIH),  KSUBH = CH * EXP(I * GAMMAH)
C     IE  NORMALIZED WITH PSI = GAMMA + PI, PSI = GAMMA - PI
C
C     IONCAP REPORT VOLUME 1 PAGE 115 OR ITSA-1 PAGE 65
C     N O T E THIS IS NOT THE SAME AS MA AND WALTERS, ITS-74, PAGE 8
C
      common /cantenna/ numants,iats(20),anttype(20),antname(20),
     +                  xfqs(20),xfqe(20),designfreq(20),antfile(20),
     +                  beammain(20),offazim(20),cond(20),diel(20),
     +                  array(30,91,20),aeff(30,20)
      character anttype*10,antname*70,antfile*24
      common /Careaant/ iarray360(360,91,2)
         integer*2 iarray360
ccc      equivalence (array,iarray360)        !  for area coverage
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
      COMMON/GEOG/GYZ(5),RAT(5),GMDIP(5),CLCK(5),ABIY(5),ARTIC(5),
     A            SIGPAT(5),EPSPAT(5)
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
c********************************************************
      RAIN=0.
      EFF = 0.0
      IF(ITR.lt.0) go to 75
      do 10 iat=1,numants
c          check to see if transmitter or receiver
      if(iats(iat).ne.itr) go to 10
c          is this in frequency range?
      if(xfqs(iat).le.FMC .and. FMC.le.xfqe(iat)) go to 20
10    continue
c          no match found, return GAIN=0
      return
c********************************************************
20    if(offazim(iat).eq.-999.) go to 50     !  area coverage antenna
c********************************************************
c          Interpolate gain from array
      I = FMC
      IP1 = I + 1
      IP1 = MIN0(30,IP1)
      XFMC = FMC - FLOAT(I)
      DELTD = DELTA * R2D
      J = DELTD + 1.
      J= MIN0(J,91)
      JP1 = J + 1
      JP1 = MIN0(91,JP1)
      XDELTA = DELTD - FLOAT(J-1)
      XX = ARRAY(I,J,iat)
      YX = ARRAY(IP1,J,iat)
      XY = ARRAY(I,JP1,iat)
      YY = ARRAY(IP1,JP1,iat)
      RX = XX + XFMC * (YX - XX)
      RY = XY + XFMC * (YY - XY)
      RAIN = RX + XDELTA * (RY - RX)
      EFF = AEFF(I,iat) +XFMC*(AEFF(IP1,iat)-AEFF(I,iat))
      RETURN
c************************************************************
c          area coverage antenna
50    eff=aeff(1,iat)               !  constant frequency
c          negative beammain is for NON-terminated rhombics
      if(iat.eq.1) ofaz=btrd-abs(beammain(iat))   !  transmitter
      if(iat.eq.2) ofaz=brtd-beammain(iat)   !  receiver
      if(ofaz.lt.0.) ofaz=ofaz+360.
      i=ofaz+1.
      if(i.gt.360) i=1
      ip1=i+1
      if(ip1.gt.360) ip1=1
      xazim=ofaz-float(i-1)
      DELTD = DELTA * R2D
      J = DELTD + 1.
      J= MIN0(J,91)
      JP1 = J + 1
      JP1 = MIN0(91,JP1)
      XDELTA = DELTD - FLOAT(J-1)
      XX = iARRAY360(I,J,iat)
      YX = iARRAY360(IP1,J,iat)
      XY = iARRAY360(I,JP1,iat)
      YY = iARRAY360(IP1,JP1,iat)
      RX = XX + Xazim*(YX - XX)
      RY = XY + Xazim*(YY - XY)
      RAIN = RX + XDELTA*(RY - RX)
      rain=rain/100.
ccc      if(iat.eq.1) then
ccc         write(72,51) beammain(iat),ofaz,btrd,deltd,rain,i,j,
ccc     +              iarray360(i,j,iat)
ccc51       format('main,ofaz,btrd,elev,gain=',5f10.3,2i4,i8)
ccc         if(i.eq.1 .and. j.eq.18) then
ccc            write(72,52) (iarray360(1,jj,1),jj=1,10)
ccc52          format('iarray=',10i7)
ccc         end if
ccc      end if
      return
c************************************************************
c          Ground Reflection LOSS
   75 IG = IABS(ITR)
      SIGMA = SIGPAT(IG)
      ER = EPSPAT(IG)
      IF(SIGMA.le.0) RETURN
C.....THE EQUATIONS FOR THE FRESNEL REFLECTION COEFFICIENTS ARE IN
C.....VOLUME I OF THE OT REPORT ON THIS ANALYSIS PROGRAM
      RELTA = DELTA
      X = 18000. * SIGMA / FMC
      T = COS (RELTA)
      Q = SIN (RELTA)
      R = Q * Q
      S = R * R
      ERT = ER - T * T
      RHO = SQRT ((ERT) * (ERT) + X * X)
      RHO12 = SQRT (RHO)
      ALPHA = - ATAN (X / ERT)
      U = (ER * ER + X * X)
      V = SQRT (U)
      ASXV = ASIN (X / V)
      CV = SQRT (RHO * RHO + U * U * S - 2. * RHO * U * R * COS (ALPHA +
     1 2. * ASXV)) / (RHO + U * R + 2. * RHO12 * V * Q * COS (ALPHA * .5
     2 + ASXV))
C
C     GROUND LOSS
C
      CH = SQRT(RHO*RHO + S - 2.*RHO*R*COS(ALPHA))/
     1         (RHO + R + 2.*RHO12*Q*COS(ALPHA*.5))
      RAIN = 4.3429*ALOG(.5*(CH*CH + CV*CV))
      RAIN = ABS(RAIN)
      IF(DELTA.le.0.00000001 ) RAIN=6.
      RETURN
      END
C--------------------------------

C SUBROUTINE SQMULT           (NEXT)
      SUBROUTINE SQMULT (A, B, C, N)
C 
C     SQUARE MATRIX MULTIPLICATION (COMPANION TO CMPINV IN ANL F103)
C 
      DIMENSION A (20, 20), B (20, 20), C (20, 20)
C 
      COMMON /PON /INDEX (20, 2), IPIVOT (20), PIVOT (20) 
C 
C.....C=A*B.............................................................
      IF (N .LT. 1) GO TO 110 
      DO 105 J = 1, N 
      IF (N .LT. 1) GO TO 115 
      DO 100 K = 1, N 
 100  PIVOT (K) = B (K, J)
 115  CONTINUE
      IF (N .LT. 1) GO TO 120 
      DO 105 I = 1, N 
      C (I, J) = 0.0
      IF (N .LT. 1) GO TO 125 
      DO 105 L = 1, N 
 105  C (I, J) = C (I, J) + A (I, L) * PIVOT (L)
 125  CONTINUE
 120  CONTINUE
 110  CONTINUE
      RETURN
      END

c###geotim.for
      SUBROUTINE GEOTIM(JT)
C--------------------------------
C
C     THIS ROUTINE CALLS FUNCTION CNGTIM TO CONVERT FROM UT TO LMT, ETC.
C
      COMMON / CON / D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / GEOG / GYZ(5), RAT(5), GMDIP(5), CLCK(5), ABIY(5),
     1 ARTIC(5), SIGPAT(5), EPSPAT(5)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      CKC = JT
C.....I!ITIM IS SPECIFIED ON THE "TIME" CONTROL CARD.
C.....IF ITIM .LT.0 USE LMT SO CALCULATE UT HERE
      IF(ITIM) 120, 130, 130
C.....LMT AT TRANSMITTER
  120 TEMP = CKC
      DUMMY = TLONG * R2D
      CNGDAY = CNGTIM(CKC,DUMMY,-1)
      GMT = CKC
      GO TO 140
C.....GMT AT TRANSMITTER
  130 GMT = CKC
      DUMMY = TLONG * R2D
      CNGDAY = CNGTIM(CKC,DUMMY,1)
      TEMP = CKC
  140 IT = GMT
      IF(IT) 150, 150, 160
  150 IT = 24
  160 UTIME(IT) = GMT
      XLMT(IT) = TEMP
C.....LMT AT RECEIVER
      CKC = GMT
      DUMMY = RLONG * R2D
      CNGDAY = CNGTIM(CKC,DUMMY,1)
      GMTR = CKC
C.....LMT AT SAMPLE POINTS
      IF(KM) 190, 190, 170
  170 DO 180 II = 1,KM
      CKC = GMT
      DUMMY = CLONG(II) * R2D
      CNGDAY = CNGTIM(CKC,DUMMY,1)
  180 CLCK(II) = CKC
  190 RETURN
      END
C--------------------------------

c###frqcom.for
      SUBROUTINE FRQCOM(FREA,IFREQ)
C--------------------------------
C
C     THIS ROUTINE SETS THE FREQUENCY COMPLEMENT FROM 2 TO 40 MHZ
C
C FREA(13) IS A FREQUENCY COMPLEMENT TO BE SET
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     A,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMUF
     B (4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     C ,YMUF(4)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      DIMENSION FREA(13)
      DATA FLOW/2./, FHIGH/40./
C.....INSERT MUF INTO FREQUENCY SLOT 12
      FREA(12) = ALLMUF(IT)
      IF(IFREQ + 10) 95, 90, 95
C.....INSERT FOT INTO FREQUENCY SLOT 1
   90 FREA(1) = FOT(IT)
      RETURN
C GET MUF"S
   95 XFL = AMIN1(EMUF(IT) , F2MUF(IT) )
      XFH = HPF(IT)
      XFL = AMAX1(FLOW,XFL)
      XFH = AMIN1(XFH,FHIGH)
      IF(XFH- FLOW) 105,105,115
C.....CASE 1. NOT LIKELY TO OCCUR
  105 FREA(1) = FLOW
      DO 110 IF=2,11
      DELF = 2.
  110 FREA(IF) =    FREA(IF-1) +DELF
C.....END OF CASE 1
      RETURN
  115 IF(XFL - FLOW) 120,120,130
C.....CASE 2. NIGHTTIME
  120 DELF = (XFH -FLOW)/11.
      FREA(1) = FLOW
      DO 125 IF=2,11
  125 FREA(IF) = FREA(IF-1) +DELF
      FREA(13)= 0.0
      RETURN
C.....END OF CASE 2.
  130 IF( XFH - (FLOW + 20.)) 135,135,150
C.....CASE 3. INSERT SMALLER MUF, WITHIN EQUAL INCREMENTS
C.....RANGE .LE. 20 MHZ
  135 DELF = (XFH-FLOW)/9.
      NE = (XFL - FLOW)/DELF
      NE = NE +2
      FREA(1) = FLOW
      DO 140 IF = 2,NE
  140 FREA(IF) = FREA(IF-1) + DELF
       FREA(NE) = XFL
      FREA(NE+1) = FREA(NE-1) + DELF
      NE = NE+2
      NE = MIN0(NE,11)
      DO 145 IF=NE,11
  145 FREA(IF) = FREA(IF-1) +DELF
      FREA(13) =0.0
      RETURN
C.....END OF CASE 3.
  150 IF(XFL -(FLOW +2.) ) 155,155,165
C.....CASE 4.  INSERT LOWER MUF BETWEEN 2 AND 4 MHZ
C.....THEN EQUAL INCREMENTS FROM 4 MHZ TO 40 MHZ
  155 DELF = (XFH- (FLOW+2.))/9.
      FREA(1) = FLOW
      FREA(2) = XFL
      FREA(3) = FLOW + 2.
      DO 160 IF=4,11
  160 FREA(IF)= FREA(IF-1) +DELF
      FREA(13) = 0.0
      RETURN
C.....END OF CASE 4.
  165 IF( (FHIGH-2.) -FLOW) 185,185,166
C.....CASE 5.  EQUAL INCREMENTS TO LOWER MUF, THEN EQUAL INCREMENTS TO
C.....UPPER LIMIT
  166 NE = (XFL - FLOW)/2.
      NE = MIN0 (NE,7)
      XNE = NE
      DELF = (XFL - FLOW)/XNE
      FREA(1) = FLOW
      DO 170  IF=2,NE
  170 FREA(IF) = FREA(IF-1) + DELF
      XNE = NE
      DELF = (XFH - FREA(NE)) / (12.0 - XNE - 1.0)
      NE = NE +1
      DO 175 IF=NE,11
  175 FREA(IF) = FREA(IF-1) + DELF
      FREA(13) =0.0
      RETURN
C.....END OF CASE 5.
C
C.....CASE 6.  EQUAL INCREMENT TO LOWER MUF, NOT LIKELY TO OCCUR
  185 DELF = ( (FHIGH-2.) -FLOW)/9.
       FREA(1) =FLOW
       DO 190 IF = 2,10
  190 FREA(IF) = FREA(IF- 1) +DELF
       FREA(11) =XFL
      FREA(13) =0.0
      RETURN
C.....END OF CASE 6.
      END
CC*****************************************************************

c# listin.f
      SUBROUTINE LISTIN
      use cversn
      common /clisting/ listing,formfeed
      character listing*1,formfeed*1
C--------------------------------
C.....THIS ROUTINE CREATES THE PROCEDURE FILE AND THEN
C.....CHECKS THE NAME IDENTIFIERS ON THE INPUT FILE
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
c jw      common /CVERSN/ VERSN
c jw         character VERSN*8
      COMMON / FILES / LUI,LUO,LU2,LU5,LU6,LU15,LU16,LU20,LU25,LU26, LU35
      COMMON / NAMEX / NAMES(100), INPUTX
      CHARACTER NAMES*10, INPUT*85, INPUTX*85,list*1
      EQUIVALENCE(INPUTX,INPUT)
      CHARACTER ITEMP*10, IOFF*10
      DATA NCARD/0/, IOFF/'OFF       '/
      list=listing
      if(list.eq.' ') list='Y'     !  blank    , do listing
      if(list.eq.'B') list='Y'     !  for Batch, do listing
      if(list.eq.'Y') WRITE(LUO,1500) formfeed,VERSN
      if(list.eq.'Y') WRITE(LUO,1502) (I,I=1,7)
      ITRUN = 1
C.....CREATE THE PROCEDURE FILE FROM THE STANDARD AND AUXILLARY INPUT
      LU = LUI
100   ICARD = MONITR(LU,MAXNAM)
C.....QUIT CARD ENCOUNTERED ON INPUT - BRANCH TO EXAMINE NAME IDENTIFIER
      IF(ICARD.eq.26) go to 300
C.....AUXIN CARD ENCOUNTERED ON INPUT FILE - INTERCHANGE LOGICAL UNITS
      IF(ICARD.ne.17) go to 140
      IF(LU - LUI) 120, 130, 120
  120 LU = LUI
      GO TO 100
  130 LU = LU15
      GO TO 100
C.....PROCEDURE CARD ENCOUNTERED ON INPUT FILE
  140 IF(ICARD - 23) 100, 150, 100
  150 ITEMP=INPUT(11:20)
      IFLAG = 0
      NUPROC = NUPROC + 1
      INDEX = NUMNAM + NUPROC
C.....THERE IS NO ROOM IN THE NAME LIST FOR THE PROCEDURE NAME
C.....ONLY 9 USER DEFINED INPUT PROCEDURES ARE ALLOWED
      IF(INDEX - MAXNAM) 170, 170, 160
  160 WRITE(LUO,1506)
      ITRUN = 0
      GO TO 300
C.....IGNORE THE PROCEDURE DEFINITION IF THE PROCEDURE NAME IS THE SAME
C.....AS A RESERVED INPUT CARD NAME. USE THE FIRST DEFINITION OF THE
C.....PROCEDURE IF A PROCEDURE WITH THE SAME NAME IS ALREADY DEFINED.
  170 DO 190 I = 1,INDEX
      IF(NAMES(I) .NE. ITEMP) GO TO 190
      IFLAG = 1
      WRITE(LUO,1508) ITEMP
  190 CONTINUE
      IF(IFLAG) 250, 250, 200
C.....IGNORE THE PROCEDURE DEFINITION
  200 NUPROC = NUPROC - 1
  210 JCARD = MONITR(LU,MAXNAM)
      IF(JCARD - 24) 210, 100, 210
C.....STORE THE PROCEDURE NAME IN THE NAME LIST AND WRITE THE PROCEDURE
  250 NAMES(INDEX) = ITEMP
      nch=lcount(inputx,85)
      if(nch.lt.11) nch=11
      WRITE(LU35,'(a)') ITEMP//INPUTX(11:nch)
  260 JCARD = MONITR(LU,MAXNAM)
      nch=lcount(inputx,85)
      WRITE(LU35,'(a)') INPUTX(1:nch)
      IF(JCARD - 24) 260, 100, 260
C.....CHECK THE NAME IDENTIFIER OF THE INPUT CARD IMAGES
  300 CONTINUE
      LU = LUI
      REWIND LU5
      REWIND LU15
      REWIND LU35
  305 ICARD = MONITR(LU,MAXNAM)
C.....CHECK FOR "EDP" CONTROL CARD AND SKIP ELECTRON DENSITY PROFILES
      IF(ICARD.ne.16) go to 311
      IF(LU.eq.LU15) go to 309
      nch=lcount(input,85)
      WRITE(LUO,'(1x,a)') INPUT(1:nch)
ccc      READ(INPUT,1522) ITEMP
      ITEMP=INPUT(16:)
      IF(ITEMP .EQ. IOFF) GO TO 305
      DO 308 I = 1,8
      READ(LU,'(a)') INPUT
      nch=lcount(input,85)
      WRITE(LUO,'(1x,a)') INPUT(1:nch)
  308 CONTINUE
      GO TO 305
  309 WRITE(LUO,1518) INPUT(1:80)
      READ(LUO,1522) ITEMP
      IF(ITEMP .EQ. IOFF) GO TO 305
      DO 310 I = 1,8
      READ(LU,'(a)') INPUT
      WRITE(LUO,1518) INPUT(1:80)
  310 CONTINUE
      GO TO 305
  311 IF(ICARD.le.MAXNAM) go to 315
C.....E R R O R - NAME IDENTIFIER ISN'T IN THE NAME LIST
      WRITE(LUO,1512) INPUT
      NCARD = NCARD + 1
      GO TO 305
  315 IF(LU.eq.LU15) then
         WRITE(LUO,1518) INPUT(1:80)
      else
         nch=lcount(input,85)
c          do not put this comment in the output file here
         if(input(1:15).ne.'COMMENT   GROUP') then
            if(list.eq.'Y') WRITE(LUO,'(1x,a)') INPUT(1:nch)
         end if
      end if
C.....QUIT CARD ENCOUNTERED ON INPUT FILE - BRANCH TO SUMMARY
      IF(ICARD.eq.26) go to 400
C.....AUXIN CARD ENCOUNTERED ON INPUT FILE - INTERCHANGE LOGICAL UNITS
      IF(ICARD.ne.17) go to 305
      IF(LU.eq.LUI) go to 370
      LU = LUI
      GO TO 305
  370 LU = LU15
      GO TO 305
C.....SUMMARY OF NAME IDENTIFIER ERRORS
  400 REWIND LUI
      REWIND LU15
      IF(NCARD.gt.0) then
         WRITE(LUO,1516) NCARD
         ITRUN = 0
      end if
      RETURN
C.....FORMAT SPECIFICATIONS
 1500 FORMAT(a1,' IONOSPHERIC COMMUNICATIONS ANALYSIS AND PREDICTI',
     A 'ON PROGRAM',/,20x,' VOACAP   VERSION ',a8,//)
 1502 FORMAT(' ',7(9X,I1),/,' ',7('1234567890'),'12345',/)
 1506 FORMAT(' THERE IS NO ROOM IN THE CARD NAME LIST FOR THE ',
     A 'PROCEDURE NAME',/,'THE USER MAY DEFINE NO MORE THAN  9 ',
     B 'PROCEDURES',//)
 1508 FORMAT(' ATTEMPT TO DEFINE A PROCEDURE CALLED - ',A10,/,
     A ' WHICH IS (1) A RESERVED INPUT CARD NAME (IGNORE DEFINITION)',
     B /,7X,'OR (2) ALREADY STORED IN THE PROCEDURE FILE (FIRST',
     C ' DEFINITION TAKES PRECEDENCE)',///)
 1512 FORMAT(' ',A80,'****NAME IDENTIFIER ERROR****')
 1516 FORMAT(///,' ',I5,' NAME IDENTIFIER ERRORS',//,' CAUSED BY ',
     A '(1) A SPELLING ERROR IN THE IDENTIFIER NAME',/,8X,
     B 'OR (2) A REFERENCE TO AN UNDEFINED PROCEDURE')
 1518 FORMAT(' ',A80,'AUXIN')
 1522 FORMAT(15X,A3)
      END
C--------------------------------

      FUNCTION F2(THETA,PHI)
C*********************************************************************
C  PARAMETERS:
C    THETA - takeoff angle in radians
C    PHI - azimuthal angle in radians
C*********************************************************************
      COMMON/ANTDAT/nostak,STKSPM,NUMBAY,BAYSPM,DIPLNM,RRSPM,STKHTM,
     +STKRAT(8),bayphs(14),DFMHZ,OFMHZ
      DIMENSION C(8),R(14),PS(14),A(8),Y(14),Z(8)
      COMMON/FWAVE/EIL,CEIL,XB,XS,XH,XR,C,R,PS,A,Y,Z,WAVE,BETA
         CPHI = COS(PHI)
         SPHI = SIN(PHI)
         CTHETA = COS(THETA)
         STHETA = SIN(THETA)
         CPSI = CTHETA * SPHI
         SPSI2 = 1. - CPSI * CPSI
         IF( SPSI2  .LE. 1.0E-12 ) SPSI2 = 1.0E-12
         EF = (COS(EIL * CPSI) - CEIL) / SPSI2
         FZPHR=0.
         FYR=0.
         FYI=0.
         NBS=IABS(NUMBAY)
         DO 50 I  = 1,NBS
         ARG = Y(I) * CPSI + PS(I)
         FYR=FYR+R(I)*COS(ARG)
   50    FYI=FYI+R(I)*SIN(ARG)
         FX =  SIN( XR * CTHETA * CPHI)
         DO 60 I =1,nostak
           COF =  C(I) * SIN(Z(I)* STHETA)
           FZPHR=FZPHR+COF
   60    CONTINUE
         COF = STHETA * SPHI
         FZTHR=FZPHR*COF
         FZPHR=FZPHR*CPHI
         F2 =  EF*EF  *FX*FX  *(FYR*FYR +FYI*FYI)
     1     *(FZTHR*FZTHR +FZPHR*FZPHR)
      RETURN
      END
ccxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

c# hfarea.f
      SUBROUTINE hfciraf(*)    !  output routine for CIRAF test points
c jw      include <windows.ins>
      common /Ccancel_batch/ icancel_batch
      common /cQUIET/ iquiet
      common /cCIRAF_TP/ nTP,idx_TP(911)
      common /Cciraf/ nciraf_tp,ciraf(911),ciraf_lat(911),ciraf_lon(911)
         character ciraf*4
C--------------------------------
C
C     THIS IS THE PROGRAM CONTROL SUBROUTINE
C     ITRUN CONTROLS PROGRAM TASK, ITOUT CONTROLS PROGRAM OUTPUT.
C
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON /RTANT /XETA, XSIG, XEPS, XND, XNL, XNH, TEX (4), ITANT,
     1 IRANT, RETA, RSIG, REPS, RND, RNL, RNH, REX(4), TEFF, REFF,
     2 KASANT(2), ITSANT, JTSANT
      COMMON / SSP / SUN(2,12), MONTH
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
*D     COMMON/INDICEZ/ISP,ISZ,IFQN,IUR,NMS(11,24,4,2)
*D     common/lpalmcmp/imddl(45,2,11,24,4,2),igdfx(45,2,11,24,4,2),
*D    +itlos(45,2,11,24,4,2),ihpfx(45,2,11,24,4,2),lNANG(2,11,24,4,2)
*D     integer*2 imddl,igdfx,itlos,ihpfx,lNANG
      COMMON /RGRID/ IPROJ,PLAT,PLON,XMIN,XMAX,YYMIN,YMAX,NX,NY
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      common /cdaily/ idaily(12)
      common /Cday/ iday
      character alf*20
c jw      logical doesit*1
      logical*1 doesit
c jw      logical*4 fexists@
      integer*4 error_code4
      integer*2 error_code
c------------------------------------------------------------------------
C.....START OF PROGRAM
C.....SET THE LOGICAL UNITS FOR SYSTEM INPUT AND OUTPUT FILES.
C     THE USER MUST INCLUDE AN "AUXIN" AND/OR AN "AUXOUT" CARD IF THE
C.....AUXILIARY INPUT AND/OR OUTPUT FILES ARE TO BE USED.
      LUI = LU5
      LUO = LU6
c***********************************************************************
c jw      nch_run=lcount(run_directory,50)
      MONTH=MONTHS(1)
      SSN=SUNSP(1)
      call REDMAP(SSN,MONTH)
      iday=idaily(1)            !  day of the month (if used)
      if(iday.ne.0) call redaily(ssn,month,iday)
      nf=1
      do 5 nf=1,11
      if(frel(nf).eq.0.) go to 6
5     continue
6     nf=nf-1
      call outciraf(-nTP,0)                !  output headers
      meth=METHOD
      if(MSPEC.eq.121) meth=30             !  smoothing method
      if(nf.eq.1) then
         if(iquiet.eq.0) 
     +   write(*,21) meth,IMON(MONTH),IHRO,nint(SSN),frel(1)
21       format(20x,' Method',i3,1x,a3,i3.2,'ut',i4,'ssn  Freqs=',f6.2)
      else
         if(iquiet.eq.0) 
     +   write(*,22) meth,IMON(MONTH),IHRO,nint(SSN),nf
22       format(20x,' Method',i3,1x,a3,i3.2,'ut',i4,'ssn  max of',
     +          i3,' Freqs')
      end if
c*****************************************************************
      DO 900 itp=1,nTP            !  loop through CIRAF test points
c          check to see if we should abort processing
c jw      doesit=fexists@(run_directory(1:nch_run)//'\voaarea.abt',error_code4)
c jw      if(doesit) then      !  file exists, abort area calculations
c jw         call erase@(run_directory(1:nch_run)//'\voaarea.abt',
c jw     +                  error_code)   !  delete file first
c jw         return 1
c jw      end if
      if(icancel_batch.ne.0) return     !  other cancel button picked
c jw      call yieldit    !  yield for Windows
      jtp=idx_TP(itp)                      !  get CIRAF test point number
      rlongd=ciraf_lon(jtp)
      rlatd =ciraf_lat(jtp)
      if(abs(RLATD-TLATD).lt..05 .and. abs(RLONGD-TLONGD).le..05) then
         RLONGD=TLONGD+.05
      end if
      do 10 i=1,24
10    allmuf(i)=-1.
ccc      NPSL=0            !  shortest path  (get NPSL from CIRCUIT card)
ccc      NPSL=1            !  thru antipode
C==================================================================
      CALL GEOM
      CALL SANG         !  reduce angle scan for this distance
C.....SET OUTPUT ARRAYS
      CALL SETOUT
C.....SET CONTROL PARAMETER FOR FREQUENCY COMPLEMENTS
      IFREQ = 1
C.....BEGIN HOUR LOOP
      JT = IHRO
      IUR=jt
      JTX = JT
      CALL GEOTIM(JT)   !  convert UT to LMT, etc
C.....WANT TO USE LONG TERM COEFFICIENTS
C.....TIME VARIATION OF MAPS
      CALL VIRTIM       !  UT variation of critical frequencies, F2M(3000)
      CALL TIMVAR       !  LMT dependency and E and F1 parameters
      CALL F2VAR        !  F2 parameters (F1 may be changed)
      CALL ESIND        !  Sporatic E parameters
      CALL IONSET
      CALL CURMUF       !  MUF by full ionosphere, and FOT calculation
      FREL(12) = ALLMUF(IT)
      IF(METHOD.EQ.22.OR.METHOD.EQ.25.OR.MSPEC.EQ.125)THEN
C.......FORCE SHORT PATH MODEL
        IPFG=100
      ELSE IF(METHOD.EQ.21)THEN
        IF(MSPEC.EQ.121)THEN
C.........SET FOR SHORT PATH AND USE LONGPATH/SHORTPATH SMOOTHING
          IPFG=100
        ELSE
C.........FORCE LONG PATH MODEL
          IPFG=200
        ENDIF
      ELSE
C.......FORCE LONG PATH MODEL IF PATH LENGTH .GT. SPECIFIED LIMIT
        IPFG=100
        IF(MSPEC.ne.121 .and. GCDKM.GE.GCDLNG)IPFG=200
      ENDIF
ccc      write(luo,111) ix,iy,method,npsl,ipfg,gcdkm,frel(12)
ccc111   format(5i5,f10.1,f10.3)
      CALL LUFFY(IPFG)
      CALL SETLUF
      call outciraf(itp,jtp)
C==================================================================
900   CONTINUE
C******************************************************************
C.....END OF RUN
      RETURN
      END
c------------------------------------------------------------

c###syssy.for
      SUBROUTINE SYSSY(G, PT, NN, FM, SU, SL, FMP, SUP, SLP)
C--------------------------------
C     SYSSY IS A TABLE LOOK-UP FOR DECILE VALUES OF THE DISTRIBUTION OF
C     EXCESS SYSTEM LOSS AND THE LIKELY PREDICTION OF ERRORS OF THE
C     SYSTEM LOSS IS DETERMINED.
C     G --- GEOMAGNETIC LATITUDE OF THE REFLECTION AREA
C     I --- MONTH
C     PT --- REFLECTION AREA LOCAL TIME
C     NN --- REFLECTION AREA
C     FM --- EXCESS SYSTEM LOSS
C     SU --- UPPER DECILE OF DISTRIBUTION OF SYSTEM LOSS
C     SL --- LOWER DECILE OF DISTRIBUTION OF SYSTEM LOSS
C     FMP --- PREDICTION ERRORS IN EXCESS SYSTEM LOSS
C     SUP --- UPPER DECILE LIMIT ASSOCIATED WITH PREDICTION ERROR IN
C     EXCESS SYSTEM LOSS
C     SLP --- LOWER DECILE LIMIT ASSOCIATED WITH PREDICTION ERROR IN
C     EXCESS SYSTEM LOSS
      COMMON / TWO /   F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     1                 FAM(14,12), SYS(9,16,6), PERR(9,4,6)
C     CHECK IF DATA FILE READ
      IF(F2D(1,1,1) ) 90,90,95
C    NO DATA TAPE USE FIRST VALUES IN ITSA-1 TABLES
   90 FM=9.
      DL=4.
      DU=9.
      FMP=5.6
      SUP=.60
      SLP=1.63
      SU=DU/1.28
      SL=DL/1.29
      RETURN
   95 CONTINUE
      LJ = 1
      J = PT + .5
      GG = ABS (G) * 5.729577E1
      KJ = ((GG - 40.) / 5.) + 1.5
      IF (KJ)100, 100, 105
  100 KJ = 1
      GO TO 115
  105 IF (KJ - 9)115, 115, 110
  110 KJ = 9
      GO TO 115
  115 IF (G)125, 120, 120
  120 KK = 0
      ND = 0
      GO TO 130
  125 KK = 8
      ND = 3
  130 LJ = FLOAT (J) / 3. + .67
      IF (LJ - 1)135, 140, 140
  135 LJ = 8
  140 LOL = LJ + KK
      LD = FLOAT(J) / 6. + .67
      IF (LD - 1)145, 150, 150
  145 LD = 4
  150 FM = SYS (KJ, LOL, NN)
      DU = SYS (KJ, LOL, NN + 1)
      DL = SYS (KJ, LOL, NN - 1)
      FMP = PERR (KJ, LD, ND + 1)
      SUP = PERR (KJ, LD, ND + 2)
      SLP = PERR (KJ, LD, ND + 3)
      SU = DU / 1.28
      SL = DL / 1.28
      RETURN
      END
C--------------------------------

module f90getopt

    implicit none

    ! Portable declaration of stderr, stdin, stdout
#ifdef f2003
    use, intrinsic :: iso_fortran_env, only : input_unit=>stdin, &
        output_unit=>stdout, &
        error_unit=>stderr
#else
#define stdin  5
#define stdout 6
#define stderr 0
#endif

    character(len=80):: optarg        ! Option's value
    character        :: optopt        ! Option's character
    integer          :: optind=1      ! Index of the next argument to process
    logical          :: opterr=.true. ! Errors are printed by default. Set opterr=.false. to suppress them

    type option_s
        character(len=80) :: name     ! Name of the option
        logical           :: has_arg  ! Option has an argument (.true./.false.)
        character         :: short    ! Option's short character equal to optopt
    end type option_s

    ! grpind is index of next option within group; always >= 2
    integer, private:: grpind=2

contains

    ! ----------------------------------------
    ! Return str(i:j) if 1 <= i <= j <= len(str),
    ! else return empty string.
    ! This is needed because Fortran standard allows but doesn't *require* short-circuited
    ! logical AND and OR operators. So this sometimes fails:
    !     if ( i < len(str) .and. str(i+1:i+1) == ':' ) then
    ! but this works:
    !     if ( substr(str, i+1, i+1) == ':' ) then

    character function substr( str, i, j )
        ! arguments
        character(len=*), intent(in):: str
        integer, intent(in):: i, j

        if ( 1 <= i .and. i <= j .and. j <= len(str)) then
            substr = str(i:j)
        else
            substr = ''
        endif
    end function substr


    ! ----------------------------------------
    character function getopt( optstring, longopts )
        ! arguments
        character(len=*), intent(in):: optstring
        type(option_s),   intent(in), optional:: longopts(:)

        ! local variables
        character(len=80):: arg

        optarg = ''
        if ( optind > command_argument_count()) then
            getopt = char(0)
        endif

        call get_command_argument( optind, arg )
        if ( present( longopts ) .and. arg(1:2) == '--' ) then
            getopt = process_long( longopts, arg )
        elseif ( arg(1:1) == '-' ) then
            getopt = process_short( optstring, arg )
        else
            getopt = char(0)
        endif
    end function getopt


    ! ----------------------------------------
    character function process_long( longopts, arg )
        ! arguments
        type(option_s),   intent(in):: longopts(:)
        character(len=*), intent(in):: arg

        ! local variables
        integer :: i = 0
        integer :: j = 0
        integer :: len_arg = 0             ! length of arg
        logical :: has_equalsign = .false. ! arg contains equal sign?

        len_arg = len_trim(arg)

        ! search for equal sign in arg and set flag "has_equalsign" and
        ! length of arg (till equal sign)
        do j=1, len_arg
            if (arg(j:j) == "=") then
                has_equalsign = .true.
                len_arg = j-1
                exit
            endif
        enddo

        ! search for matching long option

        if (.not. has_equalsign) then
            optind = optind + 1
        endif

        do i = 1, size(longopts)
            if ( arg(3:len_arg) == longopts(i)%name ) then
                optopt = longopts(i)%short
                process_long = optopt
                if ( longopts(i)%has_arg ) then
                    if (has_equalsign) then ! long option has equal sign between value and option
                        if (arg(len_arg+2:) == '') then ! no value (len_arg+2 value after "="
                            write(stderr, '(a,a,a)') "ERROR: Option '", trim(arg), "' requires a value"
                            process_long=char(0) ! Option not valid
                        else
                            call get_command_argument(optind, optarg)
                            optarg = optarg(len_arg+2:)
                            optind = optind + 1
                        endif
                    else ! long option has no equal sign between value and option
                        if ( optind <= command_argument_count()) then
                            call get_command_argument( optind, optarg )
                            optind = optind + 1
                        elseif ( opterr ) then
                            write(stderr, '(a,a,a)') "ERROR: Option '", trim(arg), "' requires a value"
                            process_long=char(0) ! Option not valid
                        endif
                    endif
                endif
                return
            endif
        end do
        ! else not found
        process_long = char(0)
        optopt='?'
        if ( opterr ) then
            write(stderr, '(a,a,a)') "ERROR: Unrecognized option '", arg(1:len_arg), "'"
        endif
        return
    end function process_long


    ! ----------------------------------------
    character function process_short( optstring, arg )
        ! arguments
        character(len=*), intent(in):: optstring, arg

        ! local variables
        integer:: i, arglen

        arglen = len( trim( arg ))
        optopt = arg(grpind:grpind)
        process_short = optopt

        i = index( optstring, optopt )
        if ( i == 0 ) then
            ! unrecognized option
            process_short = '?'
            if ( opterr ) then
                write(stderr, '(a,a,a)') "ERROR: Unrecognized option '-", optopt, "'"
            endif
        endif
        if ( i > 0 .and. substr( optstring, i+1, i+1 ) == ':' ) then
            ! required argument
            optind = optind + 1
            if ( arglen > grpind ) then
                ! -xarg, return remainder of arg
                optarg = arg(grpind+1:arglen)
            elseif ( optind <= command_argument_count()) then
                ! -x arg, return next arg
                call get_command_argument( optind, optarg )
                optind = optind + 1
            elseif ( opterr ) then
                write(stderr, '(a,a,a)') "ERROR: Option '-", optopt, "' requires a value"
                process_short = char(0) ! Option not valid
            endif
            grpind = 2
        elseif ( arglen > grpind ) then
            ! no argument (or unrecognized), go to next option in argument (-xyz)
            grpind = grpind + 1
        else
            ! no argument (or unrecognized), go to next argument
            grpind = 2
            optind = optind + 1
        endif
    end function process_short

end module f90getopt

      function len_trim(alf)     !  count # characters in alf
      CHARACTER*(*) alf
      max=len(alf)         !  get size of alf
      DO 10 I=MAX,1,-1
      IF(alf(I:I).NE.' ') GO TO 20
10    CONTINUE
20    len_trim=I
      RETURN
      END
C------------------------------------------------------------------

c###geom.for
      SUBROUTINE GEOM
C--------------------------------
C
C     THIS ROUTINE CALCULATES THE PATH GEOMETRY
C
C MAPIN IS -1,IF DATA TAPE HAS NOT BEEN READ.
      common /Cnorth_pole/ g_magnetic_lat,g_magnetic_lon  !  magnetic north pole
C
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON/GEOG/ GYZ(5), RAT(5), GMDIP(5), CLCK(5), ABIY(5), ARTIC(5),
     1 SIGPAT(5), EPSPAT(5)
      COMMON / OUTLAB / LABEL(11), LAYTYP(5), IEAST, INORTH, ISOUTH,
     A IWEST, LABLI, LABLJ, LABLK
      CHARACTER IEAST*1, ISOUTH*1, INORTH*1, IWEST*1, LABEL*5, LAYTYP*2,
     A LABLI*5, LABLJ*5, LABLK*5
      DATA EPSLON/1.E-7/
      data ddx/.03/      !  closest Tx & Rx can be
C.....RADIUS OF THE EARTH (RZ)
      BK = R2D
      AK = D2R
C.....GEOMAGNETIC NORTH POLE, LATITUDE, LONGITUDE, MINIMUM
C.....TAKE OFF ANGLE SERVICE PROBABILITY FACTOR
C.....LATITUDE SOUTH IS "-" AND LATITUDE NORTH IS "+"
C.....LONGITUDE EAST IS "+" AND LONGITUDE WEST IS "-"
ccc      GLT = 78.5 * D2R
ccc      GLG = -69.0 * D2R
      GLT = g_magnetic_lat * D2R      !  see routine set_magnetic_pole
      GLG = g_magnetic_lon * D2R
      if(abs(tlatd-rlatd).le.ddx .and. abs(tlongd-rlongd).le.ddx) then
c          move Rx away from Tx a little bit
         dd=ddx
         if(rlatd.lt.0.) dd=-ddx
         rlatd=tlatd-dd
      end if
      TLAT = TLATD * D2R
      TLONG = TLONGD * D2R
      RLAT = RLATD * D2R
      RLONG = RLONGD * D2R
      if(abs(rlatd).gt.89.9) rlong=0.     !  at poles, force long=0
      if(abs(tlatd).gt.89.9) tlong=0.     !  at poles, force long=0
C     GREAT CIRCLE DISTANCE AND BEARINGS.
 100  DLONG = TLONG - RLONG
      IF (ABS (DLONG) .GT. PI) DLONG = DLONG - SIGN (PI2, DLONG)
C.....FOR LONG GREAT CIRCLE PATH
      IF (NPSL .EQ. 1) DLONG = DLONG - SIGN (PI2, DLONG)
      QCOS=SIN(TLAT)*SIN(RLAT)+COS(TLAT)*COS(RLAT)*COS(DLONG)
      IF (ABS (QCOS) .GT. 1.0) QCOS = SIGN (1.0, QCOS)
      GCD = ACOS (QCOS)
C.....MINIMUM DISTANCE IS 31.85 METERS
      IF(GCD.LT.0.000001) GCD = 0.000001
C.....FOR GREAT CIRCLE PATH
      IF (NPSL .EQ. 1) GCD = PI2 - GCD
      GCDKM = GCD * RZ
C.....CHECK IF TRANSMITTER IS NEAR A POLE
      IF(COS(TLAT) - EPSLON) 101, 101, 104
C.....TRANSMITTER IS NEAR A POLE
  101 IF (TLAT) 102,102,103
  102 BTR= 0.0
      GO TO 106
  103 BTR = PI
      GO TO 106
C.....TRANSMITTER IS NOT NEAR A POLE
  104 CONTINUE
      QCOS=(SIN(RLAT)-SIN(TLAT)*COS(GCD))/(COS(TLAT)*SIN(GCD))
      IF (ABS (QCOS) .GT. 1.0) QCOS = SIGN (1.0, QCOS)
C.....BTR IS BEARING, TRANSMITTER TO RECEIVER
      BTR = ACOS (QCOS)
  106 CONTINUE
      IF (DLONG .GT. 0.0) BTR = PI2 - BTR
C.....CHECK IF RECEIVER IS NEAR A POLE
      IF(COS(RLAT) - EPSLON) 111, 111, 114
C.....RECEIVER IS NEAR A POLE
  111 IF( RLAT )  112,112,113
  112 BRT = 0.
      GO TO 116
  113 BRT=PI
      GO TO 116
C.....RECEIVER IS NOT NEAR A POLE
  114 CONTINUE
      QCOS=(SIN(TLAT)-SIN(RLAT)*COS(GCD))/(COS(RLAT)*SIN(GCD))
      IF (ABS (QCOS) .GT. 1.0) QCOS = SIGN (1.0, QCOS)
C.....BRT IS BEARING, RECEIVER TO TRANSMITTER
      BRT = ACOS (QCOS)
  116 CONTINUE
      IF (DLONG .LT. 0.0) BRT = PI2 - BRT
C.....CONVERT BEARINGS TO DEGREES
      BTRD = BTR * R2D
      BRTD = BRT * R2D
C     DETERMINATION OF REFLECTION AREAS.
C SELECT SAMPLE AREAS IN ORDER
      IF(GCDKM.le.2000.01) then
C.....KM IS THE NUMBER OF SAMPLE AREAS
         KM=1
         RD(1)= GCD/2.
      else if(GCDKM.le.4000.) then
         KM=3
         RD(1) = 1000. / RZ
         RD(2)= GCD/2.
         RD(3)= GCD -RD(1)
      else
         KM= 5
         RD(1) = 1000. / RZ
         RD(2)= RD(1)+RD(1)
         RD(3)= GCD/2.
         RD(4)= GCD-RD(2)
         RD(5)= GCD-RD(1)
      end if
ccc      write(12,'(''in geom, km='',i5,f10.2)') km,gcdkm
C.....RD(1) IS E LAYER, RD(2) IS F LAYER, RD(3) IS ALL LAYERS,
C.....RD(4) IS F LAYER AND RD(5) IS E LAYER
C     REFLECTION AREA COORDINATES AND GEOMAGNETIC LATITUDE.
66    IF(KM.LT.1) GO TO 185
      DO 180 I = 1, KM
      DRF = RD (I)
      CTLAT = COS(TLAT)
C.....CHECK IF TRANSMITTER IS NEAR A POLE
      IF(CTLAT - EPSLON) 71, 76, 76
C.....TRANSMITTER IS NEAR A POLE
   71 RFLT = TLAT - SIGN(DRF,TLAT)
      IF(ABS(RFLT).gt.PIO2) RFLT=PIO2*sign(1.,RFLT)
      RFLG=RLONG
      GO TO 80
C.....TRANSMITTER IS NOT NEAR A POLE
   76 CONTINUE
      QCOS=COS(DRF)*SIN(TLAT)+SIN(DRF)*COS(TLAT)*COS(BTR)
      IF (ABS (QCOS) .GT. 1.0) QCOS = SIGN (1.0, QCOS)
      RFLT = PIO2 - ACOS (QCOS)
C.....CHECK IF THE SAMPLE AREA IS NEAR A POLE
      IF(COS(RFLT) - EPSLON) 78, 78, 79
C.....SAMPLE AREA IS NEAR A POLE
   78 RFLG = TLONG
      GO TO 80
C.....SAMPLE AREA IS NOT NEAR A POLE
   79 CONTINUE
      QCOS=(COS(DRF)-SIN(RFLT)*SIN(TLAT))/(COS(RFLT)*COS(TLAT))
      IF (ABS (QCOS) .GT. 1.0) QCOS = SIGN (1.0, QCOS)
      RFLG = ACOS (QCOS)
      IF (DRF .GE. PI) RFLG = PI2 - RFLG
      RFLG = TLONG - SIGN (RFLG, DLONG)
      IF (ABS (RFLG) .GT. PI) RFLG = RFLG - SIGN (PI2, RFLG)
   80 CONTINUE
      QCOS=SIN(GLT)*SIN(RFLT)+COS(GLT)*COS(RFLT)*COS(RFLG-GLG)
      IF (ABS (QCOS) .GT. 1.0) QCOS = SIGN (1.0, QCOS)
C.....GLAT(I) IS THE GEOMAGNETIC LATITUDE
C.....CLAT(I) IS THE GEOGRAPHIC LATITUDE
C.....CLONG(I) IS THE GEOGRAPHIC LONGITUDE
      GAT = ACOS (QCOS)
      GLAT (I) = PIO2 - GAT
      CLAT (I) = RFLT
      CLONG (I) = RFLG
C.....MAGNETIC FIELD VARIABLES.
C....CLG IS THE GEOGRAPHIC EAST LONGITUDE(SAVED FOR CALL TO NOISY)
      CLG = RFLG
      CALL MAGVAR(RFLT,RFLG,I,CLG)
C.....CHECK TO SEE IF MAP AVAILABLE IS CONSISTANT WITH BEARING
ccc      IF(MAPIN.le.0) go to 115
C.....OBTAIN LAND MASS MAP
         RFLTD = RFLT * R2D
         CLGD = CLG * R2D
         IF(CLGD.LT.0.)CLGD=CLGD+360.
         CALL NOISY(7,RFLTD,CLGD,WLD)
      IF(WLD.ge.0) go to 115
C.....GROUND CONSTANTS FOR SEA
         SIGPAT (I) = 5.
         EPSPAT (I) = 80.
         go to 120
C.....GROUND CONSTANTS FOR LAND
115      SIGPAT (I) = 0.001
         EPSPAT (I) = 4.
 120  CONTINUE
  180 CONTINUE
 185  CONTINUE
      ALATD=ABS(CLAT(1))*R2D
      IF(KM.NE.1) ALATD=ABS((CLAT(1)+CLAT(2)+CLAT(3))/3.0)*R2D
ccc      write(12,'(''glat='',5e15.7)') (glat(i),i=1,km)
      RETURN
      END
C--------------------------------

c###curmuf.for
      SUBROUTINE CURMUF
c***********************************************
c          Alex Shovkoplyas made some changes to:
c             curmuf
c             seltxr
c             settxr
c             sigdis
c          Normally if the version (..\database\version.w32)
c             is yy.mmddW then the original version is used.
c                yy.mmddA then Alex's version is used.
c                yy.mmdda then Alex's version is used with IONCAP absorption.
c***********************************************
      use cversn
c jw      common /CVERSN/ VERSN
c jw      character VERSN*8
      if(versn(8:8).eq.'A' .or. versn(8:8).eq.'a') then
         call curmuf_alex       !  use Alex's modified version
      else
         call curmuf_orig       !  use original version
      end if
      return
      end
C--------------------------------
      SUBROUTINE CURMUF_orig
C--------------------------------
C
C     THIS ROUTINE CALCULATES MUF FOR ALL LAYERS AND CIRCUIT MUF (NO ES)
C     MUF FACTORS ARE COMPUTED USING COMPLETE ELECTRON DENSITY PROFILES
C
      COMMON / MFAC / F2M3(5),HPF2(5),ZENANG(5),ZENMAX(5),IEDP,FSECV(3)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     A,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMUF
     B (4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     C ,YMUF(4)
      COMMON/ES/FS(3,5),HS(5)
      COMMON / GEOG / GYZ(5), RAT(5), GMDIP(5), CLCK(5), ABIY(5),
     1 ARTIC(5), SIGPAT(5), EPSPAT(5)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON/INFORM/INFO,IHSHR,IHLNG
      COMMON /CON / D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      DATA FQDEL/0.1/, NFQ/ 4/
      DATA AE/0.5/, A1/0.5/, A2/0.5/
      DATA DZF/2000./,BEX/9.5/
      KT =1
      IF(KFX -2) 100,105,110
C     RECEIVER SITE SAMPLE AREA
  100 KR =1
      GO TO 115
  105 KR =2
      GO TO 115
  110 KR =3
  115 CONTINUE
C  SELECT CONTROLING SAMPLE AREA.
      IF(KR -2) 125,120,130
  120 CONTINUE
      IF(FI(1,KT)- FI(1,KR))  125,125,135
  125 KS = KT
      GO TO 140
C    THE 0.01 MUST AGREE WITH SELMOD
  130 IF(ABS(FI(3,KT) - FI(3,KR)) - .01) 120,120,132
  132 IF(FI(3,KT)- FI(3,KR)) 125,120,135
  135 KS = KR
  140 CONTINUE
C  CALCULATE ELECTRON DENSITY PROFILE.
      CALL  LECDEN(KS)
C  TANGENT FREQUENCIES
      XTE = 1.0 / SQRT(1.0 + AE * YI(1,KS) / HI(1,KS))
      FXE = XTE*FI(1,KS)
      FX1 = 0.0
      IF(FI(2,KS)) 150,150,145
  145 XT1 = 1.0 / SQRT(1.0 + A1 * YI(2,KS) / HI(2,KS))
      FX1 = XT1*FI(2,KS)
  150 XT2 = 1.0 / SQRT(1.0 + A2 * YI(3,KS) / HI(3,KS))
      FX2 = XT2*FI(3,KS)
C FORCE F2MUF TO APPROACH MUF(0)
      IF( GCDKM- DZF ) 146,147,147
  146 A = -1. + 1./XT2
      BETA = 1.+ A* EXP(-BEX* GCDKM/DZF)
      FX2  = BETA * FX2
      XT2 = XT2 * BETA
  147 CONTINUE
C
C  ELAYER MUF
C
C  CALCULATE TRUE AND VIRTUAL HEIGHT
      IF( IEDP ) 155,160,160
  155 CALL GETHP(FXE,HPE,HTE)
      GO TO 165
C.....EQUIVALENT RESULT TO CALL OF SUBROUTINE GETHP FOR E LAYER
C.....PARAMETERS OF 110 AND 20
  160 HTE = 104.25
      HPE = 125.30
  165 CONTINUE
      DELE = AMAX1(0.0,AMIND)
      DEL  = DELE * D2R
      PHE=ASIN(RZ*COS(DEL)/(RZ+HPE))
      NHOPS = .5 * GCDKM / ((PIO2 - DEL - PHE) * RZ)
      PSI = GCDKM/(2.*RZ)
      XHOPS=NHOPS+1
      PSI=PSI/XHOPS
      CPSI = COS(PSI)
      SPSI = SIN(PSI)
      TANP = SPSI / (1. - CPSI + HPE / RZ)
      PHE = ATAN(TANP)
      DEL = PIO2 - PHE - PSI
      CDEL = COS(DEL)
      SPHE = RZ*CDEL/(RZ+ HTE)
      SECP = 1./SQRT(1.-SPHE*SPHE)
      EMUF(IT) = FXE*SECP
      DELE = DEL * R2D
C.....DISTRIBUTION FOR E LAYER MUF
      SIGL(1) = AMAX1(0.01,0.1*EMUF(IT) )
      SIGU(1) = SIGL(1)
C.....DELMUF(1) IS THE ANGLE FOR THE E LAYER
C.....HPMUF(1) IS THE VIRTUAL HEIGHT FOR THE E LAYER
C.....HTMUF(1) IS THE TRUE HEIGHT FOR THE E LAYER
C.....FVMUF(1) IS THE EQUIVALENT VERTICAL FREQUENCY FOR THE E LAYER
C.....AFMUF(1) IS THE DEVIATIVE LOSS FACTOR FOR THE E LAYER
C.....NHOPMF(1) IS THE NUMBER OF HOPS FOR THE E LAYER
C.....YFOT(1) IS THE LOWER DECILE FOR THE E LAYER
C.....YHPF(1) IS THE UPPER DECILE FOR THE E LAYER
C.....YMUF(1) IS THE MEDIAN FOR THE E LAYER
C.....NOTE THAT THE SAME VARIABLES WITH INCREASING SUBSCRIPTS DENOTE THE
C.....E LAYER (SUBSCRIPT=1), F1 LAYER (SUBSCRIPT=2), F2 LAYER
C.....(SUBSCRIPT=3), AND ES SPORADIC E LAYER (SUBSCRIPT=4)
      DELMUF(1)= DELE
      HPMUF(1) = HPE
      HTMUF(1) = HTE
      FVMUF(1) = FXE
      AFMUF(1) = 0.0
      NHOPMF(1)= XHOPS
      YFOT(1) = EMUF(IT) - 1.28*SIGL(1)
      YHPF(1) = EMUF(IT) + 1.28*SIGU(1)
      YMUF(1) = EMUF(IT)
C
C F2  LAYER MUF
C
C CALCULATE TRUE AND VIRTUAL HEIGHTS
      IF(IEDP) 170,175,175
  170 CALL GETHP(FX2,HP2,HT2)
      GO TO 180
C.....PARABOLIC E AND F2 LAYERS
  175 HT2 = HI(3,KS) - YI(3,KS) + YI(3,KS)*(1.-SQRT(1.-XT2*XT2))
      IF(FI(2,KS)) 176, 176, 170
  176 HP2 = HI(3,KS) - YI(3,KS) + BENDY(3,KS,FX2)
     A       +( PEN(1,KS,FX2) - 2.*YI(1,KS) )
  180 CONTINUE
      DEL2 = AMAX1(0.0,AMIND)
      DEL = DEL2 * D2R
      PHE=ASIN(RZ*COS(DEL)/(RZ+HP2))
      NHOPS = .5 * GCDKM / ((PIO2 - DEL - PHE) * RZ)
      XHOPS=NHOPS+1
      PSI=GCDKM/((2.*RZ)*XHOPS)
      CPSI = COS(PSI)
      SPSI = SIN(PSI)
C  DEL2 IS TOO SMALL.
      TANP = SPSI / (1. - CPSI + HP2 / RZ)
      PHE = ATAN(TANP)
      DEL = PIO2 - PHE - PSI
      CDEL = COS(DEL)
      SPHE = RZ*CDEL/(RZ+ HT2)
      SECP = 1./SQRT(1.-SPHE*SPHE)
      FOB1 = FX2 * SECP
      NTRY = 0
      FOB2 = FOB1
      XHP = (HP2 - HT2) / RZ
c-------------fjr-------------------------begin iteration for F2MUF, HPX2
c-------------fjr----------allows 4 tries to obtain epsilon of 0.1
  190 CONTINUE
      FOB1 = FOB2
C.....CORRECTION TO MARTYN"S THEOREM
      XMUT = SPHE*SPHE
      XFSQ=  FOB1*FOB1/( FI(3,KS)*FI(3,KS) )
      SPH = XFSQ *XMUT*XHP*(HT2 + 2.*(RZ + HT2)*XHP)
c.....SPH=amin1(SPH,60.)
C  CORRECTED VIRTUAL HEIGHT.
      HPX2 = HP2 + SPH
      TANP = SPSI / (1. - CPSI + HPX2 / RZ)
      PHE = ATAN(TANP)
      DEL = PIO2 - PHE - PSI
      CDEL = COS(DEL)
      SPHE = RZ*CDEL/(RZ+ HT2)
      SECP = 1./SQRT(1.-SPHE*SPHE)
      FOB2 = FX2* SECP
      HPX1 = HPX2
      NTRY = NTRY +1
      IF(IAND(INFO,8).GT.0)THEN
        WRITE(99,'(A,I2,3(A,F8.2))')' "CURMUF"  F2-LAYER  NTRY=',NTRY,
     1  '  HP=',HP2,'  MARTYN CORR=',SPH,'  FOB=',FOB2
      ENDIF
C.....CORRECTION TO HPX2 IS SUFFICIENT
      IF( ABS(FOB2-FOB1) - FQDEL )  200,200,195
  195 IF(NFQ - NTRY)  200,190,190
c-------------------------fjr---------------end iteration for F2MUF, HPX2
  200 F2MUF(IT) = FOB2
      DEL2 = DEL * R2D
C.....MULTIPLY BY ANY VALUE LESS THAN ONE
      FREQ = .9* F2MUF(IT)
C.....OBTAIN THE F2 MUF DISTRIBUTION FROM THE F2 M(3000) TABLES
      DUMMY1 = F2MUF(IT)
      DUMMY2 = CLAT(KS)
      DUMMY3 = CLCK(KS)
      CALL F2DIS(DUMMY1,SSN,DUMMY2,FREQ,DUMMY3,SIG)
      SIGL(3) = AMAX1( 0.01,SIG)
      FREQ = 1.1 * F2MUF(IT)
      DUMMY1 = F2MUF(IT)
      DUMMY2 = CLAT(KS)
      DUMMY3 = CLCK(KS)
      CALL F2DIS(DUMMY1,SSN,DUMMY2,FREQ,DUMMY3,SIG)
      SIGU(3) = AMAX1(0.01, SIG)
      DELMUF(3)= DEL2
      HPMUF(3) = HPX2
      HTMUF(3) = HT2
      FVMUF(3) = FX2
      AFMUF(3) = 0.0
      NHOPMF(3) = XHOPS
      YFOT(3) = F2MUF(IT) - 1.28 *SIGL(3)
      YMUF(3)  = F2MUF(IT)
      YHPF(3) = F2MUF(IT) + 1.28 *SIGU(3)
      IF( FI(2,KS) ) 210,210,215
C.....SET F1 TO E WHEN THERE IS NO F1 PRESENT
  210 F1MUF(IT) = EMUF(IT)
      SIGL(2)  = +SIGL(1)
      SIGU(2)  = +SIGU(1)
      DELMUF(2) = DELMUF(1)
      HPMUF(2) =  HPMUF(1)
      HTMUF(2) =  HTMUF(1)
      FVMUF(2) =  FVMUF(1)
      AFMUF(2) =  AFMUF(1)
      NHOPMF(2)=  NHOPMF(1)
      YFOT(2)  =  YFOT(1)
      YMUF(2)  = YMUF(1)
      YHPF(2)  =  YHPF(1)
      GO TO 240
C
C  F1 LAYER MUF
C
  215 CONTINUE
      CALL GETHP(FX1,HP1,HT1)
      DEL1 = AMAX1(0.0,AMIND)
      DEL  = DEL1 * D2R
      PHE=ASIN(RZ*COS(DEL)/(RZ+HP1))
      NHOPS = .5 * GCDKM / ((PIO2 - DEL - PHE) * RZ)
      PSI = GCDKM/(2.*RZ)
      XHOPS=NHOPS+1
      PSI=PSI/XHOPS
      CPSI= COS(PSI)
      SPSI = SIN(PSI)
      TANP = SPSI / (1. - CPSI + HP1 / RZ)
      PHE = ATAN(TANP)
      DEL = PIO2 - PHE - PSI
      CDEL = COS(DEL)
      SPHE = RZ*CDEL/(RZ+ HT1)
      SECP = 1./SQRT(1.-SPHE*SPHE)
      FOB1 = FX1 * SECP
      NTRY = 0
      FOB2 = FOB1
      XHP = (HP1 - HT1) / RZ
c-------------fjr-------------------------begin iteration for F1MUF, HPF1
c-------------fjr----------allows 4 tries to obtain epsilon of 0.1
  225 CONTINUE
      FOB1 = FOB2
      XFSQ = FOB1*FOB1 / ( FI(2,KS)*FI(2,KS)  )
      XMUT = SPHE*SPHE
      SPH = XFSQ*XMUT*XHP*(HT1 + 2.*(RZ + HT1)*XHP)
c.....SPH=amin1(SPH,60.)
      HPY2 = HP1 + SPH
      TANP = SPSI / (1. - CPSI + HPY2 / RZ)
      PHE = ATAN(TANP)
      DEL = PIO2 - PHE - PSI
      CDEL = COS(DEL)
      SPHE = RZ*CDEL/(RZ + HT1)
      SECP = 1. / SQRT(1. - SPHE * SPHE)
      FOB2 = FX1 *SECP
      NTRY = NTRY +1
      HPY1 = HPY2
      IF(IAND(INFO,8).GT.0)THEN
        WRITE(99,'(A,I2,3(A,F8.2))')' "CURMUF"  F1-LAYER  NTRY=',NTRY,
     1  '  HP=',HP1,'  MARTYN CORR=',SPH,'  FOB=',FOB2
      ENDIF
      IF( ABS(FOB2-FOB1) - FQDEL)  235,235,230
  230 IF(NFQ - NTRY)  235,225,225
c-------------------------fjr---------------end iteration for F1MUF, HPF1
  235 F1MUF(IT) = FOB2
      DEL1 = DEL * R2D
      SIGL(2) = AMAX1(0.01, 0.1*F1MUF(IT) )
      SIGU(2) = SIGL(2)
      DELMUF(2)= DEL1
      HPMUF(2) = HPY2
      HTMUF(2) = HT1
      FVMUF(2) = FX1
      AFMUF(2) = 0.0
      NHOPMF(2)= XHOPS
      YFOT(2) = F1MUF(IT) - 1.28*SIGL(2)
      YMUF(2) = F1MUF(IT)
      YHPF(2) = F1MUF(IT) + 1.28*SIGU(2)
  240 CONTINUE
C
C  SPORADIC E MUF, PROB. OF REFLECTION = 0.5.
C
      DELS = AMAX1(0.0, AMIND)
      ESMUF(IT) = 1000.
      DO 270 K=1,KM
      IF(FS(2,K)) 270,270,260
  260 CONTINUE
      DEL = DELS * D2R
      PHE = ASIN(RZ * COS(DEL) / (RZ + HS(K)))
      NHOPS = .5 * GCDKM / ((PIO2 - DEL - PHE) * RZ)
      HOP = NHOPS + 1
      PSI  = 0.5* GCD/HOP
      TDEL = (COS(PSI) - RZ/(RZ+HS(K)))/ SIN(PSI)
      CDEL = 1. / SQRT(1. + TDEL * TDEL)
      SPHE = RZ * CDEL / (RZ + HS(K))
      SECP = 1. / SQRT(1. - SPHE * SPHE)
      ESD = FS(2,K) * SECP
      IF( ESMUF(IT) -ESD)  270,270,265
  265 ESMUF(IT) = ESD
      KSX = K
      TDELX = TDEL
      SECPX =SECP
  270 CONTINUE
      IF(ESMUF(IT) - 1000.) 272,271,271
  271 DELMUF(4) = 0.0
       HPMUF(4) = 0.0
      HTMUF(4) = 0.0
       FVMUF(4) = 0.0
       AFMUF(4) = 0.0
      NHOPMF(4) = 0.0
       YFOT(4) = 0.0
      YMUF(4) = 0.0
       YHPF(4) = 0.0
       SIGL(4) = 0.0
       SIGU(4) = 0.0
       ESMUF(IT) = 0.0
       GO TO 274
  272 CONTINUE
      DELMUF(4) = ATAN(TDELX) * R2D
      HPMUF(4) = HS(KSX)
      HTMUF(4) = HPMUF(4)
      FVMUF(4) = FS(2,KSX)
      AFMUF(4) = 0.0
      NHOPMF(4) = HOP
      YMUF(4) = ESMUF(IT)
C.....FS IS ES OR E CRITICAL FREQUENCY
      XES = FI(1,KS) - FS(1,KSX)
      ZDIF = 0.1
      FZERO = 0.1
C.....UPPER STANDARD DEVIATION (LOWER FROM MAPS)
      SIGU(4) = ( FS(3,KSX) - FS(2,KSX))/ 1.28
      SIGB    = ( FS(2,KSX) - FS(1,KSX))/ 1.28
      SIGZ    = ( FS(2,KSX) - FZERO)/3.1
C.....MAXIMUM LOWER - WANT PROB .GT. .001 FOR F .GT. FZERO
      IF( XES +ZDIF) 315,320,320
C.....IF LOWER DECILE IS A REGULAR E USE THE UPPER DECILE
  315 SIGL(4) = SIGB
      GO TO 335
  320 IF(XES - ZDIF)  325,330,330
  325 SIGL(4) = SIGB + ((XES+ZDIF)/(2.* ZDIF)) * (SIGU(4) - SIGB)
      GO TO 335
  330 SIGL(4) = SIGU(4)
C.....IF UPPER DECILE IS TO LARGE RESET TO LOWER DECILE
  335 SIGL(4) = AMIN1(SIGL(4), SIGZ)
      FS(1,KSX) = FS(2,KSX) - 1.28* SIGL(4)
C NOW DO  OBLIQUE CASE
      SIGL(4) = SIGL(4)* SECPX
      SIGU(4) = SIGU(4) * SECPX
      YFOT(4) = ESMUF(IT) - 1.28 * SIGL(4)
      YHPF(4) = ESMUF(IT) + 1.28 * SIGU(4)
  274 CONTINUE
C
C  CIRCUIT MUF
C
C.....NOTE THAT ES IS NOT INCLUDED HERE
      FOT(IT) = AMAX1(YFOT(1),YFOT(2),YFOT(3) )
      ALLMUF(IT)  = AMAX1(EMUF(IT),F1MUF(IT), F2MUF(IT) )
      HPF(IT)    = AMAX1(YHPF(1),YHPF(2),YHPF(3))
      IF(EMUF(IT)- ALLMUF(IT))  280,275,275
  275 ANGMUF(IT) = DELMUF(1)
      MODMUF = 1
      GO TO 295
  280 IF(F1MUF(IT) - ALLMUF(IT))  290,285,285
  285 ANGMUF(IT) = DELMUF(2)
      MODMUF = 2
      GO TO 295
  290 ANGMUF(IT) = DELMUF(3)
      MODMUF = 3
  295 CONTINUE
      RETURN
      END
C--------------------------------
c###curmuf.for
      SUBROUTINE CURMUF_alex
C--------------------------------
C
C     THIS ROUTINE CALCULATES MUF FOR ALL LAYERS AND CIRCUIT MUF (NO ES)
C     MUF FACTORS ARE COMPUTED USING COMPLETE ELECTRON DENSITY PROFILES
C
      COMMON / MFAC / F2M3(5),HPF2(5),ZENANG(5),ZENMAX(5),IEDP,FSECV(3)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     A,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMUF
     B (4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     C ,YMUF(4)
      COMMON/ES/FS(3,5),HS(5)
      COMMON / GEOG / GYZ(5), RAT(5), GMDIP(5), CLCK(5), ABIY(5),
     1 ARTIC(5), SIGPAT(5), EPSPAT(5)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON/INFORM/INFO,IHSHR,IHLNG
      COMMON /CON / D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      DATA FQDEL/0.1/, NFQ/ 4/
      DATA AE/0.5/, A1/0.5/, A2/0.5/
      DATA DZF/2000./,BEX/9.5/
c>>>>>A.S.
      DIMENSION LX(3)
      DATA LX/2,3,4/
c<<<<<       
      KT =1
      IF(KFX -2) 100,105,110
C     RECEIVER SITE SAMPLE AREA
  100 KR =1
      GO TO 115
  105 KR =2
      GO TO 115
  110 KR =3
  115 CONTINUE
C  SELECT CONTROLING SAMPLE AREA.
      IF(KR -2) 125,120,130
  120 CONTINUE
      IF(FI(1,KT)- FI(1,KR))  125,125,135
  125 KS = KT
      GO TO 140
C    THE 0.01 MUST AGREE WITH SELMOD
  130 IF(ABS(FI(3,KT) - FI(3,KR)) - .01) 120,120,132
  132 IF(FI(3,KT)- FI(3,KR)) 125,120,135
  135 KS = KR
  140 CONTINUE
C  CALCULATE ELECTRON DENSITY PROFILE.
      CALL  LECDEN(KS)
C  TANGENT FREQUENCIES
      XTE = 1.0 / SQRT(1.0 + AE * YI(1,KS) / HI(1,KS))
      FXE = XTE*FI(1,KS)
      FX1 = 0.0
      IF(FI(2,KS)) 150,150,145
  145 XT1 = 1.0 / SQRT(1.0 + A1 * YI(2,KS) / HI(2,KS))
      FX1 = XT1*FI(2,KS)
  150 XT2 = 1.0 / SQRT(1.0 + A2 * YI(3,KS) / HI(3,KS))
      FX2 = XT2*FI(3,KS)
C FORCE F2MUF TO APPROACH MUF(0)
      IF( GCDKM- DZF ) 146,147,147
  146 A = -1. + 1./XT2
      BETA = 1.+ A* EXP(-BEX* GCDKM/DZF)
      FX2  = BETA * FX2
      XT2 = XT2 * BETA
  147 CONTINUE
C
C  ELAYER MUF
C
C  CALCULATE TRUE AND VIRTUAL HEIGHT
      IF( IEDP ) 155,160,160
  155 CALL GETHP(FXE,HPE,HTE)
      GO TO 165
C.....EQUIVALENT RESULT TO CALL OF SUBROUTINE GETHP FOR E LAYER
C.....PARAMETERS OF 110 AND 20
  160 HTE = 104.25
      HPE = 125.30
  165 CONTINUE
      DELE = AMAX1(0.0,AMIND)
      DEL  = DELE * D2R
      PHE=ASIN(RZ*COS(DEL)/(RZ+HPE))
      NHOPS = .5 * GCDKM / ((PIO2 - DEL - PHE) * RZ)
      PSI = GCDKM/(2.*RZ)
      XHOPS=NHOPS+1
      PSI=PSI/XHOPS
      CPSI = COS(PSI)
      SPSI = SIN(PSI)
      TANP = SPSI / (1. - CPSI + HPE / RZ)
      PHE = ATAN(TANP)
      DEL = PIO2 - PHE - PSI
      CDEL = COS(DEL)
      SPHE = RZ*CDEL/(RZ+ HTE)
      SECP = 1./SQRT(1.-SPHE*SPHE)
      EMUF(IT) = FXE*SECP
      DELE = DEL * R2D
C.....DISTRIBUTION FOR E LAYER MUF
      SIGL(1) = AMAX1(0.01,0.1*EMUF(IT) )
      SIGU(1) = SIGL(1)
C.....DELMUF(1) IS THE ANGLE FOR THE E LAYER
C.....HPMUF(1) IS THE VIRTUAL HEIGHT FOR THE E LAYER
C.....HTMUF(1) IS THE TRUE HEIGHT FOR THE E LAYER
C.....FVMUF(1) IS THE EQUIVALENT VERTICAL FREQUENCY FOR THE E LAYER
C.....AFMUF(1) IS THE DEVIATIVE LOSS FACTOR FOR THE E LAYER
C.....NHOPMF(1) IS THE NUMBER OF HOPS FOR THE E LAYER
C.....YFOT(1) IS THE LOWER DECILE FOR THE E LAYER
C.....YHPF(1) IS THE UPPER DECILE FOR THE E LAYER
C.....YMUF(1) IS THE MEDIAN FOR THE E LAYER
C.....NOTE THAT THE SAME VARIABLES WITH INCREASING SUBSCRIPTS DENOTE THE
C.....E LAYER (SUBSCRIPT=1), F1 LAYER (SUBSCRIPT=2), F2 LAYER
C.....(SUBSCRIPT=3), AND ES SPORADIC E LAYER (SUBSCRIPT=4)
      DELMUF(1)= DELE
      HPMUF(1) = HPE
      HTMUF(1) = HTE
      FVMUF(1) = FXE
      AFMUF(1) = 0.0
      NHOPMF(1)= XHOPS
      YFOT(1) = EMUF(IT) - 1.28*SIGL(1)
      YHPF(1) = EMUF(IT) + 1.28*SIGU(1)
      YMUF(1) = EMUF(IT)
C
C F2  LAYER MUF
C
C CALCULATE TRUE AND VIRTUAL HEIGHTS
      IF(IEDP) 170,175,175
  170 CALL GETHP(FX2,HP2,HT2)
      GO TO 180
C.....PARABOLIC E AND F2 LAYERS
  175 HT2 = HI(3,KS) - YI(3,KS) + YI(3,KS)*(1.-SQRT(1.-XT2*XT2))
      IF(FI(2,KS)) 176, 176, 170
  176 HP2 = HI(3,KS) - YI(3,KS) + BENDY(3,KS,FX2)
     A       +( PEN(1,KS,FX2) - 2.*YI(1,KS) )
  180 CONTINUE
      DEL2 = AMAX1(0.0,AMIND)
      DEL = DEL2 * D2R
      PHE=ASIN(RZ*COS(DEL)/(RZ+HP2))
      NHOPS = .5 * GCDKM / ((PIO2 - DEL - PHE) * RZ)
      XHOPS=NHOPS+1
      PSI=GCDKM/((2.*RZ)*XHOPS)
      CPSI = COS(PSI)
      SPSI = SIN(PSI)
C  DEL2 IS TOO SMALL.
      TANP = SPSI / (1. - CPSI + HP2 / RZ)
      PHE = ATAN(TANP)
      DEL = PIO2 - PHE - PSI
      CDEL = COS(DEL)
      SPHE = RZ*CDEL/(RZ+ HT2)
      SECP = 1./SQRT(1.-SPHE*SPHE)
      FOB1 = FX2 * SECP
      NTRY = 0
      FOB2 = FOB1
      XHP = (HP2 - HT2) / RZ
c-------------fjr-------------------------begin iteration for F2MUF, HPX2
c-------------fjr----------allows 4 tries to obtain epsilon of 0.1
  190 CONTINUE
      FOB1 = FOB2
C.....CORRECTION TO MARTYN"S THEOREM
      XMUT = SPHE*SPHE
      XFSQ=  FOB1*FOB1/( FI(3,KS)*FI(3,KS) )
      SPH = XFSQ *XMUT*XHP*(HT2 + 2.*(RZ + HT2)*XHP)
c.....SPH=amin1(SPH,60.)
C  CORRECTED VIRTUAL HEIGHT.
      HPX2 = HP2 + SPH
      TANP = SPSI / (1. - CPSI + HPX2 / RZ)
      PHE = ATAN(TANP)
      DEL = PIO2 - PHE - PSI
      CDEL = COS(DEL)
      SPHE = RZ*CDEL/(RZ+ HT2)
      SECP = 1./SQRT(1.-SPHE*SPHE)
      FOB2 = FX2* SECP
      HPX1 = HPX2
      NTRY = NTRY +1
      IF(IAND(INFO,8).GT.0)THEN
        WRITE(99,'(A,I2,3(A,F8.2))')' "CURMUF"  F2-LAYER  NTRY=',NTRY,
     1  '  HP=',HP2,'  MARTYN CORR=',SPH,'  FOB=',FOB2
      ENDIF
C.....CORRECTION TO HPX2 IS SUFFICIENT
      IF( ABS(FOB2-FOB1) - FQDEL )  200,200,195
  195 IF(NFQ - NTRY)  200,190,190
c-------------------------fjr---------------end iteration for F2MUF, HPX2
  200 F2MUF(IT) = FOB2
      DEL2 = DEL * R2D
C.....MULTIPLY BY ANY VALUE LESS THAN ONE
      FREQ = .9* F2MUF(IT)
C.....OBTAIN THE F2 MUF DISTRIBUTION FROM THE F2 M(3000) TABLES
      DUMMY1 = F2MUF(IT)
c>>>>>A.S.
      DUMMY2 = CLAT(LX(KS))
      DUMMY3 = CLCK(LX(KS))
c<<<<<       
      CALL F2DIS(DUMMY1,SSN,DUMMY2,FREQ,DUMMY3,SIG)
      SIGL(3) = AMAX1( 0.01,SIG)
      FREQ = 1.1 * F2MUF(IT)
      DUMMY1 = F2MUF(IT)
c<<<<<       
      DUMMY2 = CLAT(LX(KS))
      DUMMY3 = CLCK(LX(KS))
c<<<<<       
      CALL F2DIS(DUMMY1,SSN,DUMMY2,FREQ,DUMMY3,SIG)
      SIGU(3) = AMAX1(0.01, SIG)
      DELMUF(3)= DEL2
      HPMUF(3) = HPX2
      HTMUF(3) = HT2
      FVMUF(3) = FX2
      AFMUF(3) = 0.0
      NHOPMF(3) = XHOPS
      YFOT(3) = F2MUF(IT) - 1.28 *SIGL(3)
      YMUF(3)  = F2MUF(IT)
      YHPF(3) = F2MUF(IT) + 1.28 *SIGU(3)
      IF( FI(2,KS) ) 210,210,215
C.....SET F1 TO E WHEN THERE IS NO F1 PRESENT
  210 F1MUF(IT) = EMUF(IT)
      SIGL(2)  = +SIGL(1)
      SIGU(2)  = +SIGU(1)
      DELMUF(2) = DELMUF(1)
      HPMUF(2) =  HPMUF(1)
      HTMUF(2) =  HTMUF(1)
      FVMUF(2) =  FVMUF(1)
      AFMUF(2) =  AFMUF(1)
      NHOPMF(2)=  NHOPMF(1)
      YFOT(2)  =  YFOT(1)
      YMUF(2)  = YMUF(1)
      YHPF(2)  =  YHPF(1)
      GO TO 240
C
C  F1 LAYER MUF
C
  215 CONTINUE
      CALL GETHP(FX1,HP1,HT1)
      DEL1 = AMAX1(0.0,AMIND)
      DEL  = DEL1 * D2R
      PHE=ASIN(RZ*COS(DEL)/(RZ+HP1))
      NHOPS = .5 * GCDKM / ((PIO2 - DEL - PHE) * RZ)
      PSI = GCDKM/(2.*RZ)
      XHOPS=NHOPS+1
      PSI=PSI/XHOPS
      CPSI= COS(PSI)
      SPSI = SIN(PSI)
      TANP = SPSI / (1. - CPSI + HP1 / RZ)
      PHE = ATAN(TANP)
      DEL = PIO2 - PHE - PSI
      CDEL = COS(DEL)
      SPHE = RZ*CDEL/(RZ+ HT1)
      SECP = 1./SQRT(1.-SPHE*SPHE)
      FOB1 = FX1 * SECP
      NTRY = 0
      FOB2 = FOB1
      XHP = (HP1 - HT1) / RZ
c-------------fjr-------------------------begin iteration for F1MUF, HPF1
c-------------fjr----------allows 4 tries to obtain epsilon of 0.1
  225 CONTINUE
      FOB1 = FOB2
      XFSQ = FOB1*FOB1 / ( FI(2,KS)*FI(2,KS)  )
      XMUT = SPHE*SPHE
      SPH = XFSQ*XMUT*XHP*(HT1 + 2.*(RZ + HT1)*XHP)
c.....SPH=amin1(SPH,60.)
      HPY2 = HP1 + SPH
      TANP = SPSI / (1. - CPSI + HPY2 / RZ)
      PHE = ATAN(TANP)
      DEL = PIO2 - PHE - PSI
      CDEL = COS(DEL)
      SPHE = RZ*CDEL/(RZ + HT1)
      SECP = 1. / SQRT(1. - SPHE * SPHE)
      FOB2 = FX1 *SECP
      NTRY = NTRY +1
      HPY1 = HPY2
      IF(IAND(INFO,8).GT.0)THEN
        WRITE(99,'(A,I2,3(A,F8.2))')' "CURMUF"  F1-LAYER  NTRY=',NTRY,
     1  '  HP=',HP1,'  MARTYN CORR=',SPH,'  FOB=',FOB2
      ENDIF
      IF( ABS(FOB2-FOB1) - FQDEL)  235,235,230
  230 IF(NFQ - NTRY)  235,225,225
c-------------------------fjr---------------end iteration for F1MUF, HPF1
  235 F1MUF(IT) = FOB2
      DEL1 = DEL * R2D
      SIGL(2) = AMAX1(0.01, 0.1*F1MUF(IT) )
      SIGU(2) = SIGL(2)
      DELMUF(2)= DEL1
      HPMUF(2) = HPY2
      HTMUF(2) = HT1
      FVMUF(2) = FX1
      AFMUF(2) = 0.0
      NHOPMF(2)= XHOPS
      YFOT(2) = F1MUF(IT) - 1.28*SIGL(2)
      YMUF(2) = F1MUF(IT)
      YHPF(2) = F1MUF(IT) + 1.28*SIGU(2)
  240 CONTINUE
C
C  SPORADIC E MUF, PROB. OF REFLECTION = 0.5.
C
      DELS = AMAX1(0.0, AMIND)
      ESMUF(IT) = 1000.
      DO 270 K=1,KM
      IF(FS(2,K)) 270,270,260
  260 CONTINUE
      DEL = DELS * D2R
      PHE = ASIN(RZ * COS(DEL) / (RZ + HS(K)))
      NHOPS = .5 * GCDKM / ((PIO2 - DEL - PHE) * RZ)
      HOP = NHOPS + 1
      PSI  = 0.5* GCD/HOP
      TDEL = (COS(PSI) - RZ/(RZ+HS(K)))/ SIN(PSI)
      CDEL = 1. / SQRT(1. + TDEL * TDEL)
      SPHE = RZ * CDEL / (RZ + HS(K))
      SECP = 1. / SQRT(1. - SPHE * SPHE)
      ESD = FS(2,K) * SECP
      IF( ESMUF(IT) -ESD)  270,270,265
  265 ESMUF(IT) = ESD
      KSX = K
      TDELX = TDEL
      SECPX =SECP
  270 CONTINUE
      IF(ESMUF(IT) - 1000.) 272,271,271
  271 DELMUF(4) = 0.0
       HPMUF(4) = 0.0
      HTMUF(4) = 0.0
       FVMUF(4) = 0.0
       AFMUF(4) = 0.0
      NHOPMF(4) = 0.0
       YFOT(4) = 0.0
      YMUF(4) = 0.0
       YHPF(4) = 0.0
       SIGL(4) = 0.0
       SIGU(4) = 0.0
       ESMUF(IT) = 0.0
       GO TO 274
  272 CONTINUE
      DELMUF(4) = ATAN(TDELX) * R2D
      HPMUF(4) = HS(KSX)
      HTMUF(4) = HPMUF(4)
      FVMUF(4) = FS(2,KSX)
      AFMUF(4) = 0.0
      NHOPMF(4) = HOP
      YMUF(4) = ESMUF(IT)
C.....FS IS ES OR E CRITICAL FREQUENCY
      XES = FI(1,KS) - FS(1,KSX)
      ZDIF = 0.1
      FZERO = 0.1
C.....UPPER STANDARD DEVIATION (LOWER FROM MAPS)
      SIGU(4) = ( FS(3,KSX) - FS(2,KSX))/ 1.28
      SIGB    = ( FS(2,KSX) - FS(1,KSX))/ 1.28
      SIGZ    = ( FS(2,KSX) - FZERO)/3.1
C.....MAXIMUM LOWER - WANT PROB .GT. .001 FOR F .GT. FZERO
      IF( XES +ZDIF) 315,320,320
C.....IF LOWER DECILE IS A REGULAR E USE THE UPPER DECILE
  315 SIGL(4) = SIGB
      GO TO 335
  320 IF(XES - ZDIF)  325,330,330
  325 SIGL(4) = SIGB + ((XES+ZDIF)/(2.* ZDIF)) * (SIGU(4) - SIGB)
      GO TO 335
  330 SIGL(4) = SIGU(4)
C.....IF UPPER DECILE IS TO LARGE RESET TO LOWER DECILE
  335 SIGL(4) = AMIN1(SIGL(4), SIGZ)
      FS(1,KSX) = FS(2,KSX) - 1.28* SIGL(4)
C NOW DO  OBLIQUE CASE
      SIGL(4) = SIGL(4)* SECPX
      SIGU(4) = SIGU(4) * SECPX
      YFOT(4) = ESMUF(IT) - 1.28 * SIGL(4)
      YHPF(4) = ESMUF(IT) + 1.28 * SIGU(4)
  274 CONTINUE
C
C  CIRCUIT MUF
C
C.....NOTE THAT ES IS NOT INCLUDED HERE
      FOT(IT) = AMAX1(YFOT(1),YFOT(2),YFOT(3) )
      ALLMUF(IT)  = AMAX1(EMUF(IT),F1MUF(IT), F2MUF(IT) )
      HPF(IT)    = AMAX1(YHPF(1),YHPF(2),YHPF(3))
      IF(EMUF(IT)- ALLMUF(IT))  280,275,275
  275 ANGMUF(IT) = DELMUF(1)
      MODMUF = 1
      GO TO 295
  280 IF(F1MUF(IT) - ALLMUF(IT))  290,285,285
  285 ANGMUF(IT) = DELMUF(2)
      MODMUF = 2
      GO TO 295
  290 ANGMUF(IT) = DELMUF(3)
      MODMUF = 3
  295 CONTINUE
      RETURN
      END
C--------------------------------

C SUBROUTINE COLL             (NEXT)
      SUBROUTINE COLL (SUM) 
C 
C     COLL - CALCULATES THE MUTUAL IMPEDANCE BETWEEN COLINEAR DIPOLE
C        ELEMENTS OF EQUAL LENGTHS. 
C     SEE REFERENCES IN SUBROUTINE GAIN AND ALSO THE ARTICLE BY 
C     H.E. KING, IRE TRANS. ANT. AND PROP., JULY 1957, P 306. 
C 
      COMPLEX CSU1, CSU3, CSV2, CSZ1, SUM, ZE 
C 
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RO, VOFL 
C 
      COMMON /CUR /DIJ, EIL, HIJ, KODE
C 
C.......................................................................
      UZ = PI2 * 2.0 * (HIJ - EIL)
      U1 = PI2 * 2.0 * HIJ
      V2 = PI2 * 2.0 * (HIJ + 2.0 * EIL)
      U3 = PI2 * 2.0 * (HIJ + EIL)
      V4 = PI2 * 2.0 * (HIJ + 3.0 * EIL)
      CSU1 = CSZ1 (U1)
      CSV2 = CSZ1 (V2)
      CSU3 = CSZ1 (U3)
      HLOG = ALOG (HIJ / (HIJ + EIL)) 
      H2LOG = ALOG ((HIJ + 2. * EIL) / (HIJ + EIL)) 
      T = PI2 * (HIJ - EIL) 
      ZE = CMPLX (COS (T), SIN (T)) 
      SUM = ZE * (CSZ1 (UZ) - CSU1) + CONJG (ZE) * ALOG (HIJ / (HIJ - EI
     1L)) 
      T = PI2 * (HIJ + EIL) 
      ZE = CMPLX (COS (T), SIN (T)) 
      SUM = SUM + ZE * (CSU3 - CSV2) + CONJG (ZE) * H2LOG 
      SUM = SUM + ZE * ( - CSU1 + CSU3) + CONJG (ZE) * HLOG 
      T = PI2 * (HIJ + 3.0 * EIL) 
      ZE = CMPLX (COS (T), SIN (T)) 
      SUM = SUM + ZE * ( - CSV2 + CSZ1 (V4)) + CONJG (ZE) * ALOG ((HIJ +
     1 2.0 * EIL) / (HIJ + 3.0 * EIL))
      TS = 2.0 * COS (PI2 * EIL)
      T = PI2 * HIJ 
      ZE = CMPLX (COS (T), SIN (T)) 
      SUM = SUM + TS * ZE * ( - CSU1 + CSU3) + TS * CONJG (ZE) * HLOG 
      T = PI2 * (HIJ + 2.0 * EIL) 
      ZE = CMPLX (COS (T), SIN (T)) 
      SUM = SUM + TS * ZE * (CSU3 - CSV2) + TS * CONJG (ZE) * H2LOG 
      IF (KODE .GT. 0) GO TO 100
      SUM = SUM * 15.0
      GO TO 105 
 100  SUM = SUM * 30.0 / (1.0 - COS (2.0 * PI2 * EIL))
 105  RETURN
      END 

      program foF2binw     !  for Salford FTN77 windows version
c          convert foF2CCIR.asc to direct access file:foF2CCIR.daw
c          convert foF2URSI.asc to direct access file:foF2URSI.daw
c          convert foF2daly.asc to binary        file:foF2dalw.bin
c**********************************************************************
      dimension XF2COF(13,76,2)
      character coeff(2)*4,title*80
      character (len=128) :: filein, fileout = ''
      data coeff/'CCIR','URSI'/
c**********************************************************************
c**********************************************************************
c     Modified to accept an (optional) arguement specifying 
c     the directory containing the .asc files.
      character (len=128) :: working_dir=''
      if (COMMAND_ARGUMENT_COUNT() == 1) then
         call GET_COMMAND_ARGUMENT(1, working_dir)
         working_dir = trim(working_dir)//"/"
      endif 
c**********************************************************************
      do 200 icoeff=1,2
      filein=trim(working_dir)//'fof2'//coeff(icoeff)//'.asc'
      fileout=trim(working_dir)//'fof2'//coeff(icoeff)//'.daw'
      open(19,file=filein,status='old')
      rewind(19)
      read(19,'(a)') title
      open(20,file=fileout,form='unformatted',access='direct',recl=7904)
      write(*,101) trim(fileout),trim(filein),trim(title)
101   format(' Creating:',a,' from:',a,' title=',a)
      do 100 month=1,12
      read(19,1) mon
1     format(6x,i2)
      if(mon.ne.month) stop 'month record does not match'
      read(19,3) XF2COF
3     format(6e15.8)
      write(20,rec=month) XF2COF
100   continue
      close(20)
200   close(19)
c********************************************************************
c          now create the daily foF2 binary coefficient file
      write(*,'('' Creating:fof2dalw.bin  from:fof2daly.asc'')')
      OPEN (21,FILE=trim(working_dir)//"fof2daly.asc",STATUS='OLD')
      REWIND(21)
      OPEN (22,FILE=trim(working_dir)//"fof2dalw.bin",form='unformatted')
      REWIND(22)
      read(21,'(a)') title
      write(*,'(1x,a)') title(1:70)
      DO 10 KFOF2R=1,9
      read(21,'(a)') title
      write(*,'(1x,a)') title(1:70)
c*****Modified to an unformatted read to avoid eof problems in with 
c*****some compliers.
      READ (21,*) XF2COF
10    write(22) xf2cof
c11    format(6(e12.6,1x))
      close(22)
      close(21)
c********************************************************************
      STOP 'foF2 BINARY COEFFICIENTS created'
      END

c###serprb.for
      SUBROUTINE SERPRB(IF)
C--------------------------------
C
C     THIS ROUTINE FINDS THE SERVICE PROBABILITY
C
C     THIS ROUTINE HAS NOT BEEN REVISED TO USE SUMMED SIGNAL
C     TLLOW(IM) = DBLOSL(IF)
C     SN(IM) = SNDB(IF)
C     TLHGH(IM) = DBLOSU(IF)
C     IM = IF
C     DO ONLY ONCE FOR IF
C
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SYGU,SYGL,KJ,JK
      COMMON / CON / D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
      COMMON / allMODE /ABPS(20),CREL(20),FLDST(20),HN(20),HP(20),
     1PROB(20),RELY(20),RGAIN(20),SIGPOW(20),SN(20),
     2SPRO(20),TGAIN(20),TIMED(20),TLOSS(20),B(20),FSLOS(20),
     3grlos(20),adv(20),obf(20),
     CNMODE(20),TLLOW(20),TLHGH(20),EFF(20),NREL,NMMOD
      DIMENSION TME(10),d10sa(20),d50sa(20)
C.....NORMAL DISTRIBUTION
      DATA TME/0.0,0.1257,0.2533,0.3853,0.5244,0.6745,0.8416,1.0364
     A , 1.2815, 1.6449 /
C.....DR IS THE PREDICTION ERROR IN RSN, REQUIRED SNR
      DATA DR/2./
      SPR = 0.0
C.....LUFP IS THE REQUIRED RELIABILITY
      ITM = IABS( LUFP - 50) /5 +1
      ITM = MIN0(ITM,10)
      TMX = TME(ITM)
C.....BEGINNING OF FINDING THE SERVICE PROBABILITY FOR EACH MODE
      DO 145 IM = 1,NMMOD
      IF(HP(IM).le.70.) then     !  set default for no mode
         SPRO(IM) = .001
         d10sa(im)=0.
         d50sa(im)=0.
         GO TO 145
      end if
      IF(LUFP.ge.50) then
         DN  = TMX *DU/DCL                !  DN is the noise
         DS  = TMX *TLLOW(IM)/DCL         !  DS is the signal
         XLH = -1.
C.....SIGNAL PREDICTION ERROR
         DSO = TMX *SUS
         DNO = TMX * SYGU/DCL
      else
         DN  = TMX *DL/DCL                !  DN is the noise
         DS  = TMX *TLHGH(IM)/DCL         !  DS is the signal
         XLH = 1.
         DSO = TMX * SLS
         DNO = TMX *SYGL/DCL
      end if
C.....D10S IS THE LOWER DECILE
C.....D50S IS THE MEDIAN
C.....D90S IS THE UPPER DECILE
      D50Sa(im)= SQRT(DN*DN + DS*DS)
      D10Sa(im)= D50Sa(im) + 
     +        SQRT(SIGM*SIGM + ADS*ADS + DNO*DNO + DSO*DSO + DR*DR)
      D50Sa(im) =  SN(IM)  + XLH*D50Sa(im)
      Z = (RSN - D50Sa(im))/d10sa(im)
C.....SERVICE PROBABILITY FOR THIS MODE
      SPRO(IM) =  1. - FNORML(Z)
  145 CONTINUE
C.....END OF FINDING THE SERVICE PROBABILITY FOR EACH MODE
C
C.....USE THE MAXIMUM
      AMXX=-1000.
      imax=1
      DO 150 I=1,NMMOD
      IF(SPRO(I).GT.SPRO(imax)) imax=i
  150 CONTINUE
      SPROB(IF)=SPRO(imax)
      D10S=d10sa(imax)
      D50S=d50sa(imax)
      D90S=D10S
      RETURN
      END
C--------------------------------

      subroutine getTR(tlat,tlon,rlat,rlon)
      INCLUDE 'ficepac.hdr'
      character cdeg*10

      cdeg=tlatdeg
      nch=10
      call rblankc(cdeg,nch)
      call chardeg(cdeg,0,tlat,ierr)
      cdeg=tlondeg
      nch=10
      call rblankc(cdeg,nch)
      call chardeg(cdeg,1,tlon,ierr)
      cdeg=rlatdeg
      nch=10
      call rblankc(cdeg,nch)
      call chardeg(cdeg,0,rlat,ierr)
      cdeg=rlondeg
      nch=10
      call rblankc(cdeg,nch)
      call chardeg(cdeg,1,rlon,ierr)
      return
      end

      subroutine rblankc(ialf,nch)   !  remove ALL blanks
      character ialf*(*),ich
      j=0
      nchold=nch
      do 10 i=1,nch
      ich=ialf(i:i)
      if(ich.eq.' ') go to 10
      j=j+1
      ialf(j:j)=ich
 10   continue
      nch=j
      if(nch.lt.nchold) ialf(nch+1:nchold)=' '
      return
      end

      SUBROUTINE DEG2CHR(DEGS,LATLON,CHAR)
C******************************************************************
C#  SUB DEG2CHR(DEGS,LATLON,CHAR)   Degrees to CHARACTER (xxxNxx'xx")
C          Convert degrees to characters for output.
C          DEGS = input degrees (may be -180 to 180  or  0 to 360)
C          LATLON=0= latitude   format xxxNxx'xx"
C                =1= longitude  format xxxExx'xx"
c                =2= latitude   format  xx.xxN
c                =3= longitude  format xxx.xxE
C          CHAR  = CHARACTER*10 output
C******************************************************************
      CHARACTER*(*) CHAR
      CHARACTER*1 NSEW
      DEG=DEGS
      IF(DEG.GT.180.) DEG=DEG-360.
      modd=mod(latlon,2)
      IF(modd.EQ.0 .AND. DEG.GE.0.) NSEW='N'
      IF(modd.EQ.0 .AND. DEG.LT.0.) NSEW='S'
      IF(modd.NE.0 .AND. DEG.GE.0.) NSEW='E'
      IF(modd.NE.0 .AND. DEG.LT.0.) NSEW='W'
      D=ABS(DEG)
      IDEG=D
      D=(D-IDEG)*60.
      MIN=D
      ISEC=(D-MIN)*60. + .5
      IF(ISEC.LT.60) GO TO 10
      ISEC=0
      MIN=MIN+1
      IF(MIN.LT.60) GO TO 10
      MIN=MIN-60
      IDEG=IDEG+1
10    if(latlon.le.1) then
         WRITE(CHAR,11) IDEG,NSEW,MIN,ISEC
11       format(i3,a1,i2,1h',i2,1h")
      else
         WRITE(CHAR,'(f6.2,a1)') abs(DEG),NSEW
      end if
      RETURN
      END

c###luffy.for
      SUBROUTINE LUFFY(IPFLAG)
C-------------------------------
C
C     LONG AND SHORT PATH SYSTEM PERFORMANCE AND LUFS.
C
C          IPFG        FUNCTION
C          ----        -----------------------------
C           100        SHORT PATH SYSTEM PERFORMANCE
C           200        LONG PATH SYSTEM PERFORMANCE
C           300        SHORT PATH LUF
C           400        LONG PATH LUF
C
      common /gh_ipfg/ ipfg
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SxGU,SxGL,KJ,JK
      common /cgains/ gaint(13),gainr(13)    !  transmitter & receiver gains
      common /sncom/ snxx(13)
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON / OUTLAB / LABEL(11), LAYTYP(5), IEAST, INORTH, ISOUTH,
     A IWEST, LABLI, LABLJ, LABLK
      CHARACTER IEAST*1, ISOUTH*1, INORTH*1, IWEST*1, LABEL*5, LAYTYP*2,
     A LABLI*5, LABLJ*5, LABLK*5
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24),FOT
     A (24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMUF(4)
     B ,HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     C ,YMUF(4)
      COMMON/SIGD/DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE,HNU
     A,HTLOSS,XNUZ,XVE
      COMMON /SSP /SUN (2, 12), MONTH
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON /TON /ADJ, ADS, GNOS, GOT, REL, SL, SLS
     1, SPR, SU, SUS, XNOISE,ZNOISE,NF
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON /MODES /GHOP, DELMOD (6, 3), HPMOD (6, 3), HTMOD (6, 3), FV
     1MOD (6, 3), ITMOD (6, 3), AFMOD (6, 3)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / allMODE /ABPS(20),CREL(20),FLDST(20),HN(20),HP(20),
     1PROB(20),RELY(20),RGAIN(20),SIGPOW(20),SN(20),
     2SPRO(20),TGAIN(20),TIMED(20),TLOSS(20),B(20),FSLOS(20),
     3grlos(20),adv(20),obf(20),
     CNMODE(20),TLLOW(20),TLHGH(20),EFF(20),NREL,NMMOD
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
C125PC      COMMON/INDICEZ/ISP,ISZ,IFQN,IUR,NMS(11,24,4,2)
      COMMON/INFORM/INFO,IHSHR,IHLNG
C125PC      COMMON/LPALMOT2/zACAV(24,4,2),zASM(24,4,2),zDSL(24,4,2),
C125PC     +zDSU(24,4,2),zYMUF(4,24,4,2),zYFOT(4,24,4,2),zYHPF(4,24,4,2),
C125PC     +zFVMUF(4,24,4,2),zSIGL(4,24,4,2),zSIGU(4,24,4,2)
CPC      COMMON/MAPS/VMAP(12,6,50,90),PNT(2,3),ILT,ILG,NLAT,NLON,IMAP
ccc      COMMON/MAPS/VMAP(3,3,45,50),PNT(2,3),ILT,ILG,NLAT,NLON,IMAP
C.....TEMPORARY STORAGE
      dimension xdbu(13,2),xreliab(13,2),xsndb(13,2),xsnpr(13,2),
     +xsnrlw(13,2),xsnrup(13,2),xsprob(13,2),yANGLE(13,2), yCPROB(13,2),
     +yDBLOS(13,2),yDBLOSL(13,2),yDBLOSU(13,2),yDELAY(13,2),
     +xprobmp(13,2),yDBW(13,2),iNHP(13,2),yVHIGH(13,2),zdu(13),zdl(13),
     +zangler(13),INMODe(13)
      dimension yrgain(13,2),ytgain(13,2)
      character*2 ymode(13,2),zmoder(13)
      CHARACTER XMDL*1
      CHARACTER MFLG(3)*3,ITF*1
      ITF=CHAR(12)
      IPFG=IPFLAG
      mspec_temp=mspec
ccc      write(luo,'('' In LUFFY('',2i5,'')  gcdkm='',2f10.2)') 
ccc     +      mspec,ipfg,gcdkm,gcd
      if(mspec.eq.121 .and. gcdkm.gt.10000.) ipfg=200   !  use long path method
      if(mspec.eq.121 .and. gcdkm.gt.10000.) mspec=0    !  beyond smoothing distance
ccc      write(luo,'('' In luffy('',2i5,'')  gcdkm='',2f10.2)') 
ccc     +      mspec,ipfg,gcdkm,gcd
      IF(IPFG.GT.200)THEN
C.......FREQUENCY COMPLEMENT
        CALL FRQCOM(FREA,0)
        PLUF = LUFP
C.......REQUIRED RELIABILITY
        PLUF = .01 * PLUF
      ENDIF
C.....SELECT CONTROLLING SAMPLE AREA
      CALL SELMOD
C  GET NOISE VALUE AT 1 MHZ  FOR RCVR SITE
      CALL ANOIS1
   83 IF((IPFG.EQ.100).OR.(IPFG.EQ.300))THEN
C.......SET FLAG TO INDICATE SHORT PATH MODEL
        JLONG = -1
        XMDL='S'
C.......SELECT SHORT PATH CONTROL AREA
        K = JMODE
      ELSE
C.......SET FLAG TO INDICATE LONG PATH MODEL
        JLONG = 1
        XMDL='L'
C.......SELECT LONG PATH TRANSMITTER AREA
        K=1
        ITXRCP(1)=1
        IF(MSPEC.EQ.121.AND.JMODE.EQ.K)GO TO 85             !  C121PC
C125PC        IF(MSPEC.EQ.125.AND.JMODE.EQ.K)GO TO 85
      ENDIF
C.....ELECTRON DENSITY PROFILE
   84 CALL LECDEN(K)
C.....IONOGRAM
      CALL GENION(K)
C.....REFLECTRIX TABLE
      CALL FOBBY(K)
C.....DEVIATION LOSS FACTOR
      CALL ALOSFV(K)
      IF((IPFG.EQ.100).OR.(K.GT.1))GO TO 87
C.....FIND LONG PATH RECEIVER INDEX
   85 K=KFX
      ITXRCP(2)=KFX
      IF(MSPEC.EQ.121.AND.JMODE.EQ.K)GO TO 87             !  C121PC
C125PC      IF(MSPEC.EQ.125.AND.JMODE.EQ.K)GO TO 87
      IF(KFX.EQ.1)THEN
        ITXRCP(2)=2
        GO TO 87
      ENDIF
      GO TO 84
C.....CAN RUN FOR SHORT PATHS ALSO
C.....SO SET ALL SAMPLE AREAS
   87 CALL SETLNG
C.....SET ABSORPTION LOSS PARAMETERS, ADJUST SIGNAL DISTRIBUTION TABLES
ccc      write(*,'(''before sigdis'')')
      CALL SIGDIS
C```````````````````````````````````````````````````````````````
C125SPLP      IF(MSPEC.EQ.125.AND.GCDKM.GE.7000.)THEN
C125SPLP        zacav(IUR,ISZ,ISP)=acav
C125SPLP        zasm(IUR,ISZ,ISP)=asm
C125SPLP        zdsl(IUR,ISZ,ISP)=dsl
C125SPLP        zdsu(IUR,ISZ,ISP)=dsu
C125SPLP        do 88 ILY=1,4
C125SPLP        zymuf(ILY,IUR,ISZ,ISP)=ymuf(ILY)
C125SPLP        zyfot(ILY,IUR,ISZ,ISP)=yfot(ILY)
C125SPLP        zyhpf(ILY,IUR,ISZ,ISP)=yhpf(ILY)
C125SPLP        zfvmuf(ILY,IUR,ISZ,ISP)=fvmuf(ILY)
C125SPLP        zSIGL(ILY,IUR,ISZ,ISP)=SIGL(ILY)
C125SPLP        zSIGU(ILY,IUR,ISZ,ISP)=SIGU(ILY)
C125SPLP   88   continue
C125SPLP      ENDIF
C-----------------------------------------------
      IHMIN=NHOPMF(1)
      IF(NHOPMF(2).GT.0.AND.NHOPMF(2).LT.IHMIN)IHMIN=NHOPMF(2)
      IF(NHOPMF(3).LT.IHMIN)IHMIN=NHOPMF(3)
      IHMX=NHOPMF(1)
      IF(NHOPMF(2).GT.0.AND.NHOPMF(2).GT.IHMX)IHMX=NHOPMF(2)
      IF(NHOPMF(3).GT.IHMX)IHMX=NHOPMF(3)
C-----------------------------------------------
C.....START FREQUENCY LOOP
      NHP   (13) = -1
      MDL(13)=xmdl
      do 90 IFX=1,12
   90 MDL(IFX)=' '
      DO 265 IFX=1,12
      IMAP=0                         !  force IMAP=0
ccc      IF(IMAP.GT.0.AND.IFX.GT.2)THEN
ccc        IF(IFX.LT.12)GO TO 265
ccc      ENDIF
      IPFG=IPFLAG
      IF(IPFG.LT.300)THEN
C.......PRESET IN COMMON/SON/
        NHP   (IFX) = -1
        SPROB(IFX)=.000
        PROBMP(IFX)=.000
        IF (FREL(IFX).le.0.) go to 265     !  no frequency 
        FREQ = FREL(IFX)
      ELSE
        FREQ=FREA(IFX)
        RELIAB(IFX)=0.0
      ENDIF
C--------------------------------------------------
        iflag=0
ccc        IFQN=IFX
        call allMODES(iflag,freq)
C125PC      ENDIF
C.....NOISE DISTRIBUTION
ccc      write(*,'(''before genois'')')
      CALL GENOIS
      IF((IPFG.EQ.100).OR.(IPFG.EQ.300))THEN
        IF(IHSHR.GT.0.OR.IAND(INFO,8).GT.0)THEN
          DO 121 ILI=1,3
  121     MFLG(ILI)='   '
          MFLG(MODMUF)='(*)'
          IF(IFX.EQ.1)WRITE(99,'(A1,/,10x,23hVCLS VERSION Short Path)')
          WRITE(99,'(/,1X,A10,A7,1X,A3,6H  SSN ,F4.0,F6.0,5H UT  ,F7.0,
     1    5H KM  ,F8.3,4H MHZ)')ITF,ITRAN,IMON(MONTH),SSN,GMT,GCDKM,FREQ
          WRITE(99,'(A,3(A3,I1,A2,1H=,F7.2,2X),/,1X,66(1H=))')
     1    '  CIRCUIT(*) MUFS   ',(MFLG(IL),NHOPMF(IL),LAYTYP(IL),
     2    YMUF(IL),IL=1,3)
        ENDIF
C.......RAY SET TABLE
        CALL FINDF(K)
        IF( DMAXKM(K) ) 122,122,123
  122   IF(IPFG.EQ.300)then
          go to 265
        else
C-----------------------------------------------
C.......ONLY ONE OVER THE MUF MODE
C??????????????????????????????????????????
          IHSRT = IHMIN
          IHSTP = IHMIN
        ENDIF
        GO TO 124
C.......UP TO THREE HOPS
  123   IHSRT = GCDKM/DMAXKM(K) + 1.
        IHMAX = GCDKM/DSKPKM(K)
        IF(IHSRT.LT.IHMIN)IHSRT = IHMIN
        IF(IHMAX.LT.IHSRT)IHMAX = IHSRT
        IHSTP =MIN0(IHMAX,IHSRT+2)
        IF(IHSRT.GT.IHMIN)IHSRT=MAX0(IHMIN,IHSTP-2)
C-----------------------------------------------
  124   IXHP = 0
C.......HOP LOOP
      IF(IAND(INFO,1).GT.0)THEN
      WRITE(99,'(A,4I3,3F8.2)')'  IHMIN,IHMAX,IHSRT,IHSTP,DMAX,DSKP,DKM'
     1,IHMIN,IHMAX,IHSRT,IHSTP,DMAXKM(K),DSKPKM(K),GCDKM
      ENDIF
ccc      write(*,'(''before do 262'')')
        DO 262 IHOP = IHSRT, IHSTP
        IXHP = IXHP + 1
        HOP = IHOP
C.......HOP DISTANCE
ccc       write(*,'(''ihop,gcd='',i5,f10.2)') ihop,gcd
        GHOP = GCD/HOP
C.......FIND UP TO SIX MODES
        CALL FDIST(IHOP,K,NUMMOD)
        CALL INMUF(IHOP,NUMMOD)
C.......SAVE ALL MODES AVAILABLE
        CALL ALLMODES(IPFG,HOP)
        IF(IHSHR.GT.0)THEN
          WRITE(99,'(1x,66(1h-))')
        ENDIF
  262   CONTINUE
ccc      write(*,'(''after  do 262'')')
C.......END OF THE HOP LOOP
C.......UP TO 2 ES MODES
        CALL ESMOD
C.......ONE ES - F MODES
        CALL ESREG
        IF(IAND(INFO,8).GT.0)THEN
          WRITE(99,'(1x,66(1h-))')
        ENDIF
        FVAL=999.
C125SPLP        IF(MSPEC.EQ.125.AND.GCDKM.GE.7000.)FVAL=990.
        CALL ALLMODES(2,FVAL)
      ELSE
        IF(IHLNG.GT.0)THEN
          IF(IFX.EQ.1)WRITE(99,'(A1,/,10x,22hVCLS VERSION LONG Path)')
     1    ITF
          DO 263 ILI=1,3
  263     MFLG(ILI)='   '
          MFLG(MODMUF)='(*)'
          WRITE(99,'(/,1X,A10,A7,1X,A3,6H  SSN ,F4.0,F6.0,5H UT  ,F7.0,
     1    5H KM  ,F8.3,4H MHZ)')ITRAN,IMON(MONTH),SSN,GMT,GCDKM,FREQ
          WRITE(99,'(A,3(A3,I1,A2,1H=,F7.2,2X),/,1X,66(1H=))')
     1    '  CIRCUIT(*) MUFS   ',(MFLG(IL),NHOPMF(IL),LAYTYP(IL),
     2    YMUF(IL),IL=1,3)
        ENDIF
C.......AREA COVERAGE, TRANSMITTER END
        CALL FINDF(ITXRCP(1))
C.......AREA COVERAGE, RECEIVER END
        CALL FINDF(ITXRCP(2))
C.......GAIN MINUS LOSS
        CALL GMLOSS
C125SPLP        IF(MSPEC.EQ.125)THEN
C125SPLP          CALL ALLMODES(ipfg,999.)
C125SPLP          GO TO 265
C125SPLP        ENDIF
C````````````````````````````````````````````````````````````````````````
C.......SELECT OPTIMUM AT TRANSMITTER/RECEIVER ENDS
        CALL SELTXR
C.......DO MODE CALCULATIONS
ccc      write(luo,'(''calling LNGPAT'')')
        CALL LNGPAT
        IF(IHLNG.GT.0)THEN
          WRITE(99,'(1x,66(1h-))')
        ENDIF
      ENDIF
C125PC      IF(MSPEC.EQ.125)GO TO 265
C.....COMBINED RELIABILITY
ccc      write(*,'(''before genois2'')')
      call genois
ccc      write(luo,'(''before relbil'')')
      call relbil(IFX,freq)
      IF(IPFG.LT.300)THEN
C.......CHECK TO SEE IF SERVICE PROBABILITIES ARE TO BE OUTPUT
        IF( LINBOT(14) ) 285,285,280
C.......CALCULATE SERVICE PROBABILITIES
  280   CALL SERPRB(IFX)
  285   CONTINUE
        IF(IPFG.EQ.100)THEN
C.........CALCULATE MULTIPATH
          CALL MPATH(IFX)
        ELSE
C.........SET RECEIVER END
          IS = NMODE(2)
          MODER(IFX) = LAYTYP(IS)
          ANGLER(IFX)=B(2)
        ENDIF
C.......normal ALL MODE OUTPUT
        CALL OUTALL(IFX)
      ELSE
C.......TEST RELIABILITY
        IF(RELIAB(IFX).GE.PLUF)GO TO 165
      ENDIF
C121PC      ******************************************************
ccc      write(luo,'(''before IF, mspec,ipflag='',2i5)') mspec,ipflag
ccc      write(luo,'(''angle('',i2,'')='',2f10.3)') 
ccc     +        ifx,angle(ifx),dblos(ifx)
      IF(MSPEC.EQ.121)THEN
        idx=(ipflag+1)/100
ccc        idx=(ipfg+1)/100
ccc      write(luo,'(''ifx,idx,ipflag,ipfg='',4i5)') ifx,idx,ipflag,ipfg
        yangle(IFX,idx)=angle(IFX)
        ycprob(IFX,idx)=cprob(IFX)
        ydblos(IFX,idx)=dblos(IFX)
        ydblosl(IFX,idx)=dblosl(IFX)
        ydblosu(IFX,idx)=dblosu(IFX)
        ydelay(IFX,idx)=delay(IFX)
        ydbw(IFX,idx)=dbw(IFX)
        inhp(IFX,idx)=nhp(IFX)
        yvhigh(IFX,idx)=vhigh(IFX)
        ymode(IFX,idx)=mode(IFX)
        xdbu(IFX,idx)=dbu(IFX)
        xreliab(IFX,idx)=reliab(IFX)
        xsndb(IFX,idx)=sndb(IFX)
        xsnpr(IFX,idx)=snpr(IFX)
        xsnrlw(IFX,idx)=snrlw(IFX)
        xsnrup(IFX,idx)=snrup(IFX)
        xsprob(IFX,idx)=sprob(IFX)
        xprobmp(IFX,idx)=probmp(IFX)
        ytgain(ifx,idx)=tgain(1)
        yrgain(ifx,idx)=rgain(1)
ccc        write(luo,'('' saving gains('',2i3,2h)=,5f10.4)') 
ccc     +    ifx,idx,tgain(1),rgain(1),angle(ifx)!  ,tgain(ifx),rgain(ifx)
ccc      if(ipflag.eq.200) write(luo,1234) du,dl,angler(ifx)
ccc1234  format('ipflag=200=',3f10.3)
       
        IF(IPFLAG.EQ.200)THEN
C.........SAVE LONG PATH PARAMETERS
          ZDU(IFX)=DU
          ZDL(IFX)=DL
          INMODE(IFX)=NMODE(1)
ccc      write(luo,'(''save long path='',i5,f10.3)') ifx,angler(ifx)
          zangler(IFX)=angler(IFX)
ccc          ZRGAIN(IFX)=RGAIN(1)
          zmoder(IFX)=moder(IFX)
        ENDIF
      ENDIF
ccc      write(*,'(''before 265'')')
C121PC      ******************************************************
  265 CONTINUE
C.....END OF FREQUENCY LOOP
ccc      IF(IMAP.GT.0)THEN
cccC.......IF IMAP SAVE DATA
ccc        VMAP(JTX,3,ILT,ILG)=ALLMUF(IT)
ccc        DO 266 IF=1,2
ccc        IF(FREL(IF).GT.0.)THEN
ccc          VMAP(JTX,IF,ILT,ILG)=RSN-SNPR(IF)
ccc        ENDIF
ccc  266   CONTINUE
ccc        RETURN
ccc      ENDIF
C.....IF ALLMODES AND DIST GT 7000 RECYCLE TO CALCULATE LONG PATH MODEL
C125PC      if(MSPEC.eq.125)THEN
C125SPLP        IF(GCDKM.GE.7000..AND.IPFLAG.EQ.100)THEN
C125SPLP          IPFLAG=200
C125SPLP          IPFG=200
C125SPLP          GO TO 83
C125SPLP        ENDIF
C ADD IAND(INFO,16) HERE, IF L/S OUTPUT DESIRED FOR MSPEC 125
C125PC        RETURN
C125PC      ENDIF
      IF(method.eq.25) go to 999    !  done
      IF(IPFG.ge.300) go to 300
C121PC  ************************************************************
c           Smoothing ONLY for distances  7000 - 10000 km
        IF(MSPEC.ne.121) go to 999    !  done
ccc      write(luo,'(''smoothing?'',f10.2)') gcdkm
        IF(gcdkm.lt.7000.) go to 999   !  done
        IF(gcdkm.gt.10000.) go to 999  !!  why was this commented out?
c.........Do LONG and Short Path Model
          if(IPFLAG.EQ.100)THEN
            IPFLAG=200
            IPFG=200
ccc            call outlin
            GO TO 83
          ENDIF
ccc            call outlin
c...........Use LONG Path/Short Path Smoothing From VOA Memo  15 Jan 1991
            MDL(13)='M'
ccc      write(luo,111)
ccc111   format(' Path     gcdkm      if  Freq    ydbw    ',
ccc     +       'ydblosl   s?pld   delpow')
            DO 290 IF=1,12
            mdl(if)=' '
            freq=frel(if)
            if(freq.le.0.)go to 290
            SLpld=YDBW(IF,2)-abs(YDBLOSL(IF,2))   !  abs added 9/14/94 per VOA
            SSpld=YDBW(if,1)-abs(YDBLOSL(if,1))   !  abs added 9/14/94 per VOA
            Delpow=slpld-sspld
ccc      write(luo,112) gcdkm,if,freq,ydbw(if,1),ydblosl(if,1),sspld,delpow
ccc112   format(' Short=',f10.2,i5,f7.3,4f9.3)
ccc      write(luo,113)               ydbw(if,2),ydblosl(if,2),slpld
ccc113   format(' Long =',22x,3f9.3)

ccc            if(delpow.lt.0. .and. gcdkm.le.10000.)then
c          for distances > 10000km, use higher signal level
            if(delpow.lt.0.)then
C.............Use short path
              idx=1
              mdl(if)='S'
              moder(if)=ymode(if,1)
              angler(if)=yangle(if,1)
              tgain(if)=ytgain(IF,1)
              rgain(if)=yrgain(IF,1)
              gaint(if)=tgain(if)      !  this is what is really printed
              gainr(if)=rgain(if)      !  this is what is really printed
              snxx(if)=RSN - xsnpr(if,1)   !  save short path for printing
ccc              write(luo,'('' short smoothing gains='',2f10.4,i5)') 
ccc     +                   tgain(if),rgain(if),if
            else
C.............Use LONG Path or Use Smoothing if Dist LT 10000
              idx=2
              mdl(if)='L'
              moder(if)=zmoder(if)
              angler(IF)=zangler(if)
              du=ZDU(IF)
              dl=ZDL(IF)
              B(1)=yangle(if,2)
              Tllow(1)=ydblosl(if,2)
              Tlhgh(1)=ydblosu(if,2)
              Timed(1)=ydelay(if,2)
              hn(1)=inhp(if,2)
              hp(1)=yvhigh(if,2)
              PROB(1)=YCPROB(IF,2)
              nmode(1)=INMODE(IF)
ccc              rgain(1)=ZRGAIN(IF)
              tgain(1)=ytgain(IF,2)
              rgain(1)=yrgain(IF,2)
ccc              write(luo,'('' long smoothing gains='',2f10.4,i5)') 
ccc     +                   tgain(1),rgain(1),if
              EFF(1)=RNEFF(if)
ccc      write(luo,'(''eff='',f10.3)') eff(1)
            ENDIF
            mode(if)=ymode(if,idx)
            angle(if)=yangle(if,idx)
            cprob(if)=ycprob(if,idx)
            dblos(if)=ydblos(if,idx)
            dblosl(if)=ydblosl(if,idx)
            dblosu(if)=ydblosu(if,idx)
            delay(if)=ydelay(if,idx)
            dbw(if)=ydbw(if,idx)
            nhp(if)=inhp(if,idx)
            RCNSE=XNYNOIS(if)
            vhigh(if)=yvhigh(if,idx)
            dbu(if)=xdbu(if,idx)
            reliab(if)=xreliab(if,idx)
            sndb(if)=xsndb(if,idx)
            snpr(if)=xsnpr(if,idx)
            snrlw(if)=xsnrlw(if,idx)
            snrup(if)=xsnrup(if,idx)
            sprob(if)=xsprob(if,idx)
            probmp(if)=xprobmp(if,idx)
            if(delpow.ge.0. .and. gcdkm.lt.10000.)then
ccc      write(*,'(''delpow>0  gcdkm<10000.'')')
c.............Use Smoothing From VOA Memo  15 Jan 1991
              mdl(if)='M'
              disint=(gcdkm-7000.)/3000.
ccc      write(*,'(''disint='',e15.7,f10.3)') disint,delpow
              if(delpow.gt.375.) then
                 delx=10.**37.5         !  avoid overflow problem
              else
                 delx=10.**(delpow/10.)
              end if
ccc      write(*,'(''delx='',e15.7)') delx
              Smooth=sspld+10.*alog10(disint*(delx-1.)+1.)
              sigpow(1)=smooth+tllow(1)
              TLOSS(1)=PWRDB(FREQ)-SIGPOW(1)
              sn(1)=sigpow(1)-RCNSE-EFF(1)
              fldst(1)=107.2+pwrdb(FREQ)+20.*alog10(freq)-TLOSS(1)-
     +                                                    rgain(1)
              NMMOD=1
              call genois
              CALL RELBIL(if,freq)
              IF( LINBOT(14).gt.0) CALL SERPRB(IF)
            ENDIF
            IF(IAND(INFO,16).GT.0)THEN
              IF(IF.EQ.1)WRITE(99,'(A1,/,10x,22hVCLS VERS L/S SMOOTHIN,
     1        1hG)')ITF
              WRITE(99,'(/,1x,66(1h=))')
              WRITE(99,291)FREQ,GCDKM,MDL(IF),SSPLD,SLPLD,
     1        (YDBW(IF,IP),IP=1,2),SMOOTH,SIGPOW(1)
  291         FORMAT(' "LUFFY"  FREQ=',F6.2,'   DIST=',F7.0,'   L/S PA',
     1       'TH MODEL= "',A1,'"',/,7X,'Short Path SIG L-Decile=',F6.2,
     2        5X,'LONG Path SIG L-Decile=',F6.2,/,7X,'Short Path SIG  ',
     3       'DBW=   ',F6.2,5X,'LONG Path SIG  DBW=    ',F6.2,/,7X,'Sm',
     4       'oothed SIG L-Decile= ',F6.2,5X,'Smoothed SIGPOW','=     ',
     5       '  ',F6.2)
              WRITE(99,'(1x,66(1h-))')
            ENDIF
  290       CONTINUE
C121PC  ************************************************************
        go to 999    !  done
C     NO LUF FOUND. ,FIND HIGHEST RELIABILITY AND QUIT.
300   IG =1
      REL = RELIAB(1)
      DO 160 IF = 2,12
      IF(RELIAB(IF).GT.REL) then     !  is this really correct or should the
         IG = IF                     !  test be RELIAB(IF).gt.RELIAB(IG)
      end if
  160 CONTINUE
      XLUF(IT) = -FREA(IG)
      FREA(13) =  FREA(IG)
      go to 999     !  done
c********************************************************
165   IF=IFX
      IF(IF.eq.1) then            !  1st frequency is good
         XLUF(IT) = FREQ
      else             !  NO ITERATION, SELECT THE FREQUENCY COMPLEMENT FIRST
         FLOW = FREA(IF-1)
         FHIGH= FREA(IF)
         RLOW = RELIAB(IF-1)
         RHIGH= RELIAB(IF)
         IF = 13
C.....USE LINEAR INTERPOLATION
         XLUF(IT) = FLOW + (FHIGH-FLOW)*(PLUF-RLOW)/(RHIGH-RLOW)
      end if
      FREA(13) = XLUF(IT)
999   mspec=mspec_temp
      RETURN
      END
C--------------------------------

C SUBROUTINE CMPINV           (NEXT)
      SUBROUTINE CMPINV (A, B, C, D, N) 
C 
C     CMPINV - COMPLEX MATRIX OPERATION THAT FINDS INVERSE, C+ID, OF
C        A+IB WHERE A,B,C, AND D ARE REAL SQUARE MATRICES.  CMPINV
C        CALLS MATINV TO INVERT REAL MATRICES AND SQMULT TO MULTIPLY
C        SQUARE MATRICES IN ORDER TO COMPUTE THE COMPLEX INVERSE
C                      C=INV(A + B*(INV(A))*B)
C                      D=-C*B*(INV(A))
C        A, B, C, AND D ARE ALL REAL N BY N MATRICIES.
C        IF A IS SINGULAR, EXCHANGE A AND B (FACTOR OUT I) AND TRY AGAIN
C     THIS ROUTINE IS SHARE NO. ANL F103 BY B.S.GARBOW OF ARGONNE 
C     NATIONAL LABORATORY, ARGONNE, ILLINOIS
C 
      DIMENSION A (20, 20), B (20, 20), C (20, 20), D (20, 20)
C 
      COMMON /PON /INDEX (20, 2), IPIVOT (20), PIVOT (20) 
C 
C.....INVERT -A.........................................................
      M = N 
      L = 1 
 100  IF (M .LT. 1) GO TO 160 
      DO 105 I = 1, M 
      IF (M .LT. 1) GO TO 165 
      DO 105 J = 1, M 
 105  D (I, J) = - A (I, J) 
 165  CONTINUE
 160  CONTINUE
      CALL MATINV (D, M)
C.....CHECK IF INV(-A) EXISTS (IF NOT GO TO 6)..........................
      IF (M .LT. 1) GO TO 170 
      DO 110 K = 1, M 
      IF (IPIVOT (K) .NE. 1) GO TO 125
 110  CONTINUE
 170  CONTINUE
C.....COMPUTE C=INV(A - B*(INV(-A))*B)..................................
      CALL SQMULT (B, D, D, M)
      CALL SQMULT (D, B, C, M)
      IF (M .LT. 1) GO TO 175 
      DO 115 I1 = 1, M
      IF (M .LT. 1) GO TO 180 
      DO 115 J1 = 1, M
 115  C (I1, J1) = A (I1, J1) - C (I1, J1)
 180  CONTINUE
 175  CONTINUE
      CALL MATINV (C, M)
C.....CHECK IF C EXISTS (IF NOT GO TO 300)..............................
      IF (M .LT. 1) GO TO 185 
      DO 120 K1 = 1, M
      IF (IPIVOT (K1) .NE. 1) GO TO 150 
 120  CONTINUE
 185  CONTINUE
C.....COMPUTE D=C*B*(INV(-A))...........................................
      CALL SQMULT (C, D, D, M)
      IF(L.NE.2) GO TO 145
      GO TO 135 
C.....A IS SINGULAR, INTERCHANGE A AND B AND TRY AGAIN..................
 125  IF (M .LT. 1) GO TO 190 
      DO 130 I2 = 1, M
      IF (M .LT. 1) GO TO 195 
      DO 130 J2 = 1, M
      TEMP = A (I2, J2) 
      A (I2, J2) = B (I2, J2) 
 130  B (I2, J2) = TEMP 
 195  CONTINUE
 190  CONTINUE
C.....IF A AND B BOTH SINGULAR, GO TO 310...............................
      IF (L .EQ. 2) GO TO 155 
      L = 2 
      GO TO 100 
C.....RE-INTERCHANGE A AND B, AND INTERCHANGE C AND D WITH SIGNS CHANGED
C     DUE TO THE -I FACTORED OUT WHEN A AND B ORIGINALLY INTERCHANGED...
 135  IF (M .LT. 1) GO TO 200 
      DO 140 I3 = 1, M
      IF (M .LT. 1) GO TO 205 
      DO 140 J3 = 1, M
      TEMP = A (I3, J3) 
      A (I3, J3) = B (I3, J3) 
      B (I3, J3) = TEMP 
      TEMP = - C (I3, J3) 
      C (I3, J3) = - D (I3, J3) 
 140  D (I3, J3) = TEMP 
 205  CONTINUE
 200  CONTINUE
 145  RETURN
C 
C.....ERROR STOP - NO INVERSE EXISTS....................................
 150  WRITE (* , 1500)
1500  FORMAT ('0MATRIX C IN SUBROUTINE CMPINV DOES NOT EXIST.'//) 
      STOP      
C.....ERROR STOP - INVERSE CANNOT BE FOUND BY THIS METHOD...............
 155  WRITE (* , 1502)
1502  FORMAT ('0MATRICES A AND B BOTH SINGULAR IN SUBR CMPINV.'//)
      STOP      
      END 

c###oution.for
      SUBROUTINE OUTION
C--------------------------------
C
C     THIS ROUTINE CALLS SUBROUTINES TO GENERATE AND OUTPUT IONOGRAMS
C
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      DO 100 K=1,KFX
      CALL LECDEN(K)
      CALL GENION(K)
      CALL IONPLT(K)
  100 CONTINUE
      RETURN
      END
C--------------------------------

c###hfmufs.for
      SUBROUTINE HFMUFS(fileout,*)
      use voacapl_defs
      use crun_directory
      use cversn
      character fileout*64,file_si*64
c jw      logical doesit*1
      logical*1 doesit
c jw      logical*4 fexists@
      integer*4 error_code4
      integer*2 error_code
      common /cQUIET/ iquiet
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      common /cdaily/ idaily(12)
      common /Cday/ iday
      common /ccoeff/ coeff
         character coeff*4
      common /cCIRAF_TP/ nTP,idx_TP(911)
C--------------------------------
C
C     THIS IS THE PROGRAM CONTROL SUBROUTINE
C     ITRUN CONTROLS PROGRAM TASK, ITOUT CONTROLS PROGRAM OUTPUT.
C
      common /c_S_to_I/ i_S_to_I    !  = 1 = S/I calculation
      common /carea/ iarea             !  see if area coverage
      common /chours/ nhours,ihours(24)
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
c jw      common /CVERSN/ VERSN
c jw         character VERSN*8
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / SSP / SUN(2,12), MONTH
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
C125PC      COMMON/INDICEZ/ISP,ISZ,IFQN,IUR,NMS(11,24,4,2)
C125PC      common/lpalmcmp/imddl(45,2,11,24,4,2),igdfx(45,2,11,24,4,2),
C125PC     +itlos(45,2,11,24,4,2),ihpfx(45,2,11,24,4,2),lNANG(2,11,24,4,2)
C125PC      integer*2 imddl,igdfx,itlos,ihpfx,lNANG
CPC      COMMON/MAPS/VMAP(12,6,50,90),PNT(2,3),ILT,ILG,NLAT,NLON,IMAP
c------------------------------------------------------------------------

C.....START OF PROGRAM
C.....SET THE LOGICAL UNITS FOR SYSTEM INPUT AND OUTPUT FILES.
C     THE USER MUST INCLUDE AN "AUXIN" AND/OR AN "AUXOUT" CARD IF THE
C.....AUXILIARY INPUT AND/OR OUTPUT FILES ARE TO BE USED.
      LUI = LU5
      LUO = LU6
      nch_run=lcount(run_directory,50)
      iarea=0
      call setvars     !  set variables that are undefined
C.....CREATE PROCEDURE FILE AND CHECK CONTROL CARD NAMES
      CALL LISTIN
C.....TERMINATE PROGRAM IF ANY INVALID CONTROL CARD NAMES OCCUR
      IF(ITRUN.le.0) go to 600
C.....INPUT AND PROCESS CONTROL CARDS
C.....INPUT IS FORMATTED CARD IMAGES (USES DECODE)
      ionce=0
      do 95 i=1,12
95    idaily(i)=0
100   CALL DECRED
C.....RETURN IF RUN OPTION IS .LE. 0
      IF(ITRUN.le.0) go to 600
      if(iarea.ne.0) then          !  area coverage
         if(nTP.eq.0) then         !  real area coverage
            call hfarea(*999)
         else
            call hfciraf(*999)     !  CIRAf zones for S/I analysis
         end if
         return
      end if
      if(i_S_to_I.ne.0) then        !  S/I calculation, open output file
         file_si=fileout
         nch=lcount(file_si,64)
         file_si(nch-3:nch)='.si '
         if(ionce.eq.0) then
            open(18,file=run_directory(1:nch_run)//PATH_SEPARATOR//file_si(1:nch))
            rewind(18)
            ionce=1
         end if
      end if
c*****************************************************************
c          mate MONTHs to SSNs per VOA request May 1993
c          required major changes to DECRED and following loop
      igraph=0                     !  do frel(1-11)
      if(frel(1).lt.0.) igraph=1   !  do frel=2 - 30 MHz
      do 550 imonth=1,12
c jw      call yieldit               !  yield for Windows operations
c          check to see if we should abort processing
ccc      inquire(file='voacap.abt',exist=doesit)
c jw      doesit=fexists@(
c jw     +    run_directory(1:nch_run)//'\voacap.abt',error_code4)
c jw      if(doesit) then      !  file exists, abort area calculations
c jw         call erase@(run_directory(1:nch_run)//'\voacap.abt',
c jw     +               error_code)   !  delete file first
c jw         return 1
c jw      end if
      MONTH=MONTHS(imonth)
      if(MONTH.eq.0) go to 100     !  no more months
      SSN=SUNSP(imonth)
ccc      if(igraph.eq.1) write(luo,9) imonth,month,nint(ssn)
ccc9     format(' COMMENT   GROUP ',i2,i5.2,i5,'ssn')
      call REDMAP(SSN,MONTH)
      iday=idaily(imonth)
      if(iday.ne.0) call redaily(ssn,month,iday)
      call GEOM
c*******************************************************
      nfr=igraph*2+1        !  (1 for non-graphs   3 for graphs)
      if(igraph.eq.1 .and. method.eq.26) nfr=1
      do 540 ifr=1,nfr
      if(igraph.eq.1) call runfreqs(ifr,frel)   !  freqs to run
      do 10 nf=1,11
      if(frel(nf).eq.0.) go to 20
10    continue
20    nf=nf-1
      meth=method
      if(mspec.eq.121) meth=30
      if(iquiet.eq.0) 
     +write(*,21) meth,IMON(MONTH),nint(SSN),(frel(if),if=1,nf)
21    format(' Method',i3,1x,a3,i4,'ssn  Freqs=',11f5.1)
      if(i_S_to_I.ne.0) then        !  S/I calculation, write to output file
         write(18,22) meth,MONTH,nint(SSN),nf,(frel(if),if=1,nf)
22       format('Method    ',4i5,11f7.3)
      end if
c*****************************************************************
C
C.....VALID RUN OPTION, BEGIN PROGRAM ANALYSIS
C.....REDUCE ANGLE SCAN FOR THIS DISTANCE
      CALL SANG
C.....PROCESS AND OUTPUT ANTENNA PATTERNS
      IF(ITRUN.eq.6) then
         CALL OUTANT
         GO TO 100
      end if
C.....SET OUTPUT ARRAYS
      CALL SETOUT
C.....SET CONTROL PARAMETER FOR FREQUENCY COMPLEMENTS
      IFREQ = FREL(14)
cD     IF(MSPEC.EQ.125)THEN
cc.......Power set to 1 Watt
cD       pwr=.001
cD       ISZ=ISZ+1
cD       IF(ISZ.GT.4)THEN
cD         ISP=ISP+1
cD         IF(ISP.GT.2)THEN
cD           do 128 ISP=1,2
cD           do 128 ISZ=1,4
cD           do 128 IUR=1,24
cD           do 128 IFQN=1,11
cc`````````````````````````````````````````````````````````````````````
cD           do 129 IEND=1,2
cD129        lNANG(IEND,IFQN,IUR,ISZ,ISP)=0
cc-------------------------------------------------------------------
cD128        NMS(IFQN,IUR,ISZ,ISP)=-1
cD           ISP=1
cD         ENDIF
cD         ISZ=1
cD       ENDIF
cD     ENDIF
C.....BEGIN HOUR LOOP
      DO 400 ihr = 1,nhours
c jw      call yieldit               !  yield for Windows operations
      JT=ihours(ihr)
      IUR=jt
      JTX = ihr
C.....CONVERT UT TO LMT, ETC.
      CALL GEOTIM(JT)
C.....WANT TO USE LONG TERM COEFFICIENTS
      IF(KRUN.gt.2) go to 140
C.....TIME VARIATION OF MAPS
C.....UT VARIATION OF CRITICAL FREQUENCIES, F2M(3000)
      CALL VIRTIM
      IF(ITRUN.le.0) go to 600
      IF(KRUN.gt.1) go to 135
C.....LMT DEPENDENCY AND E AND F1 PARAMETERS
      CALL TIMVAR
C.....F2 PARAMETERS (F1 MAY BE CHANGED)
      CALL F2VAR
C.....SPORADIC E PARAMETERS
      IF(KRUN.ge.1) go to 140
  135 CALL ESIND
C.....USE ITRUN TO CONTROL PROGRAM EXECUTION
  140 IF(ITRUN - 2) 145, 150, 155
C.....IONOSPHERIC PARAMETERS ONLY (ITRUN = 1)
  145 CALL OUTPAR
      GO TO 300
C.....IONOGRAMS ONLY (ITRUN = 2)
  150 CALL IONSET
      CALL OUTION
      GO TO 300
C.....MUF BY CLASSICAL NOMOGRAMS ONLY (ITRUN = 3)
  155 CALL IONSET
      IF(ITRUN.eq.3) then
         CALL NOMMUF
         GO TO 300
      end if
C.....MUF BY FULL IONOSPHERE, AND FOT CALCULATION (ITRUN = 4)
      CALL CURMUF
      IF(ITRUN.eq.4) go to 300
C.....MUF AS A FUNCTION OF K LINES (ITRUN = 5) (NOT YET DEVELOPED)
      IF(ITRUN.eq.5) go to 410
C.....FULL SYSTEMS PERFORMANCE MODEL (ITRUN = 7)
      IF(ITRUN.ne.7) go to 250
      IF(IFREQ.le.0) then
C............SET FREQUENCY COMPLEMENT
         CALL FRQCOM(FREL,IFREQ)
      else
         FREL(12) = ALLMUF(IT)
      end if
      IF(METHOD.EQ.22.OR.METHOD.EQ.25.OR.MSPEC.EQ.125)THEN
C.......FORCE SHORT PATH MODEL
        IPFG=100
      ELSE IF(METHOD.EQ.21) THEN
        IF(MSPEC.EQ.121)THEN
C.........SET FOR SHORT PATH AND USE LONGPATH/SHORTPATH SMOOTHING
          IPFG=100
        ELSE
C.........FORCE LONG PATH MODEL
          IPFG=200
        ENDIF
      ELSE
C.......FORCE LONG PATH MODEL IF PATH LENGTH .GT. SPECIFIED LIMIT
        IPFG=100
        IF(MSPEC.ne.121 .and. GCDKM.GE.GCDLNG) IPFG=200
        IF(meth.eq.30   .and. GCDKM.GE.GCDLNG) IPFG=200
      ENDIF
ccc      if(mspec.eq.121) 
ccc     +    write(12 ,111) method,meth,npsl,mspec,gcdkm,frel(12)
ccc111   format(' method,npsl,mspec,gcdkm,muf=',4i5,f10.1,f10.3)
      CALL LUFFY(IPFG)
      CALL SETLUF
      GO TO 300
C.....CALCULATE LUF (ITRUN = 8)
  250 IF(ITRUN.eq.8) then
         IPFG=300
         IF(GCDKM.GE.GCDLNG)IPFG=400
         CALL LUFFY(IPFG)
      end if
  260 CONTINUE
C.....USE ITOUT TO CONTROL PROGRAM OUTPUT
C
  300 if(MSPEC.eq.125)go to 400
      IF(ITOUT.eq.7) then        !  output printed lines dependent on METHOD
         CALL OUTLIN
      else IF(ITOUT.eq.8) then   !  output reliabilities
         CALL OUTTAB
      else IF(ITOUT.eq.10) then  !  output FOT-MUF-HPF for full ionosphere
         CALL OUTLAY
      end if
  400 CONTINUE
C.....END OF THE HOUR LOOP
  410 IF(ITOUT.eq.3) then
         CALL OUTMUF
         GO TO 450
      end if
C.....OUTPUT DIURNAL PRINTER PLOTS
      IF(ITOUT.eq.4) then
         CALL OUTGPH
         GO TO 450
      end if
C.....OUTPUT FOR MUF AS A FUNCTION OF K.
ccc      IF(ITRUN.eq.5) CALL OUTKMF
C.....OUTPUT ADDITIONAL DIURNAL GRAPHS IF REQUESTED BY "OUTGRAPH" CARD
  450 IF(ISOUT.le.0) go to 500
C.....IGNORE REQUEST IF CURRENT METHOD DID NOT COMPUTE MUFS OR LUFS
      IF(ITRUN.le.2) go to 500
      IF(ITRUN.le.4) go to 459
      IF(ITRUN.le.6) go to 500
      IF(ITRUN.gt.8) go to 500
C.....SAVE THE CURRENT METHOD, RUN AND OUTPUT OPTIONS
  459 ITEMP = METHOD
      JTEMP = ITRUN
      KTEMP = ITOUT
      DO 495 I = 1,12
      METHOD = KTOUT(I)
C.....IGNORE REQUEST IF IT IS FOR OUTPUT ALREADY SUPPLIED
      IF(METHOD.eq.ITEMP) go to 495
C.....IGNORE REQUEST IF AN INVALID METHOD IS SPECIFIED
      METNEG = 0
      IF(METHOD) 465, 495, 469
C.....INTERCHANGE OUTPUT FILES IF METHOD IS NEGATIVE ON "OUTGRAPH" CARD
  465 METNEG = 1
      METHOD = - METHOD
      IF(LUO.eq.LU6) then
         LUO = LU16
      else
         LUO = LU6
      end if
  469 IF(METHOD.ge.30) go to 490
      ITOUT = JTOUT(METHOD)
      ITRUN = JTRUN(METHOD)
C.....IGNORE THE REQUEST IF OUTPUT OPTION OF METHOD SPECIFIED ISN"T 3or4
      IF(ITOUT - 3) 475, 480, 475
  475 IF(ITOUT - 4) 490, 485, 490
C.....IGNORE REQUEST IF FOR LUF AND LUF HASN"T BEEN COMPUTED OR SET
C.....USING FREQUENCY COMPLEMENT AND RELIABLITIES
  480 IF(ITRUN - 8) 484, 481, 484
  481 IF(JTEMP - 7) 490, 484, 482
  482 IF(JTEMP - 8) 490, 484, 490
  484 CALL OUTMUF
      GO TO 490
  485 IF(ITRUN - 8) 488, 486, 488
  486 IF(JTEMP - 7) 490, 488, 487
  487 IF(JTEMP - 8) 490, 488, 490
  488 CALL OUTGPH
C.....RESTORE ORIGINAL OUTPUT FILES
  490 IF(METNEG.le.0) go to 495
  491 IF(LUO.eq.LU6) then
         LUO = LU16
      else
         LUO = LU6
      end if
  495 CONTINUE
C.....RESTORE THE ORIGINAL METHOD, RUN AND OUTPUT OPTIONS
      METHOD = ITEMP
      ITRUN = JTEMP
      ITOUT = KTEMP
C.....END OF EXECUTION (RETURN TO READ NEXT INPUT CARD)
  500 CONTINUE
  540 CONTINUE
  550 CONTINUE
      GO TO 100
C.....END OF RUN
  600 CONTINUE
      WRITE(LUO,1504) VERSN
 1504 FORMAT(1H ,'*****END OF RUN*****',5X,'VOACAP ',a8)
      RETURN
999   return 1     !  area coverage  or batch abort
      END
C--------------------------------

c###convh.for
      SUBROUTINE  CONVH( GD,PHE,DEL,HP,RAY,CH,PTOT )
C--------------------------------
C
C     THIS SUBROUTINE CALCULATES THE GEOMETRICAL CONVERGENCE FACTOR
C
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      DENOM = AMAX1(ABS(SIN(GD)) , .000001)
      PSI   = PIO2 - DEL - PHE
      GM = GD - 2.*PSI
      GM = AMAX1(GM,0.001)
C.....GROUP PATH
      PTOT = 2.*RAY +(RZ+HP)*GM
      SMALLC = (PTOT/RZ)*COS(DEL)/DENOM
      CH  = 10.*ALOG10(SMALLC)
C.....AT ANTIPODAL
      CH  =AMIN1(CH,15.)
      RETURN
      END
C--------------------------------

c###fdist.for
      SUBROUTINE FDIST (IHOP,K,NUMMOD)
C--------------------------------
C
C     THIS ROUTINE FINDS UP TO SIX RAYSETS FOR THE CURRENT HOP DISTANCE
C     (SET IN SUBROUTINE LUFFY) AND FREQUENCY
C     LOOK FOR E, F1 AND F2 LOW ANGLES AND HIGH ANGLES
C
C     K IS THE SAMPLE AREA (USED AS AN INDEX)
C
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON /MODES /GHOP, DELMOD (6, 3), HPMOD (6, 3), HTMOD (6, 3), FV
     1MOD (6, 3), ITMOD (6, 3), AFMOD (6, 3)
      COMMON/INFORM/INFO,IHSHR,IHLNG
      character MODZ(6)*3,mlay(3)*3
      data mlay/'  E',' F1',' F2'/
      do 1 i=1,6
    1 MODZ(i)='   '
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C.....DHOP= HOP DISTANCE KM
      DHOPKM = GHOP*RZ
      DO 100 IM = 1, 6
C.....THIS INDICATES NO MODE
      HPMOD (IM, K) = - 1.
  100 ITMOD(IM,K) = 5
CRMFORT      IF (DHOPKM - DMAXKM (K))135, 230, 230
ccc      IF(DHOPKM+0.1.GT.DMAXKM(K)) GO TO 230
c    The code below was done to fix a problem of no modes being found.
c    This was done 1/10/97 by Greg Hand.  Apparently the original line
c    was commented out with CRMFORT.  I am assuming this was done by NRL to
c    solve some problem with Ryan McFarlan Fortran compiler.
      IF(DHOPKM.GE.DMAXKM(K)) GO TO 230
      IH = 0
      IL = 0
  140 IL = IL + 1
  145 IH = IH + 1
      IF(IH.gt.44) go to 230
      IF(HPFLX(IH+1,K).le.0.) go to 230
      IF(GDFLX(IH,K) - GDFLX(IH+1,K)) 170, 160, 215
ccc  160 IF(DHOPKM - GDFLX(IH, K)) 145, 165, 145
  160 IF(abs(DHOPKM-GDFLX(IH, K)).le..001) go to 145
  165 DELMOD (IL, K) = DELFX (IH, K)
      HPMOD (IL, K) = HPFLX (IH, K)
      HTMOD (IL, K) = HTFLX (IH, K)
      ITMOD (IL, K) = IMODE (IH, K)
      AFMOD (IL, K) = AFFLX (IH, K)
      FVMOD (IL, K) = FVFLX (IH, K)
      GO TO 305
  170 IF(GDFLX(IH,K) - DHOPKM) 175, 165, 145
  175 IF(DHOPKM - GDFLX(IH+1,K)) 180, 176, 145
  176 IH = IH + 1
      GO TO 165
  180 CONTINUE
      DTH2 = GDFLX (IH + 1, K) - GDFLX (IH, K)
      IF (ABS (DTH2) - 0.001)165, 165, 185
  185 CONTINUE
      DTH = DHOPKM  - GDFLX(IH,K)
C.....BEGINNING OF SECTION TO SEARCH IN TABLE, DO LINEAR INTERPOLATION
      THET = 0.5 * DHOPKM / RZ
      HP1 = HPFLX (IH, K)
      HP2 = HPFLX (IH + 1, K)
      HT1 = HTFLX (IH, K)
      HT2 = HTFLX (IH + 1, K)
      HP = HP1 + (HP2 - HP1) * DTH / DTH2
      HT = HT1 + (HT2 - HT1) * DTH / DTH2
      AFMOD(IL,K)=AFFLX(IH,K)+(AFFLX(IH+1,K)-AFFLX(IH,K))*DTH/DTH2
      HPMOD (IL, K) = HP
      ST = SIN(THET)
      TANP = ST/(1. - COS(THET)  + HP/RZ)
      PHE  = ATAN(TANP)
C.....BUT FORCE CORRECT GEOMETRY BY CALCULATING RADIATION ANGLE AND
C.....SNELL"S LAW BY CALCULATING FV
      DELMOD(IL,K) =  (PIO2 - PHE - THET ) * R2D
      SPHI = RZ * COS (DELMOD (IL, K) * D2R) / (RZ + HT)
      SPHI = 1. - SPHI * SPHI
      SPHI = AMAX1 (SPHI, 0.000001)
      FVMOD (IL, K) = FREQ * SQRT (SPHI)
      HTMOD (IL, K) = HT
      ITMOD (IL, K) = IMODE (IH, K)
C.....CHECK ON MINIMUM ANGLE AFTER INTERPOLATION
  305 IF(DELMOD(IL,K).ge.AMIND) go to 315
      HPMOD(IL,K) = - ABS(HPMOD(IL,K))
      go to 145        !  added from ICEPAC fdist
C.....END OF SECTION TO SEARCH IN TABLE, DO LINEAR INTERPOLATION
  315 IF (IL - 6)140, 230, 230
  215 IF(GDFLX(IH,K) - DHOPKM) 145, 165, 220
  220 IF(DHOPKM - GDFLX(IH+1,K)) 145, 176, 180
  230 CONTINUE
          NUMMOD=0
          do 236 ilm=1,6
          if(HPMOD(ilm,k).lt.0.)go to 236
          NUMMOD=NUMMOD+1
          MODZ(NUMMOD)=mlay(ITMOD(ilm,k))
  236     continue
          IF(IAND(INFO,1).GT.0)THEN
           WRITE(99,'(16h "FDIST"   Nhop=,I1,3x,6hHopkm=,f6.0,7h  Mods=,
     1      I1,3X,6A3)')IHOP,DHOPKM,NUMMOD,MODZ
          ENDIF
      RETURN
      END
C--------------------------------

c###alosfv.for
      SUBROUTINE ALOSFV(K)
C--------------------------------
C
C     THIS ROUTINE COMPUTES THE DEVIATIVE LOSS FACTOR
C
C     THIS IS ZERO EXCEPT FOR THOSE MODES COMING FROM HEIGHTS ABOVE THAT
C     CORRESPONDING TO THE MUF (HIGH ANGLE MODES)
C     THE ADJUSTMENT IS BASED ON A THEORETICAL EQUATION
C     THE LOSS IS PROPORTIONAL TO THE PRODUCT OF THE AVERAGE COLLISION
C     FREQUENCY AND THE DIFFERENCE BETWEEN THE GROUP PATH AND THE
C     PHASE PATH BUT IS NORMALIZED TO THE LOSS EQUATION
C
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      DIMENSION A(3),HM(2)
      DATA  A/0.2,0.1,0.1/
C  E LAYER
      HM(1) = HPMUF(1) - HTMUF(1)
      HZ    = HI(1,K)  - YI(1,K)
      DO 105 IH =1,10
      IF( HTRUE(IH,K)- HTMUF(1) ) 100,100,102
  100 AFAC(IH,K) = 0.0
      GO TO 105
C.....COLLISION FREQUENCY TERM ADJUSTMENT FACTOR
  102 ZEXP = -2. * ( HTRUE(IH,K) - HZ ) / YI(1,K)
      ZEXP = AMAX1(ZEXP,-10.)
      CF = A(1) * EXP( ZEXP )
      AFAC(IH,K) = CF * (HPRIM(IH,K) - HTRUE(IH,K) - HM(1))
  105 CONTINUE
      IF( FI(2,K) )  115,115,140
  115 CONTINUE
C   F2 LAYER WITH NO F1 LEDGE
C
C
C.....CONTINUITY AT E TO F2 CUSP
      A(2) = CF
      HZ = HTRUE(11,K)
      HM(2) = HPRIM(13,K) - HTRUE(13,K)
      DO 120  IH = 11,12
      ZEXP = -2. * ( HTRUE(IH,K) - HZ ) / YI(3,K)
      ZEXP = AMAX1(ZEXP,-10.)
      CF = A(2) * EXP( ZEXP )
      CF = AMAX1(CF,0.05)
  120 AFAC(IH,K) = CF* ( HPRIM(IH,K) - HTRUE(IH,K) - HM(2))
      AFAC(13,K) = 0.0
      A(3) = 0.1
      HM(2) = HPMUF(3) - HTMUF(3)
      DO 135  IH = 14,30
      IF( HTRUE(IH,K) - HTMUF(3) ) 125,125,130
  125 AFAC(IH,K) =0.0
      GO TO 135
  130 ZEXP = -2. * ( HTRUE(IH,K) - HZ ) / YI(3,K)
      ZEXP = AMAX1(ZEXP,-10.)
      CF = A(3) * EXP( ZEXP )
C.....FORCE THE MINIMUM VALUE OF CF TO BE NO LESS THAN 0.5
      CF = AMAX1(CF,0.5)
      AFAC(IH,K) = CF *(HPRIM(IH,K) - HTRUE(IH,K) - HM(2) )
  135 CONTINUE
      GO TO 200
  140 CONTINUE
      IF( FI(2,K) ) 115,115,145
  145 CONTINUE
C  F1  LAYER
C.....CONTINUITY AT E TO F1 CUSP
      A(2) = CF
      HZ  = HTRUE(11,K)
      HM(2) = HPRIM(13,K) - HTRUE(13,K)
      DO  150  IH = 11,12
      ZEXP = -2. * ( HTRUE(IH,K) - HZ ) / YI(2,K)
      ZEXP = AMAX1(ZEXP,-10.)
      CF = A(2) * EXP( ZEXP )
      CF = AMAX1(CF, 0.05)
  150 AFAC(IH,K) = CF * (HPRIM(IH,K) - HTRUE(IH,K) - HM(2) )
      AFAC(13,K) = 0.0
      A(2) = 0.1
      HTM = HTMUF(2)
      HTP = HPMUF(2)
      HM(2) = HTP - HTM
      DO 165 IH = 14, 20
      IF(HTRUE(IH,K)  - HTM)  155,155,160
  155 AFAC(IH,K) = 0.0
      GO TO 165
  160 ZEXP = -2. * ( HTRUE(IH,K) - HZ ) / YI(2,K)
      ZEXP = AMAX1(ZEXP,-10.)
      CF = A(3) * EXP( ZEXP )
      CF = AMAX1( CF, 0.05)
      AFAC(IH,K) = CF *( HPRIM(IH,K) - HTRUE(IH,K) - HM(2) )
  165 CONTINUE
C  F2 LAYER WITH F1 LEDGE
C.....FORCES CONTINUITY AT F1 TO F2 LAYER
      A(3) = CF
      HZ   = HTRUE(21,K)
      HM(2) = HPRIM(23,K) - HTRUE(23,K)
      DO 170 IH = 21,22
      ZEXP = -2. * ( HTRUE(IH,K) - HZ ) / YI(3,K)
      ZEXP = AMAX1(ZEXP,-10.)
      CF = A(3) * EXP( ZEXP )
      CF = AMAX1(0.05,CF)
  170 AFAC(IH,K) = CF * (HPRIM(IH,K) - HTRUE(IH,K) - HM(2))
      AFAC(23,K) = 0.0
      A(3) = 0.1
      HTM = HTMUF(3)
      HTP = HPMUF(3)
      HM(2) = HTP - HTM
      DO 185 IH = 24,30
      IF(HTRUE(IH,K) - HTM )  175,175,180
  175 AFAC(IH,K) = 0.0
      GO TO 185
  180 ZEXP = -2. * ( HTRUE(IH,K) - HZ ) / YI(3,K)
      ZEXP = AMAX1(ZEXP,-10.)
      CF = A(3) * EXP( ZEXP )
      CF = AMAX1(CF,.05)
      AFAC(IH,K) = CF*(HPRIM(IH,K) - HTRUE(IH,K) - HM(2) )
  185 CONTINUE
  200 CONTINUE
C     HPMUF HAS ADDED CORRECTION ALREADY
      DO 205 IH = 1,30
      AFAC(IH,K) = AMAX1(0.,AFAC(IH,K) )
  205 CONTINUE
      RETURN
      END
C------
C--------------------------------

c###setluf.for
      SUBROUTINE SETLUF
C--------------------------------
C.....THIS SUBROUTINE SETS THE LUF USING THE FREQUENCY COMPLEMENT AND
C.....COMPUTED RELIABILITIES. THESE VALUES ARE CHANGED IN SUBROUTINE
C.....GETLUF IF THE LUF IS ACTUALLY COMPUTED
C
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / MUFS / EMUF(24), F1MUF(24), F2MUF(24), ESMUF(24),
     A ALLMUF(24), FOT(24), XLUF(24), HPF(24), ANGMUF(24), MODMUF,
     B SIGL(4), SIGU(4), DELMUF(4), HPMUF(4), HTMUF(4), FVMUF(4),
     C AFMUF(4), NHOPMF(4), YFOT(4), YHPF(4), YMUF(4)
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
C
      RF = FREL(1)
      REL = RELIAB(1)
      PLUF = LUFP
      PLUF = 0.01 * PLUF
      DO 200 IF = 1,11
      IF(FREL(IF)) 200, 200, 105
  105 IF(RELIAB(IF) - PLUF) 115, 110, 110
  110 XLUF(IT) = FREL(IF)
      FREL(13) = FREL(IF)
      GO TO 205
  115 IF(RELIAB(IF) - REL) 200, 200, 120
  120 REL = RELIAB(IF)
      RF = FREL(IF)
  200 CONTINUE
      XLUF(IT) = - RF
      FREL(13) = RF
  205 CONTINUE
      RETURN
      END
C--------------------------------

c# antfile.f
      subroutine antfile(dir,file,antname)
c          concatenate dir\file into antname
      use voacapl_defs
      character dir*8,file*12,antname*21

      antname='                     '
      n=0
      do 10 i=1,8
      if(dir(i:i).eq.' ') go to 15
      n=n+1
      antname(n:n)=dir(i:i)
10    continue
15    n=n+1
      antname(n:n)=PATH_SEPARATOR
      do 20 i=1,12
      if(file(i:i).eq.' ') go to 25
      n=n+1
      antname(n:n)=file(i:i)
20    continue
25    continue
      return
      end

c# icolDOS.for
      function icolDOS(color)    !  convert color name to DOS color index
      character color*6
      common /DOS_col/ ncolors,colors(20),index_DOS(20),DOScol(20)
      character colors*6,DOScol*6
      do 10 i=1,ncolors
      if(color.eq.colors(i) .or. color.eq.DOScol(i)) then
         icolDOS=index_DOS(i)
         return
      end if
10    continue
      icolDOS=-1      !  Ignore if not found
      return
      end
C------------------------------------------------------------------

        subroutine surfim (yy, dlteta, psi)
c
      common/surf/ro,costh,sinth,rnumb,gamma,epq
c
      if (ro.le.0) then 
        srag = 0
        detar = costh
        detai = sinth
      else
        srag1 = yy / rnumb
        srag2 = alog(2 * yy / gamma)
        srag = srag1 * srag2
        sraq = srag * srag
        dnm = epq + sraq + 2 * srag * sinth
        etanr = sraq * costh
        etani = epq * srag + sraq * sinth
        etar = etanr / dnm
        etai = etani / dnm
        detar = costh - etar
        detai = sinth - etai
      endif
      dlteta = sqrt(detar**2 + detai**2)
      psi = atan(detai / detar)
      return
      end
c---------------------------------------------------------------

c###outlay.for
      SUBROUTINE OUTLAY
C--------------------------------
C.....THIS ROUTINE TABULATES FOT-MUF (FULL IONOSPHERE)
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON / MUFS / EMUF(24), F1MUF(24), F2MUF(24), ESMUF(24),
     A ALLMUF(24), FOT(24), XLUF(24), HPF(24), ANGMUF(24), MODMUF,
     B SIGL(4), SIGU(4), DELMUF(4), HPMUF(4), HTMUF(4), FVMUF(4),
     C AFMUF(4), NHOPMF(4), YFOT(4), YHPF(4), YMUF(4)
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      IF(LINES - LINMAX) 110, 100, 100
  100 CALL OUTTOP
      WRITE(LUO,1502)
      WRITE(LUO,1504)
      LINES = LINES + 4
  110 WRITE(LUO,1506) UTIME(IT),XLMT(IT), (YFOT(I),YMUF(I),YHPF(I),
     A DELMUF(I), HPMUF(I), HTMUF(I), FVMUF(I), I=1,2)
      WRITE(LUO,1508) (YFOT(I), YMUF(I), YHPF(I), DELMUF(I), HPMUF(I),
     A HTMUF(I), FVMUF(I), I=3,4)
      LINES = LINES + 2
       RETURN
C.....FORMAT SPECIFICATIONS
 1502 FORMAT(/,26X,'ELAYER/F2LAYER',28X,'F1LAYER(E)/ESLAYER',/)
 1504 FORMAT(1X,' GMT   LMT',2('   FOT   MUF   HPF ANGLE VIRTL  TRUE ',
     A 'FVERT',2X),/)
 1506 FORMAT(' ',F4.1,F6.1,2(4F6.1,2F6.0,F6.1,2X))
 1508 FORMAT(11X,2(4F6.1,2F6.0,F6.1,2X))
      END
C--------------------------------

        subroutine trigfun (a, b, uust)
c
c  pre-sets arrays of trig values
c  if uust=1, 91 values are set
c  if uust=1/3, 271 values are set    -- WHAT??? This won't work!!!
c
      common/general/d1,e1,f1,p1,q1,s1,beta,rlambda
c      
        dimension a(0:361),b(0:361)
c
        do 100 z=0,90,uust
        a(ifix(z)) = sin(z * q1)
        b(ifix(z)) = cos(z * q1)
  100   continue        
        a(90) = sin(90.05 * q1)
        b(90) = cos(90.105 * q1)
        b(0) = cos(.005)
        return
        end
c---------------------------------------------------------------

c###cngtim.for
      FUNCTION CNGTIM(TIME,XTHETA,ISW)
C--------------------------------
C     /////////////////////////////////////////////
C
C     IF ISW=1
C     THIS FUNCTION CONVERTS UNIVERSAL TIME (TIME GREATER THAN
C     OR EQUAL TO ZERO BUT LESS THAN 24) IN HOURS TO LOCAL TIME
C     AT LOCAL REFRENCE LONGITUDE (THETA GREATER THAN OR EQUAL
C     TO ZERO AND LESS THAN OR EQUAL TO 360 DEGREES) IN DEGREES EAST
C
C
C     IF ISW=-1
C     THIS FUNCTION CONVERTS LOCAL TIME (TIME GREATER THAN
C     OR EQUAL TO ZERO BUT LESS THAN 24)
C     AT LOCAL REFRENCE LONGITUDE (THETA GREATER THAN OR EQUAL
C     TO ZERO AND LESS THAN OR EQUAL TO 360 DEGREES) IN DEGREES EAST
C     TO UNIVERSAL TIME
C
C
C     FUNCTION VALUE IS ZERO IF THERE IS NO DAY CHANGE
C
C     FUNCTION VALUE IS 1 IF THE DAY SHOULD BE ADVANCED
C
C     FUNCTION VALUE IS -1 IF THE DAY SHOULD BE RETARDED
C
C     /////////////////////////////////////////////
      IF(XTHETA) 80,75,85
   75 CNGTIM=0
      RETURN
   80  THETA=360. + XTHETA
      GO TO 90
   85 THETA=XTHETA
   90  CONTINUE
C
C     THE FUNCTION STARTS HERE
C
      INT1 = THETA / 180.
      INT2 = THETA / 360.
      FINT1 = INT1
      FINT2 = INT2
      FISW = ISW
      TIME = TIME + FISW * (THETA / 15.0 - FINT1 * 24. + FINT2 * 24.)
      INT1 = (TIME - 23.99999999) / 24.0
      INT2 = TIME / 24.0
      CNGTIM = INT1 + INT2
      IF (TIME)100, 105, 105
  100 TIME = TIME + 24.
  105 TIME = TIME - FINT2 * 24.
  110 IF(TIME) 115, 120, 120
  115 TIME = TIME + 24.
      GO TO 110
  120 IF(TIME - 24.) 130, 130, 125
  125 TIME = TIME - 24.
      GO TO 110
  130 CONTINUE
      RETURN
      END
C--------------------------------

c###setgph.for
      SUBROUTINE SETGPH
C--------------------------------
C
C     THIS ROUTINE SETS THE VARIABLES TO BE PLOTTED DEPENDENT ON METHOD
C     SUBROUTINE GPHBOD CREATES LINE PRINTER GRAPHS OF THE VARIABLES SET
C
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / OUTGH / PLOTI(24), PLOTJ(24), PLOTK(24), XOUT(13), NPLOTS
      COMMON / OUTLAB / LABEL(11), LAYTYP(5), IEAST, INORTH, ISOUTH,
     A IWEST, LABLI, LABLJ, LABLK
      CHARACTER IEAST*1, ISOUTH*1, INORTH*1, IWEST*1, LABEL*5, LAYTYP*2,
     A LABLI*5, LABLJ*5, LABLK*5
      DATA NHR/24/
C.....SET FOR MUF-FOT GRAPH
C.....CHANGE VARIABLES AND/OR ADD THIRD VARIABLE DEPENDENT OF METHOD.
      NPLOTS = 2
      LABLI = LABEL(10)
      LABLJ = LABEL(4)
      LABLK = LABEL(11)
      DO 80 ICR = 1,NHR
      PLOTI(ICR) = ALLMUF(ICR)
   80 PLOTJ(ICR) = FOT(ICR)
      IF(METHOD - 4) 90, 400, 90
   90 IF(METHOD - 8) 100, 400, 100
C.....SET FOR MUF-FOT-HPF GRAPH
  100 IF(METHOD - 5) 110, 120, 110
  110 IF(METHOD - 9) 140, 120, 140
  120 NPLOTS = 3
      LABLK = LABEL(7)
      DO 130 ICR = 1,NHR
  130 PLOTK(ICR) = HPF(ICR)
      GO TO 400
C.....SET FOR MUF-FOT-ES GRAPH
  140 IF(METHOD - 6) 150, 160, 150
  150 IF(METHOD - 11) 180, 160, 180
  160 NPLOTS = 3
      LABLK = LABEL(3)
      DO 170 ICR = 1,NHR
  170 PLOTK(ICR) = ESMUF(ICR)
      GO TO 400
C.....SET FOR MUF-FOT-ANG GRAPH
  180 IF(METHOD - 10) 210, 190, 210
  190 NPLOTS = 3
      LABLK = LABEL(1)
      DO 200 ICR = 1,NHR
  200 PLOTK(ICR) = ANGMUF(ICR)
      GO TO 400
C.....SET FOR LUF-FOT GRAPH
  210 IF(METHOD - 27) 240, 220, 240
  220 LABLI = LABEL(8)
      DO 230 ICR = 1,NHR
  230 PLOTI(ICR) = XLUF(ICR)
      GO TO 400
C.....SET FOR MUF-FOT-LUF GRAPH
  240 IF(METHOD - 28) 270, 250, 270
  250 NPLOTS = 3
      LABLK = LABEL(8)
      DO 260 ICR = 1,NHR
  260 PLOTK(ICR) = XLUF(ICR)
      GO TO 400
C.....SET FOR MUF-LUF GRAPH
  270 IF(METHOD - 29) 300, 280, 300
  280 LABLJ = LABEL(8)
      DO 290 ICR = 1,NHR
  290 PLOTJ(ICR) = XLUF(ICR)
      GO TO 400
C.....THE METHOD SPECIFIED DOESN"T PRODUCE GRAPHS FROM THIS ROUTINE
  300 NPLOTS = 0
  400 CONTINUE
      RETURN
      END
C--------------------------------

C--------------------------------
      BLOCK DATA    
C--------------------------------
      common /ccoeff/ coeff
      character coeff*4
      COMMON /A11/GAMMA (6)
C  OUTPUT OF NUMERICAL MAPS (SEE SUBROUTINE VERCY)
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
C  NOISE VALUES, SUBRS ANOIS1 AND GENOIS.
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SxGU,SxGL,KJ,JK
C CONSTANTS,SET BELOW.
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
C WEIGHTS AND ABSCISSCAE FOR 40 POINT GUASSIAN SET BELOW.
      COMMON / DATR / WT(20), XT(20), NT, NPL, XNPL, TWDIV
C GENERAL GEOGRAPHIC VARIABLES, SEE SUBR GEOM AND HFMUFES.
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON /FONE/ANEW(3),BNEW(3),ACHI(2),BCHI(2)
      COMMON / OUTLAB / LABEL(11), LAYTYP(5), IEAST, INORTH, ISOUTH,
     A IWEST, LABLI, LABLJ, LABLK
      CHARACTER IEAST*1, ISOUTH*1, INORTH*1, IWEST*1, LABEL*5, LAYTYP*2,
     A LABLI*5, LABLJ*5, LABLK*5
C SPORADIC E LAYER, SEE SUBR. ESIND.
      COMMON /ES /FS (3, 5), HS (5)
C  INPUT AND OUTPUT FILE NUMBERS
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
C FREQUENCY COMPLEMENT,SEE SUBR. HFMUFES.
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
C GEOGRAPHIC VARIABLES AT SAMPLE AREAS,SEE GEOM,TIMVAR,MAGVAR AND   LUFFY.
      COMMON /GEOG /GYZ (5), RAT (5), GMDIP (5), CLCK (5), ABIY (5), ART
     1IC (5), SIGPAT (5), EPSPAT (5)
      COMMON/INFORM/INFO,IHSHR,IHLNG
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON/LOSX/ANDVX(45,3),ADVX(45,3),AOFX(45,3),ARFX(45,3),GRLOSX(45
     A ,3),TGAINX(45,3),TLSKM(45,3),EFFlp(45),IAFTXR(3)
C  LONG PATH PARAMETERS,SEE SUBR LNGPAT.
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
C  PROGRAM VERSION NUMBER, PROGRAM CONTROL VARIABLES
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
C  F2 LAYER PARAMETERS (SEE SUBROUTINE F2VAR)
      COMMON / MFAC / F2M3(5),HPF2(5),ZENANG(5),ZENMAX(5),IEDP,FSECV(3)
      COMMON /MODES/GHOP, DELMOD(6,3),HPMOD(6,3),HTMOD(6,3),FVMOD(6,3),
     1 ITMOD (6, 3), AFMOD (6, 3)
C  CIRCUIT MUFS
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
C  INPUT/OUTPUT CONTROL PARAMETERS
      COMMON / NAMEX / NAMES(100), INPUT
      CHARACTER NAMES*10,INPUT*85
      COMMON / OUTFMT / KLINE(26)
      CHARACTER KLINE*6
C  PARAMETERS FOR LINE PRINTER PLOTS
      COMMON / OUTGH / PLOTI(24), PLOTJ(24), PLOTK(24), XOUT(13), NPLOTS
C  LAT AND LONG DIRECTION INDICATORS, LINE NUMBER AND MAXIMUM LINES
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
C  PREDICTED CRITICAL FREQUENCY MULTIPLIERS
      COMMON / PSCA / PSC(4), PSCB(4), IPSC
C OBLIQUE FREQUENCIES,SEE BELOW AND SUBR. GENION
      COMMON/RAYS/ANG(40),IFOB(40,30,5),NANG
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
C GEOGRAPHIC AND IONSPHERIC DATA AT SAMPLE AREAS,SEE GEOM AND GENION.
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON/SIGD/ DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE
     A ,HNU,HTLOSS,XNUZ,XVE
C LATITUDES OF SUBSOLAR POINTS AND MONTH,SEE BELOW AND SUBR. HFMUFES
      COMMON / SSP / SUN(2,12), MONTH
C TIME VARIABLES, SEE HFMUFES.
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
C AURORAL LOSS, POWER AND NOISE DATA, SEE SYSSY, HFMUFES AND RELBIL.
      COMMON /TON /ADJ, ADS, GNOS, GOT, REL, SL, SLS
     1, SPR, SU, SUS, XNOISE, ZNOISE, NF
C  LONG TERM NOISE DATA
      COMMON / TWO / F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     A FAM(14,12), SYS(9,16,6), PERR(9,4,6)
C  LOSSES ETC. FOR MODES.  SEE SUBR. REGMOD. SEE ALSO COMMON/ZON/.
      COMMON / allMODE /ABPS(20),CREL(20),FLDST(20),HN(20),HP(20),
     1PROB(20),RELY(20),RGAIN(20),SIGPOW(20),SN(20),
     2SPRO(20),TGAIN(20),TIMED(20),TLOSS(20),B(20),FSLOS(20),
     3grlos(20),adv(20),obf(20),
     CNMODE(20),TLLOW(20),TLHGH(20),EFF(20),NREL,NMMOD
C ALL MODES OUTPUT ARRAYS
CPC      COMMON/INDICEZ/ISP,ISZ,IFQN,IUR,NMS(11,24,4,2)
CPC      COMMON/SPALMOUT/RNZ(11,24,4,2),DUZ(11,24,4,2),DLZ(11,24,4,2),
CPC     -ZTL(20,11,24,4,2),BBZ(20,11,24,4,2), ZLO(20,11,24,4,2),
CPC     -ZHG(20,11,24,4,2)
CPC      COMMON/LPALMOT2/zACAV(24,4,2),zASM(24,4,2),zDSL(24,4,2),
CPC     +zDSU(24,4,2),zYMUF(4,24,4,2),zYFOT(4,24,4,2),zYHPF(4,24,4,2),
CPC     +zFVMUF(4,24,4,2),zSIGL(4,24,4,2),zSIGU(4,24,4,2)
CPC      common/lpalmcmp/imddl(45,2,11,24,4,2),igdfx(45,2,11,24,4,2),
CPC     +itlos(45,2,11,24,4,2),ihpfx(45,2,11,24,4,2),lNANG(2,11,24,4,2)
CPC      integer*2 imddl,igdfx,itlos,ihpfx,lNANG
C
C SET PREDEFINED CONSTANTS.
C
      data coeff/'CCIR'/        !  default coefficients
C     CONSTANTS
C125PC      DATA ISP,ISZ,IFQN,IUR /2,4,2*0/, INFO/0/
      DATA INFO/0/
      DATA XT      /0.0387724175,0.1160840707,0.1926975807,0.2681521850,
     1              0.3419940908,0.4137792043,0.4830758017,0.5494671251,
     2              0.6125538897,0.6719566846,0.7273182552,0.7783056514,
     3              0.8246122308,0.8659595032,0.9020988070,0.9328128083,
     4              0.9579168192,0.9772599500,0.9907262387,0.9982377097/
      DATA WT      /0.0775059480,0.0770398182,0.0761103619,0.0747231691,
     1              0.0728865824,0.0706116474,0.0679120458,0.0648040135,
     2              0.0613062425,0.0574397691,0.0532278470,0.0486958076,
     3              0.0438709082,0.0387821680,0.0334601953,0.0279370070,
     4              0.0222458492,0.0164210584,0.0104982845,0.0045212771/
      DATA JTRUN / 1,2,4*3,5*4,5,3*6,10*7,5*8,10*0/,
     A     JTOUT / 1,2,3,3*4,10,4*4,5,3*6,8*7,8,9,3,3*4,11,10*0/
      DATA ITRUN/0/, ITOUT/0/
      DATA RZ/6370./,PI/3.1415926/,VOFL/299.79246/, DCL/1.28/
      DATA GAMA/0.57721566/,PI2/6.283185307/,PIO2/1.570796326/
      DATA D2R/.01745329251/, R2D/57.295779513/
      DATA ANG/0., 0.5, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 8.0, 10.0, 12.0
     1,14.,16.,18.,20.,22.,24.,26.,28.,30.,32.,34.,36.,38.,40.,42.,44.
     2 ,46.,48.,50.,52.,54.,56.,60.,65.,70.,75.,80.,85.,89.99/
      DATA IMON /'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep',
     A 'Oct','Nov','Dec' /
      DATA NAMES / 'METHOD    ', 'MONTH     ', 'MONTHLOOP ',
     A 'SUNSPOT   ', 'CIRCUIT   ', 'SYSTEM    ', 'TIME      ',
     B 'ANTENNA   ', 'FREQUENCY ', 'LABEL     ', 'INTEGRATE ',
     C 'EXECUTE   ', 'SAMPLE    ', 'EFVAR     ', 'ESVAR     ',
     D 'EDP       ', 'AUXIN     ', 'AUXOUT    ', 'ANTOUT    ',
     E 'OUTGRAPH  ', 'COMMENT   ', 'FREEFORM  ', 'PROCEDURE ',
     F 'END       ', 'NEXT      ', 'QUIT      ', 'FPROB     ',
     G 'TOPLINES  ', 'BOTLINES  ', 'INFORM    ',
     H 'AREA      ', 'LINEMAX   ', 'COEFFS    ', 'ZONES     ',
     H 66*'          '/
      DATA LABEL / '  ANG', ' EMUF', 'ESMUF', '  FOT', 'F1MUF', 'F2MUF',
     A '  HPF', '  LUF', ' MODE', '  MUF', '     ' /
      DATA LAYTYP /' E', 'F1', 'F2', 'ES', ' N'/
c%lc:gsp, change 1b     12 Jan 1995,                          blockdata blkdat
c%lc      fdays basis changed to hop muf, not path. Name changed accordingly.
c%lc      DATA KLINE/'MODE  ','ANGLE ','DELAY ','V HITE','F DAYS',
      DATA KLINE/'MODE  ','TANGLE','DELAY ','V HITE','MUFday',
     A           'LOSS  ','DBU   ','S DBW ','N DBW ','SNR   ',
     B           'RPWRG ','REL   ','MPROB ','S PRB ','SIG LW',
     B           'SIG UP','SNR LW','SNR UP','TGAIN ','RGAIN ',
     c           'SNRxx ','DBM   ','RANGLE','N dl  ','N du  ','      '/
c%lc. end change 1b
      DATA PSCB/1.,1.,1.,0.7/, PSC/1.,1.,1.,0.7/, IPSC/0/
      DATA SUN/-23.05,-17.31,-17.30,-7.89,-7.88,4.21,4.26,
     1 14.83, 14.84, 21.93, 21.93, 23.45, 23.15, 18.23, 18.20, 8.68, 8.5
     2 5, -2.86, -2.90, -14.16, -14.20, -21.68, -21.66, -23.45/
      DATA GCDLNG/10000./,DELOPT/3./,GMIN/3./,YMIN/.1/
      DATA ADJ/1./,ADS/1./,GNOS/1./,GOT/1./
      DATA RCNSE/-204./,REL/.01/,SL/1./,SLS/1./,SPR/.01/,SU /1./,SUS/1./
      DATA XNOISE/1./
      data noise/-4/   !  default=remote
      DATA ZNOISE/-204./, NF/1/, FLUX/1./, DMP/0.85/
      DATA ERTR/1./, PMP/10./, PWR/1./, RSN/1./, SIGTR/1./
      DATA ATNU/-204./,ATNY/-204./,CC/1./,TM/1./
      DATA DU/9./,DL/4./,SIGM/1.5/,SXGL/1./,SXGU/1./,KJ/1/,JK/1/
      DATA IELECT/0,0,0/
      DATA IHRO,IHRE,IHRS/12,24,12/, ITIM/-1/, LINES/55/
      DATA LPAGES/0/, FREL(14)/-1./
      DATA JOUT/20/, INORTH/'N'/, IEAST/'E'/, ISOUTH/'S'/, IWEST/'W'/,
     A NLINE/55/, LINMAX/55/, ITYPE/0/, JLONG/-1/
      DATA MONTH/0/, NYEAR/'     '/, SSN/0./
      DATA ICARD/0/, KCARD/0/, MOREM/0/, MORES/0/, MAPIN/-1/, MONOLD/0/,
     A INTEG/1/, IANTOU/0/, ISOUT/0/, NUPROC/0/, ISPROC/0/, ISSN/0/,
     B NUMNAM/34/, MAXNAM/100/, MAXMET/30/, IRED/1/, MSPEC/0/,M100/75/
      DATA NMMOD/1/, NREL/1/, IEDP/-1/
      DATA AMIND/3./, AMIN/.05236/
      DATA IT/1/, JFREQ/0/, JTX/1/, KM/1/, KFX/1/, KRUN/0/, LTXRGM/1,1/,
     A METHOD/-1/, LINBYP/0/, LINTYP/0/, NANG/0/, NPLOTS/0/
C
C     PRESET TO BOULDER, COLO. TO ST. LOUIS, MO. SO THAT A CIRCUIT CARD
C     IS NOT NECESSARY.
      DATA ITRAN/'BOULDER, C','OLORADO   '/,
     1     IRCVR/'ST. LOUIS,',' MISSOURI '/
      DATA TLATD/40.03/, ITLAT/'N'/, TLONGD/105.3/, ITLONG/'W'/,
     A RLATD/38.67/, IRLAT/'N'/, RLONGD/90.25/, IRLONG/'W'/, NPSL/0/
      DATA TLAT/.6986553/,TLONG/-1.837308/,RLAT/.6749188/
      DATA RLONG/-1.57516/,GCDKM/1301.1/,GCD/.204254/,BTR/1.60291/
      DATA BTRD/91.84/, BRTD/281.42/
      DATA RD/.102127,.0,.0,.0,.0/,GLAT/.862245,.0,.0,.0,.0/
      DATA CLAT/.691011,.0,.0,.0,.0/,CLONG/-1.70495,.0,.0,.0,.0/
      DATA SIGPAT/.001,.001,.001,.001,.001/,EPSPAT/4.,4.,4.,4.,4./
      DATA ALATD/39.592/,GYZ/1.358,.0,.0,.0,.0/
      DATA GMDIP/.959931,.0,.0,.0,.0/
C.....ELIMINATE D-REGION ABSORPTION ON ES ONLY
C.....PRESET FOR EFFECTIVE ELIMINATION OF LAYERS USING "KRUN" OPTION
      DATA FS/15*0./, FI/10*0.,5*0.2/, HI/5*110.,5*0.,5*300./,
     A YI/5*20.,5*0.,5*100./
      DATA LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35/15,16,2,11,12,15,16,20,25,26,35/
C
C---------------------------------
C
C     PROGRAM VERSION NUMBER
C
C
CC---------------------------------
 
ccc      DATA VERSN /95.0512/         !  Changes external to propagation
ccc      DATA VERSN /95.0501/         !  Changes external to propagation
ccc      DATA VERSN /95.0428/         !  Fix METHOD 30 (SMOOTHING) for area calc
ccc      DATA VERSN /95.0411/         !  Changes external to propagation
ccc      DATA VERSN /95.0327/         !  Changes external to propagation
ccc      DATA VERSN /95.0314/         !  Changes external to propagation
ccc      DATA VERSN /95.0222/         !  Additional LUCAS change that was missed
ccc      DATA VERSN /95.0215/         !  changes to make DOS & UNIX same code
c                                      & allow maximum of frequency complement
ccc      DATA VERSN /95.0120/         !  LUCAS changes incorporated
ccc      DATA VERSN /95.0109/         !  Changed REDMAP for standard coeff files
ccc      DATA VERSN /95.0105/         !  Changed Man-Made Noise defaults
ccc      DATA VERSN /94.1114/         !  Changed SNR90 to SNRxx
ccc      DATA VERSN /94.1103/         !  fixed coeff error (115.2 > 11.52)
ccc      DATA VERSN /94.0902/         !  method 30 (smoothing) activated
ccc      DATA VERSN /94.0526/
 
C---------------------------------
C
C   VOACAP VERSION 92.0515 of   15 May 1992  is the initial interactive
C   version of VOACAP (EUIP) to be tested by VOA. 
C
C---------------------------------
C
C      ADD COMMENTS ON OTHER VERSIONS
C
C---------------------------------
C
C   VOACAP VERSION 91.0821 of   21 Aug 1991   contains two significant
C   modifications since Vers. 91.0510.
C
C          1)  This is the first version to contain an interactive entry
C     of data in lieu of the older card image file format.
C          2)  The calling sequency to find OVER-THE-MUF modes was changed
C     to assure at least an over-the-muf mode for each layer.  The old call
C     sequence was (starting in the hop loop in LUFFY) LUFFY called REGMOD
C     which in turn called FDIST then INMUF before RETURNing to LUFFY with
C     up to 6 modes for each hop. In LUFFY after exiting the hop loop, if
C     no modes were found for the three hop numbers, then INMOD was called
C     which found one over-the-muf mode AND no more. In the new sequence
C xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx continue here
C
C---------------------------------
C
C   VOACAP VERSION 91.0701 of    1 JUL 1991   contains three significant
C   modifications, a cosmetic change, a clerical change, AND one puristic.
C
C          1)  It is the iniTIAL version to provide an option to smooth
C     prediction results between the Short path model AND the Long path
C     model for distances between 7000 AND 10000 kilometers.  This is
C     implemented per VOA Memo of 15 January 1991 by selecting method
C     121 in columns 23 thru 25 on the method card.  All parameters needed
C     in IONANT for this smoothing are automatically output in the binary
C     file when the all modes option is selected by placing 125 in columns
C     23 thru 25.
C          2)  The VHF test output lines have been completely eliminated.
C          3)  Subroutines LNGOUT AND OUTLNG were incomplete AND were
C     never called so they were deleted.
C          4)  This version is the first to have its version number updated
C     with each modification AND to contain a comment section, namely this,
C     which briefly describes the current changes.
C          5)  All output pages generated using this version will automati-
C     cally bear this new version number for reference. The two most signif-
C     icant digits of the version number are the year of the modification,
C     the next two significant digits are the month AND the two least sig-
C     nificant are the day.
C          6)  An option to force an all modes method (METHOD=25) for paths
C     greater than 10,000 kilometers has been added. However when this is
C     selected the short path model is used AND NOT the long path model.
C
C---------------------------------
C
      END
C--------------------------------

      subroutine ccirgain(iant,u, v, z6,giso,gain)
c******************************************************************
c    GAIN CALCULATION  SUBROUTINE
c      INPUT  PARAMETERS:
c          iant = antenna type index number [0-10]
c          u    = elevation angle [0-90]
c          v    = off main beam azimuth angle [0-360]
c          z6   = gain normalizing factor from antinit
c          giso = maximum gain of antenna relative to isotrope (user input)
c      OUTPUT PARAMETERS:
c          gain    = calculated gain returned
c******************************************************************
c       Written by Greg Hand NTIA/ITS Boulder, Colorado   Aug 1991
c       Please call (303)497-3375 with any questions.
c*******************************************************************
c                                antenna floor value
      common /floorc/ floor
      common /ctype11g/ gain_type11(91)
      common /ccirparm/ parm(20)
c
      gain=giso
c                                     iant=0=isotrope
      if(iant.eq.0) return
      if(iant.eq.11) then           ! gain table
         ielev=nint(u)
         if(ielev.lt.0) ielev=0
         if(ielev.gt.90) ielev=90
         gain=giso + gain_type11(ielev+1)
         return
      else if(iant.eq.12) then
         call curtain(parm,v,u,gain,z6)
         gain=gain+giso
         return
      end if
c                                     calculate relative gain
      call gainrel(iant,u,v,z9)
c                                     convert relative to maximum
      if(z6.eq.0.) then
         gain=-floor
         return
      end if
      dgs=z9/z6
      if(dgs.le..03162278) then
         g9=-30.
      else
         g9=20.*alog10(dgs)
      end if
c                                     floor value limit
      if(g9.lt.-floor) g9=-floor 
      gain=g9 + gain
      if(gain.lt.-floor) gain=-floor
      return
      end
c------------------------------------------------------------------

      subroutine circant(lu,nant,antenna)
      character antenna(5)*63
c***********************************************************
      nant=0
10    nant=nant+1
      if(nant.gt.5) go to 910
      read(lu,'(a)') antenna(nant)
      read(antenna(nant),'(5x,i5)',err=900) maxfreq
      if(maxfreq.ne.30) go to 10
      return
c***********************************************************
900   write(*,901)
901   format(' Error READing CIRCUITS.??? data file.',/
     +       ' Maxfreq does not = 30.',/
     +       ' Correct problem and try again.')
      write(*,902) nant,antenna(nant)
902   format(' nant=',i2,'  antenna=',a)
      stop
910   write(*,911)
911   format(' Error READing CIRCUITS.??? data file.',/
     +       ' More than 5 antennas defined for 1 circuit.',/
     +       ' Correct problem and try again.')
      stop
      end
c------------------------------------------------------------

c###seltxr.for
      SUBROUTINE SELTXR
c***********************************************
c          Alex Shovkoplyas made some changes to:
c             curmuf
c             seltxr
c             settxr
c             sigdis
c          Normally if the version (..\database\version.w32)
c             is yy.mmddW then the original version is used.
c                yy.mmddA then Alex's version is used.
c***********************************************
      use cversn
c jw     common /CVERSN/ VERSN
c jw     character VERSN*8
      if(versn(8:8).eq.'A' .or. versn(8:8).eq.'a') then
         call seltxr_alex       !  use Alex's modified version
      else
         call seltxr_orig       !  use original version
      end if
      return
      end
C--------------------------------
      SUBROUTINE SELTXR_orig
C--------------------------------
C------------ SUBROUTINES SELRCR AND SELTMT COMBINED  1/10/91 FJR
C
C     THIS SUBROUTINE SELECTS THE OPTIMUM TRANSMISSION ANGLE
C     (NOTE THAT THIS IS AT THE TRANSMITTER/RECEIVER ENDS)
C
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/LOSX/ANDVX(45,3),ADVX(45,3),AOFX(45,3),ARFX(45,3),GRLOSX(45
     A ,3),TGAINX(45,3),TLSKM(45,3),EFFlp(45),IAFTXR(3)
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON/INFORM/INFO,IHSHR,IHLNG
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      DO 1000 JJ=1,2
      K=ITXRCP(JJ)
      DEND = AMIN1(GCDKM,4000.)
      LTXRGM(JJ) = 1
C.....ONE MODE GOOD, AS OVER THE MUF FORCED
      GO TO 105
   95 LTXRGM(JJ) = LTXRGM(JJ)-1
      IF(IAND(INFO,8).GT.0)THEN
        IF(LTXRGM(JJ).GT.1)THEN
          WRITE(99,'(13h "SELTXR" JJ=,I1,27h  CHANGE IN MODE INDEX FROM,
     1    9h "1" TO ",I2,25H" USING "LTXRGM-1" VICE 1)')JJ,LTXRGM(JJ)
        ENDIF
      ENDIF
      GO TO 1000
C.....FIND FIRST GOOD MODE (START)
  105 XHPM = DEND / GDFLX(LTXRGM(JJ),K)
      IHOP = XHPM
      IF(XHPM - 0.9) 110, 115, 115
  110 LTXRGM(JJ) = LTXRGM(JJ)+1
      IF(HPFLX(LTXRGM(JJ),K).LE.70.)GO TO 95
C.....CHECK MINIMUM ANGLE
      IF(LTXRGM(JJ) - IAFTXR(K)) 112, 112, 95
  112 IF(DELFX(LTXRGM(JJ),K) - AMIND) 110, 115, 115
  115 HOPX = IHOP
      YHPM = XHPM- HOPX
c------      IF(YHPM -.05) 120,120,116
c------      Changed 9/23/91 to reflect proper parTIAL hop.   FJR
C------      IF(YHPM -.5) 120,120,116
      IST=2
      IDNXS=LTXRGM(JJ)
      IF(IAND(INFO,4).GT.0)IST=1
      DO 999 IDF=IST,2
      IF(IDF.EQ.2)THEN
        XFRACT=0.5
        LTXRGM(JJ)=IDNXS
      ELSE
        XFRACT=.05
      ENDIF
      IF(YHPM - XFRACT)120,120,116
C.....HOP INCREMENT
  116 YHPM = 1.-YHPM
C.....GAIN-LOSS
  120 GMAX =TGAINX(LTXRGM(JJ),K)-XHPM*(ANDVX(LTXRGM(JJ),K)
     +  +ADVX(LTXRGM(JJ),K))
C.....ANGLE INCREMENT
      DELMAX= ABS(DELFX(LTXRGM(JJ),K) - DELOPT)
C.....FIND FIRST GOOD MODE (END)
      LS = LTXRGM(JJ)
      DO 165  IA=LS,IAFTXR(K)
C.....DOES THE MODE EXIST (QUESTION MARK)
      IF(HPFLX(IA,K) - 70.) 165,165,125
C.....NUMBER OF HOPS
  125 XHOP = DEND / GDFLX(IA,K)
      IHOP = XHOP
C.....AT LEAST NEAR 1
      IF(XHOP - 0.9) 165, 126, 126
  126 CONTINUE
      HOPX = IHOP
      YHOP = XHOP - HOPX
      IF( YHOP - 0.5) 135,135,130
C.....HOP INCREMENT
  130 YHOP = 1.-YHOP
C.....GAIN-LOSS
  135 GNOW = TGAINX(IA,K) - XHOP * (ANDVX(IA,K) + ADVX(IA,K))
      GML(IA,K)=GNOW
      FHP(IA,K)=YHOP
C.....ANGLE INCREMENT
      DELNOW = ABS(DELFX(IA,K) - DELOPT)
C  FIRST CHOICE ON SMALLEST GAIN MINUS LOSS.
      IF(ABS(GNOW -GMAX) - GMIN) 145,145,140
  140 IF( GNOW - GMAX) 165,165,160
C SECOND CHOICE ON CLOSEST TO SPECULAR REFLECTION (INTEGER NO. OF HOPS).
  145 IF( ABS(YHOP -YHPM) -YMIN)  155,155,150
  150 IF( YHOP - YHPM)  160,165,165
C THIRD   CHOICE ON CLOSEST TO APRIORI OPTIMUM TAKEOFF ANGLE.
  155 IF( DELNOW -DELMAX) 160,165,165
  160 LTXRGM(JJ) = IA
      XHPM = XHOP
      GMAX = GNOW
      DELMAX = DELNOW
      YHPM   = YHOP
  165 CONTINUE
      IF(IST.EQ.1)THEN
        IF(IDF.EQ.1)THEN
          LSAV=LTXRGM(JJ)
        ELSE
          IF(LTXRGM(JJ).NE.LSAV)THEN
            WRITE(99,'(A,I2,A,A,I3,A,I3)')' "SELTXR" JJ= ',JJ,'  CHANG',
     1      'ING FROM 0.05 TO 0.5 CHANGED SELECT MODE FROM ',LSAV,' TO',
     2      LTXRGM(JJ)
          ENDIF
        ENDIF
      ENDIF
  999 CONTINUE
 1000 CONTINUE
      RETURN
      END
C--------------------------------
c###seltxr.for
      SUBROUTINE SELTXR_alex
C--------------------------------
C------------ SUBROUTINES SELRCR AND SELTMT COMBINED  1/10/91 FJR
C
C     THIS SUBROUTINE SELECTS THE OPTIMUM TRANSMISSION ANGLE
C     (NOTE THAT THIS IS AT THE TRANSMITTER/RECEIVER ENDS)
C
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/LOSX/ANDVX(45,3),ADVX(45,3),AOFX(45,3),ARFX(45,3),GRLOSX(45
     A ,3),TGAINX(45,3),TLSKM(45,3),EFFlp(45),IAFTXR(3)
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON/INFORM/INFO,IHSHR,IHLNG
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      DO 1000 JJ=1,2
      K=ITXRCP(JJ)
      DEND = AMIN1(GCDKM,4000.)
c>>>>>A.S.  
c     find the first good mode
c     at least one good mode is alvays available
c     finding it is easy since all bad modes now have HPFLX = 0
c     and all good modes have HPFLX > 0
      DO 310 IA=1,45
      IF(HPFLX(IA,K) .GE. 70.) THEN
        LTXRGM(JJ) = IA
        GOTO 320 !mode found, exit the loop
        ENDIF
310   CONTINUE      
320   XHPM = DEND / GDFLX(LTXRGM(JJ),K)
      IHOP = XHPM
c<<<<< 
  115 HOPX = IHOP
      YHPM = XHPM- HOPX
c------      IF(YHPM -.05) 120,120,116
c------      Changed 9/23/91 to reflect proper parTIAL hop.   FJR
C------      IF(YHPM -.5) 120,120,116
      IST=2
      IDNXS=LTXRGM(JJ)
      IF(IAND(INFO,4).GT.0)IST=1
      DO 999 IDF=IST,2
      IF(IDF.EQ.2)THEN
        XFRACT=0.5
        LTXRGM(JJ)=IDNXS
      ELSE
        XFRACT=.05
      ENDIF
      IF(YHPM - XFRACT)120,120,116
C.....HOP INCREMENT
  116 YHPM = 1.-YHPM
C.....GAIN-LOSS
  120 GMAX =TGAINX(LTXRGM(JJ),K)-XHPM*(ANDVX(LTXRGM(JJ),K)
     +  +ADVX(LTXRGM(JJ),K))
C.....ANGLE INCREMENT
      DELMAX= ABS(DELFX(LTXRGM(JJ),K) - DELOPT)
C.....FIND FIRST GOOD MODE (END)
      LS = LTXRGM(JJ)
      DO 165  IA=LS,IAFTXR(K)
C.....DOES THE MODE EXIST (QUESTION MARK)
      IF(HPFLX(IA,K) - 70.) 165,165,125
C.....NUMBER OF HOPS
  125 XHOP = DEND / GDFLX(IA,K)
      IHOP = XHOP
C.....AT LEAST NEAR 1
c>>>>>A.S. 
c      this line was causing problems and has been removed
c      no need to check XHOP 
c      since all bad modes now have HPFLX = 0
c      IF(XHOP - 0.9) 165, 126, 126
c<<<<< 
  126 CONTINUE
      HOPX = IHOP
      YHOP = XHOP - HOPX
      IF( YHOP - 0.5) 135,135,130
C.....HOP INCREMENT
  130 YHOP = 1.-YHOP
C.....GAIN-LOSS
  135 GNOW = TGAINX(IA,K) - XHOP * (ANDVX(IA,K) + ADVX(IA,K))
      GML(IA,K)=GNOW
      FHP(IA,K)=YHOP
C.....ANGLE INCREMENT
      DELNOW = ABS(DELFX(IA,K) - DELOPT)
C  FIRST CHOICE ON SMALLEST GAIN MINUS LOSS.
      IF(ABS(GNOW -GMAX) - GMIN) 145,145,140
  140 IF( GNOW - GMAX) 165,165,160
C SECOND CHOICE ON CLOSEST TO SPECULAR REFLECTION (INTEGER NO. OF HOPS).
  145 IF( ABS(YHOP -YHPM) -YMIN)  155,155,150
  150 IF( YHOP - YHPM)  160,165,165
C THIRD   CHOICE ON CLOSEST TO APRIORI OPTIMUM TAKEOFF ANGLE.
  155 IF( DELNOW -DELMAX) 160,165,165
  160 LTXRGM(JJ) = IA
      XHPM = XHOP
      GMAX = GNOW
      DELMAX = DELNOW
      YHPM   = YHOP
  165 CONTINUE
      IF(IST.EQ.1)THEN
        IF(IDF.EQ.1)THEN
          LSAV=LTXRGM(JJ)
        ELSE
          IF(LTXRGM(JJ).NE.LSAV)THEN
            WRITE(99,'(A,I2,A,A,I3,A,I3)')' "SELTXR" JJ= ',JJ,'  CHANG',
     1      'ING FROM 0.05 TO 0.5 CHANGED SELECT MODE FROM ',LSAV,' TO',
     2      LTXRGM(JJ)
          ENDIF
        ENDIF
      ENDIF
  999 CONTINUE
 1000 CONTINUE
      RETURN
      END
C--------------------------------

c###getkmf.for
      SUBROUTINE GETKMF
C--------------------------------
C.....MUF AS A FUNCTION OF K LINES
C.....NOT YET DEVELOPED (METHOD 12)
      RETURN
      END
C--------------------------------

c###ef1var.for
      SUBROUTINE EF1VAR (CYCEN, II)
C--------------------------------
C
C     THIS ROUTINE EVALUATES E AND F1 LAYER IONOSPHERIC PARAMETERS
C
C CYCEN IS SUN ZENITH ANGLE, RADIANS.
C II IS SAMPLE AREA
      COMMON / PSCA / PSC(4), PSCB(4), IPSC
C
      COMMON / MFAC / F2M3(5),HPF2(5),ZENANG(5),ZENMAX(5),IEDP,FSECV(3)
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON /A11 /GAMMA (6)
      COMMON /FONE/ ANEW(3),BNEW(3),ACHI(2),BCHI(2)
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON /GEOG /GYZ (5), RAT (5), GMDIP (5), CLCK (5), ABIY (5), ART
     1IC (5), SIGPAT (5), EPSPAT (5)
      COMMON / SSP / SUN(2,12), MONTH
C.....RATIOS OF HEIGHT OF MAXIMUM IONIZATION TO SEMITHICKNESS
      DATA BETAE/5.5/, BETAF1/4.0/
C.....EVALUATE E LAYER CRITICAL FREQUENCY
      CALL VERSY(6, 6, II)
      IF(GAMMA(6) - 0.36) 85, 90, 90
C.....BAD VALUE FOR MAP, USE MIDNIGHT VALUE
   85 GAMMA(6) = 0.36 * SQRT(1. + 0.0098 * SSN)
   90 CONTINUE
C.....FI(1,II) IS E LAYER CRITICAL FREQUENCY
C.....HI(1,II) IS E LAYER HEIGHT OF MAXIMUM IONIZATION
C.....YI(1,II) IS E LAYER SEMITHICKNESS
      FI (1, II) = GAMMA (6) * PSC (1)
      HI (1, II) = 110.
      YI (1, II) = HI (1, II) / BETAE
      CYCEN = ABS (CYCEN)
      Z = CYCEN * R2D
      COSZ = COS (CYCEN)
C.....COSINE OF RAWER MAGNETIC DIP ANGLE
      COSDI = COS (GMDIP (II))
C.....MAXIMUM ZENITH ANGLE FOR F1 LAYER
      ZMAX = ACHI(1)+BCHI(1)*SSN + (ACHI(2)+BCHI(2)*SSN)*COSDI
      ZENMAX(II) = ZMAX
      ZENANG(II) = Z
      IF(Z.le.ZMAX) then
         FI(2,II)=(ANEW(1)+BNEW(1)*SSN) + (ANEW(2)+BNEW(2)*SSN)*COSZ
     A          + (ANEW(3)+BNEW(3)*SSN)*COSZ*COSZ
C.....FI(2,II) IS F1 LAYER CRITICAL FREQUENCY
C.....HI(2,II) IS F1 LAYER HEIGHT OF MAXIMUM IONIZATION
C.....YI(2,II) IS F1 LAYER SEMITHICKNESS
         FI(2,II)=FI(2,II)*PSC(2)
         HI(2,II)=165. + 0.6428*Z
         YI(2,II)=HI(2,II)/BETAF1
      else
         FI(2,II)=0.0
         HI(2,II)=0.0
         YI(2,II)=0.0
      end if
      RETURN
      END
C--------------------------------

      subroutine batch_S(lu,model,filein,icircuit,*)  ! Point-to-Point BATCH
c**************************************************************************
c          New special BATCH method that takes a standard IONCAP input
c          deck and runs each circuit separately.
c**************************************************************************
c          lu = file unit open of IONCAP full input deck
c          model = VOACAP or ICEPAC
c          filein = file to create the input data on
c          icircuit = circuit number to be processed
c          * = alternate return when done or if error occurs
c**************************************************************************
      use voacapl_defs
      use crun_directory
      character model*6,filein*(*)
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      common /card_deck/ ncards,cards(50)
         character cards*80
      common /Cantenna_deck/ nantennas,antennas(22)
         character antennas*80
      character alf*80

      new=0
      icircuit=icircuit+1
      if(icircuit.ne.1) go to 100  !  process up to the next execute card
c          read up to the 1st execute card
      ncards=0
      nantennas=0
10    read(lu,'(a)',end=998) alf
      if(alf(1:1).eq.' ') go to 10     !  skip blank cards
      if(alf(1:10).ne.'ANTENNA   ') go to 20
         nantennas=nantennas+1
         antennas(nantennas)=alf
      go to 10
20    if(alf(1:10).eq.'EXECUTE') go to 200   !  process the deck
      ncards=ncards+1
      cards(ncards)=alf
      if(ncards.lt.49) go to 10
      write(*,'('' Batch input deck contains too many cards'')')
      go to 998
c          read new cards and replace
100   read(lu,'(a)',end=998) alf
      if(alf(1:10).eq.'EXECUTE   ') go to 200     !  EXECUTE
      if(alf(1:10).eq.'QUIT      ') go to 998     !  QUIT
      if(alf(1:1).eq.' ') go to 100               !  skip blank cards
      if(alf(1:10).eq.'ANTENNA   ') then          !  ANTENNA card match test
         if(new.eq.0) then
            nantennas=0
            new=1
         end if
         nantennas=nantennas+1
         antennas(nantennas)=alf
         go to 100
      end if
      do 110 i=1,ncards
      if(cards(i)(1:10).eq.alf(1:10)) go to 150   !  Match
110   continue
      go to 100         !  match not found
150   cards(i)=alf      !  substitute new card
      go to 100
c**************************************************************
c          save deck and process
c200   nch_run=lenchar(run_directory)
200   continue    
      open(31,file=trim(run_directory)//PATH_SEPARATOR//model//'x.dat')
      rewind(31)
      do 210 i=1,ncards
      nch=lenchar(cards(i))
210   write(31,'(a)') cards(i)(1:nch)
      do 220 i=1,nantennas
      nch=lenchar(antennas(i))
220   write(31,'(a)') antennas(i)(1:nch)
      write(31,221)
221   format('EXECUTE',/,'QUIT')
      close(31)
      write(*,'('' Processing #'',i5)') icircuit
      return
c********************************************************
998   write(*,'(i5,'' Batch circuits processed'')') icircuit-1
      write(*,997) model
997   format(' Batch processing for ',a,' is complete.',/
     +       ' You may close this output window now.')
      close(lu)
c          file does not exist or end of file encountered
      return 1
      end
c----------------------------------------------------------------

      subroutine getfiles(directory,list,nmax,num,*)
c*******************************************************************
c         get list of antenna file names
c         from the directory ..\ANTENNAS\directory
c*******************************************************************
      use voacapl_defs
      character directory*8,filename*12,description*63,list(*)*77
      nchdir=lcount(directory,8)
c jw TODO Look at the folloing to see if it's required...
      ier=isystem('dir ..\antennas\'//directory(1:nchdir)//
     +            '\*.* /one /b /-p>antfiles.lst',16+nchdir+29)
      open(31,file='antfiles.lst',status='old',err=900)
      rewind(31)
      num=0
10    read(31,'(a)',end=100) filename
      if(filename(1:8).eq.'Path not') go to 920     !  directory does not exist
      open(32,file='..'//PATH_SEPARATOR//'antennas'//PATH_SEPARATOR//directory(1:nchdir)//PATH_SEPARATOR//filename,
     +       status='old',err=910)
      rewind(32)
      read(32,'(a)') description
      close(32)
      num=num+1
      list(num)=' '//filename//' '//description
      if(num.lt.nmax) go to 10
100   close(31)
      ier=isystem('del antfiles.lst',16)
      return
900   stop 'In GETFILES Could not OPEN file=antfiles.lst'
910   write(*,911) '..'//PATH_SEPARATOR//'antennas'//PATH_SEPARATOR//directory(1:nchdir)//PATH_SEPARATOR//filename
911   format(' Could not OPEN file=',a)
      pause 'OPEN error in getfiles'
      return
920   close(31)           !  directory does not exist
      return 1
      end
c---------------------------------------------------------------

c###fobby.for
      SUBROUTINE FOBBY(K)
C--------------------------------
C
C     THIS ROUTINE CALCULATES OBLIQUE FREQUENCIES FOR REFLECTRIX (KHZ)
C
C     THE SIZE OF THE TABLE IS REDUCED BY CALCULATION OF NANG IN
C     SUBROUTINE SANG
C
C--------------------------------
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2

ccc      COMMON / ALPHA / IMON(12), IRCVR(2), ITRAN(2), MODE(13),
ccc     A MODER(13), IRLAT, IRLONG, ITLAT, ITLONG, NYEAR
ccc      CHARACTER IMON*3,  IRCVR*10, ITRAN*10,MODE*2, MODER*2,
ccc     1 IRLAT*1, IRLONG*1, ITLAT*1, ITLONG*1,NYEAR*5

      COMMON / SSP / SUN(2,12), MONTH
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON/RAYS/ANG(40),IFOB(40,30,5),NANG
      COMMON/INFORM/INFO,IHSHR,IHLNG
ccc      write(72,1) k,d2r,rz
ccc1     format(' in fobby, k,d2r,rz=',i5,2e15.7)
      DO 650 IA=1,NANG
ccc      write(72,'('' ia='',i5)') ia
      DEL = ANG (IA) * D2R
      RCOSD = RZ * COS (DEL)
      DO 645 IH = 1, 30
ccc      write(72,'('' ih='',i5)') ih
      FV = FVERT (IH, K)
C.....TRUE HEIGHT SO NO K FACTOR
      SPHE = RCOSD / (RZ + HTRUE (IH, K))
      SQCOS = 1. - SPHE * SPHE
      SQCOS = AMAX1 (.000001, SQCOS)
      CPHE = SQRT (SQCOS)
      FREQ = FV / CPHE
      IFOB (IA, IH, K) = 1000. * FREQ
  645 CONTINUE
  650 CONTINUE
      RETURN
      END
C--------------------------------

c###noisy.for
      SUBROUTINE NOISY (KJ, XLA, CEG, ANOS)
C--------------------------------
C     NOISY IS A GENERAL PURPOSE ROUTINE USED TO EVALUATE A FOURIER
C     SERIES IN TWO VARIABLES.
C     KJ --- NUMBER OF FOURIER COEFFICIENT ARRAY TO BE USED
C     XLA --- GEOGRAPHIC LATITUDE, DEGREES,
C     CEG --- GEOGRAPHIC EAST LONGITUDE, DEGREES
C     ANOS --- NOISE VALUE, MEDIAN POWER DB ABOVE KTB
C     ABP --- NORMALIZING FACTORS FOR FOURIER SERIES
C     KJ = 1 TO 6 IS ATMOSPHERIC NOISE, KJ = 7 IS LAND MASS MAP AND
C     KJ = 8 IS RATIO OF F2 HEIGHT OF MAXIMUM TO SEMITHICKNESS
C
C     * NOTE - XLA, CEG, ANOS, ABP ARE NOT ALWAYS AS PREVIOUSLY DEFINED
C     FOURIER VARIABLES AND ATMOSPHERIC RADIO NOISE
C
      COMMON / TWO / F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     A FAM(14,12), SYS(9,16,6), PERR(9,4,6)
      DIMENSION SX (15), ZZ (29)
      ALF = ABP (1, KJ)
      BET = ABP (2, KJ)
      IF (KJ - 8)105, 100, 105
C.....LIMITS OF FOURIER SERIES
  100 LM = 15
      LN = 10
      GO TO 110
C.....LIMITS OF FOURIER SERIES
  105 LM = 29
      LN = 15
C.....HALF ANGLE (IN RADIANS)
  110 Q = .0087266466 * CEG
C.....LONGITUDE SINES
      C1 = COS (Q)
      S1 = SIN (Q)
      SX (1) = S1
      CX = C1
      IF (LN .LT. 2) GO TO 140
      DO 115 K = 2, LN
      TX = SX (K - 1)
      SX (K) = TX * C1 + CX * S1
  115 CX = CX * C1 - TX * S1
  140 CONTINUE
      IF (LM .LT. 1) GO TO 145
C.....LONGITUDE SERIES
      DO 125 J = 1, LM
      R = 0.
      IF (LN .LT. 1) GO TO 160
      DO 120 K = 1, LN
  120 R = R + SX (K) * P (J, K, KJ)
  160 CONTINUE
  125 ZZ (J) = R + P (J, 16, KJ)
  145 CONTINUE
C.....ANGLE PLUS 90 DEGREES (IN RADIANS)
      Q = .01745329252 * (XLA + 90.)
C.....LATITUDE SERIES
      S1 = SIN (Q)
      C1 = COS (Q)
      SX (1) = S1
      CX = C1
      R = 0.
      IF (LM .LT. 1) GO TO 165
      DO 130 K = 1, LM
      R = R + SX (1) * ZZ (K)
      SS = SX (1) * C1 + CX * S1
      CX = CX * C1 - SX (1) * S1
  130 SX (1) = SS
  165 CONTINUE
C.....FINAL FOURIER SERIES EVALUATION (NOTE LINEAR NORMALIZATION)
      ANOS = R + ALF + BET * Q
      RETURN
      END
C--------------------------------

       subroutine DAZEL0(ZTLAT,ZTLON,ZRLAT,ZRLON,ZTAZ,ZDGC)
C#  SUB DAZEL0             Great circle calculations. (same as DAZEL(0))
       IMPLICIT DOUBLE PRECISION(A-L,N-Y)
C
C     TWO MODES--   0   INPUT LAT AND LON OF END POINT
C                       RETURN DISTANCE AND AZIMUTH TO END PT WITH ELEVATIONS
C                   1   INPUT BEARING (AZIMUTH) OF END POINT
C                       RETURN LAT AND LON OF END POINT WITH ELEVATIONS
C
C   MODE 0
C   INPUT PARAMETERS (THESE DEFINE LOCATION OF POINTS T (TRANSMITTER)
C     AND R (RECEIVER) RELATIVE TO A SPHERICAL EARTH.
C     ZTLAT - LATITUDE (DECIMAL DEGREES NORTH OF EQUATOR) OF POINT T
C     ZTLON - LONGITUDE (DECIMAL DEGREES EAST OF PRIME (GREENWICH)
C            MERIDIAN) OF POINT T
C     ZTHT  - HEIGHT (METERS ABOVE MEAN SEA LEVEL) OF POINT T
C     ZRLAT - LATITUDE (DECIMAL DEGREES NORTH OF EQUATOR) OF POINT R
C     ZRLON - LONGITUDE (DECIMAL DEGREES EAST OF PRIME MERIDIAN OF POINT R
C     ZRHT  - HEIGHT (METERS ABOVE MEAN SEA LEVEL) OF POINT R
C
C   OUTPUT PARAMETERS
C     ZTAZ  - AZUMUTH (DECIMAL DEGREES CLOCKWISE FROM NORTH) AT T OF R
C     ZRAZ  - AZIMUTH (DECIMAL DEGREES CLOCKWISE FROM NORTH) AT R OF T
C     ZTELV - ELEVATION ANGLE (DECIMAL DEGREES ABOVE HORIZONTAL AT T
C            OF STRAIGHT LINE BETWEEN T AND R
C     ZRELV - ELEVATION ANGLE (DECIMAL DEGREES ABOVE HORIZONTAL AT R)
C            OF STRAIGHT LINE BETWEEN T AND R
C     ZTAKOF - TAKE-OFF ANGLE (DECIMAL DEGREES ABOVE HORIZONTAL AT T)
C            OF REFRACTED RAY BETWEEN T AND R (ASSUMED 4/3 EARTH RADIUS)
C     ZRAKOF - TAKE-OFF ANGLE (DECIMAL DEGREES ABOVE HORIZONTAL AT R)
C            OF REFRACTED RAY BETWEEN T AND R (ASSUMED 4/3 EARTH RADIUS)
C     ZD    - STRAIGHT LINE DISTANCE (KILOMETERS) BETWEEN T AND R
C     ZDGC  - GREAT CIRCLE DISTANCE (KILOMETERS) BETWEEN T AND R
C
C   MODE 1
C   INPUT PARAMETERS                    OUTPUT PARAMETERS
C     ZTLAT                                ZRLAT
C     ZTLON                                ZRLON
C     ZTAZ                                 RELEV,ZRAKOF
C     ZDGC                                 TELEV,ZTAKOF
C
C
C     ALL OF THE ABOVE PARAMETERS START WITH THE LETTER Z AND ARE SINGLE
C     PRECISION.  ALL PROGRAM VARIABLES ARE DOUBLE PRECISION.
C     PROGRAM IS UNPREDICTABLE FOR SEPARATIONS LESS THAN 0.00005 DEGREES,
C     ABOUT 5 METERS.
C
C   WRITTEN BY KEN SPIES 5/79
C   REFRACTION AND ST. LINE ELEVATIONS BY EJH
C
c                          RERTH changed (from 6368.) 2/26/93 by Greg hand
      DATA PI/3.141592653589793238462643D0/,RERTH/6370.0D0/
      DATA DTOR/0.01745329252D0/,RTOD/57.29577951D0/
      DATA ZTHT,ZRHT/0.,0./
       TLATS=ZTLAT
       TLONS=ZTLON
       THTS=ZTHT*1.0E-3
       RLATS=ZRLAT
       RLONS=ZRLON
       RHTS=ZRHT*1.0E-3
       IF(TLATS.LE.-90.) TLATS=-89.999
       IF(TLATS.GE. 90.) TLATS=89.999
       IF(RLATS.LE.-90.) RLATS=-89.999
       IF(RLATS.GE. 90.) RLATS=89.999
c          bad things happen when points are directly opposite
c          the angle is undefined!!!  (move receiver a little)
       if(abs(abs(tlons-rlons)-180.).le..001 .and.
     +    abs(tlats+rlats).le..002) then
          rlats=rlats+.1
          if(rlats.ge.90.) rlats=89.9
       end if
       DELAT=RLATS-TLATS
       ADLAT=DABS(DELAT)
       DELON=RLONS-TLONS
       IF(DELON-(-180.0))12,16,16
12     DELON=DELON+360.0
       IF(DELON-(-180.0))12,20,20
16     IF(DELON-180.0)20,20,18
18     DELON=DELON-360.0
       IF(DELON-180.0)20,20,18
20     ADLON=DABS(DELON)
       DELHT=RHTS-THTS
       IF(ADLON-1.0E-5)22,22,55
22     IF(ADLAT-1.0E-5)24,24,40
C
C   POINTS T AND R HAVE THE SAME COORDINATES
C
24     ZTAZ=0.0
       ZRAZ=0.0
       IF(DELHT)25,30,35
25     ZTELV=-90.0
       ZRELV=90.0
       ZD=-DELHT
      ZDGC=0.0
       RETURN
30     ZTELV=0.0
       ZRELV=0.0
       ZD=0.0
      ZDGC=0.0
       RETURN
35     ZTELV=90.0
       ZRELV=-90.0
       ZD=DELHT
      ZDGC=0.0
       RETURN
C
C   POINTS T AND R HAVE SAME LONGITUDE, DISTINCT LATITUDES
C
40     IF(DELAT-0.0)42,42,45
42     ZTAZ=180.0
       ZRAZ=0.0
       GO TO 50
45     ZTAZ=0.0
       ZRAZ=180.0
50     GC=ADLAT*DTOR
       SGC=DSIN(0.5*GC)
       D=DSQRT(DELHT*DELHT+4.0*(RERTH+THTS)*(RERTH+RHTS)*SGC*SGC)
      ZD=D
       GO TO 140
C
C   POINTS TAND R HAVE DISTINCT LONGITUDES
C
55     IF(DELON-0.0)56,56,60
56     WLAT=RLATS*DTOR
       ELAT=TLATS*DTOR
       GO TO 65
60     WLAT=TLATS*DTOR
       ELAT=RLATS*DTOR
C
C   CALCULATE AZIMUTHS AT POINTS W AND E
C
65     SDLAT=DSIN(0.5*ADLAT*DTOR)
       SDLON=DSIN(0.5*ADLON*DTOR)
       SADLN=DSIN(ADLON*DTOR)
       CWLAT=DCOS(WLAT)
       CELAT=DCOS(ELAT)
       P=2.0*(SDLAT*SDLAT+SDLON*SDLON*CWLAT*CELAT)
       SGC=DSQRT(P*(2.0-P))
       SDLAT=DSIN(ELAT-WLAT)
       CWAZ=(2.0*CELAT*DSIN(WLAT)*SDLON*SDLON+SDLAT)/SGC
      SWAZ=SADLN*CELAT/SGC
      WAZ=DATAN2(SWAZ,CWAZ)*RTOD
       CEAZ=(2.0*CWLAT*DSIN(ELAT)*SDLON*SDLON-SDLAT)/SGC
      SEAZ=SADLN*CWLAT/SGC
      EAZ=DATAN2(SEAZ,CEAZ)*RTOD
110    EAZ=360.0-EAZ
       IF(DELON-0.0)111,111,115
111    ZTAZ=EAZ
       ZRAZ=WAZ
       GO TO 120
115    ZTAZ=WAZ
       ZRAZ=EAZ
C
C
C   COMPUTE THE STRAIGHT LINE DISTANCE AND GREAT CIRCLE ANGLE BETWEEN T AND R
C
120    D=DSQRT(DELHT*DELHT+2.0*(RERTH+THTS)*(RERTH+RHTS)*P)
      ZD=D
       CGC=1.0-P
      GC=DATAN2(SGC,CGC)
C
C   COMPUTE GREAT CIRCLE DISTANCE AND ELEVATION ANGLES
C
140   ZDGC=GC*RERTH
       RETURN
      END
C------------------------------------------------------------------

      program coefbinw   !  make coeffxxW.bin files from coeffxx.asc files
c                        !  this is for Salford FTN77 windows version
c**********************************************************************
c          This was created Jan 1995 by Greg Hand so that there would be
c          a common set of coefficients between ICEPAC, VOACAP, & REC533.
c          Also, text records were added to the ASCII files so that they
c          made some sense.
c**********************************************************************
      common /ccir/ 
     +ANEW(3),BNEW(3),ACHI(2),BCHI(2),FAKMAP(29,16),ABMAP(2,3),
     +F2D(16,6,6),DUD(5,12,5),FAM(14,12),SYS(9,16,6),PERR(9,4,6),
     +FAKP(29,16,6),FAKABP(2,6),
     +IKIM(10,6), XF2COF(13,76,2),
     +XESMCF(7,61,2),XPMAP(29,16,2),
     +XESLCF(5,55,2), XESUCF(5,55,2),
     +XFM3CF(9,49,2),
     +XERCOF(9,22,2)
      character filein*12,fileout*12,name*40
c**********************************************************************
c     Modified to accept an (optional) arguement specifying 
c     the directory containing the .asc files.
      character (len=128) :: working_dir=''
      if (COMMAND_ARGUMENT_COUNT() == 1) then
         call GET_COMMAND_ARGUMENT(1, working_dir)
         working_dir = trim(working_dir)//"/"
      endif
c**********************************************************************
      do 100 month=1,12
      write(filein ,'(5hcoeff,i2.2,4h.asc)') month
      write(fileout,'(5hcoeff,i2.2,5hw.bin)') month
      print *,trim(working_dir)//filein
      open(19,file=trim(working_dir)//filein,status='old')
      rewind(19)
      open(20,file=trim(working_dir)//fileout,form='unformatted')
      rewind(20)
      write(*,1) filein,fileout
1     format(' Using:',a,' to create:',a)
      read (19,2) mon
2     format(6x,i2)
      if(month.ne.mon) stop 'month does not match'
      read (19,98) name
      if(name(1:4).ne.'IKIM') stop 'name does not match IKIM'
      read (19,97) IKIM
97    format(10I5)
      read (19,98) name
      if(name(1:3).ne.'DUD') stop 'name does not match DUD'
      read (19,99) DUD
      read (19,98) name
      if(name(1:3).ne.'FAM') stop 'name does not match FAM'
      read (19,99) FAM
      read (19,98) name
      if(name(1:3).ne.'SYS') stop 'name does not match SYS'
      read (19,99) SYS
      read (19,98) name
      if(name(1:4).ne.'FAKP') stop 'name does not match FAKP'
      read (19,99) FAKP
      read (19,98) name
      if(name(1:6).ne.'FAKABP') stop 'name does not match FAKABP'
      read (19,99) FAKABP
      read (19,98) name
      if(name(1:6).ne.'XFM3CF') stop 'name does not match XFM3CF'
      read (19,99) XFM3CF
      read (19,98) name
      if(name(1:31).ne.'ANEW(3),BNEW(3),ACHI(2),BCHI(2)') 
     +   stop 'name does not match ANEW,BNEW,ACHI,BCHI'
      read (19,99) ANEW,BNEW,ACHI,BCHI
      read (19,98) name
      if(name(1:6).ne.'FAKMAP') stop 'name does not match FAKMAP'
      read (19,99) FAKMAP
      read (19,98) name
      if(name(1:5).ne.'ABMAP') stop 'name does not match ABMAP'
      read (19,99) ABMAP
      read (19,98) name
      if(name(1:3).ne.'F2D') stop 'name does not match F2D'
      read (19,99) F2D
      read (19,98) name
      if(name(1:4).ne.'PERR') stop 'name does not match PERR'
      read (19,99) PERR
      read (19,98) name
      if(name(1:6).ne.'XESMCF') stop 'name does not match XESMCF'
      read (19,99) XESMCF
      read (19,98) name
      if(name(1:5).ne.'XPMAP') stop 'name does not match XPMAP'
      read (19,99) XPMAP
      read (19,98) name
      if(name(1:6).ne.'XESLCF') stop 'name does not match XESLCF'
      read (19,99) XESLCF
      read (19,98) name
      if(name(1:6).ne.'XESUCF') stop 'name does not match XESUCF'
      read (19,99) XESUCF
      read (19,98) name
      if(name(1:6).ne.'XERCOF') stop 'name does not match XERCOF'
      read (19,99) XERCOF
98    format(a)
99    format(6e15.8)
      close(19)
c          these are common to all (icepac,voacap,rec533)
      write(20) IKIM
      write(20) FAKP,FAKABP
      write(20) DUD,FAM,SYS
      write(20) XFM3CF
c          the rest are for ICEPAC & VOACAP only
      write(20) F2D,PERR
      write(20) ANEW,BNEW,ACHI,BCHI,FAKMAP,ABMAP
      write(20) XESMCF,XPMAP
      write(20) XESLCF, XESUCF
      write(20) XERCOF
      close(20)
100   continue
      end
c--------------------------------------------------------------------

c###hfmufs2.for
      SUBROUTINE HFMUFS2(fileout,*)   !  for vs DISTANCE & vs TIME plots
      use crun_directory
      use cversn
! TODO Do we need fileout any more?
      character fileout*64
      common /cdistance/ idistance,ndistance,ihr    !  plot vs distance
      common /ctime/ ntime                          !  plot vs time
      common /cnfreqs/ nfreqs
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      common /cdaily/ idaily(12)
      common /Cday/ iday
C--------------------------------
C
C     THIS IS THE PROGRAM CONTROL SUBROUTINE
C     ITRUN CONTROLS PROGRAM TASK, ITOUT CONTROLS PROGRAM OUTPUT.
C
      common /chours/ nhours,ihours(24)
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/LPATH/ GCDLNG,TXRGML(45,2),DELOPT,GMIN,YMIN,LTXRGM(2)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
c jw      common /CVERSN/ VERSN
c jw         character VERSN*8
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON / SSP / SUN(2,12), MONTH
      COMMON/TON/ADJ,ADS,GNOS,GOT,REL,SL,SLS,SPR,SU,SUS
     A ,XNOISE,ZNOISE,NF
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      common /cQUIET/ iquiet
c------------------------------------------------------------------------
C.....START OF PROGRAM
C.....SET THE LOGICAL UNITS FOR SYSTEM INPUT AND OUTPUT FILES.
C     THE USER MUST INCLUDE AN "AUXIN" AND/OR AN "AUXOUT" CARD IF THE
C.....AUXILIARY INPUT AND/OR OUTPUT FILES ARE TO BE USED.
      LUI = LU5
      LUO = LU6
      nch_run=lcount(run_directory,50)
      call setvars     !  set variables that are undefined
      CALL LISTIN      !  create procedure file & check control card names
C.....TERMINATE PROGRAM IF ANY INVALID CONTROL CARD NAMES OCCUR
      IF(ITRUN.le.0) go to 600
C.....INPUT AND PROCESS CONTROL CARDS
C.....INPUT IS FORMATTED CARD IMAGES (USES DECODE)
      do 95 i=1,12
95    idaily(i)=0
100   CALL DECRED
C.....RETURN IF RUN OPTION IS .LE. 0
      IF(ITRUN.le.0) go to 600
c*****************************************************************
      MONTH=MONTHS(1)   !  only use 1st month/SSN
      SSN=SUNSP(1)
      call REDMAP(SSN,MONTH)
      iday=idaily(1)
      if(iday.ne.0) call redaily(ssn,month,iday)
      call GEOM
c*******************************************************
      do 10 nfreqs=1,11
      if(frel(nfreqs).eq.0.) go to 20
10    continue
20    nfreqs=nfreqs-1
      meth=method
      if(mspec.eq.121) meth=30
      if(iquiet.eq.0) then
          write(*,21)meth,mspec,IMON(MONTH),nint(SSN),(frel(if),if=1,nfreqs)
21        format(' Method',2i4,1x,a3,i4,'ssn  Freqs=',11f5.1)
      end if  

c*****************************************************************
      if(ndistance.ne.1) then       !  plots vs DISTANCE
         write(48,'(i5,'' distances'')') ndistance
         write(48,'(i2,11f7.3)') nfreqs,(frel(i),i=1,nfreqs)
         write(48,'(25i3)') nhours,(ihours(i),i=1,nhours)
         write(48,103)
 103     format(' 24 MODE  MUF   FOT   ANGLE DELAY VHITE MUFdayLOSS  ',
     +              'DBU   SDBW  NDBW  SNR   RPWRG REL   MPROB SPRB  ',
     +              'SIGLW SIGUP SNRLW SNRUP TGAIN RGAIN SNRxx DBM   ')
         if(iquiet.eq.0) then
            write(*,'('' Calculating Distance plot'')')
            write(*,"(a)",advance='no') " UT["
         end if
      end if
      if(ntime.ne.0) then       !  plots vs TIME
         write(48,'(i2,11f7.3)') nfreqs,(frel(i),i=1,nfreqs)
         write(48,103)
         if(iquiet.eq.0) then
             write(*,'('' Calculating Time plot'')')
             write(*,"(a)",advance='no') " UT["
         end if
      end if
      rlat_dist=rlat
      rlon_dist=rlong
      DO 405 ihr = 1,nhours         !  put hour as outside loop
      JT=ihours(ihr)
      if(iquiet.eq.0) then
         write(*,"(i3)",advance='no') JT
      end if
      do 400 idistance=1,ndistance
      if(idistance.eq.1) then
         rlatd=rlat_dist/d2r
         rlongd=rlon_dist/d2r
      else
         CALL distxy(idistance,ndistance,tlat,tlong,rlat_dist,rlon_dist,
     +               npsl,RLATD,RLONGD)
         tlongdx=tlongd
         if(tlongdx.lt.0.) tlongdx=tlongdx+360.    !  between 0 & 360
         if(abs(RLATD-TLATD).lt..02 .and. 
     +      abs(RLONGD-TLONGDx).le..02) then  !  Tx & Rx cannot be same point
            RLONGD=TLONGDx+.02
            if(RLONGD.ge.360.) RLONGD=RLONGD-360.
         end if
         RLONG=RLONGD*D2R
         RLAT =RLATD *D2R
         if(abs(RLATD).gt.89.9) RLONG=0.    !  at poles, force long=0
      end if
      if(ndistance.eq.1) then
         if(ihr.eq.1) then
            CALL GEOM
            CALL SANG
            CALL SETOUT
         end if
      else
         CALL GEOM
         CALL SANG
         CALL SETOUT
      end if
c*****************************************************************
      IFREQ = FREL(14)       !  set control parameter for frequency complements
c jw      call yieldit               !  yield for Windows operations
      IUR=jt
      JTX = ihr
      CALL GEOTIM(JT)  !  convert UT to LMT, etc.
C.....WANT TO USE LONG TERM COEFFICIENTS
C.....TIME VARIATION OF MAPS
      CALL VIRTIM      !  UT VARIATION OF CRITICAL FREQUENCIES, F2M(3000)
      CALL TIMVAR      !  LMT dependency & E & F1 parameters
      CALL F2VAR       !  F2 parameters (F1 may be changed)
      CALL ESIND       !  Sporadic E parameters
      CALL IONSET
C.....MUF BY FULL IONOSPHERE, AND FOT CALCULATION (ITRUN = 4)
      CALL CURMUF
C.....FULL SYSTEMS PERFORMANCE MODEL (ITRUN = 7)
      IF(IFREQ.le.0) then
C............SET FREQUENCY COMPLEMENT
         CALL FRQCOM(FREL,IFREQ)
      else
         FREL(12) = ALLMUF(IT)
      end if
      IF(METHOD.EQ.22.OR.METHOD.EQ.25.OR.MSPEC.EQ.125)THEN
C.......FORCE SHORT PATH MODEL
        IPFG=100
      ELSE IF(METHOD.EQ.21) THEN
        IF(MSPEC.EQ.121)THEN
C.........SET FOR SHORT PATH AND USE LONGPATH/SHORTPATH SMOOTHING
          IPFG=100
        ELSE
C.........FORCE LONG PATH MODEL
          IPFG=200
        ENDIF
      ELSE
C.......FORCE LONG PATH MODEL IF PATH LENGTH .GT. SPECIFIED LIMIT
        IPFG=100
        IF(MSPEC.ne.121 .and. GCDKM.GE.GCDLNG) IPFG=200
      ENDIF

      IF(meth.eq.30   .and. GCDKM.GE.GCDLNG) IPFG=200
      IF(GCDKM.GE.GCDLNG) IPFG=200
ccc      IF(GCDKM.GE.GCDLNG) mspec=0
      IF(meth.eq.21) IPFG=200      !  forced long path
      IF(meth.eq.22) IPFG=100      !  forced short path
ccc      write(* ,111) method,meth,mspec,npsl,ipfg,gcdkm,frel(12)
ccc111   format(' method,meth,mspec,npsl,gcdkm,muf=',5i5,f10.1,f10.3)
      CALL LUFFY(IPFG)
      CALL SETLUF
C
      CALL OUTLIN
  400 CONTINUE             !  end of DISTANCE loop
  405 CONTINUE             !  end of   HOUR   loop
      if(iquiet.eq.0) write(*,"(a)") " ]" ! Close the progress display and newline
      method=meth          !  reset METHOD
      GO TO 100
C.....END OF RUN
  600 CONTINUE
ccc      write(*,601) meth,method,mspec,gcdkm,gcdlng
ccc601   format('601=',3i5,2f10.2)
      WRITE(LUO,1504) VERSN
 1504 FORMAT(1H ,'*****END OF RUN*****',5X,'VOACAP ',a8)
      RETURN
      END
C--------------------------------

c###prbmuf.for
      FUNCTION PRBMUF(FMHZ,FGO,FSET,IL)
C--------------------------------
C
C     THIS ROUTINE IS THE STANDARD PROBABILITY EVALUATION FOR THE
C     PROGRAM. THE DISTRIBUTIONS ARE SET IN SUBROUTINE CURMUF
C
C
C  EVALUATE THE PROBABILITY THAT THE OPERATING FREQUENCY IS GREATER
C THAN THE FOT, MUF OR HPF FOR A GIVEN LAYER USING THE MUF DISTRIBUTIONS
C     PRBMUF = 1. - FNORML(Z)
C
C  FMHZ IS THE OPERATING FREQUENCY
C  FGO IS THE MUF AT A SET ANGLE FOR A PARTICULAR LAYER, FOR ONE HOP
C      (IT MAY NOT BE THE CIRCUIT MUF)
C  FSET IS WHERE MEDIAN OF DISTRIBUTION IS PLACED (=FOT, MUF OR HPF)
C  IL IS LAYER (E, F1, F2 OR ES)
C  SIGL(IL) IS THE LOWER DECILE
C  SIGU(IL) IS THE UPPER DECILE
C
      COMMON / MUFS / EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24),
     A FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),
     B DELMUF(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),
     C YHPF(4),YMUF(4)
C
      DIMENSION C(4)
      DATA C/.196854, .115194, .000344, .019527/
C
      Z = FMHZ - FGO
      IF(FSET.gt.0.) go to 95
      IF(Z.le.0.) then
         QX = 1.
      else
         QX = 0.0
      end if
      GO TO 145
   95 IF(Z.le.0.) then
         SIG = FGO * SIGL(IL) / FSET
      else
         SIG = FGO * SIGU(IL) / FSET
      end if
      SIG = AMAX1(SIG,0.001)
      Z = Z / SIG
C.....KEEP WITHIN 32 BIT WORD MACHINES
C.....NOTE PRBMUF = 1. - FNORML(Z)
      YP = Z
      YPX = Z
      IF(YPX.lt.0.) YP=-YPX
      YP = AMIN1(5.0, YP)
      QX = 1. + YP * (C(1) + YP * (C(2) + YP* (C(3) + YP * C(4))))
      QX = QX * QX * QX * QX
      QX = 1. / QX
      QX = .5 * QX
      IF(YPX.lt.0.) then
         PX = QX
         QX = 1. - PX
      else
         PX = 1. - QX
      end if
  145 PRBMUF = QX
      RETURN
      END
CC*****************************************************************

c###esreg.for
      SUBROUTINE ESREG
C--------------------------------
C
C     THIS ROUTINE COMPUTES AN ES - F MODE.  IT IS A COMBINATION OF
C     SUBROUTINE REGMOD AND SUBROUTINE ESMOD.  ONE ES HOP IS DONE AND
C     THE REMAINDER ARE F HOPS.  THE POINT IS TO ADD NEW RADIATION
C     ANGLE POSSIBILITIES.
C     YOU CANNOT HAVE REGULAR E - N*F MODE FROM THE SAME IONOSPHERE
C     ONE COULD USE THE LOGIC BELOW TO MIX MODES FROM TWO OR MORE
C     SAMPLE AREAS
C
C AC(3) IS ABSORPTION LOSS FACTOR, SEE LUFFY.
C BC(3) IS DENOMINATOR OF LOSS FACTOR.
c
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SXGU,SXGL,KJ,JK
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     A,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMUF
     B (4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     C ,YMUF(4)
      COMMON/SIGD/DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE,HNU
     A ,HTLOSS,XNUZ,XVE
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / ZON / ABPS(7), CREL(7), EFF(7), FLDST(7), GRLOS(7),
     1 HN(7), HP(7), PROB(7), RELY(7), RGAIN(7), SIGPOW(7), SN(7),
     2 SPRO(7), TGAIN(7), TIMED(7), TLOSS(7), B(7), FSLOS(7), ADV(7),
     3 OBF(7),NMODE(7),TLLOW(7),TLHGH(7)
      COMMON /TON /ADJ, ADS, GNOS, GOT, REL, SL, SLS
     1, SPR, SU, SUS, XNOISE, ZNOISE, NF
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON /ES /FS (3, 5), HS (5)
      COMMON / RAYS / ANG(40), IFOB(40,30,5), NANG
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON /GEOG /GYZ (5), RAT (5), GMDIP (5), CLCK (5), ABIY (5), ART
     1IC (5), SIGPAT (5), EPSPAT (5)
      DIMENSION LX(3)
      DATA LX/1,3,5/
C PRESET ARRAYS WILL USE SIX ONLY
      IMS = 6
      IME = 7
      DO 100 IM= IMS,IME
      ABPS(IM)  = 1000.
      CREL (IM) = 1000.
      EFF  (IM) =  0.0
      FLDST(IM) = -1000.
      GRLOS(IM) =  +1000.
      HN   (IM) =  -1.
      HP   (IM) =  -1.
      PROB (IM) =  .001
      RELY (IM) =  .001
      RGAIN(IM) =  0.0
      TGAIN(IM) =  0.0
      TIMED(IM) =  -1.
      TLOSS (IM) = 1000.
      B     (IM) =   -1.
      FSLOS (IM) = 1000.
      ADV   (IM) = 1000.
      OBF   (IM) = 1000.
      NMODE (IM) =    5.
      TLLOW (IM) =   10.
      TLHGH (IM) =   10.
      SIGPOW(IM) =-1000.
      SN    (IM) = -1000.
  100 SPRO  (IM) =  .001
C
C  ERRORS IN THE CODE BELOW
C
      RETURN
c
c--ESREG-------------------------------Nothing DONe here!!!
c                                       due to RETURN above
c----------------------------------------------------------
   95 CONTINUE
C DETERMINE EXISTENCE OF ES MODE
      KS= 1
      DO 110 IS = 1,KM
C.....SELECT THE SAMPLE AREA
      IF( FS(2,KS) - FS(2,IS)) 105,110,110
  105 KS= IS
  110 CONTINUE
      IF(FS(2,KS) )  113,113,104
  104 CONTINUE
C.....CUT OFF AT LOW FREQUENCIES. MAPS ARE ES AND E
      FSDEAD = IFOB(1,3,JMODE)
      FSDEAD = FSDEAD/1000.
      FSDEAD = AMIN1(FSDEAD, 3.)
      INS= -1
      IF( FREQ - FSDEAD )  112,111,111
  111 INS= 1
  112 CONTINUE
      IF(INS ) 113,113,114
  113 RETURN
C DETERMINE EXISTENCE OF A F MODE
C.....KF IS THE SAMPLE AREA
  114 KF = JMODE
      IF( FI(2,KF) ) 125,125,115
  115 IF( DELPEN(2,KF) - 89.99)   130,125,125
  125 IF(DELPEN(3,KF) - 89.99) 130,113,113
  130 CONTINUE
C  CHECK FOR MINIMUM ANGLE
      IH = 0
C.....FIND START OF F MODES
      DO 155 IHX = 1,45
      IF( HPFLX(IHX,KF) )  155,155,140
  140 CONTINUE
      IF( DELFX(IHX,KF) - AMIND ) 155,155,145
  145 IF( DELFX(IHX,KF) - DELPEN(1,KF)) 155,155,150
  150 IH = IHX -1
      GO TO 160
  155 CONTINUE
  160 CONTINUE
      IF( IH)  113,113,165
  165 IF( IH - 44) 170,170,113
C  MIXED ES-F MODE EXISTS
  170 IHLOW = IH
      DMAXKM(KF) = GDFLX(IHLOW,KF)
C.....FIND THE MAXIMUM DISTANCE
      DO 185 IH = IHLOW,45
      IF( HPFLX( IH,KF) ) 185,185,175
  175 CONTINUE
      IF(DMAXKM(KF) - GDFLX(IH,KF) ) 180,185,185
  180 DMAXKM(KF) = GDFLX(IH,KF)
  185 CONTINUE
C.....NHOPF IS THE NUMBER OF F HOPS
      NHOPF = GCDKM / DMAXKM(KF) + 1.
      DEL   = DELFX(IHLOW,KF)* D2R
      PHE = RZ* COS(DEL)/( RZ + HS(KS) )
      PHE = ASIN(PHE)
C.....FIND THE ES HOP DISTANCE
      GDR = 2.*RZ*(PIO2 -DEL-PHE)
      HOP = NHOPF
C.....MAXIMUM DISTANCE TO THIS ANGLE
      TGCD = (HOP - 1.) * DMAXKM(KF) + GDR
      IF( TGCD - GCDKM)  195,195,190
C.....REDUCE THE NUMBER OF HOPS
  190 NHOPF = NHOPF -1
  195 CONTINUE
      IF( NHOPF )  600,600,196
  196 CONTINUE
      HOP = NHOPF
      IMD = 6
C  NOW DO MIXED MODE GEOMETRY,(LIKE FDIST)
C.....SEE THE COMMENTS IN SUBROUTINE FDIST FOR THIS SEARCH
      DO 300  IH = IHLOW,44
      IF(HPFLX(IH+1,KF).le.0.) go to 305
      DEL = DELFX(IH,KF)*D2R
      PHE   = RZ* COS(DEL  )/ (RZ + HS(KS))
      PHE   = ASIN(PHE)
      GDR1 = 2.*RZ*(PIO2-DEL-PHE)
      DEL = DELFX(IH+1,KF)*D2R
      PHE = ASIN( RZ*COS(DEL)/(RZ+HS(KS) )  )
      GDR2 = 2.*RZ*(PIO2-DEL-PHE)
      D1 = HOP*GDFLX(IH,KF)+GDR1
      D2 = HOP*GDFLX(IH+1,KF)+GDR2
      IF(D1-D2) 205,205,215
  205 IF(D1-GCDKM) 210,225,300
  210 IF(GCDKM-D2) 230,300,300
  215 IF(D1-GCDKM) 300,225,220
  220 IF(GCDKM-D2) 300,300,230
  225 CONTINUE
      HN(IMD) = NHOPF
      GDR = GDR1
      HP(IMD) = HPFLX(IH,KF)
      B (IMD) = DELFX(IH,KF)
      ISMOD = IMODE(IH,KF)
      HT       =HTFLX(IH,KF)
      AF       =AFFLX(IH,KF)
      FV       =FVFLX(IH,KF)
      GO TO 310
  230 CONTINUE
      IF(ABS(D2-D1)-1.) 225,225,235
  235 CONTINUE
      DTH2 = D2-D1
      GDR = 0.5*(GDR1+GDR2)
      DHOPKM = (GCDKM-GDR)/HOP
      DTH = GCDKM-D1
      THET = 0.5*DHOPKM/RZ
      HP1 = HPFLX(IH,KF)
      HP2 = HPFLX(IH+1,KF)
      HT1 = HTFLX(IH ,KF)
      HT2 = HTFLX(IH+1,KF)
      ISMOD=IMODE(IH ,KF)
      HN(IMD) = NHOPF
      HP(IMD) = HP1 + (HP2 - HP1) * DTH/DTH2
      HT      = HT1 + (HT2 - HT1)*DTH/DTH2
      AF      = AFFLX(IH,KF) +(AFFLX(IH+1,KF)-AFFLX(IH,KF))*DTH/DTH2
      ST = SIN(THET)
      TANP = ST / (1. - COS(THET) + HP(IMD) / RZ)
      PHE  = ATAN(TANP)
      DEL  =  PIO2 - PHE - THET
      B(IMD)= DEL * R2D
      SPHI  = RZ*COS(DEL)/(RZ + HT)
      SPHI  = 1. - SPHI*SPHI
      SPHI = AMAX1(SPHI,0.000001)
      FV   = FREQ *SQRT(SPHI)
      GO TO 310
  300 CONTINUE
  305 CONTINUE
C.....END OF FDIST SEARCH
      GO TO 600
  310 CONTINUE
C FREE SPACE LOSS  AND TIME DELAY
      CDEL = COS(DEL)
      HOP = HN(IMD)
      GHOPF = (GCDKM-GDR)/(RZ*HOP)
      IF(GHOPF.le.0.) go to 600
      PSI   = .5 * GHOPF
      PHE = PIO2 - PSI - DEL
      PATHF = 2.*HOP *( HP(IMD) + RZ * (1. - COS(PSI)))/COS(PHE)
      PSIS =  0.5 * GDR/RZ
      PHES =  PIO2 - PSIS - DEL
      CPHES = COS(PHES)
      PATHS = 2. * ( HS(KS) + RZ *(1. - COS(PSIS)))/ CPHES
      PATH  = PATHF + PATHS
      TIMED(IMD) =  PATH/VOFL
      IF(PATH*FREQ.le.0.) go to 600
      FSLOS(IMD) = 32.45 + 20.*ALOG10(PATH*FREQ)
C  F  ABSORPTION LOSS
      XNSQ = 10.2
      SINP = RZ * CDEL/ (RZ + 100.)
      SECP = 1./SQRT(1.- SINP * SINP)
      AC =  677.2 * ACAV
      L  = LX(KF)
      BC = (FREQ + GYZ(L)) ** 1.98
      ABPSF = SECP *AC / (BC + XNSQ)
      SECP = 1./SIN(DEL + PSI)
      ADV(IMD) = SECP * AF* (( FV + GYZ(L)) ** 1.98 + XNSQ)/(BC+XNSQ)
C ES  ABSORPTION LOSS, MODE DID NOT PASS THROUGH ALL OF E LAYER
      FVS = FREQ /CPHES
      IF( FI(1,KF) - FVS)  320,320,315
  315 ABPS(IMD) = ABPSF
      GO TO 325
  320 ABPS(IMD) = ABPSF + AFE + BFE * ALOG(FVS / FI(1,KF))
  325 CONTINUE
C   F MODE OBSCURATION LOSS FROM ES LAYER
      OBF(IMD) = 0.0
C.....NOT SAME SAMPLE AREA AS F SAMPLE
      IF(FS(2,KF)) 346, 346, 330
  330 FMHZ = AMAX1( FREQ,FSDEAD)
      ESD = FS(2,KF)/ CPHES
      DUMMY = YMUF(4)
      PROS = PRBMUF(FMHZ,ESD,DUMMY,4)
      PROS = AMIN1( PROS, 0.90)
      OBF( IMD) = -10.*ALOG10(1.- PROS)
C F   OVER-THE-MUF LOSS.
  346 SPHET=RZ*CDEL /(RZ + HT)
      CPHET= 1. - SPHET * SPHET
C.....MUF FOR F HOP DISTANCE
      XMUF = FVMUF(ISMOD)/CPHET
      DUMMY = YMUF(ISMOD)
      PROBF = PRBMUF(FREQ,XMUF,DUMMY,ISMOD)
      XLSF = -10.*ALOG10(PROBF)
C ES  OVER-THE-MUF LOSS ( OR REFLECTION LOSS )
C.....MUF FOR ES HOP DISTANCE
      ESD = FS(2,KS)/CPHES
      DUMMY = YMUF(4)
      PROBF = PRBMUF(FREQ,ESD,DUMMY,4)
      REF = 8.9136* PROBF **(-0.7)
C ANTENNA GAINS AND GROUND LOSS
C125PC      if(MSPEC.ne.125)then
        CALL GAIN(1,DEL,FREQ,DUMMY,TEFF)
        TGAIN(IMD) = DUMMY
        CALL GAIN(2,DEL,FREQ,DUMMY1,DUMMY2)
        RGAIN(IMD) = DUMMY1
        EFF(IMD) = DUMMY2
C125PC      else
c.......set gains and EFF to 0. dB or unity
C125PC        tgain(imd)=0.
C125PC        rgain(imd)=0.
C125PC        EFF(imd)=0.
C125PC      ENDIF
      Y = 0.0
      DO  380 IG = 1,KM
      IGX =  - IG
      CALL GAIN(IGX,DEL,FREQ,YG,GEFF)
  380 Y = Y + YG
      XKM = KM
      GRLOS(IMD) = Y/XKM
C
C  NOW SUM MEDIAN LOSSES,ETC.
C
      TLOSS(IMD) = FSLOS(IMD) + HOP * (ABPSF + ADV(IMD) + GRLOS(IMD)
     A + XLSF) +OBF(IMD) + ABPS(IMD) - RGAIN(IMD) - TGAIN(IMD) + REF
      FLDST(IMD) = 107.2+PWRDB(FREQ)+20.*ALOG10(FREQ)-TLOSS(IMD)
     +             -RGAIN(IMD)
      SIGPOW(IMD) = PWRDB(FREQ) - TLOSS(IMD)
C------------    CHANGED 9/24/91  (LONG PATH RCVR EFF CORRECTION)  FJR
C------------      SN(IMD)     = SIGPOW(IMD) - RCNSE
      SN(IMD)     = SIGPOW(IMD) - RCNSE - EFF(IMD)
      NMODE(IMD) = ISMOD
C PROB. FREQ.  LT  F2 MUF  *** AND ***  ES MUF
      DUMMY = YMUF(ISMOD)
      PROBF = PRBMUF(FREQ,DUMMY,DUMMY,ISMOD)
      DUMMY = YMUF(4)
      PROBS = PRBMUF(FREQ,DUMMY,DUMMY,4)
C.....F. DAYS
      PROB(IMD) = PROBF * PROBS
      if(prob(imd).lt..003) then
ccc         xfac=alog10(prob(imd))
ccc         if(xfac.gt.-2.5) xfac=-2.5
ccc         if(xfac.lt.-4.) xfac=-4.
ccc         ghlos=(xfac+2.5)*20.
ccc         tloss(imd)=tloss(imd)-ghlos
ccc         fldst(imd)=fldst(imd)+ghlos
ccc         sigpow(imd)=sigpow(imd)+ghlos
ccc         sn(imd)=sn(imd)+ghlos
      end if
C  LOWER DECILE  SIGNAL LEVEL ADJUSTMENT
      CPR = FVMUF(ISMOD)/YMUF(ISMOD)
      FVFOT = YFOT(ISMOD)* CPR
      XMUF  = FVFOT * CPHET
      DUMMY = YFOT(ISMOD)
      PFL = PRBMUF(FREQ,XMUF,DUMMY,ISMOD)
      XLSL =  -10.*ALOG10(PFL)/CPHET
      ESD = FS(3,KF)/CPHES
      DUMMY = YHPF(4)
      PROS = PRBMUF(FMHZ,ESD,DUMMY,4)
      PROS = AMIN1( PROS,0.9)
      OBFL = -10.*ALOG10(1.- PROS)
      ESD  = FS(1,KS)/CPHES
      DUMMY = YFOT(4)
      PSL = PRBMUF(FMHZ,ESD,DUMMY,4)
      REFL = 8.9136 * PSL ** (0.7)
      TLLOW( IMD) = DSL + (REFL - REF)  + (OBFL -OBF(IMD))
     A        + HOP*(XLSL - XLSF)
C UPPER DECILE  SIGNAL LEVEL ADJUSTMENT
      FVHPF = YHPF(ISMOD)/CPR
      XMUF = FVHPF*CPHET
      DUMMY = YHPF(ISMOD)
      PHF = PRBMUF(FREQ,XMUF,DUMMY,ISMOD)
      XLSU = -10.*ALOG10(PHF)/CPHET
      ESD = FI(1,KF)/CPHES
      DUMMY = YFOT(4)
      PSU = PRBMUF(FMHZ,ESD,DUMMY,4)
      PSU = AMIN1(PSU, 0.9)
      OBFU = -10.*ALOG10(1.-PSU)
      ESD = FS(3,KS) / CPHES
      DUMMY = YHPF(4)
      PSU = PRBMUF(FMHZ,ESD,DUMMY,4)
       REFU = 8.9136 * PSU **(-0.7)
      TLHGH(IMD) = DSU + (REF - REFU) + (OBF(IMD) - OBFU)
     A           + HOP*(XLSF - XLSU)
      TLHGH(IMD) = ABS(TLHGH(IMD))
C  BUT NO MORE THAN MAX IN TABLES
      TLLOW(IMD) = AMIN1(TLLOW(IMD),25.)
      TLHGH(IMD) = AMIN1(TLHGH(IMD),25.)
  600 CONTINUE
      RETURN
      END
C--------------------------------

c###nommuf.for
      SUBROUTINE NOMMUF
C--------------------------------
C
C     THIS ROUTINE CALCULATES MUF FOR ALL LAYERS AND CIRCUIT MUF (NO ES)
C     BY THE MANUAL METHOD PROGRAMMED FOR COMPUTER USE
C
      COMMON/MUFS/EMUF(24),F1MUF(24),F2MUF(24),ESMUF(24),ALLMUF(24)
     1,FOT(24),XLUF(24),HPF(24),ANGMUF(24),MODMUF,SIGL(4),SIGU(4),DELMU
     2F(4),HPMUF(4),HTMUF(4),FVMUF(4),AFMUF(4),NHOPMF(4),YFOT(4),YHPF(4)
     3 ,YMUF(4)
      COMMON/ES/FS(3,5),HS(5)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / MFAC / F2M3(5),HPF2(5),ZENANG(5),ZENMAX(5),IEDP,FSECV(3)
      COMMON / CON / D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      DIMENSION AE(7),AF(7)
      DATA AE /-1.133200756E-2, 3.761385053E-2, -5.038476266E-3,
     1 2.624808315E-4, -5.976618436E-6, 1.334494261E-7, -4.368460907E-9/
      DATA AF / 4.699243101E-3, 2.264634341E-3, 9.202437332E-5,
     1 6.865259817E-5, -9.985831104E-6, 4.49151441E-7, -6.712654756E-9/
      ARC= GCDKM* 0.0062137
C
C THIS IS THE MANUAL METHOD PROGRAMMED FOR COMPUTER USE. SEE NBS REPORT
C 7619. MAXIMUM USABLE FREQUENCY FACTORS USING A COMPLETE ELECTRON
C DENSITY PROFILES ARE IN SUBROUTINE CURMUF
C
C
C  E-F1 LAYER DISTANCE FACTOR
C
      IF(ARC.lt.16.) then
         ELFC=((((((AE(7)*ARC+AE(6))*ARC+AE(5))*ARC+AE(4))*ARC
     A         + AE(3) )*ARC + AE(2))* ARC + AE(1) ) *ARC +  0.2085
      else
         ELFC = 1.02
      end if
C
C  F2  LAYER DISTANCE FACTOR
C
      IF(24..le.ARC) then
         FLFC = 1.0
      else
         FLFC=((((((AF(7)*ARC +AF(6))*ARC +AF(5) )*ARC + AF(4) )*ARC +
     A        AF(3) )*ARC + AF(2) )* ARC + AF(1) )*ARC
      end if
      EC = 1000.
      DO 135 K=1,KM
C E LAYER MUF
      IF(EC.gt.FI(1,K)) EC=FI(1,K)
  135 CONTINUE
      EMUF(IT) = 4.871 * EC * ELFC
      F2MUF(IT)= 1000.
C F LAYER MUF
      DO 145 K=1,KM
      FOUR= F2M3(K)*FI(3,K) * 1.1
      FMUF= FI(3,K) + FLFC*(FOUR - FI(3,K))
      IF(FMUF.lt.F2MUF(IT) ) F2MUF(IT)=FMUF
  145 CONTINUE
C  NO SEPERATE F1
      F1MUF(IT)= -1.
C  CIRCUIT MUF
      IF(EMUF(IT).ge.F2MUF(IT)) then
         ALLMUF(IT) =EMUF(IT)
      else
         ALLMUF(IT) =F2MUF(IT)
      end if
      FOTFY= 0.85* F2MUF(IT)
      FOT(IT) =AMAX1 (FOTFY,EMUF(IT))
      HPFFY = 1.15 * F2MUF(IT)
      HPF(IT) = AMAX1(HPFFY, EMUF(IT))
      ESMUF(IT)= 1000.
C
C SPORADIC E  MUF, PROBABILITY  OF REFLECTION IS 0.5
C
      DO 170 K=1,KM
      IF(FS(2,K).le.0.) go to 170
      DMAX= 225.*SQRT(HS(K) )
      HOP = GCDKM/DMAX +1.
      PSI = 0.5* GCD/HOP
      TDEL = (COS(PSI) - RZ / (RZ + HS(K))) / SIN(PSI)
      CDEL = 1. / SQRT(1. + TDEL * TDEL)
      SPHE = RZ * CDEL / (RZ + HS(K))
      SECP = 1. / SQRT(1. - SPHE * SPHE)
      ESD = FS(2,K) * SECP
      IF(ESMUF(IT).gt.ESD) ESMUF(IT)=ESD
  170 CONTINUE
      RETURN
      END
C--------------------------------

      SUBROUTINE antmodel(iant,gain,ant_model)
* --------------------------------------------------------------------- *
      CHARACTER ant_model*10

      if(iant.eq.0) then    !  add gain above ISOTROPE
         write(ant_model,99) gain
99       format(1h+,f5.1,4h dBi)
      else if(iant.ge.1 .and. iant.le.10) then
         write(ant_model,'(8hREC705 #,i2.2)') iant
      else if(iant.eq.11) then
         ant_model='2-D Table '
      else if(iant.eq.12) then
         ant_model='NTIA87-215'
      else if(iant.eq.13) then
         ant_model='3-D Table '
      else if(iant.eq.14) then
         ant_model='2-D P-to-P'
      else if(iant.ge.21 .and. iant.le.30) then
         write(ant_model,'(8hIONCAP #,i2.2)') iant
      else if(iant.ge.31 .and. iant.le.47) then
         write(ant_model,'(8hHFMUFES#,i2.2)') iant
      else if(iant.ge.48 .and. iant.le.48) then
         write(ant_model,'(8hNOSC-95#,i2.2)') iant
      else if(iant.ge.90 .and. iant.le.99) then
         write(ant_model,'(8hExtern #,i2.2)') iant
      else
         ant_model='Unknown???'
      end if
      return
      end

C SUBROUTINE MUTUAL           (NEXT)
      SUBROUTINE MUTUAL 
C 
C     MUTUAL - CALCULATES THE MUTUAL IMPEDANCE BETWEEN ARBITRARY
C        ORIENTED LINEAR DIPOLE ELEMENTS BY GAUSSIAN INTEGRATION. 
C     SEE THE REFERENCES IN SUBROUTINE GAIN FOR DETAILS 
C 
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RO, VOFL 
C 
      COMMON /MUT /CFAC, CT, H2, PROD1, RHI2, R21, X21, Y0, Z0
C 
      EXTERNAL REACT, RESIST
C 
C.......................................................................
      XCON = - 0.1 * VOFL
      CT = COS (RHI2) 
      PROD1 = - SIN (RHI2)
C. . .NOTE ERROR OF NEXT CARD MISSING IN EARLIER VERSIONS. . . . . . . .
      X21 = 0.0 
      IF (Y0 .LE. 0.005) GO TO 100
      X21 = XCON * AGAUSS (REACT, H2) 
 100  R21 = XCON * AGAUSS (RESIST, H2)
      RETURN
      END

      subroutine suffix(ifile,nchm,isufx,nchs)
c          Append a suffix to the file name
c          Search for 1st blank or '.'
      character *(*) ifile,isufx,ich*1
      do 10 i=1,nchm-nchs
      ich=ifile(i:i)
      if(ich.eq.' ' .or. ich.eq.'.') go to 20
 10   continue
      i=nchm-nchs+1
 20   ifile(i:i+nchs-1)=isufx(1:nchs)
      return
      end

c###outgph.for
      SUBROUTINE OUTGPH
C--------------------------------
C
C     THIS ROUTINE CALLS SUBROUTINES TO SETUP AND OUTPUT LINE GRAPHS
C
      COMMON /OUTPRT/ LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      LINES = 0
C.....CALL SUBROUTINE OUTTOP TO OUTPUT THE HEADER LINES
      CALL OUTTOP
C.....CALL SUBROUTINE SETGPH TO SET THE VARIABLES TO BE PLOTTED
      CALL SETGPH
C.....CALL SUBROUTINE GPHBOD TO PRODUCE LINE PRINTER GRAPHS
      CALL GPHBOD
      RETURN
      END
C--------------------------------

      SUBROUTINE DBLTRAP(DINTGL)
C*********************************************************************
C  PARAMETERS:
C     DINTGL  -  INTEGRATION RESULT CALCULATED IN DBLTRAP
C     THETA STEP SIZE = 1  DEGREE
C     PHI   STEP SIZE = 1  DEGREE
C     THETA LOWER LIMIT OF INTEGRATION = 0. DEGREES
C     PHI   LOWER LIMIT OF INTEGRATION = -90. DEGREES
C     THETA UPPER LIMIT OF INTEGRATION = 90. DEGREES
C     PHI   UPPER LIMIT OF INTEGRATION = 90. DEGREES
C*********************************************************************
      DATA D2R/.01745329251/
      PHIZ = -90. * D2R
      PHIF =  90. * D2R
      TINT = 0.0
      T = 0.
      DO 80 IP1 = 1,91
        P = PHIZ + D2R
        PINT = 0.0
        DO 90 J = 1,179
          PINT = PINT + F2(T,P)
          P = P + D2R
   90   CONTINUE
        PINT = PINT * D2R
        PINT = PINT + (D2R/2.) * (F2(T,PHIF) + F2(T,PHIZ))
        IF (IP1.EQ.1 .OR. IP1.EQ.91) GO TO 91
        TINT = TINT + D2R * PINT *COS(T)
        GO TO 92
   91   TINT = TINT + D2R * PINT * COS(T) / 2.0
   92   CONTINUE
        T = T + D2R
   80 CONTINUE
      DINTGL =  TINT
      RETURN
      END
C------------------------------------------------------------------

!--------------------------------------------------------------
!# anttyp99.for
!***********************************************************************
PROGRAM anttyp99
!***********************************************************************
! Calculate an exteranl antenna file.
! Assumes data is in the format of:
!       ..\antennas\samples\sample.90
! Execute with:
!    anttyp99 directory mode
! where:
!    directory = full pathname to the RUN directory (e.g. c:\ITSHFBC\RUN)
!    mode      = (blank) = Point-to-Point
!              = a = Area Coverage
!***********************************************************************

    use Cant99
    
    implicit none

    real                :: elev, azimuth, freq, g 
    real                :: xfqs,xfqe,designfreq, aeff
    real                :: beammain,offazim,cond,diel
    real, dimension(91) :: gain
    character(len=24)   :: antfile
    character(len=80)   :: filename, gainfilename
    character(len=120)  :: run_directory, root_directory, arg
    character(len=1)    :: mode
    integer             :: idx, iel, iazim, ifreq
    integer, parameter  :: dat_file_un = 21
    integer, parameter  :: gain_file_un = 22
    integer, parameter  :: lua = 42

    !HARRIS_INTERP controls compatibility compatibility with the 
    !Harris version with produces gain tables with the azimuth 
    !rounded to the nearest degree.
    !HARRIS_INTERP = .false. should produce more accurate
    !gain tables, interpolated to the exact azimuth.
    !
    logical, parameter  :: HARRIS_INTERP = .true.

    !HARRIS_LOWER_LIMIT Controls the format of the lower limit.  The
    !Harris version prints the value -99.990 as -99.999 (although the 
    !value -99.990 appears to be used in the interpolation).

    logical, parameter  :: HARRIS_LOWER_LIMIT = .true.
      
!...START OF PROGRAM
    mode = " "
! We need to consider two forms of command args;
! anttype99 rundir [mode]
! anttype99 rundir rootdir [mode]
    call GET_COMMAND_ARGUMENT(1, run_directory)
    if (COMMAND_ARGUMENT_COUNT().eq.1) then
        root_directory = run_directory(1:len(trim(run_directory))-3)
    else if (COMMAND_ARGUMENT_COUNT().eq.2) then
        call GET_COMMAND_ARGUMENT(2, arg)
        if (len(trim(arg)).eq.1) then
            call GET_COMMAND_ARGUMENT(2, mode)
        else
            call GET_COMMAND_ARGUMENT(2, root_directory)
        end if
    else if (COMMAND_ARGUMENT_COUNT().eq.3) then
            call GET_COMMAND_ARGUMENT(2, root_directory)
            call GET_COMMAND_ARGUMENT(3, mode)
    end if
    open(dat_file_un,file=trim(run_directory)//'/anttyp99.dat', position='rewind', status='old',err=900)
    read(dat_file_un,*,err=920) idx          !  antenna index #, GAINxx.dat
    read(dat_file_un,'(a)',err=920) antfile  !  antenna file name
    read(dat_file_un,*,err=920) xfqs         !  starting frequency
    read(dat_file_un,*,err=920) xfqe         !  ending frequency
    read(dat_file_un,*,err=920) beammain     !  main beam (deg from North)
    read(dat_file_un,*,err=920) offazim      !  off azimuth (deg from North)
    close(dat_file_un)

    filename=trim(root_directory)//'/antennas/'//trim(antfile)
    call ant99_read(filename,21,lua,*910)
    diel=parms(3)         !  dielectric constant
    cond=parms(4)         !  conductivity
    write(gainfilename,1) trim(run_directory),idx
1   format(a,5h/gain,i2.2,4h.dat)

    open(gain_file_un,file=gainfilename, position='rewind')
    write(gain_file_un,'(a)') 'HARRIS99  '//title

    if(len(trim(mode)).eq.0) then
!****************************************************************
!                  Point-to-Point mode
!****************************************************************
        write(gain_file_un,2) xfqs,xfqe,beammain,offazim,cond,diel
2       format(2f5.0,2f7.2,2f10.5)
        azimuth=offazim
        if (HARRIS_INTERP) azimuth = real(nint(azimuth))
        do ifreq=1,30
            freq=ifreq
            if(freq.ge.xfqs .and. freq.le.xfqe) then !  in frequency range
                do iel=0,90
                    elev=iel
                    call ant99_calc(freq,azimuth,elev,gain(iel+1),aeff,*940)
                end do
            else                                     !  outside freq range
                aeff=0.
                do iel=0,90
                    gain(iel+1)=0.
                end do
            end if
            if (HARRIS_LOWER_LIMIT) then
                where (gain.lt.-99.9) gain=-99.999
            end if
            write(gain_file_un,3) ifreq,aeff,gain
3           format(i2,f6.2,(T10,10F7.3))
        end do
    else

!****************************************************************
!                    Area Coverage mode
!****************************************************************
        write(gain_file_un,2) 2.0,xfqe,beammain,-999.,cond,diel
        freq=xfqs
        call ant99_calc(freq,0.,8.,g,aeff,*940)
        write(gain_file_un,201) freq,aeff
201     format(10x,f7.3,'MHz eff=',f10.3)
        do iazim=0,359
            azimuth=iazim
            do iel=0,90
                elev=iel
                !write(*, '(A F12.6)') 'call az = ', azimuth
                call ant99_calc(freq,azimuth,elev,gain(iel+1),aeff,*940)
            end do
            write(gain_file_un,251) iazim, gain
251         format(i5,(T10,10F7.3))
        end do
    end if 
!****************************************************************
    call ant99_close      !Close the scratch file
    close(gain_file_un)
!****************************************************************
    go to 999
!****************************************************************
900 write(*,901) trim(run_directory)//'/anttyp99.dat'
901 format(' In anttyp99, could not OPEN file=',a)
    stop 'OPEN error in anttyp99 at 900'
910 write(*,911) filename
911 format(' In anttyp99, error READing file=',a)
    stop 'READ error in anttyp99 at 910'
920 write(*,921) trim(run_directory)//'/anttyp99.dat'
921 format(' In anttyp99, error READing file=',a)
    stop 'READ error in anttyp99 at 920'
!***********************************************************************
930 write(*,931)
931 format('anttyp99 must be executed:',&
        '1. Point-to-Point:',&
        '   anttyp99.exe run_directory',&
        '4. Area Coverage:',&
        '   icepacw.exe run_directory a')
    write(*,932)
932 format(&
        'Where:',&
        '      run_directory = full pathname to RUN directory',&
        '                      (e.g. /home/usr_name/itshfbc/run)')
    stop 'anttyp99 not executed properly.'
940 write(*,941) filename
941 format(' In anttyp99, error Calculating from file=',a)
    stop 'READ error in ANTTYP99 at 940'
!***********************************************************************
999 continue
end

      subroutine TxPwr(P,alf,nch)
      character alf*10,alft*10
      if(P.ge.10.) write(alf,'(f8.2,2hkW)') P
      if(P.ge.1. .and. P.lt.10.) write(alf,'(f8.4,2hkW)') P
      if(P.lt.1.) write(alf,'(f8.4,1hW)') P*1000.
c          remode leading blanks
      nch=10
      j=0
      do 10 i=1,nch
      if(alf(i:i).eq.' ') go to 10
      j=j+1
      alf(j:j)=alf(i:i)
 10   continue
      nch=j
      if(nch.lt.10) alf(nch+1:10)=' '
c          remode trailing 0s
15    alft=alf
      if(alf(nch-1:nch).eq.'0W') alf(nch-1:nch)='W '
      if(alf(nch-2:nch).eq.'0kW') alf(nch-2:nch)='kW '
      if(alft.eq.alf) go to 20
      nch=nch-1
      go to 15
20    if(alf(nch-1:nch).eq.'.W') then
         alf(nch-1:nch)='W '
         nch=nch-1
      else if(alf(nch-2:nch).eq.'.kW') then
         alf(nch-2:nch)='kW '
         nch=nch-1
      end if
      if(alf(1:1).eq.'W') then     !  Power=0 should really not occur
         alf='0W'
         nch=2
      end if
      return
      end

c# gain.f
      SUBROUTINE ionGAIN(kop,toaz,ysig,yeps,ynd,ynl,ynh,tex,
     +                DELTA,FMC,RAIN,EFF)
      dimension tex(4)
      call       ionGAIN2(kop,toaz,ysig,yeps,ynd,ynl,ynh,tex,
     +                DELTA,FMC,RAIN,EFF)
c          this is to adjust type 3 & 4 antennas so 90 deg elevation
c          angle is consistent no matter what the azimuth
      if(kop.eq.3 .or. kop.eq.4) then
         toaz_0=0.
         delta_90=1.570796
         call    ionGAIN2(kop,toaz_0,ysig,yeps,ynd,ynl,ynh,tex,
     +                DELTA_90,FMC,RAIN_90,EFF_90)
         gmorph=sin(delta)**4
         rain=rain_90*gmorph + rain*(1.-gmorph)
      end if
      return
      end
c--------------------------------------------------------------
      SUBROUTINE ionGAIN2(kop,toaz,ysig,yeps,ynd,ynl,ynh,tex,
     +                DELTA,FMC,RAIN,EFF)
C---------------------------------
C.....ITR .LT. 0 INDICATES TO CALCULATE GROUND REFLECTION LOSS
C     ITR = 1 INDICATES TRANSMITTER ANTENNA
C     ITR = 2 INDICATES RECEIVER ANTENNA
C
C     POWER GAIN OF ANTENNA AND GROUND REFLECTION LOSS
C     FOR LOSS, KOP IS ZERO OR MINUS
C     DIMENSION A(10),B(10),CA(10),SA(10)
c toaz  is off azimuth in degrees
C DELTA IS ELEVATION ANGLE,RADIANS
C FMC  IS FREQUENCY,MHZ.
C BETA IS 0.0 FOR LOSS AND VARIES WITH ANTENNA TYPE.
C SIGMA IS GROUND CONDUCTIVITY, MHOS/METER.
C ER IS GROUND RELATIVE DIELECTRIC CONSTANT.
C PHI,EL,H AND EX(4) VARY WITH ANTENNA TYPE
C RAIN IS LOSS OR GAIN.
C
C
C     THE REFLECTION COEFFICIENTS ARE
C     KSUBV = -CV * EXP(I * PSIV),  KSUBV = CV * EXP(I * GAMMAV)
C     KSUBH = -CH * EXP(I * PSIH),  KSUBH = CH * EXP(I * GAMMAH)
C     IE  NORMALIZED WITH PSI = GAMMA + PI, PSI = GAMMA - PI
C
C     IONCAP REPORT VOLUME 1 PAGE 115 OR ITSA-1 PAGE 65
C     N O T E THIS IS NOT THE SAME AS MA AND WALTERS, ITS-74, PAGE 8
C
      COMMON/CON/D2R,DCL,GAMA,PI,PI2,PIO2,R2D,RZ,VOFL
ccc      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD
ccc      COMMON/GEOG/GYZ(5),RAT(5),GMDIP(5),CLCK(5),ABIY(5),ARTIC(5),SIGPAT
ccc     A (5),EPSPAT(5)
      DIMENSION CA(10), SA(10)
      DIMENSION EX(4),tex(4)
      save
      DATA RINTW/18.06/
      COT(X) = 1. / TAN(X)
C.....RINTW IS "RA" FOR VERTICAL MONOPOLE AT H/LAMDA = .2
ccc      write(*,'('' in iongain, kop='',i5,10f8.3)')
ccc     +         kop,toaz,ysig,yeps,ynd,ynl,ynh,tex
      SOK = 0.0
      RAIN=0.
      EFF = 0.0
      floor=-30.      !  minimum antenna gain value
c********************************************************
      SIGMA = YSIG
      ER = YEPS
      BETA = TOAZ
      PHI = YND
      EL = YNL
      H = YNH
      DO 535 IK = 1,4
  535 EX(IK) = TEX(IK)
      IF(SIGMA.le.0.) stop 'In GAIN, SIGMA<=0.'
c*********************************************************************
C.....THE EQUATIONS FOR THE FRESNEL REFLECTION COEFFICIENTS ARE IN
C.....VOLUME I OF THE OT REPORT ON THIS ANALYSIS PROGRAM
      SOK = 0.
      if(delta.le.0.) then        !  elevation angle=0  force gain=-30
         rain=floor
         go to 610
      end if
      RELTA = DELTA
c           for vertical beam, force off azimuth=0 so answers will be the same
ccc      if(abs(DELTA-PIO2).lt..0001) BETA=0.
      ibeta=nint(beta)
      X = 18000. * SIGMA / FMC
      T = COS (RELTA)
      Q = SIN (RELTA)
      R = Q * Q
      S = R * R
      ERT = ER - T * T
      RHO = SQRT ((ERT) * (ERT) + X * X)
      RHO12 = SQRT (RHO)
      ALPHA = - ATAN (X / ERT)
      U = (ER * ER + X * X)
      V = SQRT (U)
      ASXV = ASIN (X / V)
      CV = SQRT (RHO * RHO + U * U * S - 2. * RHO * U * R * COS (ALPHA +
     1 2. * ASXV)) / (RHO + U * R + 2. * RHO12 * V * Q * COS (ALPHA * .5
     2 + ASXV))
      RAIN = 0.
      A = 2. * RHO12 * Q * V * SIN (ALPHA * .5 + ASXV)
      WAVE = 299.7925 / FMC
      B = RHO - U * R
      IF (B)135, 115, 140
 115  IF (A)120, 125, 130
 120  PSIV = - 1.570796
      GO TO 145
 125  PSIV = 0.
      GO TO 145
 130  PSIV = 1.570796
      GO TO 145
 135  PSIV = ATAN (A / B) + 3.141593
      GO TO 145
 140  PSIV = ATAN (A / B)
  145 SOK = EX(1)
      RETA = BETA * .017453293
      PSIH = ATAN (2. * RHO12 * Q * SIN (ALPHA * .5) / (RHO - R))
      SB = SIN (RETA)
      CB = COS (RETA)
      X = 1.
      CH = SQRT (RHO * RHO + S - 2. * RHO * R * COS (ALPHA)) / (RHO + R
     1+ 2. * RHO12 * Q * COS (ALPHA * .5))
      if(abs(cv-ch).le..001) cv=ch
      IF (EL)165, 185, 185
 165  EL1 = ABS(EL)
      FAC = 3.1416 * EL1
      GO TO 190
 185  FAC = 3.1416 * EL / WAVE
      EL1 = EL / WAVE
 190  IF (H)200, 200, 195
 195  HWAVE = 6.2832 * H / WAVE
      H1 = H / WAVE
      GO TO 220
  200 H1 = ABS(H)
      HWAVE = 6.2832 * H1
  220 RHI = PHI * .017453293
C.....THE EQUATIONS USED FOR EACH OF THE ANTENNAS SPECIFIED BELOW ARE IN
C.....VOLUME I OF THE OT REPORT ON THIS ANALYSIS PROGRAM
      GO TO(230,350,340,340,345,270,265,245,265,240), KOP
C
C    TERMINATED RHOMBIC                          KOP=1
C
 230  U1 = 1. - T * SIN (RHI + RETA)
      U2 = 1. - T * SIN (RHI - RETA)
      RAIN = 3.2 * (COS(RHI) * SIN(FAC * U1) * SIN(FAC * U2) / (U1 *
     1U2)) * * 2 * ((CB - SIN (RHI) * T) * * 2 * (CH * CH + 1. - 2. * CH
     2 * COS (PSIH - 2. * HWAVE * Q)) + SB * SB * (CV * CV + 1. - 2. * C
     3V * COS (PSIV - 2. * HWAVE * Q)) * R)
      GO TO 385
C
C      TERMINATED INTERLACED RHOMBIC             KOP=10
C
 240  HT = EX (1)
      SOK = 0.
      SS = EX (2)
      E = SIN (RHI)
      F = COS (RHI)
      D = SQRT (SS * SS + HT * HT)
      SG = HT / D
      CG = SS / D
      HTWAVE = 6.283185308 * HT / WAVE
      YH = PSIH - 2. * HWAVE * Q
      YV = PSIV - 2. * HWAVE * Q
      U1 = 1. - T * SIN (RETA + RHI)
      U2 = 1. - T * SIN (RHI - RETA)
      ELFAC = F * SIN (FAC * U1) * SIN (FAC * U2) / (U1 * U2)
      ELFAC2 = ELFAC * ELFAC
      Y = 6.283185308 / WAVE * (SS - D * (Q * SG + T * CG * CB))
      Z = Y - 2. * HTWAVE * Q
      H1 =1.+COS(Y) - CH * (COS(YH) * (1. + COS(Z)) - SIN(YH) * SIN(Z))
      H2 = - SIN(Y) - CH * (-SIN(YH) * (1. + COS(Z)) - COS(YH) * SIN(Z))
      HK = H1 * H1 + H2 * H2
      BRK = CB - E * T
      HRAIN = ELFAC2 * BRK * BRK * HK
      V1 = 1.+COS(Y) - CV*(COS(YV) * (1. + COS(Z)) - SIN(YV) * SIN(Z))
      V2 = -SIN(Y) - CV * (-SIN(YV) *(1. + COS(Z)) - COS(YV) * SIN(Z))
      VK = V1 * V1 + V2 * V2
      BRV = SB * SB * R
      VRAIN = ELFAC2 * BRV * VK
      RAIN = (HRAIN + VRAIN) * 0.8
      GO TO 385
C
C      INVERTED L                                KOP=8
C
 245  FAC2 = FAC * 2.
      FAC4 = FAC * 4.
      TWAVE = HWAVE * .15916
      IF(TWAVE - .20) 250, 251, 251
  250 EFF = TWAVE * (6.335 + TWAVE*(67.95 - TWAVE*(693. - 1600.*TWAVE)))
      EFF = 20.*ALOG10(EFF)
      GO TO 252
  251 EFF = 0.0
  252 HAC2 = HWAVE + HWAVE
      HAC4 = HAC2 + HAC2
      CALL CISI(HAC2,W5,W6)
      CALL CISI(HAC4,W7,W8)
      CIN2 = .577215 + ALOG(HAC2) - W5
      CIN4 = .577215 + ALOG(HAC4) - W7
      RA = 30. * (-.5 * COS(HAC2) * CIN4 + (1. + COS(HAC2)) * CIN2 +
     1 SIN(HAC2) * (.5 * W8 - W6))
      U = T * SB
      HK = 1. + CH * CH - 2. * CH * COS (PSIH - 2. * HWAVE * Q)
      C = 1. - COS(FAC2*U) * COS(FAC2) - U * SIN(FAC2*U) - 0.5 *
     1 SIN(FAC2) * SIN(FAC2) * (1. - U * U)
      HQ = Q * HWAVE
      CHQ = COS(HQ)
      SHQ = SIN(HQ)
      CFAC2 = COS(FAC2)
      SFAC2 = SIN(FAC2)
      A = CFAC2 * CHQ - Q * SFAC2 * SHQ - COS(HWAVE + FAC2)
      B = Q * SFAC2 * CHQ + CFAC2 * SHQ - Q * SIN(HWAVE + FAC2)
      BPRIM = 0.0
      if(A.ne.0.) BPRIM = ATAN(B / A)
      SPHIP = 1. - U * U
      G2 = 0.0
      if(SPHIP.ne.0.) G2 = HK * (2. * C * CB / SPHIP) ** 2
      F1 = 0.0
      if(T.ne.0.)F1=(A*A+B*B)*(1.-2.*CV*COS(PSIV- 2.*BPRIM)+CV*CV)/(T*T)
      RAIN = 30. * (G2 + F1) / RA
      X = 1.
      GO TO 385
C
C.....TERMINATED SLOPING VEE           KOP = 7,
C.....AND TERMINATED SLOPING RHOMBIC   KOP = 9.
  265 HT = EX(1)
      SOK = 0.
      IF(HT.LT.0.)THEN
        HT = ABS(HT)
      ELSE
        HT=HT/WAVE
      ENDIF
      G = (HT - H1) / EL1
      IF(KOP .EQ. 9) G = 0.5 * G
      P = SQRT(1. - G * G)
      E = SIN (RHI)
      F = COS (RHI)
      RHI = ASIN (E / P)
      SISUM = SIN (RHI + RETA)
      SIDIF = SIN (RETA - RHI)
      COSUM = COS (RHI + RETA)
      CODIF = COS (RHI - RETA)
      COPSI1 = Q * G + T * P * CODIF
      COPSI2 = Q * G + T * P * COSUM
      COPSI3 = - Q * G + T * P * CODIF
      COPSI4 = - Q * G + T * P * COSUM
      COPSI5 = T * G + Q * P * CODIF
      COPSI6 = T * G + Q * P * COSUM
      COPSI7 = - T * G + Q * P * CODIF
      COPSI8 = - T * G + Q * P * COSUM
      U1 = 1. - COPSI1
      U2 = 1. - COPSI2
      U3 = 1. - COPSI3
      U4 = 1. - COPSI4
      W1 = COS(PSIH - 2. * HWAVE * Q)
      W2 = SIN(PSIH - 2. * HWAVE * Q)
      W3 = COS(PSIV - 2. * HWAVE * Q)
      W4 = SIN(PSIV - 2. * HWAVE * Q)
      FAC2 = FAC * 2.
      IF(KOP - 9) 268, 235, 235
  268 Y1 = U1 * SISUM
      Y2 = U2 * SIDIF
      Y3 = U3 * SISUM
      Y4 = U4 * SIDIF
      Z1 = COS (FAC2 * U1) - 1.
      Z2 = COS (FAC2 * U2) - 1.
      Z3 = COS (FAC2 * U3) - 1.
      Z4 = COS (FAC2 * U4) - 1.
      V1 = SIN (FAC2 * U1)
      V2 = SIN (FAC2 * U2)
      V3 = SIN (FAC2 * U3)
      V4 = SIN (FAC2 * U4)
      UC27 = U2 * COPSI7
      UC18 = U1 * COPSI8
      UC45 = U4 * COPSI5
      UC36 = U3 * COPSI6
      RAIN = .025 * (P * P * (((Y2 * Z1 - Y1 * Z2) / (U1 * U2) - CH / (U
     13 * U4) * (Y4 * (W1 * Z3 + W2 * V3) - Y3 * (W1 * Z4 + W2 * V4))) *
     2 * 2 + (( - Y2 * V1 + Y1 * V2) / (U1 * U2) - CH / (U3 * U4) * (Y4
     3* (W2 * Z3 - W1 * V3) - Y3 * (W2 * Z4 - W1 * V4))) * * 2) + ((Z1 *
     4 UC27 - Z2 * UC18) / (U1 * U2) - CV / (U3 * U4) * (W3 * (Z3 * UC45
     5 - Z4 * UC36) + W4 * (V3 * UC45 - V4 * UC36))) * * 2 + (( - V1 * U
     6C27 + V2 * UC18) / (U1 * U2) - CV / (U3 * U4) * (W3 * ( - V3 * UC4
     75 + V4 * UC36) + W4 * (Z3 * UC45 - Z4 * UC36))) * * 2)
      RAIN = 2. * RAIN
      X = 1.
      GO TO 385
C  FINISH TERMINATED SLOPING RHOMBIC , KOP = 9
  235 A6 = 1. + COS(FAC2*(U1+U2)) - COS(FAC2*U1) - COS(FAC2*U2)
      B6 = - SIN(FAC2*(U1+U2)) + SIN(FAC2*U1) + SIN(FAC2 *U2)
      A7 = 1. + COS(FAC2*(U3+U4)) - COS(FAC2*U3) -  COS(FAC2*U4)
      B7 = - SIN(FAC2*(U3+U4)) + SIN(FAC2*U3) + SIN(FAC2*U4)
      X7 = COPSI8/U2 - COPSI7/U1
      Y7 = COPSI5/U3 - COPSI6/U4
      X8 = SIDIF /U1 - SISUM /U2
      Y8 = SIDIF /U3 - SISUM /U4
C.....SWITCH TO MA"S USE
      PSIV = PSIV - PI
      PSIH = PSIH + PI
      W1 = COS(PSIH - 2. * HWAVE * Q)
      W2 = SIN(PSIH - 2. * HWAVE * Q)
      W3 = COS(PSIV - 2. * HWAVE * Q)
      W4 = SIN(PSIV - 2. * HWAVE * Q)
      F7 = X7*A6  + Y7* CV * (A7* W3 - B7 * W4)
      G7 =  X7*B6  + Y7* CV * (A7* W4 + B7 * W3)
      F8 =  X8*A6  + Y8* CH * (A7* W1 - B7 * W2)
      G8 =  X8*B6  + Y8* CH * (A7* W2 + B7 * W1)
      RAIN = .05 *( F7*F7 + G7*G7 + P*P * (F8*F8 + G8*G8 ) )
      GO TO 385
C
C     CURTAIN                                    KOP=6
  270 CONTINUE
      IF(abs(DELTA-PIO2).gt.0001) go to 272    !  not vertical
  271 RAIN = floor
      GO TO 610
  272 CONTINUE
      SOK = 0.
C.....ALLOW SPACING FOR CURTAIN TO BE IN WAVELENGTHS
C.....(TO ALLOW CCIR ANTENNA PATTERNS HR M/N/H WITH EX(4)=-.25)
C
      DY = EX(2) / WAVE                  !  horz spacing bet dipole centers
      IF(EX(2).le.0.) DY=ABS(EX(2))      !  wavelengths
      DZ = EX(3) / WAVE                  !  vert spacing between dipoles
      IF(EX(3).le.0.) DZ=ABS(EX(3))      !  wavelengths
      DX = EX(4) / WAVE                  !  distance to screen
      IF(EX(4).le.0.) DX=ABS(EX(4))      !  wavelengths
C.....HEIGHT OF BOTTOM ELEMENT IS H1
      CHI = CH
      PSIHI = PSIH
      CH = - CHI * COS (PSIHI)
      PSIH = - CHI * SIN (PSIHI)
      IF (AMOD (PHI, 2.))275, 280, 275
 275  EP = 1.
      NEP = 1
      GO TO 285
 280  EP = 0.
      NEP = 0
 285  NN = (PHI - EP) / 2.
      M = EX (1)
      CVI = CV
      PSIVI = PSIV
      CV = - CVI * COS (PSIVI)
      PSIV = - CVI * SIN (PSIVI)
      FAC1 = FAC
      FAC2 = 2. * FAC
      FAC3 = PI * DY
      DENOM = 1. - SB * SB * T * T
      SEL = COS (FAC1 * SB * T) - COS (FAC1)
      SV = SB * Q
      SZ = SIN(2. * PI * DX * CB * T)
      SX = EP
      FAC4 = T * SB
      DO 290 I = 1, NN
      FN = 2 * I - 1 + NEP
  290 SX = SX + 2.0 * COS(FN * FAC3 * FAC4)
      FAC6 = (SEL * SX * SZ) / DENOM
      HREAL = 0.
      HIMG = 0.
      VREAL = 0.
      VIMG = 0.
      EH = 0.
      EV = 0.
      DO 295 J = 1, M
      FM = J - 1
      ARG = 2.0*PI * Q * (H1 + FM * DZ)
      CA(J) = COS(ARG)
 295  SA(J) = SIN(ARG)
      DO 315 J = 1, M
      HREAL = HREAL + 1.0 * (CA(J) * (1. + CH) + PSIH * SA(J))
      HIMG  = HIMG  + 1.0 * (SA(J) * (1. - CH) + PSIH * CA(J))
 315  CONTINUE
      EH = FAC6 * CB * SQRT (HREAL * HREAL + HIMG * HIMG)
      DO 330 J = 1, M
      VREAL = VREAL + 1.0 * (CA(J) * (1. + CV) + PSIV * SA(J))
      VIMG  = VIMG  + 1.0 * (SA(J) * (1. - CV) + PSIV * CA(J))
 330  CONTINUE
      EV = FAC6 * SV * SQRT (VREAL * VREAL + VIMG * VIMG)
      VALUE = SQRT (EH * EH + EV * EV)
      IF(VALUE.le..00001) go to 271
      RAIN = 20.*ALOG10(VALUE)
      SOK = 0.0
      GO TO 610
C
C     HORIZONAL DIPOLE AND HORIZONAL YAGI        KOP=3 AND 4
  340 DUMMY = FAC * 4.
      CALL CISI(DUMMY,W,W1)
      DUMMY = FAC * 2.
      CALL CISI(DUMMY,W2,W3)
      G = COT (FAC)
      SS = SB * SB
      C = T * T
cxxx      RAIN = 4. / ((1. - G * G) * (.5772 + ALOG (4. * FAC) + W) + 4. * G
cxxx     1 * G * (.5772 + ALOG (2. * FAC) + W2) + 2. * G * (W1 - 2. * W3)) *
cxxx     2 ((COS (FAC * SB * T) - COS (FAC)) / (1. - SS * C)) * * 2 * (CB *
cxxx     3CB * (CH * CH + 1. - 2. * CH * COS (PSIH - 2. * HWAVE * Q)) + SB *
cxxx     4 SB * R * (CV * CV + 1. - 2. * CV * COS (PSIV - 2. * HWAVE * Q)))
      ci_kl=w2
      si_kl=w3
      ci_2kl=w
      si_2kl=w1
      cin_kl=.577 + alog(2.*FAC) - ci_kl
      cin_2kl=.577 + alog(4.*FAC) - ci_2kl
      sin2kl=sin(2.*FAC)**2
      sin2kl=1.
      xR=30.*((1.-G*G)*cin_2kl + 4.*G*G*cin_kl +
     +      2.*G*(si_2kl-2.*si_kl))/sin2kl
      xKv=CV*CV + 1. -2.*CV*COS(PSIV-2.*HWAVE*Q)
      xKh=CH*CH + 1. -2.*CH*COS(PSIH-2.*HWAVE*Q)
      xt1=COS(FAC*SB*T) - COS(FAC)
      xb1=1.-SS*C
      xt2=(xKv*SS*R + xKh*CB*CB)/sin2kl
      RAIN=120./xR*(xt1/xb1)**2*xt2
ccc      if(abs(DELTA-PIO2).lt..0001) then      !  90 degrees elevation angle
ccc      if(ibeta.eq.0 .or. ibeta.eq.90) then
ccc         write(15,'('' delta,beta='',2f10.4)') delta,beta
ccc         write(15,'('' sin_delta,cos_delta='',2f10.4)') q,t
ccc         write(15,'('' sin_beta ,cos_beta ='',2f10.4)') SB,CB
ccc         write(15,'('' SS,R,CB='',3e15.7)') SS,R,CB
ccc         write(15,'('' PXIV,PSIH='',2e15.7)') PSIV,PSIH
ccc         write(15,'('' xKv,xKh='',2e15.7)') xKv,xKh
ccc         write(15,'('' xR='',e15.7)') xR
ccc         write(15,'('' xt1='',e15.7)') xt1
ccc         write(15,'('' xb1='',e15.7)') xb1
ccc         write(15,'('' xt2='',e15.7)') xt2
ccc         write(15,'('' RAIN='',e15.7)') RAIN
ccc         write(15,'('' CH,CV='',2e15.7)') CH,CV
ccc      end if
ccc      end if
      GO TO 385
C
C        VERTICAL LOG PERIODIC                   KOP=5
 345  SOK = EX (1)
      GO TO 351
C      VERTICAL MONOPOLE                          KOP = 2
  350 SOK = H
  351 TEMP = H
      H = EL
      EL = TEMP
      E = ER
      IF (H)360, 360, 355
 355  A = 6.283185 * H / WAVE
      X = H / WAVE
      GO TO 380
  360 H1 = ABS(H)
      A = H1 * 6.283185
      X = H1
 380  D = 2. * A
      Z = 2. * D
      CALL CISI (Z, W, W1)
      CALL CISI (D, W2, W3)
      HWAVE = 6.283 * X
      RA = 30. * ( - .5 * COS (D) * (.577215 + ALOG (Z) - W) + (1. + COS
     1 (D)) * (.577215 + ALOG (D) - W2) + SIN (D) * (.5 * W1 - W3))
      IF(EL1 - 0.2) 353, 354, 354
  353 RA = 400. * EL1 * EL1 * RINTW / 16.
  354 CONTINUE
      DENOM = COS(HWAVE*Q) - COS(HWAVE)
      if(DENOM.eq.0.) DENOM = 0.00000001
      BPRIM = ATAN((SIN(HWAVE*Q)-Q*SIN(HWAVE) )/DENOM)
      RAIN = 30. * (((COS (HWAVE * Q) - COS (HWAVE)) / (T * COS (BPRIM))
     1) * * 2 * (CV * CV + 1. - 2. * CV * COS (PSIV - 2. * BPRIM))) / RA
  385 RAIN = AMAX1(RAIN,0.00001)
      RAIN = 10.*ALOG10(RAIN)
C.....DO ANTENNA EFFICIENCY AS ITSA-1 RELBIL.
  610 GO TO (620,625,615,615,625,615,620,630,620,620,615), KOP
  615 EFF = 0.0
      GO TO 405
  620 EFF = -1.7
      GO TO 405
  625 IF(X.ge..35) go to 615
      EFF = (((6416.702573 * X - 6091.33295) * X + 2179.890548) * X - 36
     14.8173803) * X + 25.64620146
      EFF = -EFF
      GO TO 405
C   EFF CALCULATED ABOVE, KOP=8
  630 CONTINUE
  405 RAIN = RAIN + EFF + SOK
      IF(KOP.eq.2) go to 420
      IF(RAIN.le.floor) RAIN=floor + EFF
 420  RETURN
      END
C--------------------------------

      subroutine set_run       !  set current directory to ..\RUN
      use voacapl_defs
      use crun_directory
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50

c jw      integer*2 error_code
      integer error_code
      character tmp*50,subs(12)*10
c jw TODO reinsert the path sep parameter below
c      data subs/'\antennas\','\areadata\','\BIN_WIN\' ,'\coeffs\'  ,
c     +          '\database\','\geocity\' ,'\geonatio\','\geostate\',
c     +          '\HELP_WIN\','\news_win\','\SAVED\'   ,'\userdb\'  /

c jw TODO reinsert the path sep parameter below
      data subs/'/antennas/','/areadata/','/BIN_WIN/' ,'/coeffs/'  ,
     +          '/database/','/geocity/' ,'/geonatio/','/geostate/',
     +          '/HELP_WIN/','/news_win/','/SAVED/'   ,'/userdb/'  /

      nch=len(trim(run_directory))
      if(run_directory(nch-3:nch).eq.PATH_SEPARATOR//'RUN') go to 900    !  ok
      if(run_directory(nch-3:nch).eq.PATH_SEPARATOR//'run') go to 900    !  ok
c          force this to be the RUN sub-directory
      tmp=run_directory
c jw      call ucase(tmp,nch)                       !  convert to UPPER case
      do 10 i=1,12
      nch=lcount(subs(i),10)
      idx=index(tmp,subs(i)(1:nch))
      if(idx.le.0) go to 10
         run_directory=tmp(1:idx)//'run'
         go to 900
10    continue
c 900   call attach@(run_directory,error_code)    !  reset to the RUN directory
ccc      write(*, "(A)") trim(run_directory)
900   call chdir(trim(run_directory),error_code)    !  reset to the RUN directory
      return
      end
c--------------------------------------------------------------------
      subroutine get_run       !  get current directory
      use voacapl_defs
      use crun_directory
c jw      common /crun_directory/ run_directory
c jw      character run_directory*50
      character tmp*50

c      run_directory=curdir@()      !  get the current directory
      call getcwd(run_directory)      !  get the current directory
      nch=lenchar(run_directory)
c jw      call ucase(run_directory,nch)
c jw      if(run_directory(nch-7:nch).eq.'\BIN_WIN')
c jw     +          run_directory(nch-6:)='RUN'
      if(run_directory(1:2).ne.PATH_SEPARATOR//PATH_SEPARATOR) return
      if(run_directory(4:4).eq.PATH_SEPARATOR) then
         nch_run=lcount(run_directory,50)
         tmp=run_directory(3:3)//':'//run_directory(4:nch_run)
         run_directory=tmp
      end if
      nch=lenchar(run_directory)
c jw      call ucase(run_directory,nch)
      return
      end
c--------------------------------------------------------------------
c     subroutine get_run       !  get current directory
c     common /crun_directory/ run_directory
c        character run_directory*50
c     character curdir@*50,tmp*50
c     run_directory=curdir@()      !  get the current directory
c     if(run_directory(1:2).ne.'\\') return
c     if(run_directory(4:4).eq.'\') then
c        nch_run=lcount(run_directory,50)
c        tmp=run_directory(3:3)//':'//run_directory(4:nch_run)
c        run_directory=tmp
c     end if
c     return
c     end
c--------------------------------------------------------------------

c###fnorml.for
      FUNCTION FNORML(YPX)
C--------------------------------
C
C     THIS FUNCTION COMPUTES THE CUMULATIVE NORMAL DISTRIBUTION FUNCTION
C     FOR POSITIVE OR NEGATIVE VALUES OF X. SEE "THE HANDBOOK OF
C     MATHEMATICAL FUNCTIONS", AMS 55.  NOTE THAT THIS METHOD WILL WORK
C     ON 16 BIT MACHINES (32 BIT FLOATING POINT WORD)
C
      DIMENSION C(4)
      DATA C/.196854, .115194, .000344, .019527/
C
      YP = YPX
      IF(YPX) 105, 110, 110
  105 YP = - YPX
  110 YP = AMIN1(5.0, YP)
      QX = 1. + YP * (C(1) + YP * (C(2) + YP* (C(3) + YP * C(4))))
      QX = QX * QX * QX * QX
      QX = 1. / QX
      QX = .5 * QX
      IF(YPX) 115, 120, 120
  115 PX = QX
      QX = 1. - PX
      GO TO 125
  120 PX = 1. - QX
  125 CONTINUE
      FNORML = PX
      RETURN
      END
C--------------------------------
C--------------------------------

C------------------------
c# outant.f
      SUBROUTINE OUTANT
C--------------------------------
C
C     THIS ROUTINE OUTPUTS THE ANTENNA PATTERNS GENERATED IN GETANT
C     IF METHOD IS 13,14 OR 15 AND CREATES AN ANTENNA FILE IF USER
C     REQUEST WAS MADE VIA AN "ANTOUT" CONTROL CARD.
C
      use cversn
      common /cmodel/model
      character model*8
      common /cantenna/ numants,iats(20),anttype(20),antname(20),
     +                  xfqs(20),xfqe(20),designfreq(20),antfile(20),
     +                  beammain(20),offazim(20),cond(20),diel(20),
     +                  array(30,91,20),aeff(30,20)
      character anttype*10,antname*70,antfile*24
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON / CONTRL / IELECT(3), KTOUT(12), MONTHS(12), SUNSP(12),
     A IANTOU, ICARD, INTEG, IRED, ISOUT, ISPROC, ISSN, ITYPE, JDASH,
     B JFREQ, JLONG, KCARD, KRUN, MAPIN, MAXNAM, MONOLD, MOREM, MORES,
     C NUMNAM, NUPROC, MAXMET, MSPEC, M100
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / METSET / ITRUN, ITOUT, JTRUN(40), JTOUT(40)
c jw      common /CVERSN/ VERSN
c jw         character VERSN*8
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      dimension iff(21)
      CHARACTER ITL*46,xmtrecv(2)*11
      DATA ITL/'          ELEVATION ANGLE IN DEGREES'/
      data xmtrecv/'TRANSMITTER','RECEIVER'/
c          METHOD=13 = Transmitter output only (ITR=1)
c          METHOD=14 = Receiver    output only (ITR=2)
c          METHOD=15 = Both Transmitter (ITR=1) & Receiver (ITR=2) output
      itr1=1
      itr2=2
      if(method.eq.13) itr2=1
      if(method.eq.14) itr1=2
      do 200 itr=itr1,itr2

C.... PRINT THE PATTERN
      do 150 ian=1,numants
      if(iats(ian).ne.itr) go to 150
      
      LPAGES = LPAGES + 1
      WRITE(LUO,500) METHOD, model,VERSN, LPAGES
  500 FORMAT(1H,32X,'METHOD',I3,1X,a8,1x,a8,2X,'PAGE',I4,/)
      WRITE(LUO,502) anttype(ian),xmtrecv(itr),antfile(ian),antname(ian)
  502 FORMAT(1x,a10,' ANTENNA PACKAGE',26X,'ANTENNA PATTERN',10x,a,/
     + 2h [,a21,2h] ,a70,/
     A ' Frequency Range  ',
     B 'Design Freq  Bearing   Off Azim  Conduct.  Dielect.')
      WRITE(LUO,504) xfqs(ian),xfqe(ian),designfreq(ian),
     +               beammain(ian),offazim(ian),
     +               cond(ian),diel(ian)
  504 FORMAT(1X,F5.1,' to ',F5.1,2X,f10.3,2f10.1,2f10.3)
      if1=xfqs(ian)
      if2=xfqe(ian)
      if(if2-if1.le.20) then
         nf=if2-if1+1
         do 10 if=1,nf
10       iff(if)=if1 + if-1
      else
         nf=21
         do 20 if=1,13
20       iff(if)=if+1
         do 25 if=14,21
25       iff(if)=16 + (if-14)*2
      end if
      WRITE(LUO,506) (iff(if),if=1,nf)
      DO 140 K =1,91,2
      L = 92-K
      M = L-1
      N = (K+1)/2
      WRITE(LUO,508) ITL(N:N),M,(ARRAY(iff(i),L,ian),I=1,nf)
  140 CONTINUE
      WRITE(LUO,506) (iff(if),if=1,nf)
      WRITE(LUO,510)
      WRITE(LUO,512) (AEFF(iff(i),ian),I=1,nf)
      WRITE(LUO,506) (iff(if),if=1,nf)
      WRITE(LUO,510)
150   CONTINUE
200   CONTINUE
      RETURN
  506 FORMAT(4X,21(4X,I2) )
  508 FORMAT(1X,A1,1X,I2,21F6.1)
  510 FORMAT(/,/,48X,'FREQUENCY IN MEGAHERTZ')
  512 FORMAT(/,/,48X,'ANTENNA EFFICIENCY',/,' ',4X,21F6.1)
      END
C--------------------------------

c###virtim.for
      SUBROUTINE VIRTIM
C--------------------------------
C
C     THIS ROUTINE EVALUATES TIME VARIATION OF LONG TERM PREDICTION MAPS
C
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON / ONE /   IA(6), IB(6), IKIM(10,6), ESLCOF(5,55),
     1                 ESMCOF(7,61), ESUCOF(5,55), F2COF(13,76),
     2                 FM3COF(9,49), ERCOF(9,22)
      REAL*4 COFION(2604)
      EQUIVALENCE(ESLCOF,COFION)
      COMMON / TWO / F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     A FAM(14,12), SYS(9,16,6), PERR(9,4,6)
      COMMON /TWO_AB/ AB(318)
      DIMENSION C (8), S (8), IC (6)
C.....START OF EACH TWO DIMENSIONAL ARRAY IN "COFION"
      DATA IC/1,56,117,172,248,297/
      TIME = (15. * GMT - 180.) * D2R
      C (1) = COS (TIME)
      S (1) = SIN (TIME)
      DO 100 JB = 2, 8
      C (JB) = C (1) * C (JB - 1) - S (1) * S (JB - 1)
  100 S (JB) = C (1) * S (JB - 1) + S (1) * C (JB - 1)
C.....FOURIER EXPANSION ON TIME VARIATION
      DO 110 IZ = 1, 6
C.....LIMITS FOR FOURIER EXPANSION
      J = IKIM (10, IZ)
      I = IKIM (9, IZ) + 1
      DO 105 JB = 1, I
C     COFION( 1,JB,IZ)  AND AB(JB,IZ)
C.....CALCULATE SUBSCRIPTS
      ISUBB = IA (IZ) + (JB - 1) * IB (IZ)
      ISUBA = IC (IZ) + JB - 1
      AB (ISUBA) = COFION (ISUBB)
      DO 105 KA = 1, J
C     COFION(2*KA,JB,IZ) AND COFION(2*KA+1,JB,IZ)
C.....CALCULATE SUBSCRIPT
      ISUBC = ISUBB + 2 * KA - 1
C.....ADD FOURIER EXPANSION
105   AB(ISUBA)=AB(ISUBA)+S(KA)*COFION(ISUBC)+C(KA)*COFION(ISUBC+1)
110   CONTINUE
C.....THE 5208 COEFFICIENTS WERE REDUCED TO 2604 BY THE SUNSPOT
C.....NUMBER INTERPOLATION.  THE TIME VARIATION EVALUATION HAS REDUCED
C.....THE NUMBER TO 318.
      RETURN
      END
C--------------------------------

c# genfam.f
C--------------------------------
      SUBROUTINE GENFAM(Y2,IBLK,FREQ,Z,FA,DUA,DLA,DMS,DUS,DLS)
c**********************************************************************
c          Re-written 3.June.93 by Greg Hand because previous version was
c          really incorrect. It made an attempt to limit Sigma Fam (DMS)
c          to a 10 MHz frequency, but the indicies I and J became
c          confused, and the result was not correct. Ironically,
c          Sigma Fam was the only result that was computed correctly.
c          DUA, DLA, DUS, DLS were all incorrect.  This current
c          version should limit DMS to 10 MHz and the others to 20 MHz
c          because their curves end at 20 MHz. Unfortunately, this error
c          has probably existed since time began, and it may take a
c          while for this corrected version to propagate into all version
c          that exist. The magnitude of the errors in DUA, DLA, DUS, DLS
c          could approach +/- 4dB at 20MHz.  However, for use in
c          propagation prediction programs such as IONCAP, these errors
c          are almost unnoticable because Atmospheric Noise is not
c          the driving force at HF frequencies.
c**********************************************************************
c          INPUTs:
c              Y2 = latitude of point of interest
c                   only cares if + or - to flip Northern/Southern Hemisphere
c              IBLK = time block of interest (local time 1=0000-0400)
c              FREQ = Frequency in MHz
c              Z = 1 MHz Fam value
c**********************************************************************
c          OUTPUTs:
c              FA = Frequency variation of Fam
c              DUA = Du = ratio of upper decile to median value (Fam)
c              DLA = Dl = ratio of median value (Fam) to lower decile
c              DMS = Sigma Fam = standard deviation of values of Fam
c              DUS = Sigma Du  = standard deviation of values of Du
c              DLS = Sigma Dl  = standard deviation of values of Dl
c**********************************************************************
C--------------------------------
C
C     GENFAM CALCULATES THE FREQUENCY DEPENDENCE OF THE ATMOSPHERIC
C     NOISE AND GETS DECILES AND PREDICTION ERRORS FROM TABLES
C
      COMMON / TWO / F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     A FAM(14,12), SYS(9,16,6), PERR(9,4,6)
      DIMENSION V(5)
C.....
      IBK=IBLK
C.....CHECK IF LATITUDE IS NORTH OR SOUTH
      IF(Y2.lt.0.) IBK=IBK+6
      U1 = -.75
      X = ALOG10(FREQ)
      U = (8. * 2.**X - 11.) /4.
      KOP = 1
 110  PZ = U1*FAM(1,IBK) + FAM(2,IBK)
      PX = U1*FAM(8,IBK) + FAM(9,IBK)
      DO 115 I=3,7
      PZ = U1*PZ + FAM(I  ,IBK)
 115  PX = U1*PX + FAM(I+7,IBK)
      IF(KOP.eq.1) then
         CZ = Z * PZ + PX
         CZ = Z + Z - CZ
         U1 = U
         KOP = 2
         GO TO 110
      end if
      FA = CZ*PZ + PX
c***********************************************************
c          Limit frequency to 20 MHz for DUA, DLA, DUS, DLS
c            because curves in REP 322 only go to 20 MHz
      if(FREQ.gt.20.) X=ALOG10(20.)
      DO 145 I = 1, 5
c          Limit frequency to 10 MHz for DMS (Sigma Fam)
c            because curves in REP 322 only go to 10 MHz
      if(I.eq.5 .and. FREQ.gt.10.) X=1.
      Y = DUD(1,IBK,I)
      DO 140 J = 2,5
 140  Y = Y*X + DUD(J,IBK,I)
 145  V(I) = Y
      DUA = V(1)
      DLA = V(2)
      DUS = V(3)
      DLS = V(4)
      DMS = V(5)
      RETURN
      END

c###penang.for
      SUBROUTINE PENANG(K)
C--------------------------------
C
C     THIS ROUTINE CALCULATES THE PENETRATION ANGLE FOR EACH LAYER
C
C     LAW OF SINES, SNELL"S LAW AND TABLE INCREMENTS ARE BEING COMBINED
C
      COMMON/REFLX/DELFX(45,3),HPFLX(45,3),HTFLX(45,3),GDFLX(45,3),FVFLX
     A (45,3),DSKPKM(3),DELSKP(3),HPSKP(3),HTSKP(3),DMAXKM(3),FVSKP(3)
     B ,ISKP(3),IMODE(45,3),AFFLX(45,3),DELPEN(3,5),GML(45,3),FHP(45,3)
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      FMHZ = FREQ
C.....USE CUSP FOR E LAYER
      HT = HTRUE (10, K)
      FV = FVERT (10, K)
      FRAT = FV / FREQ
      FRAT = FRAT * FRAT
      IF (FRAT - 0.9999)110, 105, 105
  105 DELPEN (1, K) = 89.9
      DELPEN (2, K) = 90.0
      DELPEN (3, K) = 90.0
      GO TO 205
  110 CDEL = (RZ + HT) * SQRT (1. - FRAT) / RZ
      IF (CDEL - .999999)115, 115, 125
  115 DELPEN (1, K) = ACOS (CDEL) * R2D
      GO TO 135
  125 DELPEN (1, K) = 0.0
  135 IF (FI (2, K))145, 145, 180
  145 DELPEN (2, K) = DELPEN (1, K)
  155 CONTINUE
C   REFLECTION UNTIL MAX(RZ+HT)*MU , NOT UNTIL MIDDLE OF LAYER
C.....BUT F LAYER IS SENSITIVE TO SPERICAL SYMMETRY DUE TO THICKNESS
      IF(FVERT(30,K) - FREQ + 0.0001 ) 156,160,160
  156 XM28 = (RZ + HTRUE(28,K)) * SQRT(1.0 - (FVERT(28,K) / FMHZ) ** 2 )
      XM29 = (RZ + HTRUE(29,K)) * SQRT(1.0 - (FVERT(29,K) / FMHZ) ** 2 )
      XM30 = (RZ + HTRUE(30,K)) * SQRT(1.0 - (FVERT(30,K) / FMHZ) ** 2 )
      IF(XM30 - XM29) 161, 157, 157
  157 IF(XM30 - XM28) 158, 159, 159
  158 CDEL = XM28 / RZ
      GO TO 163
  159 CDEL = XM30 / RZ
      GO TO 163
  160 DELPEN(3,K) = 89.9
      GO TO 205
  161 IF(XM29 - XM28) 158, 162, 162
  162 CDEL = XM29 / RZ
  163 CONTINUE
      IF (CDEL - .999999)170, 170, 175
  170 DELPEN (3, K) = ACOS (CDEL) * R2D
      GO TO 205
  175 DELPEN (3, K) = 0.0
      DSKPKM (K) = - 1.
      DMAXKM (K) = - 1.
      RETURN
C.....JUST USE CUSP FOR F1 LAYER
  180 HT = HTRUE (20, K)
      FV = FVERT (20, K)
      FRAT = FV / FREQ
      FRAT = FRAT * FRAT
      IF (FRAT - 0.9999)190, 185, 185
  185 DELPEN(2,K) = 89.9
      DELPEN (3, K) = 90.
      GO TO 205
  190 CDEL = (RZ + HT) * SQRT (1. - FRAT) / RZ
      IF (CDEL - .999999)195, 195, 200
  195 DELPEN (2, K) = ACOS (CDEL) * R2D
      GO TO 155
  200 DELPEN (2, K) = 0.
      GO TO 155
  205 CONTINUE
      RETURN
      END
C--------------------------------

c###xlin.for
      FUNCTION XLIN(X,XN,YN,NTAB,K)
C--------------------------------
C
C     THIS ROUTINE DOES LINEAR INTERPOLATION
C
C     XN AND YN MAY BE MULTIPLE SUBSCRIPTED
C
      DIMENSION XN(*),YN(*)
      ISMIN=NTAB*(K-1)
      ISMAX=NTAB*K
      IS=ISMIN+1
      IF(XN(IS)-X) 3,3,2
    2 XLIN=YN(IS)
      RETURN
    3 NMIN1=NTAB-1
      DO 19 J=1,NMIN1
      IS=ISMIN+J
      IF(XN(IS)-XN(IS+1)) 8,5,11
    5 IF(X-XN(IS)) 19,7,19
    7 XLIN=YN(IS)
      RETURN
    8 IF(XN(IS)-X) 9,9,10
    9 IF(X-XN(IS+1)) 10,19,19
   10 A=YN(IS)
      B=X-XN(IS)
      C=YN(IS+1)-YN(IS)
      D=XN(IS+1)-XN(IS)
      XLIN=A+B*C/D
      RETURN
   11 IF(XN(IS)-X) 19,12,12
   12 IF(X-XN(IS+1)) 19,19,10
   19 CONTINUE
      XLIN=YN(ISMAX)
      RETURN
      END
C--------------------------------

C SUBROUTINE GAIN             (NEXT)
c          this is the GAIN routine for HFMUFES ITS-78 antennas
      SUBROUTINE MUFESGAN (KOP,KAS,TOAZ,YSIG,YEPS,YND,YNL,YNH,TEX,
     +                 DELTA, FREQ, RAIN, EFF)
      save FLOG,C2KEL,S2KEL,ZT,RZERO,RIN
C 
C     GAIN - CALCULTES THE GAIN IN DECIBELS OF THE TRANSMITTING AND 
C        RECEIVING ANTENNAS.
C     KOP       ANTENNA 
C       1    TERMINATED RHOMBIC 
C       2*   VERTICAL 
C       3*   HORIZONTAL HALF-WAVE DIPOLE
C       4    HORIZONTAL YAGI
C       5    VERTICAL DIPOLE
C       6*   CURTAIN ARRAY WITH SCREEN
C       7    TERMINATED SLOPING VEE 
C       8*   INVERTED L 
C       9    TERMINATED SLOPING RHOMBIC 
C      10    ANTENNA GAINS ARE IN THE PREVIOUSLY STORED ARRAY 
C      11    SLOPING LONG WIRE
C      12    CONSTANT GAIN
C      13    HORIZONTAL LOG PERIODIC
C      14    ARBITRARY TILTED DIPOLE
C      15    HALF RHOMBIC 
C      16    SLOPING DOUBLE RHOMBOID
C      17*   VERTICAL WITH A RADIAL CONDUCTOR GROUND SYSTEM 
C 
C        NOTE  THE ANTENNA NUMBERS, (KOP) WITH AN ASTERISK AFTER THEM 
C        HAVE BEEN CHECKED AGAINST THE EQUATIONS IN MA AND WALTERS(1969)
C        AND WHERE NECESSARY BROUGHT INTO AGREEMENT WITH THAT REPORT
C 
C        NOTE  FOR KAS .NE. 0, THE ARRAY IS FILLED AUTOMATICALLY (AS IN 
C        METHOD=9) IN SUBROUTINE LUFFY IN ORDER TO
C        SAVE COMPUTATION TIME.  FOR KAS = 0, THEN, THIS ARRAY IS 
C        INTERPOLATED ON TO OBTAIN THE GAIN AT A GIVEN FREQ AND ANGLE 
C 
C 
C     ITR = 0 = CALCULATE GROUND REFLECTION LOSSES ONLY,
C         = 1 = TRANSMITTER ANTENNA GAIN CALCULATION
C         = 2 = RECEIVER ANTENNA GAIN CALCULATION 
C     KAS = 0 = INTERPOLATE GAIN FROM ARRAY 
C         = 1 = FIRST CALL FOR EACH FREQUENCY, SO CALCULATE THE 
C               IMPEDANCES, CURRENTS, ETC., 
C         .GT. 1 = NOT FIRST CALL OF FREQUENCY, SO SKIP CALCULATION 
C                  OF IMPEDANCES, CURRENTS, ETC., 
C     DELTA = TAKE-OFF ANGLE IN RADIANS,
C     FREQ = FREQUENCY IN MHZ., 
C     RAIN = THE GAIN IN DB RETURNED TO THE CALLING ROUTINE,
C     EFF = THE ANTENNA EFFICIENCY IN DB RETURNED TO THE CALLING ROUTINE
C     THE OTHER ANTENNA PARAMETERS ARE COMMUNICATED TO GAIN VIA 
C     PARAMETERS NTR, XFQB, XFQE, IANT, TOAZ, XQ, XP, XNH, XNL, XND,
C     AND TEX IN COMMON.
C 
C 
C     POWER GAIN OF ANTENNA AND GROUND REFLECTION LOSS. 
C 
C     SEE ITS-78, ESSA TECH REPORT ERL 104-ITS 74 (MA AND WALTERS,
C     APRIL 1969), AND ESSA TECH REPORT IER 54-ITSA 52 (MA AND WALTERS, 
C     1967) FOR THE DETAILS OF SUBROUTINES GAIN, CZS1, ONEJ, COLL,
C     ECH, ZMUT, CIN, SIM, CMPINV, MATINV, SQMULT, MUTUAL, AGAUSS,
C     REACT, RESIST.  SEE ALSO ANY PARTICULAR REFERENCES GIVEN IN EACH. 
C. . .SEE ALSO MA, M.T.(1974), THEORY AND APPLICATION OF ANTENNA ARRAYS 
C. . .WILEY-INTERSCIENCE. THE MAIN REFERENCE IS MA AND WALTERS (1969). .
C 
      dimension TEX(4)
      DIMENSION CIX (20), CIY (20), D (20), EX (4), R (5, 5), RDZ (5, 10
     1), RDZB (10), RDZE (5, 5), RDZZ (5), RP (5, 5), RPZB (5), RPZE (5)
     2, RT (5, 10), RTZB (10), RTZE (5, 5), RTZZ (5), RZB (5), RZE (5), 
     3TX (20, 20), TY (20, 20), XK (20), YI (20, 20), YR (20, 20), Z (20
     4, 20) 
      COMPLEX WK2,WKOK2,WK2OK,RV,RH,RC
C 
      COMPLEX ACSQ, AZH, AZV,  CSZ1, DELZ, DIF, EPHI, ETA, ETH
     1ETA1, ETHETA2,  HRATIO, QPAR, QPER, R, RDZ, RDZB, RDZE, R
     2DZZ, RHCP, RP, RPZB, RPZE, RPZZ, RT, RTZB, RTZE, RTZZ, RZB, RZE, R
     3ZZ, SQRD, V, Z, ZM, ZSUM1, ZSUM2, ZSUM3, ZSUM4, ZT, ZTERM1, ZTERM2
     4, ZTERM3, ZTERM4, ZTR, ZS, AF, CURNT, CTU, CTD, A1, B1
C 
C 
ccc      COMMON /AON /ARRAY (30, 91, 2), ITRP, ZANTP (3, 2), AEFF (30,2),
ccc     1 JA, JTR, J, MTR (2), JANT (20, 2), YNH (20, 2), YNL (20, 2),
ccc     2YND(20, 2),YETA (20, 2), TEY (4, 20, 2), YQ (20, 2), YP (20, 2),
ccc     3YFQB (20, 2), YFQE (20, 2) 
C 
ccc      COMMON /DON /ABI (24), ABIY (5, 24), ALATD, AMIN, AMIND, BRTD, BTR
ccc     1, BTRD, CLAT (5), CLCK (5, 24), CLONG (5), DLONG, DMP, EC (24), EM
ccc     2F (5, 24), ERTR, ESC (24), ESDL (24), ESDU (24), FC (24), FM (24),
ccc     3 FMM (5,24), FOES (5,24,3),SPDF (5,24), FOT (24), GCD, GCDKM, 
ccc     4GEC (24), GLAT (5), GMA (5,24), GY (5,24), GYR (24), HO (24), 
ccc     5HPFR (24), HY (5, 24), IANT (3, 2), IEA, IFQB, IFQE, IRCVR    , 
ccc     6 ITRAN    , LUFP, NOISE, NTR (2), PMP, PMUF (10, 24), 
ccc     7PWR, RD (5), RLAT, RLATD, RLONG, RLONGD, RSN, SIGTR, TEX (4, 3, 2)
ccc     8, TLAT, TLATD, TLONG, TLONGD, TOAZ (3, 2), XBTA (24), XETA (3, 2),
ccc     9 XFQB (3, 2), XFQE (3, 2), XLUF (24), XMUF (24), XND (3, 2), XNH (
ccc     A3,2),XNL(3,2),XP(3,2),XQ(3,2),YM(24),ESMUF(24),ESHPF(24),ESBTA(24)
ccc     B,ESMODE 
C 
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RO, VOFL 
C 
      COMMON /CUR /DIJ, EIL, HIJ, KODE
C 
      COMMON /MUT /CFAC, CT, H2, PROD1, RHI2, R21, X21, Y0, Z0
C 
      COMMON /WAITS /HH (48), XI (48) 
C 
      COMMON /HFMUFES_ONE /D1D (20), ELL (20), NMX, NO, ZS (20) 
ccc      CHARACTER*8 ITRAN(2),IRCVR(2),ESMODE(24)
ccc      CHARACTER*16 ZANTP
C 
C        48 POINT GAUSSIAN INTEGRATION - WEIGHTS AND ABSCISSAS
C 
C 
C            NOTE ALL EQUATION AND PAGE NUMBERS REFERRED TO BELOW ARE 
C            FROM MA AND WALTERS(1969) UNLESS EXPLICITLY NOTED
C            OTHERWISE.                (J)= SQRT(-1). 
C 
C 
C.....SET UP CONSTANTS AND PICK UP PARAMETERS...........................
      DATA (XI (J), J = 1, 48) / - 0.99877100725, - 0.99353017227, - 0. 
     198412458372, - 0.97059159255, - 0.95298770316, - 0.93138669071, - 
     20.90587913672, - 0.87657202027, - 0.84358826162, - 0.80706620403, 
     3- 0.76715903252, - 0.72403413092, - 0.67787237963, - 0.62886739678
     4, - 0.57722472608, - 0.52316097472, - 0.46690290475, - 0.408686481
     599, - 0.34875588629, - 0.28736248736, - 0.22476379039, - 0.1612223
     65607, - 0.097004699209, - 0.032380170963, 0.032380170963, 0.097004
     7699209, 0.16122235607, 0.22476379039, 0.28736248736, 0.34875588629
     8, 0.40868648199, 0.46690290475, 0.52316097472, 0.57722472608, 0.62
     9886739678, 0.67787237963, 0.72403413092, 0.76715903252, 0.80706620
     A403, 0.84358826162, 0.87657202027, 0.90587913672, 0.93138669071, 0
     B.95298770316, 0.97059159255, 0.98412458372, 0.99353017227, 0.99877
     C100725/ 
      DATA (HH (J), J = 1, 48) / 0.0031533460523, 0.007327553901, 0.011 
     1477234579, 0.015579315723, 0.019616160457, 0.023570760839, 0.02742
     26509708, 0.031167227833, 0.034777222565, 0.038241351066, 0.0415450
     382943, 0.044674560857, 0.047616658492, 0.050359035554, 0.052890189
     4485, 0.055199503700, 0.057277292100, 0.059114839698, 0.06070443916
     56, 0.062039423160, 0.063114192286, 0.063924238585, 0.064466164436,
     6 0.064737696813, 0.064737696813, 0.064466164436, 0.063924238585, 0
     7.063114192286, 0.062039423160, 0.060704439166, 0.059114839698, 0.0
     857277292100, 0.055199503700, 0.052890189485, 0.050359035554, 0.047
     9616658492, 0.044674560857, 0.041545082943, 0.038241351066, 0.03477
     A7222565, 0.031167227833, 0.027426509708, 0.023570760839, 0.0196161
     B60457, 0.015579315723, 0.011477234579, 0.0073275539013, 0.00315334
     C60523/
C 
ccc      DATA ARRAY/5460 * 0.0/,AEFF/60 * 0.0/ 
C 
      DATA SQRTWO/1.41421356237/,RINTW/18.06/,RINFR/100.34/,XINTR/.60001
     12/
C.....RINTW IS "RIN" FOR VERTICAL MONOPOLE AT H/LAMDA = .2
C.....RINFR IS "RIN" FOR VERTICAL DIPOLE AT H/LAMDA = .4
C.....XINTR = (4. - 1.) / (5. - 0.0001) 
C     CHANGE (LENGTH/DIAMETER) RATIO FOR HALF-WAVE ANTENNA FROM 1000
C     TO 4680. SEE MA (1974), TABLE 4.1, P. 254.
      floor=-30.                !  antenna gain floor value (was -10.)
      rain_min=.001
      RATIO = SQRTWO / 4680.0 
      DELTD = DELTA * R2D 
      BETA = TOAZ
      SIGMA = YSIG
      ER = YEPS
      H = YNH
      EL = YNL
      PHI = YND
      DO 110 IKEX = 1, 4
 110  EX(IKEX) = TEX(IKEX) 
      if(DELTA.le.0.) then
         RAIN = floor
         EFF = 0.0 
         GO TO 630 
      end if
      IF (KOP .EQ. 12) GO TO 475
C.....CALCULATE WAVE=WAVELENGTH IN METERS AND SET EFFICIENCY=0DB
      WAVE = VOFL / FREQ
      EFF = 0.0 
C.....CALCULATE SIN AND COS OF TAKE-OFF ANGLE (=90-ZENITH ANG.) 
      Q = SIN (DELTA) 
      T = COS (DELTA) 
C.....DIF=COMPLEX DIELECTRIC CONSTANT=ER-(J)*18000*SIGMA/FREQ(MHZ)
C     SEE EQN.(11), P.6.
      DIF = CMPLX (ER, - 60.0 * SIGMA * WAVE) 
C.....ACSQ=RATIO OF WAVE NUMBER IN MEDIA TO THAT IN FREE SPACE, 
C     SEE EQN.(11), P. 6. 
      ACSQ = CSQRT (DIF - T * * 2)
C.....CALCULATE COMPLEX FRESNEL REFLECTION COEFFICIENT FOR VERTICAL 
C     (PERPENDICULAR) POLARIZATION(RV), EQN(9), P. 5. 
      QPER = (DIF * Q - ACSQ) / (DIF * Q + ACSQ)
      CV = CABS (QPER)
      PSIV = CANG (QPER)
C.....CALCULATE COMPLEX FRESNEL REFLECTION COEFFICIENT FOR HORIZONTAL 
C     (PARALLEL) POLARIZATION(RH), EQN(10), P. 5. 
      QPAR = (Q - ACSQ) / (Q + ACSQ)
      CH = CABS (QPAR)
      PSIH = CANG (QPAR)
C.....PUT PARAMETERS INTO WAVELENGTHS FOR ANTENNA GAIN CALCULATIONS.....
      EL1 = EL / WAVE 
      IF (EL .LT. 0.0) EL1 = ABS (EL) 
      FAC = PI * EL1
      FAC2 = PI2 * EL1
      FAC4 = 2.0 * FAC2 
      X = H / WAVE
      IF (H .LT. 0.0) X = ABS (H) 
      HWAVE = PI2 * X 
      HQWAVE = 2.0 * HWAVE * Q
      RHI = PHI * D2R 
      SR = SIN (RHI)
      CR = COS (RHI)
      RETA = BETA * D2R 
      SB = SIN (RETA) 
      CB = COS (RETA) 
C...ANTENNAS  1   2   3   4   5   6   7   8   9  10  11  12 13 14 15 16 17 =KOP
      GO TO(160,165,205,220,275,285,380,405,435,445,450,475,
     1 480, 560, 590, 595, 165), KOP 
C.....TERMINATED RHOMBIC ANTENNA, KOP=1.................................
 160  TSC = 1.0 - T * SR * CB 
      TCS = T * CR * SB 
      U1 = TSC - TCS
      U2 = TSC + TCS
      W1 = COS (PSIH - HQWAVE)
      W3 = COS (PSIV - HQWAVE)
      RAIN = 3.20 * (CR * SIN (FAC * U1) * SIN (FAC * U2) / (U1 * U2)) *
     1 * 2 * ((CB - SR * T) * * 2 * (CH * * 2 + 1.0 + 2.0 * CH * W1) + S
     2B * * 2 * (CV * * 2 + 1.0 - 2.0 * CV * W3) * Q * * 2) 
      EFF = - 1.7 
      GO TO 615 
C.....VERTICAL ANTENNA, KOP=2...........................................
 165  DMPIO2 = ABS (DELTA - PIO2) 
      RAIN = .00004 
      IF (DMPIO2 .LE. 0.5 * D2R)GOTO170 
C. . .CALCULATE A=A2,AS=B2,EQN.(30), P. 11
      SFAC2 = SIN (FAC2)
      CFAC2 = COS (FAC2)
      HQ = FAC2 * Q 
      A = COS (HQ) - CFAC2
      AS = SIN (HQ) - Q * SFAC2 
      IF(kas.le.1) then
C. . .CALCULATE RIN, EQN.(33), P. 12
         FLOG = ALOG (FAC2)
         C2KEL = 2.0 * CFAC2 * CFAC2 - 1.0 
         S2KEL = 2.0 * CFAC2 * SFAC2 
         ZT = CSZ1 (4.0 * FAC2)
C. . .LN(2)=0.6931471806, LN(4)=1.3862943612
         RZERO=.5*(C2KEL*(REAL(ZT)-FLOG-1.3862943612-GAMA)-
     +                      S2KEL*AIMAG(ZT))
         ZT = CSZ1 (FAC4)
         RZERO=30.*(RZERO+(1.+C2KEL)*(REAL(-ZT)+FLOG+0.6931471806+GAMA)
     +                     +S2KEL*AIMAG(ZT)) 
         RIN = RZERO 
         IF(EL1.lt..2) RIN = 400. * EL1 * EL1 * RINTW / 16.
         RZERO = RIN 
      end if
C.....FOR VERTICAL WITH GROUND SCREEN 
C.....CALCULATE REST OF FACTORS PER PP 13-15
      IF (KOP .EQ. 17) GO TO 175
C. . .CALCULATE GAIN USING EQNS. (29) AND (34), PP. 11-12 
      W3 = COS (PSIV) 
      W4 = SIN (PSIV) 
      RAIN = 30.0 * ((A * (1.0 + CV * W3) + AS * CV * W4) * * 2 + (A * C
     1V * W4 + AS * (1.0 - CV * W3)) * * 2) / (RIN * T * * 2) 
      RAIN = AMAX1 (RAIN, .00004) 
 170  IF (EL1 .GE. 0.35) GO TO 615
      EFF = - ((((6416.702 * EL1 - 6091.33) * EL1 + 2179.89) * EL1 - 364
     1.817) * EL1 + 25.646) 
      GO TO 615 
C.....VERTICAL ANTENNA WITH A RADIAL CONDUCTOR GROUND SYSTEM, KOP=17....
 175  continue
      IF (kas .le. 1) then
C   . . .GET AA=LENGTH OF RADIALS IN WAVE LENGTHS
         AA = PHI / WAVE 
         IF (PHI .LT. 0.0) AA = ABS (PHI)
C   . . .CAYA=K*AA=WAVE NUMBER * LENGTH OF RADIALS 
         CAYA = PI2 * AA 
C   . . .ETA FROM EQN. IN TEXT FOLLOWING EQN.(37), P. 13 
         ETA=CSQRT(CMPLX(0.,8.*PI**2*FREQ*.1)/
     +       CMPLX(SIGMA,FREQ*ER*.001/18.))
         ALPHA = CANG (ETA) + PIO2 
C   . . .LITTLE R0 AND LITTLE R1, P. 15
         RZ = SQRT (AA * * 2 + EL1 * * 2)
         R1 = AA + RZ
         ZTR = CMPLX (0.0, PIO2) 
C   . . .DELTAZ1, EQN.(39), P.14 
      DELZ = (CSZ1 (2.0 * PI2 * (RZ + EL1)) + ZTR) * CMPLX (C2KEL, S2KEL
     1) + (CSZ1 (2.0 * PI2 * (RZ - EL1)) + ZTR) * CMPLX (C2KEL, - S2KEL)
     2 + (CSZ1 (2.0 * CAYA) + ZTR) * 2.0 * CFAC2 * * 2 + (CSZ1 (PI2 * R1
     3) + ZTR) * 4.0 * CFAC2 - (CSZ1 (PI2 * (R1 - EL1)) + ZTR) * 4.0 * C
     4FAC2 * CMPLX (CFAC2, - SFAC2) - (CSZ1 (PI2 * (R1 + EL1)) + ZTR) * 
     54.0 * CFAC2 * CMPLX (CFAC2, SFAC2)
         DELR1 = REAL (DELZ * ETA / (2.0 * PI2)) 
         ETA1 = REAL (ETA) 
         ETA2 = AIMAG (ETA)
C   . . .DELTAZ2, EQN.(40), P. 15
         DELR2 = 0.0 
         DP = AA / 2.0 
         QU = 240.0 * PI * * 2 / EX (2)
         CW = WAVE * 1000.0 / (EX (1) * EX (2))
         DO 180 J = 1, 48
         P = DP * (XI (J) + 1.0) 
         RQ = PI2 * SQRT (P * * 2 + EL1 * * 2) 
         PLOG = ALOG (P * CW)
         QQ = QU * P * PLOG
         EQ = ETA2 + QQ
         TA = ATAN2 (EQ, ETA1) 
 180     DELR2 = DELR2 + (COS(ALPHA-TA-2.*RQ) + CFAC2**2 *
     1   COS(ALPHA-TA-4.*PI*P)-2.*CFAC2*COS(ALPHA-TA-PI2*P-RQ))
     2   / SQRT(ETA1**2 + EQ**2) * PLOG * DP * HH (J) 
         DELR2 = -120.0 * PI * CABS (ETA) / EX (2) * DELR2
C   . . .RIN, EQN.(38), P. 14
         RIN = RZERO + DELR1 + DELR2 
      end if
C. . .HRATIO=A3+(J)*B3, EQN.(36), P. 13 
      HRATIO = CMPLX (0.0, 0.0) 
      DO 190 J = 1, 48
      XX = CAYA / 2.0 * (XI (J) + 1.0)
      TD = SQRT (XX * * 2 + FAC2 * * 2) 
      TS = ONEJ (XX * T)
 190  HRATIO = HRATIO + HH (J) * TS * CMPLX (COS (TD) - COS (XX) * CFAC2
     1, - SIN (TD) + SIN (XX) * CFAC2)
      HRATIO = 1.0 - HRATIO * CAYA * ETA * T / (120.0 * PI2 * A)
      RAIN = 0.0
      IF(ABS(REAL(HRATIO)).GT.2. .OR. ABS(AIMAG(HRATIO)).GT.1.)go to 195
C. . .GAIN FROM EQN.(41), P. 15 
      BP = ATAN2 (AS, A)
      CAYVH = 1.+CV**2 + 2.*CV*COS(PSIV-2.*BP) 
      TB = A / (T * COS (BP)) 
      RAIN = 30./RIN*TB**2*CAYVH*HRATIO*CONJG(HRATIO)
195   continue
      IF (EL1 .GE. 0.35) GO TO 615
      EFF=-((((6416.702*EL1-6091.33)*EL1+2179.89)*EL1-364.817)*EL1+
     1 25.646) 
      GO TO 615 
C.....HORIZONTAL HALFWAVE DIPOLE ANTENNA, KOP=3.........................
C. . .NOTE--THIS MODEL IS NOT VALID FOR ANTENNAS LESS THAN .15
C. . .WAVELENGHTHS FROM THE GROUND. 
205   SFAC = SIN (FAC)
      CFAC = COS (FAC)
      W1 = COS (PSIH - HQWAVE)
      W2 = SIN (PSIH - HQWAVE)
      W3 = COS (PSIV - HQWAVE)
      W4 = SIN (PSIV - HQWAVE)
      CPHI = T * SB 
      SPHI2 = 1. - CPHI ** 2
      RAIN = 0.0
      IF (SPHI2 .EQ. 0.0) GO TO 615 
      GI = (COS (FAC * CPHI) - CFAC) / SPHI2
      AA = SQRT (1. + CV * CV - 2. * CV * W3) * GI
      BB = SQRT (1. + CH * CH + 2. * CH * W1) * GI
      IF (kas .le. 1) then
C   . . .CALCULATE RIN, EQNS. (27),(26),(25), PP. 9-10 
         D1D (1) = 2.0 * HWAVE 
         D1D (2) = RATIO * FAC 
         SFAC2 = SIN (FAC2)
         CFAC2 = COS (FAC2)
         DO 210 J = 1, 2 
         TT = SQRT (D1D (J) * * 2 + FAC2 * * 2)
         UZ = TT - FAC2
         VZ = TT + FAC2
         TT = SQRT (D1D (J) * * 2 + FAC * * 2) 
         U1 = TT - FAC 
         V1 = TT + FAC 
         Z(J,1)=(CSZ1(UZ)-2.*CSZ1(U1))*CMPLX(CFAC2,-SFAC2)+(
     1   CSZ1(VZ)-2.*CSZ1(V1))*CMPLX(CFAC2,SFAC2)-2.*(CSZ1(U1)+CSZ1(V1))
     2   + 2.*CSZ1(D1D(J))*(CFAC2+2.)
 210     Z (J,1) = Z (J,1) * 60.0 / (1.0 - CFAC2)
         SQRD = CSQRT (DIF)
         CXC = REAL (Z (1,1) * ((1.0 - SQRD) / (1.0 + SQRD)))
         RIN = REAL (Z (2,1)) + CXC
      end if
C. . .GAIN= EQN.(28), P. 10 
      RAIN = (120. * (AA * AA * SB * SB * Q * Q + BB * BB * CB * CB)) / 
     1(RIN * SFAC * SFAC) 
      GO TO 615 
C.....HORIZONTAL YAGI ANTENNA, KOP=4....................................
 220  RAIN = 0.0
      IF (EL1 .LT. 0.25 .OR. EL1 .GT. 0.75) GO TO 615 
      W1 = CH * COS (PSIH - HQWAVE) 
      W2 = CH * SIN (PSIH - HQWAVE) 
      W3 = CV * COS (PSIV - HQWAVE) 
      W4 = CV * SIN (PSIV - HQWAVE) 
      N = EX (2)
      NM1 = N - 1 
      NM2 = N - 2 
      D (NM1) = EX (4) / WAVE 
      IF (EX (4) .LT. 0.0) D (NM1)  = ABS (EX (4))
      D (1) = EX (3) / WAVE 
      IF (EX (3) .LT. 0.0) D (1)  = ABS (EX (3))
      ELL (N) = PI * PHI / WAVE 
      IF (PHI .LT. 0.0) ELL (N)  = PI * ABS (PHI) 
      ELL (NM1) = FAC 
      ELL (1) = PI * EX (1) / WAVE
      IF (EX (1) .LT. 0.0) ELL (1)  = PI * ABS (EX (1)) 
      XK (1) = 0.0
      IF (N .EQ. 3) GO TO 230 
      IF (NM2 .LT. 2) GO TO 670 
      DO 225 J = 2, NM2 
      ELL (J) = ELL (1) 
 225  D (J) = D (1) 
 670  CONTINUE
 230  IF (N .LT. 2) GO TO 675 
      DO 235 J = 2, N 
 235  XK (J) = XK (J - 1) + D (J - 1) 
 675  CONTINUE
      IF (kas .GT. 1) GO TO 265 
C     CALL TO CIN ELIMINATED - CODE INCORPORATED BELOW
      DO 245 I = 1, N 
      NO = I
      NMX = I 
      DO 240 K = 1, NO
      D1D (K) = PI2 * ABS (XK (I) - XK (K)) 
      IF (I .EQ. K) D1D (K)  = ELL (I)  / 125.1579
 240  CONTINUE
      CALL SIM
      DO 245 J = 1, I 
      YR (NMX, J) = REAL (ZS (J)) 
      YR (J, NMX) = YR (NMX, J) 
      YI (NMX, J) = AIMAG (ZS (J))
      YI (J, NMX) = YI (NMX, J) 
 245  CONTINUE
      CALL CMPINV (YR, YI, TX, TY, N) 
      DO 250 I = 1, N 
      CIX (I) = TX (I, NM1) 
 250  CIY (I) = TY (I, NM1) 
      V = 1. / CMPLX (CIX (NM1), CIY (NM1)) 
      SUM1 = REAL (V) 
      TT = 4.0 * X * * 2
      DO 255 J = 1, NM1 
      TX1 = (NM1 - J) * * 2 
      D1D (J) = PI2 * SQRT (TT + TX1 * D (J) * * 2) 
 255  CONTINUE
      D1D (N) = PI2 * SQRT (TT + D (NM1) * * 2) 
      NMX = NM1 
      NO = N
      CALL SIM
      V = CMPLX (0.0, 0.0)
      DO 260 J = 1, N 
 260  V = V + CMPLX (CIX (J), CIY (J)) * ZS (J) 
      SQRD = CSQRT (DIF)
      SUM2 = REAL (V * (1. - SQRD) / (1. + SQRD) / CMPLX (CIX (NM1), CIY
     1 (NM1)))
      RIN = SUM1 + SUM2 
 265  CPSI = T * SB 
      SPSI2 = 1.0 - CPSI * * 2
      RAIN = 0.0
      IF (SPSI2 .EQ. 0.0) GO TO 615 
      ETR = 0.0 
      ETI = 0.0 
      PR = - CB * PI2 * T 
      IF (N .LT. 1) GO TO 710 
      DO 270 J = 1, N 
      CTK = COS (PR * XK (J)) 
      STK = SIN (PR * XK (J)) 
      SIS = 1.0 / SIN (ELL (J)) 
      TT = SIS * * 2 * (COS (ELL (J) * CPSI) - COS (ELL (J))) 
      ETR = ETR + TT * (CIX (J) * CTK - CIY (J) * STK)
      ETI = ETI + TT * (CIX (J) * STK + CIY (J) * CTK)
 270  CONTINUE
 710  CONTINUE
      EPMAG = CB * * 2 * ((ETR * (1.0 + W1) - ETI * W2) * * 2 + (ETI * (
     11.0 + W1) + ETR * W2) * * 2)
      ETMAG = SB * * 2 * Q * * 2 * ((ETR * (1.0 - W3) + ETI * W4) * * 2 
     1+ (ETI * (1.0 - W3) - ETR * W4) * * 2)
      RAIN = 120.0 * RIN * (ETMAG + EPMAG) / (SPSI2 * * 2)
      GO TO 615 
C.....VERTICAL DIPOLE ANTENNA, KOP=5....................................
 275  TIP = 0.5 * EL1 
ccc      IF (TIP .GT. X) GO TO 635 
      IF (TIP .GT. X) then      !  antenna not physically valid
         write(*,276) h,el,wave,freq,el1,tip,x
276      format('TIP>H/WAVE  H,EL,WAVE,FREQ,EL1,TIP,X=',7f10.4)
         rain=floor
         return
      end if
      CFAC = COS (FAC)
      SPHI2 = 1.0 - Q * * 2 
      RAIN = 0.0
      IF (SPHI2 .EQ. 0.0) GO TO 615 
      GI = (COS (FAC * Q) - CFAC) / SPHI2 
      W3 = COS (PSIV - HQWAVE)
      ETETA1 = - T * GI * (1.0 + CV * W3) 
      W4 = SIN (PSIV - HQWAVE)
      ETETA2 = - T * GI * CV * W4 
      HAC2 = HWAVE + HWAVE
      HAC4 = HAC2 + HAC2
      AZH = CSZ1 (HAC2) 
      W33 = REAL (AZH)
      W4 = - AIMAG (AZH)
      AZH = CSZ1 (HAC4) 
      W5 = REAL (AZH) 
      W6 = - AIMAG (AZH)
      RIN = 60. * ((1. + COS (HAC2)) *(GAMA + ALOG (HAC2) - W33) - 0.5 *
     1COS (HAC2) * (GAMA + ALOG (HAC4) - W5) + SIN (HAC2) * (.5 * W6 - W
     24)) 
      IF (EL1 - 0.4) 278, 279, 279
278   RIN = 800. * EL1 * EL1 * RINFR / 128. 
279   FMULT = 4. - XINTR * (SIGMA - 0.0001) 
      RIN = 128. * FMULT * RIN / RINFR
      RAIN = 120. * (ETETA1 ** 2 + ETETA2 ** 2) / RIN 
      GO TO 615 
C.....CURTAIN ANTENNA ARRAY WITH PERFECTLY CONDUCTING SCREEN, KOP=6.....
285   CONTINUE
      IF (BETA .LT. 90. .OR. BETA .GT. 270.) GO TO 286
      RAIN = 0.05 
      GO TO 615 
286   THETAZ = 90.0 
      DELTAP = 0.0
      EIL = 0.5 * EL1 
      NB = ABS (PHI)
      NBB = ABS (100.0 * (ABS (PHI) - NB)) + 0.5
C. . .THE BAYS ARE FED IN ANTI-PHASE(MOD NBB) IF PHI NON-INTEGER . . . .
      CBAY = + 1.0
      IF (NBB .NE. 0) CBAY = - 1.0
      IF (NBB .EQ. 0) NBB = 1 
      NE = ABS (EX (1)) 
      NEE = ABS (100.0 * (ABS (EX (1)) - NE)) + 0.5 
C. . .THE ELTS ARE FED IN ANTI-PHASE(MOD NEE) IF EX(1) IS NON-INTEGER. .
      CELE = + 1.0
      IF (NEE .NE. 0) CELE = - 1.0
      IF (NEE .EQ. 0) NEE = 1 
      DY = EX (2) / WAVE
      IF (EX (2) .LT. 0.0) DY = ABS (EX (2))
      DZ = EX (3) / WAVE
      IF (EX (3) .LT. 0.0) DZ = ABS (EX (3))
      DX = EX (4) / WAVE
      IF (EX (4) .LT. 0.0) DX = ABS (EX (4))
      IF (kas .GT. 1) GO TO 355 
C. . .CALCULATE ALL SELF- AND MUTUAL-IMPEDANCES 
      DIJ = 0.01767766952 * EIL 
      HIJ = EIL 
      KODE = 1
      CALL ZMUT (RZZ) 
C. . .SEE MA(1974),TABLE 4.1, P. 254, AND EQN.(4.114), P. 273 
      IF (REAL (RZZ) .LT. 3631.53) GO TO 290
      RZZ = CMPLX (3631.53, - 2356.47)
      KODE = - 1
      RIN = FLOAT (NB * NE) * 3631.53 
      GO TO 355 
 290  DIJ = 2.0 * DX
      CALL ZMUT (RPZZ)
      DO 295 I = 1, NE
      CI = I
      TT = (CI - 1.0) * DZ + X
      DIJ = 2.0 * TT
      CALL ZMUT (RDZZ (I))
      DIJ = 2.0 * SQRT (DX * * 2 + TT * * 2)
 295  CALL ZMUT (RTZZ (I))
      TS = (2.0 * DX) * * 2 
      IJEND = NE - 1
      DO 300 IJ = 1, IJEND
      CIJ = IJ
      DIJ = CIJ * DZ
      CALL ZMUT (RZB (IJ))
      DIJ = SQRT (TS + CIJ * * 2 * DZ * * 2)
 300  CALL ZMUT (RPZB (IJ)) 
      IPJEND = 2 * NE 
      DO 305 IPJ = 2, IPJEND
      CIPJ = IPJ
      TT = (CIPJ - 2.0) * DZ + 2.0 * X
      DIJ = TT
      CALL ZMUT (RDZB (IPJ))
      DIJ = SQRT (TS + TT * * 2)
 305  CALL ZMUT (RTZB (IPJ))
      MNEND = NB - 1
      DO 325 MN = 1, MNEND
      CMN = MN
      HIJ = CMN * DY - EIL
      CALL COLL (RZE (MN))
      DIJ = 2. * DX 
      CALL ECH (RPZE (MN))
      DO 310 I = 1, NE
      CI = I
      TT = 2.0 * ((CI - 1.0) * DZ + X)
      DIJ = TT
      CALL ECH (RDZE (MN, I)) 
      DIJ = SQRT (TS + TT * * 2)
 310  CALL ECH (RTZE (MN, I)) 
      DO 315 IJ = 1, IJEND
      CIJ = IJ
      DIJ = CIJ * DZ
      CALL ECH (R (MN, IJ)) 
      DIJ = SQRT (TS + CIJ * * 2 * DZ * * 2)
 315  CALL ECH (RP (MN, IJ))
      DO 320 IPJ = 2, IPJEND
      CIPJ = IPJ
      TT = (CIPJ - 2.0) * DZ + 2.0 * X
      DIJ = TT
      CALL ECH (RDZ (MN, IPJ))
      DIJ = SQRT (TS + TT * * 2)
 320  CALL ECH (RT (MN, IPJ)) 
 325  CONTINUE
C. . .SUM ALL SELF-AND MUTUAL-IMPEDANCES FOR ALL REAL-REAL AND REAL-. . 
C. . .IMAGE ELEMENT PAIRS . . . . . . . . . . . . . . . . . . . . ... . 
      ZSUM1 = CMPLX (0.0, 0.0)
      ZSUM2 = CMPLX (0.0, 0.0)
      ZSUM3 = CMPLX (0.0, 0.0)
      ZSUM4 = CMPLX (0.0, 0.0)
      DO 350 M = 1, NB
      DO 350 I = 1, NE
      DO 350 N = 1, NB
      DO 350 J = 1, NE
      IF (M .NE. N .OR. I .NE. J) GO TO 330 
      ZTERM1 = RZZ
      ZTERM2 = RPZZ 
      ZTERM3 = RDZZ (I) 
      ZTERM4 = RTZZ (I) 
      GO TO 345 
 330  IF (M .NE. N) GO TO 335 
      IJ = IABS (I - J) 
      ZTERM1 = RZB (IJ) 
      ZTERM2 = RPZB (IJ)
      ZTERM3 = RDZB (I + J) 
      ZTERM4 = RTZB (I + J) 
      GO TO 345 
 335  IF (I .NE. J) GO TO 340 
      MN = IABS (M - N) 
      ZTERM1 = RZE (MN) 
      ZTERM2 = RPZE (MN)
      ZTERM3 = RDZE (MN, I) 
      ZTERM4 = RTZE (MN, I) 
      GO TO 345 
 340  MN = IABS (M - N) 
      IJ = IABS (I - J) 
      ZTERM1 = R (MN, IJ) 
      ZTERM2 = RP (MN, IJ)
      ZTERM3 = RDZ (MN, I + J)
      ZTERM4 = RT (MN, I + J) 
 345  ZSUM1 = ZSUM1 + ZTERM1
      ZSUM2 = ZSUM2 + ZTERM2
      ZSUM3 = ZSUM3 + ZTERM3
      ZSUM4 = ZSUM4 + ZTERM4
 350  CONTINUE
C. . .CALCULATE THE INPUT IMPEDANCE RIN. . . . . . . . . . . . . . . . .
      SQRD = CSQRT (DIF)
      RHCP = (1.0 - SQRD) / (1.0 + SQRD)
      RIN = REAL (ZSUM1 - ZSUM2 + RHCP * (ZSUM3 - ZSUM4)) 
C. . .CALCULATE THE ELEMENT ARRAYING FACTOR (SIN(THETA)=SIN(90-DELTA)=
C. . .COS(DELTA)). . . . . . . . . . . . . .. . . . . . . . . . . . . . 
 355  STHETA = COS (DELTA)
      CPSI = STHETA * SB
      AZV = CMPLX (0.0, 0.0)
      AZH = CMPLX (0.0, 0.0)
      CTHETAZ = COS (THETAZ * D2R)
      SBZ = SIN (DELTAP * D2R)
      FACTOR = CELE 
      DO 360 M = 1, NE
      EM = M
      ZM = X + (EM - 1.0) * DZ
C. . .IF ANTI-PHASE, GROUP IN NEE-TUPLES,E.G.,++,--,++,ETC FOR NEE=2 . .
      IF (MOD (M, NEE) .EQ. 1 .OR. NEE .EQ. 1) FACTOR = FACTOR * CELE 
      TT = PI2 * ZM * (Q - CTHETAZ) 
      ZT = CMPLX (COS (TT), SIN (TT)) 
      TT = 2.0 * PI2 * ZM * Q 
      ZTR = CMPLX (COS (TT), - SIN (TT))
      AZV = AZV + ZT * (1. - QPER * ZTR) * FACTOR 
 360  AZH = AZH + ZT * (1. + QPAR * ZTR) * FACTOR 
C. . .CALCULATE THE BAY ARRAYING FACTOR . . . . . . . . . . . . . . . . 
      AF = CMPLX (1.0, 0.0) 
      IF (NB .LE. 1) GO TO 370
      AF = CMPLX (0.0, 0.0) 
      FACTOR = CBAY 
      DO 365 N = 1, NB
      EN = N
C. . .IF ANTI-PHASE, GROUP IN NBB-TUPLES,E.G.,++,--,++,ETC FOR NBB=2 . .
      IF (MOD (N, NBB) .EQ. 1 .OR. NBB .EQ. 1) FACTOR = FACTOR * CBAY 
      TT = PI2 * DY * (EN - 1.0)
      TS = CPSI - STHETA * SBZ
      ZT = CMPLX (COS (TT * TS), SIN (TT * TS)) 
 365  AF = AF + ZT * FACTOR 
C. . .CALCULATE REAL-IMAGE (SCREEN) ARRARYING FACTOR . . . . . . . . .
 370  TT = SIN (PI2 * DX * STHETA * CB) 
C. . .CALCULATE THE GAIN. . . . . . . . . . . . . . . . . . . . . . . . 
      ZT = (SB * * 2 * Q * * 2 * AZV * CONJG (AZV) + CB * * 2 * AZH * CO
     1NJG (AZH)) * TT * * 2 
      SPSI2 = 1.0 - CPSI * * 2
      RAIN = 0.0
      IF (SPSI2 .EQ. 0.0) GO TO 615 
      TT = (COS (PI2 * EIL * CPSI) - COS (PI2 * EIL)) / SPSI2 
      TRAIN = ZT * AF * CONJG (AF) * TT * * 2 / RIN 
      IF (KODE .LT. 0) GO TO 375
      RAIN = 480.0 * (1.0 / SIN (PI2 * EIL)) * * 2 * TRAIN
      GO TO 615 
C. . .SEE MA(1974) EQN.(4.114) P. 273 AND MA (PRIVATE COMM.) FOR. . . . 
C. . .CTU AND CTD VALUES FOR FULL WAVELENGTH CASE . . . . . . . . . . . 
 375  CTU = CMPLX ( - 0.0419290, + 0.0461374) 
      CTD = CMPLX ( - 0.0184019, + 0.0612938) 
      CURNT = SIN (PI2 * EIL) + CTU * (1.0 - COS (PI2 * EIL)) + CTD * (1
     1.0 - COS (PI * EIL))
      RAIN = 480.0 * TRAIN / (CURNT * CONJG (CURNT))
      GO TO 615 
C.....TERMINATED SLOPING VEE ANTENNA, KOP=7.............................
 380  HT = EX (1) / WAVE
      IF (EX (1) .LT. 0.0) HT = ABS (EX (1))
      DELTAP = ASIN ((HT - X) / EL1)
      CDELP = COS (DELTAP)
 385  RHI = ASIN (SR / CDELP) 
      CR = COS (RHI)
      SR = SIN (RHI)
      CD = CB * CR + SB * SR
      CS = CB * CR - SB * SR
      SS = SB * CR + CB * SR
      SD = SB * CR - CB * SR
      SCP = T * CDELP 
      CCP = Q * CDELP 
      SDELP = SIN (DELTAP)
      SSP = T * SDELP 
      CSP = Q * SDELP 
      U1 = 1.0 - (CSP + SCP * CD) 
      U2 = 1.0 - (CSP + SCP * CS) 
      U3 = 1.0 - ( - CSP + SCP * CD)
      U4 = 1.0 - ( - CSP + SCP * CS)
      CP5 = SSP + CCP * CD
      CP6 = SSP + CCP * CS
      CP7 = - SSP + CCP * CD
      CP8 = - SSP + CCP * CS
      W1 = COS (PSIH - HQWAVE)
      W2 = SIN (PSIH - HQWAVE)
      W3 = COS (PSIV - HQWAVE)
      W4 = SIN (PSIV - HQWAVE)
      FU1 = FAC2 * U1 
      V1 = SIN (FU1)
      Z1 = COS (FU1)
      FU2 = FAC2 * U2 
      V2 = SIN (FU2)
      Z2 = COS (FU2)
      FU3 = FAC2 * U3 
      V3 = SIN (FU3)
      Z3 = COS (FU3)
      FU4 = FAC2 * U4 
      V4 = SIN (FU4)
      Z4 = COS (FU4)
      IF (KOP .EQ. 9) GO TO 440 
      Z1 = Z1 - 1.0 
      Z2 = Z2 - 1.0 
      Z3 = Z3 - 1.0 
      Z4 = Z4 - 1.0 
      Y1 = U1 * SS
      Y3 = U3 * SS
      Y2 = U2 * SD
      Y4 = U4 * SD
      U12 = U1 * U2 
      U34 = U3 * U4 
      IF (U12 .EQ. 0.0) GO TO 390 
      A1 = (U2 * CP7 * Z1 - U1 * Z2 * CP8) / U12
      B1 = (U1 * V2 * CP8 - U2 * V1 * CP7) / U12
      C1 = (Y1 * Z2 - Y2 * Z1) / U12
      D1 = (Y2 * V1 - Y1 * V2) / U12
      GO TO 395 
 390  A1 = 0.0
      B1 = 0.0
      C1 = 0.0
      D1 = 0.0
      IF (U34 .EQ. 0.0) GO TO 615 
 395  IF (U34 .EQ. 0.0) GO TO 400 
      A2 = U3 * Z4 * CP6 - U4 * Z3 * CP5
      B2 = U3 * V4 * CP6 - U4 * V3 * CP5
      A1 = A1 + CV * (W3 * A2 + W4 * B2) / U34
      B1 = B1 + CV * ( - B2 * W3 + W4 * A2) / U34 
      AA2 = Y3 * Z4 - Y4 * Z3 
      BB2 = Y4 * V3 - Y3 * V4 
      C1 = C1 + CH * (W1 * AA2 - W2 * BB2) / U34
      D1 = D1 + CH * (W1 * BB2 + W2 * AA2) / U34
 400  RAIN = 0.05 * (A1 * * 2 + B1 * * 2 + CDELP * * 2 * (C1 * * 2 + D1 
     1* * 2)) 
      EFF = - 1.7 
      GO TO 615 
C.....INVERTED L ANTENNA, KOP=8.........................................
405   SPH = SB
      CPH = CB
      SB = Q
      CB = T
      XL = EL 
      XH = H
      EPS = ER
      SIG = SIGMA 
      F = FREQ
      WK = PI2 / WAVE 
      PSIG = -18000. * SIG / F
      WK2 = WK * CSQRT(CMPLX (EPS, PSIG)) 
      WKOK2 = WK / WK2
      WK2OK = WK2 / WK
      WL = WK * XL
      IF (XL .LT. 0.0) WL = PI2 * ABS (XL)
      WH = WK * XH
      IF (XH .LT. 0.0) WH = PI2 * ABS (XH)
      WLH = WL + WH 
      SWL = SIN (WL)
      CWL = COS (WL)
      SWLH = SIN (WLH)
      SWLH2 = SWLH * SWLH 
      CWLH = COS (WLH)
      RC = CSQRT (1. - (WKOK2 * CB) ** 2) 
      RV = (SB - WKOK2 * RC) / (SB + WKOK2 * RC)
      RH = (SB - WK2OK * RC) / (SB + WK2OK * RC)
      RVAB = CABS (RV)
      RHAB = CABS (RH)
      PSIV = CANG (RV)
      PSIH = CANG (RH)
      CPSIPH = CB * SPH 
      PSIPH = ACOS (CPSIPH) 
      SPSIPH = SIN (PSIPH)
      SPSIPH2 = SPSIPH ** 2 
      WB = WH * SB
      SWB = SIN (WB)
      CWB = COS (WB)
      A4 = CWL * CWB - SB * SWL * SWB - CWLH
      B4 = SB * SWL * CWB + CWL * SWB - SB * SWLH 
      AB4 = SQRT (A4 * A4 + B4 * B4)
      IF (AB4 .NE. 0.0) GO TO 14
      BP = 0.0
      GO TO 15
14    BP = ATAN2 (B4, A4) 
15    WC = WL * CPSIPH
      SWC = SIN (WC)
      CWC = COS (WC)
      A5 = CWC - CWL
      B5 = SWC - CPSIPH * SWL 
      AB5 = SQRT (A5 * A5 + B5 * B5)
      IF (AB5 .NE. 0.0) GO TO 16
      BPP = 0.0 
      GO TO 17
16    BPP = ATAN2 (B5, A5)
17    PARV = BPP + PSIV - 2. * WH * SB
      PARH = BPP + PSIH - 2. * WH * SB
      IF (SPSIPH2 .NE. 0.0) GO TO 18
      F2 = 0.0
      F11 = 0.0
      G2 = 0.0
      G11 = 0.0
      GO TO 19
18    DAB5 = AB5 * SPH * SB / SPSIPH2 
      F11 = DAB5 * (COS (BPP) - RVAB * COS (PARV))
      G11 = DAB5 * (SIN (BPP) - RVAB * SIN (PARV))
      HAB5 = AB5 * CPH / SPSIPH2
      F2 = HAB5 * (COS (BPP) + RHAB * COS (PARH)) 
      G2 = HAB5 * (SIN (BPP) + RHAB * SIN (PARH)) 
19    IF (CB .NE. 0.0) GO TO 20 
      F12 = 0.0 
      G12 = 0.0 
      GO TO 21
20    DAB4 = AB4 / CB 
      F12 = - DAB4 * (COS (BP) + RVAB * COS (PSIV - BP))
      G12 = - DAB4 * (SIN (BP) + RVAB * SIN (PSIV - BP))
21    F1 = F11 + F12
      G1 = G11 + G12
      G = 30. * (F1 ** 2 + G1 ** 2 + F2 ** 2 + G2 ** 2) 
      W2H = 2. * WH 
      W4H = 2. * W2H
      CI2 = REAL (CSZ1 (W2H)) 
      CI4 = REAL (CSZ1 (W4H)) 
      CIN2 = GAMA + ALOG (W2H) - CI2
      CIN4 = GAMA + ALOG (W4H) - CI4
      SI2 = - AIMAG (CSZ1 (W2H))
      SI4 = - AIMAG (CSZ1 (W4H))
      CW2H = COS (W2H)
      SW2H = SIN (W2H)
      VRT = 30. * ((1 + CW2H) * CIN2 - 0.5 * CW2H * CIN4 - SW2H * (SI2 -
     1 0.5 * SI4))
      RIN = VRT 
      IF (X .GE. 0.2) GO TO 430 
      RIN = 400. * X * X * RINTW / 16.
430   FMULT = 4. - 3. * (SIGMA - .0001) /(5. - .0001) 
      RIN = 16. * FMULT * RIN / RINTW 
C. . .CALCULATE GAIN FROM ABOVE AND EQN.(4), P. 4 
      RAIN = G / RIN
      IF (X .GT. 0.20) GO TO 615
      EFF = 20.0 * ALOG10 (X * (6.335 + X * (67.95 - X * (693.0 - X * 16
     100.0))))
      GO TO 615 
C.....TERMINATED SLOPING RHOMBIC ANTENNA, KOP=9.........................
 435  HT = EX (1) / WAVE
      IF (EX (1) .LT. 0.0) HT = ABS (EX (1))
      DELTAP = ASIN ((HT - X) / (2.0 * EL1))
      CDELP = COS (DELTAP)
      GO TO 385 
 440  A1 = 1.0 + Z1 * Z2 - V1 * V2 - Z1 - Z2
      B1 = - V1 * Z2 - Z1 * V2 + V1 + V2
      A2 = 1.0 + Z3 * Z4 - V3 * V4 - Z3 - Z4
      B2 = - V3 * Z4 - Z3 * V4 + V3 + V4
      CM = CP8 / U2 - CP7 / U1
      CN = (CP5 / U3 - CP6 / U4) * CV 
      CMP = SD / U1 - SS / U2 
      CNP = (SD / U3 - SS / U4) * CH
      AM = CM * A1 + CN * (A2 * W3 - B2 * W4) 
      AN = CM * B1 + CN * (A2 * W4 + B2 * W3) 
      PAM = CMP * A1 + CNP * (A2 * W1 - B2 * W2)
      PAN = CMP * B1 + CNP * (A2 * W2 + B2 * W1)
      RAIN = 0.05 * (AM * * 2 + AN * * 2 + CDELP * * 2 * (PAM * * 2 + PA
     1N * * 2)) 
      EFF = - 1.7 
      GO TO 615 
C.....ANTENNA ALREADY IN THE ARRAY, KOP=10..............................
 445  CONTINUE
      write (*,446)
 446  FORMAT (' Antenna type 10 not used for HFMUFES GAIN.')
      GO TO 640 
C.....SLOPING LONG WIRE, KOP = 11.......................................
 450  CFAC2 = COS (FAC2)
      SFAC2 = SIN (FAC2)
      W1 = COS (PSIH - HQWAVE)
      W2 = SIN (PSIH - HQWAVE)
      W3 = COS (PSIV - HQWAVE)
      W4 = SIN (PSIV - HQWAVE)
      CRB = CR * CB * Q 
      SRT = SR * T
      CBS = CR * SB 
      SRQ = Q * SR
      CPHI = SRQ + T * CR * CB
      SPHI2 = 1.0 - CPHI * * 2
      CPHIP = - SRQ + T * CR * CB 
      SPHIP2 = 1.0 - CPHIP * * 2
      RAIN = 0.0
      IF (SPHI2 .EQ. 0.0 .AND. SPHIP2 .EQ. 0.0) GO TO 615 
      IF (SPHI2 .EQ. 0.0) GO TO 455 
      CIG = (COS (FAC2 * CPHI) - CFAC2) / SPHI2 
      EPHI1 = - CBS * CIG 
      ETHET1 = (CRB - SRT) * CIG
      SIG = (SIN (FAC2 * CPHI) - CPHI * SFAC2) / SPHI2
      ETHET2 = (CRB - SRT) * SIG
      EPHI2 = - CBS * SIG 
      GO TO 460 
 455  ETHET1 = 0.0
      ETHET2 = 0.0
      EPHI1 = 0.0 
      EPHI2 = 0.0 
 460  IF (SPHIP2 .EQ. 0.0) GO TO 465
      CIGP = (COS (FAC2 * CPHIP) - CFAC2) / SPHIP2
      SIGP = (SIN (FAC2 * CPHIP) - CPHIP * SFAC2) / SPHIP2
      ETHET1 = ETHET1 - (CRB + SRT) * CV * (W3 * CIGP - W4 * SIGP)
      ETHET2 = ETHET2 - (CRB + SRT) * CV * (W4 * CIGP + W3 * SIGP)
      EPHI1 = EPHI1 - CBS * CH * (W1 * CIGP - W2 * SIGP)
      EPHI2 = EPHI2 - CBS * CH * (W2 * CIGP + W1 * SIGP)
 465  continue
      IF (kas .le. 1) then
         AZH = CSZ1 (2.0 * FAC4) 
         W5 = REAL (AZH) 
         W6 = AIMAG (AZH)
         AZH = CSZ1 (FAC4) 
         W33 = REAL (AZH)
         W4 = AIMAG (AZH)
         FLOG = ALOG (FAC2) + GAMA 
         RIN=30.*(0.5*(FLOG-W5)+0.6931471806 + CFAC2 * (CFAC2 * 
     1   (FLOG - 2.0 * W33 + W5) - SFAC2 * (W6 - 2.0 * W4))) 
      end if
      RAIN=30.*(ETHET1**2 + ETHET2**2 + EPHI1**2 + EPHI2**2)/RIN
      GO TO 615 
C.....CONSTANT GAIN KOP=12..............................................
 475  RAIN = H
      EFF = 0.0 
      GO TO 630 
C.....GENERAL HORIZONTAL LOG-PERIODIC ANTENNA  KOP=13...................
 480  CONTINUE
      IF (kas .GT. 1) GO TO 550 
C     CALL TO CIN ELIMINATED - CODE INCORPORATED BELOW
      YZ = 1. / EX (1)
      N = EX (4)
      ELL (N) = FAC 
      XK(N)  =  ELL(N) *(1.0 / TAN (EX(2)*D2R)   )
      NMX = N - 1 
      DO 485 II = 1, NMX
      NII = N - II
      NIP = NII + 1 
      ELL (NII) = ELL (NIP) * EX (3)
      XK (NII) = XK (NIP) * EX (3)
 485  CONTINUE
C     DO 490 J = 1, 400 
      DO 490 J = 1, 20
      DO 490 JJ = 1, 20 
      TX (J,JJ) = 0.0 
      TY (J,JJ) = 0.0 
      YR (J,JJ) = 0.0 
 490  YI (J,JJ) = 0.0 
      DO 500 I = 1, NMX 
      MID = I + 1 
      IF (I .EQ. 1) GO TO 495 
      YI(I,I)=-YZ*(1./TAN(XK(MID)-XK(I))+1./TAN(XK(I)-XK(I-1)))
 495  YI (I, MID) = - YZ / SIN (XK (MID) - XK (I))
      YI (MID, I) = YI (I, MID) 
 500  CONTINUE
      YI(1,1) = -YZ *(1.0/TAN(XK(2) - XK(1))  ) 
      COT = 1.0 / (YZ *(1.0/TAN  (ELL(N)/2.0))  ) 
      ZTS = 0.0 
      TA = ZTS * * 2 + COT * * 2
      YRN = ZTS / TA
      YI(N,N)  =  - (COT / TA + YZ *(1.0/TAN(XK(N) - XK(NMX)))   )
      CONST = SQRTWO / 177.0
      DO 520 I = 1, N 
      JEND = I
      NO = JEND 
      NMX = JEND
      D1D (JEND) = ELL (JEND) * CONST 
      JEN = JEND - 1
      DO 505 JL = 1, JEN
 505  D1D (JL) = ABS (XK (JEND) - XK (JL))
      CALL SIM
      DO 515 JK = 1, JEND 
      Z(JK,JEND)=ZS(JK)
      IF(JK.NE.JEND) Z(JEND,JK)=ZS(JK)
 515  CONTINUE
 520  CONTINUE
      DO 525 J = 1, N 
      DO 525 I = 1, N 
      DO 525 K = 1, N 
      TX (I, J) = TX (I, J) - YI (K, I) * AIMAG (Z (K, J))
      TY (I, J) = TY (I, J) + YI (K, I) * REAL (Z (K, J)) 
      IF (I .NE. N .OR. K .NE. N) GO TO 525 
      TX (N, J) = TX (N, J) + YRN * REAL (Z (N, J)) 
      TY (N, J) = TY (N, J) + YRN * AIMAG (Z (N, J))
 525  CONTINUE
      DO 530 I = 1, N 
 530  TX (I, I) = TX (I, I) + 1.0 
      CALL CMPINV (TX, TY, YR, YI, N) 
      SUM0 = 0.0
      DO 535 I = 1, N 
      CIX (I) = YR (I,1)
      CIY (I) = YI (I,1)
 535  SUM0=SUM0+YR(I,1)*REAL(Z(I,1))-YI(I,1)*AIMAG(Z(I,1))
      SUMD = 0.0
      D1D (1) = 2.0 * HWAVE 
      TH = D1D (1) * * 2
      TXS = 4.0 * HWAVE * CR
      DO 540 NJ = 2, N
      SUMD = SUMD + XK (NJ) - XK (NJ - 1) 
 540  D1D (NJ) = SQRT (TH + SUMD * * 2 + TXS * SUMD)
      NMX = 1 
      NO = N
      CALL SIM
      V = CMPLX (0.0, 0.0)
      DO 545 J = 1, N 
 545  V = V + CMPLX (YR (I,1), YI (I,1)) * ZS (I) 
      SQRD = CSQRT (DIF)
      SUM2 = REAL (V * (1.0 - SQRD) / (1.0 + SQRD)) 
      RIN = SUM0 + SUM2 
 550  CPSI = T * SB 
      SPSI2 = 1.0 - CPSI * * 2
      RAIN = 0.0
      IF (SPSI2 .EQ. 0.0) GO TO 615 
      ETR = 0.0 
      ETI = 0.0 
      EPR = 0.0 
      EPI = 0.0 
      CQ2 = CR * Q
      CBETA = CQ2 - T * CB * SR 
      CQ2 = 2.0 * CQ2 
      DO 555 J = 1, N 
      ARG5 = CQ2 * XK (J) 
      CR5 = COS (ARG5)
      SR5 = SIN (ARG5)
      CCB = COS (XK (J) * CBETA) / SIN (ELL (J))
      SCB = SIN (XK (J) * CBETA) / SIN (ELL (J))
      TT = COS (ELL (J) * CPSI) - COS (ELL (J)) 
      A = (CIX (J) * CCB - CIY (J) * SCB) * TT
      BB = (CIY (J) * CCB + CIX (J) * SCB) * TT 
      W1 = CH * COS (PSIH - HQWAVE) 
      W2 = CH * SIN (PSIH - HQWAVE) 
      W3 = CV * COS (PSIV - HQWAVE) 
      W4 = CV * SIN (PSIV - HQWAVE) 
      C = 1.0 - (W3 * CR5 + W4 * SR5) 
      DD = W4 * CR5 - W3 * SR5
      ETR = ETR + A * C + BB * DD 
      ETI = ETI + BB * C - A * DD 
      CC = 1.0 + (W1 * CR5 + W2 * SR5)
      DC = W2 * CR5 - W1 * SR5
      EPR = EPR + A * CC - BB * DC
 555  EPI = EPI + BB * CC + A * DC
      ETMAG = (ETR * * 2 + ETI * * 2) * (Q * SB / SPSI2) * * 2
      EPMAG = (EPR * * 2 + EPI * * 2) * (CB / SPSI2) * * 2
      RAIN = 120.0 * (ETMAG + EPMAG) / RIN
      GO TO 615 
C.....ARBITARY TILTED DIPOLE ANTENNA, KOP=14............................
 560  CFAC = COS (FAC)
      W1 = COS (PSIH - HQWAVE)
      W2 = SIN (PSIH - HQWAVE)
      W3 = COS (PSIV - HQWAVE)
      W4 = SIN (PSIV - HQWAVE)
      TIP = 0.5 * EL1 * SR
      IF (TIP .GT. X) GO TO 635 
      CSB = CR * SB 
      CPHI = Q * SR + T * CSB 
      SPHI2 = 1.0 - CPHI * * 2
      CPHIP = - Q * SR + T * CSB
      SPHIP2 = 1.0 - CPHIP * * 2
      IF (SPHI2 .EQ. 0.0) GO TO 565 
      GI = (COS (FAC * CPHI) - CFAC) / SPHI2
      ETHETA1 = (CSB * Q - SR * T) * GI 
      EPHI1 = CR * CB * GI
      GO TO 570 
 565  ETHETA1 = CMPLX (0.0, 0.0)
      EPHI1 = CMPLX (0.0, 0.0)
 570  IF (SPHIP2 .EQ. 0.0) GO TO 575
      DI = (COS (FAC * CPHIP) - CFAC) / SPHIP2
      ETHETA1 = ETHETA1 - ((CSB * Q + SR * T) * DI * CV * W3) 
      EPHI1 = EPHI1 + DI * CH * W1 * CR * CB
      ETHETA2 = - (CSB * Q + SR * T) * DI * CV * W4 
      EPHI2 = CR * CB * DI * CH * W2
      GO TO 580 
 575  ETHETA2 = CMPLX (0.0, 0.0)
      EPHI2 = CMPLX (0.0, 0.0)
 580  continue
      IF (kas .GT. 1) GO TO 585 
      Y0 = RATIO * EL1
      H2 = 0.5 * EL1
      RHI2 = 0.0
      Z0 = 0.0
      CALL MUTUAL 
      R11 = R21 
      Y0 = 2.0 * X * CR 
      Z0 = 2.0 * X * SR 
      RHI2 = 2.0 * RHI
      CALL MUTUAL 
      ZM = CMPLX (R21, X21) 
      IF (RHI2 .GT. PIO2) ZM = - ZM 
      SQRD = CSQRT (DIF)
      CXC = REAL (ZM * (((1.0 - SQRD) / (1.0 + SQRD)) * CR + CMPLX (0.0,
     1 1.0) * ((DIF - SQRD) / (DIF + SQRD)) * SR) * CMPLX (CR, - SR)) 
      RIN = R11 + CXC 
 585  RAIN = 120.0 * (ETHETA1 * * 2 + ETHETA2 * * 2 + EPHI1 * * 2 + EPHI
     12 * * 2) / RIN
      GO TO 615 
C.....HALF RHOMBIC ANTENNA, KOP=15......................................
 590  W1 = COS (PSIH) 
      W2 = SIN (PSIH) 
      W3 = COS (PSIV) 
      W4 = SIN (PSIV) 
      TT = Q * SR 
      TS = 1.0 - T * CR * CB
      TT2 = TS + TT 
      TS2 = FAC2 * TT2
      STS4 = SIN (TS2) / TT2
      CTS4 = (1.0 - COS (TS2)) / TT2
      TT1 = TS - TT 
      TS1 = FAC2 * TT1
      STS1 = SIN (TS1)
      CTS1 = COS (TS1)
      R1 = (1.0 - CTS1) / TT1 
      FI1 = STS1 / TT1
      R4 = (1.0 - CTS1) * COS (FAC4 * SR * Q) + STS1 * SIN (FAC4 * SR * 
     1Q)
      FI4 = STS1 * COS (FAC4 * SR * Q) - SIN (FAC4 * SR * Q) * (1.0 - CT
     1S1) 
      R2 = CTS4 * CTS1 + STS4 * STS1
      FI2 = CTS1 * STS4 - CTS4 * STS1 
      F4C = (FI4 * CTS1 - R4 * STS1) / TT1
      R4C = (R4 * CTS1 + FI4 * STS1) / TT1
      RB = R1 + R2 - ((CTS4 + R4C) * W3 - (STS4 + F4C) * W4) * CV 
      BI = FI1 + FI2 - ((CTS4 + R4C) * W4 + (STS4 + F4C) * W3) * CV 
      RC = - R1 + R2 + (( - CTS4 + R4C) * W3 - ( - STS4 + F4C) * W4) * C
     1V 
      CC = - FI1 + FI2 + (( - CTS4 + R4C) * W4 + ( - STS4 + F4C) * W3) *
     1 CV 
      RA = R1 + R2 + ((CTS4 + R4C) * W1 - (STS4 + F4C) * W2) * CH 
      AI = FI1 + FI2 + ((CTS4 + R4C) * W2 + (STS4 + F4C) * W1) * CH 
      EM1 = (CR * CB * Q * RB + SR * T * RC) * * 2 + (CR * CB * Q * BI +
     1 SR * T * CC) * * 2 
      ENN1 = (CR * SB * RA) * * 2 + (CR * SB * AI) * * 2
      RAIN = 0.1 * (ENN1 + EM1) 
      RIN = 300.0 
      EFF = - 1.7 
      GO TO 615 
C.....SLOPING DOUBLE RHOMBOID, KOP=16...................................
 595  EL2 = EX (3) / WAVE 
      IF (EX (3) .LT. 0.0) EL2 = ABS (EX (3)) 
      FAK = PI2 * EL2 
      HT = EX (4) / WAVE
      IF (EX (4) .LT. 0.0) HT = ABS (EX (4))
      DEL = ASIN ((HT - X) / (EL1 + EL2)) 
      W1 = CH * COS (PSIH - HQWAVE) 
      W2 = CH * SIN (PSIH - HQWAVE) 
      W3 = CV * COS (PSIV - HQWAVE) 
      W4 = CV * SIN (PSIV - HQWAVE) 
      CDEL = COS (DEL)
      SDEL = SIN (DEL)
      SX1 = SIN (EX (1) * D2R)
      BP1 = ASIN (SX1 / CDEL) 
      CP1 = COS (BP1) 
      SP1 = SIN (BP1) 
      SX2 = SIN (EX (2) * D2R)
      BP2 = ASIN (SX2 / CDEL) 
      CP2 = COS (BP2) 
      SP2 = SIN (BP2) 
      RP1M = ((CB * CP1 - SB * SP1) * CR + (SB * CP1 + CB * SP1) * SR) *
     1 CDEL 
      RP2P = ((CB * CP2 - SB * SP2) * CR - (SB * CP2 + CB * SP2) * SR) *
     1 CDEL 
      RM2M = ((CB * CP2 + SB * SP2) * CR + (SB * CP2 - CB * SP2) * SR) *
     1 CDEL 
      RM1P = ((CB * CP1 + SB * SP1) * CR - (SB * CP1 - CB * SP1) * SR) *
     1 CDEL 
      ARGL1 = FAC4 * SDEL * Q 
      SL1 = SIN (ARGL1) 
      CL1 = SQRT (1.0 - SL1 * * 2)
      W1H1 = W1 * CL1 + W2 * SL1
      W2H1 = W2 * CL1 - W1 * SL1
      W3H1 = W3 * CL1 + W4 * SL1
      W4H1 = W4 * CL1 - W3 * SL1
      ARGL2 = 2.0 * FAK * SDEL * Q
      SL2 = SIN (ARGL2) 
      CL2 = SQRT (1.0 - SL2 * * 2)
      W1H2 = W1 * CL2 + W2 * SL2
      W2H2 = W2 * CL2 - W1 * SL2
      W3H2 = W3 * CL2 + W4 * SL2
      W4H2 = W4 * CL2 - W3 * SL2
      U1 = 1.0 - (Q * SDEL + T * RP1M)
      U2 = 1.0 - (Q * SDEL + T * RP2P)
      U3 = 1.0 - (Q * SDEL + T * RM2M)
      U4 = 1.0 - (Q * SDEL + T * RM1P)
      C11 = COS (FAC2 * U1) 
      S11 = SIN (FAC2 * U1) 
      C22 = COS (FAK * U2)
      S22 = SIN (FAK * U2)
      C23 = COS (FAK * U3)
      S23 = SIN (FAK * U3)
      C14 = COS (FAC2 * U4) 
      S14 = SIN (FAC2 * U4) 
      U1G = 1.0 / (1.0 + Q * SDEL - T * RP1M) 
      U2G = 1.0 / (1.0 + Q * SDEL - T * RP2P) 
      U3G = 1.0 / (1.0 + Q * SDEL - T * RM2M) 
      U4G = 1.0 / (1.0 + Q * SDEL - T * RM1P) 
      VR1 = (1.0 - C11) / U1
      VI1 = S11 / U1
      VR2 = (1.0 - C22) / U2
      VI2 = S22 / U2
      VR3 = (1.0 - C23) / U3
      VI3 = S23 / U3
      VR4 = (1.0 - C14) / U4
      VI4 = S14 / U4
      VR1G = (W3 * (1.0 - C11) - W4 * S11) * U1G
      VR2G = (W3 * (1.0 - C22) - W4 * S22) * U2G
      VR3G = (W3 * (1.0 - C23) - W4 * S23) * U3G
      VR4G = (W3 * (1.0 - C14) - W4 * S14) * U4G
      VR5G = (W3H2 * (1.0 - C11) - W4H2 * S11) * U1G
      VR6G = (W3H1 * (1.0 - C22) - W4H1 * S22) * U2G
      VR7G = (W3H1 * (1.0 - C23) - W4H1 * S23) * U3G
      VR8G = (W3H2 * (1.0 - C14) - W4H2 * S14) * U4G
      VI1G = (W3 * S11 + W4 * (1.0 - C11)) * U1G
      VI2G = (W3 * S22 + W4 * (1.0 - C22)) * U2G
      VI3G = (W3 * S23 + W4 * (1.0 - C23)) * U3G
      VI4G = (W3 * S14 + W4 * (1.0 - C14)) * U4G
      VI5G = (W3H2 * S11 + W4H2 * (1.0 - C11)) * U1G
      VI6G = (W3H1 * S22 + W4H1 * (1.0 - C22)) * U2G
      VI7G = (W3H1 * S23 + W4H1 * (1.0 - C23)) * U3G
      VI8G = (W3H2 * S14 + W4H2 * (1.0 - C14)) * U4G
      VR1H = (W1 * (1.0 - C11) - W2 * S11) * U1G
      VR2H = (W1 * (1.0 - C22) - W2 * S22) * U2G
      VR3H = (W1 * (1.0 - C23) - W2 * S23) * U3G
      VR4H = (W1 * (1.0 - C14) - W2 * S14) * U4G
      VR5H = (W1H2 * (1.0 - C11) - W2H2 * S11) * U1G
      VR6H = (W1H1 * (1.0 - C22) - W2H1 * S22) * U2G
      VR7H = (W1H1 * (1.0 - C23) - W2H1 * S23) * U3G
      VR8H = (W1H2 * (1.0 - C14) - W2H2 * S14) * U4G
      VI1H = (W1 * S11 + W2 * (1.0 - C11)) * U1G
      VI2H = (W1 * S22 + W2 * (1.0 - C22)) * U2G
      VI3H = (W1 * S23 + W2 * (1.0 - C23)) * U3G
      VI4H = (W1 * S14 + W2 * (1.0 - C14)) * U4G
      VI5H = (W1H2 * S11 + W2H2 * (1.0 - C11)) * U1G
      VI6H = (W1H1 * S22 + W2H1 * (1.0 - C22)) * U2G
      VI7H = (W1H1 * S23 + W2H1 * (1.0 - C23)) * U3G
      VI8H = (W1H2 * S14 + W2H2 * (1.0 - C14)) * U4G
      E1R = (VR1 - VR1G) * Q * RP1M - (VR1 + VR1G) * SDEL * T 
      E1I = (VI1 - VI1G) * Q * RP1M - (VI1 + VI1G) * SDEL * T 
      E2R = (VR2 - VR2G) * Q * RP2P - (VR2 + VR2G) * SDEL * T 
      E2I = (VI2 - VI2G) * Q * RP2P - (VI2 + VI2G) * SDEL * T 
      E3R = - (VR3 - VR3G) * Q * RM2M + (VR3 + VR3G) * SDEL * T 
      E3I = - (VI3 - VI3G) * Q * RM2M + (VI3 + VI3G) * SDEL * T 
      E4R = - (VR4 - VR4G) * Q * RM1P + (VR4 + VR4G) * SDEL * T 
      E4I = - (VI4 - VI4G) * Q * RM1P + (VI4 + VI4G) * SDEL * T 
      E5R = - C23 * ((VR1 - VR5G) * Q * RP1M - (VR1 + VR5G) * SDEL * T) 
      E5R = E5R - S23 * ((VI1 - VI5G) * Q * RP1M - (VI1 + VI5G) * SDEL *
     1 T) 
      E5I = - C23 * ((VI1 - VI5G) * Q * RP1M - (VI1 + VI5G) * SDEL * T) 
      E5I = E5I + S23 * ((VR1 - VR5G) * Q * RP1M - (VR1 + VR5G) * SDEL *
     1 T) 
      E6R = - C14 * ((VR2 - VR6G) * Q * RP2P - (VR2 + VR6G) * SDEL * T) 
      E6R = E6R - S14 * ((VI2 - VI6G) * Q * RP2P - (VI2 + VI6G) * SDEL *
     1 T) 
      E6I = - C14 * ((VI2 - VI6G) * Q * RP2P - (VI2 + VI6G) * SDEL * T) 
      E6I = E6I + S14 * ((VR2 - VR6G) * Q * RP2P - (VR2 + VR6G) * SDEL *
     1 T) 
      E7R = C11 * ((VR3 - VR7G) * Q * RM2M - (VR3 + VR7G) * SDEL * T) 
      E7R = E7R + S11 * ((VI3 - VI7G) * Q * RM2M - (VI3 + VI7G) * SDEL *
     1 T) 
      E7I = C11 * ((VI3 - VI7G) * Q * RM2M - (VI3 + VI7G) * SDEL * T) 
      E7I = E7I - S11 * ((VR3 - VR7G) * Q * RM2M - (VR3 + VR7G) * SDEL *
     1 T) 
      E8R = C22 * ((VR4 - VR8G) * Q * RM1P - (VR4 + VR8G) * SDEL * T) 
      E8R = E8R + S22 * ((VI4 - VI8G) * Q * RM1P - (VI4 + VI8G) * SDEL *
     1 T) 
      E8I = C22 * ((VI4 - VI8G) * Q * RM1P - (VI4 + VI8G) * SDEL * T) 
      E8I = E8I - S22 * ((VR4 - VR8G) * Q * RM1P - (VR4 + VR8G) * SDEL *
     1 T) 
      ETHR = E1R + E2R + E3R + E4R + E5R + E6R + E7R + E8R
      ETHI = E1I + E2I + E3I + E4I + E5I + E6I + E7I + E8I
      SP1M = (SB * CP1 + CB * SP1) * CR - (CB * CP1 - SB * SP1) * SR
      SP2P = (SB * CP2 + CB * SP2) * CR + (CB * CP2 - SB * SP2) * SR
      SM2M = (SB * CP2 - CB * SP2) * CR - (CB * CP2 + SB * SP2) * SR
      SM1P = (SB * CP1 - CB * SP1) * CR + (CB * CP1 + SB * SP1) * SR
      P1R = - (VR1 + VR1H) * SP1M 
      P1I = - (VI1 + VI1H) * SP1M 
      P2R = - (VR2 + VR2H) * SP2P 
      P2I = - (VI2 + VI2H) * SP2P 
      P3R = (VR3 + VR3H) * SM2M 
      P3I = (VI3 + VI3H) * SM2M 
      P4R = (VR4 + VR4H) * SM1P 
      P4I = (VI4 + VI4H) * SM1P 
      P5R = ((VR1 + VR5H) * C23 + (VI1 + VI5H) * S23) * SP1M
      P5I = ((VI1 + VI5H) * C23 - (VR1 + VR5H) * S23) * SP1M
      P6R = ((VR2 + VR6H) * C14 + (VI2 + VI6H) * S14) * SP2P
      P6I = ((VI2 + VI6H) * C14 - (VR2 + VR6H) * S14) * SP2P
      P7R = - ((VR3 + VR7H) * C11 + (VI3 + VI7H) * S11) * SM2M
      P7I = - ((VI3 + VI7H) * C11 - (VR3 + VR7H) * S11) * SM2M
      P8R = - ((VR4 + VR8H) * C22 + (VI4 + VI8H) * S22) * SM1P
      P8I = - ((VI4 + VI8H) * C22 - (VR4 + VR8H) * S22) * SM1P
      EPHR = (P1R + P2R + P3R + P4R + P5R + P6R + P7R + P8R) * CDEL 
      EPHI = (P1I + P2I + P3I + P4I + P5I + P6I + P7I + P8I) * CDEL 
      RAIN = 0.0296 * (ETHR * ETHR + ETHI * ETHI + EPHR * EPHR + EPHI * 
     1EPHI) 
      EFF = - 1.7 
C.....CALCULATES DECIBELS...............................................
615   IF (RAIN .LE. rain_min) RAIN = rain_min
      RAIN = 10.0 * ALOG10 (RAIN) 
C. . .ADD ADDITIONAL GAIN FOR ANTENNA TYPES 2(VERTICAL), 3(1/2 WAVE 
C     DIPOLE), AND 5(VERTICAL DIPOLE). . . . . . . . . . . . . . . . . .
      IF (KOP .EQ. 2)RAIN = RAIN + H
      IF (KOP .EQ. 3 .OR. KOP .EQ. 5)RAIN = RAIN + PHI
      IF (RAIN .LT. floor)RAIN = floor
 620  RAINE = RAIN + EFF
      IF (RAINE .GE. floor) GO TO 625
      RAINE = floor
ccc      EFF = RAINE - RAIN
 625  RAIN = RAINE
C.....NORMAL EXIT.......................................................
 630  RETURN
C.....ERROR EXIT........................................................
 635  write (*,636)
 636  format(' TIP > X in HUMUFES GAIN calculations.')
 640  STOP      
C 
C 
C 
      END

      SUBROUTINE setvars     !  set variables we have found are undefined
C--------------------------------
      common /cantenna/ numants,iats(20),anttype(20),antname(20),
     +                  xfqs(20),xfqe(20),designfreq(20),antfile(20),
     +                  beammain(20),offazim(20),cond(20),diel(20),
     +                  array(30,91,22),aeff(30,20)
      character anttype*10,antname*70,antfile*24
      COMMON/GEOG/GYZ(5),RAT(5),GMDIP(5),CLCK(5),ABIY(5),ARTIC(5),SIGPAT
     A(5), EPSPAT(5)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON /RAYS/ ANG(40), IFOB(40,30,5), NANG
      COMMON/INFORM/INFO,IHSHR,IHLNG
      COMMON / ZON / ABPS(7), CREL(7), EFF(7), FLDST(7), GRLOS(7),
     1 HN(7), HP(7), PROB(7), RELY(7), RGAIN(7), SIGPOW(7), SN(7),
     2 SPRO(7), TGAIN(7), TIMED(7), TLOSS(7), B(7), FSLOS(7), ADV(7),
     3 OBF(7),NMODE(7),TLLOW(7),TLHGH(7)
c------------------------------------------------------------------------
      zero=0.
      numants=0
      do 10 i=1,5
10    ARTIC(i)=zero
      do 20 j=1,5
      do 20 i=1,30
      HTRUE(i,j)=zero
      FVERT(i,j)=zero
      AFAC(i,j)=zero
20    HPRIM(i,j)=zero
      do 30 k=1,5
      do 30 j=1,30
      do 30 i=1,40
30    IFOB(i,j,k)=zero
      IHSHR=0
      IHLNG=0
      do 40 i=1,7
      HP(i)=zero
      rely(i)=zero
      hn(i)=zero
      nmode(i)=0
      sn(i)=zero
      fldst(i)=zero
      sigpow(i)=zero
      b(i)=zero
      timed(i)=zero
      abps(i)=zero
      prob(i)=zero
      rgain(i)=zero
      tgain(i)=zero
      fslos(i)=zero
      spro(i)=zero
      EFF(i)=zero
      grlos(i)=zero
      adv(i)=zero
      obf(i)=zero
40    CREL(i)=zero
      return
      end
C--------------------------------

c###f2dis.for
      SUBROUTINE F2DIS (FMUF, SSN, CLAT, FREQ, ABB, SIG)
C--------------------------------
c          re-written 3/20/2009 by Greg Hand to modern Fortran
C--------------------------------
C
C     THIS ROUTINE OBTAINS THE UPPER AND LOWER DECILE FOR THE F2 MUF
C
C     USES TABLES OF F2 MUF(3000)  (IE MUF FOR A DISTANCE OF 3000 KM)
C
C FMUF IS F2 MUF,MHZ.
C SSN  IS SUNSPOT NUMBER.
C CLAT IS GEOGRAPHIC LATITUDE, RADIANS.
C FREQ IS OPERATING FREQUENCY,MHZ.
C ABB  IS LOCAL MEAN TIME (HOURS)   SEE CLCK(K)
C SIG  IS STANDARD DEVIATION OF F2 MUF (NORMAL)
C
      COMMON / TWO / F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     A FAM(14,12), SYS(9,16,6), PERR(9,4,6)

      IF(F2D(1,1,1).le.0) then   !  No ionospheric data - use classical values
         SIG=0.15*FMUF/1.28155
         SIG=AMAX1(SIG,0.001)
         RETURN
      end if

      CL = CLAT * 57.29577    !  convert to degrees
      ICC = ABB / 4.0 + 1.55  !  4 hour time blocks
      IF(ICC.gt.6) ICC=1      !  make sure index is within limits

      IF(FREQ.le.FMUF) then
         I = 8                !  lower decile
      else
         I = 0                !  upper decile
      end if

      ICL = 9.5 - ABS (CL) / 10.
      if(ICL.lt.1) ICL=1    !  limit index
      if(ICL.gt.8) ICL=8    !  limit index
      IZ = ICL + I

      J=2                     !  50 < SSN <= 100
      if(SSN.le.50.) J=1      !  SSN <=  50
      if(SSN.gt.100.) J=3     !  SSN >  100

      if(cl.le.0.) J=J+3      !  Southern Hemisphere
      SIG = ABS(FMUF - F2D(IZ,J,ICC) * FMUF) / 1.28
      IF (SIG .LE. 0.001) SIG = 0.001
      RETURN
      END
C--------------------------------

c###timvar.for
      SUBROUTINE TIMVAR
C--------------------------------
C
C     THIS ROUTINE EVALUATES THE ZENITH ANGLE, RATIO OF F2 LAYER HEIGHT
C     OF MAXIMUM TO SEMITHICKNESS AND ABSORPTION INDEX.
C     SUBROUTINE EF1VAR IS CALLED TO EVALUATE THE E AND F1 PARAMETERS
C
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON / CON / D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON/GEOG/GYZ(5),RAT(5),GMDIP(5),CLCK(5),ABIY(5),ARTIC(5),SIGPAT
     A(5), EPSPAT(5)
      COMMON / SSP / SUN(2,12), MONTH
C.....LONGITUDE OF NOON
      SSL = (180. - 15. * GMT) * D2R
      IF (KM .LT. 1) GO TO 160
      DO 155 II = 1, KM
C.....SAMPLE AREA LONGITUDE AND LATITUDE
      CENLG = CLONG (II)
      CENLAT = CLAT (II)
      CENDOG = ABS(CENLAT - D2R * SUN(1,MONTH))
C.....SSP IS THE LATITUDE OF THE SUBSOLAR POINT
      SSP = SUN(2,MONTH) * D2R
      CENCAT = ABS (CENLAT - SSP)
      IF (CENDOG - CENCAT)105, 105, 100
C.....SSP IS THE LATITUDE OF THE SUBSOLAR POINT
  100 SSP = SUN(1,MONTH) * D2R
  105 CLOCK = GMT + CENLG / .261799387
      IF (24. - CLOCK)110, 115, 115
  110 CLOCK = CLOCK - 24.
      GO TO 125
  115 IF (CLOCK)120, 120, 125
  120 CLOCK = CLOCK + 24.
C.....CLCK(II) IS LOCAL MEAN TIME
  125 CLCK (II) = CLOCK
      Z = CENLG - SSL
      CYCEN = SIN (CENLAT) * SIN (SSP) + COS (CENLAT) * COS (SSP) * COS
     1(Z)
C.....CYCEN IS THE ZENITH ANGLE
      CYCEN = ACOS (CYCEN)
C.....EVALUATE THE E AND F1 LAYER PARAMETERS
      CALL EF1VAR (CYCEN, II)
C.....GLAT(II) IS THE GEOMAGNETIC LATITUDE
      GM = ABS (GLAT (II)) * R2D - 45.
      Z = CYCEN * R2D
      IF (CLOCK - 12.0)135, 140, 140
  135 Z = - Z
  140 Z = Z + 180.0
C.....EVALUATE RATIO MAP
      CALL NOISY (8, GM, Z, YM)
      IF (YM - 2.0)145, 150, 150
  145 YM = 2.0
C.....RAT(II) IS RATIO OF F2 HEIGHT OF MAXIMUM IONIZATION TO SEMITHICK
C.....ABIY(II) IS ABSORPTION INDEX AS RELATED TO E LAYER CRITICAL FREQ
  150 RAT (II) = YM
      ABI = - .04 + EXP ( - 2.937 + .8445 * FI (1, II))
      ABIY (II) = ABI
  155 CONTINUE
  160 CONTINUE
      RETURN
      END
C--------------------------------

      subroutine del_abt     !  delete the voaarea.abt & voacap.abt files
      use crun_directory
c**********************************************************
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
      nch_run=lcount(run_directory,50)
c          make sure the ABORT file is not there
      call erase@(run_directory(1:nch_run)//'\voaarea.abt',error_code)
      call erase@(run_directory(1:nch_run)//'\voacap.abt',error_code)
      return
      END
* -------------------------------------------------------------------- *

c###selmod.for
      SUBROUTINE SELMOD
C--------------------------------
C
C     THIS ROUTINE SELECTS THE SAMPLE AREA TO BE USED IN RAY PATH
C     CALCULATIONS.
C
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      IF(KFX.EQ.1)THEN
C.......ONLY ONE AVAILABLE
        JMODE =1
      ELSE IF(KFX.EQ.2)THEN
C.......ONLY TWO WITH THE SAME F (SET EQUAL IN IONSET)
C.......SO CHECK E LAYER
        IF(FI(1,1).GT.FI(1,2))THEN
C.........RECEIVER END CONTROLS
          JMODE =2
        ELSE
C.........TRANSMITTER END CONTROLS
          JMODE =1
        ENDIF
      ELSE
C.......THREE SAMPLES BUT CHECK ENDS ONLY
C.......CHECK  F2 LAYERS
        DELFI=FI(3,1)-FI(3,3)
        IF( ABS(DELFI).LT.0.01 )THEN
C.........F2 LAYER IS SAME SO CHECK E LAYER
          IF(FI(1,1).GT.FI(1,3))THEN
C...........RECEIVER END CONTROLS
            JMODE =3
          ELSE
C...........TRANSMITTER END CONTROLS
            JMODE =1
          ENDIF
        ELSE
C.........F2 LAYER CONTROLS
          IF(DELFI.GT.0.)THEN
C...........RECEIVER END CONTROLS
            JMODE =3
          ELSE
C...........TRANSMITTER END CONTROLS
            JMODE =1
          ENDIF
        ENDIF
      ENDIF
      RETURN
      END
C--------------------------------

      subroutine read_asc(model,*)       !  read common from modelW.ASC
      use voacapl_defs
      use crun_directory
      character model*6

      INCLUDE 'ficepac.hdr'
      INCLUDE 'fice_ssn.hdr'
      common /cbotlines/ nbotlines,linesbot(14)
      common /ctoplines/ ntoplines,linestop( 7)
      common /zMETHOD/ kmeth     !  propagation method used for method=23
         integer*4 kmeth
c jw      common /crun_directory/ run_directory
c jw         character run_directory*50
c**********************************************************************

      nch_run=lcount(run_directory,50)
      open(29,file=run_directory(1:nch_run)//PATH_SEPARATOR//model//'w.asc',
     +      status='old',err=999)
      rewind(29)
      i999=0

      read (29,1,err=900) method,methodname
1     format(i2,1x,a)
      read (29,2,err=900) icoeffs,year
2     format(11i6)
      read (29,3,err=900) montha
3     format(10f7.2)
      read (29,4,err=900) ssna
4     format(10i7)
      read (29,3,err=900) qindexa
      read (29,2,err=900) ihr1,ihr2,ihrinc,itimecode
      read (29,5,err=900) tlatdeg,tlondeg,tname
5     format(3a)
      read (29,5,err=900) rlatdeg,rlondeg,rname
      read (29,6,err=900) ipath,gcdkm,gcdnmi,gcdmi,TazR
6     format(i5,3f10.2,f10.4)
      read (29,2,err=900) freq
      read (29,7,err=900) noise,amind,xlufp,rsn,pmp,dmpx,fprob
7     format(i5,f10.6,2i5,2f10.4,4f10.5)
      read (29,8,err=900) rec_dir,rec_file,rec_bear,rec_gain
8     format(a,1x ,a,2f10.5)
      read (29,2,err=900) numants,Index_ant
      do 10 i=1,numants
       read (29,9,err=900) 
     +            minfreq(i),maxfreq(i),design_freq(i),xmtr_dir(i),
     +            xmtr_file(i),xmtr_model(i),beam_main(i),TxPower(i)
9     format(2i5,f10.5,1x,a,1x ,a,1x ,a,f10.5,f20.10)
10    continue
      read (29,11,err=900) nbotlines,linesbot
11    format(20i4)
      read (29,11,err=900) ntoplines,linestop
      read (29,12,err=900) flat
12    format(5f15.8)
      read (29,12,err=900) flon
      read (29,11,err=900) utime
      read (29,12,err=900) fof2
      read (29,12,err=900) ssn_eff
      read (29,12,err=900) ssn_ave
      read (29,1,err=900) kmeth
      read (29,2,err=900) i999

      close(29)
      if(i999.ne.999) go to 999
      return
900   close(29)
999   return 1      !  error return
      END
* -------------------------------------------------------------------- *

      subroutine antcal(bmain,bazim,del,gain)
c******************************************************************
c          bmain- is main beam azmuthal bearing (degrees)
c          bazim- is azimuthal bearing (degrees) to calculate
c          del  - is elevation angle (degrees)
c          gain - is returned
c*****************************************************************
c   calculates gain of antenna for azimuthal offset and elevation angle
c
      common /gain_10/ gain10(90,29)
      common /ccirparm/ parm(20),z6,umax,vmax,giso,
     +                  modegain,gainmax(3,2),gnorm(30)
      common /ctype11g/ gain_type11(91)
      jant=nint(parm(2))         !  ccir antenna type
      gain=giso
      if(jant.eq.10) then        !  vertical monopole
         ielev=nint(del)
         if(ielev.lt.0) ielev=0
         if(ielev.gt.90) ielev=90
         if(ielev.eq.0) then
            gain=-30.
         else
            freq=parm(5)          !  operating freq
            ifreq=freq
            if(ifreq.lt.30) then
               gain=gain10(ielev,ifreq-1)+(freq-float(ifreq))*
     +                     (gain10(ielev,ifreq)-gain10(ielev,ifreq-1))
            else
               gain=gain10(ielev,29)
            end if
         end if
      else if(jant.eq.11) then        !  gain table
         ielev=nint(del)
         if(ielev.lt.0) ielev=0
         if(ielev.gt.90) ielev=90
         gain=gain + gain_type11(ielev+1)
      else if(jant.eq.12) then   !  NTIA Report 87-215 Curtain arrays
         ofaz=bazim-bmain
         if(ofaz.lt.0.) ofaz=ofaz+360.
         freq=parm(5)          !  operating freq
         ifreq=freq
         if(ifreq.lt.30) then
            gn=gnorm(ifreq)+(freq-float(ifreq))*
     +                      (gnorm(ifreq+1)-gnorm(ifreq))
         else
            gn=gnorm(30)
         end if
         call curtain(parm,ofaz,del,gain,gn)
         if(gain.lt.-30.) gain=-30.
      else if(jant.gt.0) then    !  not Isotrope
         ofaz=bazim-bmain
         if(ofaz.lt.0.) ofaz=ofaz+360.
         call ccirgain(jant,del,ofaz,z6,giso,gain)
      end if
      return
      end
c------------------------------------------------------------------

      subroutine gainorm ( z6, umax, vmax, iperf,iant,ifs)
*
*       calculation of the gain normalizing factor
*
*        dimension w(90)
*
c  pre-set angles of maximum radiation for simple cases
c  in the vertical plane
c
      if(iant.eq.4.or.(iant.lt.4.and.ifs.ne.0)) then        
        if(iperf.eq.1) then
          u=0.0
        else
          if(iant.eq.4) then
            u=45.0
          else
            u=5.0
          endif
        endif
c
c  find maximum in horizontal plane
c         
        vmin1=270
        vmax1=450
        vm=10
        rmax=0
        do 1435 v=vmin1,vmax1,vm
        call gainrel(iant,u, v, z9)
        if(z9.gt.rmax) then
          rmax=z9
          vmax=v
        endif
 1435   continue        
        z6=z9
        vmin1=vmax-10
        vmax1=vmax+10
        vm=1
        call azmax(iant,u, vmin1, vmax1, vm, rmax, vmax)
        if(iperf.eq.1) return
      else
        vmax=0
        if(iperf.ne.0) then
          u=0
          v=0
          call gainrel(iant,u,v,z9)
          z6=z9
          return
        endif
      endif
      v=vmax
      wmx=0
      do 1520  u = 1,90
      call gainrel(iant,u, v, z9)
      if(z9.ge.wmx) then
        wmx=z9
        umax=u
      endif
1520  continue
      z6 = wmx
      if(ifs.ne.0.or.iant.eq.4) then
        u=umax
        i=0
        rmax=z6
        vmin1=vmax-5.0
        vmax1=vmax+5.0
        vm=1
        call azmax(iant,u, vmin1, vmax1, vm, rmax, vmax)
        z6 = rmax
        if(vmax.ge.360) vmax=vmax-360
      endif
      return
      end
c--------------------------------------------------------------------

      function xlimit6(x,i)
c          make sure x will print in the F6.i format
      dimension xmin(4),xmax(4)
      data xmin/-999.9,-99.99,-9.999,-.9999/
      data xmax/9999.9,999.99,99.999,9.9999/
      xlimit6=x
      if(x.lt.xmin(i)) xlimit6=xmin(i)
      if(x.gt.xmax(i)) xlimit6=xmax(i)
      return
      end

c###anois1.for
      SUBROUTINE ANOIS1
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
C--------------------------------
C
C     THIS ROUTINE DETERMINES THE 1 MHZ ATMOSPHERIC NOISE
C
C     FOURIER SERIES IN LATITUDE AND LONGITUDE FOR TWO DISCRETE
C     LOCAL TIME BLOCKS
C
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SYGU,SYGL,KJ,JK
      COMMON /CON /D2R, DCL, GAMA, PI, PI2, PIO2, R2D, RZ, VOFL
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON / TWO / F2D(16,6,6), P(29,16,8), ABP(2,9), DUD(5,12,5),
     A FAM(14,12), SYS(9,16,6), PERR(9,4,6)
C  LMT AT RCVR SITE
      IF(F2D(1,1,1)) 90, 90, 100
C.....NO IONOSPHERIC LONG TERM DATA BASE FILE
C.....SET NOISE TO ZERO HERE (-204 IN SUBROUTINE GENOIS)
C.....THE USER CAN INPUT ANY VALUE AS MAN-MADE NOISE (RESET IN GENOIS)
   90 ATNU = 0.0
      ATNY = 0.0
      RETURN
  100 CC = GMTR
      KJ= 6
      IF(CC-22.) 105,110,110
  105 KJ = CC/4. +1.
  110 TM = 4*KJ-2
      IF(CC-TM) 115,120,125
  115 JK = KJ -1
      GO TO 130
  120 JK = KJ
      GO TO 130
  125 JK = KJ+1
  130 IF(JK) 135,135,140
  135 JK =6
      GO TO 150
  140 IF(JK-6) 150,150,145
  145 JK = 1
  150 IF(RLONG) 155,160,160
  155 CEG= 360.+ RLONG*R2D
      GO TO 165
C.....EAST LONGITUDE (IN DEGREES)
  160 CEG= RLONGD
  165 XLA = RLAT * R2D
C.....LATITUDE (IN DEGREES) "+" IS NORTH
      CALL NOISY(KJ,XLA,CEG,ATNU)
      CALL NOISY(JK,XLA,CEG,ATNY)
ccc      write(luo,'(''anois1='',2i5,4f10.4)') kj,jk,xla,ceg,atnu,atny
      RETURN
      END
C--------------------------------

c###sang.for
      SUBROUTINE SANG
C--------------------------------
C
C     THIS ROUTINE RESTRICTS THE PRELIMINARY CALCULATIONS
C     RESTRICT ANGLE SCAN BY DISTANCE, BUT IF USER INSISTS ON HIGHER
C     ANGLES THAN REASONABLE CHECK AMIND.
C
      COMMON/RAYS/ANG(40),IFOB(40,30,5),NANG
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      DIMENSION NANGX(8)
      DATA NANGX/ 40,    34,    29,    24,    19,    14,    12,    9/
C
C     THESE MUST BE COORDINATED WITH ANG(40) IN COMMON/RAYS/
C
C        DISTANCE            MAXIMUM ANGLE
C
C     .LT. 2000KM                 89.99
C     2000 TO 4000KM              60.
C     4000 TO 6000KM              48.
C     6000 TO 8000KM              38.
C     8000 TO 10000KM             28.
C     10000 TO 12000KM            18.
C     12000 TO 14000KM            14.
C     .GE. 14000KM                8.
C
C     REFLECTRIX TABLE WILL BE CALCULATED ONLY UP TO THESE ANGLES
C
       ID= GCDKM/2000. +1.
      ID=MIN0(ID,8)
      IANG = NANGX(ID)
      IF(AMIND)  120,120,100
  100 IF(ANG(IANG) -10. - AMIND)  105,120,120
  105 CONTINUE
      DO 115 IA = 1,40
      IANG =IA
      IF(ANG(IANG)-8.5 -AMIND) 110,120,120
  110 CONTINUE
  115 CONTINUE
  120 CONTINUE
      NANG=IANG
      RETURN
      END
C--------------------------------

c###outall.for
      SUBROUTINE OUTALL(IF)
C--------------------------------
C
C     THIS ROUTINE OUTPUTS ALL MODES TABLES
C
      COMMON / ALPHA / IMON(12), ITRAN(2), IRCVR(2), LBMAP(2), MODE(13),
     A MODER(13), ITLAT, ITLONG, IRLAT, IRLONG, IRLATU, IRLONGU, NYEAR
      CHARACTER IMON*3, NYEAR*5, ITRAN*10, IRCVR*10, LBMAP*10, ITLAT*1,
     A ITLONG*1, IRLAT*1, IRLONG*1, IRLATU*1, IRLONGU*1, MODE*2, MODER*2
      COMMON / FILES / LUI, LUO, LU2, LU5, LU6, LU15, LU16, LU20, LU25,
     A LU26, LU35
      COMMON/ANOIS/ATNU,ATNY,CC,TM,RCNSE,DU,DL,SIGM,SYGU,SYGL,KJ,JK
      COMMON /DON /ALATD, AMIN, AMIND, BTR, BTRD, DLONG, DMP, ERTR, GCD,
     1 GCDKM, PMP, PWR, TLAT, TLATD, TLONG, TLONGD, RSN, SIGTR, RLAT,
     2 RLATD,RLONG,RLONGD,BRTD,FLUX,ULAT,ULATD,ULONG,ULONGD,SSN,D90R,
     3 D50R,D10R,D90S,D50S,D10S
      COMMON/FRQ/FREA(13),FREL(29),FREQ,JMODE,ITXRCP(2)
      COMMON / ION / IHRE, IHRO, IHRS, LUFP, METHOD, NOISE, NPSL
      COMMON / OUTLAB / LABEL(11), LAYTYP(5), IEAST, INORTH, ISOUTH,
     A IWEST, LABLI, LABLJ, LABLK
      CHARACTER IEAST*1, ISOUTH*1, INORTH*1, IWEST*1, LABEL*5, LAYTYP*2,
     A LABLI*5, LABLJ*5, LABLK*5
      COMMON / OUTPRT / LINBOT(26), LINBD(14), LINTOP(15), LINTP(14),
     A GRPTYP, JOUT, LINBYP, LINES, LINMAX, LINTYP, LPAGES, NLINE
      COMMON / SON / ANGLE(13), ANGLER(13), CPROB(13), DBLOS(13),
     A DBLOSL(13), DBLOSU(13), DBU(13), DELAY(13), DBW(13), NHP(13),
     B XNYNOIS(13), PROBMP(13), RELIAB(13), SNDB(13), SNPR(13),
     C SNRLW(13), SNRUP(13), SPROB(13), VHIGH(13), RNEFF(13),MDL(13)
       CHARACTER MDL*1
      COMMON / TIME / IT, GMT, UTIME(24), GMTR, XLMT(24), ITIM, JTX
      COMMON / TON / ADJ, ADS, GNOS, GOT, REL, SL,
     2 SLS, SPR, SU, SUS, XNOISE, ZNOISE, NF
      COMMON / allMODE /ABPS(20),CREL(20),FLDST(20),HN(20),HP(20),
     1PROB(20),RELY(20),RGAIN(20),SIGPOW(20),SN(20),
     2SPRO(20),TGAIN(20),TIMED(20),TLOSS(20),B(20),FSLOS(20),
     3grlos(20),adv(20),obf(20),
     CNMODE(20),TLLOW(20),TLHGH(20),EFF(20),NREL,NMMOD
      COMMON/SIGD/DSL,ASM,DSU,AGLAT,DSLF,ASMF,DSUF,ACAV,FEAV,AFE,BFE,HNU
     A,HTLOSS,XNUZ,XVE
      CHARACTER NNAME(22)*10, ITEMP(20)*2
      CHARACTER f505*18,f512*34,f513*28
      DATA NNAME/' TIME DEL.', ' ANGLE    ', ' ABSORB   ',
     A ' FS. LOSS ', ' T. GAIN  ', ' ES OBSCUR', ' ADD. LOSS',
     B ' GROUND L.', ' TRAN.LOSS', ' FIELD ST.', ' SIG. POW.',
     C ' SNR      ', ' MODE PROB', ' R. PWRG  ', ' RELIABIL ',
     D ' SERV PROB', ' ANT. EFF ', ' VIR. HITE', ' R. GAIN  ',
     E ' 252-FLDST', ' SIG LOW  ', ' SIG  UP  '/
      DATA NADD/30/
      data f505,f512,f513/'(   x,9h Most REL)','(12x,  (3x,f4.0,a2,1x),4
     +x,f4.0,a2)','(1x,a10,  (1x,f9.2),2x,f9.2)'/
      IF(METHOD.ne.25) return
      JOUT = LUO
      IF(IF.eq.1) then
         LINES = LINMAX
         CALL OUTPAR
      end if
      LINES = LINES + NADD
      IF(LINES.gt.LINMAX) then
         CALL OUTTOP                !  output header lines
         LINES = LINTOP(10) + NADD
      end if
      WRITE(JOUT,505)
      WRITE(JOUT,505)
      XNHP = NHP(IF)
      SIGPW = DBW(IF)
      WRITE(JOUT,501) NMMOD,FREQ, GMT
      IST=NMMOD
      DO 250 IM = 1,IST
      IS = NMODE(IM)
      ITEMP(IM) = LAYTYP(IS)
  250 CONTINUE
ccc      if(NMMOD.lt.12)then
      if(NMMOD.lt.20)then       !  change 12/27/2008 to put output on 1 page
        IST1=10*IST+13
        WRITE(f505(2:4),'(i3)')IST1
        WRITE(f512(6:7),'(i2)')IST
        WRITE(f513(9:10),'(i2)')IST
        WRITE(JOUT,f505)
        WRITE(JOUT,f512) (HN(IM),ITEMP(IM),IM=1,IST), XNHP, MODE(IF)
        WRITE(JOUT,f513) NNAME(1), (timed(IM),IM=1,ist), DELAY(IF)
        WRITE(JOUT,f513) NNAME(2), (B(IM),IM=1,IST), ANGLE(IF)
        WRITE(JOUT,f513) NNAME(18), (hp(IM),IM=1,ist), VHIGH(IF)
        WRITE(JOUT,f513) NNAME(9), (TLOSS(IM),IM=1,IST), DBLOS(IF)
        WRITE(JOUT,f513) NNAME(5),(TGAIN(IM),IM=1,IST),TGAIN(NREL)
        WRITE(JOUT,f513) NNAME(19), (RGAIN(IM),IM=1,IST), RGAIN(NREL)
        WRITE(JOUT,f513) NNAME(3),(abps(IM),IM=1,ist)
        WRITE(JOUT,f513) NNAME(4),(fslos(IM),IM=1,ist)
        WRITE(JOUT,f513) NNAME(10), (FLDST(IM),IM=1,IST), DBU(IF)
        WRITE(JOUT,f513) NNAME(11), (SIGPOW(IM),IM=1,IST), SIGPW
        WRITE(JOUT,f513) NNAME(12), (SN(IM),IM=1,IST), SNDB(IF)
        WRITE(JOUT,f513) NNAME(13), (prob(IM),IM=1,ist), CPROB(IF)
        WRITE(jout,f513) NNAME(14), (crel(IM),IM=1,ist), SNPR(IF)
        WRITE(JOUT,f513) NNAME(15), (RELY(IM),IM=1,IST), RELIAB(IF)
        WRITE(JOUT,f513) NNAME(16), (spro(IM),IM=1,ist), SPROB(IF)
        WRITE(JOUT,f513) NNAME(21), (TLLOW(IM),IM =1,IST),DBLOSL(IF)
        WRITE(JOUT,f513) NNAME(22), (TLHGH(IM),IM=1,IST) ,DBLOSU(IF)
      else
        WRITE(f512(6:7),'(2h10)')
        WRITE(f513(9:10),'(2h10)')
        WRITE(JOUT,f512) (HN(IM),ITEMP(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(1), (timed(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(2), (B(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(18), (hp(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(9), (TLOSS(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(5),(TGAIN(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(19), (RGAIN(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(3),(abps(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(4),(fslos(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(10), (FLDST(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(11), (SIGPOW(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(12), (SN(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(13), (prob(IM),IM=1,10)
        WRITE(jout,f513) NNAME(14), (crel(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(15), (RELY(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(16), (spro(IM),IM=1,10)
        WRITE(JOUT,f513) NNAME(21), (TLLOW(IM),IM =1,10)
        WRITE(JOUT,f513) NNAME(22), (TLHGH(IM),IM=1,10)
        LINES = LINES + NADD
        IF(LINES.gt.LINMAX) then
           CALL OUTTOP
           LINES = LINTOP(10) + NADD
        end if
        WRITE(JOUT,505)
        WRITE(JOUT,505)
        irem=ist-10
        IST1=10*irem+13
        WRITE(f505(2:4),'(i3)')IST1
        WRITE(f512(6:7),'(i2)')irem
        WRITE(f513(9:10),'(i2)')irem
        WRITE(JOUT,f505)
        WRITE(JOUT,f512) (HN(IM),ITEMP(IM),IM=11,IST), XNHP, MODE(IF)
        WRITE(JOUT,f513) NNAME(1), (timed(IM),IM=11,ist), DELAY(IF)
        WRITE(JOUT,f513) NNAME(2), (B(IM),IM=11,IST), ANGLE(IF)
        WRITE(JOUT,f513) NNAME(18), (hp(IM),IM=11,ist), VHIGH(IF)
        WRITE(JOUT,f513) NNAME(9), (TLOSS(IM),IM=11,IST), DBLOS(IF)
        WRITE(JOUT,f513) NNAME(5),(TGAIN(IM),IM=11,IST),TGAIN(NREL)
        WRITE(JOUT,f513) NNAME(19), (RGAIN(IM),IM=11,IST), RGAIN(NREL)
        WRITE(JOUT,f513) NNAME(3),(abps(IM),IM=11,ist)
        WRITE(JOUT,f513) NNAME(4),(fslos(IM),IM=11,ist)
        WRITE(JOUT,f513) NNAME(10), (FLDST(IM),IM=11,IST), DBU(IF)
        WRITE(JOUT,f513) NNAME(11), (SIGPOW(IM),IM=11,IST), SIGPW
        WRITE(JOUT,f513) NNAME(12), (SN(IM),IM=11,IST), SNDB(IF)
        WRITE(JOUT,f513) NNAME(13), (prob(IM),IM=11,ist), CPROB(IF)
        WRITE(jout,f513) NNAME(14), (crel(IM),IM=11,ist), SNPR(IF)
        WRITE(JOUT,f513) NNAME(15), (RELY(IM),IM=11,IST), RELIAB(IF)
        WRITE(JOUT,f513) NNAME(16), (spro(IM),IM=11,ist), SPROB(IF)
        WRITE(JOUT,f513) NNAME(21), (TLLOW(IM),IM =11,IST),DBLOSL(IF)
        WRITE(JOUT,f513) NNAME(22), (TLHGH(IM),IM=11,IST) ,DBLOSU(IF)
      ENDIF
      NRCNSE=anint(XNYNOIS(IF)+RNEFF(IF))
      WRITE(JOUT,511) NRCNSE, DBW(IF)
      WRITE(JOUT,502) DSL,ASM,DSU,SLS,ADS,SUS
      XRCNSE=RCNSE+RNEFF(IF)
      WRITE(JOUT,503) DU, XRCNSE, DL, SYGU, SIGM, SYGL
      WRITE(JOUT,506) D90R, D50R, D10R
      WRITE(JOUT,507) D90S, D50S, D10S
  625 RETURN
  501 FORMAT(' SUMMARY  ',I3,' MODES   FREQ = ',F5.1,' MHZ  UT = ',F5.1)
  502 FORMAT(' ',' SIGNAL =',3F7.1,'  /',3F8.1)
  503 FORMAT(' ',' NOISE = ',3F7.1,'  /',3F8.1)
  505 FORMAT(' ')
  506 FORMAT(' ',' RELIAB =',3F7.1)
  507 FORMAT(' ',' SPROB = ',3F7.1)
  511 FORMAT(' ',' NOISE = ',I6,5X,' S. POWER = ',F6.1)
      END
C--------------------------------

      subroutine curnorm(parm,z6,umax,vmax,gmax)
c*******************************************************************
c       PURPOSE:
c          initialize NTIA Report 83-215 antenna calculations
c       INPUT  PARAMETERS:
c          parm(1-n) = parameters that define the antenna characteristics
c       OUTPUT PARAMETERS:
c          z6 = gain normalizing factor (used by ccirgain)
c          umax = elevation angle at z6
c          vmax = azimuthal angle at z6
c*******************************************************************
c       Written by Greg Hand NTIA/ITS Boulder, Colorado   Aug 1991
c       Please call (303)497-3375 with any questions.
c*******************************************************************
      dimension parm(20)
      gmax=-99999.
      nazim=0
      if(parm(15).ne.0) nazim=nint(abs(parm(15)))+1
      nazim=nazim*2
      do 10 iazim=0,nazim
      azim=iazim
      if(nazim.ne.0) azim=iazim-nazim/2
      do 10 ielev=0,45
      elev=ielev
      call curtain(parm,azim,elev,gain,z6)
      if(gain.gt.gmax) then
         gmax=gain
         umax=elev
         vmax=azim
      end if
10    continue
      return
      end

c###f2var.for
      SUBROUTINE F2VAR
C--------------------------------
C
C     THIS ROUTINE EVALUATES THE F2 LAYER PARAMETERS
C
      COMMON / PSCA / PSC(4), PSCB(4), IPSC
      COMMON /A11 /GAMMA (6)
      COMMON / MFAC / F2M3(5),HPF2(5),ZENANG(5),ZENMAX(5),IEDP,FSECV(3)
      COMMON /RON /CLAT(5), CLONG(5), GLAT(5), RD(5), FI(3,5), YI(3,5),
     1HI(3,5), HPRIM(30,5), HTRUE(30,5), FVERT(30,5),KM,KFX, AFAC(30,5),
     2HTR(50,3), FNSQ(50,3)
      COMMON /GEOG /GYZ (5), RAT (5), GMDIP (5), CLCK (5), ABIY (5), ART
     1IC (5), SIGPAT (5), EPSPAT (5)
      DATA XF1/1.1/,DELZ/2./
      DO 125 II = 1, KM
C.....EVALUATE M(3000) AND CRITICAL FREQUENCY
      CALL VERSY(4, 5, II)
C.....F2M3(II) IS THE F2 LAYER M(3000) FACTOR
C.....HPF2(II) IS THE VIRTUAL HEIGHT AT 0.834 CRITICAL FREQUENCY
      F2M3 (II) = GAMMA (5)
      HPF2(II) = 1490. / GAMMA(5) - 176.
      FI (3, II) = (GAMMA (4) + 0.5 * GYZ (II)) * PSC (3)
      ZMAX = ZENMAX(II)
      Z = ZENANG(II)
C.....F1 MUST BE LESS THAN F2
      FI(2,II) = AMIN1(FI(2,II),FI(3,II)-.2)
      FC=0.834*FI(3,II)
      EC = FI (1, II)
      FCEC = FC / EC
       FCEC = AMAX1(FCEC,1.1)
C.....E LAYER RETARDATION
      RET = FCEC * ALOG ((FCEC + 1.) / (FCEC - 1.))
      RET=(RET-2.)*YI(1,II)
      FC1 = FI (2, II)
      IF (FC1)120, 120, 110
  110 FFEC = FC / FC1
C  FORCE MERGER OF F1 LAYER INTO F2 LAYER.
C.....CHECK IF F1 IS AT TWILIGHT
      IF(ZMAX-DELZ - Z) 215,210,210
C  NO PROBLEM.
  210 FFEC = AMAX1(FFEC,XF1)
      RFT  = FFEC*ALOG((FFEC+1.)/(FFEC-1.))
      RFT  = .5* YI(2, II)*(RFT-2.)
      GO TO 115
C NEAR DAY-NIGHT,CORRECT HI(2,II) AND RETARDATION.
C.....FORCE F1 UP INTO F2 AND RETARDATION TO ZERO FROM ZN TO ZMAX
  215 FFEC = AMAX1(FFEC,XF1)
      ZN = ZMAX - DELZ
      HN = 165. + .6428*ZN
      YN = HN *(YI(2,II)/HI(2,II))
      RFN= FFEC*ALOG((FFEC +1.)/(FFEC -1.))
      RFN= .5*YN*(RFN -2.)
      SZ = (Z-ZN)/DELZ
      RFT= RFN*(1.-SZ)
C  F2 WITHOUT F1.
      HM = HPF2(II) - RET
      YM = HM/RAT(II)
      DHN = (HM-YM) - (HN-YN)
      IF( DHN) 115,115,220
C.....BOTTOM OF F1 GOES TO BOTTOM OF F2
  220 DH = DHN*(1. - SZ)
      HI(2,II) = (HM-YM) - DH +YI(2,II)
      IF(FC1 - FC) 115, 115, 225
C  F1 IS ALSO CLOSE TO F2 IN FREQUENCY, FORCE F1 YM TO F2 YM.
  225 Y1MAX = YN + (YM - YN) * (FC1 / FI(3,II) - 0.834) / 0.166
      YI(2,II) = YN + (Y1MAX - YN) * SZ
      HI(2,II) = (HM - YM) - DH + YI(2,II)
  115 RET = RET + RFT
  120 HI(3,II) = HPF2(II) - RET
      YI(3,II) = HI(3,II) / RAT(II)
  125 CONTINUE
      RETURN
      END
C--------------------------------
